import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import math
import Tkinter
import Canvas
import os
import pstat
import stats
import csv
from string import replace



# 25.11.2013: ACsimple1.py derived from antichain20_4.py
# 20.8.2014 bug mit lbpdtopen


def xselectfile():
    # brg 6.8.2013, 25.11.2013 (taken from fuzzysimpl
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)




def xfileopen():
    """Informs about the file-operations"""
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    #rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)   #6.8.2013

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # corrections 22.8.2014
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)    

##### end of open/editwindow ### 29.8.2013 ####

def inread():
    #brg 13.8.10, 25.4.2011, 09.2.18
    x1=ex1.get().split(",")
    
    if len(x1)<=1:
        lbwarning.config(text="++Note: Wrong input++++ ",bg="yellow")
    else:
        lbwarning.config(text="Antichain has more than one element ")
        
    lx1=len(x1)
    print "AC = ",x1," len x1",lx1
    return x1,lx1

    

def showDM():
    """shows the columnwise normalized dm"""
    # taken from fuzzyHD7
    # brg 10.02.2018
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in \n \
                        and normalized data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=20)
    tfile.pack()
    xredn=rmod2.matrixnorm(rred,k,xred)
    txt1="File= "+str(fn)+"\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n [0,1]-data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(xredn[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def HD():
    # brg 26.7.2013, 29.8.2013, 25.11.2013, 10.02.2018
    global x,la,ls,xred,cov,n,txteq
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  "+"\nfile: "+str(fn))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()

##        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
##        buttcover.pack()



def calc_discrepancy():
    #09.02.18, 10.02.18
    global k
    xredn=rmod2.matrixnorm(rred,k,xred)
    txtdisc="data of file: "+str(fn)+"\n"
    
    x1,lx=inread()
    
    txtdisc="Selected antichain= "
    for ob in x1:
        txtdisc+=str(ob)+", "
    txtdisc+="\n"
    txtdisc+=60*"="+"\n"
    txtdisc+="Object1\tobject2\tdiscrepancy\tindicator pairs "+"\n"
    obpairs=[]
    
    
    for iob1 in range(0,lx-1):
        #print "iob1 = ",iob1, " object = ",x1[iob1]
        iob1aktual = objred.index(x1[iob1])
        #print "iob1actual= ",iob1aktual
        for iob2 in range(iob1+1, lx):
            propmin=[]
            #print "iob2= ",iob2, "  object= ",x1[iob2]
            iob2aktual=objred.index(x1[iob2])
            print x1[iob1],x1[iob2]
            testn4=[]
            for j1 in range(0,k):
                for j2 in range(j1+1,k):
                    print j1,j2
                    testn1=(xredn[iob1aktual][j1]-xredn[iob2aktual][j1])
                    testn2=(xredn[iob1aktual][j2]-xredn[iob2aktual][j2])
                    #print "testn1 ",testn1, "  testn2= ",testn2, "produkt= ",testn1*testn2
                    if testn1*testn2<0:
                        # incomparable ob1,ob2 wrt j1,j2
                        propmin.append([j1,j2,abs(testn1)*abs(testn2)])
            #print iob1,iob2,"  len: ",len(propmin)
            print x1[iob1],x1[iob2]   
            print "propmin ",propmin
                     
##            for j in range(0, len(propmin)):
##                print j,
##                for k1 in range(0,3):
##                    print propmin[j][k1]," ",
##                print " "    
            #max-value in propmin[2]
            maxpropmin=-9999
            #print "propmin= ",propmin
            for j in range(0,len(propmin)):
                #print propmin[j][2]
                if propmin[j][2]>maxpropmin:
                    maxpropmin=propmin[j][2]
            dishilf=maxpropmin
            # which pairs (j1,j2) have this maximal value
            suspairs=[]
            for j in range(0,len(propmin)):
                if propmin[j][2]==dishilf:
                    suspairs.append((propmin[j][0],propmin[j][1]))
            #print "dishilf = ",dishilf
            #print x1[iob1],x1[iob2], "   suspairs = ",suspairs
            lsus=len(suspairs)
            txthilf=""
            if lsus>0:
                for j in range(0,lsus):
                    txthilf+="("+str(prop[suspairs[j][0]])+", "+str(prop[suspairs[j][1]])+")"
            txtdisc+=str(x1[iob1])+"\t, "+str(x1[iob2])+":     "+str(round(dishilf,3)) +3*"\t"+txthilf       
            txtdisc+="\n"
           
            obpairs.append((x1[iob1],x1[iob2],dishilf))
        
##    print "obpairs = "
##    for j in range(0, len(obpairs)):
##        print obpairs[j]
    discsort=[]
    for j in range(0, len(obpairs)):
        discsort.append(obpairs[j][2])
    #print "discsort= ",discsort               
    help2,help3,nhelp=rmod2.raisort2(discsort)
    #print "help2 ",help2
    #print "help3= ",help3
    #print "nhelp= ",nhelp
    txtdisc+= "Sorted objpairs wrt discrepancies"+"\n"
    txtdisc+=" (not decreasing values) "+"\n"
    for j in range(0, len(obpairs)):
        if j <len(obpairs)-1:
            txtdisc+="("+str(obpairs[nhelp[j]][0])+", "+str(obpairs[nhelp[j]][1])+")  =<  "
        else:
            txtdisc+="("+str(obpairs[nhelp[j]][0])+", "+str(obpairs[nhelp[j]][1])+")"
    txtdisc+="\n"    
    tpdisc=Tkinter.Toplevel(hf)
    tdisc=ScrolledText(tpdisc,width=80, height=20)
    tdisc.pack()
    tdisc.insert("end",txtdisc)        
    

    
    
hf=Tkinter.Tk()
hf.title('--   GUI AC_discrepancy   -- ')

aboutmainHD=raioop2.brgabout(hf,"tp1","about_AC_discrepance.txt",1,\
            "Febr., the 10th, 2018"," about AC_discrepance ", "white", "t1",120,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_AC_discrepance.txt",1,\
            "Nov., the 10th, 2018"," help_AC_discrepance ", "white", "t1",120,10,ScrolledText)
    
fr1=Tkinter.Frame(hf,width=60)   #about, help, fn, lbopen1
fr1.pack()
fr11=Tkinter.Frame(fr1,width=60)
fr11.pack()
Buttfn=Tkinter.Button(fr11,text="select&open-file",width=30,bg="cyan",command=xselectfile)
Buttfn.pack()
lbopen1=Tkinter.Label(fr1,text="",width=60)
lbopen1.pack()
lbpdtopen = Tkinter.Label(fr1, text="",width = 60)
lbpdtopen.pack()
fr12=Tkinter.Frame(fr1,width=60)
fr12.pack()
Buttshow=Tkinter.Button(fr12,text="show data matrix from txt-file",bg="cyan",width=30,command=showDM)
Buttshow.pack()
ButtHD=Tkinter.Button(fr12,text="Hassediagram ",width=30,bg="cyan",command=HD)
ButtHD.pack()
fr13=Tkinter.Frame(fr12,bd=4,relief="sunken")
fr13.pack()
lbwarning=Tkinter.Label(fr12,text="")
lbwarning.pack()
labex1=Tkinter.Label(fr13,text="Select the objects of an antichain >>>")
labex1.pack(side="left")
ex1=Tkinter.Entry(fr13,width=30)
ex1.pack(side="left")
Buttdiscrep=Tkinter.Button(fr13,text="Calculate discrepancies ", bg="cyan", width=30, command=calc_discrepancy)
Buttdiscrep.pack()
Buttexit=Tkinter.Button(fr12,text="Exit ",bg="red",bd="4",width=30,command=hf.destroy)
Buttexit.pack(pady=5)
hf.mainloop()
