import rmod2
import tkFileDialog
import Tkinter
from ScrolledText import *
import raioop2

def selop():
    #Brg 31.8.2011
    global rred,r,dm,xred,k,obj,objred,prop,fn
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    
    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
                
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  



def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    #taken from antag2.py 31.8.2011
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def profile(name):
    #brg 31.8.2011
    iobact=objred.index(name)
    txtpr=""
    
    for j in range(0,k):
        txtpr+=str(round(xred[iobact][j],2))+", "
    txtpr+="\n"
    return txtpr 

def listpresuc():
    #brg 4.9.2011
    tpli=Tkinter.Toplevel(hf)
    lbli=Tkinter.Label(tpli,text="detailed info of "+nameact,bg="yellow",font=("arial",14,"bold"))
    lbli.pack()
    tli=ScrolledText(tpli,width=60,height=10)
    tli.pack()
    txtlist=""
    txtlist+="\n predecessors: \n"
    txtlist+=txthilf1
    txtlist+="\n"
    txtlist+="\n successors: \n"
    txtlist+=txthilf2
    tli.insert("end",txtlist)
    

def infohd(event):
    #brg 19.8.2011
    global infohd,nameact,txthilf1,txthilf2                       
    
    x=int(cv1.canvasx(event.x))
    y=int(cv1.canvasy(event.y))
    #print item2
    flag=0
    tu=cv1.gettags(cv1.find_closest(x,y))
    print "tu= ",tu[0]
    lt=len(tu[0])
    tagn=tu[0][7:lt]
    try:
        iobact=zob.index(tagn)
        flag=1
    except:
        flag=0
    if flag==1:    
        tpinfo=Tkinter.Toplevel(hf)
        tpinfo.title('Info for vertex '+str(tagn))
        tinfo=ScrolledText(tpinfo,width=40,height=10)
        tinfo.pack(expand="yes")
        txt=" M-dep. info"+"\n"
        txt+=15*"=" +"\n"
        
        nameact=str(tagn)
        profileact=profile(nameact)
        
        txt+= "\nName       = "+nameact
        txt+="\nData: "+profileact
        txt+=10*"- "+"\n"
        txt+="\nLevel      = "+str(infhd[iobact][1])
        txt+="\nU          = "+str(infhd[iobact][2])
        txthilf1=str(infhd[iobact][3])
        if infhd[iobact][13]>5:
            txt+="\nnumber of predecessors (up) =: "+str(infhd[iobact][13])
            buttpred=Tkinter.Button(tpinfo,text="detailed Llst",command=listpresuc)
            buttpred.pack()
        else:
            txt+="\npredecessors (up)  = "+txthilf1
        txthilf2=str(infhd[iobact][4])
        if infhd[iobact][14]>5:
            txt+="\nnumber of successors (down) =: "+str(infhd[iobact][14])
            buttsucc=Tkinter.Button(tpinfo,text="detailed list ",command=listpresuc)
            buttsucc.pack()
        else:
            txt+="\nsuccessors (down) = "+txthilf2
        txt+= "\ncovered by         = "+str(infhd[iobact][5])
        txt+= "\ncovering           = "+str(infhd[iobact][6])
        txt+="\n - - - e o f - - - "
        tinfo.insert("end",txt)
    else:
        pass


def movebrgright(event):
    #brg 4.9.2011
    r=3
    color="black"
    dx=5
    tagact=cv1.gettags(cv1.find_closest(int(cv1.canvasx(event.x)),\
                                        int(cv1.canvasy(event.y))))
    lt=len(tagact[0])
    tagn=tagact[0][7:lt]
    print "tagact[0] bei mouseclick  ",tagact[0],"   tagn= ",tagn
    try:
        itag=objred.index(tagn)
        print "itag= ",itag,"  tagact 0/objred to be deleted",tagact[0],"  objred[itag]= ",objred[itag]
        geocy[itag][0]+=dx
        cv1.delete(tagact[0])
        cv1.create_oval(geocy[itag][0]-r,geocy[itag][1]+r,\
                        geocy[itag][0]+r,geocy[itag][1]-r,fill=color,\
                        tags="object_"+str(objred[itag]))
        for j in range(0,2*covz):   
            if conn[itag][j]==1:
                print "j= ",j
                order=""
                if int(1.0*j/2.0)!=1.0*j/2.0:
                    jact=int((j-1.0)/2.0)
                    order="u"
                else:
                    jact=int(1.0*j/2)
                    order="g"
                
                cv1.delete("li"+str(jact))
                geoli[j][0]+=dx
                if order=="g":
                    cv1.create_line(geoli[j][0],geoli[j][1],geoli[j+1][0],\
                                     geoli[j+1][1],tags="li"+str(jact))
                else:
                    cv1.create_line(geoli[j-1][0],geoli[j-1][1],geoli[j][0],\
                                    geoli[j][1],tags="li"+str(jact))
    except:
        pass
                           
def movebrgleft(event):
    #brg 4.9.2011
    r=3
    color="black"
    dx=-5
    tagact=cv1.gettags(cv1.find_closest(int(cv1.canvasx(event.x)),\
                                        int(cv1.canvasy(event.y))))
    lt=len(tagact[0])
    tagn=tagact[0][7:lt]
    print "tagact[0] bei mouseclick  ",tagact[0],"   tagn= ",tagn
        
    try:
        itag=objred.index(tagn)
        geocy[itag][0]+=dx
        cv1.delete(tagact[0])  #6.9.2011
        cv1.create_oval(geocy[itag][0]-r,geocy[itag][1]+r,\
                        geocy[itag][0]+r,geocy[itag][1]-r,fill=color,\
                        tags="object_"+str(objred[itag]))  #6.9.2011
        for j in range(0,2*covz):   
            if conn[itag][j]==1:
                print "j= ",j
                order=""
                if int(1.0*j/2.0)!=1.0*j/2.0:
                    jact=int((j-1.0)/2.0)
                    order="u"
                else:
                    jact=int(1.0*j/2)
                    order="g"
                cv1.delete("li"+str(jact))
                geoli[j][0]+=dx
                if order=="g":
                    cv1.create_line(geoli[j][0],geoli[j][1],geoli[j+1][0],\
                                     geoli[j+1][1],tags="li"+str(jact))
                else:
                    cv1.create_line(geoli[j-1][0],geoli[j-1][1],geoli[j][0],\
                                    geoli[j][1],tags="li"+str(jact))
    except:
        pass


def trred(n,ad):
    #brg 18.8.2011
    #ad: zeta matrix: row >= column
    covh=rmod2.marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
            covh[i][j]=ad[i][j]
    for i in range(0,n):
        for j in range(0,n):
            if i!=j:
                for k in range(0,n):
                    if j!=k:
                    
                        testsum=ad[i][j]+ad[j][k]
                        if testsum>ad[i][k]:
                            covh[i][k]=0
    return covh            


def maxlevel(n,c):
   #brg 19.8.2011
   visit=set([])
   for i in range(0,n):
        sumc=0
        for j in range(0,n):
            sumc+=c[i][j]
        if sumc==0:
            visit.add(i)
                
   return visit           
                

def level(n,c):
    # brg  19.8.2011
    # initializing
    alllevels=rmod2.vecgen1(n)
    for i in range(0,n):
        alllevels[i]=-1
    iobset=set([])
    for i in range(0,n):
        iobset.add(i)
    visitall=set([])

    # stepwise : step i: max-level of c-maxlevel of the step i-1 
    z=0
    for lev in range(0,n):
        visit=set([])
        if len(iobset-visitall)==0:
            #print "loop stop"
            break
        for iob in iobset-visitall:
            #print "z= ",z,"  iob= ",iob,"  iobset ",iobset    
            sumc=0
            for j in range(0,n):
                if j not in visitall:
                    sumc+=c[iob][j]
            if sumc==0:
                visit.add(iob)
        
        
            #print "visit ",visit
            alllevels[z]=visit
        visitall=visitall|visit    
        z+=1
    return alllevels

def HD():
    #31.8.2011
    #Note: test version, new algorithm for finding the transitives and for reducing them
    global cv1,lz,l,objred,geocy,geoli,covz,conn,covwd,lobj
    try:
        schalter=int(eschalter.get())
    except:
        schalter=1
        
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
  
    n=rred
    cov=rmod2.marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
             cov[i][j]=zeta[i][j]

    for ic in range(0,n):
        cov1=trred(n,cov)
        flag=0
        for i1 in range(0,n):
            for i2 in range(0,n):
                if cov1[i1][i2]!=cov[i1][i2]:
                    flag=1
                    break
                    
        if flag==1:
            for i in range(0,n):
                for j in range(0,n):
                     cov[i][j]=cov1[i][j]
            continue
        else:
            break

              
                
    covt=rmod2.marray(rred,rred)

    for i in range(0,rred):
        for j in range(0,rred):
            covt[i][j]=cov1[j][i]
            if i==j:
                covt[i][j]=0

    print "Stop after ",ic," cycles, covt"    
    #rmod2.matout(n,n,covt)      

    #print "cov "
    #rmod2.matout(rred,rred,cov1)

    covwd=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            if i==j:
                covwd[i][j]=0
            else:
                covwd[i][j]=cov1[i][j]

    print "covwd = "
    #rmod2.matout(rred,rred,covwd)


    all_levels=level(rred,covwd)

    z=0
    vecalllev=[]
    for i in range(0,rred):
        if all_levels[i]!=-1:
            print "all levels ",i," = ",all_levels[i]
            vecalllev.append(all_levels[i])
            z+=1
    nroflevels=z
    #print "Number of levels ",nroflevels
    #print "vecalllev= ",vecalllev

    lobj=[]
    for i in range(0,nroflevels):
        lobj.append(0)
    #listpresuc
    for i in range(0,nroflevels):
        lobj[i]=[]
        for iob in vecalllev[i]:
            lobj[i].append(iob)

    levelwidth=[]
    for i in range(0,nroflevels):
        print lobj[i]
        levelwidth.append(len(lobj[i]))

    maxwidth=max(levelwidth)    
    
    
    
    geomwidth=100*maxwidth
    geomheight=100*nroflevels
    print "geomwidth = ",geomwidth
    print "geomheight= ",geomheight
        
    lz=nroflevels
    l=rmod2.vecgen1(lz)
    for i in range(0,lz):
        l[i]=len(lobj[i])

    pos=rmod2.vecgen1(lz)
    for i in range(0,lz):
        pos[i]=l[i]


    global infhd,zob
    infhd=rmod2.marray(rred,15)
            
    if schalter==0:
        tphd0=Tkinter.Toplevel(hf)
        tphd0.title('  Hassediagram version with labels')
        
        cv0=Tkinter.Canvas(tphd0,width=max(geomwidth,800),height=min(geomheight,800),bg="white")
        cv0.pack()
        geom0x=20
        geom0y=50
        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)
        factorx=200  #changed 1.5.16 from 600 to 200
        factory=200   #changed 1.5.16 from 600 to 200
        for i in range(0,lz):
                for j in range(0,l[i]):
                    geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                    geomy[i][j]=geom0y+(factory/lz)*i
                
            
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covwd[lobj[i1][j1]][lobj[i][j]]==1:
                            cv0.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv0.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv0.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        
    else:
       # HD without labels, but to be explored by mouseclick 
       tphd1=Tkinter.Toplevel(hf)
       tphd1.title('  Hassediagram ')                        
       lb1.config(text="mouse-click to get infos about the vertices ",bg="yellow")
       cv1=Tkinter.Canvas(tphd1,width=50+min(geomwidth,800),height=min(geomheight,800),bg="white")
       cv1.pack()
       geom0x=10
       geom0y=10
       global geomx,geomy,zob
        
       geomx=rmod2.marray(rred,rred)
       geomy=rmod2.marray(rred,rred)
       factorx=200  #changed 1.5.16
       factory=200  #changed 1.5.16
       objid=[]
                 
       geocy=rmod2.marray(rred,2)
       zcy=0
       for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
                objid.append(lobj[i][j])
                

       
       global covz 
       covz=0
       li=[]
       for i in range(0,lz-1):
           for j in range(0,l[i]):
               for i1 in range(i+1,lz):
                   for j1 in range(0,l[i1]):
                       if covwd[lobj[i1][j1]][lobj[i][j]]==1:
                           li.append(covz)
                           li[covz]=cv1.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1],tags="li"+str(covz))
                           covz+=1

       geoli=rmod2.marray(2*covz,2)
       conn=rmod2.marray(rred,2*covz+1)
       #print "covz= ",covz
       z=0
       for i in range(0,lz-1):
           for j in range(0,l[i]):
               for i1 in range(i+1,lz):
                   for j1 in range(0,l[i1]):
                       if covwd[lobj[i1][j1]][lobj[i][j]]==1:
                           geoli[z][0]=geomx[i][j]
                           geoli[z][1]=geomy[i][j]
                           geoli[z+1][0]=geomx[i1][j1]
                           geoli[z+1][1]=geomy[i1][j1]
                           conn[objred.index(objred[lobj[i1][j1]])][z+1]=1
                           conn[objred.index(objred[lobj[i][j]])][z]=1
                           z+=2 

       z=0
       zob=[]
       r=3
       color="black"
       for i in range(0,lz):
           for j in range(0,l[i]):
               cv1.create_oval(geomx[i][j]-r,geomy[i][j]+r,geomx[i][j]+r,\
                               geomy[i][j]-r,fill=color,tags="object_"+objred[lobj[i][j]])#6.9.2011 ob new
                
               zcy=lobj[i][j] 
               geocy[zcy][0]=geomx[i][j]
               geocy[zcy][1]=geomy[i][j]
               
               zob.append(objred[lobj[i][j]])  
               infhd[z][0]=objred[lobj[i][j]] 
               infhd[z][1]=nroflevels-i
               ui=0
               
               for j1 in range(0,rred):
                    if zeta[objid[z]][j1]==0 and zeta[j1][objid[z]]==0:
                           ui+=1.0
               infhd[z][2]=ui
               zdown=0
               txt1=""
               for j1 in range(0,rred):
                   if zeta[objid[z]][j1]==1 and j1!=objid[z]:
                       zdown+=1
                       txt1+=str(objred[j1])+", "
               infhd[z][3]=txt1
               infhd[z][13]=zdown
               zup=0
               txt1=""
               for j1 in range(0,rred):
                   if zeta[j1][objid[z]]==1 and j1!=objid[z]:
                       zup+=1
                       txt1+=str(objred[j1])+", "
               infhd[z][4]=txt1
               infhd[z][14]=zup
               txt1=""
               for j1 in range(0,rred):
                   if covwd[objid[z]][j1]==1 and j1!=objid[z]:
                       txt1+=str(objred[j1])+", "
               infhd[z][5]=txt1        
               txt1=""
               for j1 in range(0,rred):
                   if covwd[j1][objid[z]]==1 and j1!=objid[z]:
                       txt1+=str(objred[j1])+", "
               infhd[z][6]=txt1   


               z+=1 
##       print "geocy" 
##       rmod2.matout(rred,2,geocy) 
       cv1.bind("<Alt-Button-1>",infohd)
       cv1.bind("<Button-3>",movebrgright)
       cv1.bind("<Button-1>",movebrgleft)

    

hf = Tkinter.Tk()
hf.title(' HD_alternativ ')
aboutHDalter=raioop2.brgabout(hf,"tp1","about_HDalter.txt",6,\
            "Sept., 6th,2011"," about HDalter ", "white", "t1",80,5,ScrolledText)
helpHDalter=raioop2.brgabout(hf,"tp1","help_HDalter.txt",6,\
            "Sept, 6th ,2011"," help_HDsimpl ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open file',width=25,bg="cyan",command=selop)
buttHD.pack(pady=5)
buttshowdm=Tkinter.Button(fr,text="show dm ",command=showDM)
buttshowdm.pack()
frsch=Tkinter.Frame(fr)
frsch.pack(pady=5)
lbschalter=Tkinter.Label(frsch,text="select graph-modus: 0: with labels or 1: without labels")
lbschalter.pack(side="left")
eschalter=Tkinter.Entry(frsch,width=2)
eschalter.pack(side="left")

buttHD=Tkinter.Button(fr,text="Hasse diagram in repres. \ndepending on your selection ",bg="cyan",width=25,command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()










