import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import random

# brg 7.11.09,22.11.09, 19.6.2012

def dmcalc():
    global dm,obj,att,r,k,nact,mact,nmact
    obj=rmod2.vecgen1(nmax)
    att=rmod2.vecgen1(mmax)
    dmin=rmod2.marray(nmax,mmax)
    for i in range(0,nmax):
        obj[i]=chr(97+i)
    for j in range(0,mmax):
        att[j]="q"+str(j+1)
        
    for i in range(0,nmax):
       for j in range(0,mmax):
            hilf=datentry[i][j].get()
            try:
                dmin[i][j]=float(hilf)
            except:
                dmin[i][j]=-999
    nact=0
    nact2=0
    nmact=0
    for i in range(0,nmax):
       if dmin[i][0]!=-999:
           nact+=1
       if dmin[i][1]!=-999:
           nact2+=1
       
       for j in range(0,mmax):
           if dmin[i][j]!=-999:
               nmact+=1
           
    mact=1.0*nmact/(1.0*nact)
    if mact!=int(mact) or nact!=nact2:
        tpwarn=Tkinter.Toplevel(hf)
        tpwarn.title("warning")
        lbwarn=Tkinter.Label(tpwarn,text="+++ dm may be incorrect +++",bg="yellow")
        lbwarn.pack()
        
##    print "nact= ",nact
##    print "nmact= ",nmact
##    print "mact= ",mact
    dm=rmod2.marray(int(nact),int(mact))
    for i in range(0,int(nact)):
        for j in range(0,int(mact)):
           dm[i][j]=dmin[i][j]
    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    r=int(nact)
    k=int(mact)
   
    
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of dm with "\
                            +str(nact)+ " rows and "+str(int(mact))+" columns  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

        try:
            perturb=int(eperturb.get())
        except:
            perturb=0
            
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(1.0+perturb*random.randint(1,3))*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttshow.config(state="active")



def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    txt1=" General information "
    txt1+="\n taken rows: "+str(nact)
    txt1+="\n taken columns "+str(mact)
    txt1+=2*"\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+att[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=att[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def sf():
    #brg  31.5.09, 1.6.09
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
    rmod2.raiwrite5(fn,dm,obj,att,r,k)
    lbsuccess.config(text="matrix with \n"+str(r)+"  rows  and "+str(k)+"\n  columns stored",bg="yellow")


def submit():
    # brg 19.6.2012
    global nmax,mmax,datentry
    tp=Tkinter.Toplevel(hf)
    nmax=int(enmax.get())
    mmax=int(emmax.get())
    lbobj=rmod2.vecgen1(nmax)
    lbatt=rmod2.vecgen1(mmax)
    datentry=rmod2.marray(nmax,mmax)
    
    for j in range(0,mmax):
        lbatt[j]=Tkinter.Label(tp,text="q"+str(j+1))
        lbatt[j].grid(row=0,column=1+j)
    for i in range(0,nmax):
        for j in range(0,mmax):
            lbobj[i]=Tkinter.Label(tp,text=chr(97+i)+":")
            lbobj[i].grid(row=1+i,column=0)
            datentry[i][j]=Tkinter.Entry(tp,width=3)
            datentry[i][j].grid(row=1+i,column=1+j)
        
    







hf=Tkinter.Tk()
hf.title(' HDscratch ')
lbgen=Tkinter.Label(hf,text= "    HD from scratch, show dm , store dm        ", width=60)
lbgen.pack()     
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_HDscratch.txt",2,\
            "June, the 19th, 2012"," about HDscratch ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_HDscratch.txt",2,\
            "June, the 19th, 2012"," help_HDscratch ", "white", "t1",80,5,ScrolledText)
    

fr=Tkinter.Frame(hf,width=200,height=200,relief="sunken",bd=3)
fr.pack(pady=10)
lbnmax=Tkinter.Label(fr,text="Please enter number of rows ")
lbnmax.pack()
enmax=Tkinter.Entry(fr,width=4)
enmax.pack()
lbmmax=Tkinter.Label(fr, text="Please enter number of columns ")
lbmmax.pack()
emmax=Tkinter.Entry(fr,width=4)
emmax.pack()
buttsubmit=Tkinter.Button(fr,text="Submit matrix dimensions ",width=25,bg="cyan", command=submit)
buttsubmit.pack()
frperturb=Tkinter.Frame(hf)
frperturb.pack()
lbperturb=Tkinter.Label(frperturb,text="0: symm. repr., 1,2...:perturbed repr.")
lbperturb.pack(side="left")
eperturb=Tkinter.Entry(frperturb,width=2)
eperturb.pack(side="left")
buttdm=Tkinter.Button(frperturb,text="Hasse diagram",width=25,bg="cyan",command=dmcalc)
buttdm.pack()
buttshow=Tkinter.Button(hf,text=" show dm ",width=25, bg="cyan", command=showDM,state="disabled")
buttshow.pack(pady=5)
buttsave=Tkinter.Button(hf,text="store dm in PyHasse format",width=25,bg="cyan",command=sf)
buttsave.pack()
lbsuccess=Tkinter.Label(hf,text="\n\n\n")
lbsuccess.pack()
buttexit=Tkinter.Button(hf,text="exit",width=25,bg="red",command=hf.destroy)
buttexit.pack(pady=5)







hf.mainloop()
