import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 19.12.17 Control prints
# 25.07.18 L_evalsimpl


###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def interface_graphviz():
    # brg 9.9.2014
    #taken from mHDCl2
    covgr=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if i1!=i2:
                covgr[i1][i2]=cov[i1][i2]
    txtgr=rmod2.covtxt(covgr,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile3(fr,'t','w',txtgr,rred,rred) 
    import tkMessageBox
    tkMessageBox.showinfo(title="store graphviz-interface",message="successafull!")


    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    # brg 25.07.18: reduction onto quotient sets eliminated
    global r,k,obj,prop,x,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
 
def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    # brg 25.07.18: reduction onto quotient sets eliminated
    global r,k,x,fn,obj,prop,dm
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    

    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    
    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)
   
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    
def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17, 25.07.18
    # brg 25.07.18: reduction onto quotient sets eliminated
    global fn,r,k,x,prop,obj
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
 

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # brg 25.07.18: reduction onto quotient sets eliminated
    # source: mainHD19
    global fn,r,k,x,prop,obj
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    

##### end of editenster ### 29.8.2013 ####
def show_dm():
    #brg 25.07.18
    textmatrix="\n Read in data matrix \n"
    show_matrix(x, obj, prop, textmatrix)

def show_matrix(matrix, label_rows, label_columns, textmatrix):
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from interval9.py
    # strongly reorganized: 25.07.18
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    k=len(label_columns)
    r=len(label_rows)
    txt1="\n"
    txt1+=textmatrix
    txt1+="\n label_rows\n"
    for i in range(0,r):
        txt1+=" "+label_rows[i]+",\t"
    txt1+="\n"
    txt2="\n label_columns  \n"
    for j in range(0,k):
        txt2+=" "+label_columns[j]+",\t"
    txt2+="\n"
    txt3="\n matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=label_columns[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=label_rows[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(matrix[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
                      
def resid(vec1,vec2,n):
    #brg 25.07.18, 27.07.18
    # calculates the residuum of the standard norm for  a l l
    # elements of vec1, vec2
    
    s=[]
    for j in range(0,n):
        if vec1[j]<=vec2[j]:
            s.append(1)
        else:
            s.append(vec2[j])
    smin=9999
    jmin=0
    for j in range(0,n):
        if s[j]<=smin:
            smin=s[j]
            jmin=j
    #print "smin= ",smin, "j = ",jmin, objred[jmin]
    objmin=[]
    for j in range(0,n):
        if s[j]==smin:
            objmin.append(j)
    return smin,jmin, objmin

def HD(dm, rows, columns, labels_for_the_vertices, texthd):
    # brg 26.7.2013, 29.8.2013, 2.11.16, 25.07.18
    # 25.07.18: reduced to quotient set now explicitly in HD   
    tphd=Tkinter.Toplevel(hf)
    tphd.title('Hasse diagram / cover matrix ')
    frhd=Tkinter.Frame(tphd,width=200,height=300)
    frhd.pack()
    rowsred,dmred,labelsred,txteq,neq=rmod2.equivcompactm2(rows,columns,dm,labels_for_the_vertices,10)     
    zetahilf=rmod2.comp(rowsred,columns, dmred)  #zeta matrix with col<row
    zeta=rmod2.marray(rowsred,rowsred)
    for i1 in range(0,rowsred):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rowsred):
            zeta[i1][i2]=zetahilf[i2][i1]
    
    Utotal = rmod2.incompzeta(rowsred,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rowsred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rowsred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rowsred,adjc,lext)
       
    
    cov=rmod2.cover(rowsred,tr,lext)

    if rowsred>500:
        lbhd3=Tkinter.Label(frhd,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()
        lbhd4=Tkinter.Label(frhd,text=str(fn))
        lbhd4.pack()
    else:
        lbhd3=Tkinter.Label(frhd,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        lbhd4=Tkinter.Label(frhd,text=str(fn)+texthd)
        lbhd4.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rowsred,levmax,zzmax)
        cv=Tkinter.Canvas(frhd,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rowsred,rowsred)
        geomy=rmod2.marray(rowsred,rowsred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=labels_for_the_vertices[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        
                      
    return dmred, labelsred, cov, zeta, rowsred, txteq
        
def cover(covermatrix,labels_for_the_vertices, rred, textcov):
    # brg 25.07.18
    tpcover = Tkinter.Toplevel(hf)
    tpcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(tpcover,text=" Cover-Relations "+textcov)
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i1 in range(0, rred):
        txt3 += "\n" + str(labels_for_the_vertices[i1]) + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, rred):
            if i1!=i2:
                if covermatrix[i1][i2] == 1:
                    txt3 += " " + str(labels_for_the_vertices[i2]) + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(tpcover,width=50, height=40)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq(txtequiv):
    # brg 25.07.18 
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=40)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txtequiv
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def HDdmorig():
    # brg 25.07.18
    global txteqorig, rred, xred, objred
    texthd="\nOriginal data matrix "+"\n"
    xred, objred, covorig, zetaorig, rred, txteqorig = HD(x, r, k, obj, texthd)
    print txteqorig
    
                      
def HDdmtr():
    # brg 25.07.18
    global txteqtr,kred, xredtr, attred
    texthdorig="\ndata matrix transposed "+"\n"
    dmtr=rmod2.marray(k,r)
    for i in range(0, r):
        for j in range(0, k):
            dmtr[j][i]=x[i][j]
    print "dmtr"
    rmod2.matout(k,r,dmtr)
    print " "
    xredtr, attred,covtr,zetatr,kred, txteqtr=HD(dmtr, k, r, prop, texthdorig)
    print txteqtr
    if kred!=k:
        lbdmtr.config(text="++++ please check the dm: n\
                    Some indicators are superfluous++++", bg="red")
                      

def truthvalues():
    # brg 25.07.18
    global vecA, vecB, A, B, objmin
    A=e_A.get().split(",")
    B=e_B.get().split(",")
    for j in range(0, len(A)):
        A[j]=int(A[j])
        if A[j] > 1:                #26.07.18
            A[j]=1
    for j in range(0, len(B)):
        B[j]=int(B[j])
        if B[j] > 1:               #26.7.18
            B[j]=1
    #print "A = ",A
    #print "B = ",B
    txt="truth value"+"\n"
    txt+=str(fn)+"\n"
    txtall=""
    for j in range(0,k):
        txtall+=str(prop[j])+", "
    txtall+="\n"
    txt+=txtall+"\n"
    
    txtA=""
    txtB=""
    for j in range(0,k):
        if A[j]==1:
            txtA+=str(prop[j])+", "
    txt+="Indicators of premise  "+txtA+"\n"        
    for j in range(0,k):
        if B[j]==1:
            txtB+=str(prop[j])+", "
    txt+="indicators of conclusion "+txtB+"\n"        
    txt+=txtA +"==> "+txtB + "\n"        
    
    
    countA=sum(A)
    countB=sum(B)
    if countA>k or countB >k:
        print "++++ warning +++"
    if countA ==0 or countB == 0:
        print "+++ implications with 'empty' +++ ???"
    vecA=[]
    vecB=[]
    for i in range(0, rred):
        hilf=[]
        for j in range(0, k):
            if A[j]==1:
                hilf.append(xred[i][j])
        vecA.append(min(hilf))
    
    
    for i in range(0, rred):
        hilf=[]            
        for j in range(0, k):
            if B[j]==1:
                hilf.append(xred[i][j])
        vecB.append(min(hilf))        
    sminact,jminact,objmin=resid(vecA,vecB,len(vecA))
    print sminact
    print objred[jminact]
    txt+=50*"-"+"\n"
    txt+="truth value of (  "+txtA +"  ==> "+txtB+") : "+str(round(sminact,2))+"\n"
    lobjmin=len(objmin)
    txt+="Minimal value was found for "+str(lobjmin) + "  objects" +"\n"
    txt+="one object of this list : "+str(objred[jminact])+"\n"
    txt+=50*"-"+"\n"
    tpimp=Tkinter.Toplevel(hf)
    tpimp.title("Implications ")
    timp=ScrolledText(tpimp,width=60, height=10)
    timp.pack()
    timp.insert("end",txt)
    
def details():
    # brg 25.07.18, 26.07.18
    txt="details"+"\n"
    txt+="Equivalencies "+"\n"
    txt+=str(fn)+"\n"
    txt+=txteqorig+"\n"
    txt+=txteqtr+"\n"
    txt+="Details of calculation "+"\n"
    txt+="Premise"+"\n"
    for j in range(0,k):
        if A[j]==1:
            txt+=str(prop[j])
    txt+="\n"
    txt+="Conclusion "+"\n"
    for j in range(0,k):
        if B[j]==1:
            txt+=str(prop[j])
    txt+="\n"
    txt+="Interim results:"+"\n"
    txt+="vecA: = minimum of data values of premise"+"\n"
    for i in range(0, rred):
        txt+=str(round(vecA[i],4))+", "
    txt+="\n"
    txt+="vecB: = minimum of data values of conclusion"+"\n"
    for i in range(0, rred):
        txt+=str(round(vecB[i],4))+", "
    txt+="\n"
    txt+="list of objects whose residuum was minimal: "+"\n"
    for j in range(0,len(objmin)):
        txt+=str(objred[objmin[j]])+", "
    txt+="\n"    
    tpdetails=Tkinter.Toplevel(hf)
    tpdetails.title("details")
    tdetails=ScrolledText(tpdetails,width=60, height=20)
    tdetails.pack()
    tdetails.insert("end",txt)
    
    


## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' L_evalsimpl ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_L_evalsimpl.txt",1,\
            "July, the 26th, 2018"," about L_evalsimpl ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_L_evalsimpl.txt",1,\
            "July, the 26th, 2018"," help_HDsimpl ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
lb0=Tkinter.Label(fr,text="+++Only data matrices with values between 0 an 1 +++", bg="orange")
lb0.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=25, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=25, bg="cyan", command=HDdmorig)
buttHD.pack(pady=3)
buttHDtr=Tkinter.Button(fr, text="Draw HD of the transposed dm ",bg="cyan", width=45, command=HDdmtr)
buttHDtr.pack()
lbdmtr=Tkinter.Label(fr, text=" ")
lbdmtr.pack()
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
lb2 = Tkinter.Label(fr, text="Enter the premise 'A' in form of 0 or 1 ;\n\
                    1 in those positions whose indicator is to be selected ")
lb2.pack()
lb3 = Tkinter.Label(fr, text="Enter the conclusion 'B' in form of 0 or 1 ;\n\
                    1 in those positions whose indicator is to be selected ")
lb3.pack()
fr2=Tkinter.Frame(fr,bd=4,relief="sunken")
fr2.pack()
# Grid-Manager !!!
lbA=Tkinter.Label(fr2,text="Premise A: ")
lbA.grid(row=1, column=1)
e_A=Tkinter.Entry(fr2,width=40)
e_A.grid(row=1, column=2)
lbB=Tkinter.Label(fr2,text="Conclusion  B: ")
lbB.grid(row=2, column=1)
e_B=Tkinter.Entry(fr2,width=40)
e_B.grid(row=2,column=2)
butttv=Tkinter.Button(fr, text="Calculate the truthvalue of the implication A ==> B ",bg="cyan",width=45,command=truthvalues)
butttv.pack()
buttdetails=Tkinter.Button(fr,text="details", width=45, bg="cyan", command=details)
buttdetails.pack()


buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
