import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import polib
import math


# brg 26.7.2013, 31.10.2018
# 30.10.2018 Todeschini_method1, derived from hdsimpl4.py
# 31.10.2018 linear order 


###### editfenster ### 29.8.2013, 30.10.2018 #####
    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


##### end of editenster ### 29.8.2013 ####
def show_dm():
    polib.show_DM(hf,fn,x,prop,obj)


def HDdm():
    polib.HD(hf,fn,xred,rred,k,objred,13)

def calc_t(r,k,x, weight, precision=10):
    # brg 30.10.2018, 1.11.2018
    # r: number of objects
    # k: number of indicators
    # x: data matrix
    # precision: How many digitsafter the decimal-dot are to be regarded.
    global RT
    RThilf = []
    for i1 in range(0,r):
        RThilf.append(0)
        RThilf[i1]=[]
        for i2 in range(0,r):
            hilf = 0
            for j in range(0, k):
                if round(x[i1][j],precision)> round(x[i2][j],precision):
                    delta=1.0
                elif round(x[i1][j],precision) == round(x[i2][j],precision):
                    delta=0.5
                else:
                    delta=0.0
                hilf+=weight[j]*delta
            RThilf[i1].append(hilf)
    #proportional scaling
    RT=[]        
    for i1 in range(0,r):
        RT.append(0)
        RT[i1]=[]
        for i2 in range(0,r):
            RT[i1].append(1.0*RThilf[i1][i2]/(RThilf[i1][i2]+RThilf[i2][i1]))
    rmod2.matout(r,r,RT)        
    # transposing RT  (==> RTt)                      
    RTt=[]
    for i1 in range(0,r):
        RTt.append(0)
        RTt[i1]=[]
        for i2 in range(0,r):
            RTt[i1].append(RT[i2][i1])
    rmod2.matout(r,r,RTt)        
    return RT, RTt

def alpha(r):
    import math
    alf=1.0/(1.0*r+math.log(r,2))
    return alf

def calc_evRT():
    # brg 1.11.2018
    global evRT, evRTt, weight
    weight=rmod2.vecgen1(k)
    try:
        hilf=eweight.get().split(",")
        for j in range(0,k):
            weight[j]=float(hilf[j])
    except:
        for j in range(0,k):
            weight[j]=1.0/k
    
    print "weight= "
    print weight
    RTact,RTtact=calc_t(r,k,x, weight, precision=10)
    ewRT,evRT,countRT = rmod2.calc_maxEWEV(RTact)
    ewRTt,evRTt,countRTt = rmod2.calc_maxEWEV(RTtact)
    # norm by supposing length=1
    sum1=0
    for i in range(0,r):
        sum1+=evRT[i]*evRT[i]
    nrt=math.sqrt(sum1)
    for i in range(0,r):
        evRT[i]=1.0*evRT[i]/nrt
    sum2=0
    for i in range(0,r):
        sum2+=evRTt[i]*evRTt[i]
    nrt2=math.sqrt(sum2)
    for i in range(0,r):
        evRTt[i]=1.0*evRTt[i]/nrt2    
    print "evRT=  "
    for i in range(0,r):
        print round(evRT[i],3)," ",
    print " "    
    print "evRTt= "
    for i in range(0,r):
        print round(evRTt[i],3)," ",
    print " "
    wPWR=[]
    alf=alpha(r)
    for i in range(0,r):
        wPWR.append(1.0*(alf+evRT[i])/(1.0*alf+evRTt[i]))
    return evRT,evRTt,wPWR

def evord():
    # brg 1.11.2018
    evRT,evRTt,wPWR = calc_evRT()
    maxevRTt = max(evRTt)
    newev=[]
    for i in range(0,r):
        newev.append(maxevRTt - evRTt[i])
    dmnew=rmod2.marray(r,2)
    for i1 in range(0,r):
        dmnew[i1][0]=evRT[i1]
        dmnew[i1][1]=newev[i1]
    # dmnew must be reduced, in case of nontrivial equivalence classes
    rred2,xred2,objred2,txteq2,neq2=rmod2.equivcompactm2(r,2,dmnew,obj,10) 
    return xred2, objred2, rred2, txteq2

def HDwPWR():
    # brg 1.11.2018
    dmnew2,objred2,rred2,txteq2=evord()
    print dmnew2
    rmod2.matout(rred2,2,dmnew2)
    polib.HD(hf,fn,dmnew2,rred2,2,objred2,12)
    print "txteq2= ",txteq2
    
    
def show_orderwPWR():
    # brg 1.11.2018
    tpwPWR = Tkinter.Toplevel(hf)
    tpwPWR.title(' Todeschini et al, paper 2')
    twPWR=ScrolledText(tpwPWR,width=60,height=20)
    twPWR.pack()
    txt="Linear or weak order "+"\n"
    txt+="...based on the wPWR-quotients "+"\n"
    evRT,evRTt,wPWR = calc_evRT()
    for i in range(0,r):
        txt+=str(obj[i])+": "+str(round(wPWR[i],3))+", "
    txt+="\n"
    txt+="objects sorted increasingly "+"\n"
    txt+="  "
    d1,d2=rmod2.raisort(r,wPWR)
    print d2
    for i in range(0,r):
        if i==r-1:
            txt+=str(obj[d2[i]])
        else:    
            txt+= str(obj[d2[i]])+" =< "
    txt+="\n"    
    txt+=" - - - e o f - - - "
    twPWR.insert("end",txt)

        
        
    

    

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' Todeschini ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_wPWR.txt",1,\
            "November, the 1st, 2018"," about wPWR ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_wPWR.txt",1,\
            "Nowember, the 1st, 2018"," help wPWR ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=25, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=25, bg="cyan", command=HDdm)
buttHD.pack(pady=5)
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
lb2=Tkinter.Label(fr,text="insert weights (summing up to 1)")
lb2.pack()
eweight=Tkinter.Entry(fr,width=20)
eweight.pack()
buttevrt=Tkinter.Button(fr,text="wPWR ",bg="cyan",width=25,command=HDwPWR)
buttevrt.pack()
buttlinearorder=Tkinter.Button(fr,text="Linear(weak) order ",bg="cyan",width=25, command=show_orderwPWR)
buttlinearorder.pack()

buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
