import rmod2
import pstat
import stats
import random
import Tkinter
import tkFileDialog
import raioop2

from ScrolledText import * 

# brg 2.11.16
# Vs: 4_3: Evaluation part UMC etc now only related to representative elements

def local_incomp(n,relat):
    # brg 2.11.2016
    Uloc=rmod2.vecgen1(n)
    for i1 in range(0,n):
        hilf=0
        for i2 in range(0,n):
            if relat[i1][i2]==0 and relat[i2][i1]==0:
                hilf+=1
        Uloc[i1]=hilf
    return Uloc    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    

def determine_lastposition(x):
    # brg 24.04.17
    #last contribution of x unequal 0, counted 1,2,3...
    # for example x = [0,2,0,3,4,5,0,0,0,0] then hmax would be 6
    hmax=len(x)
    for j in range(hmax-1,0,-1):
        #print j,x[j]
        if x[j]==0:
            hmax-=1
            #print "hmax= ",hmax
        else:
            break
    return hmax


def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,n,m,dm,prop,obj,rred,xred,objred,txteq
    dm,ob,pr,n,m=rmod2.EXCELreadin6(fn)
    obj=rmod2.vecgentext1(n)                        # 29.11.07
    prop=rmod2.vecgentext1(m)
    for i in range(0,n):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,m):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(n)+" rows and "+str(m)+"  columns"
    dmnorm=rmod2.matrixnorm(n,m,dm)
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(n,m,dmnorm,obj,10)   # 8.9.2014
    print "n = ",n
    print "rred=  ",rred
    print "xred= "
    rmod2.matout(rred,m,xred)
    print " "

def openproc():
    # Brg  30.11.2016
    xselectfile()
    xfileopen()


def HD():
    # brg 26.7.2013, 29.8.2013, 2.11.16, 20.4.2017
    
    global x,la,ls,cov, rred, objred, sumfreq
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    
    zetahilf=rmod2.comp(rred,m,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    rmod2.matout(rred,rred,zeta)
    Utotal = rmod2.incompzeta(rred,zeta)
    print "Utotal = ", Utotal
    # list of incomparable pairs (x,y)
    listofincomp_pairs = []
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if zeta[i1][i2]==0 and zeta[i2][i1]==0:
                if (objred[i1],objred[i2]) in listofincomp_pairs or (objred[i2],objred[i1]) in listofincomp_pairs:
                    pass
                else:
                    listofincomp_pairs.append((objred[i1],objred[i2]))
    print "listofincomp_pairs "
    print listofincomp_pairs
    txt="min max of incomparabilities "+"\n"
##    for j1 in range(0,m):
##        for j2 in range(j1+1,m):
##            txt+="\t"+"("+str(prop[j1])+","+str(prop[j2])+")"
    #txt+="\n"
    maxU2=[]
    for i1 in range(0,rred):
        for i2 in range(i1+1,rred):
            if zeta[i1][i2]==0 and zeta[i2][i1]==0:
                 txt+=str(objred[i1])+","+str(objred[i2])+":\t"
            hilf=[]     
            for j1 in range(0,m):
                for j2 in range(j1+1,m):
                    zeta2att,q1,q2=rmod2.comp2(rred,j1,j2,xred)
                    if zeta2att[i1][i2]==0 and zeta2att[i2][i1]==0:
                        mindelta=min(abs(xred[i1][j1]-xred[i2][j1]),abs(xred[i1][j2]-xred[i2][j2]))
                        maxdelta=max(abs(xred[i1][j1]-xred[i2][j1]),abs(xred[i1][j2]-xred[i2][j2]))
                        hilf.append(mindelta)
                        txt+=str(prop[j1])+","+str(prop[j2])+": "+"("+str(mindelta)+", "+str(maxdelta)+")\t"
            print objred[i1],objred[i2],"  hilf= ",hilf,
            if hilf!=[]:
                print "   max = ",max(hilf)
            else:
                print "   max = ----"
            if hilf!=[]:            
                maxU2.append(max(hilf))            
            txt+="\n"          
    txt+="\n"
    txt+="maxU2.Values "+"\n"
    for j in range(0, len(maxU2)):
        txt+=str(round(maxU2[j],3))+", "
    hcruc=[0]
    for j in range(0,10):
        countcruc=0
        for j2 in range(0,len(maxU2)):
            if j*0.1<round(maxU2[j2],3)<=(j+1)*0.1: 
                countcruc+=1
        hcruc.append(countcruc)
    hmax=determine_lastposition(hcruc)
        
    
    txt+="\nFrequencies " +"\n"
    if hmax<11:
        txt+="+++Note: partitioning of "+str(Utotal)+"  has not standard length ! +++"
        txt+="\n"
        txt+="Contributions to "+str(Utotal) +"  start at "+str(hmax)+"\n"
    txttit="Frequencies "+"\n"
    for j in range(0,len(hcruc)):
        txt+=str(hcruc[j])+", "
        txttit+=str(hcruc[j])+", "
    txt+="\n"
    txttit+="\n"
    txt+="Akkumulation "+"\n"
    sumfreq=[]
    sumf=0
    for j in range(0,hmax):
        sumfreq.append(sumf)
        sumf+=hcruc[hmax-1-j]
        txt+=str(sumfreq[j])+", "
    txt+="\n"    
    print "sumfreq= ",sumfreq    
    print "hcruc= ",hcruc
    
    tpcruc=Tkinter.Toplevel(hf)
    tcruc=ScrolledText(tpcruc,width=120,height=20)
    tcruc.pack()
    tcruc.insert("end",txt)
    barth=["0","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1"]
    histotitel="Distribution U2max "+txttit
    breite_bar=6
    colour="black"
    app=raioop2.brgbar10(hf,hcruc,barth,histotitel,breite_bar,colour)
    app.ausgabe()
    print "nach app:  n= ",n
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def submit():
    #brg 30.11.2016
    global weight
    ew=eweight.get()
    weight=ew.split(",")
    for j in range(0,m):
        weight[j]=float(weight[j])
        print round(weight[j],3),
    print " "    

def standardweights():
    # brg 24.04.17
    global weight
    weight=[]
    print "weights by default "
    for j in range(0,m):
        weight.append(1.0/(1.0*m))
        print round(weight[j],3)
    
def calc():
    #brg 30.11.2016
    MC = int(eMC.get())
    tpdm=Tkinter.Toplevel(hf)
    tpdm.title("data matrix ")
    tdm=ScrolledText(tpdm,width=80, height=20)
    tdm.pack()
    txtdm="Data matrix with "+str(n)+"  rows and "+str(m)+"   indicators\n"
    
    for i in range(0,n):
        for j in range(0,m):
            txtdm+=str(round(dm[i][j],3))+"\t"
        txtdm+="\n"
    tdm.insert("end",txtdm)
    # correlation
    corvec=[]
    for j1 in range(0,m):
        hilf1=[]
        for i in range(0,n):
            hilf1.append(dm[i][j1])
          
        for j2 in range(j1+1,m):
            hilf2=[] 
            for i in range(0,n):
                hilf2.append(dm[i][j2])
        
            correl,dummy=pstat.lpearsonr(hilf1,hilf2)
            print j1,j2,"  correl**2 ",correl*correl                     
            corvec.append(correl*correl)
    # relat matrix based on dm random
    relat = rmod2.comp(rred,m,xred)
    Utotal = rmod2.incompzeta(rred,relat)
    

    Uloc=local_incomp(rred,relat)
    
    suma=0
    print "final weights "
    for j in range(0,m):
        print round(weight[j],3),
    print " "    
    #weight intervals
    o=[]
    u=[]
    tplimits=Tkinter.Toplevel(hf)
    tplimits.title("Upper and lower \nlimits of weight evolution")
    tlimits=ScrolledText(tplimits,width=80,height=20)
    tlimits.pack()
    txtlimits=""
    for s in range(0,11,1):
        o.append(0)
        o[s]=[]
        u.append(0)
        u[s]=[]
        for j in range(0,m):
            o[s].append((1-weight[j])*0.1*s + weight[j])
            u[s].append((-weight[j])*0.1*s + weight[j])
    txtlimits+="o= "+"\n"
    for j in range(0,m):
        txtlimits+=str(prop[j])+": "+"\n"
        for s in range(0,11,1):
                txtlimits+=str(round(o[s][j],3))+" "
        txtlimits+="\n"    
    txtlimits+= "u= "+"\n"
    for j in range(0,m):
        txtlimits+=str(prop[j])+": "+"\n"
        for s in range(0,11,1):
            txtlimits+=str(round(u[s][j],3))+" "
        txtlimits+="\n"
    txtlimits+="\n"
    tlimits.insert("end",txtlimits)
                       

    # MC-simulation
    mincor=min(corvec)
    txtexcel="s\tUtotMC\tUs\tsurviving incomps\n"
    deviation = []  #deviation along UMC and Us
    for s in range(0,11,1):
        V=1
        w = []
        # generation of a random weight-matrix
        wmax=rmod2.vecgen1(m)
        wmin=rmod2.vecgen1(m)
        countgrw=rmod2.vecgen1(m)
        wsum=rmod2.vecgen1(MC)
        for mc in range(0,MC):
            #print "s= ",s,"  mc= ",mc
            w.append(0)
            w[mc]=[]
            wsum[mc]=0
            
            for j in range(0, m):
                #print "j= ",j,"  u= ",u[s][j],"  o= ",o[s][j]
                if u[s][j]==o[s][j]:
                    w[mc].append(u[s][j])
                else:
                    hilfx=random.uniform(u[s][j],o[s][j])                          #central select. of weights
                    w[mc].append(hilfx)
                if o[s][j]-((1.0*o[s][j]-1.0*u[s][j])/5.0)<=w[mc][j]<=o[s][j]:
                    countgrw[j]+=1
                wsum[mc]+=w[mc][j]


    # end of mc-loop
    # max
        for j in range(0, m):
            wmax[j]=-99999

        for j in range(0,m):    
            for mc in range(0,MC):
                if w[mc][j]>wmax[j]:
                    wmax[j]=w[mc][j]

    # min
        for j in range(0,m):
            wmin[j]=99999

        for j in range(0,m):    
            for mc in range(0,MC):
                if w[mc][j]<wmin[j]:
                    wmin[j]=w[mc][j]
    ##    print "s= ",s            
        
    
        dmC = []
        for i in range(0,rred):
            dmC.append(0)
            dmC[i]=[]
            for mc in range(0,MC):
                hilf=0
                for j in range(0,m):                
                    hilf+=1.0*w[mc][j]*xred[i][j]
                dmC[i].append(1.0*hilf/(1.0*wsum[mc]))
        relatC = rmod2.comp(rred,MC,dmC)
        #rmod2.matout(n,n,relatC)
        UtotalC=rmod2.incompzeta(rred, relatC)
        Us = Utotal*0.1*s
        devhilf = UtotalC - Us
        devhilfabs=abs(UtotalC-Us)
        deviation.append(devhilfabs)
        
        txtexcel+=str(s)+"\t"+str(UtotalC)+"\t"+str(0.1*s*Utotal)+"\t"+"\n"
    txthilf="\nsumfreq (to be compared with UtotalC (UtotMC)"+"\n"
    for j in range(0,len(sumfreq)):
        txthilf+=str(sumfreq[j])+"\n"
    txthilf+="\n"
    txtexcel+=txthilf+"\n"
    print "deviation ",deviation
    tpexcel=Tkinter.Toplevel(hf)
    tpexcel.title("Functions of s ")
    texcel=ScrolledText(tpexcel,width=80,height=20)
    texcel.pack()
    texcel.insert("end",txtexcel)
    maxdev = max(deviation)
    maintp=Tkinter.Toplevel(hf)
    maintp.title("main result ")
    maintxt=ScrolledText(maintp,width=80,height=10)
    maintxt.pack()
    txtm="File = "+str(fn)+"\n"
    txtm+="Number of repr. objects "+str(rred)+"\n"
    txtm+="number of indicators "+str(m)+"\n"
    txtm+="minimal Pearson correlation (r*r) "+str(round(mincor,4))+"\n"
    txtm+="weights "+"\n"
    for j in range(0,m):
        txtm+=str(round(weight[j],3))+"\t"
    txtm+="\n"
    txtm+="U of orig. dm "+str(Utotal)+"\n"
    txtm+="Maximal deviation of MC_U from Us (absolute values)"+str(round(maxdev,2))+"\n"
    maintxt.insert("end",txtm)
    
    


hf = Tkinter.Tk()
hf.title("special module: weight-MC-simulation ")
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_modspec1.txt",4,\
            "November, the 30th, 2016"," about UMC_vs_Us ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_UMC_vs_Us.txt",4,\
            "November, the 30th, 2016"," help UMC_vs_Us ", "white", "t1",80,5,ScrolledText)
    
lbopen1=Tkinter.Label(hf,text="")
lbopen1.pack()
butt1=Tkinter.Button(hf, text="Select and open a file ",width=30,bg="cyan",command=openproc)
butt1.pack()
butt2=Tkinter.Button(hf,text="Draw Hd",width=30,bg="cyan",command=HD)
butt2.pack()
lbweight=Tkinter.Label(hf,text="read in the weights (if equal weights: press 'default') ")
lbweight.pack()
eweight=Tkinter.Entry(hf,width=20)
eweight.pack()
butt3=Tkinter.Button(hf,text="submit the start-weights ",width=30,bg="cyan",command=submit)
butt3.pack()
butt3b=Tkinter.Button(hf,text="Default (for the weights ) ",width=30,bg="cyan",command=standardweights)
butt3b.pack()
lbMC=Tkinter.Label(hf,text="read in the number of MC-simulations (10000)")
lbMC.pack()
eMC=Tkinter.Entry(hf,width=6)
eMC.pack()
butt4=Tkinter.Button(hf,text="Calculation ",width=30,bg="cyan",command=calc)
butt4.pack()
buttexit=Tkinter.Button(hf, text="exit ",bg="red",width=30,command=hf.destroy)
buttexit.pack()
hf.mainloop()





    
