import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import stats
import pstat
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 19.12.17 Control prints
# 26.03.18: from Hdsimpl derived: am1_1.py
# 27.03.18-30.03.18: extension to vs 2-5


###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####

def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015, 28.03.18
    #*: 13.1.08
    #akt: 28.03.2018
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def spearmancorrel():
    #brg 29.03.18
    global scorrel,lscorrel
    scorrel=[]
    indicmin1=""
    indicmin2=""
    for j1 in range(0,k-1):
        for j2 in range(j1+1,k):
            hilf1=[]
            hilf2=[]
            for i in range(0, r):
                hilf1.append(x[i][j1])
                hilf2.append(x[i][j2])
            #print "hilf1 = ",hilf1
            #print "hilf2 = ",hilf2
            spear, probspear = pstat.lspearmanr(hilf1,hilf2)    
            scorrel.append((prop[j1],prop[j2],spear))
    #print "scorrel= ",scorrel
    lscorrel=len(scorrel)
    print "length of scorrel = ",lscorrel
    scorrmin=9999
    for j in range(0, lscorrel):
        if scorrel[j][2]<=scorrmin:
            indicmin1=scorrel[j][0]
            indicmin2=scorrel[j][1]
            scorrmin=scorrel[j][2]
    lbcorrsp.config(text= "Minimal Spearman correlation: "+str(indicmin1)+", "+str(indicmin2)+"  value: "+str(round(float(scorrmin),3)))
    

def show_spear():
    #brg 29.03.18
    tpcorr=Tkinter.Toplevel(hf)
    tpcorr.title(" Spearman correlation ")
    tcorr=ScrolledText(tpcorr,width=60,height=20)
    tcorr.pack()
    txtcorr="Spearman-correlation "+"\n"
    txtcorr+="file = "+str(fn)+"\n"
    txtcorr+=50*"-"+"\n"
    for j in range(0, lscorrel):
        txtcorr+=str(scorrel[j][0])+", "+str(scorrel[j][1])+": "+str(round(scorrel[j][2],4))+"\n"
    txtcorr+="\n"
    tcorr.insert("end",txtcorr)
        

def HDobj():
    # brg 26.3.18
    global covobj
    covobj=HD(rred, k, xred, objred)
    

def HDcombi():
    # brg 26.03.18
    global covam
    covam=HD(namseqred, k, UseqHD, seqred)

def HD(rows, col, matrix, labels):
    # brg 26.7.2013, 29.8.2013, 2.11.16
    global UHD
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rows,col,matrix)  #zeta matrix with col<row
    zeta=rmod2.marray(rows,rows)
    for i in range(0,rows):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rows):
            zeta[i][j]=zetahilf[j][i]
    
    UHD = rmod2.incompzeta(rows,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rows,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rows,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rows,adjc,lext)
       
    
    cov=rmod2.cover(rows,tr,lext)

    if rows>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(UHD))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rows,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rows,rows)
        geomy=rmod2.marray(rows,rows)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=labels[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        return cov
        


def covobjects():
    #brg 26.03.18
    cover(rred, objred,covobj)

def covamcurves():
    #brg 26.03.18
    cover(namseqred,seqred,covam)


def cover(rows, labels, cov):
    # brg 26.03.18
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i1 in range(0, rows):
        txt3 += "\n" + labels[i1] + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, rows):
            if i1!=i2:
                if cov[i1][i2] == 1:
                    txt3 += " " + labels[i2] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes : "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

# ++++ here the am-specific part +++++ 

def calc_am():
    #brg 24.03.18, 25.3.18, 26.03.18, 27.03.18
    global eamseq,fram, elimitU, ecorr, lbperm, eselectseq
    Tpam=Tkinter.Toplevel(hf)
    Tpam.title("Am-curves")
    fram2=Tkinter.Frame(Tpam)
    fram2.pack()
    lbwarn2=Tkinter.Label(fram2,text=" 'Calc all f(natt)' is not recommendable,if \n number of indicators >= 6")
    lbwarn2.pack()
    buttfill_am=Tkinter.Button(fram2,text="Calc all f(natt) ",width=35,bg="white",command=fill_am)
    buttfill_am.pack()
    buttHDcombi = Tkinter.Button(fram2,text = "HD of f(natt) ",width = 35, bg="white", command = HDcombi)
    buttHDcombi.pack()
    buttshowamotherresults=Tkinter.Button(fram2,text=" Equivalence classes = f(natt) ",width=35, bg="white",command=showothers)
    buttshowamotherresults.pack()
    buttshoweq=Tkinter.Button(fram2,text=" Sequences equivalent w.r.t. Am-curves",width=35,bg="white",command=show_seq_eq)
    buttshoweq.pack()
    buttcoveram=Tkinter.Button(fram2,text="cover relation of HD of Am curves",width=35,bg="white",command=covamcurves)
    buttcoveram.pack()
    lbgeneral=Tkinter.Label(fram2, text="\nOptimization scheme: Step (0) must be performed only once")
    lbgeneral.pack()
    buttperm=Tkinter.Button(fram2,text="(0) Gen. all permut. of "+str(k)+" indicators (mandatory)", width=45, \
                            bg="cyan", bd=5, command=permutation)
    buttperm.pack()
    lbperm=Tkinter.Label(fram2,text="  ")
    lbperm.pack()
    lbcorr1=Tkinter.Label(fram2,text="Only seq will be selected, whose first two indicators... ")
    lbcorr1.pack()
    lbcorr2=Tkinter.Label(fram2,text="...have a Spearman-correlation less or equal than a limiting value ")
    lbcorr2.pack()
    ecorr=Tkinter.Entry(fram2,width=5)
    ecorr.pack()
    
    buttsomesequences = Tkinter.Button(fram2, text="(1) Optimal sequences ",width=35, bg="white",command=optimseq)
    buttsomesequences.pack()
    buttHDopt=Tkinter.Button(fram2,text=" (2) HD of optimal sequences ",width=35,bg="white",command=HDoptseq)
    buttHDopt.pack()
    buttcovoptseq=Tkinter.Button(fram2,text="(3) cov rel according to HD of opt. seq. ",width=35,bg="white",command=covopt)
    buttcovoptseq.pack()
    lbselect=Tkinter.Label(fram2,text="Select a sequence for further details, just the number, without 'S' ")
    lbselect.pack(pady=3)
    eselectseq=Tkinter.Entry(fram2,width=4)
    eselectseq.pack()
    buttfurtherdetails=Tkinter.Button(fram2,text="Further details for the selected sequence ",width=35,bg="white",command=furthdetails)
    buttfurtherdetails.pack()
                           
    
def fill_am():
    # brg 24.03.18, 28.03.18
    # k number of indicators
    global txt1 , txtseq, UseqHD, namseqred, seqred, seq_am                   
    # generation of a list of k indicators
    
    lind = []
    for j in range(0,k):
        lind.append(j)
    # permutation
    namseq = 1
    for i in range(1,k+1):
        namseq = namseq*i    
        
    set_ind=rmod2.vecgen1(namseq)
    Useq = rmod2.marray(namseq,k)
    txt1="Number of all Am-sequences: "+str(namseq)+"\n"
    txt1+="Equivalence classes: "+"\n"
    seq_am = rmod2.perm(lind)
    zahl=0
    for i in range(0,namseq):
        set_ind[i]=set([ ])
        attrib = []
        for j in range(0,k):
            set_ind[i].add(int(seq_am[i][j]))
            for indic in set_ind[i]:
                attrib.append(indic)
            #1) data matrix xx corresponding to attrib
            xx=rmod2.marray(r,len(set_ind[i]))    
            for i1 in range(0,r):
                zaehl=0
                for j1 in range(0,k):
                    if j1 in attrib:
                        xx[i1][zaehl]=x[i1][j1]    #x is the orig. dm
                        zaehl+=1
            #print i,"  xx= "
            #rmod2.matout(r,len(set_ind[i]),xx)
            #2) xxred (elimination of eq.classes )
            rredact,xxred,objredact,txtact=rmod2.equivcompact(r,len(set_ind[i]),xx,obj)
            txt1+="sequence no: "+str(i)+"  natt = "+str(j)+"\n"
            txt1+=txtact+"\n"
            #3) zeta matrix
            zetahilf=rmod2.comp(rredact,len(set_ind[i]),xxred)
            #4) U corresponding to i and j
            hilfU = 0
            for i2 in range(0, rredact):
                for i3 in range(0, rredact):
                    if zetahilf[i2][i3]==0 and zetahilf[i3][i2]==0:
                        hilfU+=0.5
            Useq[i][j]=hilfU        
    tpresult=Tkinter.Toplevel(hf)
    tpresult.title(" Am-sequences ")
    tresult=ScrolledText(tpresult,width = 120, height = 30)
    tresult.pack()
    txt2=" Am as a function of natt for "+str(namseq)+" indicator sequences" +"\n"
    txt2+="\n"+"U as function of the sequences: U=f(natt)"+"\n"
    seqlab = []
    for i in range(0, namseq):
        #labels
        seqlab.append("S"+str(i))
            
    txt2+="natt           \t("
    for i in range(0, k):
        txt2+="natt="+str(i)+"\t"
    txt2+=")\n"
    for j in range(0, k):
        txt2+="- "
    txt2+="\n"
    
    for i in range(0, namseq):
        txt2+="Seq.: "+str(seqlab[i])+":\t "
        hilftxt=""
        for indic in seq_am[i]:
            hilftxt+=str(indic)+","
        txt2+=hilftxt+"::"+3*"\t"    
        for j in range(0,k):    
            txt2+=str(int(Useq[i][j]))+"\t"
        txt2+="\n"
    tresult.insert("end",txt2)
    #5) construction of UseqHD
    
    #5a) elimination of equivalent rows
    print "namseq= ",namseq
    #print "seqlab= ",seqlab
    #print " k = ",k
    #print "Useq "
    #print rmod2.matout(namseq,k,Useq)
    namseqred,UseqHD,seqred,txtseq = rmod2.equivcompact(namseq,k,Useq,seqlab)
    #print "txtseq= "
    #print txtseq
    
def showothers():
    #brg 25.03.18
    global txt1
    Tpothers=Tkinter.Toplevel(hf)
    tothers=ScrolledText(Tpothers,width=60,height=30)
    tothers.pack()
    tothers.insert("end",txt1)
    
    
def show_seq_eq():
    #brg 26.03.18
    tpseqeq=Tkinter.Toplevel(hf)
    tpseqeq.title("equivalent Sequences")
    tseqeq=ScrolledText(tpseqeq,width=60, height=20)
    tseqeq.pack()
    tseqeq.insert("end",txtseq)

def calc_Spear():
    # brg 29.03.18
    spearmancorrel()

def permutation():
    #brg 27.03.18
    # permutation will generated only once,
    # then the reults can be varied according to corr*
    global seq_am, nperm
    lind = []
    for j in range(0,k):
        lind.append(j)
    # permutation
    seq_am = rmod2.perm(lind)
    nperm=len(seq_am)
    lbperm.config(text= "permutations are performed "+str(nperm))
    lbperm.pack()

def optimseq():
    #brg 27.03.18
    #One of several criteria is to
    #select those sequences, where for natt=2
    # the correlation is low
    
    global labfinal, count_actseq, Useqoptred, seq_am
    try:
        limitcorr=float(ecorr.get())
    except:
        limitcorr=-0.3
    print "limitcorr = ",limitcorr    
    
    xxx=rmod2.marray(r,2)
    # which are the potential optimal sequences...
    li_opt = []
    for i1 in range(0, nperm):
        li1=[]
        li2=[]
        for i2 in range(0,r):
            xxx[i2][0]=x[i2][seq_am[i1][0]]
            xxx[i2][1]=x[i2][seq_am[i1][1]]
            li1.append(xxx[i2][0])
            li2.append(xxx[i2][1])
            #print x[i2],"   xxx= ",xxx[i2]
        rspear,probspear=pstat.lspearmanr(li1,li2)
        #print "i1= ",i1," correl ",rspear
        if rspear<=limitcorr:
            li_opt.append(i1)
    print "li_opt= ",li_opt        
    # now a subset of sequences is found and the proper calculation...
    # ...begins
    txt1=" Optimal sequences "+"\n"
    set_ind2=rmod2.vecgen1(len(li_opt))
    Useqopt=rmod2.marray(len(li_opt),k)
    zahl=0
    labseqopt = []
    labseqoptnum = []
    for i in range(0,len(li_opt)):
        txt1+="Seq"+str(li_opt[i])+", "
        labseqopt.append("S"+str(li_opt[i]))
        labseqoptnum.append(str(li_opt[i]))
        set_ind2[i]=set([ ])
        attrib2 = []
        for j in range(0,k):
            set_ind2[i].add(int(seq_am[li_opt[i]][j]))   #only those sequences are selected, whose no is in li_opt
            for indic in set_ind2[i]:
                attrib2.append(indic)
            #1) data matrix xxxx corresponding to attrib
            xxxx=rmod2.marray(r,len(set_ind2[i]))    
            for i1 in range(0,r):
                zaehl=0
                for j1 in range(0,k):
                    if j1 in attrib2:
                        xxxx[i1][zaehl]=x[i1][j1]    #x is the orig. dm
                        zaehl+=1
            #print i,"  xx= "
            #rmod2.matout(r,len(set_ind[i]),xx)
            #2) xxxxred (elimination of eq.classes )
            rrrredact,xxxxred,objred2,txtact2=rmod2.equivcompact(r,len(set_ind2[i]),xxxx,obj)
            txt1+="sequence no: "+str(i)+"  natt = "+str(j)+"\n"
            txt1+=txtact2+"\n"
            #3) zeta matrix
            zetahilf2=rmod2.comp(rrrredact,len(set_ind2[i]),xxxxred)
            #4) U corresponding to i and j
            hilfU = 0
            for i2 in range(0, rrrredact):
                for i3 in range(0, rrrredact):
                    if zetahilf2[i2][i3]==0 and zetahilf2[i3][i2]==0:
                        hilfU+=0.5
            Useqopt[i][j]=hilfU
    tpopt1=Tkinter.Toplevel(hf)
    tpopt1.title(" Background info: optimization ")
    topt1=ScrolledText(tpopt1,width=60,height=10)
    topt1.pack()
    topt1.insert("end",txt1)
    #print "labseqopt = ",labseqopt        
    #print "Useqopt"
    #rmod2.matout(len(li_opt),k,Useqopt)
    count_actseq,Useqoptred,seq_labrednum,txtseqred=rmod2.equivcompact(len(li_opt),k,Useqopt,labseqoptnum)
    print count_actseq
    #print Useqoptred
    #print seq_labrednum
    #print txtseqred
    labfinal=[]
    for i in range(0, count_actseq):
        labfinal.append("S"+str(seq_labrednum[i]))
    #print "labfinal = ",labfinal    
    txt2="Output opt sequences "+"\n"
    txt2+="data matrix: file "+str(fn)+"\n"
    txt2+="Only those sequences, where the first two indicators have a Spearman-correlation <="+str(limitcorr)+"\n"
    txt2+="Count of Representative sequences of incomparabilities  "+str(count_actseq)+"\n"
    txt2hilf=""
    for i1 in range(0,len(Useqoptred)):
        txt2hilf+=str(labfinal[i1])+": "
        for i2 in range(0, len(Useqoptred[i1])):
            txt2hilf+=str(Useqoptred[i1][i2])+", "
        txt2hilf+="\n"
    
    txt2+=txt2hilf+"\n"
    txt2+="The relevant sequences of indicators "+"\n"
    txt3hilf=""
    for i1 in range(0, count_actseq):
        txt3hilf+=str(labfinal[i1])+": "
        for i2 in range(0,k):
            #print "relev seq-no ",int(seq_labrednum[i1])
            #print "seq_am = ",seq_am[int(seq_labrednum[i1])][i2], 
            txt3hilf+=str(seq_am[int(seq_labrednum[i1])][i2])+", "
        txt3hilf+="\n"
        #print " "
    txt2+=txt3hilf+"\n"

    tpopt2=Tkinter.Toplevel(hf)
    tpopt2.title(" optimization: results ")
    topt2=ScrolledText(tpopt2,width=120,height=20)
    topt2.pack()
    topt2.insert("end",txt2)
    #Now the HD...
    #labels: labfinal
    #number of vertices: count_actseq
    #data matrix : Useqoptred
    
def HDoptseq():
    #brg 27.03.18
    global covoptseq
    covoptseq=HD(count_actseq,k,Useqoptred,labfinal)

def covopt():
    #brg 27.03.18
    global count_actseq
    cover(count_actseq,labfinal,covoptseq)
    
def furthdetails():
    #brg 28.03.18, 02.04.18
    selseq=int(eselectseq.get())
    print "selseq= ",selseq
    tpselect=Tkinter.Toplevel(hf)
    tpselect.title('details concerning the sequence S'+str(selseq))
    tselect=ScrolledText(tpselect,width=60,height=20)
    tselect.pack()
    txtsel="Details concerning sequence S"+str(selseq)+"\n"
    txtsel+="File: "+str(fn)+"\n"
    count_representatives = []
    isovec=[]
    maximvec=[]
    minimvec=[]
    nseq=len(seq_am[selseq])
    attribsel=[]
    labseqsel=[]
    txtsel+="Actually selected sequence: "+"\n"
    for j in range(0, k):
        txtsel+=str(seq_am[selseq][j])+", "
    txtsel+="\n"
    for j in range(0, k):
        txtsel+=str(prop[seq_am[selseq][j]])+", "     #02.04.18
        labseqsel.append(str(seq_am[selseq][j]))
    #print "labseqsel = ",labseqsel                     
    txtsel+="\n"
    attribsel.append(seq_am[selseq][0])
    for j in range(0,k):
        attribsel.append(seq_am[selseq][j])
        #print j, "  attribsel = ",attribsel
        xxsel=rmod2.marray(r,len(attribsel))
        for i1 in range(0,r):
            zaehl=0
            for j1 in attribsel:
                xxsel[i1][zaehl]=x[i1][j1]    #x is the orig. dm
                zaehl+=1
        #print j,"   obj = ",obj        
        #print j,"  xxsel = "
        #rmod2.matout(r,len(attribsel),xxsel)
        rredactsel,xxredsel,objredred,txtactsel=rmod2.equivcompact(r,len(attribsel),xxsel,obj)
        #zeta matrix
        zetahilf=rmod2.comp(rredactsel,len(attribsel),xxredsel)
        lzsel=len(zetahilf)
        count_representatives.append(lzsel)
        # zetahilf represents the >= relation
        rowsum=rmod2.matrixrowsum(zetahilf,lzsel,lzsel)
        colsum=rmod2.matrixcolsum(zetahilf,lzsel,lzsel)
        #print j, "  rowsum= ",rowsum
        #print j, "  colsum= ",colsum
        #Isolated elements
        hilfiso=[]
        for i2 in range(0, lzsel):
            if rowsum[i2]==1 and colsum[i2]==1:
                hilfiso.append(i2)
        isovec.append(len(hilfiso))
        hilfmax=[]
        for i2 in range(0, lzsel):
            if colsum[i2]==1 and rowsum[i2]>1:  #!!!
                hilfmax.append(i2)
        maximvec.append(len(hilfmax))
        hilfmin=[]
        for i2 in range(0, lzsel):
            if rowsum[i2]==1 and colsum[i2]>1:
                hilfmin.append(i2)
        minimvec.append(len(hilfmin))
    print "isovec ",isovec
    print "maximvec ",maximvec
    #output    
    txtsel+="\nEvolution as a function of the number of merged indicators according to the ..."+"\n"
    txtsel+="...selected sequence S"+str(selseq)+"\n"
    txtsel+=60*"-"+"\n"
    txtsel+="evolution of representative elements "+"\n"
    txtsel+="\t"
    for i3 in range(0,len(count_representatives)):
        txtsel+=str(count_representatives[i3])+", "
    txtsel+="\n"    
    txtsel+="evolution of (count of) isolated elements "+"\n"
    txtsel+="\t"
    for i3 in range(0, len(isovec)):
        txtsel+=str(isovec[i3])+", "
    txtsel+="\n"    
    txtsel+="evolution of (count of) proper maximal elements "+"\n"
    txtsel+="\t"
    for i3 in range(0, len(maximvec)):
        txtsel+=str(maximvec[i3])+", "
    txtsel+="\n"    
    txtsel+="evolution of (count of) proper minimal elements "+"\n"
    txtsel+="\t"
    for i3 in range(0, len(minimvec)):
        txtsel+=str(minimvec[i3])+", "
    txtsel+="\n"
    txtsel+="evolution of (count of) extremal elements "+"\n"
    txtsel+=" (= maximal+isolated elements)"+"\n"
    txtsel+="\t"
    for i3 in range(0, len(minimvec)):
        txtsel+=str(maximvec[i3]+isovec[i3])+", "
    txtsel+="\n"
    txtsel+="\n"
    
    tselect.insert("end",txtsel)


def individual_am():
    #brg 24.03.18, 25.3.18, 02.04.18
    # taken from sensitivity25_5
    global eamseq,fram
    Tpam=Tkinter.Toplevel(hf)
    fram=Tkinter.Frame(Tpam)
    fram.pack()
    lbam1=Tkinter.Label(fram,text="How many sequences ? ")
    lbam1.pack()
    eamseq=Tkinter.Entry(fram,width=10)
    eamseq.pack()
    buttsubmit_seq=Tkinter.Button(fram,text="submit the sequences ",bg="cyan", width=25, command=submit_amseq)
    buttsubmit_seq.pack()
    fram2=Tkinter.Button(Tpam)
    fram2.pack()
    buttfill_am=Tkinter.Button(fram2,text="Results ",bg="cyan",width=25,command=fill_am)
    buttfill_am.pack()
    buttshowamotherresults=Tkinter.Button(fram2,text=" Equivalence classes ",width=25, bg="white",command=showothers)
    buttshowamotherresults.pack()
    
    
def submit_amseq():
    # brg 24.03.18
    global eseq, namseq
    
    namseq=int(eamseq.get())
    print "namseq= ",namseq
    lbam2=Tkinter.Label(fram,text="Insert the different sequences of indicators\n all with the same length: "+str(k) )
    lbam2.pack()
    eseq=rmod2.vecgen1(namseq)
    for i in range(0, namseq):
        eseq[i]=Tkinter.Entry(fram, width=20)
        eseq[i].pack()
        
    
def fill_am():
    # brg 24.03.18
    # k number of indicators
    global txt1                    
    hilfseq=rmod2.vecgen1(namseq)
    seq_am=rmod2.vecgen1(namseq)
    
    for i in range(0,namseq):
        hilfseq[i]=eseq[i].get()
        seq_am[i]=hilfseq[i].split(",")
    #print "seq_am[0] ", seq_am[0]
    #print "seq_am[1]: ",seq_am[1]
    set_ind=rmod2.vecgen1(namseq)
    Useq = rmod2.marray(namseq,k)
    Maximseq = rmod2.marray(namseq,k)
    Minimseq = rmod2.marray(namseq,k)
    Isoseq = rmod2.marray(namseq,k)
    count_representatives = rmod2.marray(namseq, k)
    txt1=" Am-sequences "+"\n"
    txt1+="Equivalence classes: "+"\n"
    for i in range(0,namseq):
        set_ind[i]=set([ ])
        attrib = []
        for j in range(0,k):
            set_ind[i].add(int(seq_am[i][j]))
            for indic in set_ind[i]:
                attrib.append(indic)
            #1) data matrix xx corresponding to attrib
            xx=rmod2.marray(r,len(set_ind[i]))    
            for i1 in range(0,r):
                zaehl=0
                for j1 in range(0,k):
                    if j1 in attrib:
                        xx[i1][zaehl]=xred[i1][j1]
                        zaehl+=1
            #print i,"  xx= "
            #rmod2.matout(r,len(set_ind[i]),xx)
            #2) xxred (elimination of eq.classes )
            rredact,xxred,objredact,txtact=rmod2.equivcompact(r,len(set_ind[i]),xx,obj)
            txt1+="sequence no: "+str(i)+"  natt = "+str(j)+"\n"
            txt1+=txtact+"\n"
            #3) zeta matrix
            zetahilf=rmod2.comp(rredact,len(set_ind[i]),xxred)
            lzsel=len(zetahilf)
            #4) U corresponding to i and j
            hilfU = 0
            for i2 in range(0, rredact):
                for i3 in range(0, rredact):
                    if zetahilf[i2][i3]==0 and zetahilf[i3][i2]==0:
                        hilfU+=0.5
            Useq[i][j]=hilfU
            ####baustelle 020418 ###
            count_representatives[i][j]=lzsel
            # zetahilf represents the >= relation
            rowsum=rmod2.matrixrowsum(zetahilf,lzsel,lzsel)
            colsum=rmod2.matrixcolsum(zetahilf,lzsel,lzsel)
            hilfiso=[]
            for i2 in range(0, lzsel):
                if rowsum[i2]==1 and colsum[i2]==1:
                    hilfiso.append(i2)
            Isoseq[i][j] = len(hilfiso)
            hilfmax=[]
            for i2 in range(0, lzsel):
                if colsum[i2]==1 and rowsum[i2]>1:  #!!!
                    hilfmax.append(i2)
            Maximseq[i][j] = len(hilfmax)
            hilfmin=[]
            for i2 in range(0, lzsel):
                if rowsum[i2]==1 and colsum[i2]>1:
                    hilfmin.append(i2)
            Minimseq[i][j] = len(hilfmin)
    print "Isoseq ",Isoseq
    
            
    txt2=" Am as a function of natt for "+str(namseq)+" indicator sequences" +"\n"       
    txt2+="\n"+"U as function of the sequences: U=f(natt)"+"\n"
    txt2+="natt  \t"
    for i in range(0, k):
        txt2+="natt="+str(i)+"\t"
    txt2+="\n"    
    for i in range(0, namseq):
        txt2+="Seq. "+str(i)+"\t "
        for j in range(0, k):
            txt2+=str(int(Useq[i][j]))+"\t"
        txt2+="\n"
    txt2+="\n"+"Count of isolated elements = f(natt)"+"\n"
    txt2+="natt  \t"
    for i in range(0, k):
        txt2+="natt="+str(i)+"\t"
    txt2+="\n"    
    for i in range(0, namseq):
        txt2+="Seq. "+str(i)+"\t "
        for j in range(0, k):
            txt2+=str(int(Isoseq[i][j]))+"\t"
        txt2+="\n"        
    txt2+="\n"+"Count of maximal elementsU = f(natt)"+"\n"
    txt2+="natt  \t"
    for i in range(0, k):
        txt2+="natt="+str(i)+"\t"
    txt2+="\n"    
    for i in range(0, namseq):
        txt2+="Seq. "+str(i)+"\t "
        for j in range(0, k):
            txt2+=str(int(Maximseq[i][j]))+"\t"
        txt2+="\n"
    txt2+="\n"+"Count of minimal elementsU = f(natt)"+"\n"
    txt2+="natt  \t"
    for i in range(0, k):
        txt2+="natt="+str(i)+"\t"
    txt2+="\n"    
    for i in range(0, namseq):
        txt2+="Seq. "+str(i)+"\t "
        for j in range(0, k):
            txt2+=str(int(Minimseq[i][j]))+"\t"
        txt2+="\n"        
    tam=ScrolledText(fram,width=120, height=20)
    tam.pack()
    tam.insert("end",txt2)
    
                        
            
def showothers():
    #brg 25.03.18
    global txt1
    Tpothers=Tkinter.Toplevel(hf)
    tothers=ScrolledText(Tpothers,width=60,height=30)
    tothers.pack()
    tothers.insert("end",txt1)

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' Am-curves ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_am.txt",5,\
            "March, the 29th, 2018"," about am ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_am.txt",5,\
            "March, the 29th, 2018"," help_am ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=25, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD of objects', width=25, bg="cyan", command=HDobj)
buttHD.pack(pady=5)
buttcovobj = Tkinter.Button(fr, text="cover relation of HD of objects ",bg="cyan",width=25, command=covobjects)
buttcovobj.pack()
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
buttcorr=Tkinter.Button(fr,text="Calc the mininimalSpearman correlation ",width=35, bg="cyan", command=calc_Spear)
buttcorr.pack()
lbcorrsp=Tkinter.Label(fr,text=" ",width=50)
lbcorrsp.pack()
buttshowcorrel=Tkinter.Button(fr,text="show the complete Spearman-correlation ",width=35,bg="cyan", command=show_spear)
buttshowcorrel.pack()
buttindiv=Tkinter.Button(fr,text="Individual sequence of indicators ", width=35, bg="cyan", command=individual_am)
buttindiv.pack()
buttam = Tkinter.Button(fr, text="Calc Am=f(natt) (all or optimized seq.) ",width=35, bg="cyan", command=calc_am)
buttam.pack()

buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
