import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import math

import Canvas
import os
import pstat
import stats


#  brg  22.9.2010 aus sepanal9 vom 6.6.09 abgeleitet.
#  brg 4.11.2010 brgbar9 needs str-inputs
# brg 27.11.2010: which elements of an antichain
#     have attribute values above certain limits
#     this is called: pattern-analysis
# 24.4.2011: bardiagram of importance of attribute pairs
# 25.4.2011 as default the top level will be read in.
# 26.4.2010 Correction
# 31.5.2011 Win32All-package necessary
# 28.6.2011 corrections (cosmetics)
# 25.7.2011 Outranking matrix der interessierenden AC
# 21.9.2011: Further tools to analyze AC
# 17.10.2011: Critical pairs
# 2.11.2011 Distribution of severity of objectpairs separation
#            and of efficiency how att.pairs are separating
# 17.11.2012 cosmetics
# 19.1.2012  Inclusion of tripartite graph concept
# 20.-22.3.2012: Extensions in pattern analysis, version 14
# 25.-27.3.2012 Graph and distribution statistics of densities
# 27.3.2012 pstat quartiles replaced by an own routine in rmod2 (passed five SPSS-tests)
# 28.3.2012 different changes. Hence antichain16Excel.py
# 30.3.2012 pstat.ldescribe replaced by pstat.mean and pstat.stdev
# 31.3.2012 antichain18Excel: more detailed statistics now as optional
# 9.4.2012: rearrangement of user interface of antichain--> antichain19EXCEL.py
# 10.4.2012: ....continued
# 11.4.2012: antichain20.py
# 12.4.2012: antichain20.py cosmetics
# 11.9.2012: bug detected and eliminated: frequencies of attributes causing incomp. antichain20_1
# 30.11.2012: bug detected and eliminated
# 4.1.2013 towards HDs of AC
# 5.1.2013 antichain20_4

global tver1,tver2,tver3,tver4,tver5,tver6,tver7
# tver - vectors: addresses of toplevels are gathered in order to manipulate them 
tver1=[]
tver2=[]
tver3=[]
tver4=[]
tver5=[]
tver6=[]
tver7=[]

class Excelreadinnew(object):
    # win32com in definitions
    def __init__ (self,fn):
        import win32com.client
        self.fn=fn
        return

    def clread(self):
        import win32com.client
        x1App=win32com.client.Dispatch("Excel.Application")
        x1App.Workbooks.Add()


        simple=x1App.Workbooks.Open(self.fn)

        #Objekte
        self.obj=[]
        i=2
        j=1
        zahl=0
        while simple.ActiveSheet.Cells(i,j).Value!=None:
            self.obj.append(str(simple.ActiveSheet.Cells(i,j).Value))
            i+=1
            zahl+=1
            if zahl>2000:
                break
        self.n=len(self.obj)
        print self.obj
        self.prop=[]
        j=2
        i=1
        zahl=0
        while simple.ActiveSheet.Cells(i,j).Value!=None:
            self.prop.append(str(simple.ActiveSheet.Cells(i,j).Value))
            j+=1
            zahl+=1
            if zahl>2000:
                break
        self.m=len(self.prop)

        self.dm=rmod2.marray(self.n,self.m)    
        for i in range(0,self.n):
            for j in range(0,self.m):
                self.dm[i][j]=simple.ActiveSheet.Cells(i+2,j+2).Value
                
        simple.Close()
        return self.fn,self.n,self.m,self.obj,self.prop,self.dm


def fileselectExcel():
    """ File selection and opening directly from Excel-sheet """
    global fn,k0,r,dm,pro,ob,prop,obj,xred,objred,rred
    import win32com.client
    fn=tkFileDialog.askopenfilename()
    app1=Excelreadinnew(fn)
    fn,r,k0,obj,prop,dm=app1.clread()
    print prop
    #############################this part is of 21.12.07 #########
    rred,xred,objred,txt=rmod2.equivcompact(r,k0,dm,obj)    
    ###############################################################
    global ex1,x1default
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    
    labex1=Tkinter.Label(fr2a,text="Select the objects of an antichain >>>")
    labex1.pack(side="left")  #Excel
    ex1=Tkinter.Entry(fr2a,width=30)
    ex1.pack(side="left")
    
    #global rred, objred,xred,obj
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    tver1.append(hfhd2)
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    n=rred
    tpeqorig=Tkinter.Toplevel(hf)
    tpeqorig.title(' equivalence classes of the original DM ')
    tver1.append(tpeqorig)
    teqorig=ScrolledText(tpeqorig,width=60,height=5)
    teqorig.pack()
    teqorig.insert("end",txt)
    #
    zetahilf=rmod2.comp(n,k0,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
            
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    
    lbbasic2=Tkinter.Label(freq,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    x1default=set([])
    for j in range(0,len(lobj[0])):
            x1default.add(objred[lobj[0][j]])
    print "x1default ",x1default        
    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    global zeta2
    zeta2=rmod2.cover(n,tr,lext)
    
    if n>100:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def showdmExcel():
    #brg 31.05.2011
    global fn
    import win32com.client
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    tver1.append(tp2)
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    app1=Excelreadinnew(fn)
    fn,r,k0,obj,prop,dm=app1.clread()
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k0):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k0):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k0):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
   
    

def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08, 28.5.09
    #note: Taken from antag
    #source:-
    
    global fn,k0,r,dm,pro,ob,prop,obj,xred,objred,rred,zeta
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k0=rmod2.EXCELreadin6(fn)
    lbopen1.config(bg="yellow")
    lbopen1["text"]="sel. file : "+fn+"\n"+str(r)+" rows\n"+str(k0)+" columns"
    prop=rmod2.vecgentext1(k0)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k0):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################this part is of 21.12.07 #########
    rred,xred,objred,txt=rmod2.equivcompact(r,k0,dm,obj)    
    ###############################################################
    global ex1,x1default,tpeqorig,hfhd2
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    
          
    labex1=Tkinter.Label(fr2a,text="Select the objects of an antichain >>>")
    labex1.pack(side="left")
    ex1=Tkinter.Entry(fr2a,width=30)
    ex1.pack(side="left")
    
    #global rred, objred,xred,obj
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    tver1.append(hfhd2)
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    n=rred
    tpeqorig=Tkinter.Toplevel(hf)
    tpeqorig.title(' equivalence classes of the original DM ')
    tver1.append(tpeqorig)
    teqorig=ScrolledText(tpeqorig,width=60,height=5)
    teqorig.pack()
    teqorig.insert("end",txt)
    #
    zetahilf=rmod2.comp(n,k0,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
            
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
   
    lbbasic2=Tkinter.Label(freq,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    x1default=set([])
    for j in range(0,len(lobj[0])):
            x1default.add(objred[lobj[0][j]])
    print "x1default ",x1default        
    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    global zeta2
    zeta2=rmod2.cover(n,tr,lext)
    
    if n>100:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    global hfcover
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    tver1.append(hfcover)
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    n=rred
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y            
         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    global tp2
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    tver1.append(tp2)
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
   

def inread():
    #brg 13.8.10, 25.4.2011
    x1=set(ex1.get().split(","))
    
    if len(x1)<=1:
        x1=x1default
        lbwarning.config(text="++Note: Top-level selected++ ",bg="yellow")
    else:
        lbwarning.config(text="Antichain has more than one element ")
        
    lx1=len(x1)
    print x1," len x1",lx1
    return x1,lx1



# 6 groups of commands

def ac_basics():
    # brg 9.4.2012
    global tpbc
    tpbc=Tkinter.Toplevel(hf)
    tpbc.title(' (1) Basic calculations ')
    tver2.append(tpbc)
    frbc=Tkinter.Frame(tpbc,relief="sunken",bd=3,bg="white")
    frbc.pack()
    lbbc=Tkinter.Label(frbc,text="Results of (1) are needed almost everywhere ",bg="yellow")
    lbbc.pack()
    buttaccalc=Tkinter.Button(frbc,text="(1.1) Antichain densities ",bg="cyan",bd=4,width=40,command=ac_statistics)
    buttaccalc.pack()
    buttachisto=Tkinter.Button(frbc,text="(1.2) Attribute densities histogram ",width=40,bg="cyan",command=indatt2)
    buttachisto.pack()
    buttacm=Tkinter.Button(frbc,text="(1.3)Antichain-matrix  ",bg="cyan",width=40,command=acmatrix)
    buttacm.pack()
    buttdiscrep=Tkinter.Button(frbc,text="(1.4) Discrepancies ",bg="cyan",width=40,command=discrepancy)
    buttdiscrep.pack()
    buttexit0=Tkinter.Button(frbc,text="(1.4) Exit orig HD and other preliminary info ",width=40,bg="orange",command=preliminary_exit)
    buttexit0.pack()
    buttexit1=Tkinter.Button(frbc,text="(1.5) Exit ac_basics ",bg="orange",width=40,command=ac_basics_exit)
    buttexit1.pack()

def ac_adv_statistics():
    # brg 9.4.2012
    global tpas
    tpas=Tkinter.Toplevel(hf)
    tpas.title('(2) Detailed statistics, distributions etc ')
    tver3.append(tpas)
    fras=Tkinter.Frame(tpas,relief="sunken",bd=3,bg="white")
    fras.pack()
    buttas=Tkinter.Button(fras,text="(2.1) Some more statistical characteristics",width=40,bg="cyan",command=mstatist)
    buttas.pack()
    buttdistr=Tkinter.Button(fras,text="(2.2)    Distributions      ",width=40,bg="cyan", command=distri)
    buttdistr.pack()
    buttexit2=Tkinter.Button(fras,text="(2.3) Exit ac_adv_statistics ",bg="orange",width=40,command=ac_adv_exit)
    buttexit2.pack()

def ac_rankings():
    # brg 9.4.2012,10.4.2012
    global tpacr
    tpacr=Tkinter.Toplevel(hf)
    tpacr.title('(3) Ac-rankings ')
    tver4.append(tpacr)
    fracr=Tkinter.Frame(tpacr,relief="sunken",bd=3,bg="white")
    fracr.pack()
    buttoutrk=Tkinter.Button(fracr,text="(3.1) weighted outranking ",width=40,bg="cyan",command=calcoutrk)
    buttoutrk.pack()
    buttpoac=Tkinter.Button(fracr,text="(3.2) Hasse diagram based on #pairs and discrepancy ",bg="cyan",width=40,command=POAC)
    buttpoac.pack()
    buttexit3=Tkinter.Button(fracr,text="(3.3) Exit ac_rankings ",bg="orange",width=40,command=acr_exit)
    buttexit3.pack()

def ac_pattern():
    # brg 9.4.2012, 10.4.2012
    global eob,tpacp,buttsingle
    tpacp=Tkinter.Toplevel(hf)
    tpacp.title(' (4) Analysis of patterns ')
    tver5.append(tpacp)
    fracp=Tkinter.Frame(tpacp,relief="sunken",bd=3,bg="white")
    fracp.pack()
    buttpattern=Tkinter.Button(fracp,text=" (4.1) How often a certain limit is exceeded ",bg="cyan",width=40,command=pattern)
    buttpattern.pack()
    buttnorm=Tkinter.Button(fracp,text=" (4.2) Normalized pattern and its analysis  ",bg="cyan",width=40,command=patnorm)
    buttnorm.pack()
    fracp1=Tkinter.Frame(fracp,relief="groove",bd=4)
    fracp1.pack()
    eob=Tkinter.Entry(fracp1,width=4)
    eob.pack()
    buttsingle=Tkinter.Button(fracp,text=" (4.3) Pattern of a single object (graphics) ",bg="cyan",width=40,state="disabled",command=pattsingle)
    buttsingle.pack()
    buttexit4=Tkinter.Button(fracp,text="(4.4) Exit ac_pattern ",bg="orange",width=40,command=acp_exit)
    buttexit4.pack()


    
def ac_graphs():
    # brg 9.4.2012
    global tpacg,elimit
    tpacg=Tkinter.Toplevel(hf)
    tpacg.title(' (5) Graphs and combinatorics ')
    tver6.append(tpacg)
    fracg=Tkinter.Frame(tpacg,relief="sunken",bd=3,bg="white")
    fracg.pack()
    butttpg=Tkinter.Button(fracg,text=" (5.1) Tripartite graphs ",bg="cyan",width=40,command=tripartite_graph)
    butttpg.pack()
    fracg1=Tkinter.Frame(fracg)
    fracg1.pack()
    lbgraph=Tkinter.Label(fracg1,text="Enter limit-value for attributepair-density --> (5.2) ")
    lbgraph.pack(side="left")
    elimit=Tkinter.Entry(fracg1,width=4)
    elimit.pack(side="left")
    buttgraphac=Tkinter.Button(fracg,text=" (5.2) graphs of attributes, whose densities>= limit ",width=40,bg="cyan",command=graph_of_attributes)
    buttgraphac.pack()
    buttcrit=Tkinter.Button(fracg,text=" (5.3) Critical pairs (dime theory, mutual prob)", width=40,bg="cyan",command=criticpairs)
    buttcrit.pack()
    buttexit5=Tkinter.Button(fracg,text="(5.4) Exit ac_graphs ",bg="orange",width=40,command=acg_exit)
    buttexit5.pack()


def ac_Excel():
    #brg 9.4.2012
    global tpex
    import win32com.client
    tpex=Tkinter.Toplevel(hf)
    tpex.title('  (6) Results export to Excel  ')
    tver7.append(tpex)
    frex=Tkinter.Frame(tpex,relief="sunken",bd=3,bg="white")
    frex.pack()
    lbex=Tkinter.Label(frex,text="++ Note: Windows as operating system and \nwin32com.client must be available ! +++",bg="yellow")
    lbex.pack()
    buttexcel1=Tkinter.Button(frex,text= "(6.1) Attribute pairs --> Excel ",bg="cyan",width=40,command=writeExcelattpairs)
    buttexcel1.pack()
    buttexcel1=Tkinter.Button(frex,text= "(6.2) Object pairs    --> Excel ",bg="cyan",width=40,command=writeExcelobjpairs)
    buttexcel1.pack()
    buttexit6=Tkinter.Button(frex,text="(6.3) Exit Excel-exports ",bg="orange",width=40,command=ace_exit)
    buttexit6.pack()
    
# specialized exits

def preliminary_exit():
    # brg 11.4.2012
    lt1=len(tver1)
    for itop in range(0,lt1):
        tver1[itop].destroy()

def ac_basics_exit():
    #brg 9.4.2012
    lt2=len(tver2)
    for itop in range(0,lt2):
        tver2[itop].destroy()
##    tpbc.destroy()
##    tpanti.destroy()
##    tpattfreq.destroy()
##    tpac.destroy()

def ac_adv_exit():
    # brg 10.4.2012
    lt3=len(tver3)
    for itop in range(0,lt3):
        tver3[itop].destroy()
##    tpas.destroy()
##    tpmorestat.destroy()
##    tpdistr.destroy()
##    tpdisdis1.destroy()
##    tpdisdis2.destroy()

def acr_exit():
    # brg 10.4.2012
    lt4=len(tver4)
    for itop in range(0,lt4):
        tver4[itop].destroy()
##    tpacr.destroy()
##    tpoutrk2.destroy()
##    tpoutrk.destroy()
##    tpac2.destroy()
##    tpbasic3.destroy()
##    tpscatter.destroy()
##    tpeqorig.destroy()
##    hfhd3.destroy()
    
def acp_exit():
    # brg 10.4.2012
    lt5=len(tver5)
    for itop in range(0,lt5):
        tver5[itop].destroy()
##    tpacp.destroy()
##    tppattern.destroy()
##    tpantix.destroy()
##    tpps.destroy()
    

def acg_exit():
    # brg 10.4.2012
    lt6=len(tver6)
    for itop in range(0,lt6):
        tver6[itop].destroy()
##    tpacg.destroy()
##    tptrip0.destroy()
##    tptrip.destroy()
##    tpco7.destroy()
##    tpco7b.destroy()
##    tpcrit2.destroy()
##    tpcrit.destroy()
##    hfgraph.destroy()
##    tpvalence.destroy()
    
    
def ace_exit():
    # brg 11.4.2012
    lt7=len(tver7)
    for itop in range(0,lt7):
        tver7[itop].destroy()
    

# more specialized defs
    
def ac_statistics():
    # brg 22.9.2010, 21.3.2012,26.3.2012, 31.3.2012,9.4.2012
    global eattr,emino,emaxo,emina,emaxa, propmatrix,tpanti
    global densobjdisc,objdisc,densattdisc,maxd2,d1,d2,listobjpair,attmatrix
    #Note: pstat seems to render a pretty crude approximation brg 26.3.2012
    x1,xd1=inread()  #4.11.2010
    #print "xd1= ",xd1
    tpanti=Tkinter.Toplevel(hf)
    tpanti.title(' antichain-analysis ')
    tver2.append(tpanti)    
    tant=ScrolledText(tpanti,width=60, height=10)
    tant.pack()
    
    d1=int(1.0*xd1*(xd1-1.0)/2.0)
    d2=int(1.0*k0*(k0-1)/2.0)
    
    propmatrix=rmod2.marray(d1,d2)
    listobjpair=rmod2.vecgen1(d1)
    listattrpair=rmod2.vecgen1(d2)
    densobjdisc=rmod2.vecgen1(d2)
    densobjdisc=rmod2.vecgen1(d1)
    
    attmatrix=rmod2.marray(k0,k0)   #26.3.2012
    for k1 in range(0,k0):
        for k2 in range(k1+1,k0):
            for ob1 in x1:
                for ob2 in x1:
                    bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                    bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                    bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                    bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                    if (bool1 and bool2) or (bool3 and bool4):
                        attmatrix[k1][k2]+=0.5
##    print "attmatrix"
##    rmod2.matout(k0,k0,attmatrix)                    
    deltax1=set([])
    txtatt=""
    z1=0
    for ob1 in x1:
        deltax1.add(ob1)
        for ob2 in x1:
            if ob2 not in deltax1:
                txtatt+="\n\n"+ob1+","+ob2+": "
                z2=0
                
                for k1 in range(0,k0):
                    for k2 in range(k1+1,k0):
                        bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                        bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                        bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                        bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                        if (bool1 and bool2) or (bool3 and bool4):
                            txtatt+="("+str(prop[k1])+", "+str(prop[k2])+"), "
                            propmatrix[z1][z2]+=1
                        listattrpair[z2]=[prop[k1],prop[k2]]    
                        z2+=1
                        
                listobjpair[z1]=[ob1,ob2]
                z1+=1

           
    txt="Antichain-analysis "+"\n"
    objdisc=rmod2.matrixrowsum(propmatrix,d1,d2)
    attdisc=rmod2.matrixcolsum(propmatrix,d1,d2)
    #print "objdisc ",objdisc
    #print "listobjpair ",listobjpair
   
    #maximum of qi,qj pairs:
    #triangle transitivity related attributes cannot have at the same time 1.
    #therefore d2 is  n o t  the maximal value.
    hilfd21=k0*k0
    
    #print "d1 = ",d1,"  k0 = ",k0,"   hilfd21 = ",hilfd21
    maxd2=math.floor(1.0*hilfd21/4.0) #Turan s theorem
    #print "maxd2= ",maxd2
    txt+="Objectpairs' analysis \n"
    txt+="d1 = "+str(d1)+"\t"+"=maximum possible object pairs from AC "+"\n"
    densattdisc=rmod2.vecgen1(d2)
    for i in range(0,d1):
        densobjdisc[i]=1.0*objdisc[i]/(1.0*maxd2)
        txt+=str(listobjpair[i])+":\t"+str(objdisc[i])+"\t density (/maxd2):\t"+str(round(densobjdisc[i],2))+"\n"  #4.11.2010 d1->d2
    txt+="\n\n"
    
    # attmatrix normalizing
    txt+="attributepairs analysis "+"\n"
    txt+="d2= "+str(d2)+"\t"+"max. possible: maxd2="+str(maxd2)+" of attribute pairs \n"
    for i1 in range(0,k0):
        for j1 in range(i1+1,k0):
            attmatrix[i1][j1]=1.0*attmatrix[i1][j1]/(1.0*d1)
   
    
    for i in range(0,d2):
        densattdisc[i]=1.0*attdisc[i]/(1.0*d1)
        txt+=str(listattrpair[i])+":\t"+str(attdisc[i])+"\t density (/d1):\t"+str(round(densattdisc[i],2))+"\n" #4.11.2010: d2-> d1
    txt+="\n"
    txt+="Frequence how often an attribute is contributing to incomparability "+"\n"
    txt+="of the objects in the selected AC "+"\n"
    lp=len(listattrpair)
    for proname in prop:
        #print "proame= ",proname
        z3=0
        txt+=proname+": \t"
        for j in range(0,lp):
            #print proname, listattrpair[j][0],listattrpair[j][1]
            #print "listattrpairj0 ",listattrpair[j][0],"  listattrpairj1 ",listattrpair[j][1],"  attdiscj ",attdisc[j]
            if proname == listattrpair[j][0] or proname == listattrpair[j][1]:
                z3+=attdisc[j]
        txt+=str(z3)+"\n"
        
    txt+="\n\n"        
    txt+="\n Individual analysis: object pairs  \n"
    txt+=txtatt
    txt2att="Individual analysis: attribute pairs \n"
    
    #z4=0
    for k1 in range(0,k0):
        for k2 in range(k1+1,k0):  #24.4.2011
            #indatt[z4]=set([])
            #z4+=1
            txt2att+="\n"+str(prop[k1])+" "+str(prop[k2])+": "
            delta2x1=set([])
            for ob1 in x1:
                delta2x1.add(ob1)
                for ob2 in x1:
                    if ob2 not in delta2x1:
                        bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                        bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                        bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                        bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                        if (bool1 and bool2) or (bool3 and bool4):
                            #print k1," ",k2," ",ob1," ",ob2
                            txt2att+="("+ob1+", "+ob2+"), "
                            #indatt[z4].add("("+ob1+","+ob2+")")
                        
    
    
    txt2att+="\n - - - e o f - - - "
    txt+=txt2att
    tant.insert("end",txt)
    frdistrib=Tkinter.Frame(tpanti,width=60,height=5)
    frdistrib.pack()
    lbdistrib0=Tkinter.Label(frdistrib,text="objectpairs min-value:  "+str(min(densobjdisc))+"   max-value "+str(max(densobjdisc)))
    lbdistrib0.pack()
    lbdistrib1=Tkinter.Label(frdistrib,text="objectpairs: insert min-value (default min(vector))\ninsert max-value (default=1)")
    lbdistrib1.pack()
    emino=Tkinter.Entry(frdistrib,width=5)
    emino.pack()
    emaxo=Tkinter.Entry(frdistrib,width=5)
    emaxo.pack()
    lbdistrib02=Tkinter.Label(frdistrib,text="attr-pairs min-value:  "+str(min(densattdisc))+"   max-value "+str(max(densattdisc)))
    lbdistrib02.pack()
    lbdistrib2=Tkinter.Label(frdistrib,text="attributpairs: insert min-value (default min(vector))\ninsert max-value (default=1)")
    lbdistrib2.pack()
    emina=Tkinter.Entry(frdistrib,width=5)
    emina.pack()
    emaxa=Tkinter.Entry(frdistrib,width=5)
    emaxa.pack()
    franti=Tkinter.Frame(tpanti,relief="sunken",bd=3)
    franti.pack()
    Buttondistrib=Tkinter.Button(franti,text="Distribution ",width=30,command=distri)
    Buttondistrib.pack(side="left")
    Buttonmorestatistics=Tkinter.Button(franti,text="More detailled statistics ",width=30,command=mstatist)
    Buttonmorestatistics.pack(side="left")
##    ButtwriteExcelobj.config(state='active')
##    ButtPOAC.config(state="active")
##    buttgraph.config(state="active")


def mstatist():
    #brg 31.3.2012
    global tpmorestat
    #statistics 26.3.2012, 27.3.2012
    x1,xd1=inread()  
    tpmorestat=Tkinter.Toplevel(hf)
    tpmorestat.title(' More and detailed statistics ')
    tver2.append(tpmorestat)
    tver3.append(tpmorestat)
    lbmorestat=Tkinter.Label(tpmorestat,text="quartiles, mean, standardeviation and derived\
            quantiies\n Note: For AC of less than 3 objects or IB of less than 3 attributes\n\
            these statistics beyond the average are meaningless ")
    lbmorestat.pack()
    tmorestatistic=ScrolledText(tpmorestat,width=60,height=20)
    tmorestatistic.pack()
    txts="more statisitcs of actual selected AC: "+"\n"
    for ob in x1:
        txts+=ob+" "
    txts+="\n"
    txts+=60*"-"+"\n"
    meanobj=pstat.mean(densobjdisc)
    if len(densobjdisc)<=2:
        stdobj=-999
        meanminusstd=-999
        meanplusstd=-999
        quartile1=-999
        quartile2=-999
        quartile3=-999
    else:
        quartile1,quartile2,quartile3=rmod2.quartile(densobjdisc)
        stdobj=pstat.stdev(densobjdisc)
        meanminusstd=meanobj-stdobj
        meanplusstd=meanobj+stdobj
    txts+="quartile-statistic:objects ( -999 means: not meaningful)"+"\n"
    txts+="First quartile:"+"\t"+str(round(quartile1,3))+"\n"
    txts+="Median        :"+"\t"+str(round(quartile2,3))+"\n"
    txts+="Third quartile:"+"\t"+str(round(quartile3,3))+"\n\n"
    txts+="Mean and std - measures (-999 means: not meaningful) "+"\n"
    txts+="standard deviation   \t"+str(round(stdobj,3))+"\n"
    txts+="mean-standarddeviation \t"+str(round(meanminusstd,2))+"\n"
    txts+="mean                   \t" +str(round(meanobj,3))+"\n"
    txts+="mean+standarddeviation \t"+str(round(meanplusstd,3))+"\n\n"
    
    txts+="Contribution of each attribute: "+"\n"    
    
    
    #statistics 26.3.2012
    
    meanatt=pstat.mean(densattdisc)
    if len(densattdisc)<=2:
        stdatt=-999
        meanminusstd=-999
        meanplusstd=-999
        quartile1=-999
        quartile2=-999
        quartile3=-999
    else:
        quartile1,quartile2,quartile3=rmod2.quartile(densattdisc)
        stdatt=pstat.stdev(densattdisc)
        meanminusstd=meanatt-stdatt
        meanplusstd=meanatt+stdatt
    txts+="quartile-statistic: attributes (-999 means not meaningful))"+"\n"
    txts+="First quartile:"+"\t"+str(round(quartile1,3))+"\n"
    txts+="Median:"+"\t"+str(round(quartile2,3))+"\n"
    txts+="Third quartile:"+"\t"+str(round(quartile3,3))+"\n\n"
    txts+="Mean and std - measures "+"\n"
    txts+="standard deviation   \t"+str(round(stdatt,3))+"\n"
    txts+="mean-standarddeviation (-999 means: not meaningful) \t"+str(round(meanminusstd,3))+"\n"
    txts+="mean                   \t" +str(round(meanatt,3))+"\n"
    txts+="mean+standarddeviation \t"+str(round(meanplusstd,3))+"\n"
    txts+="\n"
    tmorestatistic.insert("end",txts)


def indatt2():
    #brg 24.4.2011
    global tpattfreq
    latt=int(k0*1.0*(k0-1)/2.0)
    
    attp=rmod2.vecgen1(latt)
    freqatt=rmod2.vecgen1(latt)
    x1,xd1=inread()  #4.11.2010
    z1=0
    for k1 in range(0,k0):
        for k2 in range(k1+1,k0):  #24.4.2011
            
            attp[z1]=(prop[k1],prop[k2])
            delta2x1=set([])
            
            for ob1 in x1:
                delta2x1.add(ob1)
                for ob2 in x1:
                    if ob2 not in delta2x1:
                        bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                        bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                        bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                        bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                        if (bool1 and bool2) or (bool3 and bool4):
                            freqatt[z1]+=1
            
            
            z1+=1
        #print " "    
            
    #print freqatt
    tpattfreq=Tkinter.Toplevel(hf)
    
    tver2.append(tpattfreq)
    app1=raioop2.brgbar9(tpattfreq,freqatt,attp,"attribute's contribution",2)
    app1.ausgabe()
    
def distri():
    #brg 2.11.2011, 10.4.2012
    global densobjdisc,densattdisc,maxd2,d1,tpdistr,tpdisdis1,tpdisdis2
    print "maxd2= ",maxd2
    # objdensdistribution
    try:
        mino=float(emino.get())
        print "in try mino",mino
    except:
        mino=min(densobjdisc)
    try:
        maxo=float(emaxo.get())
        print "in try maxo ",maxo
    except:    
        maxo=1.0
    print "mino= ",mino
    print "maxo= ",maxo
    klass=5
    hdiscobj=rmod2.distrib(densobjdisc,len(densobjdisc),klass,mino,maxo)
    # attributpair distribution
    try:
        mina=float(emina.get())
    except:
        mina=min(densattdisc)
    try:
        maxa=float(emaxa.get())
    except:    
        maxa=1.0
    
    klass=5
    hdiscatt=rmod2.distrib(densattdisc,len(densattdisc),klass, mina,maxa)
    tpdistr=Tkinter.Toplevel(hf)
    tpdistr.title(' Distribution of object- and attributpairs in 5 intervals')
    tver3.append(tpdistr)
    tver2.append(tpdistr)
    tdistr=ScrolledText(tpdistr,width=60,height=10)
    tdistr.pack()
    txtdistr="Distribution of severity of objectpairs separation "+"\n"
    txtdistr+="min-value "+str(mino)+"\nmax-value "+str(maxo)+"\nnumber of classes: "+str(klass)+"\n"
    for j in range(0,len(hdiscobj)):
        txtdistr+=str(hdiscobj[j])+",  "
    txtdistr+="\n"
    if len(densobjdisc)>=3:                                      
        quartile1,quartile2,quartile3=rmod2.quartile(densobjdisc)
        txtdistr+="percentile-statistic:objects (by Brg)"+"\n"
        txtdistr+="First quartile:"+"\t"+str(quartile1)+"\n"
        txtdistr+="Median:"+"\t"+str(quartile2)+"\n"
        txtdistr+="Third quartile:"+"\t"+str(quartile3)+"\n\n"
    else:
        txtdistr+="+++quartiles not meaningful +++"+"\n"                                                               
    txtdistr+="\n\nDistribution of efficiency how attr.pairs are separating "+"\n"
    txtdistr+="min-value "+str(mina)+"\nmax-value "+str(maxa)+"\nnumber of classes: "+str(klass)+"\n"
    for j in range(0,len(hdiscatt)):
        txtdistr+=str(hdiscatt[j])+",  "
    txtdistr+="\n"
    if len(densattdisc)>=3:                                      
        quartile1,quartile2,quartile3=rmod2.quartile(densattdisc)
        txtdistr+="percentile-statistic: attributes by pstat"+"\n"
        txtdistr+="First quartile:"+"\t"+str(quartile1)+"\n"
        txtdistr+="Median:"+"\t"+str(quartile2)+"\n"
        txtdistr+="Third quartile:"+"\t"+str(quartile3)+"\n"
    else:
        txtdistr+="+++ quartiles not meaningful +++"+"\n"                                  
    tdistr.insert("end",txtdistr)
    objtitel=[" 1 "," 2 "," 3 "," 4 "," 5 "]
    
    tpdisdis1=Tkinter.Toplevel(hf)
    tpdisdis2=Tkinter.Toplevel(hf)
    tver3.append(tpdisdis1)
    tver3.append(tpdisdis2)
    tver2.append(tpdisdis1)
    tver2.append(tpdisdis2)
    app1=raioop2.brgbar9(tpdisdis1,hdiscobj,objtitel,"Distribution severity of obj.pairs (5 intervals) ",5)
    app1.ausgabe()
    app2=raioop2.brgbar9(tpdisdis2,hdiscatt,objtitel,"Distribution impact of attr.pairs on obj. pairs (5 intervals) ",5)
    app2.ausgabe()


def graph_of_attributes():
    #brg 26.3.2012, parts taken from dds11
    #statistics 26.3.2012
    hfgraph=Tkinter.Toplevel(hf)
    hfgraph.title(' attribute-graph ')
    tver6.append(hfgraph)
    lbattgraph=Tkinter.Label(hfgraph)
    lbattgraph.pack()
    txtga1="+++you need first to calculate the densities in command group (1) ++++"
    farbe1="yellow"
    txtga2=" ok!  "
    farbe2="white"
    if len(tver2)>0:
        lbattgraph.config(text=txtga2,bg=farbe2)
        quartile1,quartile2,quartile3=rmod2.quartile(densattdisc)
        if elimit.get()==""or elimit==" " or elimit.get()=="  " or elimit.get()=="   " or elimit.get()=="    ":
            alimit=quartile3
        else:    
            alimit=float(elimit.get())
        
        print "alimit=",alimit
        print "k0= ",k0
        
        
        graphdom=rmod2.marray(k0,k0)
        for i in range(0,k0):
            for j in range(i+1,k0):
    ##            print i,j," ",densattdisc[i][j]," ",alimit
                if attmatrix[i][j]>=alimit:
                    graphdom[i][j]=1
                else:
                    graphdom[i][j]=0
        #graphdom is a symmetric matrix, hence:
        for i in range(0,k0):
            for j in range(i+1,k0):
                if graphdom[i][j]==1:
                    graphdom[j][i]=1

        
        valencegraphdom=rmod2.matrixrowsum(graphdom,k0,k0)
        
        frgr=Tkinter.Frame(hfgraph,width=400,height=400,relief="raised",bd=3)
        frgr.pack()
        txt2="\ matrix of the graph of attributes "
        txt2+="\n\t"
        for i in range(0,k0):
            txt2+=str(i)+"\t"
        txt2+="\n"
        for i in range(0,k0):
            txt2+=str(i)+" :\t"
            for j in range(0,k0):
                txt2+=str(graphdom[i][j])+"\t"
            txt2+="\n"
        tgraph=ScrolledText(hfgraph,width=50,height=4)
        tgraph.pack()
        tgraph.insert("end",txt2)
        posx=rmod2.vecgen1(k0)
        posy=rmod2.vecgen1(k0)
        cvgr=Tkinter.Canvas(frgr,width=400, height=400, bg="white")
        
        
        for i in range(0,k0):
            posx[i]=100*math.cos(i*6.28/k0)
            posy[i]=100*math.sin(i*6.28/k0)
            
            cvgr.create_oval(160+posx[i]-20,130+posy[i]+20,160+posx[i]+20,130+posy[i]-20)       
            cvgr.create_text(162+posx[i],132+posy[i],text=str(prop[i]),font = "8")

        rdgr=80
        for i in range(0,k0):
            posx[i]=rdgr*math.cos(i*6.28/k0)
            posy[i]=rdgr*math.sin(i*6.28/k0)
            for j in range(0,k0):
                posx[j]=rdgr*math.cos(j*6.28/k0)
                posy[j]=rdgr*math.sin(j*6.28/k0)
                if i!=j:
                    if graphdom[i][j]==1:
                        cvgr.create_line(160+posx[i],130+posy[i],160+posx[j],130+posy[j])  
                        

                        
        cvgr.create_text(140,360,text=" Graph of attributes, filter = "+str(alimit),font="10")
            
        tpvalence=Tkinter.Toplevel(hf)
        tpvalence.title(' Valences of attributes in the graph ')
        tver6.append(tpvalence)
        tvalence=ScrolledText(tpvalence,width=60,height=10)
        tvalence.pack()
        txtval="Valence of attributes due to "+str(alimit)+"\n"
        
        x1,xd1=inread()  #4.11.2010
        hilftxt=""
        for ob in x1:
            hilftxt+=ob+"\t"
        cvgr.create_text(100,380,text="Selected AC = "+hilftxt)
        cvgr.pack()
        txtval+="Used AC :"+hilftxt+"\n"    
        for j in range(0,k0):
            txtval+=str(prop[j])+"\t"+str(valencegraphdom[j])+"\n"
        txtval+="\n"
        tvalence.insert("end",txtval)
    else:
        lbattgraph.config(text=txtga1,bg=farbe1)


def acmatrix():
    # brg 25.4.2010
    global eattr,tpac,propmatrix,listobjpair,listattrpair
    x1,xd1=inread()  #4.11.2010
    #print "xd1= ",xd1
    d1=int(1.0*xd1*(xd1-1.0)/2.0)
    d2=int(1.0*k0*(k0-1)/2.0)
    propmatrix=rmod2.marray(d1,d2)
    listobjpair=rmod2.vecgen1(d1)
    listattrpair=rmod2.vecgen1(d2)
    deltax1=set([])
    
    txtatt=""
    z1=0
    for ob1 in x1:
        deltax1.add(ob1)
        for ob2 in x1:
            if ob2 not in deltax1:
                txtatt+="\n\n"+ob1+","+ob2+": "
                z2=0
                
                for k1 in range(0,k0):
                    for k2 in range(k1+1,k0):
                        bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                        bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                        bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                        bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                        if (bool1 and bool2) or (bool3 and bool4):
                            txtatt+=str(prop[k1])+" "+str(prop[k2])+", "
                            propmatrix[z1][z2]+=1
                        listattrpair[z2]=[prop[k1],prop[k2]]    
                        z2+=1
                        
                listobjpair[z1]=[ob1,ob2]
                z1+=1

    tpac=Tkinter.Toplevel(hf)
    tpac.title(' AC-matrix ')
    tver2.append(tpac)
    
    tac=ScrolledText(tpac,width=180,height=20)
    tac.pack()
    txt=" Matrix AC "+"\n"
    txt+=100*"="+"\n"
    txt+=2*"\t"
    for i in range(0,len(listattrpair)):
        txt+=str(listattrpair[i])+"\t"
    txt+="\n"
    for i in range(0,len(listobjpair)):
        txt+=str(listobjpair[i])+":"+2*"\t"
        for j in range(0,len(listattrpair)):
            txt+=str(propmatrix[i][j])+"\t"
        txt+="\n"
    txt+="\n"
    txt+="- - - e o f - - - "
    tac.insert("end",txt)
    tac.configure(font=("arial",7))
    buttHDobjpairs=Tkinter.Button(tpac,text="HD of objpairs ",bg="cyan",width=20,command=HDop)
    buttHDobjpairs.pack()
    buttHDattpairs=Tkinter.Button(tpac,text="HD of attpairs ",bg="cyan",width=20,command=HDap)
    buttHDattpairs.pack()
    
def HDop():
    # brg 4.1.2013
    # propmatrix in its standard form as dm
     #global rred, objred,xred,obj
    global zeta2ac,cvac,xredac,objac
    rac=len(listobjpair)
    kac=len(listattrpair)
    print "listobjpair ",listobjpair
    print "listattrpaiir  ",listattrpair
    obac=[]
    for i in range(0,rac):
        obac.append(str(i))
        
    rredac,xredac,objac,txtac=rmod2.equivcompact(rac,kac,propmatrix,obac)
    print "xredac "
    print xredac
    print " "
    print "Equivalences, expressed in txtac= ",txtac
    print "objac  ",objac
    txteq=""
    for i in range(0,len(listobjpair)):
        txteq+=str(i)+": pair "+str(listobjpair[i])+"\n"
    txteq+=60*"="+"\n"
    txteq+=txtac
    txteq+="\n"
    hfhdac=Tkinter.Toplevel(hf)
    hfhdac.title('Hasse diagram / cover matrix ')
    freqac=Tkinter.Frame(hfhdac,width=400,height=400)
    freqac.pack()
    lbfreqac=Tkinter.Label(freqac,text="ALT-Left-Mouse-Button for infos ",bg="yellow")
    lbfreqac.pack()
    n=rredac
    tpeqorigac=Tkinter.Toplevel(hf)
    tpeqorigac.title(' equivalence classes of the original ACM (object pairs)')
    teqorigac=ScrolledText(tpeqorigac,width=60,height=5)
    teqorigac.pack()
    teqorigac.insert("end",txteq)
    #
    zetahilf=rmod2.comp(n,kac,xredac)
    zeta=rmod2.marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
            zeta[i][j]=zetahilf[j][i]
            
      
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)


    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
        
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    global zeta2
    zeta2ac=rmod2.cover(n,tr,lext)
    
    if n>100:
        cover_showac()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freqac,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        cvac=Tkinter.Canvas(freqac,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2ac[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cvac.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cvac.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cvac.create_text(geomx[i][j],geomy[i][j],text=objac[lobj[i][j]],tag="123"+str(objac[lobj[i][j]]))
        
        cvac.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")

        cvac.create_text(garrow1x+8,garrow1y-6,text="high")
        cvac.create_text(garrow1x+8,garrow2y+6,text="low")
        cvac.pack()
        cvac.bind("<Alt-Button 1>",infoobac)
        tac=ScrolledText(freqac,height=5)
        tac.pack()
        txtobjac=""
        for i in range(0,rredac):
            pairnumber=int(objac[i])
            txtobjac+=str(pairnumber)+": "+str(listobjpair[pairnumber])+"\n"
        tac.insert("end",txtobjac)    
        buttcover=Tkinter.Button(freqac,text="show cover relation",command=cover_showac)
        buttcover.pack()
    

def infoobac(event):
    # brg 5.1.2013
    global cvac
    xmouse=int(cvac.canvasx(event.x))
    ymouse=int(cvac.canvasy(event.y))
    #print item2
    
    tu=cvac.gettags(cvac.find_closest(xmouse,ymouse))
    
    lt=len(tu[0])
    tagn=tu[0][3:lt]
    print "tu ",tu[0]
    print "tu 3:lt ",tagn
    print "tagn= ",tagn
    number=objac.index(tagn)
    print "number in xredac ",number
    print "pair ",listobjpair[int(tagn)]
    txt="Info objectpairs "+"\n"
    txt+=str(tagn)+": "+str(listobjpair[int(tagn)])
    hilf=""
    
    hilf2=""
    for j in range(0,len(listattrpair)):
        
        if xredac[number][j]==1:
            hilf2+="Separation by "+str(listattrpair[j])+"\n"
        else:
            pass
    txt+="\n"+hilf2+"\n"    

    tpmouse1=Tkinter.Toplevel(hf)
    tpmouse1.title("Mouse sensitive of objpair-HD ")
    tmouse1=ScrolledText(tpmouse1,width=40,height=5)
    tmouse1.pack()
    tmouse1.insert("end",txt)

def HDap():
    # Brg 4.1.2013
    global zeta2actr,trxredac,cvac2,attacred
    rac=len(listobjpair)
    kac=len(listattrpair)
    print "listobjpair ",listobjpair
    print "listattrpaiir  ",listattrpair
    hilf=""
    for j in range(0,len(listattrpair)):
        hilf+=str(j)+": pair "+str(listattrpair[j])+"\n"
    hilf+=60*"="+"\n"    
    attac=[]
    for j in range(0,kac):
        attac.append(str(j))

    trpropmatrix=rmod2.marray(kac,rac)
    for i in range(0,rac):
        for j in range(0,kac):
            trpropmatrix[j][i]=propmatrix[i][j]
            
    kadac,trxredac,attacred,txtattac=rmod2.equivcompact(kac,rac,trpropmatrix,attac)
    txteqatt=hilf+txtattac
    hfhdac2=Tkinter.Toplevel(hf)
    hfhdac2.title('Hasse diagram / cover matrix ')
    freqac2=Tkinter.Frame(hfhdac2,width=400,height=400)
    freqac2.pack()
    lbfreqac2=Tkinter.Label(freqac2,text="ALT-Left-Mouse-Button for infos ",bg="yellow")
    lbfreqac2.pack()
    n=kadac
    tpeqorigac=Tkinter.Toplevel(hf)
    tpeqorigac.title(' equivalence classes of the original ACM (attribute pairs)')
    teqorigac=ScrolledText(tpeqorigac,width=60,height=5)
    teqorigac.pack()
    teqorigac.insert("end",txteqatt)
    #
    zetahilf=rmod2.comp(kadac,rac,trxredac)
    zeta=rmod2.marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
            zeta[i][j]=zetahilf[j][i]
            
      
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)


    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
        
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    global zeta2
    zeta2actr=rmod2.cover(n,tr,lext)
    
    if n>100:
        cover_showattac()                  #20.1.08
    else:
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        cvac2=Tkinter.Canvas(freqac2,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2actr[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cvac2.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cvac2.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cvac2.create_text(geomx[i][j],geomy[i][j],text=attacred[lobj[i][j]],tag="123"+str(attacred[lobj[i][j]]))
        
        cvac2.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")

        cvac2.create_text(garrow1x+8,garrow1y-6,text="high")
        cvac2.create_text(garrow1x+8,garrow2y+6,text="low")
        cvac2.pack()
        cvac2.bind("<Alt-Button 1>",infoobac2)
        tac2=ScrolledText(freqac2,height=5)
        tac2.pack()
        txtobjac2=""
        for i in range(0,kadac):
            pairnumber=int(attacred[i])
            txtobjac2+=str(pairnumber)+": "+str(listattrpair[i])+"\n"
        tac2.insert("end",txtobjac2)    
        buttcover2=Tkinter.Button(freqac2,text="show cover relation att-pair-HD",command=cover_showac2)
        buttcover2.pack()

def infoobac2(event):
    # brg 5.1.2013
    global cvac2
    xmouse=int(cvac2.canvasx(event.x))
    ymouse=int(cvac2.canvasy(event.y))
    #print item2
    
    tu=cvac2.gettags(cvac2.find_closest(xmouse,ymouse))
    
    lt=len(tu[0])
    tagn=tu[0][3:lt]
    print "tu ",tu[0]
    print "tu 3:lt ",tagn
    print "tagn= ",tagn
    number=attacred.index(tagn)
    txt="Info attributepairs "+"\n"
    txt+=str(tagn)+": "+str(listattrpair[number])
    hilf=""
    for i in range(0,len(listobjpair)):
        if trxredac[number][i]==1:
            hilf+="separating "+str(listobjpair[i])+"\n"
        else:
            pass
    txt+="\n"+hilf+"\n"    

    tpmouse2=Tkinter.Toplevel(hf)
    tpmouse2.title("Mouse sensitive of attpair-HD ")
    tmouse2=ScrolledText(tpmouse2,width=40,height=5)
    tmouse2.pack()
    tmouse2.insert("end",txt)



def cover_showac():
    # Brg 4.1.2013
    txtac1=coverac(zeta2ac,listobjpair)
    tpcac1=Tkinter.Toplevel(hf)
    tpcac1.title(' cover - matrix ')
    tac1=ScrolledText(tpcac1,width=60,height=5)
    tac1.pack()
    tac1.insert("end",txtac1)

def cover_showac2():
    # brg 4.1.2013
    txtac2=coverac(zeta2actr,listattrpair)
    tpcac2=Tkinter.Toplevel(hf)
    tpcac2.title(' cover - matrix ')
    tac2=ScrolledText(tpcac2,width=60,height=5)
    tac2.pack()
    tac2.insert("end",txtac2)


def coverac(matrix,rows):
    # brg 5.1.2013
    dimm=len(matrix)
    txt="\n cover-matrix  \n"
    
    for i in range(0,dimm):
        txt+="\n"+str(rows[i])+":\t"
        txt+="is covered by "
        for j in range(0,dimm):
            if i!=j:
                if matrix[i][j]==1:
                    txt+=" "+str(rows[j])+" ,"
                else:
                    pass
            else:
                pass
        txt+="\n"    
    txt+="\n"
    txt+=" -- end of list --"
    return txt
    

     
def pattern():
    #brg 27.11.2010
    global tppattern,eyn
    tppattern=Tkinter.Toplevel(hf)
    tppattern.title(' pattern-analysis ')
    tver5.append(tppattern)
    frgrid1=Tkinter.Frame(tppattern,bd=3,relief="sunken")# Nota bene : frgrid: grid-manager
    frgrid1.pack()
    lbg1=Tkinter.Label(frgrid1,text="same limiting\nvalue f all attr's (y/n)")
    lbg1.grid(row=0,columnspan=k0+1)
    eyn=Tkinter.Entry(frgrid1,width=3)
    eyn.grid(row=0,column=k0+1)
    buttsubmit=Tkinter.Button(frgrid1,text="submit ",width=5,command=pattern2)
    buttsubmit.grid(row=0,column=k0+2)
    
def pattern2():
    #brg 27.11.2010
    global eyn,yn,elimitvalue,elimitvalues
    frgrid2=Tkinter.Frame(tppattern)
    frgrid2.pack()
    yn=eyn.get()
    #print "yn= ",yn
    if yn=="y":
        elimitvalue=Tkinter.Entry(frgrid2,width=5)
        elimitvalue.grid(row=2,column=0)
    else:
        elimitvalues=rmod2.vecgen1(k0)
        for j in range(0,k0):
            elimitvalues[j]=Tkinter.Entry(frgrid2,width=3)
            elimitvalues[j].grid(row=2,column=j)
    buttsubmit2=Tkinter.Button(frgrid2,text="submit your selection",width=15,command=pattern3)
    buttsubmit2.grid(row=3,column=9)


def pattern3():
    #brg 27.11.2010
    global limitattval
    limitattval=rmod2.vecgen1(k0)
    if yn=="y":
        attlimitval=float(elimitvalue.get())
        for j in range(0,k0):
            limitattval[j]=attlimitval
    else:
        for j in range(0,k0):
            limitattval[j]=float(elimitvalues[j].get())
    txt="limiting values for attributes \n"
    for j in range(0,k0):
        txt+=str(limitattval[j])+", "
    lbinterim=Tkinter.Label(tppattern,text=txt,bg="yellow")
    lbinterim.pack()
    buttsubmit3=Tkinter.Button(tppattern,text="perform the calc. ",width=15,command=cp)
    buttsubmit3.pack()

def patnorm():
    # brg 21.3.2012
    global maxval,tpantix
    x1,xd1=inread()  #4.11.2010
    #print "xd1= ",xd1
    tpantix=Tkinter.Toplevel(hf)
    tpantix.title(' antichain-analysis: pattern of normalized attributes ')
    tver5.append(tpantix)
    tantix=ScrolledText(tpantix,width=80, height=20)
    tantix.pack()
    txtpn="indicator cluster-hierarchy "+"\n"
    txtpn+="object\tlimit\tindicators>=limit"+"\n"
    txtpn+=70*"="+"\n"
    maxval=rmod2.marray(rred,k0)
    xredn=rmod2.matrixnorm(rred,k0,xred)
    
    for ob in x1:
        for limit in range(5,11):
            txtpn+=ob+"\t:"+str(round(0.1*limit,2))+" "
            iob=objred.index(ob)
            for j in range(0,k0):
                if xredn[iob][j]>=0.1*limit:
                    txtpn+=str(prop[j])+" "
                    maxval[iob][j]=0.1*limit
                else:
                    txtpn+="    "
            txtpn+="\n"+70*"-"+"\n"
        txtpn+=70*"="+"\n"
    txtpn+="  -   -  -   e  o  f  -  -  -  "
    tantix.insert("end",txtpn)    
    buttsingle.config(state="active")
    
        
def pattsingle():
    # brg 22.3.2012
    global tpps
    obsp=eob.get()
    iobsp=objred.index(obsp)
    tpps=Tkinter.Toplevel(hf)
    tver5.append(tpps)
    cvps=Tkinter.Canvas(tpps,width=450,height=400,bg="white")
    cvps.pack()
    start=50
    delta=50
    for j in range(0,k0):
        cvpstext=cvps.create_text(start,50,text=str(prop[j]),font=("arial",8,"bold"))
        start+=delta
    
    delta2=10
    start2=50
    cvpstxt=cvps.create_text(50+k0*delta2*0.5,10,text="object = "+str(obsp),font=("arial",12,"bold"))
    cvpsrect=cvps.create_rectangle(50,380,50+k0*delta2,400)
    for j in range(0,k0):
        if maxval[iobsp][j]<0.5:
            cvspline1=cvps.create_line(start2,380,start2,390,fill="red")
        else:    
            cvpsline=cvps.create_line(start2,380-280*maxval[iobsp][j],start2,380,width=1,fill="blue")
        start2+=delta2
    
    

def cp():
    #brg 27.11.2010
    x1,xd1=inread()  #x1 is the list of elements of an AC
    print "x1= ",x1
    histopatt=rmod2.vecgen1(xd1)
    correspondence=rmod2.vecgen1(xd1)
    obac=[]
    z=0
    for ob in x1:
        obac.append(ob)
        iob=objred.index(ob)
        print "object= ",ob, "   iob = ",iob
        for j in range(0,k0):
            if xred[iob][j]>=limitattval[j]:
                print j," tes attribut  ",xred[iob][j]
                histopatt[z]+=1
        correspondence[z]=iob        
        z+=1
##    print correspondence
##    print histopatt
    tpattern=ScrolledText(tppattern,width=60,height=10)
    tpattern.pack(expand="yes",fill="both")
    txt="Result of pattern analysis \n"
    txt+=60*"="+"\n"
    txt0=" \n"
    txt0+="limiting values ;\n"
    for j in range(0,k0):
        txt0+=str(limitattval[j])+", "
    txt0+="\n"
    txt+=txt0
    barth=rmod2.vecgen1(xd1)
    z=0
    for ob in x1:
        barth[z]=ob
        iob=objred.index(ob)
        for ii in range(0,xd1):
            if correspondence[ii]==iob:
                txt+=ob+":"+" "+str(histopatt[ii])+"\n"
        z+=1
    txt+="\n"
    txt+=" - - - e o f - - - - "
    tpattern.insert("end",txt)
    app1=raioop2.brgbar8(tppattern,histopatt,barth,"AC-pattern, \nlimiting values"+txt0)
    app1.ausgabe()
            
            
def writeExcelattpairs():
    #brg 31.5.2011
    #Writes directly to EXCEL
    import win32com.client    
    latt=int(k0*1.0*(k0-1)/2.0)
    
    attp=rmod2.vecgen1(latt)
    freqatt=rmod2.vecgen1(latt)
    x1,xd1=inread()  #4.11.2010
    z1=0
    for k1 in range(0,k0):
        for k2 in range(k1+1,k0):  #24.4.2011
            
            attp[z1]=(prop[k1],prop[k2])
            delta2x1=set([])
            
            for ob1 in x1:
                delta2x1.add(ob1)
                for ob2 in x1:
                    if ob2 not in delta2x1:
                        bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                        bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                        bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                        bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                        if (bool1 and bool2) or (bool3 and bool4):
                            freqatt[z1]+=1
            
            
            z1+=1
        #print " "    
    txtexc=""
    for obexc in x1:
        txtexc+=obexc+", "
    #print txtexc    
    x1App=win32com.client.Dispatch("Excel.Application")
    x1App.Visible=True
    x1App.Workbooks.Add()
    
    x1App.ActiveSheet.Cells(2,1).Value="col_sum_of_ACM"
    zahl=2
    for j1 in range(0,k0-1):
        for j2 in range(j1+1,k0):
            x1App.ActiveSheet.Cells(1,zahl).Value="("+str(prop[j1])+","+str(prop[j2])+")"
            zahl+=1
    for j in range(0,latt):
        x1App.ActiveSheet.Cells(2,j+2).Value=str(1.0*freqatt[j]/d1)

#normalization by the number of objectpairs x,y with x not equal y and (x,y) is (y,x)
                                                 
    
def writeExcelobjpairs():
    #brg 31.05.2011, 1.6.2011
    #writes the objectpair statistics into an Excelfile
    #Note this can only be used if the needed calc. are done before.
    x1App=win32com.client.Dispatch("Excel.Application")
    x1App.Visible=True
    x1App.Workbooks.Add()
    x1App.ActiveSheet.Cells(1,1).Value="matrix_ACM"
    x1App.ActiveSheet.Cells(2,1).Value="row_sum_of_ACM"
    for i in range(0,d1):
        x1App.ActiveSheet.Cells(1,i+2).Value=str(listobjpair[i])
            
    for i in range(0,d1):
        x1App.ActiveSheet.Cells(2,i+2).Value=str(round(densobjdisc[i],3))
    
def inreadweights():
    #brg 17.8.10, 9.4.2012
    txtb1=""
    txtb1+="user defined weights \n"
    weights1=[]
    for i in range(0,k0):
        try:
            weights1.append(float(ew[i].get()))
        except:
            weights1.append(1.0/(1.0*k0))
    
    txtb1+="\n"
    txtw1="weights: "
    for j in range(0,k0):
        txtw1+=str(round(weights1[j],2))+"\t"
    
    txtb1+=txtw1+"\n"
    return weights1,txtb1

def calcoutrk():
    # brg 9.4.2012
    global ew,tpsub
    tpsub=Tkinter.Toplevel(hf,width=60,height=10)
    tpsub.title(' submit weight-window')
    tver4.append(tpsub)
    labew=Tkinter.Label(tpsub,text="Select weights for "+str(k0)+" attributes")
    labew.pack(side="left")
    frc=Tkinter.Frame(tpsub)
    frc.pack(pady=2)
    
    ew=rmod2.vecgen1(k0)
    for i in range(0,k0):
        ew[i]=Tkinter.Entry(frc,width=4)
        ew[i].grid(row=0,column=i)
    buttcontinue=Tkinter.Button(tpsub,text="perform the outranking ",command=calcoutrk2)
    buttcontinue.pack()

def calcoutrk2():
    # Brg  17.6.10, 17.8.10, 25.7.2011
    # calc the outranking matrix
    # takes the weights
    # Performs the Kemenyi-algorithm (CKYL algorithm after Munda)
    # taken from outrk6.py
    global tpoutrk,tpoutrk2
    x1,xd1=inread()
    #print x1
    ovec=[]
    rredac=len(x1)
    i1=0
    for objac in x1:
        ovec.append(objac)
        i1+=1

    #reduced data matrix corresponding to the AC
    xredac=rmod2.marray(rredac,k0)
    
    
    for i2 in range(0,rredac):
        for i in range(0,rred):
            if objred[i]==ovec[i2]:
                for j in range(0,k0):
                    xredac[i2][j]=xred[i][j]
            
    #rmod2.matout(rred,k0,xred)
    #rmod2.matout(rredac,k0,xredac)

    

    weights,txtb=inreadweights()
    print weights 
    
    outrk1,lov=rmod2.outranking(ovec,weights,xredac,k0)
    rwsumout=rmod2.matrixrowsum(outrk1,rredac,rredac)
    print rwsumout
    outrktransp=rmod2.mattransp(rredac,rredac,outrk1) #to ascertain that row is to the degree <outrk> over column
    #rmod2.matout(rredac,rredac,outrk1)
    #print lov
    tpoutrk=Tkinter.Toplevel(hf)
    tver4.append(tpoutrk)
    app1=raioop2.brgmatrixoutput3(tpoutrk,outrk1,"outrk_AC",txtb,rredac,rredac,ovec,ovec,"Outranking of AC")
    app1.ausgabe()
    tpoutrk2=Tkinter.Toplevel(hf)
    tpoutrk2.title('empirical ranking of AC')
    tver4.append(tpoutrk2)
    toutrk2=ScrolledText(tpoutrk2,width=120,height=30)
    toutrk2.pack()
    txtoutrk2=" Based on the weights an empirical ranking-index is calculated "+"\n"
    txtoutrk2+=80*"="+"\n"
    for i in range(0,rredac):
        txtoutrk2+=str(ovec[i])+":\t"+str(round(rwsumout[i],3)) +"\n"
    txtoutrk2+="\n"+" - - - e o f - - -"    
    toutrk2.insert("end",txtoutrk2)


def discrepancy():
    #brg 07.02.2018, 12.02.17
    deltamaxn=[]
    xredhilf=rmod2.matrixnorm(rred,k0,xred)
    #normalization by scaling all columns
    txtdisc="Analysis of discrepancies (based on the columnwise [0,1]-normalized matrix"+"\n"
    txtdisc+= "delta(i1,i2,j): = abs(dm(i1,j)-dm(i2,j))"+"\n"
    txtdisc+="Discrepancy object i1, object i2 : = max(delta(i1,i2),j1)*delta(i1,i2,j2))"+"\n"
    txtdisc+=70*"="+"\n"
    txtdisc+="Analyzed the antichain: "
      
            
    x1,xd1=inread()
    print x1
    for ob in x1:
        txtdisc+=str(ob)+", "
    txtdisc+="\n"  
    rredac=len(x1)
    discrepancy=rmod2.marray(rredac,rredac)
    iz1=0
    for ob1 in x1:
        iob1=objred.index(ob1)
        iz2=0
        for ob2 in x1:
            iob2=objred.index(ob2)
            testn4=[]
            for j1 in range(0,k0-1):
                for j2 in range(j1+1,k0):
                    testn1=(xredhilf[iob1][j1]-xredhilf[iob2][j1])
                    testn2=(xredhilf[iob1][j2]-xredhilf[iob2][j2])
                    if testn1*testn2<0:
                        # incomparable ob1,ob2 wrt j1,j2
                        
                        testn3=abs(testn1)*abs(testn2)
                        print ob1,ob2,prop[j1],prop[j2],"  testn3 = ",testn3
                    else:
                        testn3=0
                    testn4.append(testn3)            
              
            discrepancy[iz1][iz2]=max(testn4)
            txtdisc+=str(ob1)+", "+str(ob2)+":\t"+str(round(discrepancy[iz1][iz2],3))+"\n"
            print "testn4= ",testn4
            iz2+=1
        iz1+=1    
    tpdisc=Tkinter.Toplevel(hf)
    tdisc=ScrolledText(tpdisc,width=80, height=20)
    tdisc.pack()
    tdisc.insert("end",txtdisc)
            
        
    


def POAC():
    # brg 21.9.2011, 10.4.2012, 07.02.2018
    global newdm,rredac,dimobpair,obpair,tpac2
    x1,xd1=inread()
    #print x1
    ovec=[]
    rredac=len(x1)
    i1=0
    for objac in x1:
        ovec.append(objac)
        i1+=1

    #reduced data matrix corresponding to the AC
    dimobpair=rredac*(rredac-1.0)/2.0    
    xredac=rmod2.marray(rredac,k0)
    minredac=rmod2.vecgen1(k0)
    maxredac=rmod2.vecgen1(k0)
    obpair=rmod2.vecgen1(int(dimobpair))
    for i in range(0,int(dimobpair)):
        obpair[i]=listobjpair[i][0]+", "+listobjpair[i][1]
        #print "objpair= ",obpair[i]
    for i2 in range(0,rredac):
        for i in range(0,rred):
            if objred[i]==ovec[i2]:
                for j in range(0,k0):
                    xredac[i2][j]=xred[i][j]
                    
    for j in range(0,k0):
        mincol=99999.0
        maxcol=-99999.0
        for i in range(0,rred):#Here is an important point: The maximum-minimum could also be...
            if xred[i][j]<=mincol:     #...derived from xredac, the remaining dm corresp. to the AC
                mincol=xred[i][j]
                minredac[j]=xred[i][j]
            if xred[i][j]>=maxcol:
                maxcol=xred[i][j]
                maxredac[j]=xred[i][j]
        print j,minredac[j],maxredac[j]        
        
    rmod2.matout(rred,k0,xred)
##    print minredac
##    print maxredac
    deltamax=rmod2.vecgen1(k0)
    for j in range(0,k0):
        deltamax[j]=maxredac[j]-minredac[j]
        print "attribut= ",j," deltamax = ",deltamax[j]
            
    
    dimattpair=k0*(k0-1.0)/2.0
    delta=rmod2.vecgen1(int(dimobpair))
    
    z=0
    for i1 in range(0,rredac):
        for i2 in range(i1+1,rredac):
            maxcol=-99999.9
            mincol=99999.9
            z2=0
            for j1 in range(0,k0):
                for j2 in range(j1+1,k0):   #deltamax=0 possibility inserted 30.11.2012
                    if deltamax[j1]!=0:
                        hilf1=1.0*abs(xredac[i1][j1]-xredac[i2][j1])/deltamax[j1]
                    else:
                        hilf1=0
                    if deltamax[j2]!=0:    
                        hilf2=1.0*abs(xredac[i1][j2]-xredac[i2][j2])/deltamax[j2]
                    else:
                        hilf2=0
                    hilf3=hilf1*hilf2*propmatrix[z][z2] #hier noch tests noetig###
                    print "objects ",i1,i2,"  attributes ",j1,j2,hilf1,hilf2,hilf3
                    if hilf3>=maxcol:
                        maxcol=hilf3 #only for incomparable pairs of attribute values is delta unequal zero
                    z2+=1
            delta[z]=maxcol
            z+=1   
    print i1,i2, "delta= ",delta
    
    newdm=rmod2.marray(int(dimobpair),2)
    z=0
    for i in range(0,int(dimobpair)):
        newdm[i][0]=delta[i]
        newdm[i][1]=objdisc[i]
    tpac2=Tkinter.Toplevel(hf)
    tpac2.title(' further characterisation of AC ')
    tver4.append(tpac2)
    tac2=ScrolledText(tpac2,width=60,height=10)
    tac2.pack(fill="both")
    txt=""
    txt+="Further characterisation of AC "+"\n"
    txt+=60*"="+"\n"
    txt+="degree of discrepancies 'delta'\tnumber of incomparabilities \n \tdue to attributecombinations 'Uqiqj' "+"\n"
    txt+="\t"+"objpair"+"\t\t"+"delta"+"\t\t"+"Uqiqj"+"\n"
    for i in range(0,int(dimobpair)):
        txt+="\t"+str(listobjpair[i])+"\t\t"+str(round(newdm[i][0],3))+"\t\t"+str(newdm[i][1])+"\n"
    txt+="\n"
    txt+=60*"-"+"\n"
    tac2.insert("end",txt)
    frtac2=Tkinter.Frame(tpac2,relief="sunken",bd=3)
    frtac2.pack()
    buttscatter=Tkinter.Button(frtac2,text="Scatterplot ",width=25,command=scatter)
    buttscatter.pack(side="left")
    butthassediagram=Tkinter.Button(frtac2,text="Hasse diagram of object pairs of AC ",width=35,command=HDtac2)
    butthassediagram.pack(side="left")


def scatter():
     # brg 21.9.2011,22.9.2011,10.4.2012
     global tpscatter,tpinfo
     tpscatter=Tkinter.Toplevel(hf)
     tpinfo=Tkinter.Toplevel(hf)
     tver4.append(tpscatter)
     tver4.append(tpinfo)    
     app1=raioop2.brgscatterplot3(tpscatter,tpinfo,obpair,newdm,dm,r,k0,obj,"Uq1q2","delta",int(dimobpair))
     app1.anzeige()



     
def HDtac2():
    #brg 21.9.2011
    global tpbasic3,tpeqorig3,hfhd3
    rred2,xred2,objred2,txt2=rmod2.equivcompact(int(dimobpair),2,newdm,obpair)   
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagram of obj-pairs of AC ')
    tver4.append(hfhd3)
    freq3=Tkinter.Frame(hfhd3,width=200,height=300)
    freq3.pack()
    n=rred2
    print "objpairs in HD/AC",n
    tpeqorig3=Tkinter.Toplevel(hf)
    tpeqorig3.title(' equivalence classes of the original DM ')
    tver4.append(tpeqorig3)
    teqorig=ScrolledText(tpeqorig3,width=60,height=5)
    teqorig.pack()
    teqorig.insert("end",txt2)
    #
    zetahilf=rmod2.comp(n,2,xred2)
    zeta=rmod2.marray(n,n)
    for i in range(0,n):
        for j in range(0,n):
            zeta[i][j]=zetahilf[j][i]
            
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq3,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq3,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic3=Tkinter.Toplevel(hf)
    tpbasic3.title('  HD of object pairs of AC')
    tver4.append(tpbasic3)
    lbbasic2=Tkinter.Label(tpbasic3,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred2[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    x1default=set([])
    for j in range(0,len(lobj[0])):
            x1default.add(objred2[lobj[0][j]])
    print "x1default ",x1default        
    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred2[revlext[i]]+" < "
        else:
            txt2+=objred2[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq3,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    global zeta2
    zeta2=rmod2.cover(n,tr,lext)
    
    if n>100:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq3,text=" Hasse Diagram of AC ")
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq3,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-15,geomy[i][j]+15,geomx[i][j]+15,geomy[i][j]-15,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.pack()

def criticpairs():
    #brg 17.10.2011, 27.3.2012
    #rmod2.matout(rred,rred,zeta)
    global txtcrit,tpcrit
    probm=[]
    inc2=set([])
    for i in range(0,rred):
        for j in range(0,rred):
            if i!=j and zeta[i][j]==0 and zeta[j][i]==0:
                ob1=objred[i]
                ob2=objred[j]
                inc2.add((ob1,ob2))
    #print inc2
    crit=set([])
    for test in inc2:
        iob1=objred.index(test[0])
        iob2=objred.index(test[1])
        #print iob1,iob2
        down1=set([])
        up1=set([])
        down2=set([])
        up2=set([])
        for i2 in range(0,rred):
            if i2!=iob1 and zeta[iob1][i2]==1:
                up1.add(i2)
            if i2!= iob1 and zeta[i2][iob1]==1:
                down1.add(i2)
        m1=len(down1)
        n1=len(up1)
        for i3 in range(0,rred):
            if i3!=iob2 and zeta[iob2][i3]==1:
                up2.add(i3)
            if i3!= iob2 and zeta[i3][iob2]==1:
                down2.add(i3)       
        m2=len(down2)
        n2=len(up2)
        Q1=(1.0*m1+1.0)/(1.0*n1+1.0)
        Q2=(1.0*m2+1.0)/(1.0*n2+1.0)
        hilf=1.0*Q1/(1.0*Q1+1.0*Q2)
        probm.append((test,hilf))
        if down1.issubset(down2) and up1.issuperset(up2):
            crit.add(test)
    #print crit        
    cntinc2=len(inc2)
    cntcrit=len(crit)
    tpcrit=Tkinter.Toplevel(hf)
    tpcrit.title(' critical pairs ')
    tver6.append(tpcrit)
    tcrit=ScrolledText(tpcrit,width=60,height=10)
    tcrit.pack()
    txtcrit="Critical pair analysis "+"\n"
    txtcrit+=50*"=" +"\n"
    txtcrit+="set of all ordered incomparable pairs "+"\n"
    txtcrit+=str(cntinc2)+" ordered pairs "+"\n"
    zahl=1
    for test in inc2:
        txtcrit+="("+test[0]+", "+test[1]+")"+", "
        if 1.0*zahl/5.0-zahl/5==0:
            txtcrit+="\n"
        zahl+=1    

    txtcrit+="\n"
    txtcrit+="\n"
    txtcrit+="(Estim.) Mutual probability of first element over second element of inc2"+"\n"
    lprobm=len(probm)
    for i5 in range(0,lprobm):
        txtcrit+=str(probm[i5][0])+"  probm: "+str(round(probm[i5][1],3))+"\n"
    txtcrit+=2*"\n"    
    txtcrit+="set of critical pairs "+"\n"
    txtcrit+=str(cntcrit)+" ordered critical pairs "+"\n"
    zahl=1
    for test in crit:
        txtcrit+="("+test[0]+", "+test[1]+")"+", "
        if 1.0*zahl/5.0-zahl/5==0:
            txtcrit+="\n"
        zahl+=1    
    # comparison with user defined ac
    txt="Critical pairs in selected antichain "+"\n"
    txt+="Let (x,y) be a pair, taken from elements of the selected AC\n"
    txt+="then: If downset(x) is subset of downset(y) and upset(x) is superset of upset(y)"+"\n"
    txt+="then (x,y) is a critical pair of AC\n" 
    txt+=60*"=" + "\n"
    x1,xd1=inread()  #4.11.2010
    xx1=set([])
    for ob1 in x1:
        for ob2 in x1:
            if ob1!=ob2:
                xx1.add((ob1,ob2))

    critac=crit.intersection(xx1)
    cntcritac=len(critac)
    txt+=2*"\n"
    txt+="There are "+str(cntcritac)+"  common elements"+"\n"
    txt+=" in user defined pairs of AC and crit-pairs "+"\n"
    zahl=1
    for test in critac:
        txt+="("+test[0]+", "+test[1]+")"+", "
        if 1.0*zahl/5.0-zahl/5==0:
            txt+="\n"
        zahl+=1    
    txt+=2*"\n"
    tcrit.insert("end",txt)
    buttcritcrit=Tkinter.Button(tpcrit,text="Details ",command=displaydetails)
    buttcritcrit.pack()

def displaydetails():
    #brg 27.3.2012
    global tpcrit2
    tpcrit2=Tkinter.Toplevel(hf)
    tpcrit2.title('details of critical pairs ')
    tver6.append(tpcrit2)
    tcrit2=ScrolledText(tpcrit2,width=60,height=10)
    tcrit2.pack()
    tcrit2.insert("end",txtcrit)
    
    
def tripartite_graph():
    #  brg 19.1.2012
    # Only the set of buttons for complete, objectpair or selected attribute
    global eob1,eob2,eatt1,tptrip0
    tptrip0=Tkinter.Toplevel(hf)
    tptrip0.title(' tripartite graph of AC ')
    tver6.append(tptrip0)
    frtg=Tkinter.Frame(tptrip0, bd=4, relief="sunken")
    frtg.pack()
    butt1=Tkinter.Button(frtg,text=" All vertices of the tripartite graph ",width=40,bg="cyan",command=atp)
    butt1.pack()
    frtg1=Tkinter.Frame(frtg)
    frtg1.pack()
    eob1=Tkinter.Entry(frtg1,width=4)
    eob1.pack(side="left")
    eob2=Tkinter.Entry(frtg1,width=4)
    eob2.pack(side="left")
    butt2=Tkinter.Button(frtg1,text=" One objectpair  ",width=40,bg="cyan",command=atp7b)
    butt2.pack(side="left",fill="x")
    frtg2=Tkinter.Frame(frtg)
    frtg2.pack()
    eatt1=Tkinter.Entry(frtg2,width=4)
    eatt1.pack(side="left")
    butt3=Tkinter.Button(frtg2,text=" One attribute (0,1,..,"+str(k0-1)+ " )",width=40,bg="cyan",command=atp7c)
    butt3.pack(side="left",fill="x")
    
def atp():
    # brg taken and modified from sepanal16 , 19.1.2012
    global tptrip
    tptrip=Tkinter.Toplevel(hf)
    tptrip.title(' complete tripartite graph of AC ')
    tver6.append(tptrip)
    x1,xd1=inread()
    nlist =int(1.0*xd1*(xd1-1.0)/2.0)
    objlist=rmod2.vecgen1(xd1)
    zahl=0
    for ob in x1:
        iob=objred.index(ob)
        objlist[zahl]=iob
        zahl+=1
    listpaar=[]
    for i1 in range(0,xd1):
        for i2 in range(i1+1,xd1):
            listpaar.append([objlist[i1],objlist[i2]])
    
    cv=Tkinter.Canvas(tptrip,width=400,height=400,bg="white")
    cv.config(scrollregion=(0,0,1000,1000)) 
    cv.config(highlightthickness=1)
    t="0123456789"
    tt=7*t
    lb1=Tkinter.Label(cv,text=tt,bg="yellow")
    lb1.pack()


    sbary=Tkinter.Scrollbar(cv,orient="vertical")
    sbary.config(command=cv.yview) 
    cv.config(yscrollcommand=sbary.set) 
    sbary.pack(side="right", fill="y")
    cv.pack(side="left",expand="yes",fill="both")
    pos1=rmod2.marray(k0,2)
    pos2=rmod2.marray(nlist,2)
    pos3=rmod2.marray(k0,2)
    ct01=cv.create_text(130,40,text=" x > y ")
    ct012=cv.create_text(200,40,text=" (x,y) ")
    ct02=cv.create_text(270,40,text=" x < y ") 
    for j in range(0,k0):
        pos1[j][0]=75
        pos3[j][0]=325
        pos1[j][1]=60+20*j
        pos3[j][1]=60+20*j

    for i in range(0,nlist):
        pos2[i][0]=200
        pos2[i][1]=60+20*i

    for j in range(0,k0):
        xx=pos1[j][0]
        yy=pos1[j][1]
        ct1=cv.create_text(xx,yy,text=prop[j])

        xx2=pos3[j][0]
        yy2=pos3[j][1]
        ct2=cv.create_text(xx2,yy2,text=prop[j])

    for i in range(0,nlist):
        xx1=pos2[i][0]
        yy1=pos2[i][1]
        ctp=cv.create_text(xx1,yy1,text="("+str(objred[listpaar[i][0]])+","+str(objred[listpaar[i][1]])+")")

    for j in range(0,k0):
        for i in range(0,nlist):
            io1=listpaar[i][0]
            io2=listpaar[i][1]
            if xred[io1][j]>xred[io2][j]:
                o1o2q=1
                
            if xred[io1][j]==xred[io2][j]:
                o1o2q=0
               
            if xred[io1][j]<xred[io2][j]:
                o1o2q=-1
            if o1o2q==1:
                line1=cv.create_line(pos1[j][0]+15,pos1[j][1],pos2[i][0]-20,pos2[i][1],fill="red")
            if o1o2q==-1:
                line2=cv.create_line(pos3[j][0]-15,pos3[j][1],pos2[i][0]+20,pos2[i][1],fill="blue")


def atp7b():
    #brg 22.8.10  individual analysis
    # 19.1.2012 taken from sepanal16, co7 there
    global eob1,eob2,tpco7
    tpco7=Tkinter.Toplevel(hf)
    tver6.append(tpco7)
    tpco7.title(' individual analysis ')
    th="0123456789"
    tt=7*th
    x1,xd1=inread()
    nlist =int(1.0*xd1*(xd1-1.0)/2.0)
    objlist=rmod2.vecgen1(xd1)
    zahl=0
    for ob in x1:
        iob=objred.index(ob)
        objlist[zahl]=iob
        zahl+=1
    listpaar=[]
    for i1 in range(0,xd1):
        for i2 in range(i1+1,xd1):
            listpaar.append([objlist[i1],objlist[i2]])
    

    
    ob1=eob1.get()
    iob1=objred.index(ob1)
    ob2=eob2.get()
    iob2=objred.index(ob2)
    
    cv2=Tkinter.Canvas(tpco7,width=400,height=400,bg="white")
    lb2=Tkinter.Label(tpco7,text=tt,bg="yellow")
    lb2.pack()
    cv2.pack(expand="yes",fill="both")
    pos12=rmod2.marray(k0,2)
    pos32=rmod2.marray(k0,2)
    ct01=cv2.create_text(130,40,text=" x  > y ")
    ct012=cv2.create_text(200,40,text=" (x,y) ")
    ct02=cv2.create_text(270,40,text=" x  < y ") 
    for j in range(0,k0):
        pos12[j][0]=75
        pos32[j][0]=325
        pos12[j][1]=60+20*j
        pos32[j][1]=60+20*j


    for j in range(0,k0):
        xx1=pos12[j][0]
        yy1=pos12[j][1]
        ct1=cv2.create_text(xx1,yy1,text=prop[j])

        x3=pos32[j][0]
        y3=pos32[j][1]
        ct2=cv2.create_text(x3,y3,text=prop[j])


    xx2=200
    yy2=60+k0*10
    ctp=cv2.create_text(xx2,yy2,text="("+ob1+","+ob2+")")

    for j in range(0,k0):
        if xred[iob1][j]>xred[iob2][j]:
                o1o2q=1
                
        if xred[iob1][j]==xred[iob2][j]:
            o1o2q=0
           
        if xred[iob1][j]<xred[iob2][j]:
            o1o2q=-1

        if o1o2q==1:
            line1=cv2.create_line(pos12[j][0]+15,pos12[j][1],xx2-15,yy2,fill="red",width=2)
        if o1o2q==-1:
            line2=cv2.create_line(pos32[j][0]-15,pos32[j][1],xx2+15,yy2,fill="blue",width=2)



def atp7c():
    #brg 4.9.10
    #brg 22.8.10  individual analysis
    # brg 19.1.2012 taken from sepanal16
    global eatt1,tpco7b
    tpco7b=Tkinter.Toplevel(hf)
    tpco7b.title(' individual analysis /attr. ')
    tver6.append(tpco7b)
    th="0123456789"
    tt=7*th
    x1,xd1=inread()
    nlist =int(1.0*xd1*(xd1-1.0)/2.0)
    objlist=rmod2.vecgen1(xd1)
    zahl=0
    for ob in x1:
        iob=objred.index(ob)
        objlist[zahl]=iob
        zahl+=1
    listpaar=[]
    for i1 in range(0,xd1):
        for i2 in range(i1+1,xd1):
            listpaar.append([objlist[i1],objlist[i2]])
    
    
    iatt=int(eatt1.get())
    
    
    cv2=Tkinter.Canvas(tpco7b,width=400,height=400,bg="white")
    lb2=Tkinter.Label(tpco7b,text=tt,bg="yellow")
    lb2.pack()
    cv2.pack(expand="yes",fill="both")
    pos12=rmod2.marray(1,2)
    pos32=rmod2.marray(1,2)
    ct01=cv2.create_text(130,40,text=" x  > y ")
    ct012=cv2.create_text(200,40,text="(x,y)")
    ct02=cv2.create_text(270,40,text=" x  < y ") 
    
    
    pos12[0][0]=75
    pos32[0][0]=325
    pos12[0][1]=120
    pos32[0][1]=120


    ct1=cv2.create_text(pos12[0][0],pos12[0][1],text=prop[iatt])
    ct2=cv2.create_text(pos32[0][0],pos32[0][1],text=prop[iatt])

    for i in range(0,nlist):
        ctp=cv2.create_text(200,60+15*i,text="("+str(objred[listpaar[i][0]])+","+str(objred[listpaar[i][1]])+")")

    for i in range(0,nlist):
        iob1=listpaar[i][0]
        iob2=listpaar[i][1]
        if xred[iob1][iatt]>xred[iob2][iatt]:
                o1o2q=1
                
        if xred[iob1][iatt]==xred[iob2][iatt]:
            o1o2q=0
           
        if xred[iob1][iatt]<xred[iob2][iatt]:
            o1o2q=-1

        if o1o2q==1:
            line1=cv2.create_line(pos12[0][0]+15,pos12[0][1],200-15,60+15*i,fill="red",width=2)
        if o1o2q==-1:
            line2=cv2.create_line(pos32[0][0]-15,pos32[0][1],200+15,60+15*i,fill="blue",width=2)
    


hf=Tkinter.Tk()
hf.title('--   GUI antichain-analysis   -- ')

aboutmainHD=raioop2.brgabout(hf,"tp1","about_antich.txt",20,\
            "March, 31, 2012"," about antichain ", "white", "t1",120,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_antich.txt",20,\
            "April, 11th, 2012"," help_antichain ", "white", "t1",120,10,ScrolledText)
    

fr1=Tkinter.Frame(hf,width=60)   #about, help, fn, lbopen1
fr1.pack()
fr11=Tkinter.Frame(fr1,width=60)
fr11.pack()
Buttfn=Tkinter.Button(fr11,text="select&open-file&HD from txt-files",width=30,bg="cyan",command=fileselect)
Buttfn.pack(side='left',pady=5)
Buttfn2=Tkinter.Button(fr11,text="select&open-file&HD from Excel-sheet",width=30,bg="cyan",command=fileselectExcel)
Buttfn2.pack(side='right',pady=5)
lbopen1=Tkinter.Label(fr1,text="",width=60)
lbopen1.pack()
fr12=Tkinter.Frame(fr1,width=60)
fr12.pack()
Buttshow=Tkinter.Button(fr12,text="show data matrix from txt-file",width=30,command=showDM)
Buttshow.pack(side='left',pady=5)
Buttshow2=Tkinter.Button(fr12,text="show data matrix from Excel-sheet",width=30,command=showdmExcel)
Buttshow2.pack(side='right',pady=5)
fr2a=Tkinter.Frame(hf)
fr2a.pack(pady=5)
frm=Tkinter.Frame(hf,width=60,height=10,relief="raised",bd=4)
frm.pack()
lbwarning=Tkinter.Label(frm,text="")
lbwarning.pack()
Butt1=Tkinter.Button(frm,text="AC-Basic calculations ",bg="cyan",width=40,command=ac_basics)
Butt1.pack()
Butt2=Tkinter.Button(frm,text="AC-advanced statistics ",bg="cyan",width=40,command=ac_adv_statistics)
Butt2.pack()
Butt3=Tkinter.Button(frm,text=" AC-rankings ",bg="cyan",width=40,command=ac_rankings)
Butt3.pack()
Butt4=Tkinter.Button(frm,text="AC-pattern-analysis ",bg="cyan",width=40,command=ac_pattern)
Butt4.pack()
Butt5=Tkinter.Button(frm,text="AC-Graphs, critical pairs ",bg="cyan",width=40,command=ac_graphs)
Butt5.pack()
##Butt6=Tkinter.Button(frm,text="AC-Excel-->export ",bg="cyan",width=40,command=ac_Excel)
##Butt6.pack()
buttexit=Tkinter.Button(hf,text=" Exit  ",bg="red", width=30,command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()


