#Brg umbau3
# Brg towardsavrank.py in "RainerVorstufe"
# Problem: u wird nicht erkannt
# 15.1.09 funktioniert
import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import Canvas
import os
from math import *

# Other procedures taken from antag2.py
# URL to get psyco.zip: http://www.voidspace.org.uk/python/modules.shtml
# brg 25.12.2011: open pdt-file
# brg 28.11.2011: warnings w.r.t. global statements . Improvements. 


global fn,objred

def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08, 25.12.2011
    #note: There may be conflicts with other moduls
    #source:-
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    global fn,dm,obj,prop,r,k
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    
    return 

def fileselect_PyHasse():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    #* 1.6.09
    # akt. 1.6.09, 25.12.2011
    # source: mainHD20.py
    global fn,r,k,dm,prop,obj
    fn=tkFileDialog.askopenfilename()
    r,k,dm,obj,prop=rmod2.raireadin5(fn)
    
    lbopen2.config(bg="yellow")
    lbopen2["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    return 

         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
   
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    

def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 14.1.08, 8.5.08, 28.12.2011
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global xred,objred,rred,eqm
    
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt,eqm=rmod2.equivcompactgr(r,k,dm,obj)    
    ###############################################################
    eqcl_act,dummy,dummy2=rmod2.deliver_readable_eqclasses(r, eqm,obj)
    tpeq=Tkinter.Toplevel(hf)
    teq=ScrolledText(tpeq,height=10, width=60)
    teq.pack()
    txt="Equivslence classes"+"\n"
    for i in range(0,len(eqcl_act)):
        if len(eqcl_act[i])>1:
            for i2 in range(0, len(eqcl_act[i])):
                txt+=str(eqcl_act[i][i2])+", "
            txt+="\n"
        else:
            pass
    txt+="\n"
    txt+="- - - e o f - - -  "+"\n"
    teq.insert("end",txt)
    
    return rred,k,xred,objred,obj,prop,txt           
     



def getPoset(xred):
  """ Procedure by Oliver Wienand to obtain the poset
  of a data matrix. The poset is described by a vector ,
  where any representative is a component. The value
  is the bit-code of all repreeseantants reachable.
  For example component 0 (object No 0) reaches object 2 and 3
  then 0*2power0 +0*2power1 + 1*2power2 + 1*2power3 = 12."""
  # Brg adapted 15.7.09
  n=len(xred)
  poset = [0] * len(xred)
  for k in range(0, len(xred)):
    first = xred[k]
    for l in range(0, len(xred)):
      if (k != l):
        i = 0
        second = xred[l]
        while ((first[i] <= second[i]) & (i < len(first) - 1)): #= eingefuegt
          i = i + 1
        if (i == len(first) - 1):
          if ((first[i] <= second[i]) & (first[i] <= second[i])): #= eingefuegt
            #print "k= ",k," l = ",l,"   poset = ",poset[k]
            poset[k] = poset[k] | 2**l
            #print "k= ",k,"  l= ",l,"  poset bitvertgleich ",poset[k]
  #print "final poset ",poset  #wer mit wem nach oben verbunden ist wird mit 2 hoch labelnr codiert
  # z.B. wenn 0 mit 1 3 und 4 verbunden ist, dann bekommt poset [0]: 1*2hoch1 + 1*2hoch3 und 1*2hoch4 als code.
  
  return poset,n

def getWitness(xred):
    """ Procedure by Oliver Wienand . getWitness is unclear to me
    it may be that u is the vector of a linear extension"""
    # Brg adapted 15.7.09
    global u
    poset,n=getPoset(xred)
    u = [-1] * len(poset)
    tmp = 0
    #print(poset)
    for k in range(0, len(poset)):
        i = 0
        while ((i in u) | (tmp & poset[i] != poset[i])):
            i = i + 1
        u[k] = i
        tmp = tmp + 2**i
    #print "in get Witness u ",u  
    return u

def getNameOfNode(v):
    """Procedure written by Oliver Wienand. In node the
    objects covering v are detected """
    node = list()
    while(v != 0):
        i = 0;
        while(2**i & v == 0):
            i = i + 1
        v = v - 2**i
        node.append(i + 1)
    return(node)


def getPosetCover(poset):
  """procedure written by O. Wienand: cover relatiuon """  
  cover = []
  for i in range(0, len(poset)):
    rel = getNameOfNode(poset[i])
    rest = getNameOfNode(poset[i])
    for k in rel:
      for j in getNameOfNode(poset[k-1]):
        try:
          rest.remove(j)
        except:
          pass
    cover.append(rest)
    nc=len(cover)
    #print rel
  return cover,nc

def facePoset(a, b, c, ni):
    """procedure written by O. Wienand"""
    
    poset,n=getPoset(xred)
    return(poset[ni] & a == poset[ni])  #this line I don't understand. In original program it is called with
                                        #out any argument

def computePaths(search_nodes, paths, terminals):
  """procedure written by O.Wienand"""  
  while (len(search_nodes) > 0):
    new_search = set()
    for v in search_nodes:
      for e in terminals[ v ]:
        paths[ e[1] ] = paths[ v ] + paths[e[1]]
        new_search.add(e[1])  #new_search is a set and here e[1] is added
    search_nodes = new_search
  #print "In computePaths  : No of paths = ",len(paths)  
  
  print("  No of computed paths : " + str(paths[v]))
  global lpth  
  lpth=paths[v]
    
def getPaths(start_v, terminals):
  """ procedure written by O.Wienand"""  
  paths = [0]*(len(terminals))
  paths[start_v] = 1
  computePaths([start_v], paths, terminals)
  #print "In getPaths:  ",len(paths)
  return(paths)


def computeRankFreq(paths, ipaths, nodes, initials, n):
  """procedure written by O. Wienand """  
  rank = 0
  ranks = [0] * n
  search_nodes = [nodes.index(0)]
  while (len(search_nodes) > 0):
    rank = rank + 1;
    new_search = set()
    for v in search_nodes:
      for e in initials[ v ]:
        ranks[ e[0] ] = ranks[ e[0] ] + paths[ e[1] ] * rank * ipaths[ v ]
        new_search.add(e[1])
    search_nodes = new_search
  return(ranks)

# The rule propagate

def propagate(cnodes, cedges, terminals, initials, wedges, pnodes):
  """procedure written by O. Wienand """  
  #print "Aufruf propagate "
  face=facePoset   #20.7.09
  edge_count = 0
  e = wedges[-1]
  del wedges[-1]
  edge_count = edge_count + 1
  terminals[e[1]].append((e[2], e[0]))
  initials[e[0]].append((e[2], e[1]))
  cedges.append((e[0],e[1]))
  for initial in initials[e[1]]:
    i = initial[0]
    if (i != e[2]):
      if (face(cnodes[e[0]], cnodes[e[0]]^cnodes[e[1]], 2**i, i)):
          mn = cnodes[e[0]] + 2**i
          ind = pnodes[e[3]].get(mn)
          edge_count = edge_count + 1
          if (ind == None):
            ind = len(cnodes)
            cnodes.append(mn)
            pnodes[e[3]][mn] = ind
            terminals.append([(i, e[0])])
            initials.append([])
            wedges.append((ind, initial[1], e[2], e[3] + 1))
          else:
            terminals[ind].append((i, e[0]))
          initials[e[0]].append((i, ind))
          cedges.append((e[0],ind))
    else:
      print("KJDKLSDJFKLDSJ")
  return(edge_count)

# Routine for initialization

def initSets(u):
  """procedure written by O. Wienand """  
  edge_count = 0
  pnodes = list()
  terminals = list()
  initials = list()
  cnodes = list()
  cedges = list()
  wedges = list()

  for i in range(0, len(u)):
    pnodes.append(dict())

  count = 0
  tmp = 0
  cnodes.append(tmp)
  terminals.append([])
  initials.append([])
  for i in u:
    tmp = tmp + 2**i
    cnodes.append(tmp)
    pnodes[count][tmp] = count + 1
    terminals.append([])
    initials.append([])
    wedges.append((count, count + 1, i, count))
    count = count + 1
  edge_count = edge_count + 1
  del wedges[-1]
  terminals[-1].append([u[-1],len(u)-1])
  initials[-2].append([u[-1],len(u)])
  cedges.append((len(u) - 1, len(u) - 0))
  return(cnodes, cedges, terminals, initials, pnodes, wedges, edge_count)

# The algorithm

def process(u):
  """ Procedure written by O. Wienand """  
  (cnodes, cedges, terminals, initials, pnodes, wedges, edge_count) = initSets(u)
  i = 0
  tpcompdetails=Tkinter.Toplevel(hf)
  tpcompdetails.title(' calculation details ')
  tcd=ScrolledText(tpcompdetails)
  tcd.pack()
  txtd=""
  txtd+=" Computational details  \n"
  txtd+=60*"="+"\n"
  
  while ((len(wedges) > 0) & (i < 10000000000000)):
    i = i + 1;
    if (i % 50000 == 0): 
       txtd+="\n  Running iteration    : \t" + str(i)
       txtd+="\n  Number of vertices   : \t" + str(len(cnodes))
       txtd+="\n  Number of edges      : \t" + str(edge_count)
       txtd+="\n  Number of wait edges : \t" + str(len(wedges))
       
    edge_count = edge_count + propagate(cnodes, cedges, terminals, initials, wedges, pnodes)
  
  txtd+="\n  Iteration needed     : " + str(i)
  txtd+="\n  Number of vertices   : " + str(len(cnodes))
  txtd+="\n  Number of edges      : " + str(edge_count)
  tcd.insert("end",txtd)   
  return(cnodes, cedges, initials, terminals, i, edge_count)


def actionPrintRankFreq():
  """ procedure written by O. Wienand """
  #brg modified 15.7.09, 10.11.2014
  global rankFreq, rkf, cnodes,initials
  n=rred
  paths=actionComputePaths(fn)
  ipaths=actionComputeIPaths(fn)
  rankFreq = computeRankFreq(paths, ipaths, cnodes, initials, n)
  
  lrf=len(rankFreq)  #ab hier: Brg Zusatz 12.7.09
  #print "dimension = ", dimension
  
  #print "No of paths = ",lpth
  #print "No of rank freq. (= nr of Obj.) ",lrf
  tpavrk=Tkinter.Toplevel(hf,width=60)
  tpavrk.title(' averaged ranks  ')
  tavrk=ScrolledText(tpavrk,width=60)
  tavrk.pack()
  txt=" averaged ranks (representative elements) : Method of Oliver Wienand \n"
  txt+=60*"="
  txt+="\n"
  rkf=[]
  for i in range(0,lrf):
      rkf.append(n+1 - 1.0*rankFreq[i]/(1.0*lpth))
      txt+=str(objred[i])+":\t"+str(round(rkf[i],3))+"\n"
  rkavext=rmod2.weak1(r, obj, objred, rkf,eqm)
  txt+=" averaged ranks (full object set) : Method of Oliver Wienand"+"\n"
  txt+=60*"="
  txt+="\n"
  rkf=[]
  for i in range(0,r):
      txt+=str(obj[i])+":\t"+str(round(rkavext[i],3))+"\n"
  txt+=" - - - e o f - - - "
  tavrk.insert("end",txt)
  return rkf    

def actionComputePaths(fn):
  """procedure written by O.Wienand"""
  #Brg modified 15.7.09
  rred,k1,xred,objred,obj,prop,txt=filecomp(fn)
  global paths
  actionComputeCell(xred)
  paths = getPaths(len(u), terminals)
  #print "in actionComputePaths: paths  ", paths
  return (paths)

def actionComputeIPaths(fn):
  """ procedure written by O.Wienand """
  #brg modified 15.7.09
  rred,k1,xred,objred,obj,prop,txt=filecomp(fn)
  global ipaths
  actionComputeCell(xred)
  ipaths = getPaths(0, initials)
  #print "inactionComputeIpaths: Ipaths  ",ipaths
  return (ipaths)

def actionComputeCell(xred):
    """ procedure written by O.Wienand """
    #Brg modified 15.7.09
    global cnodes, rankFreq, cedges, initials, terminals, iterations, edge_count, \
           paths, ipaths, n, weights, face
    (rankFreq, paths, ipaths, cnodes, cedges, initials, terminals,\
    weights, iterations, edge_count) = [None] * 10
    u=getWitness(xred)   #Baustelle
    (cnodes, cedges, initials, terminals, iterations, edge_count) = process(u)
    

def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension"
    # Brg 20.12.07, 28.12.07, 14.1.08 taken from mainHD3
    # If the number of representants > 30 then only the cover-matrix and the level-population
    #
    print "HD command was set..."
    global zeta2,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram or cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    rred,k,xred,objred,obj,prop,txt=filecomp(fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    Utot=0
    for i in range(0,rred):
        for j in range(0,rred):
            if zeta[i][j]==0 and zeta[j][i]==0:
                Utot+=0.5
    print "zeta-matrix and related quatities..."
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    print "HD is ongoing..."
    if n>60:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn+"\nU total = "+str(Utot))
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "  #25.12.2011
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)

def rkextsave():
    #brg 22.8.2014
    dummy1,dummy2,dummy3,dummy4,eqm_act = rmod2.equivcompactgr(r,k,dm,obj)
    print "eqm_act= ",eqm_act
    rkextended = rmod2.weak2(r,obj,objred,rkf, eqm_act)
    print "rkextended = ",rkextended
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save rkextended (extension '.txt' is recommended")
    f = open(fn,"w")
    f.write(str(len(rkextended))+"\n")
    for i in range(0, len(rkextended)):
        f.write(str(rkextended[i])+",")
    f.close


hf=Tkinter.Tk()
hf.title(' AverageRanks DeLOOF/O:WIENAND ')
lbavrank=Tkinter.Label(hf,text=" Distributive lattice and paths ",width=50)
lbavrank.pack(pady=5)
helpavrank=raioop2.brgabout(hf,"tp1","help_avrank.txt",5,\
            "Dec, 25th,2011"," help_avrank ", "white", "t1",80,5,ScrolledText)
    
aboutantag=raioop2.brgabout(hf,"tp1","about_avrank.txt",5,\
            "Dec, 25th,2011"," about_avrank ", "white", "t1",80,5,ScrolledText)    

fr1=Tkinter.Frame(hf,relief="sunken")
fr1.pack()

fr2=Tkinter.Frame(hf)
fr2.pack()

fr2a=Tkinter.Frame(fr2,width=60,height=50,relief="sunken",bd=4)
fr2a.pack(side="left",pady=5)

#In fr2a exclusively grid - geometry manager  (26.7.08)
buttsubmit=Tkinter.Button(fr2a,text="(1a) select and open (Excel-derived) file",width=25,bg="white",command=fileselect)
buttsubmit.grid(columnspan=2,row=1)
lbopen1=Tkinter.Label(fr2a,text="")
lbopen1.grid(columnspan=2,row=2)

fr2b=Tkinter.Frame(fr2,width=60,height=50,relief="sunken",bd=4)
fr2b.pack(side="right",pady=5)

#In fr2b exclusively grid - geometry manager  (26.7.08)
buttsubmit2=Tkinter.Button(fr2b,text="(1b) select and open (pdt) file",width=25,bg="white",command=fileselect_PyHasse)
buttsubmit2.grid(columnspan=2,row=1)
lbopen2=Tkinter.Label(fr2b,text="")
lbopen2.grid(columnspan=2,row=2)

frshow=Tkinter.Frame(hf)
frshow.pack()
buttshow=Tkinter.Button(frshow,text="(2b) show data matrix",width=25, command=showDM)
buttshow.grid(columnspan=3,row=4)

fr3=Tkinter.Frame(hf,width=60,height=200,relief="sunken",bd=4)
fr3.pack()
buttHD=Tkinter.Button(fr3,text="HD ",bg="cyan",width=25,command=HD)
buttHD.pack()
buttavrk=Tkinter.Button(fr3,text="Averaged ranks ",bg="cyan",width=25,command=actionPrintRankFreq)
buttavrk.pack()
buttsave = Tkinter.Button(fr3,text = "save the ranks \n(for a subsequent analysis)",bg="cyan",width=25, command=rkextsave)
buttsave.pack()
buttexit=Tkinter.Button(fr3,text= "exit ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()


