

import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import math

import Canvas
import os

# brg 7.11.2010 (Gent)
# avrkmut1.py
# BRG check with Karel's dat#
# brg 10.11.2010: correction
# brg 10.11.2010 extension
# brg 15.2.2013 cosmetics

def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08, 28.5.09
    #note: Taken from antag
    #source:-
    
    global fn,k0,r,dm,pro,ob,prop,obj,xred,objred,rred,zeta
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k0=rmod2.EXCELreadin4(fn)
    lbopen1.config(bg="yellow")
    lbopen1["text"]="sel. file : "+fn+"\n"+str(r)+" rows\n"+str(k0)+" columns"
    prop=rmod2.vecgentext1(k0)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k0):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################this part is of 21.12.07 #########
    rred,xred,objred,txt=rmod2.equivcompact(r,k0,dm,obj)    
    ###############################################################
   
    
    
    
    #global rred, objred,xred,obj
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    n=rred
    tpeqorig=Tkinter.Toplevel(hf)
    tpeqorig.title(' equivalence classes of the original DM ')
    teqorig=ScrolledText(tpeqorig,width=60,height=5)
    teqorig.pack()
    teqorig.insert("end",txt)
    #
    zetahilf=rmod2.comp(n,k0,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
            
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic2=Tkinter.Toplevel(hf)
    tpbasic2.title(' basic characteristics of the orig HD ')
    lbbasic2=Tkinter.Label(tpbasic2,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    global zeta2
    zeta2=rmod2.cover(n,tr,lext)
    
    if n>60:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
##        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
##        buttcover.pack()
        #print "zetamatrix"
        #rmod2.matout(rred,rred,zeta)

def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y            
         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def mutprobsimple(smaller,larger):
    # brg 16.2.2013
    for i in range(0,len(larger)):
        larger[i]=larger[i]-1
        smaller[i]=smaller[i]-1
        #print "i= ",i,"  larger= ",larger[i],"   smaller= ",smaller[i]
    # Bruggemann approach, see NERI 2002    
    mutprob=rmod2.marray(rred,rred)
    for i in range(0,rred):
       for j in range(0,rred):
           if i==j:
               mutprob[i][j]=1
           elif zeta[i][j]==1 and zeta[j][i]==0:
               mutprob[i][j]=0
           elif zeta[i][j]==0 and zeta[j][i]==1:
               mutprob[i][j]=1
           else:
               nenner=1.0*(smaller[i]+1.0)*(larger[j]+1.0)+1.0*(larger[i]+1.0)*(smaller[j]+1.0) 
               mutprob[i][j]=1.0*(smaller[i]+1.0)*(larger[j]+1.0)/nenner
    #print "mutprob-matrix"
    return mutprob
    
def mutprobCC(smaller,larger):
    #brg 16.2.2013
    for i in range(0,len(larger)):
        larger[i]=larger[i]-1
        smaller[i]=smaller[i]-1
        print "object ",objred[i],"  smaller  ",smaller[i],"   larger ",larger[i]
    print " "    
    Lxovery=rmod2.marray(rred,rred)
    LT=rmod2.marray(rred,rred)
    mutprobCCapprox=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for i1 in range(0,rred):
            if i==i1:
                mutprobCCapprox[i][i1]=1
            elif zeta[i][i1]==1 and zeta[i1][i]==0:
                mutprobCCapprox[i][i1]=0
            elif zeta[i][i1]==0 and zeta[i1][i]==1:
                mutprobCCapprox[i][i1]=1
            else:    
                for k in range(0,larger[i1]+1):
                    Lxovery[i][i1]+=rmod2.nueberk(smaller[i]+smaller[i1]+1+k,smaller[i])*rmod2.nueberk(larger[i]+larger[i1]-k,larger[i])

                LT[i][i1]= 1.0*rmod2.fakult(smaller[i]+larger[i]+1+smaller[i1]+larger[i1]+1)/(1.0*rmod2.fakult(smaller[i]+larger[i]+1)*1.0*rmod2.fakult(smaller[i1]+larger[i1]+1))
                mutprobCCapprox[i][i1]=(1.0*Lxovery[i][i1]/(1.0*LT[i][i1]))
    print "LT"
    rmod2.matout(rred,rred,LT)
    print " "
    print "Lxovery"
    rmod2.matout(rred,rred,Lxovery)

    print "mutprobCCapprox"
    rmod2.matout(rred,rred,mutprobCCapprox)
    print "----"
    return mutprobCCapprox        
    
   
def calc():
    #brg 7.11.2010, 15.2.2013, 16.2.2013
    #first step: counts of x: elements larger/ smaller than x
    global avrkmut,mutprob, genmutprob
    try:
        schalt=int(eschalt.get())
    except:
        schalt=0   #mutprobsimpl (Bruggemann formula)
    larger=rmod2.matrixrowsum(zeta,rred,rred)
    smaller=rmod2.matrixcolsum(zeta,rred,rred)
        #rmod2.matout(rred,rred,mutprob)
    if schalt==0:
        mutprob=mutprobsimple(smaller,larger)
    else:
        mutprob=mutprobCC(smaller,larger)
    
    avrkBrg=rmod2.matrixrowsum(mutprob,rred,rred)
    txt=" Average height (rank) "+"\n"
    txt+="a) simply rowsum of mutprob-matrix"+"\n"
    if schalt==0:
        txt+="mutprob-approximation after Bruggemann-formula (O(x)/(F(x))/(O(x)/F(x) + (O(y)/F(y)))"
    else:
        txt+="mutprob-approximation after LPOM0-CC-approximation "
    txt+="\n"
    
    txt+="\n"+60*"="+"\n"
    for i in range(0,rred):
        txt+=str(objred[i])+" :"+str(round(avrkBrg[i],3))+"\n"
    txt+=3*"\n"
        
    genlarger=rmod2.matrixrowsum(mutprob,rred,rred)
    gensmaller=rmod2.matrixcolsum(mutprob,rred,rred)
    
    if schalt==0:
        genmutprob=mutprobsimple(gensmaller,genlarger)
    else:
        genmutprob=mutprobCC(gensmaller,genlarger)
    
    #print "generalized mutprob "
    #rmod2.matout(rred,rred,genmutprob)
    avrkmut=rmod2.vecgen1(rred)
    for j in range(0,rred):
        avrkmut[j]=smaller[j]+1.0
        for i in range(0,rred):
            if zeta[i][j]==0 and zeta[j][i]==0:
                avrkmut[j]+=genmutprob[i][j] #colsum of genmutprob
            else:
                avrkmut[j]+=0
    print "final result: avrk after K.DeLoof et al,2011"
    for i in range(0,rred):
        print "i=",i,"  object= ",objred[i],"  avrk= ",round(avrkmut[i],3)
    tpavrk=Tkinter.Toplevel(hf)
    tavrk=ScrolledText(tpavrk,width=60,height=10)
    tavrk.pack()
    txt+=" Averaged ranks after K.DeLoof et al., 2011"
    if schalt==0:
        txt+=" Simple Brg-Formula "
    else:
        txt+=" LPOM-CC-model "
    txt+="\n"+60*"="+"\n"
    for i in range(0,rred):
        txt+=str(objred[i])+" :"+str(round(avrkmut[i],3))+"\n"
    txt+="\n"
    txt+="- - - - e o f - - - -"
    tavrk.insert("end",txt)

def show_mutprob_genmutprob():
    #brg 15.2.2013, 31.03.2017
    tpmutgenmut=Tkinter.Toplevel(hf)
    tpmutgenmut.title("show (gen) mutual probabilities ")
    tmutgenmut=ScrolledText(tpmutgenmut,width=60,height=10)
    tmutgenmut.pack()
    txt=" Details of calculation "+"\n"
    txt+=60*"="+"\n"
    txt+=" Mutprob-matrix prob that row >= col "+"\n"
    txt+="\t"
    for i1 in range(0,rred):
            txt+=str(objred[i1])+"\t"
    txt+="\n"
    for i in range(0,rred):
        txt+=str(objred[i])+":\t "
        for i1 in range(0,rred):
            txt+=str(round(mutprob[i][i1],3))+"\t"
        txt+="\n"
    txt+="\n"
    txt+="Generalized mutprob (after De Loof et al., 2011)"+"\n"
    txt+="\t"
    for i1 in range(0,rred):
            txt+=str(objred[i1])+"\t"
    txt+="\n"
    for i in range(0,rred):
        txt+=str(objred[i])+":\t "
        for i1 in range(0,rred):
            txt+=str(round(genmutprob[i][i1],2))+"\t"
        txt+="\n"
    txt+="\n"
    txt+="\n"
    txt+="   -  -  -   e o f  -  -  -"
    tmutgenmut.insert("end",txt)
    
def ranking():
    # brg 10.11.2010 in Bruessel
    dmavrk=rmod2.marray(rred,2)
    for i in range(0,rred):
        dmavrk[i][0]=avrkmut[i]
        dmavrk[i][1]=avrkmut[i] #formally as matrix
    #############################this part is of 21.12.07 #########
    rred2,xred2,objred2,txt2e=rmod2.equivcompact(rred,2,dmavrk,objred)    
    ###############################################################
   
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Ranking ')
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    n=rred2
    tpeqorig2=Tkinter.Toplevel(hf)
    tpeqorig2.title(' equivalence classes of the original DM ')
    teqorig=ScrolledText(tpeqorig2,width=60,height=5)
    teqorig.pack()
    teqorig.insert("end",txt2e)
    #
    zetahilf=rmod2.comp(n,2,xred2)
    zeta=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):
        for j in range(0,rred2):
            zeta[i][j]=zetahilf[j][i]
            
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic2=Tkinter.Toplevel(hf)
    tpbasic2.title(' basic characteristics of the orig HD ')
    lbbasic2=Tkinter.Label(tpbasic2,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred2[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred2[revlext[i]]+" < "
        else:
            txt2+=objred2[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2e)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    global zeta2
    zeta2=rmod2.cover(n,tr,lext)
    
    if n>60:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
##        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
##        buttcover.pack()
        #print "zetamatrix"
        #rmod2.matout(rred,rred,zeta)

        

hf=Tkinter.Tk()
hf.title('--   GUI averaged ranks after K.De Loof et al., 2011   -- ')


aboutmainHD=raioop2.brgabout(hf,"tp1","about_avrkmut.txt",3,\
            "Nov., 07th, 2010"," about avrkmut ", "white", "t1",120,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_avrkmut.txt",3,\
            "Nov.,07th, 2010"," help_avrkmut ", "white", "t1",120,10,ScrolledText)
    
lb0=Tkinter.Label(hf,text="___________________________________________________________________________________________ ")
lb0.pack()
buttHD=Tkinter.Button(hf,text="file  open and HD ",width=25,bg="cyan",command=fileselect)
buttHD.pack()
lbopen1=Tkinter.Label(hf,text="")
lbopen1.pack()
fr2a=Tkinter.Frame(hf)
fr2a.pack()
buttshow=Tkinter.Button(hf,text="show data matrix",bg="cyan",width=25,command=showDM)
buttshow.pack()
frmethode=Tkinter.Frame(hf,bd=2,relief="sunken")
frmethode.pack()
lbmethode=Tkinter.Label(frmethode,text="0 for simple approx., 1 for CC-approximation ")
lbmethode.pack()
eschalt=Tkinter.Entry(frmethode,width=2)
eschalt.pack()
buttcalc=Tkinter.Button(hf,text="calculation",bg="cyan",width=25,command=calc)
buttcalc.pack()
buttshowmutprob=Tkinter.Button(hf,text="show mutprob \nand genmutprob-matrices ",width=25,command=show_mutprob_genmutprob)
buttshowmutprob.pack()
buttranking=Tkinter.Button(hf,text="ranking as HD",width=25,bg="cyan",command=ranking)
buttranking.pack()

buttexit=Tkinter.Button(hf,text="  exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=5)
hf.mainloop()
