import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2

# brg 1.12.17
# brg 11.12.17


###### editfenster ### 08.09.17 #####
def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    # brg 26.11.17
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xredh,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "txteq = ", txteq
    xred=rmod2.matrixnorm(rred,k,xredh)

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    # brg 26.11.17
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xredh,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq
    xred=rmod2.matrixnorm(rred,k,xredh)




def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 26.11.17
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xredh,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq
    xred=rmod2.matrixnorm(rred,k,xredh)

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013, 26.11.17
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xredh,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq
    xred=rmod2.matrixnorm(rred,k,xredh)

##### end of edit_window ### 29.8.2013 ####
def show_dm():
    #brg taken from fuzzy_FCA1.py
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08, 21.10.17, 01.12.17
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" Gen. info. about the \n[0,1]-colwise normalized data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,rred):
        txt1+=" "+objred[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,rred):
        txt3+=objred[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(xred[i][j],2))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def HD(dm, k, labels):
    # brg 26.7.2013, 29.8.2013, 2.11.16, 21.11.17
    # Rearrangement as a dunctional procedure, getting data by the procedure input list
    TpHD=Tkinter.Toplevel(hf)
    TpHD.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(TpHD,width=200,height=300)
    freq.pack()
    nHD=len(labels)    #
    zetahilf=rmod2.comp(nHD,k,dm)  #zeta matrix with col<row
    zeta=rmod2.marray(nHD,nHD)
    for i1 in range(0,nHD):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,nHD):
            zeta[i1][i2]=zetahilf[i2][i1]
    
    Utotal = rmod2.incompzeta(nHD,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(nHD,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(nHD,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(nHD,adjc,lext)
       
    
    cov=rmod2.cover(nHD,tr,lext)

    if nHD>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(nHD,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(nHD,nHD)
        geomy=rmod2.marray(nHD,nHD)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=labels[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        return cov


def inputfield():
    #brg 01.12.17, 11.12.17
    global cto, etotal,r
    flag=0
    try:
        cto=int(e_count_of_total_orders.get())
    except:
        cto=2
        flag+=1
    if flag==0:   
        print "User defined: cto = ",cto
    else:
        print "By default: cto = ",cto
    
    r=int(e_r.get())
    print "r = ",r
    etotal=rmod2.vecgen1(cto)
    tp1=Tkinter.Toplevel(hf)
    lbinputfield=Tkinter.Label(tp1,text="Number of objects must be the same,\n\
                               sorted increasingly, separated by ',' ")
    lbinputfield.pack()
    for i in range(0,cto):
        etotal[i]=Tkinter.Entry(tp1,width=40)
        etotal[i].pack()
    #print etotal

def calc_cover(cov, labels):
    #brg 21.11.17
    #rearrangement to a functional procedure
    Tpcover = Tkinter.Toplevel(hf)
    Tpcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(Tpcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    ncc = len(labels)
    for i1 in range(0, ncc):
        txt3 += "\n" + str(labels[i1]) + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, ncc):
            if i1!=i2:
                if cov[i1][i2] == 1:
                    txt3 += " " + str(labels[i2]) + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(Tpcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
        

def calc_HD():
    #brg 01.12.17
    global cov
    hilf=rmod2.vecgen1(r)
    order=rmod2.vecgen1(cto)
    dmorder=rmod2.marray(r,cto)
    for i in range(0,cto):
        hilf[i]=etotal[i].get()
        order[i]=hilf[i].split(",")
    print "order"
    rmod2.strmatout(cto,r,order)
    print ""
    obj=rmod2.vecgen1(r)
    for j in range(0,r):
        obj[j]=order[0][j]
    print obj    
    numorder=rmod2.marray(cto,r)
    for i in range(0,cto):
        for j in range(0,r):
            numorder[i][j]=order[i].index(obj[j])
            
    print "numorder"
    rmod2.matout(cto,r,numorder)
    dmorder=rmod2.mattransp(cto,r,numorder)
    print "dmorder "
    rmod2.matout(r,cto,dmorder)
    cov=HD(dmorder,cto,order[0])
    calc_cover(cov,obj)        
        






## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' combi total orders ')
aboutfuzzy_FCA=raioop2.brgabout(hf,"tp1","about_combitotalorders.txt",1,\
            "Dec. the 01s, 2017"," about combi. total orders ", "white", "t1",120,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_combitotalorders.txt",1,\
            "Dec., the 01s, 2017"," help_combi. total orders ", "white", "t1",120,5,ScrolledText)
global e_count_of_total_orders,e_r,fr    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
lb0=Tkinter.Label(fr,text="Insert how many total orders (default: 2) ")
lb0.pack()
e_count_of_total_orders=Tkinter.Entry(fr,width=5)
e_count_of_total_orders.pack()
lb1=Tkinter.Label(fr,text="How many objects? ")
lb1.pack()
e_r=Tkinter.Entry(fr,width=5)
e_r.pack()
##lb2=Tkinter.Label(fr,text="the order in the first entry will be used for referencing ")
##lb2.pack()
buttinputfield=Tkinter.Button(fr,text="Open inputfield ",width=45,bg="cyan",command=inputfield)
buttinputfield.pack()
buttcalc_HD=Tkinter.Button(fr,text="calc Hasse diagram ",width=45,bg="cyan",command=calc_HD)
buttcalc_HD.pack()
buttexit=Tkinter.Button(fr,text="Exit ",bg="red",bd=5,width=10,command=hf.destroy)
buttexit.pack()
hf.mainloop()
