import rmod2
import itertools
import random
import Tkinter
import Canvas
import tkFileDialog
from ScrolledText import *
import raioop2
import math

# brg 4.8.2012 combsimilarity
# brg 18.8.2012 combination of single attributes and their proximities
# brg 22.2.2013, 24.3.2013 Beginning the rearrangements to statistical testing
# brg 27.3., 28.3. 2013 Final programming work
# brg 7.5.2013 in attatt_eval (searchtabelle: xu is the inoput in that routine and is nemp (number of objects)
# brg 17.8.2013 bug eliminated (in att-att-analysis)
# brg 26.1.2014 controlling prints


def Scherbsimulation(perm):
    # brg 24.3.2013
    # Hagen Scherb: Simulation of n*2-dm : 1000 MC-runs
    # perm==1 then permutation (basis of simulation: attributes continuous in concept)
    # perm=0  then with ties (basis: attributes with intger values)
    
    # n mean std std error
    # Tabelle1: permutation
    tabelle1=[[2,0.50,0.50,0.35],[3,1.48,0.97,0.56],[4,2.87,1.47,0.74],[5,5.03,2.05,0.92],\
              [6,7.44,2.68,1.09],[7,10.47,3.30, 1.25],[8,14.02,3.95,1.40],[9,17.77,4.88,1.63],\
              [10,22.60,5.68,1.80],[20,95.57,15.30,3.42],[30,216.75,28.19,5.15],[40,390.14,44.67,7.06],\
              [50,614.30,61.13,8.65],[60,881.34,78.49,10.13],[70,1210.07,102.48,12.25],[80,1572.58,117.55,13.14],\
              [90,2000.64,144.41,15.22],[100,2473.20,171.93,17.19],[200,9943.01,470.56,33.27],[300,22445.20,856.74,49.46],\
              [400,39835.30,1358.54,67.93],[500,62330.30,1910.72,85.45]]
    tabelle2=[[2,1.10,0.62,0.44],[3,2.67,1.07,0.62],[4,4.73,1.52,0.76],[5,7.28,2.04,0.91],[6,10.22,2.66,1.09],[7,13.76,3.30,1.25],\
              [8,17.63,3.90,1.38],[9,22.25,4.59,1.53],[10,27.27,5.80,1.83],[20,105.33,15.15,3.39],[30,233.60,28.70,5.24],\
              [40,407.77,42.94,6.79],[50,639.34,59.01,8.34],[60,913.10,78.26,10.10],[70,1247.55,100.06,11.96],\
              [80,1622.55,120.50,13.47],[90,2041.80,139.46,14.70],[100,2528.33,166.64,16.66],[200,10064.51,491.13,34.73],\
              [300,22582.13,870.54,50.26],[400,40107.23,1289.65,64.48],[500,62602.57,1838.90,82.24]]
    if perm==1:
        return tabelle1
    else:
        return tabelle2


def combianalysis(v):
    #dummy to simulate an analysis
    #with the outcome of itertools.comnbinations
    #in real application: the problem specific procedure
    result=sum(v)
    return result

def simiorigdm():
    # brg 6.8.2012
    # standard similarity between dm1 and dm2 (as done in similarity10_1)
    # dm 1
    qob1=rmod2.marray(r1,r1)
    ob1=rmod2.comp(r1,k1,y1)
    rmod2.qualcomp(r1,ob1,qob1)

    # dm 2
    qob2=rmod2.marray(r2,r2)
    ob2=rmod2.comp(r2,k2,y2)
    rmod2.qualcomp(r2,ob2,qob2)

   #standard similarity as in similarity10_1
    r=r1
    if r!=r1:
        print "#######!!!!#####! "
    simistandard=rmod2.similarity1(r,qob1,qob2)
    isodm1dm2=1.0*simistandard[0]/(r*(r-1.0))
    antidm1dm2=1.0*simistandard[1]/(r*(r-1.0))
    weakdm1dm2=1.0*simistandard[2]/(r*(r-1.0))
    indiffdm1dm2=1.0*simistandard[3]/(r*(r-1.0))
    equaldm1dm2=1.0*simistandard[4]/(r*(r-1.0))
    return isodm1dm2,antidm1dm2,indiffdm1dm2,weakdm1dm2,equaldm1dm2
    

def selfsimilarity():
    #* brg 5.8.2012
    # self-similarities
    
    # dm 1
    res_ss1=rmod2.vecgen1(5)
    objx1s=rmod2.marray(r1,r1)
    quobx1s=rmod2.marray(r1,r1)
    objx1s=rmod2.comp(r1,k1,y1)
    rmod2.qualcomp(r1,objx1s,quobx1s)

    #start with analysis: derivation of quoby
    objx2s=rmod2.marray(r1,r1)
    quobx2s=rmod2.marray(r1,r1)
    objx2s=rmod2.comp(r1,k1,y1)
    rmod2.qualcomp(r1,objx2s,quobx2s)

   

    simiself1=rmod2.similarity1(r1,quobx1s,quobx2s)
    isoss1=1.0*simiself1[0]/(r1*(r1-1.0))
    antiss1=1.0*simiself1[1]/(r1*(r1-1.0))
    weakss1=1.0*simiself1[2]/(r1*(r1-1.0))
    indiffss1=1.0*simiself1[3]/(r1*(r1-1.0))
    equalss1=1.0*simiself1[4]/(r1*(r1-1.0))
    res_ss1[0]=isoss1
    res_ss1[1]=antiss1
    res_ss1[3]=weakss1
    res_ss1[2]=indiffss1
    res_ss1[4]=equalss1

    
    # now selfsimilarity with dm 2
    res_ss2=rmod2.vecgen1(5)
    objx3s=rmod2.marray(r2,r2)
    quobx3s=rmod2.marray(r2,r2)
    objx3s=rmod2.comp(r2,k2,y2)
    rmod2.qualcomp(r2,objx3s,quobx3s)

    #start with analysis: derivation of quoby
    objx4s=rmod2.marray(r2,r2)
    quobx4s=rmod2.marray(r2,r2)
    objx4s=rmod2.comp(r2,k2,y2)
    rmod2.qualcomp(r2,objx4s,quobx4s)

    
    simiself2=rmod2.similarity1(r2,quobx3s,quobx4s)
    #print "self-similarity dm2 ",simiself2
    isoss2=1.0*simiself2[0]/(r2*(1.0*r2-1.0))
    antiss2=1.0*simiself2[1]/(r2*(1.0*r2-1.0))
    weakss2=1.0*simiself2[2]/(r2*(1.0*r2-1.0))
    indiffss2=1.0*simiself2[3]/(r2*(1.0*r2-1.0))
    equalss2=1.0*simiself2[4]/(r2*(1.0*r2-1.0))
    res_ss2[0]=isoss2
    res_ss2[1]=antiss2
    res_ss2[3]=weakss2
    res_ss2[2]=indiffss2
    res_ss2[4]=equalss2
    return res_ss1,res_ss2

def calcexact(classanz,r,k1,k2,dm_remaining,dm_to_be_sampled):
    #  brg4.8.2012, 13.12.2012
    global veciso,vecanti,vecindiff,vecweakiso,vecequal,nzexact,exact
    import itertools
    exact=True
    nzexact=classanz
    propstochsim=[]
    for j in range(0,max(k1,k2)):
        propstochsim.append(j)
        
    
    dmnew=rmod2.marray(r,min(k1,k2))
    
    
    veciso=rmod2.vecgen1(classanz)
    vecanti=rmod2.vecgen1(classanz)
    vecindiff=rmod2.vecgen1(classanz)
    vecweakiso=rmod2.vecgen1(classanz)
    vecequal=rmod2.vecgen1(classanz)
    
    normalizer=1.0*r*(1.0*r-1.0)
    vec_comb=itertools.combinations(propstochsim,min(k1,k2)) #combinatorial generation of ksample - tuples from propstochsim
    countsim=0
    for i in range(0,classanz):
        zahl=0
        # dmnew r as the original matrix, but now ksample columns. ksample=min(k1,k2)
        for j in vec_comb.next():
            for i1 in range(0,r):
                dmnew[i1][zahl]=dm_to_be_sampled[i1][j]
            zahl+=1
        
        #now a matrix is obtained having the same number (randomly selected) of attributes as dm_remaining
        # start with analysis: derivation of quobx
        objx1=rmod2.marray(r,r)
        quobx1=rmod2.marray(r,r)
        objx1=rmod2.comp(r,min(k1,k2),dm_remaining)
        rmod2.qualcomp(r,objx1,quobx1)
    
        #start with analysis: derivation of quoby
        objx2=rmod2.marray(r,r)
        quobx2=rmod2.marray(r,r)
        objx2=rmod2.comp(r,min(k1,k2),dmnew)
        rmod2.qualcomp(r,objx2,quobx2)
    

        #heart of similarity analysis:
        # Based on quobx and quoby the sim-matrix will be prepared for each i (run through all attribute combinations
    
    
        simistoch=rmod2.similarity1(r,quobx1,quobx2)
        
        veciso[i]=simistoch[0]
        #print "i= ",i,"  veciso= ",veciso[i]
        vecanti[i]=simistoch[1]
        print "i= ",i,"  vecanti = ",vecanti[i]
        vecweakiso[i]=simistoch[2]
        print "i= ",i,"  vecweakiso= ",vecweakiso[i]
        vecindiff[i]=simistoch[3]
        print "i= ",i,"  vecindiff =",vecindiff[i]
        vecequal[i]=simistoch[4]
        countsim+=1
        if classanz!=countsim:
            print "classanz= ",classanz,"   countsim= ",countsim
    #in each run i=0 to classanz a combination of min(k1,k2) attributes out of max(k1,k2) attr. is selected
    #the dmnew generated
    #and the similarity profile of the posets of dm_remaining and dmbew calculated
    # Now the characteristica of this distribution: min, av and max
    
    barth=[]
    print "veciso"
    for i in range(0,classanz):
        barth.append(".")
        print veciso[i]," ",
    print " "    
    app=raioop2.brgbardist(hf,"tpclassiso",classanz,veciso,"Distribution iso",35,2,2)
    app.ausgabe()
    app2=raioop2.brgbardist(hf,"tpclassanti",classanz,vecanti,"Distribution anti ",35,2,2)
    app2.ausgabe()
    app3=raioop2.brgbardist(hf,"tpclassindiff",classanz,vecindiff,"Distribution indiff",35,2,2)
    app3.ausgabe()
    #resvec in the order min,av,max for iso, anti, indiff, weakiso, equal
    resvec=rmod2.vecgen1(15)    
    aviso=1.0*sum(veciso)/classanz/normalizer
    resvec[1]=aviso
    miniso=min(veciso)/normalizer
    resvec[0]=miniso
    maxiso=max(veciso)/normalizer
    resvec[2]=maxiso
    avanti=1.0*sum(vecanti)/classanz/normalizer
    resvec[4]=avanti
    minanti=min(vecanti)/normalizer
    resvec[3]=minanti
    maxanti=max(vecanti)/normalizer
    resvec[5]=maxanti
    avindiff=1.0*sum(vecindiff)/classanz/normalizer
    resvec[7]=avindiff
    minindiff=min(vecindiff)/normalizer
    resvec[6]=minindiff
    maxindiff=max(vecindiff)/normalizer
    resvec[8]=maxindiff
    avweak=1.0*sum(vecweakiso)/classanz/normalizer
    resvec[10]=avweak
    minweak=min(vecweakiso)/normalizer
    resvec[9]=minweak
    maxweak=max(vecweakiso)/normalizer
    resvec[11]=maxweak
    avequal=1.0*sum(vecequal)/classanz/normalizer
    resvec[13]=avequal
    minequal=min(vecequal)/normalizer
    resvec[12]=minequal
    maxequal=max(vecequal)/normalizer
    resvec[14]=maxequal
    return resvec


def calcestim(nrand,r,k1,k2,dm_remaining,dm_to_be_sampled):
    # brg 4.8.2012, 13.12.2012
    # nrand number of trials
    # r number of rows in the dm
    # k1 number of attributes in the 1.dm
    # k2 number of attributes in the 2. dm
    # dm_remaining the dm with the smaller set of attributes
    # dm_to_be_sampled the dm with the greater number of
    # ... attributes
    global veciso,vecanti,vecindiff,vecweakiso,vecequal,nzest,exact
    exact=False
    nzestim=nrand
    veciso=rmod2.vecgen1(nrand)
    vecanti=rmod2.vecgen1(nrand)
    vecindiff=rmod2.vecgen1(nrand)
    vecweakiso=rmod2.vecgen1(nrand)
    vecequal=rmod2.vecgen1(nrand)
    vec=rmod2.vecgen1(nrand)

    normalizer=1.0*r*(1.0*r-1.0)

    for i in range(0,nrand): #number of stochastic samplings
        raset=set([])
        zahl=0
        while len(raset)<min(k1,k2):   #generation of random set of attributes
            raset.add(random.randint(0,max(k1,k2-1))) # out of columns 0,1,2,...,max(k1,k2)-1 
        
        v1=[]
        for i2 in raset:
            v1.append(i2)
        
        dmnew=rmod2.marray(r,min(k1,k2))
        for j in v1:
            for i1 in range(0,r):
                dmnew[i1][zahl]=dm_to_be_sampled[i1][j]
            zahl+=1
        
        #now a matrix is obtained having the same number (randomly selected) of attributes as dm_remaining
        # start with analysis: derivation of quobx
        objx1=rmod2.marray(r,r)
        quobx1=rmod2.marray(r,r)
        objx1=rmod2.comp(r,min(k1,k2),dm_remaining)
        rmod2.qualcomp(r,objx1,quobx1)
    
        #start with analysis: derivation of quoby
        objx2=rmod2.marray(r,r)
        quobx2=rmod2.marray(r,r)
        objx2=rmod2.comp(r,min(k1,k2),dmnew)
        rmod2.qualcomp(r,objx2,quobx2)
    

        #heart of similarity analysis:
        # Based on quobx and quoby the sim-matrix will be prepared for each i (run through all attribute combinations
    
    
        simistoch=[]   #preparation of similarity matrix
        for i4 in range(0,12):  #preparation of similarity matrix
            simistoch.append(0)

        simistoch=rmod2.similarity1(r,quobx1,quobx2)
        
        veciso[i]=simistoch[0]
        print "i= ",i,"  veciso= ",veciso[i]
        vecanti[i]=simistoch[1]
        print "i= ",i,"  vecanti = ",vecanti[i]
        vecweakiso[i]=simistoch[2]
        print "i= ",i,"  vecweakiso= ",vecweakiso[i]
        vecindiff[i]=simistoch[3]
        print "i= ",i,"  vecindiff =",vecindiff[i]
        vecequal[i]=simistoch[4]


    #in each run i=0 to classanz a combination of min(k1,k2) attributes out of max(k1,k2) attr. is selected
    #the dmnew generated
    #and the similarity profile of the posets of dm_ramaining and dmbew calculated
    # Now the characteristica of this distribution: min, av and max     

    barth=[]
    print "veciso"
    for i in range(0,classanz):
        barth.append(".")
        print veciso[i]," ",
    print " "    
    app=raioop2.brgbardist(hf,"tpclassiso",classanz,veciso,"est. Distribution iso",35,2,2)
    app.ausgabe()
    app2=raioop2.brgbardist(hf,"tpclassanti",classanz,vecanti,"est. Distribution anti ",35,2,2)
    app2.ausgabe()
    app3=raioop2.brgbardist(hf,"tpclassindiff",classanz,vecindiff,"est. Distribution indiff",35,2,2)
    app3.ausgabe()

        
    #resvec in the order min,av,max for iso, anti, indiff, weakiso, equal
    resvec=rmod2.vecgen1(15)    
    aviso=1.0*sum(veciso)/nrand/normalizer
    resvec[1]=aviso
    miniso=min(veciso)/normalizer
    resvec[0]=miniso
    maxiso=max(veciso)/normalizer
    resvec[2]=maxiso
    avanti=1.0*sum(vecanti)/nrand/normalizer
    resvec[4]=avanti
    minanti=min(vecanti)/normalizer
    resvec[3]=minanti
    maxanti=max(vecanti)/normalizer
    resvec[5]=maxanti
    avindiff=1.0*sum(vecindiff)/nrand/normalizer
    resvec[7]=avindiff
    minindiff=min(vecindiff)/normalizer
    resvec[6]=minindiff
    maxindiff=max(vecindiff)/normalizer
    resvec[8]=maxindiff
    avweak=1.0*sum(vecweakiso)/nrand/normalizer
    resvec[10]=avweak
    minweak=min(vecweakiso)/normalizer
    resvec[9]=minweak
    maxweak=max(vecweakiso)/normalizer
    resvec[11]=maxweak
    avequal=1.0*sum(vecequal)/nrand/normalizer
    resvec[13]=avequal
    minequal=min(vecequal)/normalizer
    resvec[12]=minequal
    maxequal=max(vecequal)/normalizer
    resvec[14]=maxequal
    return resvec

def savecom():
    # brg 13.12.2012
    # select file and stores the vectors iso, anti, indiff, weakiso, equal
    fnvec=tkFileDialog.asksaveasfilename(parent=hf,title="save the distributions of iso,..., equal")
    if exact:
        nz=nzexact
    else:
        nz=nzest
    f=open(fnvec,"w")
    f.write("number of cases = "+str(nz)+"\n")
    f.write("iso"+", "+"anti "+", "+"indiff"+", "+"weak iso"+", "+"equal"+"\n")
    for i in range(0,nz):
        f.write(str(veciso[i])+", "+str(vecanti[i])+", "+str(vecindiff[i])+", "+str(vecweakiso[i])+", "+str(vecequal[i])+"\n")
    f.write("\n")
    
    
    f.close



def simi_fileselect():
    """ file open 1, file open 2"""
    # Brg 15.1.08
    #*:15.1.08
    #akt: 15.1.08
    #note: a variant of fileselect, used in other HD programs, taken from similarity10
    #source:-
    
    global y1,y2,obj1,obj2,prop1,prop2,r,k1,k2,fn1,fn2,r1,r2
    fn1=tkFileDialog.askopenfilename(title="matrix with less attributes")
    fn2=tkFileDialog.askopenfilename(title="matrix with equal or more attributes")

    
    y1,ob1,pro1,r1,k1=rmod2.EXCELreadin4(fn1)
    y2,ob2,pro2,r2,k2=rmod2.EXCELreadin4(fn2)
    obj1=[]
    for i in range(0,r1):
        obj1.append(ob1[i+1])
    obj2=[]
    for i in range(0,r2):
        obj2.append(ob2[i+1])
    print "obj1= ",obj1
    print "obj2= ",obj2
    prop1=[]
    for j in range(0,k1):
        prop1.append(pro1[j+1])
    prop2=[]
    for j in range(0,k2):
        prop2.append(pro2[j+1])    
    # it may be that there are the same objects but in different order in the two different files
    tp1=Tkinter.Toplevel(hf)
    tp1.title('open/select')
    txtopen=" opened file1 with "+str(r1)+" rows and "+str(k1)+" columns\n and file2 with "+str(r2)+" rows and "+str(k2)+"  columns"
    lbfileselect=Tkinter.Label(tp1, bg="yellow",text = txtopen)
    lbfileselect.pack()
    if r1!=r2:
        lberror=Tkinter.Label(tp1,bg="yellow",text="++++ error : unequal number of objects +++"\
                              ,font=14 )
        lberror.pack()
        buttexit=Tkinter.Button(tp1,text=" quit ",command=hf.destroy)
        buttexit.pack()
    else:
        r=r1
                                
    return


def showmatrices():
    # brg 4.8.2012
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack(expand=1,fill="both")
    showDM(k1,r1,obj1,prop1,y1,tfile)
    showDM(k2,r2,obj2,prop2,y2,tfile)
    


def showDM(k,r,obj,prop,matrix,tfile):
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 4.8.2012
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(matrix[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def Hasse():
    # brg 4.8.2012
    hfhd=rmod2.vecgen1(2)
    cvhd=rmod2.vecgen1(2)
    hfhd[0]=Tkinter.Toplevel(hf)
    hfhd[1]=Tkinter.Toplevel(hf)
    txthd= " Hassediagrams of "
    hfhd[0].title(txthd+" dm1 ")
    hfhd[1].title(txthd+" dm2 ")
    cvhd[0]=Tkinter.Canvas(hfhd[0])
    cvhd[1]=Tkinter.Canvas(hfhd[1])
    cvhd[0].pack()
    cvhd[1].pack()
    HD(fn1,r1,k1,prop1,obj1,y1,hfhd[0],cvhd[0])
    HD(fn2,r2,k2,prop2,obj2,y2,hfhd[1],cvhd[1])
    

def HD(fn,r,k,prop,obj,dm,hfhd,cv):
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 200 then only the cover-matrix and the level-population
    #
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,txteq,neq=rmod2.equivcompactgr(r,k,dm,obj)
    txteqvec=txteq.split("\n")
    n=rred
    labeq=Tkinter.Label(hfhd,text="file = "+str(fn)+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    utotal=0
    for i in range(0,n):
        for i2 in range(0,n):
            if zeta[i][i2]==0 and zeta[i2][i]==0 and i!=i2:
                utotal+=0.5

    comparabilities=0
    for i in range(0,n):
        for i2 in range(0,n):
            if zeta[i][i2]==1 and i!=i2:
                comparabilities+=1
    
    #One linear extension (based on levels)
    

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Level pop. of'+str(fn))
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1=str(fn)+"\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(tplev,width=60, height=2)
    tlinext.pack(expand=1,fill="both")
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    cov=rmod2.cover(n,tr,lext)

    if n>200:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(hfhd,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv.config(width=actwidth,height=actheight,bg="white")
        
       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,\
                               fill="white",tags="object_"+str(objred[lobj[i][j]]))
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        txtouteq=""
        for i in range(0,len(txteqvec)):
            txtouteq+=txteqvec[i]+", "
        cv.create_text(int(1.0*actwidth/2.0),actheight-5,text="compar.:  "+str(comparabilities)+\
                       ",   incomp. "+str(utotal))
        cv.pack()


def combsimprep():
    # brg 6.8.2012
    import math
    tpcontrol=Tkinter.Toplevel(hf)
    txtcontrol= " Controlling the combinatorial analysis "+"\n"
    txtcontrol+=60*"="+"\n"
    anzcomb,txtres=rmod2.estimanz(max(k1,k2),min(k1,k2))
    txtcontrol+=" Theoretical no of  combinations ("+txtres+" ):"+str(anzcomb)+"\n"
    txtcontrol+=" Around an order of 10power "+str(int(math.log10(anzcomb)))+"\n"
    txtcontrol+=" 100 000 runs need around 10 minutes,"+"\n"
    txtcontrol+=" 1 000 000 runs would need around 30 minutes "+"\n"
    txtcontrol+=" What is your limit for exact calculation (number of combin. < limit) "+"\n"
    txtcontrol+=" In case the number of comnbination exceeds 100000: Recommended: 100 000 "+"\n"
    txtcontrol+=" Else take any number > "+str(anzcomb)+"  to get an exact calculation "+"\n"
    fr=Tkinter.Frame(tpcontrol,bg="yellow",width=60,height=3)
    fr.pack()
    tcontrol=ScrolledText(fr,width=80,height=10)
    tcontrol.pack()
    tcontrol.insert("end",txtcontrol)
    elimitnr=Tkinter.Entry(fr,width=10)
    elimitnr.pack()
    buttstartcalc=Tkinter.Button(fr,text="start the calculation ",bg="cyan",width=30,command=coman)
    buttstartcalc.pack()
    

def coman():
    #brg 5.8.2012, 6.8.2012, 13.12.2012
    global res,resactss1,resactss2,tpcoman,isodm1dm2,indiffdm1dm2
    anzcomb,txtres=rmod2.estimanz(max(k1,k2),min(k1,k2))
    lbCombin.config(text=txtres+" "+str(anzcomb),bg="yellow")
    try:
        limitnr=int(elimitnr.get())
    except:
        limitnr=100000
        
    if anzcomb>limitnr:
        # exact analysis takes too much time , hence h e r e  a random sampling
        nrand=limitnr
        res=calcestim(nrand,r,k1,k2,y1,y2)
        print "res estim ",res
    else:
        # exact analysis
        classanz=int(anzcomb+0.3)
        res=calcexact(classanz,r,k1,k2,y1,y2)
        print "res exact",res
        print " "
    resactss1,resactss2=selfsimilarity()    
##    print "resactss1 ",resactss1
##    print "resactss2 ",resactss2

    isodm1dm2,antidm1dm2,indiffdm1dm2,weakdm1dm2,equaldm1dm2=simiorigdm()
    tpcoman=Tkinter.Toplevel(hf)
    tpcoman.title(' combinatorial similarity ')
    tcoman=ScrolledText(tpcoman,width=60,height=10)
    tcoman.pack()
    txt=" Combinatorical simiilarity "+"\n"
    txt+=60*"="+"\n"
    txt+="basics"+2*"\n"
    txt+="dm1: "+ str(fn1)+"\n"
    txt+="dm2: "+ str(fn2)+"\n"
    txt+="number of attributes in dm1 = "+str(k1)+"\n"
    txt+="number of attributes in dm2 = "+str(k2)+2*"\n"
    txt+="\tmin   "+2*" \t"+" average"+2*"\t"+"max   -values"+"\n"
    txt+=60*"-"+"\n"
    txt+="iso     \t:"+str(round(res[0],4))+2*"\t"+str(round(res[1],4))+2*"\t"+str(round(res[2],4))+"\n"
    txt+="anti    \t:"+str(round(res[3],4))+2*"\t"+str(round(res[4],4))+2*"\t"+str(round(res[5],4))+"\n"
    txt+="indiff  \t:"+str(round(res[6],4))+2*"\t"+str(round(res[7],4))+2*"\t"+str(round(res[8],4))+"\n"
    txt+="weak iso\t:"+str(round(res[9],4))+2*"\t"+str(round(res[10],4))+2*"\t"+str(round(res[11],4))+"\n"
    txt+="equal   \t:"+str(round(res[12],4))+2*"\t"+str(round(res[13],4))+2*"\t"+str(round(res[14],4))+"\n"
    txt+=2*"\n"
    txt+=" dm1 "+"\n"
    txt+="self-iso1        \t: "+str(round(resactss1[0],4))+"\n"
    txt+="self-anti1       \t: "+str(round(resactss1[1],4))+"\n"
    txt+="self-indiff1     \t: "+str(round(resactss1[2],4))+"\n"
    txt+="self-weak iso1   \t: "+str(round(resactss1[3],4))+"\n"
    txt+="self-equal1      \t: "+str(round(resactss1[4],4))+"\n"
    txt+="\n"+" dm2 "+"\n"
    txt+="self-iso2        \t: "+str(round(resactss2[0],4))+"\n"
    txt+="self-anti2       \t: "+str(round(resactss2[1],4))+"\n"
    txt+="self-indiff2     \t: "+str(round(resactss2[2],4))+"\n"
    txt+="self-weak iso2   \t: "+str(round(resactss2[3],4))+"\n"
    txt+="self-equal2      \t: "+str(round(resactss2[4],4))+"\n"
    txt+=2*"\n"
    txt+="orig dm1, dm2 and their similarity profile "+"\n"
    txt+="iso_dm1_dm2:     "+str(round(isodm1dm2,4))+"\n"
    txt+="anti_dm1_dm2:    "+str(round(antidm1dm2,4))+"\n"
    txt+="indiff_dm1_dm2:  "+str(round(indiffdm1dm2,4))+"\n"
    txt+="weakiso_dm1_dm2: "+str(round(weakdm1dm2,4))+"\n"
    txt+="equal_dm1_dm2:   "+str(round(equaldm1dm2,4))+"\n"
    txt+="\n"
    txt+="      - - - e o f - - -       "+"\n"
    
    
    tcoman.insert("end",txt)
    buttgraphics=Tkinter.Button(tpcoman,text="graphical display ",command=comangr)
    buttgraphics.pack()


def comangr():
    # brg 5.8.2012
    cvcoman=Tkinter.Canvas(tpcoman,width=400,height=400,bg="white")
    cvcoman.pack()
    cviso=cvcoman.create_line(100,100,300,100,width=2,fill="red")
    cvisotext=cvcoman.create_text(50,100,text="Iso ")
    cvanti=cvcoman.create_line(100,200,300,200,width=2,fill="red")
    cvantitext=cvcoman.create_text(50,200,text="Anti ")
    cvindiff=cvcoman.create_line(100,300,300,300,width=2,fill="red")
    cvindifftext=cvcoman.create_text(50,300,text="Indiff ")
    cvvertical1=cvcoman.create_line(300,50,300,350)
    cvvertical2=cvcoman.create_line(100,50,100,350)
    cvverttext1=cvcoman.create_text(100,375,text=str(0))
    cvverttext2=cvcoman.create_text(300,375,text=str(1))
    
    cvisorange=cvcoman.create_rectangle(200*res[0]+100,95,200*res[2]+100,105,fill="grey")
    cvisoact=cvcoman.create_line(200*res[1]+100,80,200*res[1]+100,120,width=2,fill="red")
    cvisodm1dm2=cvcoman.create_line(200*isodm1dm2+100,80,200*isodm1dm2+100,120,width=2)
    cvisoacttext=cvcoman.create_text(200*res[1]+100,130,text="smp")
    cvisodm1dm2text=cvcoman.create_text(200*isodm1dm2+100,140,text="iso12")
    cvisoss1=cvcoman.create_line(200*resactss1[0]+100,90,200*resactss1[0]+100,110)
    cvisoss2=cvcoman.create_line(200*resactss2[0]+100,90,200*resactss2[0]+100,110)
    cvisoss1text=cvcoman.create_text(200*resactss1[0]+100,70,text="ss1")
    cvisoss2text=cvcoman.create_text(200*resactss2[0]+100,70,text="ss2")
    
    cvantirange=cvcoman.create_rectangle(200*res[3]+100,195,200*res[5]+100,205,fill="grey")
    cvantiact=cvcoman.create_line(200*res[4]+100,180,200*res[4]+100,220,width=2,fill="red")
    cvantiacttext=cvcoman.create_text(200*res[4]+100,230,text="smp")
    
    
    cvindiffacttext=cvcoman.create_text(200*res[7]+100,330,text="smp")
    cvindiffrange=cvcoman.create_rectangle(200*res[6]+100,295,200*res[8]+100,305,fill="grey")
    cvindiffact=cvcoman.create_line(200*res[7]+100,280,200*res[7]+100,320,width=2,fill="red")
    cvindiffdm1dm2=cvcoman.create_line(200*indiffdm1dm2+100,280,200*indiffdm1dm2+100,320,width=2)
    cvindiffdm1dm2text=cvcoman.create_text(200*indiffdm1dm2+100,340,text="indiff12")
    cvindiffss1=cvcoman.create_line(200*resactss1[2]+100,290,200*resactss1[2]+100,310)
    cvindiffss2=cvcoman.create_line(200*resactss2[2]+100,290,200*resactss2[2]+100,310)
    cvindiffss1text=cvcoman.create_text(200*resactss1[2]+100,280,text="ss1")
    cvindifss2text=cvcoman.create_text(200*resactss2[2]+100,280,text="ss2")
    



def singleatt_comb():
    #brg 18.8.2012, 13.12.2012
    # attatt
    global compar,countequality,countltgt,comparnames
    import stats
    import pstat
    r=r1
    compar=[]
    comparnames=[]
    countequality=[]
    countltgt=[]
    
    
    for kk1 in range(0,k1):
        for kk2 in range(0,k2):
            countcomp=0
            counteq=0
            cltgt=0
            dm2=rmod2.marray(r,2)
            for i in range(0,r):    
                dm2[i][0]=float(y1[i][kk1])    #17.8.2013
                dm2[i][1]=float(y2[i][kk2])
            print "single r*2-matrices: selected columns:",kk1," ",kk2
            rmod2.matout(r,2,dm2)
            print "--"
            objx1=rmod2.marray(r,r)
            quobx1=rmod2.marray(r,r)
            objx1=rmod2.comp(r,2,dm2) #changed: instead k1: correct : 2
            rmod2.qualcomp(r,objx1,quobx1)
            countcomp=0
            for i1 in range(0,r):
                for i2 in range(i1+1,r):
                    print quobx1[i1][i2]," ",
                    if quobx1[i1][i2]!="ic":
                        countcomp+=1
                    if quobx1[i1][i2]=="eg":
                        counteq+=1
                    if quobx1[i1][i2]=="lt" or quobx1[i1][i2]=="gt":
                        cltgt+=1
                print " "    
            print "column of dm1 ",kk1,"   column of dm2 ",kk2,"   eg,lt,gt= ",countcomp
            compar.append(countcomp)
            countequality.append(counteq)
            countltgt.append(cltgt)
            comparnames.append((prop1[kk1],prop2[kk2]))
            
    
    
    barth=[]
    print "compar"
    for i in range(0,len(compar)):
        barth.append(".")
        print compar[i]," ",
    print " "
    print "mincompar ", min(compar)
    print "maxcompar ",max(compar)
    app=raioop2.brgbardist(hf,"tpattatt_iso",len(compar),compar,"Distribution iso att-att",35,2,2)
    app.ausgabe()

    # selfsimilarity 1
    comparself1=[]
    comparnamesself1=[]
    for kk1 in range(0,k1):
        for kk2 in range(kk1+1,k1):
            dm2=rmod2.marray(r,2)
            for i in range(0,r):    
                dm2[i][0]=y1[i][kk1]
                dm2[i][1]=y1[i][kk2]
            rredhilf,xredhilf,objredhilf,txteqhilf,neqhilf=\
                    rmod2.equivcompactgr(r,2,dm2,obj1)
            zetahilf=rmod2.comp(rredhilf,2,xredhilf)  #zeta matrix with col<row
            sumz1=0
            for i1 in range(0,rredhilf):
                for i2 in range(0,rredhilf):
                    if i1!=i2:
                        sumz1+=zetahilf[i1][i2]
            comparself1.append(sumz1)
            comparnamesself1.append((prop1[kk1],prop1[kk2]))
    print "comparself1 ",comparself1
    maxcp1=max(comparself1)
    mincp1=min(comparself1)
    meancp1=0
    for j in range(0,len(comparself1)):
        meancp1+=comparself1[j]
    meancp1=1.0*meancp1/len(comparself1)

    # selfsimilarity2
    comparself2=[]
    comparnamesself2=[]
    for kk1 in range(0,k2):
        for kk2 in range(kk1+1,k2):
            dm2=rmod2.marray(r,2)
            for i in range(0,r):    
                dm2[i][0]=y2[i][kk1]
                dm2[i][1]=y2[i][kk2]
            rredhilf,xredhilf,objredhilf,txteqhilf,neqhilf=\
                    rmod2.equivcompactgr(r,2,dm2,obj1)
            zetahilf=rmod2.comp(rredhilf,2,xredhilf)  #zeta matrix with col<row
            sumz2=0
            for i1 in range(0,rredhilf):
                for i2 in range(0,rredhilf):
                    if i1!=i2:
                        sumz2+=zetahilf[i1][i2]
            comparself2.append(sumz2)
            comparnamesself2.append((prop2[kk1],prop2[kk2]))

    print "comparself2 ",comparself2
    print "comparnamesself2 ",comparnamesself2
    maxcp2=max(comparself2)
    mincp2=min(comparself2)
    meancp2=0
    for j in range(0,len(comparself2)):
        meancp2+=comparself2[j]
    meancp2=1.0*meancp2/len(comparself2)

    lcompar=k1*k2
    maxcompar=max(compar)
    mincompar=min(compar)
    meancompar=0
    for j in range(0,lcompar):
        meancompar+=compar[j]
    meancompar=1.0*meancompar/lcompar
    # new part : 17.2.2014
    flagcompar=0
    test=compar[0]
    for j in range(0,lcompar):
        if compar[j]==test:
            flagcompar+=1
    if flagcompar==lcompar:#compar does not vary
        meancompar=test
        stdev_compar="----"
    else:    
        dummy1,range_compar,dummy2,stdev_compar,dummy3,dummy4=pstat.ldescribe(compar)
    numberofcasesgreatermean=0
    for j in range(0,lcompar):
        if compar[j]>=meancompar:
            numberofcasesgreatermean+=1
            
    tpatt_att=Tkinter.Toplevel(hf)
    tatt_tatt=ScrolledText(tpatt_att,width=60,height=10)
    tatt_tatt.pack()
    txt=" Results of attribute-pair comparison "+"\n"
    txt+=60*"="+"\n"
    txt+="dm1 =                     "+str(fn1)+"\n"
    txt+="dm2 =                     "+str(fn2)+"\n"
    txt+="Number of possible pairs: "+str(lcompar)+"\n"
    txt+="Range =:                  "+str(mincompar)+" .... "+str(maxcompar)+"\n"
    txt+="Difference max- min:=     "+str(maxcompar-mincompar)+"\n"
    txt+="Mean =:                   "+str(meancompar)+"\n"
    txt+="stddev =:                 "+str(stdev_compar)+"\n"
    txt+="count: combin >= mean  :  "+str(numberofcasesgreatermean)+"\n"
    txt+="Reference cases "+"\n"
    txt+="Range of comps of dm1     "+str(mincp1)+" .... "+str(maxcp1)+"\n"
    txt+="Mean of comp of dm1       "+str(meancp1)+"\n"
    txt+=" Range of comps of dm2    "+str(mincp2)+" ... " +str(maxcp2)+"\n"
    txt+="Mean of comp of dm2       "+str(meancp2)+"\n"
    tatt_tatt.insert("end",txt)

def showattatt():
    #brg 22.2.2013
    # Display of the att-att-results in detail
    tpattattdetail=Tkinter.Toplevel(hf)
    tpattattdetail.title(' att-att-details ')
    tattattdetail=ScrolledText(tpattattdetail,width=60, height=20)
    tattattdetail.pack()
    # global compar,countequality,countltgt,comparnames
    txt=" Details of att-att-method "+"\n"
    txt+=60*"="+"\n"
    ltc=k1*k2
    print "ltc = ",ltc
    for i in range(0,ltc):
        if i!=0 and int(1.0*i/(1.0*40))==1.0*i/(1.0*40):
            txt+="\n"
        else:
            txt+=str(comparnames[i])+", "
    txt+="\n"
    txt+="\ncompar (lt,gt,eq) "+"\n"
    for i in range(0,ltc):
        if i!=0 and int(1.0*i/(1.0*40))==1.0*i/(1.0*40):
            txt+="\n"
        else:
            txt+=str(compar[i])+", "
    txt+=2*"\n"
    txt+="equalities "+"\n"
    for i in range(0,ltc):
        if i!=0 and int(1.0*i/(1.0*40))==1.0*i/(1.0*40):
            txt+="\n"
        else:
            txt+=str(countequality[i])+", "
    txt+="\n"
    txt+="\nOnly lt, gt "+"\n"
    for i in range(0,ltc):
        if i!=0 and int(1.0*i/(1.0*40))==1.0*i/(1.0*40):
            txt+="\n"
        else:
            txt+=str(countltgt[i])+", "
    txt+="\n"
    txt+= "   -   -  -   e  o   f   -   -   -"
    tattattdetail.insert("end",txt)
    
def attattsave():
    #brg 13.12.2012
    fnvecattatt=tkFileDialog.asksaveasfilename(parent=hf,title="save the distributions of iso (att-att) ")
    
    f2=open(fnvecattatt,"w")
    f2.write("number of cases = "+str(len(compar))+"\n")
    f2.write("iso_att-att"+"\n")
    for i in range(0,len(compar)):
        f2.write(str(compar[i])+", ")
    f2.write("\n")
    
    
def attatt_eval():
    # brg 27.3.2013
    import stats
    import pstat
    try:
        perm=int(eperm.get())
    except:
        perm=1
    #print "Protocol 24.3.2013 "
    nemp=r
    print "rows of empirical matrices ",nemp
    # perm=1 : tabelle1 Only permutation
    tab_act=Scherbsimulation(perm)
##    print "Scherb' simulation (1000 runs)"
##    rmod2.matout(len(tab_act),4,tab_act)
##    print "  "
    print "compar (isotone) ",compar
    n1=1000  #Scherb: 1000 simulation runs
    n2=len(compar) #resulting from combisimilarity 16 is not a number in Tabelle1/2, therefore interpolation needed.

    #imin_act,flag_act,mean_act=rmod2.searchtabelle(nemp,tab_act,1)  # mean selected  (8,tab_act,1) replaced by (nemp,..#
    mean_act=0.250185*nemp*nemp-0.288923*nemp+1.131909   #Function determined by Hagen Scherb, 9.8.2013
    #imin_act2,flag_act2, std_act=rmod2.searchtabelle(nemp,tab_act,2) #std selected (8,tab_act,2) replaced by (nemp,...)
    #function determined by Hagen Scherb
    a3=-0.204561*(10**(-6))
    a2=0.000208337556
    a1=0.360401245353
    a0=-0.272758179506
    polynom=a3*nemp**3+a2*nemp**2+a1*nemp+a0
    std_act=polynom**math.sqrt(2)

    print "Interpolation routine"
    # mean_act is the theoretical mean of the simulation study of Scherb (1000 runs) 
##    print "lower interpolation point             ",imin_act, "   th row of Tabelle " 
##    print " Warning (flag=1) no warning (flag=0) ",flag_act
    print "Inter/extra polated value of mean     ",mean_act
    # std2_act is the theoretical mean of the simulation study of Scherb (1000 runs)
    print "Inter/extra polated value of stdev    ",std_act
    ##t_act,prob_act=pstat.lttest_ind(a,b)
    ##print "t= ",t_act
    ##print "prob= ",prob_act
   
    #Student's - t-distribution 
    sd2=pstat.stdev(compar)
    mean2=pstat.mean(compar)
    
    tscherb,fgh,fg=rmod2.tcritfgestimation(std_act,mean_act,n1,sd2,mean2,n2)
    print "2) t-value, fg after formulas of Scherb "
    print "tscherb= ",tscherb
    print "fgh= (immediate result of A(t:fg)              ",fgh
    print "fg= (rounded)                                  ",fg
    atfg_act=rmod2.atfg(tscherb,fg)
    print "3) Final result"
    print "two-sided probability that the two t-values are different ",atfg_act
    print "two-sided prob that t-values are not different            ",1.0-atfg_act
    tpstudent=Tkinter.Toplevel(hf)
    tpstudent.title(' Results of statistical analysis : att_att ')
    tstudent=ScrolledText(tpstudent,width=60,height=10)
    tstudent.pack()
    txt=" Test results "+"\n"
    txt+=60*"="+"\n"
    txt+="Basic information "+"\n"
    txt+="number of objects:  "+"\t"+str(nemp)+"\n"
    txt+="number of isotone-values: "+"\t"+str(n2)+"\n"
    txt+="number of simulations: "+"\t"+str(n1)+"\n"
    txt+="mean of simulations: "+"\t"+str(mean_act)+"\n"
    txt+="stdev of simulations: "+"\t"+str(std_act)+"\n"
    txt+="mean of isotone-values:"+"\t"+str(mean2)+"\n"
    txt+=" stdev of isotone-values: "+"\t"+str(sd2)+"\n"
    txt+="abs(difference of the two mean-values:"+"\t  "+str(abs(mean_act-mean2))+"\n"
    txt+="t-test-Results "+"\n"
    txt+="t-test : t= "+"\t"+str(tscherb)+"\n"
    txt+="Degree of freedoms "+"\t"+str(fg)+"\n"
    txt+="Probabilities from students-t-distribution "+"\n"
    txt+="Based on fg = "+str(fg)+"   and the t-value of "+str(tscherb)+"   it is found: "+"\n"
    txt+="two-sided prob: the two mean-values are different:"+"\t"+str(round(atfg_act,4))+"\n"
    txt+="two-sided prob: the two mean-values are  n o t different:"+"\t"+str(round(1.0-atfg_act,4))+"\n"
    txt+=60*"="+"\n"
    txt+="    -   -   -   eof  -   -    -  "
    tstudent.insert("end",txt)
    bvar1=(mean_act<mean2)  #isotone: mean_simulation less mean_isotone implies similar 
    bvar2=1.0-atfg_act<0.001  #isotone: probability of not-different is negligible
    print "mean_act= ",mean_act,"   mean2=  ",mean2,"  bvar1= ",bvar1
    if atfg_act != 1.0:
        print "log10(1-atgf_act)= ",math.log10(1.0-atfg_act),"  bvar2= ",bvar2
    else:
        print "Exact coincidence: prob = 1 "
        
    txtvar1="poset1(dm1) and poset2(dm2)\n are similar with error prob. (%)<0.1"
    txtvar2="poset1(dm1) and poset2(dm2)\n are similar with error prob. (%) >= 0.1"
    txtvar3="poset1(dm1) and poset2(dm2)\n are not similar with error prob. (%) <0.1"
    txtvar4="poset1(dm1) and poset2(dm2)\n are not similar with error prob. (%) >= 0.1"
    txtvar5="see detailed values "
    txtfinal=""
    if bvar1 and  bvar2:
        txtfinal=txtvar1
    elif bvar1 and not bvar2:
        txtfinal= txtvar2+"\n"+txtvar5
    elif not bvar1 and bvar2:
        txtfinal=txtvar3
    else:
        txtfinal=txtvar4+"\n"+txtvar5
    lbfinal.config(text=txtfinal,font=("arial",15),bg="yellow")    
    

                    
            

# brg 4.8.2012, 5.8.2012, 13.12.2012, 22.2.2013, 28.3.2013
hf=Tkinter.Tk()
hf.title(' CombinatSimilarity ')
aboutcombsim=raioop2.brgabout(hf,"tp1","about_combsimilarity.txt",6,\
            "February, 22nd,2013"," about combsimilarity ", "white", "t1",80,5,ScrolledText)
helpcombsim=raioop2.brgabout(hf,"tp1","help_combsimilarity.txt",6,\
            "February, 22nd,2013"," help_combsimilarity ", "white", "t1",80,5,ScrolledText)
    
buttsimifileselect=Tkinter.Button(hf,text="open the two files\n (first that with smaller , \
\n then that with larger number of attributes",width=40,bg="cyan", command=simi_fileselect)
buttsimifileselect.pack()    
buttshowdm=Tkinter.Button(hf,text="show the two matrices ",width=40,bg="cyan",command=showmatrices)
buttshowdm.pack(pady=5)
lbperturb=Tkinter.Label(hf,text="Pertrub the HD (1,2,3...)")
lbperturb.pack()
eperturb=Tkinter.Entry(hf,width=3)
eperturb.pack()
buttHD=Tkinter.Button(hf,text="Show both HDs ",width=40, bg="cyan",command=Hasse)
buttHD.pack()
buttCombipreparation=Tkinter.Button(hf,text=" Preparating step for combinatorial similarity ",width=40,command=combsimprep)
buttCombipreparation.pack()
buttCombin=Tkinter.Button(hf,text="Perform a comnbinatorial \nsimilarity analysis",width=40,bg="cyan",command=coman)
buttCombin.pack()
lbCombin=Tkinter.Label(hf,text="")
lbCombin.pack()
buttcombinsave=Tkinter.Button(hf,text="save the combinatorial results ",bg="cyan",width=40,command=savecom)
buttcombinsave.pack()
buttatt_att_analysis=Tkinter.Button(hf,text="att_att_analysis ",width=40, bg="cyan",command=singleatt_comb)
buttatt_att_analysis.pack(pady=10)
lbattatt=Tkinter.Label(text="show-att-att-results in detail can be a very long list ....", bg="yellow")
lbattatt.pack()
buttshowattatt=Tkinter.Button(hf,text=" show details of att-att ",bg="cyan",width=40, command=showattatt)
buttshowattatt.pack()

buttsaveatt_att=Tkinter.Button(hf,text="save att-att-result ",width=40,bg="cyan",command=attattsave)
buttsaveatt_att.pack()
lbperm=Tkinter.Label(hf,text="Select 1 (permutation) or 0 ( acceptance of ties) ")
lbperm.pack()
eperm=Tkinter.Entry(hf,width=2)
eperm.pack()
buttattatteval=Tkinter.Button(hf,text="Statistical analysis of att_att ",bg="cyan",width=40,command=attatt_eval)
buttattatteval.pack()
lbfinal=Tkinter.Label(hf,text="")
lbfinal.pack()
buttexit=Tkinter.Button(hf,text=" Exit  ",bg="red",width=20, command=hf.destroy)
buttexit.pack()
hf.mainloop()    
               
    

