# -*- coding: cp1252 -*-
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import tkFileDialog
import raioop2
import pstat
import stats

#Brg in cooperation with Korbinian Freier, MPI Hamburg, 2.10. and 3.10.09
# conflict1.py: has nothing to do with Peter Soerensen conflict diagram
# Idea: check the objects near bottom level and their position in ci.
#    If discrepancy: why
# 5.10.2010
# 6.10.2010
# 6.10.2010: rearrangements due to PyHasse standard
# 7.10.: Nota bene: if the sum of attributes is the same for different objects then there are equi
#       valencies within CI which do not appear in PO. Therefore the basis of calculations must be on r not on rred1 or rred2!!!!!
# 11.10. version 4 takes into account possible different equiv.classes in PO and CI, resp.
# 4.8.2011 ###Baustelle#### under construction!!!!
# complete rearrangement. Most of the tasks are now in HDCI6. Therefore this program is specialized to investigate object sets
# 7.11.2014 wrong rkav (LPOM0) values, because instead of zeta, the relational matrix was used
# 7.11.2014 Correction of this bug
# Inclusion of the extension to all objects


def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global rred1,objred1,zzmax1,k,xred1,prop,fn,r,dm,dmnorm, ci,obj,we,zeta1,neq1
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)   
    lb1.config(text="opened "+fn,bg="yellow")
    we=rmod2.vecgen1(k)   #weights entry fields
    default=round(1.0/(1.0*k),3)
    lbweights.config(text="weights of CI-calculation (default: "+str(default)+")")
    for j in range(0,k):
        we[j]=Tkinter.Entry(frw,width=3)
        we[j].grid(row=1,column=j)

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    
    dmnorm=rmod2.matrixnorm(r,k,dm)    
        
    rred1,xred1,objred1,txt1,neq1=rmod2.equivcompactgr(r,k,dmnorm,obj)  #changed: equivcompactm to equivcompactgr
    
    #
    # first dmnorm
    zetahilf1=rmod2.comp(rred1,k,xred1)  #zeta matrix with col<row
    zeta1=rmod2.marray(rred1,rred1)
    for i in range(0,rred1):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred1):
            zeta1[i][j]=zetahilf1[j][i]
    #
    #One linear extension (based on levels)
    global lobj1,l1
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(rred1,zeta1)
       
    levmax1=-10**20     #20.6.08
    for i in range(0,zzmax1):
        if len(lobj1[i])>=levmax1:
            levmax1=len(lobj1[i])
       
    #Adj-Listen

    adjc1=rmod2.adjacent(rred1,lext1,revlext1,zeta1)
        
    #Transitive reduced relations
    ts1,tr1=rmod2.trreduct(rred1,adjc1,lext1)
       
    
    cov1=rmod2.cover(rred1,tr1,lext1)

    if rred1>200:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred1,levmax1,zzmax1)
        cv1=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz1=zzmax1
        l1=rmod2.vecgen1(lz1)
        for i in range(0,lz1):
            l1[i]=len(lobj1[i])

        pos1=rmod2.vecgen1(lz1)
        for i in range(0,lz1):
            pos1[i]=l1[i]

        geomx1=rmod2.marray(rred1,rred1)
        geomy1=rmod2.marray(rred1,rred1)

       
        for i in range(0,lz1):
            for j in range(0,l1[i]):
                geomx1[i][j]=geom0x+(factorx/(pos1[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy1[i][j]=geom0y+(factory/lz1)*i
            
        
        for i in range(0,lz1-1):
            for j in range(0,l1[i]):
                for i1 in range(i+1,lz1):
                    for j1 in range(0,l1[i1]):
                        if cov1[lobj1[i1][j1]][lobj1[i][j]]==1:
                            cv1.create_line(geomx1[i][j],geomy1[i][j],geomx1[i1][j1],geomy1[i1][j1])


        for i in range(0,lz1):
            for j in range(0,l1[i]):
                cv1.create_oval(geomx1[i][j]-10,geomy1[i][j]+10,geomx1[i][j]+10,geomy1[i][j]-10,fill="white")
                cv1.create_text(geomx1[i][j],geomy1[i][j],text=objred1[lobj1[i][j]])
        cv1.pack(side="left")
    teq1=ScrolledText(freq,width=60, height=5)
    teq1.pack()
    teq1.insert("end",txt1)


        

def CIcalc():
    # Brg 6.8.2011
    #CI-calculation on the basis of columnwise normalized matrix dm
    dmnorm=rmod2.matrixnorm(r,k,dm)
    global ci,w
    ci=rmod2.vecgen1(r)
    w=rmod2.vecgen1(k)
    for j in range(0,k):
        try:
            w[j]=float(we[j].get())
        except:
            w[j]=1.0/(1.0*k)
    sumw=0
    for j in range(0,k):
        sumw+=w[j]
    if sumw!=1.00:
        for j in range(0,k):
            w[j]=1.0*w[j]/(1.0*sumw)
    
    for i in range(0,r):        #in order to use as far as possible former routines: ci gets two identical columns
        for j in range(0,k):
            ci[i]+=dmnorm[i][j]*w[j]
    
    Tpci=Tkinter.Toplevel(hf)
    Tpci.title(' Results of CI ')
    tci=ScrolledText(Tpci,width=60,height=5)
    tci.pack()
    txtci="Results of CI "+"\n"
    txtwe=""
    for j in range(0,k):
        txtwe+=str(round(w[j],3))+",\t"
    txtci+="Weights  :"+txtwe+"\n"
    for i in range(0,r):
        txtci+=str(obj[i])+": "+str(round(ci[i],3))+"\n"
    txtci+="- - -  e o f - - -"
    tci.insert("end",txtci)

def CIcalcrepres():
    # Brg 6.8.2011, 8.11.2014
    #CI-calculation on the basis of columnwise normalized matrix dm
    # of the representative elements
    global cirepres,w
    cirepres=rmod2.vecgen1(rred1)
    w=rmod2.vecgen1(k)
    for j in range(0,k):
        try:
            w[j]=float(we[j].get())
        except:
            w[j]=1.0/(1.0*k)
    sumw=0
    for j in range(0,k):
        sumw+=w[j]
    if sumw!=1.00:
        for j in range(0,k):
            w[j]=1.0*w[j]/(1.0*sumw)
    
    for i in range(0,rred1):        #in order to use as far as possible former routines: ci gets two identical columns
        for j in range(0,k):
            cirepres[i]+=xred1[i][j]*w[j]
    
    Tpcirep=Tkinter.Toplevel(hf)
    Tpcirep.title(' Results of CI (repres. elements) ')
    tcirep=ScrolledText(Tpcirep,width=60,height=5)
    tcirep.pack()
    txtci="Results of CI of repres. elements "+"\n"
    txtwe=""
    for j in range(0,k):
        txtwe+=str(round(w[j],3))+",\t"
    txtci+="Weights  :"+txtwe+"\n"
    for i in range(0,rred1):
        txtci+=str(objred1[i])+": "+str(round(cirepres[i],3))+"\n"
    txtci+="- - -  e o f - - -"
    tcirep.insert("end",txtci)    

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def rkav():
    #brg 12.10.2010, 6.8.2011, 8.11.2014
    global rkav0, rkav0ext
    zetahilf2=rmod2.comp(rred1,k,xred1)  #zeta matrix with col<row of the o b j e c t  set
    zeta2=rmod2.marray(rred1,rred1)
    for i1 in range(0,rred1):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rred1):
            zeta2[i1][i2]=zetahilf2[i2][i1]
    
    rkav2=rmod2.vecgen1(rred1)
    
    
    # U and S-assessment
    S1=[]
    U1=[]
    
    for i1 in range(0,rred1):
        s1sum=0
        usum=0
        for i2 in range(0,rred1):
            if zeta2[i2][i1]==1:
                s1sum+=1
            if zeta2[i1][i2]==0 and zeta2[i2][i1]==0:
                usum+=1
        S1.append(s1sum)
        U1.append(usum)
        
    s1l=len(S1)
    u1l=len(U1)
    S1LPOM=rmod2.vecgen1(rred1)  
    rkav0=rmod2.vecgen1(rred1)# 
    for i in range(0,rred1):
        S1LPOM[i]=S1[i]-1
        rkav0[i]=1.0*(S1LPOM[i]+1)*(rred1+1)/(1.0*rred1+1.0-U1[i])
        
    tprkav=Tkinter.Toplevel(hf)
    tprkav.title(' rkav of the object set ')
    trkav=ScrolledText(tprkav,width=60,height=10)
    trkav.pack()
    txtrkav="Results of LPOM0 for the representaive elements of the bject set "+"\n"
    txtrkav+=30*"="+"\n"
    for i in range(0,rred1):
        txtrkav+=str(objred1[i])+"  rkav= "+str(round(rkav0[i],3))+"\n"
    txtrkav+="\n"
    txtrkav+="Extension to all objects by applying the weak1 - routine"+"\n"
    rkav0ext=rmod2.weak1(r,obj,objred1,rkav0,neq1)
    for i in range(0,r):
        txtrkav+=str(obj[i])+"  rkav= "+str(round(rkav0ext[i],3))+"\n"
    txtrkav+="\n"
    txtrkav+="- - -    e o f - - -"
    trkav.insert("end",txtrkav)

def analysis():
    # related first to representastive elements
    tpan=Tkinter.Toplevel(hf)
    tpan.title(' results CI vs rkav ')
    tan=ScrolledText(tpan,width=60,height=5)
    tan.pack()
    CIcalcrepres()
    rkav()
    txtan=""
    txtwe=""
    for j in range(0,k):
        txtwe+=str(round(w[j],3))+",\t"
    txtan+="Weights  :"+txtwe+"\n"
    
    rspear,probrs=pstat.lspearmanr(cirepres,rkav0)
    txtan+="\n"+"Spearman correl(rkav,ci) represent elements: "+str(rspear)+"\n"
    
    txtcontrol=""
    if rspear>0.95:
        txtcontrol+="weighting seems to be ok"
    else:
        txtcontrol+="+++Please check LPOM or weighting+++"
    lbresult.config(text=txtcontrol,bg="yellow")
    # related to object set
    CIcalc()
    txtan2=""
    txtwe2=""
    for j in range(0,k):
        txtwe2+=str(round(w[j],3))+",\t"
    txtan2+="Weights  :"+txtwe2+"\n"
    
    rspear,probrs=pstat.lspearmanr(ci,rkav0ext)
    txtan2+="\n"+"Spearman correl(rkav,ci) all objects: "+str(rspear)+"\n"
    txtan2+="\n"
    txtcontrol2=""
    if rspear>0.95:
        txtcontrol2+="weighting seems to be ok"
    else:
        txtcontrol2+="+++Please check LPOM or weighting+++"
    lbresult.config(text=txtcontrol2,bg="yellow")
    txtan+=txtan2
    txtan+="\n"
    txtan+="- - -  e o f - - - "
    
    tan.insert("end",txtan)
                    
    
    

## main program
hf = Tkinter.Tk()
hf.title(' conflict analysis ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_conflict.txt",9,\
            "Nov, 8th,2014"," about conflict ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_conflict.txt",9,\
            "Nov., 6th,2014"," help_conflict ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select,open,HD of dm',width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttshow=Tkinter.Button(fr,text="show data matrix",width=25,command=showDM)
buttshow.pack()
frw=Tkinter.Frame(fr)   #Nota bene: grid!!
frw.pack()
lbweights=Tkinter.Label(frw,text="")
lbweights.grid(row=0,columnspan=4)
buttCI1=Tkinter.Button(fr,text="Calculation of CI (repres. elements)", width=25, command=CIcalcrepres)
buttCI1.pack()
buttCI2=Tkinter.Button(fr,text="Calculation of CI (object set)", width=25, command=CIcalc)
buttCI2.pack()
buttrkav=Tkinter.Button(fr,text="Rkav based on LPOM0 (object set)",width=25,command=rkav)
buttrkav.pack()
buttanalysis=Tkinter.Button(fr,text="Spearman correlation rkav and CI ",bg="cyan",width=25, command=analysis)
buttanalysis.pack()      
lbresult=Tkinter.Label(fr,text="")
lbresult.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

