import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog

import Canvas
import os
from math import *

#  brg  28.5.09, 29.5.09, 31.05.09, 1.6.09 (version 1 ready), 5.6.09
#  brg 21.3.2012, 12.1.2015, 4.11.16


def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08, 28.5.09, 12.1.2015
    #note: Taken from antag
    #source:-
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    global fn,k,r,dm,e_mina,e_maxa,e_K,pro,ob, eKdefault, prop
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected initial file : "+fn+"\n"+str(r)+" rows\n"+str(k)+" columns"
    lbmaxselect.config(text="select:\n min max  K (K = number of eq.dist. intervals)")
    frdefault=Tkinter.Frame(fr1, bd=3,relief="sunken")
    frdefault.pack()
    eKdefault=Tkinter.Entry(frdefault,width=5)
    eKdefault.pack()
       
    e_maxa=rmod2.vecgen1(k)
    e_mina=rmod2.vecgen1(k)
    e_K=rmod2.vecgen1(k)
    frgrid=Tkinter.Frame(fr1)
    frgrid.pack()
    for i in range(0,k):
        lbgrid0=Tkinter.Label(frgrid,text="q"+str(i),bg="cyan")
        lbgrid0.grid(column=i+1,row=0)
    lbgrid1=Tkinter.Label(frgrid,text="min....",bg="cyan")
    lbgrid1.grid(column=0,row=1)
    lbgrid2=Tkinter.Label(frgrid,text="max....",bg="cyan")
    lbgrid2.grid(column=0,row=2)
    lbgrid3=Tkinter.Label(frgrid,text="K......",bg="cyan")
    lbgrid3.grid(column=0,row=3)
    for i in range(0,k):
        e_mina[i]=Tkinter.Entry(frgrid,width=5)
        e_mina[i].grid(column=1+i,row=1)

    for i in range(0,k):
        e_maxa[i]=Tkinter.Entry(frgrid,width=5)
        e_maxa[i].grid(column=1+i,row=2)    

    for i in range(0,k):
        e_K[i]=Tkinter.Entry(frgrid,width=5)
        e_K[i].grid(column=1+i,row=3)        

    return r,k,dm,ob,pro,fn

def classification():
    # modified 21.3.2012, 2.6.16
    global rred, objred,xred,obj,prop,dms, zeta2
    try:
        defaultKa=int(eKdefault.get())
    except:
        defaultKa=3.0
    lbdefault.config(text="The number of intervals by default is "+str(defaultKa))
    tpclass=Tkinter.Toplevel(hf)
    tpclass.title("Specifications of the classification ")
    tclass=ScrolledText(tpclass,width=120,height=10)
    tclass.pack()
    mindm=rmod2.vecgen1(k)
    maxdm=rmod2.vecgen1(k)
    txt="Specifications of the user-defined classification "+"\n"
    txt+="min and max "+"\n"
    for j in range(0,k):
        txt+=str(pro[j+1])+"\t"
    txt+="\n"    
    for j in range(0,k):
        dmc=rmod2.vecgen1(r)
        for i in range(0,r):
            dmc[i]=dm[i][j]
        mindm[j]=min(dmc)
        
    for j in range(0,k):
        dmc=rmod2.vecgen1(r)
        for i in range(0,r):
            dmc[i]=dm[i][j]
        maxdm[j]=max(dmc)
        

    maxa=rmod2.vecgen1(k)
    mina=rmod2.vecgen1(k)
    Ka=rmod2.vecgen1(k)
    for i in range(0,k):
        try:
            mina[i]=float(e_mina[i].get())
        except:
            mina[i]=mindm[i]
        txt+=str(mindm[i])+"\t "
    txt+="\n"    
    for i in range(0,k):
        try:
            maxa[i]=float(e_maxa[i].get())
        except:
            maxa[i]=maxdm[i]
        txt+=str(maxdm[i])+"\t "
    txt+="\n"
    txt+="Number of classes K"+"\n"
    for i in range(0,k):
        try:
            Ka[i]=int(e_K[i].get())
        except:
            Ka[i]= defaultKa
        txt+=str(Ka[i])+"\t"
    txt+="\n"
    txt+="Interval-limits"+"\n"
    intervlimits=[]
    for j in range(0, k):
        txt+=str(pro[j+1])+":"+"\n"
        for j1 in range(0, int(Ka[j])+1):
            txt+=str(mina[j]+(j1*1.0*(maxa[j]-mina[j])/(1.0*Ka[j])))+",\t"
        txt+="\n"
    tclass.insert("end",txt)    
    dms=rmod2.marray(r,k)    
    for i in range(0,r):
        for j in range(0,k):
            
            hilf=[]
            for j1 in range(0,int(Ka[j])):
                if j1<Ka[j]-1:
                    if dm[i][j]<mina[j]: # dm not in the min max interval
                        dms[i][j]=0
                    if mina[j]+j1*1.0*(maxa[j]-mina[j])/(1.0*Ka[j])<=dm[i][j]\
                       <mina[j]+(j1+1)*1.0*(maxa[j]-mina[j])/(1.0*Ka[j]):
                        dms[i][j]=j1
                else:
                    if dm[i][j]>=maxa[j]: # dm not in the min max interval, change 24.2.10 >= instead of >
                        dms[i][j]=Ka[j]-1
                    if mina[j]+j1*1.0*(maxa[j]-mina[j])/(1.0*Ka[j])<=dm[i][j]\
                       <=mina[j]+(j1+1)*1.0*(maxa[j]-mina[j])/(1.0*Ka[j]):
                        dms[i][j]=j1
    
    rmod2.matout(r,k,dms)                
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################this part is of 21.12.07 #########
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dms,obj)    
    ###############################################################
    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    n=rred
    tpeqorig=Tkinter.Toplevel(hf)
    tpeqorig.title(' equivalence classes of the original DM ')
    teqorig=ScrolledText(tpeqorig,width=60,height=5)
    teqorig.pack()
    teqorig.insert("end",txt)
    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic2=Tkinter.Toplevel(hf)
    tpbasic2.title(' basic characteristics of the orig HD ')
    lbbasic2=Tkinter.Label(tpbasic2,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    
    if n>200:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
##        print "actual width  ",actwidth
##        print "actual height ",actheight
##        print "factory       ",factory
##        print "factorx       ",factorx
##        print "garrow1x      ",garrow1x
        
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07, 25.1.2014
    #*28.12.07
    #akt25.1.14
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    n=rred
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)






def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y            
         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    global mindm,maxdm
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    
    txtext="\n\nMin and Max of any column\n"
    mindm=rmod2.vecgen1(k)
    maxdm=rmod2.vecgen1(k)
    for j in range(0,k):
        txtext+="q("+str(j)+")\t"
    txtext+="\n"
    for j in range(0,k):
        dmc=rmod2.vecgen1(r)
        for i in range(0,r):
            dmc[i]=dm[i][j]
        mindm[j]=min(dmc)
        txtext+=str(min(dmc))+"\t"
    txtext+="\n"
    for j in range(0,k):
        dmc=rmod2.vecgen1(r)
        for i in range(0,r):
            dmc[i]=dm[i][j]
        maxdm[j]=max(dmc)
        txtext+=str(max(dmc))+"\t"
    txtext+="\n"
    txt+=txtext        
    tfile.insert("end",txt)


def showdms():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp3=Tkinter.Toplevel(hf)
    tp3.title(' show discret.DM ')
    lbtp2=Tkinter.Label(tp3,text=" Discret. data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp3,width=60,height=20)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"     #23.10.2018
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 14.1.08, 8.5.08, 2.8.16
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global r,dm,prop 
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k1)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k1):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################this part is of 21.12.07 #########
    rred,xred,objred,txt=rmod2.equivcompact(r,k1,dm,obj)    
    ###############################################################
    return rred,k1,xred,objred,obj,prop,txt           
     
def sf():
    #brg  31.5.09, 1.6.09
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
    for i in range(0,r):
        print obj[i]," ",
    print " "    
    rmod2.raiwrite5(fn,dms,obj,prop,r,k)
    lbsuccess.config(text="matrix with \n"+str(r)+"  rows  and "+str(k)+"\n  columns stored",bg="yellow")

def savefile():
    # brg 4.8.2016, 4.11.2016
    txt=""
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file in Standard format")
    f1=open(fn,"w")
    txt+="path+filename="+fn+"\n"
    f1.write("dummy"+"\t")
    txt+=str(k)+"  columns"+"\n"
    for j in range(0,k):
        f1.write(str(prop[j])+"\t")
    f1.write("\n")
    txt+=str(r)+"  rows"+"\n"
    for i in range(0,r):
        f1.write(str(obj[i])+"\t")
        for j in range(0, k):
            f1.write(str(dms[i][j])+"\t")
        f1.write("\n")
    f1.close()
    txt+="successfully saved "
    lbsuccess2.config(text=txt,bg="yellow")

hf=Tkinter.Tk()
hf.title('--    discretization and HD   -- ')


aboutmainHD=raioop2.brgabout(hf,"tp1","about_discret.txt",5,\
            "October, the 23rd,2018"," about discret ", "white", "t1",80,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_discret.txt",5,\
            "October, the 23rd,2018"," help_discret ", "white", "t1",80,5,ScrolledText)
    
global fr1
fr1=Tkinter.Frame(hf,width=60)   #about, help, fn, lbopen1
fr1.pack()

Buttfn=Tkinter.Button(fr1,text="select file",width=25,bg="cyan",command=fileselect)
Buttfn.pack(pady=5)
lbopen1=Tkinter.Label(fr1,text="")
lbopen1.pack()
Buttshow=Tkinter.Button(fr1,text="show data matrix",width=25,command=showDM)
Buttshow.pack(pady=5)
lbmaxselect=Tkinter.Label(fr1,text="")
lbmaxselect.pack()


fr3=Tkinter.Frame(hf)
fr3.pack(pady=5)
buttshowdms=Tkinter.Button(fr3,text="show discret. matrix ",width=25,bg="cyan",command=showdms)
buttshowdms.pack()
Buttsavedms=Tkinter.Button(fr3,text="save discret. data matrix (pdt-format)",width=25,bg="white"\
                           ,command=sf)
Buttsavedms.pack(pady=5)
lbsuccess=Tkinter.Label(fr3,text="")
lbsuccess.pack()
ButtsaveStandard=Tkinter.Button(fr3, text="Save discretiz. data matrix \n(Excel-analog.format)",bg="cyan",bd=5,command=savefile)
ButtsaveStandard.pack()
lbsuccess2=Tkinter.Label(fr3,text="")
lbsuccess2.pack()
buttexit=Tkinter.Button(fr3,text=" Exit  ",bg="red", width=25,command=hf.destroy)
buttexit.pack(pady=10)






hf.mainloop()


