import rmod2
import raioop2
import Tkinter
import Canvas
import csv
from ScrolledText import ScrolledText
import tkFileDialog

# brg 4.9.2013 other versions in toward electre5
# brg 24.9.2014 save relation matrix

def fileopen():
    # brg 4.9.2013
    import tkFileDialog
    global fn,x,r,k,obj,prop
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)
    
    return x,r,k,obj,prop 


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xorig,xred,rred,objred,dm
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    xorig=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            xorig[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,xorig)
    en=enorm.get()   #new 26.9.2014
    if en!="n":
        x=rmod2.matrixnorm(r,k,xorig)
    else:
        x=rmod2.matcopy1(r,k,xorig)
    return x,r,k,obj,prop 


def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,xorig,fn,obj,prop,xred,objred,rred,dm
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    xorig=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            xorig[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,xorig)
    en=enorm.get()   #new 26.9.2014
    if en!="n":
        x=rmod2.matrixnorm(r,k,xorig)
    else:
        x=rmod2.matcopy1(r,k,xorig)
    return x,r,k,obj,prop 



def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,xorig,prop,obj,rred,xred,objred
    xorig,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    rmod2.matout(r,k,xorig)
    en=enorm.get()   #new 26.9.2014
    if en!="n":
        x=rmod2.matrixnorm(r,k,xorig)
    else:
        x=rmod2.matcopy1(r,k,xorig)
    return x,r,k,obj,prop 

    
        

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,xorig,prop,obj,rred,xred,objred
    
    r,k,xorig,obj,prop=rmod2.raireadin5(fn)
    en=enorm.get()   #new 26.9.2014
    if en!="n":
        x=rmod2.matrixnorm(r,k,xorig)
    else:
        x=rmod2.matcopy1(r,k,xorig)
    return x,r,k,obj,prop 


def param_Electr():
    # brg 4.9.2013
    global eindiff,esigni,eveto,eweight,p1f,p2f,p3f,p4f
    tppE=Tkinter.Toplevel(hf)
    tppE.title('parameter sel')
    lb1=Tkinter.Label(tppE,text="Enter indifference levels ")
    lb1.pack()
    eindiff=Tkinter.Entry(tppE,width=20)
    eindiff.pack()
    lb2=Tkinter.Label(tppE,text="Enter significance levels ")
    lb2.pack()
    esigni=Tkinter.Entry(tppE,width=20)
    esigni.pack()
    lb3=Tkinter.Label(tppE,text="Enter veto levels ")
    lb3.pack()
    eveto=Tkinter.Entry(tppE,width=20)
    eveto.pack()
    lb4=Tkinter.Label(tppE,text="Enter weights ")
    lb4.pack()
    eweight=Tkinter.Entry(tppE,width=20)
    eweight.pack()
##    buttsubmit=Tkinter.Button(tppE,text="submit ",bd=2,command=submit_parameters)
##    buttsubmit.pack()
    
    
def submit_parameters():
    # brg 4.9.2013
    global p1f,p2f,p3f,p4f
    p1=eindiff.get().split(",")
    p2=esigni.get().split(",")
    p3=eveto.get().split(",")
    p4=eweight.get().split(",")

    p1f=[]
    lp=len(p1)
    for j in range(0,lp):
        p1f.append(float(p1[j]))

    p2f=[]
    lp=len(p2)
    for j in range(0,lp):
        p2f.append(float(p2[j]))    

    p3f=[]
    lp=len(p3)
    for j in range(0,lp):
        p3f.append(float(p3[j]))

    p4f=[]
    lp=len(p4)
    for j in range(0,lp):
        p4f.append(float(p4[j]))    
    return p1f,p2f,p3f,p4f 
    
             
    


def calc(x,r,k,obj,prop):
    # brg 4.9.2013
    print "calculations "
    p,q,v,w=submit_parameters()
    # calculation partial concordance
    c=rmod2.marray3(k,r,r)
    for j in range(0,k):
        for i1 in range(0,r):
            for i2 in range(0,r):
                if x[i1][j]>=x[i2][j]-q[j]:
                    c[j][i1][i2]=1.0
                elif x[i1][j]<x[i2][j]-p[j]:
                    c[j][i1][i2]=0.0
                else:
                    c[j][i1][i2]=1.0*(x[i1][j]-x[i2][j]+p[j])/(1.0*p[j]-1.0*q[j])

    # total concordance
    tc=rmod2.marray(r,r)

    for i1 in range(0,r):
        for i2 in range(0,r):
            sumtc=0
            for j in range(0,k):
                sumtc+=w[j]*c[j][i1][i2]
            tc[i1][i2]=sumtc


    # calculation partial disconcordance
    d=rmod2.marray3(k,r,r)
    for j in range(0,k):
        for i1 in range(0,r):
            for i2 in range(0,r):
                if x[i2][j]>x[i1][j]+v[j]:
                    d[j][i1][i2]=1.0
                elif x[i2][j]<=x[i1][j]+p[j]:
                    d[j][i1][i2]=0.0
                else:
                    d[j][i1][i2]=1.0*(x[i2][j]-x[i1][j]-p[j])/(1.0*v[j]-1.0*p[j])



    # determination of the discordance set, speciific for each object pair and criterion
    Disc=rmod2.marray(r,r)
    for i1 in range(0,r):
        for i2 in range(0,r):
            Disc[i1][i2]=set([])
            for j in range(0,k):
                if d[j][i1][i2]>tc[i1][i2]:
                    Disc[i1][i2].add(j)
                else:
                    pass
            #print "i1= ",i1,"  i2= ",i2,"  Disc= ",Disc[i1][i2]
    print "Disc - done "

    # credibility index
    cred=rmod2.marray(r,r)
    for i1 in range(0,r):
        for i2 in range(0,r):
            faktor=tc[i1][i2]
            for j in range(0,k):
                if j in Disc[i1][i2]:
                    if tc[i1][i2]!=0:
                        faktor=faktor*(1.0-1.0*d[j][i1][i2])/(1.0-1.0*tc[i1][i2])
                    else:
                        pass
                else:
                    pass
            cred[i1][i2]=faktor    
                

##
    # HD on basis of dominance dom and (invertred) subdominance as in PROMETHEE
    # This deviates, so far I see from the ELECTRE variants
    dom=rmod2.matrixrowsum(cred,r,r)
    subdom=rmod2.matrixcolsum(cred,r,r)
    maxsubdom=max(subdom)
    indic2=[]
    for i in range(0,r):
        indic2.append(maxsubdom-subdom[i])

    dmnewindic=rmod2.marray(r,2)
    for i in range(0,r):
        dmnewindic[i][0]=dom[i]
        dmnewindic[i][1]=indic2[i]
        #print "i= ",i,"  1 : ",dmnewindic[0],"   2:  ",dmnewindic[1]

    #print "dmnewindic"
    #rmod2.matout(r,2,dmnewindic)
    knew=2
    return dmnewindic,r,knew,d,tc,cred

## Ausgaben, Graphik    
def HD(x,r,k,obj,prop,name):
    # brg 26.7.2013, 29.8.2013, 4.9.2013
    global relat
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)  
    
    name=Tkinter.Toplevel(hf)
    
    freq=Tkinter.Frame(name,width=400,height=400)
    freq.pack()
    relathilf=rmod2.marray(r,r)
    relat=rmod2.marray(r,r)
    relathilf=rmod2.comp(r,k,x)
    for i1 in range(0,r):
        for i2 in range(0,r):
            relat[i1][i2]=relathilf[i2][i1]
    print "relat-matrix"
    rmod2.matout(r,r,relat)
    print"--"
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta_electre=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta_electre[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta_electre)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta_electre)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
    txteq="Equivalence classes"+"\n"
    txteq+=60*"="+"\n"
    txteq+=txt
    
    cov=rmod2.cover(rred,tr,lext)
    ts=ScrolledText(freq,width=80,height=4)
    ts.pack()
    ts.insert("end",txteq)
    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()
        
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
    

# main ELECTRESimpl
# brg 1.9.2013
# towards ELECTRE III after J.Borken, Dissertation,2005
# test , maunally was successful!
# 3.9.2013
# 4.9.2013 ---> electre6.py PyHasse-struktur
# ........---> electre5.py Strukure evtl mit Koppatz bearbeiten

global x,r,k,obj,prop,p,q,v,w,xnew,kn,d,tc


def selectandopenfile():
    x,r,k,obj,prop=fileopen()   #basic dm 

def electre_parameters():
    global p,q,v,w
    #weights,preference, indifference parameters
    param_Electr()   #Electr-specific parameters
    

def calc_electre():
    # brg 4.9.2013
    global r,k,kn,xnew,d,tc,cred
    xnew,r,kn,d,tc,cred=calc(x,r,k,obj,prop)



def HDorigdm():
    global r,k
    HD(x,r,k,obj,prop,"orig")

def HDelectre():
    global r,k,kn,xnew
    HD(xnew,r,kn,obj,prop,"Electre")

def matrices():
    # brg 54.9.2013
    global tc,d,cred
    import raioop2
    sel=esel.get()
    
    if sel=="tc":
        # Output concordance total
        app1=raioop2.brgmatrixoutput(hf,tc,"tptc","Total concordance"," ",r,r,obj,obj,"total concordance")
        app1.ausgabe()
    elif sel=="d":
        for j in range(0,k):
            app2=raioop2.brgmatrixoutput(hf,d[j],"tpdis","local discordance "+str(prop[j])," ",r,r,obj,obj,"local discordance "+str(prop[j]))
            app2.ausgabe()
        #output discordance
        
    elif sel=="cred":
        #Output credibility
        app3=raioop2.brgmatrixoutput(hf,cred,"tpcred","credibility matrix"," ",r,r,obj,obj,"credibility")
        app3.ausgabe()
    else:
        pass

def save_zeta():
    # brg 26.7.2013, 24.9.2014
           
    fnzeta=tkFileDialog.asksaveasfilename(parent=hf,title="save zeta-files in PyHasseformat")
    fcsv=open(fnzeta,"w")
    fcsv.write(str(r)+"\n")
    for i1 in range(0,r):
        for i2 in range(0,r):
            fcsv.write(str(relat[i1][i2])+"\t")
        fcsv.write("\n")
    fcsv.close()

def show_parameters():
    # brg 24.9.2014
    tpparam=Tkinter.Toplevel(hf)
    tpparam.title('parameters of ELECTRE ')
    tparam=ScrolledText(tpparam,height=10,width=60)
    tparam.pack()
    txt="actually used parameters of calculation "+"\n"
    txt+="Indifference: "
    for j in range(0,k):
        txt+=str(p1f[j])+"\t"
    txt+="\nsignicance: "
    for j in range(0,k):
        txt+=str(p2f[j])+"\t"
    txt+="\n  veto:     "
    for j in range(0,k):
        txt+=str(p3f[j])+"\t"
    txt+="\nweights:    "
    for j in range(0,k):
        txt+=str(round(p4f[j],3))+"\t"
    txt+="\n"
    txt+="  -  -  - e o f  -  -   - "
    tparam.insert("end",txt)
    
        

    
hf=Tkinter.Tk()
hf.title(' ElectreSimpl ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_electresimpl.txt",6,\
            "Sept, the 24th, 2014"," about eletresimpl ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_electresimpl.txt",6,\
            "Sept, the 24th, 2014"," help_electresimpl ", "white", "t1",80,5,ScrolledText)
    
Butt10=Tkinter.Button(hf,text="select and open file ",bg="cyan",width=40,command=selectandopenfile)
Butt10.pack()
fr=Tkinter.Frame(hf,bd=3, relief="sunken")
fr.pack()
txtnorm="By default a columnwise normalization is performed\n\
when the user want to suppress this, \n\
then enter a 'n' in the entry box"
lbnorm=Tkinter.Label(fr,text=txtnorm)
lbnorm.pack(side="left")
enorm=Tkinter.Entry(fr,width=3)
enorm.pack(side="left")
Butt20=Tkinter.Button(hf,text="Select the parameters of Electre ",bg="cyan",width=40,command=electre_parameters)
Butt20.pack()
Butt30=Tkinter.Button(hf,text="Calculation ",width=40,bg="cyan",command=calc_electre)
Butt30.pack()
lbsel=Tkinter.Label(hf,text="tc: total concordance \nd:all local discordances\n\
                cred: credibility matrix",bg="white")
lbsel.pack()
esel=Tkinter.Entry(hf,width=5)
esel.pack()
Butt40=Tkinter.Button(hf,text="Show the selected matrix (matrices) ",bg="white",width=40, command=matrices)
Butt40.pack()
Butt50=Tkinter.Button(hf,text="HD orig dm ",bg="white",width=40,command=HDorigdm)
Butt50.pack()
Butt60=Tkinter.Button(hf,text="HD after Electre-operations ",bg="cyan",width=40,command= HDelectre)
Butt60.pack()
Butt70=Tkinter.Button(hf,text="show Electre-parameters ",bg="cyan",width=40, command=show_parameters)
Butt70.pack()
lab80=Tkinter.Label(hf, text="save relation matrix, select a name where main parameters are included")
lab80.pack()
Butt80=Tkinter.Button(hf,text="save relation-matrix based on dom and subdom ",bg="cyan",width=40,command=save_zeta)
Butt80.pack()
Buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red", bd=4,command=hf.destroy)
Buttexit.pack(pady=5)

hf.mainloop()
