import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 19.12.17 Control prints
# 22.7.2018 gc_distribution


###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def interface_graphviz():
    # brg 9.9.2014
    #taken from mHDCl2
    covgr=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if i1!=i2:
                covgr[i1][i2]=cov[i1][i2]
    txtgr=rmod2.covtxt(covgr,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile3(fr,'t','w',txtgr,rred,rred) 
    import tkMessageBox
    tkMessageBox.showinfo(title="store graphviz-interface",message="successafull!")


    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####

def histogram(x,interval):
    # brg  22.07.18
    # x is a vector with quantities between 0 and 1
    # interval is the step, starting from 0 to 1 where
    # a count is done whether or not an element of x falls in this interval
    # example x = [0,0.2,0.5,0.05, 0.93, 1] and interval=0.1
    # then 0=<x[i]<0.1 ....2
    # 0.1=< x[i] < 0.2 ....0
    # ...
    # 0.9 =<x[i] <= 1 )note the upper limit will be couted too: ....2
    # result: h should then be [2, 0, 1, 0, 0, 1, 0, 0, 0, 2]
    linterv = int(1.0/interval)
    h=[]
    hdetails=[]
    for i in range(0,linterv):
        h.append(0)
        hdetails.append(0)
        for i2 in range(0,len(x)):
            if i<linterv-1:
                if i*interval<=x[i2]<(i+1)*interval:
                    h[i]+=1
            else:
                if i*interval<=x[i2]<=(i+1)*interval:
                    h[i]+=1 
        iu=round(i*interval,2)
        #print "iu = ",iu
        io=round((i+1)*interval,2)
        #print "io = ",io
        
        hdetails[i]=(str(iu),str(io),h[i])
    return h, hdetails    
    
    

def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 22.7.18
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def normalize():
    # brg 22.7.18
    global xred
    xred=rmod2.matrixnorm(rred,k,xred)

def HD():
    # brg 26.7.2013, 29.8.2013, 2.11.16, 22.7.18
    
    global x,la,ls,cov, rred, objred, zeta
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    print "actually used dm in HD..."    #
    rmod2.matout(rred,k,xred)
    print "  "
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #print "zeta = "        
    #rmod2.matout(rred,rred,zeta)
    #print " "
    Utotal = rmod2.incompzeta(rred,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def calc_gc_distribution():
    # brg 22.07.18
    global cim, incomp
    print "used data matrix in calc_gc_distribution "
    rmod2.matout(rred,k,xred)
    print " "
    cim=rmod2.marray(rred,rred)
    # matrix with the mutual differences of the sum q(i1,j) j=1,..,m
    incomp="n"
    incomp=e_incomp.get()  #incomp either "y" or "n"
    
    ci=rmod2.vecgen1(rred)   #the sum
    for i1 in range(0, rred):
        hilf1=0
        for j in range(0, k):
            hilf1+=xred[i1][j]
        ci[i1]=hilf1
        for i2 in range(0,rred):
            hilf2=0
            for j in range(0, k):
                hilf2+=xred[i2][j]
            ci[i2]=hilf2
            cim[i1][i2]=abs(ci[i1]-ci[i2])
    print "ci = ",ci        
    print "cim= "
    rmod2.matout(rred,rred,cim)
    print " "

def critvalue_gc():
    # brg 22.07.18
    global hdist, hdistvector, eps, maxgc, gcvector
    eps=float(eeps.get())
    hdist=0
    hdistvector=[]
    gcvector=[]
    zahl=0
    for i1 in range(0, rred-1):
        for i2 in range(i1+1,rred):
            if incomp=="n":
                hdistvector.append((i1,i2,cim[i1][i2]))
                gcvector.append(cim[i1][i2])
                if cim[i1][i2]<=eps:
                    hdist+=1
            else:
                if zeta[i1][i2]+zeta[i2][i1]==0:
                    hdistvector.append((i1,i2,cim[i1][i2]))
                    gcvector.append(cim[i1][i2])
                    if cim[i1][i2]<=eps:
                        hdist+=1
    print "gcvector = "
    rmod2.vecout(len(gcvector),gcvector)
    maxgc= max(gcvector)           
    
def calc_gc():
    # brg 22.07.18
    calc_gc_distribution()
    critvalue_gc()
    tpgc=Tkinter.Toplevel(hf)
    tpgc.title(" frequency of critical cases ")
    tgc=ScrolledText(tpgc,width=60, height=20)
    tgc.pack()
    txt=" Count of critical cases "+"\n"
    txt+="file = "+str(fn)+"\n"
    txt+="eps = "+str(eps)+"\n"
    txt+="maximale difference within cim "+str(round(maxgc,3))+"\n"
    if incomp=="y":
        txt+="only objectpairs x(i1), x(i2) with x(i1)||x(i2) ..."+"\n"
        txt+="...are considered"+"\n"
    txt+="count= "+str(hdist)+"\n"
    if incomp=="n":
        neff=rred*(rred-1)/2.0
    else:
        print "incomp= ",incomp
        hilf=0
        for i1 in range(0, rred):
            for i2 in range(0, rred):
                if zeta[i1][i2]+zeta[i2][i1]==0:
                    hilf+=1
        print "hilf = ",hilf            
        neff = hilf/(2.0)
    if neff!=0:    
        percentage=100*hdist/(1.0*neff)
    txt+="count of cases: "+str(neff)+"\n"
    if neff!=0:
        txt+="percentage = "+str(round(percentage,3))+"%"+"\n"
    tgc.insert("end",txt)
    
def show_details():
    # brg 22.07.18
    tpdetails=Tkinter.Toplevel(hf)
    tdetails=ScrolledText(tpdetails,width=80, height=40)
    tdetails.pack()
    txt="Details of calculation "+"\n"
    txt+="file : "+str(fn)+"\n"
    txt+="matrix of the absolute differences of sum(j) q(i1,j) - sum(j) q(i2,j) +\n"
    txt+="\t"
    for i in range(0, rred):
        txt+=str(objred[i])
    txt+="\n"
    
    for i1 in range(0,rred):
        txt+=str(objred[i1])+"\t"
        for i2 in range(0,rred):
            txt+=str(round(cim[i1][i2],3))+"\t"
        txt+="\n"
    txt+="\n"
    print hdistvector
    txt+=" all differences values i1 > i2 "+"\n"
    lhdist=len(hdistvector)
    for i in range(0, lhdist):
        txt+=str(objred[hdistvector[i][0]])+", "+str(objred[hdistvector[i][1]])+" value: "+str(round(hdistvector[i][2],3))+"\n"
    txt+="\n"
    txt+="Only the integers of(values*1000): "+"\n"
    for i in range(0,lhdist):
        txt+=str(int(1000*hdistvector[i][2]))+"\n"
    txt+="\n"    
    #
    gcnorm=rmod2.vecgen1(len(gcvector))
    for i in range(0, len(gcvector)):
        gcnorm[i] = gcvector[i]/(1.0*maxgc)
    print "gcnorm"
    print gcnorm
    histo, histodetails=histogram(gcnorm,0.1)
    for i in range(0, len(histo)):
        if i<len(histo)-1:
            txt+=str(histodetails[i][0])+"= < " +"  delta <  "+str(histodetails[i][1])+" : "+str(histodetails[i][2])+"\n"
        else:
            txt+=str(histodetails[i][0])+"= < " +"  delta =< "+str(histodetails[i][1])+" : "+str(histodetails[i][2])+"\n"
    txt+="\n"
            
    txt+="-   -   -   eof  -   -   -"
    tdetails.insert("end",txt)
    barth=["0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1"]
    app=raioop2.brgbar4(hf,histo,barth,"delta-histogram",10)
    app.ausgabe()
    
    
    
    
        
        
        
        
    
                               
    

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' gc_distribution ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_gc_distribution.txt",2,\
            "July, the 22nd, 2018"," about gc_distribution", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_gc_distribution.txt",2,\
            "July, the 22nd, 2018"," help_gc_distribution ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=25, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=25, bg="cyan", command=HD)
buttHD.pack(pady=5)
buttnorm=Tkinter.Button(fr,text="Normalize the data (dm will be overwritten)",bg="cyan",width=40,command=normalize)
buttnorm.pack()                        
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
lb2 = Tkinter.Label(fr, text="Which tolerance for the difference of ci(x), ci(y) ")
lb2.pack()
eeps=Tkinter.Entry(fr,width=5)
eeps.pack()
lb3=Tkinter.Label(fr, text="Only incomparable objects , then enter 'y'")
lb3.pack()
e_incomp=Tkinter.Entry(fr,width=3)
e_incomp.pack()
buttcalc = Tkinter.Button(fr, text="calc critical cases ",bg="cyan", width=40,command=calc_gc)
buttcalc.pack(pady=5)
buttdetails = Tkinter.Button(fr,text="show details ",bg="cyan",width=40,command=show_details)
buttdetails.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=5)

hf.mainloop()
