# -*- coding: cp1252 -*-
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
#import pylab

# Brg 17.1.08 sensi3.py with graphics, 4.2.08
# Brg 17.2.10 from sensi12 derived
# Brg 17.2.10: qi the attributes then comparison:
#               say: q1 with g1*q1, (q1,q2)with g1q1+g2*q2, (q1,q2,q3,...) with sum gi*qi, i=1,...
# Brg: read in pdt-File and rearrangements
# brg 22.12.2014 problem with fropen2
# brg 22.12.2014 many problems. I wonder that this module worked in former time

def about():
    """ About gevol """
    # Brg 16.8.08
    aboutsensi=raioop2.brgabout(hf,"tp2","about_gevol.txt",3,\
            "Dec. 22nd,2014"," about_gevol ", "white", "t2",120,3,ScrolledText)
    

def raihelp():
    """ Help about sensi """
    
    #  Use of OOP
    helpsensi=raioop2.brgabout(hf,"tp1","help_gevol.txt",3,\
            "Dec. 22nd,2014"," help_gevol ", "white", "t1",120,10,ScrolledText)

def File_select_and_open():
    """select a file and open it """
    #Brg 17.1.08, 18.1.10
    #*:17.1.08
    #akt: 18.1.08
    global fn,r,objred,zeta2,eweights,dm,rred,xred,k, obj, prop
    
    
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()
    tpweights2=Tkinter.Toplevel(hf)
    tpweights2.title("weights selection ")
    fropen2=Tkinter.Frame(tpweights2)
    fropen2.pack()
    lbgew=Tkinter.Label(fropen2,text=" Entry fields for the weigths\n sorted in the order of the attributes")
    lbgew.pack(side="top")
    eweights=rmod2.vecgen1(k)
    for j in range(0,k):
        eweights[j]=Tkinter.Entry(fropen2,width=4)
        eweights[j].pack(side="left")

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)    
    ###############################################################


def HD():
    freq=Tkinter.Toplevel(hf)
    zetahilf=rmod2.comp(rred,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
            
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    zeta2=rmod2.cover(rred,tr,lext)
    
    if rred>100:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=400,height=400,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for i1 in range(0,rred):
            if i!=i1:
                if zeta2[i][i1]==1:
                    txt3+=" "+objred[i1]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)  
    return 

def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def seloppdtfile():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from pycluster1.py
    #* 1.6.09
   
    global fn,r,k,dm,prop,obj,rred,xred,objred,eweights
    fn=tkFileDialog.askopenfilename()
    r,k,dm,obj,prop=rmod2.raireadin5(fn)
    lbopenpdt.config(bg="yellow")
    lbopenpdt["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    lbgew=Tkinter.Label(fropenpdt,text=" Entry fields for the weigths\n sorted in the order of the attributes")
    lbgew.pack(side="top")
    eweights=rmod2.vecgen1(k)
    for j in range(0,k):
        eweights[j]=Tkinter.Entry(fropenpdt,width=4)
        eweights[j].pack(side="left")

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)
    
def showpdtdm():
    # 29.10.2012, 30.10.2012 taken from pycluster1.py
    txt="show pdt-file "+"\n"
    txt+="objects: "
    for i in range(0,r):
        txt+=str(obj[i])+", "
    txt+="\n"    
    txt+="attributes "
    for j in range(0,k):
        txt+=str(prop[j])+", "
    txt+="\n"
    txt+="data matrix "+"\n"
    for i in range(0,r):
        for j in range(0,k):
            txt+=str(round(dm[i][j],3))+", "
        txt+="\n"
    txt+="\n"
    txt+="\n - - -  e o f - - -"
    tppdtshow=Tkinter.Toplevel(hf)
    tppdtshow.title(' pdt file ')
    tpdtshow=ScrolledText(tppdtshow,width=80, height=10)
    tpdtshow.pack()
    tpdtshow.insert("end",txt)

      
def extract(r,zetah,i,obj):
    """extracts from the crisp matrix the order relations"""
    #brg 30.11.07, 11.4.08, 16.8.08 taken from fuzzyHD10, 4.10.08, 17.2.10
    # the matrix order corresponds to object
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    ec=rmod2.dmcompress(r,r,zetah)             #30.11. from cq the equivalent relations
    eqtext=""
    eqtext+=rmod2.eqcguiout1(r,ec,obj)        #30.11. matrix output
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    
    ltxt=len(txt)
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    if b=="true":
        texteq="No equivalent objects in case "+str(i)
    else:
        texteq="Case "+str(i)+": Equivalent objects"
    
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,zetah) # columns eliminated
    zeta,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
        #print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        #print "ex5: rs = ",rs
    return zeta,objec,rs


def calc():
    """calculates sensitivity """
    #Brg 17.1.08, 16.8.08
    #*17.1.08
    #akt: 16.8.08
    #note: 
    #source:    main body taken from sensi1.py
    global newcase
    
    
    case=rmod2.preparcases(k)
    print "case = ",case
    di=rmod2.vecgen1(k+1)
    disort=rmod2.vecgen1(k+1)
    di[0]=0
    #di is the distance vector based on zeta-matrix-comparisons
    zeta0=rmod2.comp(r,k,dm)
       
    for i in range(1,k+1):
        zetah=rmod2.comp3(r,k,case,i,dm)  #zetah may contain equivalent rows/columns 
        zeta1,objred,rred=extract(r,zetah,i,obj)  #important step, modified procedure: 4.10.08
        zeta=rmod2.marray(rred,rred)
        for i2 in range(0,rred):
            for i3 in range(0,rred):
                zeta[i2][i3]=zeta1[i3][i2]
        lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
        di[i]=rmod2.posetdistanz(r,zeta0,zetah)
              
    #print "Distances: ",di   ## muss als Ergebnis dargestellt werden 
    
    dibar=rmod2.vecgen1(k)
    for i in range(1,k+1):
        dibar[i-1]=di[i]
       
    gr=raioop2.brgbar2(hf,"tpbar",k,dibar,prop,"red","white",50,"sensitivity",35,\
                      15,25)
    gr.ausgabe()
    ##################################################################################################
    disort,prot=rmod2.raisort(k+1,di)
    #print "disort ",disort
    #print "prot   ",prot 
    #new cases according to the importance
    newcase=rmod2.marray(k,k)
    for i7 in range(0,k):
        for j in range(0,k):
            newcase[i7][j]=-1
    for i8 in range(0,k):
        zaehl=0
        for j in range(i8+1,k+1):
            newcase[i8][zaehl]=prot[j]
            zaehl+=1
    rmod2.matout(k,k,newcase)        
    #########################################################################
    # newcase: first line all attributes                                    #
    #          second line the least important arribute removed             #
    #          third line: the next less important attribute removed etc    #
    #          ...                                                          #
    #          last line: the most important attribut                       #
    #          note the corresponding indexes                               #
    #########################################################################
    
                    
def checknc(newcase,l,j,k):
    flagnc=0
    for ll in range(0,k):
        if int(newcase[l][ll])==j+1:
               flagnc=1
    return flagnc          
    
def gindex(newcase,dm,g,k,r):
    dmn=rmod2.matrixnorm(r,k,dm)
    print "dmn = "
    rmod2.matout(r,k,dmn)
    compindex=rmod2.marray(r,k)
    for j in range(0,k):
        g[j]=float(eweights[j].get())

    for j in range(0,k):
        for i in range(0,r):
            for j2 in range(0,k):
                flc=checknc(newcase,j,j2,k)
                print j,i,j2,"  flc= ",flc, "  dmn= ",dmn[i][j2]
                compindex[i][j]+=g[j2]*flc*dmn[i][j2]
                
    print "Result as compindex-matrix"    
    rmod2.matout(r,k,compindex)
    downsetcount=rmod2.marray(r,k)
    
    for j in range(0,k):
        for i1 in range(0,r):
            for i2 in range(0,r):
                if compindex[i1][j]>=compindex[i2][j]:
                    downsetcount[i1][j]+=1

    rmod2.matout(r,k,downsetcount)                
    return downsetcount      


def gcalc():
    import random
    global dsetc
                          
    
    propm=rmod2.vecgen1(k) #names of the newcases
    namecases=rmod2.vecgen1(k)
    g=rmod2.vecgen1(k)
    revdsetc=rmod2.marray(r,k)
    dsetc=gindex(newcase,dm,g,k,r)
    for i in range(0,r):
        for j in range(0,k):
            revdsetc[i][k-1-j]=dsetc[i][j]
    for j1 in range(0,k):
        propm[j1]="cs"+str(j1)
        hilf=""
        for j2 in range(0,k):
            if newcase[j1][j2]!=-1:
                hilf+=str(newcase[j1][j2])+" "
        namecases[k-1-j1]=hilf
    tweights=""
    tcases=""
    for j1 in range(0,k):
        tweights+=str(round(g[j1],3))+","
        tcases+=namecases[j1]+"_"
    lbaddinfo1.config(text="weight-vector= "+tweights+"\n"+"newcases = "+tcases)        
    app1=raioop2.brgmatrixoutput(hf,revdsetc,"tpCI","CI=f(natt)","-",r,k,propm,obj,"  CI-natt  ")
    app1.ausgabe()

def objan():
    """ Daughter window for the object specific analysis (osa)
    taken from sensi12.py and modified , brg  18.2.10 """
    global downsetcountPO
    
    namecases=rmod2.vecgen1(k)
    

    txt1="lt"
    txt2="eg"
    downsetcountPO=rmod2.marray(r,k)
    revdcPO=rmod2.marray(r,k)
    propm=rmod2.vecgen1(k)
    for j in range(0,k):  #case-loop
        objx=rmod2.comp4(r,k,newcase,j,dm)  ## here is a crucial step!
        redobjx=rmod2.marray(r,r)
        quobx=rmod2.marray(r,r)
        unit=rmod2.matunit(r)
        rmod2.matadd(r,1.0,objx,-1.0,unit,redobjx)
        rmod2.qualcomp(r,objx,quobx)
        c1,txt1,txt2=rmod2.porgraph(r,quobx,txt1,txt2)
        #print "case No ",j
        #rmod2.strmatout(r,r,quobx)
        #print " "
        for iob in range(0,r):
            for iob2 in range(0,r):
                if c1[iob2][iob]!=-1:
                    downsetcountPO[iob][j]+=1
                        
    print "PoA-downset count "
    rmod2.matout(r,k,downsetcountPO)
    for i in range(0,r):
        for j in range(0,k):
            revdcPO[i][k-1-j]=downsetcountPO[i][j]
    for j1 in range(0,k):
        propm[j1]="cs"+str(j1)
        hilf=""
        for j2 in range(0,k):
            if newcase[j1][j2]!=-1:
                hilf+=str(newcase[j1][j2])+" "
        namecases[k-1-j1]=hilf
    
    tcases=""
    for j1 in range(0,k):
        tcases+=namecases[j1]+"_"
    lbaddinfo2.config(text="newcases = "+tcases)        
    app2=raioop2.brgmatrixoutput(hf,revdcPO,"tpCI2","PO=f(natt)","-",r,k,propm,obj,"  Successorsets-natt  ")
    app2.ausgabe()
    
           
def compardownsets():
    import pstat
    import stats
    global cdownset
    
    perc25=rmod2.vecgen1(k)
    perc50=rmod2.vecgen1(k)
    perc75=rmod2.vecgen1(k)
    propm=rmod2.vecgen1(k)
    namecases=rmod2.vecgen1(k)
    fmaxstepq=rmod2.vecgen1(r)
    cdownset=rmod2.marray(r,k)
    revcc=rmod2.marray(r,k)  #same as cdownset, however columns ordered from one indicator --- all indicators
    for i in range(0,r):
        for j in range(0,k):
            cdownset[i][j]=dsetc[i][j]-downsetcountPO[i][j]
            
    
    for j in range(0,k):
        hilf=rmod2.vecgen1(r)
        for i in range(0,r):
            hilf[i]=cdownset[i][j]
        perc25[j]=pstat.lscoreatpercentile(hilf,0.25)
        perc50[j]=pstat.lscoreatpercentile(hilf,0.50)
        perc75[j]=pstat.lscoreatpercentile(hilf,0.75)
    


    for i in range(0,r):
        for j in range(0,k):
            revcc[i][k-1-j]=cdownset[i][j]
    for j1 in range(0,k):
        propm[j1]="cs"+str(j1)
        hilf=""
        for j2 in range(0,k):
            if newcase[j1][j2]!=-1:
                hilf+=str(newcase[j1][j2])+" "
        namecases[k-1-j1]=hilf
    
    tcases=""
    tperc50=""
    for j1 in range(0,k):
        tcases+=namecases[j1]+"_"
        if perc50[k-1-j1]>=0:
            tperc50+=str(round(perc50[k-1-j1],1))+","
        else:
            tperc50+="set:0,"

    lbaddinfo3.config(text="newcases = "+tcases+"\n"+"percentile50: "+tperc50)        
    app3=raioop2.brgmatrixoutput(hf,revcc,"tpCI","CI vs PoA","-",r,k,propm,obj,"  CI-natt  ")
    app3.ausgabe()
    

def view_on_object():
   
   hilfpresentation1=rmod2.vecgen1(k)
        
   

   try:
       obj_wanted=eobj.get()
   except:
       idobj=int(0.5*r)
       obj_wanted=obj[idobj]
       
   lbvoo.config(text="object "+obj_wanted+"  selected",bg="yellow")    
   crevdownset=rmod2.marray(r,k)
   for i in range(0,r):
       for j in range(0,k):
           crevdownset[i][k-1-j]=cdownset[i][j]
   iwanted=obj.index(obj_wanted)
   
   for j in range(0,k):
       hilfpresentation1[j]=crevdownset[iwanted][j]
       
   barth=[]
   for j in range(0,k):
        barth.append("case"+str(j))
   comment2="Object "+obj_wanted
   histotitel="  g-evolution "
   breite_bar=10
   app4=raioop2.brgbar6(hf,hilfpresentation1,barth,comment2,histotitel,breite_bar)
   app4.ausgabe()
    


hf=Tkinter.Tk()
hf.title('   HD and g-evolution')
about()
raihelp()
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen=Tkinter.Label(fropen,text="")
lbopen.pack()
lbfileselect=Tkinter.Label(fropen,text=">>>select,open file,  >>>")
lbfileselect.pack(side="left",pady=5)
buttfileselect=Tkinter.Button(fropen,text="select and open file ",width=25, bg="white",command=File_select_and_open)
buttfileselect.pack(side="left",pady=5)
frshow=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshow.pack(fill="x")
buttshow=Tkinter.Button(frshow,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=5)

fropenpdt=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropenpdt.pack()
lbopenpdt=Tkinter.Label(fropenpdt,text=" ")
lbopenpdt.pack()
lbfileselectpdt=Tkinter.Label(fropenpdt,text=">>>select,open pdt-file,  >>>")
lbfileselectpdt.pack(side="left",pady=5)
buttfileselectpdt=Tkinter.Button(fropenpdt,text="select and open pdt-file ",width=25, bg="white",command=seloppdtfile)
buttfileselectpdt.pack(side="left",pady=5)
frshowpdt=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshowpdt.pack(fill="x")
buttshowpdt=Tkinter.Button(frshowpdt,text="show pdt-data matrix ",width=25,command=showpdtdm)
buttshowpdt.pack(pady=5)

frcalc=Tkinter.Frame(hf,relief="sunken",bd=2)
frcalc.pack(pady=5)
buttHD=Tkinter.Button(frcalc,text="Hassediagram",bg="cyan",width=25,command=HD)
buttHD.pack()
buttcalc=Tkinter.Button(frcalc,text="(1) global calculate",bg="cyan",width=25,command=calc)
buttcalc.pack(pady=25)
buttgcalc=Tkinter.Button(frcalc,text=" (2)composite indicators ",bg="cyan",width=25,command=gcalc)
buttgcalc.pack()
lbaddinfo1=Tkinter.Label(frcalc,text="\n")
lbaddinfo1.pack()
buttPoA=Tkinter.Button(frcalc,text="(3)Downsetcount PoA",width=25,bg="cyan",command=objan)
buttPoA.pack()
lbaddinfo2=Tkinter.Label(frcalc,text="")
lbaddinfo2.pack()
buttcompare=Tkinter.Button(frcalc,text="(4) Compare the downsets ",width=25,bg="cyan",command=compardownsets)
buttcompare.pack()
lbaddinfo3=Tkinter.Label(frcalc,text="")
lbaddinfo3.pack()
lbvoo=Tkinter.Label(hf,text="")
lbvoo.pack()
frdisplay=Tkinter.Frame(hf,relief="sunken",bd=2)
frdisplay.pack(pady=10)
lbexpla=Tkinter.Label(frdisplay,text="Select object name >>>>")
lbexpla.grid(row=0,column=0)
eobj=Tkinter.Entry(frdisplay,width=10)
eobj.grid(row=0,column=2)
buttdisplay=Tkinter.Button(frdisplay,text=" Display g-evolution for selected object ",width=40,bg="cyan",command=view_on_object)
buttdisplay.grid(row=2,column=2)
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=10,command=hf.destroy)
buttexit.pack(pady=30)




























hf.mainloop()
