import rmod2
import raioop2
import Tkinter
import tkFileDialog
from ScrolledText import *



# brg 17.7.2012





def selectopen():
    # brg 17.7.2012 (adopted from HDsimpl1)
    global zeta,cov,objred,rred,k,xred
    
    
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)  
    
    #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #

    cov=rmod2.trred(rred,zeta)
    for i in range(0,rred):
        cov[i][i]=0

    posetinfo(rred,zeta,fn,objred,prop)
    lb2.config(text="select location and filename of graphviz-file ")
    stogv()

def stogv():
    """ stores the cover matrix in graphviz
        format """
    # brg 15.3.09
    # File-name is a request within 'brgsavefile1'
    txtgr=rmod2.covtxt(cov,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile1(hf,'yellow','t','w',txtgr,rred,rred)


def posetinfo(rred,zeta,fn,objred,prop):
    # brg 17.7.2012 from HDweightsMC2.py
    #comparabilities and incomparabilities, count of minimal and maximal elements

    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    levmax=-10**20     #20.6.08
    lmaxch=len(lext)
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])

    comparabilities=0
    for i in range(0,rred):
        for j in range(0,rred):
            if i!=j:
                comparabilities+=zeta[i][j]
    utotal=0
    for i in range(0,rred):
        for j in range(0,rred):
            if zeta[i][j]==0 and zeta[j][i]==0:
                utotal+=0.5

    rsumzeta=rmod2.matrixrowsum(zeta,rred,rred)
    #print "rsumzetaMC = ",rsumzetaMC
    maxcount=0
    objmax=" "
    for i in range(0,rred):
        if rsumzeta[i]==1:
            maxcount+=1
            objmax+=objred[i]+", "
    
    csumzeta=rmod2.matrixcolsum(zeta,rred,rred)
    #print "csumzetaMC = ",csumzetaMC
    mincount=0
    objmin=" "
    for i in range(0,rred):
        if csumzeta[i]==1:
            mincount+=1
            objmin+=objred[i]+", "

    isocount=0
    objiso=" "
    for i in range(0,rred):
        if csumzeta[i]==1 and rsumzeta[i]==1:
            isocount+=1
            objiso+=objred[i]+", "

    tpposetinfo=Tkinter.Toplevel(hf)
    tpposetinfo.title(' infos about the poset\n (diagram by graphviz)')
    tposinf=ScrolledText(tpposetinfo,width=80,height=10)
    tposinf.pack()
    txt1="Info about poset of "+fn+"\n"
    txt1+=60*"="+"\n"
    txt1+="1) general info \n"
    txt1+="objects (representants)\n"
    txthilf1=""
    for ob in objred:
        txthilf1+=ob+", "
    txt1+=txthilf1+2*"\n"
    txt1+="properties (indicators, attributes) "+"\n"
    txthilf2=""
    for att in prop:
        txthilf2+=att+", "
    txt1+=txthilf2+"\n"
    txt1+="\n2)posetic info " +"\n"
    txt1+=" Number of levels (= length of maxim. chains)  = "+str(zzmax)+"\n"
    txt1+=" Number of elements in largest level           = "+str(levmax)+"\n" 
    txt1+=" Comparabilities                               = "+str(comparabilities)+"\n"
    txt1+=" Incomparabilities                             = "+str(utotal)+"\n"
    txt1+=" Count of maximal elements                     = "+str(maxcount)+"\n"
    txt1+=" Maximal elements \n"
    txt1+=objmax+"\n"
    txt1+=" Count of minimal elements                     = "+str(mincount)+"\n"
    txt1+=" Minimal elements \n"
    txt1+=objmin+"\n"
    txt1+=" Count of isolated objects                     = "+str(isocount)+"\n"
    txt1+=" Isolated objects \n"
    txt1+=objiso
    
    
    txt1+="\n\n  -- end --"        
    tposinf.insert("end",txt1)
    
def localinfo():
    # brg 17.7.2012
    # info about two represerntants
    torder=ScrolledText(tporder,width=80,height=10)
    torder.pack()
    txt="Local order information "+"\n"
    txt+=60*"="+"\n"
    obj1=eobj1.get()
    obj2=eobj2.get()
    flag=0
    if obj1 in objred:
        txt+=obj1+", "
    else:
        flag=1
        txt+=obj1+":++sorry, this is no representant "+"\n"

    if obj2 in objred:
        txt+=obj2+"\n"
    else:
        flag=1
        txt+=obj2+":++sorry, this is no representant "+"\n"

    if flag!=1:
        iob1=objred.index(obj1)
        iob2=objred.index(obj2)
        if zeta[iob1][iob2]==1:
            txt+=obj1+" comparable to "+obj2+"\n"
            if cov[iob1][iob2]==1:
                txt+=obj1+" is covered by "+obj2+"\n"
            else:    
                txt+=obj1+" < "+obj2+"\n"
        else:
            if zeta[iob2][iob1]==1:
                txt+=obj1+" comparable to "+obj2+"\n"
                if cov[iob2][iob1]==1:
                    txt+=obj1+" covers "+obj2+"\n"
                else:    
                    txt+=obj1+" > "+obj2+"\n"
            else:
                txt+=obj1 +" || "+obj2+"\n"
                countg=0
                counte=0
                for j in range(0,k):
                    if xred[iob1][j]>xred[iob2][j]:
                        countg+=1
                    if xred[iob1][j]==xred[iob2][j]:
                        counte+=1
                txt+=str(countg)+" attributes: "+obj1+" > "+obj2+"\n"
                txt+=str(counte)+" attributes: "+obj1+" = "+obj2+"\n"
                txt+=str(k-countg-counte)+" attributes: "+obj1+" < "+obj2+"\n"
        txt+="\n"
    txt+=20*" - "+"\n"
    torder.insert("end",txt)       
            
            
            
    


hf=Tkinter.Tk()
hf.title('Poset/graphviz ')
abouthdgr=raioop2.brgabout(hf,"tp1","about_graphvizHD.txt",1,\
            "July, 17th,2012"," about graphvizHD ", "white", "t1",80,5,ScrolledText)
helphdgr=raioop2.brgabout(hf,"tp1","help_graphvizHD.txt",2,\
            "July, 17th,2012"," help_graphvizHD ", "white", "t1",80,5,ScrolledText)
    
buttselectopen=Tkinter.Button(hf,text="select and open a file", bg="cyan",width=35,command=selectopen)
buttselectopen.pack()
lb1=Tkinter.Label(hf,text="")
lb1.pack()
lb2=Tkinter.Label(hf,text="")
lb2.pack()
lb3=Tkinter.Label(hf, text="insert two representants ")
lb3.pack()
eobj1=Tkinter.Entry(hf,width=5)
eobj1.pack()
eobj2=Tkinter.Entry(hf,width=5)
eobj2.pack()
tporder=Tkinter.Toplevel(hf)
tporder.title('local order infos ')
buttlocalinfo=Tkinter.Button(hf,text="order between any two repres. ",bg="cyan",width=35,command=localinfo)
buttlocalinfo.pack()
buttexit=Tkinter.Button(hf, text="exit",bg="red",width=25, command=hf.destroy)
buttexit.pack()

    
hf.mainloop()    
