import tkFileDialog
import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import Canvas
import random

#8.7.08 aus simi3.py
#9.7.08 erste Umbaumassnahmen, 15.7.08 weitere Umbaumassnahmen
# A c h t u n g . pay attention: in the original data set the order of objects must
# be the same in both files !!!
#16.7.08 Umbau jetzt fertig bis def hpor und die hpor spez. Teile
#26.7.08 Begin of testing the program (hpor1,hpor2),(hpor3,hpor4),(hpor5,hpor6)
#20.11.08 bug in showcover of HD12 eliminated, number of objects where
#         HDs are shown was changed from 20 to 30
# 16.10.09
# 24.12.2010: Save the new dm

x=rmod2.marray(200,200)
y=rmod2.marray(200,200)

def rfilter():
    """ subposet by generatiing a filter """
    # taken from mainHD19_3_3
    global i12set,orderchar
    dobj=o1.get()  
    #print "filter generating object: ",dobj
    #print "objred ",objred
    i1=objred12.index(dobj)
    i1set=set([i1])
    for j in range(0,n12):
        if zeta12[i1][j]==1:
            i1set=i1set|set([j])
    i2set=set([0])
    for i in range(1,n12):
        i2set=i2set|set([i])
    i12set=i1set&i2set
    orderchar="principal filter of "+dobj
    graphs()

def rideal():
    """ subposet by generating ideal """
    #taken from mainDD19_3_3
    global i12set,orderchar
    uobj=o2.get() #upper object
    i2=objred12.index(uobj)
    i2set=set([i2])
    for i in range(0,n12):
        if zeta12[i][i2]==1:
            i2set=i2set|set([i])
    i1set=set([0])
    for i in range(1,n12):
        i1set=i1set|set([i])
    i12set=i1set&i2set
    orderchar="principal ideal of "+uobj
    graphs()
     

def rinterv():
    """ subposet by generating interval """
    # taken from mainHD19_3_3
    global i12set,orderchar
    #print " rinterval i12set ",i12set
    dobj=o3.get() #lower object
    uobj=o4.get() #upper object
    #print "rinterval dobj ",dobj
    #print "rinterval uobj ",uobj
    i1=objred12.index(dobj)
    i2=objred12.index(uobj)
    i1set=set([i1])
    for j in range(0,n12):
        if zeta12[i1][j]==1:
            i1set=i1set|set([j])
    i2set=set([i2])
    for i in range(0,n12):
        if zeta12[i][i2]==1:
            i2set=i2set|set([i])
    i12set=i1set&i2set
    orderchar="interval of "+dobj+"  and  "+uobj    #5.3.09
    graphs()
     

def graphs():
    """ Digraph based on subset selections """
    # taken from mainHD19_3_3
    tpsub=Tkinter.Toplevel(hf)
    tpsub.title(' subgraphs ')
    
        
    l12=len(i12set)
    if l12==0:
        lbmsg=Tkinter.Label(tpsub,text="  +++empty order +++  ", font=("Arial",18,"bold"),bg="yellow")
        lbmsg.pack()
    else:    
        objsub=rmod2.vecgentext1(l12)
        z=0
        #print "in graphs: rred = ",rred,"  objred = ",objred 
        for i in range(0,n12):
            if objred12.index(objred12[i]) in i12set:
                objsub[z]=objred12[i]
                z+=1
            
        zetaneu=rmod2.marray(l12,l12)
        z1=0
        for i in range(0,n12):
            z2=0
            for j in range(0,n12):
                if i in i12set and j in i12set:
                    if zeta12[i][j]==1:
                        zetaneu[z1][z2]=1
                    else:
                        zetaneu[z1][z2]=0
                    z2+=1   
            if i in i12set:
                z1+=1

        #rmod2.matout(l12,l12,zetaneu)
        n=l12
        #rmod2.matout(n,n,zeta)
        lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zetaneu)
        #print "zzmax = ",zzmax
        
           
        #Adj-Listen

        adjc=rmod2.adjacent(n,lext,revlext,zetaneu)
            
        #Transitive reduced relations
        ts,tr=rmod2.trreduct(n,adjc,lext)
           
        
        cov12=rmod2.cover(n,tr,lext)
        if n>60:
            lbhd2=Tkinter.Label(tpsub,text=" graphical presentation not meaningful, see levels and cover-matrix ")
            lbhd2.pack()
            txt3="\n cover-matrix  \n"
            for i in range(0,n):
                txt3+="\t"+objred12[i]+"\t"
            txt3+="\n"
            for i in range(0,n):
                txt3+=objred12[i]+" :"
                for j in range(0,n):
                    txt3+=str(cov12[i][j])+"\t"
                txt3+="\n"
            txt3+=" -- end of list --"
            tcov=ScrolledText(tpsub,width=60, height=6)
            tcov.pack()
            tcov.insert("end",txt3)
        else:
            lbhd3=Tkinter.Label(tpsub,text=orderchar)
            lbhd3.pack()
            cv=Tkinter.Canvas(tpsub,width=300,height=200,bg="white")
            lz=zzmax
            l=rmod2.vecgen1(lz)
            for i in range(0,lz):
                l[i]=len(lobj[i])

            pos=rmod2.vecgen1(lz)
            for i in range(0,lz):
                pos[i]=l[i]
            
            geomx=rmod2.marray(n,n)
            geomy=rmod2.marray(n,n)

            geom0x=10
            geom0y=20
            for i in range(0,lz):
                for j in range(0,l[i]):
                    geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                    geomy[i][j]=geom0y+(160.0/lz)*i
                

            for i in range(0,lz-1):
                for j in range(0,l[i]):
                    #print obj[lobj[i][j]]
                    for i1 in range(i+1,lz):
                        for j1 in range(0,l[i1]):
                            #print obj[lobj[i1][j1]]
                            if cov12[lobj[i1][j1]][lobj[i][j]]==1:
                                #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


            for i in range(0,lz):
                for j in range(0,l[i]):
                    cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                    cv.create_text(geomx[i][j],geomy[i][j],text=objsub[lobj[i][j]])
            garrow1x=210
            garrow1y=20
            garrow2y=190
            cv.pack()

def HD12(cov,zeta12,zzmax,levmax,lobj,objred,rred,comparabilities,utotal):
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #
    tp12=Tkinter.Toplevel(hf)
    tp12.title(' HD of averaged ranks ')
    freq12=Tkinter.Frame(tp12)
    freq12.pack()
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
        
    n=rred

    if n>200:
        cover_show()                  #20.1.08
    else:
        
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq12,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(int(1.0*actwidth/2.0),actheight-5,text="compar.:  "+str(comparabilities)+\
                       ",   incomp. "+str(utotal))
        cv.pack()
        
        buttfilter.config(state="active",bg="cyan")
        buttideal.config(state="active",bg="cyan")
        buttinterv.config(state="active",bg="cyan")
        




def sf():
    #brg  31.5.09, 1.6.09, taken from interval8
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
    for i in range(0,r):
        print objn2[i]," ",
    print " "    
    rmod2.raiwrite5(fn,dm12,objn2,["rkav1","rkav2"],r,2)
    lbsuccess.config(text="matrix with \n"+str(r)+"  rows  and "+str(2)+"\n  columns stored",bg="yellow")


def about():
    """ about hpor vs 3 of Dec, 24th, 10 """
    txtabout1="Helm,D., 2006. Evaluation of Biomonitoring Data. \n\
    In: Bruggemann,R. and L.Carlsen (eds), Partial Order in Environmental Sciences and Chemistry, \n\
    Springer-Verlag, Berlin, pp. 285-307\n"
    txtabout2="Carlsen,L.2008, Hierarchical partial order ranking\n\
    Environ.Pollution 155, 247-253."
    txtabout0="Author: Bruggemann, R., hpor version 3, Dec. 24th, 2010 "
    tpabout=Tkinter.Toplevel(hf,width=100)
    tpabout.title(' about hpor ')
    txt=" "
    txt+="\n"+txtabout0
    txt+="\n\n"+"see for further references: "
    txt+="\n"+txtabout1
    txt+="\n"+txtabout2
    txt+="\n\n   -  -  -  end of file - - - "
    tabout=ScrolledText(tpabout,width=100,height=5)
    tabout.pack()
    tabout.insert("end",txt)
    
    

    
def fileselect():
    """ file open 1, file open 2"""
    # Brg 15.1.08,16.7.08
    #*:15.1.08
    #akt: 16.7.08
    #note: a variant of fileselect, used in other HD programs
    #source:-
    import tkFileDialog
    global dm1,dm2,obj1,obj2,prop1,prop2,r,k1,k2,fn1,fn2
    fn1=tkFileDialog.askopenfilename()
    fn2=tkFileDialog.askopenfilename()
    dm1,obj1,prop1,r1,k1=rmod2.EXCELreadin4(fn1)
    dm2,obj2,prop2,r2,k2=rmod2.EXCELreadin4(fn2)
    # it may be that there are the same objects but in different order in the two different files
    tp1=Tkinter.Toplevel(hf)
    tp1.title('open/select')
    lbfileselect=Tkinter.Label(tp1, bg="yellow",text = "opened file1 with "+str(r1)+" rows and "+str(k1)+" columns\n\
and file2 with "+str(r2)+" rows and "+str(k2)+"  columns")
    lbfileselect.pack()
    if r1!=r2:
        lberror=Tkinter.Label(tp1,bg="yellow",text="++++ error : unequal number of objects +++"\
                              ,font=14 )
        lberror.pack()
        buttexit=Tkinter.Button(tp1,text=" quit ",command=hf.destroy)
        buttexit.pack()
    else:
        r=r1
                                
    return

def showDM1():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from dds7.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM1 ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj1[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k1):
        txt2+=" "+prop1[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k1):
        txt3+=prop1[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj1[i+1]+"\t"
        for j in range(0,k1):
            txt3+=str(dm1[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def showDM2():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from dds7.py
    tp3=Tkinter.Toplevel(hf)
    tp3.title('show DM2 ')
    lbtp2=Tkinter.Label(tp3,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp3,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj2[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k2):
        txt2+=" "+prop2[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k2):
        txt3+=prop2[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj2[i+1]+"\t"
        for j in range(0,k2):
            txt3+=str(dm2[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    




def matchar1():
    """ characterizes the original dm """
    # brg 9.12.07, 16.12.07
    hfchar1=Tkinter.Toplevel(hf)
    hfchar1.title('characteristics 1')
    lbhfchar1=Tkinter.Label(hfchar1,text=' dm1 and characteristics of the dm1 ')
    lbhfchar1.pack()
    tm=ScrolledText(hfchar1,width=60,height=5)
    tm.pack()
    txtm="\n Data matrix (dm) 1  \n"
    txtm+="\t"
    for j in range(0,k1):
        txtm+=prop1[j+1]+"\t"
    for i in range(0,r):
        txtm+="\n"+obj1[i+1]+" :\t"    
        for j in range(0,k1):
            txtm+=str(round(dm1[i][j],2))+"\t"
        txtm+="\n"
    tm.insert("end",txtm)
    
    tchar=ScrolledText(hfchar1, width=60, height=5)
    tchar.pack()
    
    a1=rmod2.matrixchar(r,k1,dm1)
    #rmod2.matout(4,k,a)
    txt="\n characteristics of the dm1-properties \n"
    txt+="number of rows  "+str(r)+ "  number of columns "+str(k1)+"\n"
    for j in range(0,k1):
        txt+="\t"+prop1[j+1]+"       "
    txt+="\n"
    txt+="max   :\t"
    for j in range(0,k1):
        txt+=str(a1[0][j])+"\t"
    txt+="\nmin   :\t"
    for j in range(0,k1):
        txt+=str(a1[1][j])+"\t"
    txt+="\nmean  :\t"
    for j in range(0,k1):
        txt+=str(a1[2][j])+"\t"
    txt+="\nstdev :\t"
    for j in range(0,k1):
        txt+=str(a1[3][j])+"\t"
    txt+="\n"
    tchar.insert("end",txt)

def matchar2():
    """ characterizes the original dm """
    # brg 9.12.07, 16.12.07
    hfchar2=Tkinter.Toplevel(hf)
    hfchar2.title('characteristics 2')
    lbhfchar2=Tkinter.Label(hfchar2,text=' dm2 and characteristics of dm2 ')
    lbhfchar2.pack()
    tm=ScrolledText(hfchar2,width=60,height=5)
    tm.pack()
    txtm=""
    txtm+="\n Data matrix (dm) 2  \n"
    txtm+="\t"
    for j in range(0,k2):
        txtm+=prop2[j+1]+"\t"
    for i in range(0,r):
        txtm+="\n"+obj2[i+1]+" :\t"    
        for j in range(0,k2):
            txtm+=str(round(dm2[i][j],2))+"\t"
        txtm+="\n"
    tm.insert("end",txtm)
    tchar=ScrolledText(hfchar2, width=60, height=5)
    tchar.pack()
    
    a2=rmod2.matrixchar(r,k2,dm2)
    
    txt="\n characteristics of the dm2-properties \n"
    txt+="number of rows  "+str(r)+ "  number of columns "+str(k2)+"\n"
    for j in range(0,k2):
        txt+="\t"+prop2[j+1]+"       "
    txt+="\n"
    txt+="max   :\t"
    for j in range(0,k2):
        txt+=str(a2[0][j])+"\t"
    txt+="\nmin   :\t"
    for j in range(0,k2):
        txt+=str(a2[1][j])+"\t"
    txt+="\nmean  :\t"
    for j in range(0,k2):
        txt+=str(a2[2][j])+"\t"
    txt+="\nstdev :\t"
    for j in range(0,k2):
        txt+=str(a2[3][j])+"\t"
    txt+="\n"
    tchar.insert("end",txt)


def HD1():
    """ reduces a dm with equiv objects to a dm of a quotient set and \
    generates a Hasse diagram """
    # Brg 12.12.07, 13.1.08, 14.1.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global zeta21,n1,objred1,txtec1,rred1  
   
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('warning 1')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    propn1=rmod2.vecgentext1(k1)
    objn1=rmod2.vecgentext1(r)    #8.5.08 changed to ...text1
    for i in range(0,k1):
        propn1[i]=prop1[i+1]
    for i in range(0,r):
        objn1[i]=obj1[i+1]
    #############################dieser Teil ist neu 21.12.07
    n1,yred1,objred1,txt1=rmod2.equivcompact(r,k1,dm1,objn1)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    rred1=n1
    txtec1=txt1      #neu 15.7.08

    hfhd1=Tkinter.Toplevel(hf)
    hfhd1.title('HD 1')
    lbhfhd1=Tkinter.Label(hfhd1,text='Hasse diagram or cover matrix ')
    lbhfhd1.pack()
    freq=Tkinter.Frame(hfhd1,width=200,height=300)
    freq.pack()
    
   
    labeq=Tkinter.Label(freq,text="file = "+fn1+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf1=rmod2.comp(n1,k1,yred1)
    zeta1=rmod2.marray(n1,n1)
    for i in range(0,n1):
        for j in range(0,n1):
            zeta1[i][j]=zetahilf1[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj1,lext1,revlext1,zzmax1=rmod2.levtopsort(n1,zeta1)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txtl1="\n"
    for i in range(0,zzmax1):
        txtl1+="Level "+str(zzmax1-i)+" :"
        for j in range(0,len(lobj1[i])):
            txtl1+= objred1[lobj1[i][j]]+" "
        txtl1+="\n"    
    txtl1+="\n\n  -- end --"        
    tlev.insert("end",txtl1)

    txtl2="\n One linear extension \n\n"
    for i in range(0,n1):
        if i<n1-1:
            txtl2+=objred1[revlext1[i]]+" < "
        else:
            txtl2+=objred1[revlext1[i]]+"\n"
    txtl2+="\n"
    txtl2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txtl2)
    
    #Adj-Listen

    adjc1=rmod2.adjacent(n1,lext1,revlext1,zeta1)
        
    #Transitive reduced relations
    ts1,tr1=rmod2.trreduct(n1,adjc1,lext1)
       
    
    zeta21=rmod2.cover(n1,tr1,lext1)
    if n1>30:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txtl3="\n cover-matrix  \n"
        for i in range(0,n1):
            txtl3+="\t"+objred1[i]+"\t"
        txtl3+="\n"
        for i in range(0,n1):
            txtl3+=objred1[i]+" :"
            for j in range(0,n1):
                txtl3+=str(zeta21[i][j])+"\t"
            txtl3+="\n"
        txtl3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txtl3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn1)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax1
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj1[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n1,n1)
        geomy=rmod2.marray(n1,n1)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta21[lobj1[i1][j1]][lobj1[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred1[lobj1[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show1)
        buttcover.pack()

def cover_show1():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix 1')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n1):
        txt3+="\n"+objred1[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n1):
            if i!=j:
                if zeta21[i][j]==1:
                    txt3+=" "+objred1[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)

    
def HD2():
    """ reduces a dm with equiv objects to a dm of a quotient set and \
    generates a Hasse diagram """
    # Brg 12.12.07, 13.1.08, 14.1.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    global zeta22,n2,objred2,txtec2,rred2 
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning2=Tkinter.Toplevel(hf)
        hfwarning2.title('warning 2')
        frwarning2=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning2.pack()
        bwarning2=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning2.pack()
        
    propn2=rmod2.vecgentext1(k2)
    objn2=rmod2.vecgentext1(r)   #changed to ...text1 8.5.08
    for i in range(0,k2):
        propn2[i]=prop2[i+1]
    for i in range(0,r):
        objn2[i]=obj2[i+1]
    #############################dieser Teil ist neu 21.12.07
    n2,yred2,objred2,txt2=rmod2.equivcompact(r,k2,dm2,objn2)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    rred2=n2
    txtec2=txt2                 #neu 15.7.08
    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title(' HD 2')
    lbhfhd2=Tkinter.Label(hfhd2,text='Hasse diagram or cover matrix ')
    lbhfhd2.pack()
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
   
    labeq=Tkinter.Label(freq,text="file = "+fn2+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf2=rmod2.comp(n2,k2,yred2)
    zeta2=rmod2.marray(n2,n2)
    for i in range(0,n2):
        for j in range(0,n2):
            zeta2[i][j]=zetahilf2[j][i]
    #
    #One linear extension (based on levels)
    lbhd2=Tkinter.Label(freq,text= "Level ")
    lbhd2.pack()

    #rmod2.matout(n,n,zeta)
    lobj2,lext2,revlext2,zzmax2=rmod2.levtopsort(n2,zeta2)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txtl1="\n"
    for i in range(0,zzmax2):
        txtl1+="Level "+str(zzmax2-i)+" :"
        for j in range(0,len(lobj2[i])):
            txtl1+= objred2[lobj2[i][j]]+" "
        txtl1+="\n"    
    txtl1+="\n\n  -- end --"        
    tlev.insert("end",txtl1)

    txtl2="\n One linear extension \n\n"
    for i in range(0,n2):
        if i<n2-1:
            txtl2+=objred2[revlext2[i]]+" < "
        else:
            txtl2+=objred2[revlext2[i]]+"\n"
    txtl2+="\n"
    txtl2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc2=rmod2.adjacent(n2,lext2,revlext2,zeta2)
        
    #Transitive reduced relations
    ts2,tr2=rmod2.trreduct(n2,adjc2,lext2)
       
    
    zeta22=rmod2.cover(n2,tr2,lext2)
    if n2>30:
        lbhd3=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd3.pack()
        txtl3="\n cover-matrix  \n"
        for i in range(0,n2):
            txtl3+="\t"+objred2[i]+"\t"
        txtl3+="\n"
        for i in range(0,n2):
            txtl3+=objred2[i]+" :"
            for j in range(0,n2):
                txtl3+=str(zeta22[i][j])+"\t"
            txtl3+="\n"
        txtl3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn2)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax2
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj2[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n2,n2)
        geomy=rmod2.marray(n2,n2)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta22[lobj2[i1][j1]][lobj2[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj2[i][j]])  #29.5.08 Korrektur objred 2 
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show2)
        buttcover.pack()

def cover_show2():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover2=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix 2')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n2):
        txt3+="\n"+objred2[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n2):
            if i!=j:
                if zeta22[i][j]==1:
                    txt3+=" "+objred2[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)



def calc1():
    "series of HD/LPOM calculations"
    #brg 7.11.07, 12.12.07, 21.3.08, 17.6.08, 19.6.08, 21.6.08, 16.7.08
    
    #rred1 von HD1
    
    global dmred1,objred1,fn1,rred1,utotal1,eqtotal1,comparabilities1  

    ############# very important ###########################
    rred1,dmred1,objred1,obj1,prop1,txt1,neq1=filecomp(fn1) 
    ############## very important ##########################
    
    l1=len(obj1)
    l2=len(objred1)
    hfeq=Tkinter.Toplevel(hf)
    hfeq.title(' dm1: equivalent elements ')
    lbeq1=Tkinter.Label(hfeq,text="dm 1: Structure: quotient set  ") #21.6.08 many changes
    lbeq1.pack()
    labeq=Tkinter.Label(hfeq,text="")
    labeq.pack()
    txteq=ScrolledText(hfeq,width=60,height=10)
    txteq.pack()
    txtq=""
    if l1!=l2:
        labeq.config(text="dm1: quotient set is unequal the object set ")
        
        txtq=txt1+"\n"
        txtq+="\n\n dm1: distribution of equivalent elements \n"
        for i in range(0,r):
            if neq1[i]>1:
                txtq+=str(neq1[i])+"\n"
        
       
    else:
        labeq.config(text="dm1: quotient set = object set ",bg="yellow")
        txtq+="\nThe equivalence elements are singletons "
        txtq+="\n see the data matrix for the objects "
    txteq.insert("end",txtq)    


    # 21.6.08 end of the changed part

    #         definitions of vectors
    p1=[]      #successors of any obj
    u1=[]      #incomparable elem. of any obj
    succ1=[]   #predecessors of any obj, nmen leider vertauscht. 
    pr1=[]     # number of  chains
    rkav1=[]   #rkav after LPOM(0)model
    minx1=[]
    maxx1=[]
    isox1=[]

    zmaxminiso1=[]

    for i in range(0,rred1):
        succ1.append(0)
        u1.append(0)
        p1.append(0)
        rkav1.append(0)
        pr1.append(0)
        minx1.append(-1)
        maxx1.append(-1)
        isox1.append(-1)
        zmaxminiso1.append(0)

    # definiton of matrices
    global objx1,redobjx1,quobx1   #17.6.08
    objx1=rmod2.marray(rred1,rred1)   
    redobjx1=rmod2.marray(rred1,rred1)
    quobx1=rmod2.marray(rred1,rred1)
    prod1=rmod2.marray(rred1,rred1)
    prod11=rmod2.marray(rred1,rred1)
    unit=rmod2.matunit(rred1)


    # heart of the program begin
    
    
    objx1=rmod2.comp(rred1,k1,dmred1)
    rmod2.matadd(rred1,1.0,objx1,-1.0,unit,redobjx1)
    
    level1,pr1=rmod2.chainlevel(rred1,redobjx1)

    ######## results window 2 ######################################################
    hfresults2=Tkinter.Toplevel(hf)
    hfresults2.title(' dm1: results 1 ')
    lbresultlevel=Tkinter.Label(hfresults2,text="maximal count of levels: "+str(level1))
    lbresultlevel["font"]="Arial 16"
    tchainlength=ScrolledText(hfresults2,width=50,height=10)
    tchainlength.pack()
    txt="\n chain analysis \n"
    for i in range(0,rred1):
        if pr1[i]!=0:
            txt+="dm1: number of chains with length:  "+str(i)+" = :"+str(pr1[i])+"\n"
    
    tchainlength.insert("end",txt)

    rmod2.qualcomp(rred1,objx1,quobx1)
    #rmod2.matout(rred,rred,objx)  #7.11.07
    #rmod2.strmatout(r,r,quobx)  #7.11.07
    inco1=rmod2.marray(rred1,rred1)    
    maxx1,minx1,isox1=rmod2.maxminiso1(rred1,quobx1)  #9.7.08

    inco1=rmod2.rai_inc(rred1,quobx1)

    lbresult=Tkinter.Label(hfresults2,text="")
    lbresult.pack()
    lbresult["text"]="dm1: maximal,minimal and isolated elements (row-numbers) "
    lbmax=Tkinter.Label(hfresults2,text="")
    lbmax.pack()
    lbmax["text"]="dm1: maximal elements"
    tmaxel=ScrolledText(hfresults2,width=50,height=10)
    tmaxel.pack()
    txt=""
    z=0
    for i in range(0,rred1):
        if maxx1[i]!=-1:
            z+=1
            txt+=str(objred1[maxx1[i]])+" "                 #29.11.07
    #print "number of maximal elements: ",z
    txt+="\n dm1: count of max elements: "+str(z)+"\n"
    tmaxel.insert("end",txt)

    ####################################6.11.07##################
    lbmin=Tkinter.Label(hfresults2,text="")
    lbmin.pack()
                        
    lbmin["text"]="dm1: minimal elements"
    tminel=ScrolledText(hfresults2,width=50,height=10)
    tminel.pack()
    txt=""
    z=0
    for i in range(0,rred1):
        if minx1[i]!=-1:
            z+=1    
            txt+=str(objred1[minx1[i]])+" "                   #29.11.07
    txt+="\n dm1: count of min elements: "+str(z)+"\n"
    tminel.insert("end",txt)

    lbiso=Tkinter.Label(hfresults2,text="dm1: Isolated elements")
    lbiso.pack()
    tisoel=ScrolledText(hfresults2,width=50,height=10)
    tisoel.pack()
    txt=""
    z=0
    for i in range(0,rred1):
        if isox1[i]!=-1:
            z+=1
            txt+=str(objred1[isox1[i]])+" "
    txt+="\n dm1: count of isolated elements: "+str(z)+"\n"
    tisoel.insert("end",txt)

    
    
    hfresults3=Tkinter.Toplevel(hf)   #26.5.08 
    hfresults3.title(' dm1: results 2')
    labinc=Tkinter.Label(hfresults3,text="dm1: incomparable elements:")
    labinc.pack(pady=3)
    tincel=ScrolledText(hfresults3,width=50,height=10)
    tincel.pack()
    z=0
    txt=" "
    for i in range(0,rred1):
        txt+="object "+str(objred1[i])+":  "               #29.11.07
        for j in range(0,rred1):
            if inco1[i][j]!=-1:
                z+=1
                txt+=str(objred1[inco1[i][j]])+" "         #29.11.07
        txt+="\n"
    utotal1=round(float(1.0*z/2.0),2)
    ntotal1= 1.0*r*(r-1.0)/2.0
    #print "ntotal = ",ntotal
    eqtotal1=0
    for i in range(0,r):
        eqtotal1+=(neq1[i]*(neq1[i]-1))/2.0     #20.6.08
        
    if rred1==0:
        pib=0
        txt+=" "
        msgwarning()
    else:    
        pib=round(2.0*utotal1/(rred1*(rred1-1)),2)
        txt+="\n number of incomparable pairs "+str(utotal1)+"  stability: "+str(pib) +"\n"   
    totobj=len(objred1)   #26.5.08
    #txt+="\n nr. of representants "+str(totobj)
    comparabilities= (totobj*(totobj-1)/2.0)-utotal1
    #txt+="\n nr of comparabilities "+str(comparabilities)
    tincel.insert("end",txt)    
    labov=Tkinter.Label(hfresults3,text="dm1: Relational information")
    labov.pack(pady=5)
    tstat=ScrolledText(hfresults3,width=50,height=4)
    tstat.pack()
    txtstat="dm1: Quotient set and some characteristics \n"
    txtstat+="\n number of incomparabilities\t"+str(utotal1)
    txtstat+="\n number of comparabilties  \t"+str(comparabilities)
    txtstat+="\n number of representants   \t"+str(totobj)
    txtstat+="\n stability ('P(IB)'):  \t"+str(2.0*utotal1/(1.0*totobj*(totobj-1)))
    txtstat+="\n - - - end of file - - - "
    tstat.insert("end",txtstat)
    
    lablevel=Tkinter.Label(hfresults3,text="Pop. of the levels")
    lablevel.pack(pady=5)
    
    levelpop1=rmod2.marray(level1,rred1)
    levelpop1=rmod2.railevel(rred1,level1,objx1)

    tlevpop=ScrolledText(hfresults3,width=50,height=10)
    tlevpop.pack()
    
    txt="dm1: Level info\n"
    for iz in range(0,level1):
        txt+="Level "+str(level1-iz)+": "
        for j in range(0,rred1):
            if levelpop1[iz][j]!=-1:
                txt+=str(objred1[levelpop1[iz][j]])+" "          #29.11.07
        txt+="\n"        
    txt+="\n"
    tlevpop.insert("end",txt)   
    lbstruc=Tkinter.Label(hfresults3,text="structural details ")
    lbstruc.pack(pady=5)
    txtstruc=ScrolledText(hfresults3,width=50,height=10)
    txtstruc.pack()
    txtsuc="\n dm1: successors\n"
    for i in range(0,rred1):
        txtsuc+="object "+objred1[i]+": "
        for j in range(0,rred1):
            if i!=j:
                if objx1[i][j]==1:
                    txtsuc+=objred1[j]+" ,"
                else:
                    pass
            else:
                pass
        txtsuc+="\n"
    txtsuc+="\n dm1: predecessors  \n"
    for j in range(0,rred1):
        txtsuc+="object "+objred1[j]+": "
        for i in range(0,rred1):
            if j!=i:
                if objx1[i][j]==1:
                    txtsuc+=objred1[i]+", "
                else:
                    pass
            else:
                pass
        txtsuc+="\n"    
    txtstruc.insert("end",txtsuc)
    butthd1.config(state="active",bg="cyan")
    
    
    
    
    
def LPOM1():
    """Local partial order model """
    #brg 17.6.08
    global rkav1
    tplpom1=Tkinter.Toplevel(hf)
    tplpom1.title(" dm1: LPOM calculation's results 1")           
    succ1,p1,u1,eq1=rmod2.sucpredinc(rred1,quobx1)
    lbavrk1=Tkinter.Label(tplpom1,text="Results of LPOM-calculation ")
    lbavrk1.pack()

    tstruct=ScrolledText(tplpom1,width=60,height=5)
    tstruct.pack()
    

    
    txt1="dm1: results of LPOM1a: structuralinformation \n"
    txt1+="\nobject\tsucc\tpredec\tincom\n"
    for i in range(0,rred1):
        txt1+=str(objred1[i])+":\t"+str(succ1[i])+"\t"+str(p1[i])+"\t"+str(u1[i])+"\t "
        txt1+="\n"
    
    tstruct.insert("end",txt1)    

    rkav1,pro1,p1,succ1,u1,eq1=rmod2.lpom0(rred1,quobx1)


    trkav=ScrolledText(tplpom1,width=60,height=6)
    trkav.pack()
    txt2="dm1: results of LPOM1b): averaged ranks and probabilities \n"
    txt2+="\n\t\tNo\tRkav\tpr<\tpr>\n"
    
    for i in range(0,rred1):
        #test=round(pro[i][0]+pro[i][1],3)
        p11=round(pro1[i][0],3)
        p21=round(pro1[i][1],3)
        avr1=round(rkav1[i],3)
        txt2+="\t\t "+str(objred1[i])+" :\t"
        txt2+=str(avr1)+"\t"+str(p11)+"\t"+str(p21)+"\n"      
    txt2+="\n"
    trkav.insert("end",txt2)
    # new 21.3.08
    
        
                             
def calc2():
    "series of HD/LPOM calculations"
    #brg 7.11.07, 12.12.07, 21.3.08, 17.6.08, 19.6.08, 21.6.08
    
    global rred2,n2,objred2,fn2,utotal2,eqtotal2,comparabilities2

    ###################very important ##########################
    rred2,dmred2,objred2,obj2,prop2,txt2,neq2=filecomp(fn2)
    #############################################################

    
    #print "dm2 = "
    #rmod2.matout(rred,k,dmred2)
    l1=len(obj2)
    l2=len(objred2)
    hfeq=Tkinter.Toplevel(hf)
    hfeq.title(' dm2: equivalent elements ')
    lbeq1=Tkinter.Label(hfeq,text="dm2: Structure: quotient set") #21.6.08 many changes
    lbeq1.pack()
    labeq=Tkinter.Label(hfeq,text="")
    labeq.pack()
    txteq=ScrolledText(hfeq,width=60,height=10)
    txteq.pack()
    txtq=""
    if l1!=l2:
        labeq.config(text="dm2: quotient set is unequal the object set ")
        
        txtq=txt2+"\n"
        txtq+="\n\n dm2: distribution of equivalent elements \n"
        for i in range(0,r):
            if neq2[i]>1:
                txtq+=str(neq2[i])+"\n"
        
       
    else:
        labeq.config(text="dm2: quotient set = object set ",bg="yellow")
        txtq+="\nThe equivalence elements are singletons "
        txtq+="\n see the data matrix for the objects "
    txteq.insert("end",txtq)    

    # 21.6.08 end of the changed part

    #         definitions of vectors
    p2=[]      #successors of any obj
    u2=[]      #incomparable elem. of any obj
    succ2=[]   #predecessors of any obj, nmen leider vertauscht. 
    pr2=[]     # number of  chains
    rkav2=[]   #rkav after LPOM(0)model
    minx2=[]
    maxx2=[]
    isox2=[]

    zmaxminiso2=[]

    for i in range(0,rred2):
        succ2.append(0)
        u2.append(0)
        p2.append(0)
        rkav2.append(0)
        pr2.append(0)
        minx2.append(-1)
        maxx2.append(-1)
        isox2.append(-1)
        zmaxminiso2.append(0)

    # definiton of matrices
    global objx2,redobjx2,quobx2   #17.6.08
    objx2=rmod2.marray(rred2,rred2)   
    redobjx2=rmod2.marray(rred2,rred2)
    quobx2=rmod2.marray(rred2,rred2)
    prod2=rmod2.marray(rred2,rred2)
    prod12=rmod2.marray(rred2,rred2)
    unit=rmod2.matunit(rred2)


    # heart of the program begin
    
    
    objx2=rmod2.comp(rred2,k2,dmred2)
    rmod2.matadd(rred2,1.0,objx2,-1.0,unit,redobjx2)
    
    level2,pr2=rmod2.chainlevel(rred2,redobjx2)

    ######## results window 2 ######################################################
    hfresults2=Tkinter.Toplevel(hf)
    hfresults2.title('dm2:  results 1 ')
    lbresultlevel=Tkinter.Label(hfresults2,text="dm2: maximal count of levels: "+str(level2))
    lbresultlevel["font"]="Arial 16"
    tchainlength=ScrolledText(hfresults2,width=50,height=10)
    tchainlength.pack()
    txt="\n chain analysis \n"
    for i in range(0,rred2):
        if pr2[i]!=0:
            txt+="dm2: number of chains with length:  "+str(i)+" = :"+str(pr2[i])+"\n"
    
    tchainlength.insert("end",txt)

    rmod2.qualcomp(rred2,objx2,quobx2)
    #rmod2.matout(rred2,rred2,objx2)  #7.11.07
    #rmod2.strmatout(r,r,quobx2)  #7.11.07
    inco2=rmod2.marray(rred2,rred2)    
    maxx2,minx2,isox2=rmod2.maxminiso1(rred2,quobx2)  #9.7.08

    inco2=rmod2.rai_inc(rred2,quobx2)

    lbresult=Tkinter.Label(hfresults2,text="")
    lbresult.pack()
    lbresult["text"]="dm2: maximal,minimal and isolated elements (row-numbers) "
    lbmax=Tkinter.Label(hfresults2,text="")
    lbmax.pack()
    lbmax["text"]="dm2: maximal elements"
    tmaxel=ScrolledText(hfresults2,width=50,height=10)
    tmaxel.pack()
    txt=""
    z=0
    for i in range(0,rred2):
        if maxx2[i]!=-1:
            z+=1
            txt+=str(objred2[maxx2[i]])+" "                 #29.11.07
    #print "number of maximal elements: ",z
    txt+="\n dm2: count of max elements: "+str(z)+"\n"
    tmaxel.insert("end",txt)

    ####################################6.11.07##################
    lbmin=Tkinter.Label(hfresults2,text="")
    lbmin.pack()
                        
    lbmin["text"]="dm2: minimal elements"
    tminel=ScrolledText(hfresults2,width=50,height=10)
    tminel.pack()
    txt=""
    z=0
    for i in range(0,rred2):
        if minx2[i]!=-1:
            z+=1    
            txt+=str(objred2[minx2[i]])+" "                   #29.11.07
    txt+="\n dm2: count of min elements: "+str(z)+"\n"
    tminel.insert("end",txt)

    lbiso=Tkinter.Label(hfresults2,text="dm2: Isolated elements")
    lbiso.pack()
    tisoel=ScrolledText(hfresults2,width=50,height=10)
    tisoel.pack()
    txt=""
    z=0
    for i in range(0,rred2):
        if isox2[i]!=-1:
            z+=1
            txt+=str(objred2[isox2[i]])+" "
    txt+="\n dm2: count of isolated elements: "+str(z)+"\n"
    tisoel.insert("end",txt)

    
    
     

    hfresults3=Tkinter.Toplevel(hf)   #26.5.08 
    hfresults3.title(' dm2: results 2')
    labinc=Tkinter.Label(hfresults3,text="dm2: incomparable elements:")
    labinc.pack(pady=3)
    tincel=ScrolledText(hfresults3,width=50,height=10)
    tincel.pack()
    z=0
    txt=" "
    for i in range(0,rred2):
        txt+="object "+str(objred2[i])+":  "               #29.11.07
        for j in range(0,rred2):
            if inco2[i][j]!=-1:
                z+=1
                txt+=str(objred2[inco2[i][j]])+" "         #29.11.07
        txt+="\n"
    utotal2=round(float(1.0*z/2.0),2)
    ntotal2= 1.0*r*(r-1.0)/2.0
    #print "ntotal = ",ntotal
    eqtotal2=0
    for i in range(0,r):
        eqtotal2+=(neq2[i]*(neq2[i]-1))/2.0     #20.6.08
        
    if rred2==0:
        pib=0
        txt+=" "
        msgwarning()
    else:    
        pib=round(2.0*utotal2/(rred2*(rred2-1)),2)
        txt+="\n dm2: number of incomparable pairs "+str(utotal2)+"  stability: "+str(pib) +"\n"   
    totobj2=len(objred2)   #26.5.08
    #txt+="\n nr. of representants "+str(totobj)
    comparabilities2= (totobj2*(totobj2-1)/2.0)-utotal2
    #txt+="\n nr of comparabilities "+str(comparabilities)
    tincel.insert("end",txt)    
    labov=Tkinter.Label(hfresults3,text="dm2: Relational information")
    labov.pack(pady=5)
    tstat=ScrolledText(hfresults3,width=50,height=4)
    tstat.pack()
    txtstat="dm2: Quotient set and some characteristics \n"
    txtstat+="\n number of incomparabilities\t"+str(utotal2)
    txtstat+="\n number of comparabilties  \t"+str(comparabilities2)
    txtstat+="\n number of representants   \t"+str(totobj2)
    txtstat+="\n stability ('P(IB)'):  \t"+str(2.0*utotal2/(1.0*totobj2*(totobj2-1)))
    txtstat+="\n - - - end of file - - - "
    tstat.insert("end",txtstat)
    
    lablevel=Tkinter.Label(hfresults3,text="Pop. of the levels")
    lablevel.pack(pady=5)
    
    levelpop2=rmod2.marray(level2,rred2)
    levelpop2=rmod2.railevel(rred2,level2,objx2)

    tlevpop=ScrolledText(hfresults3,width=50,height=10)
    tlevpop.pack()
    
    txt="dm2: Level info\n"
    for iz in range(0,level2):
        txt+="Level "+str(level2-iz)+": "
        for j in range(0,rred2):
            if levelpop2[iz][j]!=-1:
                txt+=str(objred2[levelpop2[iz][j]])+" "          #29.11.07
        txt+="\n"        
    txt+="\n"
    tlevpop.insert("end",txt)   
    lbstruc=Tkinter.Label(hfresults3,text="structural details ")
    lbstruc.pack(pady=5)
    txtstruc=ScrolledText(hfresults3,width=50,height=10)
    txtstruc.pack()
    txtsuc="\n dm2: successors\n"
    for i in range(0,rred2):
        txtsuc+="object "+objred2[i]+": "
        for j in range(0,rred2):
            if i!=j:
                if objx2[i][j]==1:
                    txtsuc+=objred2[j]+" ,"
                else:
                    pass
            else:
                pass
        txtsuc+="\n"
    txtsuc+="\n dm2: predecessors  \n"
    for j in range(0,rred2):
        txtsuc+="object "+objred2[j]+": "
        for i in range(0,rred2):
            if j!=i:
                if objx2[i][j]==1:
                    txtsuc+=objred2[i]+", "
                else:
                    pass
            else:
                pass
        txtsuc+="\n"    
    txtstruc.insert("end",txtsuc)
    butthd2.config(state="active",bg="cyan")
    
    
    
    
    
    
def LPOM2():
    """Local partial order model """
    #brg 17.6.08
    global rkav2
    tplpom1=Tkinter.Toplevel(hf)
    tplpom1.title(" dm2: LPOM calculation's results 1")           
    succ2,p2,u2,eq2=rmod2.sucpredinc(rred2,quobx2)
    lbavrk1=Tkinter.Label(tplpom1,text="dm2: Results of LPOM-calculation ")
    lbavrk1.pack()

    tstruct=ScrolledText(tplpom1,width=60,height=5)
    tstruct.pack()
    

    
    txt1="dm2: results of LPOM2a): structuralinformation \n"
    txt1+="\nobject\tsucc\tpredec\tincom\n"
    for i in range(0,rred2):
        txt1+=str(objred2[i])+":\t"+str(succ2[i])+"\t"+str(p2[i])+"\t"+str(u2[i])+"\t "
        txt1+="\n"
    
    tstruct.insert("end",txt1)    

    rkav2,pro2,p2,succ2,u2,eq2=rmod2.lpom0(rred2,quobx2)

##    tplom2=Tkinter.Toplevel(hf)
##    tplom2.title(" lpom calculations 2 ")
    trkav=ScrolledText(tplpom1,width=60,height=6)
    trkav.pack()
    txt2="dm2: results of LPOM2b): averaged ranks and probabilities \n"
    txt2+="\n\t\tNo\tRkav\tpr<\tpr>\n"
    
    for i in range(0,rred2):
        #test=round(pro[i][0]+pro[i][1],3)
        p12=round(pro2[i][0],3)
        p22=round(pro2[i][1],3)
        avr2=round(rkav2[i],3)
        txt2+="\t\t "+str(objred2[i])+" :\t"
        txt2+=str(avr2)+"\t"+str(p12)+"\t"+str(p22)+"\n"      
    txt2+="\n"
    trkav.insert("end",txt2)
    # new 21.3.08
    
       
def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08, 20.6.08
    # 16.7.08 wichtige Aenderung Eingabe zu filecomp nur noch fn. Die parameter r,dm,pro
    # sind gestrichen
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,prop,txt,neq   #20.6.08        
                
               

def hpor():
    """ from LPOM1 and LPOM2 a new dm and from that a new HD """
    ### Baustelle 25.7.08
    # Achtung: Es koennten verschiedene aequivalenzklassen auftreten in dm1 bzw. dm2
    #Formal muessen dann den aequivalenten Objekten die gleichen rkav-Werte gegeben werden.
    # 15.7.08 : Im Prinzip ist jetzt Rkav1 und Rkav2 fuer quotienten sets
    # bekannt. Hier:
    # a) neue dm auf der basis von rkav1 und rkav2
    # b) aequibvalente elemente in dm1 bekommen ihr 'richtiges' rkav1 , analog 2.
    # c) HD basierend auf rkav11, rkav2
    # d) level, succ, predec. basierend auf poset (rkav1,rkav2)

    global n12,objn2,zeta12,objred2,neq12,yred12,objred12,dm12,r 
    
    propn1=rmod2.vecgentext1(k1)
    objn1=rmod2.vecgentext1(r)    #8.5.08 changed to ...text1
    for i in range(0,k1):
        propn1[i]=prop1[i+1]
    for i in range(0,r):
        objn1[i]=obj1[i+1]

    propn2=rmod2.vecgentext1(k2)
    objn2=rmod2.vecgentext1(r)    #8.5.08 changed to ...text1
    for i in range(0,k2):
        propn2[i]=prop2[i+1]
    for i in range(0,r):
        objn2[i]=obj2[i+1]    

    eqc1=rmod2.equiv_hpor(r,k1,dm1,objn1)
    eqc2=rmod2.equiv_hpor(r,k2,dm2,objn2)    
    rkav1extend=rmod2.vecgen1(r)
    rkav2extend=rmod2.vecgen1(r)

    # central procedure in hpor ###########################################
    for i in range(0,r):
        if objn1[i] in objred1:
            istar=objred1.index(objn1[i])  #index wird ermittelt
            rkav1extend[i]=rkav1[istar] #averaged rank of objred wird uebertragen auf extended av.list
            #print "objn1 ",objn1[i]," ist in objred1"
        else:
            #Baustelle  25.7.08, 26.7.08
            #print "set 1:  objn1[",i,"]= ",objn1[i]
            i1=0
            flag1=0
            zaehl=0
            while flag1==0:
                for j in range(1,r):
                    if eqc1[i1][j]==i:
                        itest=objred1.index(objn1[eqc1[i1][0]])
                        #print "i1 = ",i1,"  j= ",j,"  eqc1 = ",eqc1[i1][0],"obj = ",objn1[eqc1[i1][0]],"  itest= ",itest," rkav = ",rkav1[itest]
                        rkav1extend[i]=rkav1[itest]
                        flag1=1
                        break
                i1+=1    
                zaehl+=1
                if zaehl>100 or i1>r-1:
                    #print "+++1"
                    break
                  
    #print "    "
    #print "  "
    for i in range(0,r):
        if objn2[i] in objred2:
            istar=objred2.index(objn2[i])  #index wird ermittelt
            rkav2extend[i]=rkav2[istar] #averaged rank of objred wird uebertragen auf extended av.list
            #print "objn2 ",objn2[i]," ist in objred1"
        else:
            #Baustelle  25.7.08, 26.7.08
            #print "set 2:  objn2[",i,"]= ",objn2[i]
            i1=0
            flag2=0
            zaehl2=0
            while flag2==0:
                for j in range(1,r):
                    if eqc2[i1][j]==i:
                        itest=objred2.index(objn2[eqc2[i1][0]])
                        #print "i1 = ",i1,"  j= ",j,"  eqc2 = ",eqc2[i1][0],"obj = ",objn2[eqc2[i1][0]],"  itest = ",itest,"   rkav2 = ",rkav2[itest]
                        rkav2extend[i]=rkav2[itest]
                        flag2=1
                        break
                i1+=1
                zaehl2+=1
                if zaehl2>100 or i1>r-1:
                    #print "+++2"
                    break
                 
                  
    
    ##############################################################################

    dm12=rmod2.marray(r,2)
    for i in range(0,r):
        dm12[i][0]=rkav1extend[i]
        dm12[i][1]=rkav2extend[i]
        

    tpdm12=Tkinter.Toplevel(hf)
    tpdm12.title(' hpor matrix dm12 ')
    txt12=" hpor datamatrix (dm12) "
    txt12+="\n"
    txthilf="object\trkav1\trkav2"
    txthilf+="\n"+60*"="
    for i in range(0,r):
        txthilf+=objn2[i]+"\t"+str(round(rkav1extend[i],2))+"\t"+str(round(rkav2extend[i],2))+"\n"
    txt12+=txthilf
    txt12+="\n\n  - - -  end of file  - - -"
    tdm12=ScrolledText(tpdm12,width=60,height=5)
    tdm12.pack(expand="yes",fill="both")
    tdm12.insert("end",txt12)
    
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning2=Tkinter.Toplevel(hf)
        hfwarning2.title('warning 2')
        frwarning2=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning2.pack()
        bwarning2=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning2.pack()
        
    #################################################################
    n12,yred12,objred12,txt2,neq12=rmod2.equivcompactm(r,2,dm12,objn2)    
    ##################################################################
    
    
    l1=len(objn2)
    l2=len(objred12)
    
        ##############26.7.08##########   
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title(' HD 12')
    lbhfhd2=Tkinter.Label(hfhd2,text='Hasse diagram based on RKAV or cover matrix ')
    lbhfhd2.pack()
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
   
    labeq=Tkinter.Label(freq,text="files = "+fn1+" and "+fn2)
    labeq.config(bg="yellow")
    labeq.pack()

    lbeq1=Tkinter.Label(hfhd2,text="dm12: Structure: quotient set") #21.6.08 many changes
    lbeq1.pack()
    labeq=Tkinter.Label(hfhd2,text="")
    labeq.pack()
    txteq=ScrolledText(hfhd2,width=60,height=10)
    txteq.pack(expand="yes",fill="both")
    txtq=""
    if l1!=l2:
        labeq.config(text="dm12: quotient set is unequal the object set ")
        
        txtq=txt2+"\n"
        txtq+="\n\n dm12: distribution of equivalent elements \n"
        for i in range(0,r):
            if neq12[i]>1:
                txtq+=str(neq12[i])+"\n"
        
       
    else:
        labeq.config(text="dm12: quotient set = object set ",bg="yellow")
        txtq+="\nThe equivalence elements are singletons "
        txtq+="\n see the data matrix for the objects "
    txteq.insert("end",txtq)    

    # 21.6.08 end of the changed part

    #
    zetahilf2=rmod2.comp(n12,2,yred12)   #26.7.08 k2 replaced by 2 , yred2 replaced by yred12
    zeta12=rmod2.marray(n12,n12)
    for i in range(0,n12):
        for j in range(0,n12):
            zeta12[i][j]=zetahilf2[j][i]

    #comparabilities
    rs=rmod2.matrixrowsum(zeta12,n12,n12)
    comptotal=sum(rs)-n12
    #incomparabilities
    utotal=0
    for i in range(0,n12):
        for j in range(0,n12):
            if zeta12[i][j]==0 and zeta12[j][i]==0:
                utotal+=1
    utotal=0.5*utotal            
    #One linear extension (based on levels)
    
    #rmod2.matout(n,n,zeta)
    lobj2,lext2,revlext2,zzmax2=rmod2.levtopsort(n12,zeta12)
    #print "zzmax = ",zzmax
    
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax2):
        if len(lobj2[i])>=levmax:
            levmax=len(lobj2[i])
   
        
    #Adj-Listen

    adjc2=rmod2.adjacent(n12,lext2,revlext2,zeta12)
        
    #Transitive reduced relations
    ts2,tr2=rmod2.trreduct(n12,adjc2,lext2)
       
    
    cov12=rmod2.cover(n12,tr2,lext2) #covermatrix
    HD12(cov12,zeta12,zzmax2,levmax,lobj2,objred12,n12,comptotal,utotal)
    
def cover_show12():
    """Cover-matrix is displayed"""
    #brg 28.12.07, 20.11.08
    #*28.12.07
    #akt20.11.08
    #note: -
    #source: -
    hfcover2=Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix 2')
    
    lbhd2=Tkinter.Label(hfcover2,text=" Cover-Relations ")  #20.11.08
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n12):
        txt3+="\n"+objred12[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n12):
            if i!=j:
                if zeta22[i][j]==1:
                    txt3+=" "+objred12[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover2,width=60, height=4)   #20.11.08
    tcov.pack()
    tcov.insert("end",txt3)

def calc12():
    "series of HD/LPOM calculations"
    #brg 7.11.07, 12.12.07, 21.3.08, 17.6.08, 19.6.08, 21.6.08, 26.7.08
    
    # based on poset arising from rkav1 and rkav2
    
    global n12,n,objred12,fn2,utotal2,eqtotal2,comparabilities2  
    
    #print "dm2 = "
    #rmod2.matout(rred,k,dmred2)
    l1=len(objn2)
    l2=len(objred12)
    

    # 21.6.08 end of the changed part

    #         definitions of vectors
    p2=[]      #successors of any obj
    u2=[]      #incomparable elem. of any obj
    succ2=[]   #predecessors of any obj, nmen leider vertauscht. 
    pr2=[]     # number of  chains
    rkav2=[]   #rkav after LPOM(0)model
    minx2=[]
    maxx2=[]
    isox2=[]

    zmaxminiso2=[]

    for i in range(0,n12):
        succ2.append(0)
        u2.append(0)
        p2.append(0)
        rkav2.append(0)
        pr2.append(0)
        minx2.append(-1)
        maxx2.append(-1)
        isox2.append(-1)
        zmaxminiso2.append(0)

    # definiton of matrices
    global objx2,redobjx2,quobx2   #17.6.08
    objx2=rmod2.marray(n12,n12)   
    redobjx2=rmod2.marray(n12,n12)
    quobx2=rmod2.marray(n12,n12)
    prod2=rmod2.marray(n12,n12)
    prod12=rmod2.marray(n12,n12)
    unit=rmod2.matunit(n12)


    # heart of the program begin
    
    
    objx2=rmod2.comp(n12,2,yred12)   #yred12 comes from the HD12 modul
    rmod2.matadd(n12,1.0,objx2,-1.0,unit,redobjx2)
    
    level12,pr2=rmod2.chainlevel(n12,redobjx2)

    ######## results window 2 ######################################################
    hfresults2=Tkinter.Toplevel(hf)
    hfresults2.title('  results 1 of new dm')
    lbresultlevel=Tkinter.Label(hfresults2,text="maximal count of levels: "+str(level12))
    lbresultlevel["font"]="Arial 16"
    tchainlength=ScrolledText(hfresults2,width=60,height=10)
    tchainlength.pack()
    txt="\n chain analysis \n"
    for i in range(0,n12):
        if pr2[i]!=0:
            txt+="number of chains with length:  "+str(i)+" = :"+str(pr2[i])+"\n"
    
    tchainlength.insert("end",txt)

    rmod2.qualcomp(n12,objx2,quobx2)
    #rmod2.matout(rred,rred,objx2)  #7.11.07
    #rmod2.strmatout(r,r,quobx2)  #7.11.07
    inco2=rmod2.marray(n12,n12)    
    maxx2,minx2,isox2=rmod2.maxminiso1(n12,quobx2)  #9.7.08

    inco2=rmod2.rai_inc(n12,quobx2)

    lbresult=Tkinter.Label(hfresults2,text="")
    lbresult.pack()
    lbresult["text"]="maximal,minimal and isolated elements (row-numbers) "
    lbmax=Tkinter.Label(hfresults2,text="")
    lbmax.pack()
    lbmax["text"]="maximal elements"
    tmaxel=ScrolledText(hfresults2,width=60,height=10)
    tmaxel.pack()
    txt=""
    z=0
    for i in range(0,n12):
        if maxx2[i]!=-1:
            z+=1
            txt+=str(objred12[maxx2[i]])+" "                 #29.11.07
    #print "number of maximal elements: ",z
    txt+="\n count of max elements: "+str(z)+"\n"
    tmaxel.insert("end",txt)

    ####################################6.11.07##################
    lbmin=Tkinter.Label(hfresults2,text="")
    lbmin.pack()
                        
    lbmin["text"]="minimal elements"
    tminel=ScrolledText(hfresults2,width=60,height=10)
    tminel.pack()
    txt=""
    z=0
    for i in range(0,n12):
        if minx2[i]!=-1:
            z+=1    
            txt+=str(objred12[minx2[i]])+" "                   #29.11.07
    txt+="\n count of min elements: "+str(z)+"\n"
    tminel.insert("end",txt)

    lbiso=Tkinter.Label(hfresults2,text="Isolated elements")
    lbiso.pack()
    tisoel=ScrolledText(hfresults2,width=60,height=10)
    tisoel.pack()
    txt=""
    z=0
    for i in range(0,n12):
        if isox2[i]!=-1:
            z+=1
            txt+=str(objred12[isox2[i]])+" "
    txt+="\n count of isolated elements: "+str(z)+"\n"
    tisoel.insert("end",txt)

    hfresults3=Tkinter.Toplevel(hf)   #26.5.08 
    hfresults3.title(' results 2 of new dm')
    labinc=Tkinter.Label(hfresults3,text="incomparable elements:")
    labinc.pack(pady=3)
    tincel=ScrolledText(hfresults3,width=60,height=10)
    tincel.pack()
    z=0
    txt=" "
    for i in range(0,n12):
        txt+="object "+str(objred12[i])+":  "               #29.11.07
        for j in range(0,n12):
            if inco2[i][j]!=-1:
                z+=1
                txt+=str(objred12[inco2[i][j]])+" "         #29.11.07
        txt+="\n"
    utotal12=round(float(1.0*z/2.0),2)
    ntotal12= 1.0*r*(r-1.0)/2.0
    #print "ntotal = ",ntotal
    eqtotal12=0
    for i in range(0,r):
        eqtotal12+=(neq12[i]*(neq12[i]-1))/2.0     #20.6.08
        
    if n12==0:
        pib=0
        txt+=" "
        msgwarning()
    else:    
        pib=round(2.0*utotal12/(n12*(n12-1)),2)
        txt+="\n number of incomparable pairs "+str(utotal12)+"  stability: "+str(pib) +"\n"   
    totobj12=len(objred12)   #26.5.08
    #txt+="\n nr. of representants "+str(totobj)
    comparabilities12= (totobj12*(totobj12-1)/2.0)-utotal12
    #txt+="\n nr of comparabilities "+str(comparabilities)
    tincel.insert("end",txt)    
    labov=Tkinter.Label(hfresults3,text="Relational information")
    labov.pack(pady=5)
    tstat=ScrolledText(hfresults3,width=60,height=4)
    tstat.pack()
    txtstat="Quotient set and some characteristics \n"
    txtstat+="\n number of incomparabilities\t"+str(utotal12)
    txtstat+="\n number of comparabilties  \t"+str(comparabilities12)
    txtstat+="\n number of representants   \t"+str(totobj12)
    txtstat+="\n stability ('P(IB)'):  \t"+str(2.0*utotal12/(1.0*totobj12*(totobj12-1)))
    txtstat+="\n - - - end of file - - - "
    tstat.insert("end",txtstat)
    
    lablevel=Tkinter.Label(hfresults3,text="Pop. of the levels")
    lablevel.pack(pady=5)
    
    levelpop2=rmod2.marray(level12,n12)
    levelpop2=rmod2.railevel(n12,level12,objx2)

    tlevpop=ScrolledText(hfresults3,width=60,height=10)
    tlevpop.pack()
    
    txt="Level info\n"
    for iz in range(0,level12):
        txt+="Level "+str(level12-iz)+": "
        for j in range(0,n12):
            if levelpop2[iz][j]!=-1:
                txt+=str(objred12[levelpop2[iz][j]])+" "          #29.11.07
        txt+="\n"        
    txt+="\n"
    tlevpop.insert("end",txt)   
    lbstruc=Tkinter.Label(hfresults3,text="structural details ")
    lbstruc.pack(pady=5)
    txtstruc=ScrolledText(hfresults3,width=60,height=10)
    txtstruc.pack()
    txtsuc="\n successors\n"
    for i in range(0,n12):
        txtsuc+="object "+objred12[i]+": "
        for j in range(0,n12):
            if i!=j:
                if objx2[i][j]==1:
                    txtsuc+=objred12[j]+" ,"
                else:
                    pass
            else:
                pass
        txtsuc+="\n"
    txtsuc+="\n predecessors  \n"
    for j in range(0,n12):
        txtsuc+="object "+objred12[j]+": "
        for i in range(0,n12):
            if j!=i:
                if objx2[i][j]==1:
                    txtsuc+=objred12[i]+", "
                else:
                    pass
            else:
                pass
        txtsuc+="\n"    
    txtstruc.insert("end",txtsuc)
    


#########26.7.08############
def LPOM12():
    """Local partial order model """
    #brg 17.6.08
    
    tplpom12=Tkinter.Toplevel(hf)
    tplpom12.title(" dm12: LPOM calculation's results (a)")           
    succ2,p2,u2,eq2=rmod2.sucpredinc(n12,quobx2)
    lbavrk1=Tkinter.Label(tplpom12,text="dm12: Results of LPOM-calculation ")
    lbavrk1.pack()

    tstruct=ScrolledText(tplpom12,width=60,height=5)
    tstruct.pack()
    

    
    txt1="dm12: results of LPOM12a): structuralinformation \n"
    txt1+="\nobject\tsucc\tpredec\tincom\n"
    for i in range(0,n12):
        txt1+=str(objred2[i])+":\t"+str(succ2[i])+"\t"+str(p2[i])+"\t"+str(u2[i])+"\t "
        txt1+="\n"
    
    tstruct.insert("end",txt1)    

    rkav12,pro2,p2,succ2,u2,eq2=rmod2.lpom0(n12,quobx2)

##    tplom2=Tkinter.Toplevel(hf)
##    tplom2.title(" lpom calculations 2 ")
    trkav=ScrolledText(tplpom12,width=60,height=6)
    trkav.pack()
    txt2="dm12: results of LPOM2b): averaged ranks and probabilities \n"
    txt2+="\n\t\tNo\tRkav\tpr<\tpr>\n"
    
    for i in range(0,n12):
        #test=round(pro[i][0]+pro[i][1],3)
        p12=round(pro2[i][0],3)
        p22=round(pro2[i][1],3)
        avr2=round(rkav12[i],3)
        txt2+="\t\t "+str(objred2[i])+" :\t"
        txt2+=str(avr2)+"\t"+str(p12)+"\t"+str(p22)+"\n"      
    txt2+="\n"
    trkav.insert("end",txt2)
    # new 21.3.08
    

hf=Tkinter.Tk()
hf.title("Hierarchical Partial Order Ranking (HPOR)")
    
frgen=Tkinter.Frame(hf,relief="groove",bd=3)
frgen.pack()
lbinfo=Tkinter.Label(frgen,text="     Author: R.Bruggemann, vs 3 of 24.12.2010 ",width=60)
lbinfo.pack(pady=25)
helphpor=raioop2.brgabout(hf,"tp1","help_hpor.txt",2,\
            "Dec. 24.12.2010"," help_hpor ", "white", "t1",120,10,ScrolledText)
buttabout=Tkinter.Button(frgen,text="about",width=25,bg="green",command=about)
buttabout.pack()


fr=Tkinter.Frame(hf)
fr.pack(pady=5)
butt1=Tkinter.Button(fr,text="(1)select and open the files",width=25,bg="white",command=fileselect)
butt1.pack(pady=10)

frbackground=Tkinter.Frame(hf,bd=3,relief="groove")
frbackground.pack(pady=5)
butt2=Tkinter.Button(frbackground,text="(2a) show data matrix 1",width=25,command=showDM1)
butt2.pack(side="left")
butt3=Tkinter.Button(frbackground,text="(2b) show data matrix 2",width=25,command=showDM2)
butt3.pack(side="left")
frbackground2=Tkinter.Frame(hf,bd=3,relief="groove")
frbackground2.pack()
buttchar1=Tkinter.Button(frbackground2,text="(3a) char data matrix1",width=25,command=matchar1)
buttchar1.pack(side="left")
buttchar2=Tkinter.Button(frbackground2,text="(3b) char data matrix2",width=25,command=matchar2)
buttchar2.pack(side="left")

frsingle=Tkinter.Frame(hf)
frsingle.pack(pady=5)
buttcalc1=Tkinter.Button(frsingle,text="(4a) calc1",width=25, bg="cyan",command=calc1)
buttcalc1.pack(side="left")
buttcalc2=Tkinter.Button(frsingle,text="(4b) calc2",width=25,bg="cyan",command=calc2)
buttcalc2.pack(side="left")
frsingle2=Tkinter.Frame(hf)
frsingle2.pack()
buttLPOM1=Tkinter.Button(frsingle2,text="(5a) LPOM1",width=25,bg="cyan",command=LPOM1)
buttLPOM1.pack(side="left")
buttLPOM2=Tkinter.Button(frsingle2,text="(5b) LPOM2",width=25,bg="cyan",command=LPOM2)
buttLPOM2.pack(side="left")
frsingle3=Tkinter.Frame(hf)
frsingle3.pack()
butthd1=Tkinter.Button(frsingle3,text="(6a) HD 1",width=25,bg="cyan",command=HD1)
butthd1.pack(side="left")
butthd2=Tkinter.Button(frsingle3,text="(6b) HD 2",width=25,bg="cyan",command=HD2)
butthd2.pack(side="left")
frhpor=Tkinter.Frame(hf, bd=4,relief="sunken")
frhpor.pack(pady=5)
lbhpor=Tkinter.Label(frhpor,text="combining two averaged rank vectors")
lbhpor.pack(pady=5)
frhpor2=Tkinter.Frame(frhpor)
frhpor2.pack()
lbperturb=Tkinter.Label(frhpor2,text="slight permutation of HD>>>")
lbperturb.pack(side="left")
eperturb=Tkinter.Entry(frhpor2,width=3)
eperturb.pack(side="left")
butt2=Tkinter.Button(frhpor,text="(7) HD12 ",width=25,bg="cyan",command=hpor)
butt2.pack(pady=10)
buttcalc12=Tkinter.Button(frhpor,text="(8) calc12",width=25,bg="cyan",command=calc12)
buttcalc12.pack()
#

frfilter=Tkinter.Frame(hf,relief="sunken",bd=2)
frfilter.pack(fill="x")
lbfilter=Tkinter.Label(frfilter,text=">>>enter filter-generating object >>>")
lbfilter.pack(side="left",fill="x")
o1=Tkinter.Entry(frfilter,width=10)
o1.pack(side="left")
buttfilter=Tkinter.Button(frfilter,text = "(3a) filter ",bg="cyan",state="disabled",width=15,command=rfilter)
buttfilter.pack()

frideal=Tkinter.Frame(hf,relief="sunken",bd=2)
frideal.pack(fill="x")
lbideal=Tkinter.Label(frideal,text=">>>enter ideal-generating object >>>")
lbideal.pack(side="left",fill="x")
o2=Tkinter.Entry(frideal,width=10)
o2.pack(side="left")
buttideal=Tkinter.Button(frideal,text = "(3b) ideal ",bg="cyan",state="disabled",width=15,command=rideal)
buttideal.pack()

frinterv=Tkinter.Frame(hf,relief="sunken",bd=2)
frinterv.pack()
lbinterv1=Tkinter.Label(frinterv,text=">enter generat.object (below)>>")
lbinterv1.pack(side="left")
o3=Tkinter.Entry(frinterv,width=10)
o3.pack(side="left")
lbinterv2=Tkinter.Label(frinterv,text=">enter generat.object (above)>>")
lbinterv2.pack(side="left")
o4=Tkinter.Entry(frinterv,width=10)
o4.pack(side="left")              
buttinterv=Tkinter.Button(frinterv,text = "(3c) interval ",bg="cyan",state="disabled",width=15,command=rinterv)
buttinterv.pack()


#
buttLPOM12=Tkinter.Button(frhpor,text="(9) LPOM12",width=25,bg="cyan",command=LPOM12)
buttLPOM12.pack()
lbsuccess=Tkinter.Label(frhpor,text=" ")
lbsuccess.pack()
buttsave=Tkinter.Button(frhpor,text=" save the new dm ",width=25,bg="cyan",command=sf)
buttsave.pack()
frexit=Tkinter.Frame(hf)
frexit.pack(pady=10)
buttexit=Tkinter.Button(frexit,text = " Exit ", width=25,bg="red",command=hf.destroy)
buttexit.pack()


hf.mainloop()
