import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import random
import os
import tkFileDialog
import math

# Brg  10.6.08:
# Brg equivcompact replaced by equivcompactm 16.9.08
# inclusion order as complementary order to the m2 order
# 16.10.09
#  8.7.2010: xprof (the min,max dm taken from the original normalized dm ) will be
#             available for other programs with pdt-format.
# 9.7.2010 end member elimination (emelim)
# 10.7.2010 inclusion of contextspecific help
# 14.7.10 inclusion of a RRR-like presentation
# 8.12.2010: GUI does not fit to laptop formats therefore rearrangements: interval8
# 22.5.2013: elimination of many bugs, some extensions in results
# 3.9.16: circles of HDs now as input parameter, just a matter of design

global q1,tech,r,flagnorm

tech=rmod2.vecgen1(20)
x=rmod2.marray(200,200)
y=rmod2.marray(200,200)





def sf():
    #brg  31.5.09, 1.6.09, taken from palg4
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file (extension '.pdt' is recommended")
    # brg  30.5.09
    for i in range(0,r):
        print obj[i]," ",
    print " "    
    rmod2.raiwrite5(fn,xprof,objprof,["minq","maxq"],rprof,2)
    lbsuccess.config(text="matrix with \n"+str(rprof)+"  rows  and "+str(2)+"\n  columns stored",bg="yellow")




def showcruc():
    """properties which are a min and max, resp of obbjects
    unnormalized (for example when ranks are used )"""
    # Brg 10.6.08, 22.5.2013
    o1=str(eobj1.get())
    o2=str(eobj2.get())
    tpc=Tkinter.Toplevel(hf,width=60,height=100)
    tpc.title('crucial attribute values')
    sct=ScrolledText(tpc,width=60,height=10)
    sct.pack()
    print "obj (in showcruc)",obj
    print "selected objects: ",o1,"  and ",o2
    if o1 in obj and o2 in obj:
        nro1=obj.index(o1)
        nro2=obj.index(o2)
        mino1=x[nro1][crucprop[nro1][0]]
        maxo1=x[nro1][crucprop[nro1][1]]
        mino2=x[nro2][crucprop[nro2][0]]
        maxo2=x[nro2][crucprop[nro2][1]]
        minprop1=prop[crucprop[nro1][0]]
        maxprop1=prop[crucprop[nro1][1]]
        minprop2=prop[crucprop[nro2][0]]
        maxprop2=prop[crucprop[nro2][1]]
        txt="\n crucial properties "
        txt+="\n"+o1+":  Min_prop "+minprop1+" value: "+str(round(mino1,2))
        txt+="\n"+o1+":  Max_prop "+maxprop1+" value: "+str(round(maxo1,2))
        txt+="\n"+o2+":  Min_prop "+minprop2+" value: "+str(round(mino2,2))
        txt+="\n"+o2+":  Max_prop "+maxprop2+" value: "+str(round(maxo2,2))
        sct.insert("end",txt)
        maxo=max(maxo1,maxo2)
        cvc=Tkinter.Canvas(tpc,width=500,height=200)
        cvc.pack()
        cvc.create_line(40+400.0*mino1/(1.0*maxo),150,40+400.0*maxo1/(1.0*maxo),150,width=4,fill="red")  #changed 22.5.2013 
        cvc.create_line(40+400.0*mino2/(1.0*maxo),100,40+400.0*maxo2/(1.0*maxo),100,width=4,fill="red")  # changed 22.5.2013
        cvc.create_line(40,155,440,155)
        for i in range(0,6):
            cvc.create_line(40+80*i,157,40+80*i,153)
        cvc.create_line(20,90,20,160)
        cvc.create_text(40+400.0*mino1/(1.0*maxo),175,text=minprop1)
        cvc.create_text(40+400.0*maxo1/(1.0*maxo),175,text=maxprop1)
        cvc.create_text(40+400.0*mino2/(1.0*maxo),125,text=minprop2)
        cvc.create_text(40+400.0*maxo2/(1.0*maxo),125,text=maxprop2)
        cvc.create_text(10,150,text=o1)
        cvc.create_text(10,100,text=o2)
    else:
        txt="++++ sorry ++++ objects not found "
        sct.insert("end",txt)
        
def showcruc_b():
    """properties which are a min and max, resp of obbjects
    of the normalized data matrix """
    # Brg 10.6.08, 11.5.09, 22.5.2013
    o1=eobj1n.get()
    o2=eobj2n.get()
    tpc=Tkinter.Toplevel(hf,width=60,height=100)
    tpc.title('crucial attribute values')
    sct=ScrolledText(tpc,width=60,height=10)
    sct.pack()
    if o1 in obj and o2 in obj:
        nro1=obj.index(o1)
        nro2=obj.index(o2)
        minho1=yn[nro1][crucprop[nro1][0]]
        maxho1=yn[nro1][crucprop[nro1][1]]
        minho2=yn[nro2][crucprop[nro2][0]]
        maxho2=yn[nro2][crucprop[nro2][1]]
        absmin=min(minho1,minho2)
        absmax=max(maxho1,maxho2)
        faktor=1.0/(1.0*(absmax-absmin))
        mino1=1.0*(minho1-absmin)*faktor
        mino2=1.0*(minho2-absmin)*faktor
        maxo1=1.0*(maxho1-absmin)*faktor
        maxo2=1.0*(maxho2-absmin)*faktor
        minprop1=prop[crucprop[nro1][0]]
        maxprop1=prop[crucprop[nro1][1]]
        minprop2=prop[crucprop[nro2][0]]
        maxprop2=prop[crucprop[nro2][1]]
        txt="\n crucial properties "
        txt+="\n"+o1+":  Min_prop "+minprop1+" value: "+str(round(mino1,2))
        txt+="\n"+o1+":  Max_prop "+maxprop1+" value: "+str(round(maxo1,2))
        txt+="\n"+o2+":  Min_prop "+minprop2+" value: "+str(round(mino2,2))
        txt+="\n"+o2+":  Max_prop "+maxprop2+" value: "+str(round(maxo2,2))
        sct.insert("end",txt)
        cvc=Tkinter.Canvas(tpc,width=500,height=200)
        cvc.pack()
        cvc.create_line(40+400*mino1,150,40+400*maxo1,150,width=4,fill="red")
        cvc.create_line(40+400*mino2,100,40+400*maxo2,100,width=4,fill="red")
        cvc.create_line(40,155,440,155)
        for i in range(0,6):
            cvc.create_line(40+80*i,157,40+80*i,153)
        cvc.create_line(20,90,20,160)
        cvc.create_text(40+400*mino1,175,text=minprop1)
        cvc.create_text(40+400*maxo1,175,text=maxprop1)
        cvc.create_text(40+400*mino2,125,text=minprop2)
        cvc.create_text(40+400*maxo2,125,text=maxprop2)
        cvc.create_text(10,150,text=o1)
        cvc.create_text(10,100,text=o2)
    else:
        txt="++++ sorry ++++ objects not found "
        sct.insert("end",txt)
        
def emelim():
    #brg 9.7.10
    
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)

    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string


    eme=rmod2.marray(r,5)   #eme(i,0) min-attribute and its reduction of disparity
                                # eme(i,1) the value
                                # eme(i,2) max attribute and its reduction of disparity
                                # eme(i,3) the value
                                # eme(i,4) the range from min to max -- delta
    hilf=rmod2.vecgen1(k)
    for i in range(0,r):
        for j in range(0,k):
            hilf[j]=yn[i][j]
        ah,bh=rmod2.raisort(k,hilf)
        delta=ah[k-1]-ah[0]
        deltawithoutleast=ah[k-1]-ah[1]
        deltawithoutgreatest=ah[k-2]-ah[0]
        if delta!=0:
            deltaleast=1.0*deltawithoutleast/(1.0*delta)
            deltagreatest=1.0*deltawithoutgreatest/(1.0*delta)
        else:
            deltaleast=0
            deltagreatest=0
        eme[i][0]=bh[0]
        eme[i][1]=deltaleast
        eme[i][2]=bh[k-1]
        eme[i][3]=deltagreatest
        eme[i][4]=delta

    tpemel=Tkinter.Toplevel(hf)    #new: 22.5.2013
    tpemel.title(' end of member elimination ')
    temel=ScrolledText(tpemel,width=60, height=20)
    temel.pack()
    txt=" End member elimination "+"\n"
    txt+=57*"="+"\n"
    txt+="\t"+"  delta...."+"\n"
    txt+=2*"\t"+"   least"+"\t"+"   greatest"+"\t"+"    range"+"\n"
    for i in range(0,r):
        txt+="Obj: "+str(obj[i])+3*"\t"+str(round(eme[i][1],3))+"\t"+str(round(eme[i][3],3))+"\t"+str(round(eme[i][4],3))+"\n"
    txt+="\n"
    txt+="--- e o f --- "
    temel.insert("end",txt)
    # Graphics
    h1=rmod2.vecgen1(r)
    h2=rmod2.vecgen1(r)
    h3=rmod2.vecgen1(r)
    barth=rmod2.vecgen1(r)
    
    for i in range(0,r):
        h1[i]=eme[i][1]
        h2[i]=eme[i][3]
        h3[i]=eme[i][4]
        barth[i]=obj[i]
        
    app1=raioop2.brgbar6(hf,h1,barth,"eme_least "," End Member Elimination",12)
    app2=raioop2.brgbar6(hf,h2,barth,"eme_greatest"," End Member Elimination ",12)
    app3=raioop2.brgbar6(hf,h3,barth," eme ranges"," End Member Elimination ",12)
    app1.ausgabe()
    app2.ausgabe()
    app3.ausgabe()
            
            
def singleobjemel():
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)

    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string


    eme=rmod2.marray(r,5)   #eme(i,0) min-attribute and its reduction of disparity
                                # eme(i,1) the value
                                # eme(i,2) max attribute and its reduction of disparity
                                # eme(i,3) the value
                                # eme(i,4) the range --  delta --
    hilf=rmod2.vecgen1(k)
    for i in range(0,r):
        for j in range(0,k):
            hilf[j]=yn[i][j]
        ah,bh=rmod2.raisort(k,hilf)
        delta=ah[k-1]-ah[0]
        deltawithoutleast=ah[k-1]-ah[1]
        deltawithoutgreatest=ah[k-2]-ah[0]
        if delta!=0:
            deltaleast=1.0*deltawithoutleast/(1.0*delta)
            deltagreatest=1.0*deltawithoutgreatest/(1.0*delta)
        else:
            deltaleast=0
            deltagreatest=0
        eme[i][0]=bh[0]
        eme[i][1]=deltaleast
        eme[i][2]=bh[k-1]
        eme[i][3]=deltagreatest
        eme[i][4]=delta

    objectact=eobj.get()
    iobj=obj.index(objectact)
    
    txtemelin=" End Member Elimination \n"
    txtemelin+="Object: "+objectact+"\n"
    txtemelin+="  range           \t"+str(round(eme[iobj][4],2))+"\n" 
    txtemelin+="  least attribute \t"+prop[eme[iobj][0]]+"\n"
    txtemelin+="  deltaleast= \t"+str(round(100-eme[iobj][1]*100,2))+"\n"
    txtemelin+="  greatest attribute \t"+prop[eme[iobj][2]]+"\n"
    txtemelin+="  deltagreatest= \t"+str(round(100-eme[iobj][3]*100,2))
    txtemelin+="\n\n"
    temelin.insert("end",txtemelin)
    buttaddhelp=Tkinter.Button(temelin,text="additional info?",bg="green",command=eme_explain)
    temelin.window_create("end",window=buttaddhelp)
    pos="1.0"
    temelin.tag_add("info",pos,pos+"wordend")
    temelin.tag_config("info",font=("arial",8,"italic"))

def eme_explain():
    txte="Some more details:"+"\n"
    txte+="Consider the rank order of the attributes\n"
    txte+="Let us assume q1<q2<....qm \n"
    txte+="range: = max(q) - min(q) = qm-q1\n"
    txte+="deltaleast = 100 - 100*(qm-q2)/(qm-q1) \n"
    txte+="deltagreatest= 100 - 100*(qm-1-q1)/(qm-q1)  \n"
    txte+="The larger deltaleast the more efficient an improvement of q1 \n"
    txte+="The larger deltagreatest the more efficient an improvement of qm \n"
    tpadd=Tkinter.Toplevel(hf)
    tpadd.title("additional help for end member elimination ")
    tadd=ScrolledText(tpadd,width=80,height=5)
    tadd.pack()
    tadd.insert("end",txte)
    

def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 10.6.08
    # brg 10.6.08
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y
                  
    

def rfilter():
    global i12set,orderchar
    dobj=o1.get()  
    #print "filter generating object: ",dobj
    #print "objred ",objred
    i1=objred.index(dobj)
    i1set=set([i1])
    for j in range(0,n):
        if zeta[i1][j]==1:
            i1set=i1set|set([j])
    i2set=set([0])
    for i in range(1,rred):
        i2set=i2set|set([i])
    i12set=i1set&i2set
    orderchar="principal filter of "+dobj
    graphs()

def rideal():
    global i12set,orderchar
    uobj=o2.get() #upper object
    i2=objred.index(uobj)
    i2set=set([i2])
    for i in range(0,n):
        if zeta[i][i2]==1:
            i2set=i2set|set([i])
    i1set=set([0])
    for i in range(1,rred):
        i1set=i1set|set([i])
    i12set=i1set&i2set
    orderchar="principal ideal of "+uobj
    graphs()
     

def rinterv():
    global i12set,orderchar
    print " rinterval i12set ",i12set
    dobj=o3.get() #lower object
    uobj=o4.get() #upper object
    print "rinterval dobj ",dobj
    print "rinterval uobj ",uobj
    i1=objred.index(dobj)
    i2=objred.index(uobj)
    i1set=set([i1])
    for j in range(0,rred):
        if zeta[i1][j]==1:
            i1set=i1set|set([j])
    i2set=set([i2])
    for i in range(0,rred):
        if zeta[i][i2]==1:
            i2set=i2set|set([i])
    i12set=i1set&i2set
    orderchar="interval "+dobj+" - "+uobj
    graphs()
     

def graphs():
    tpsub=Tkinter.Toplevel(hf)
    tpsub.title(' subgraphs ')
    l12=len(i12set)
    objsub=rmod2.vecgentext1(l12)
    z=0
    print "in graphs: rred = ",rred,"  objred = ",objred 
    for i in range(0,rred):
        if objred.index(objred[i]) in i12set:
            objsub[z]=objred[i]
            z+=1
        
    zetaneu=rmod2.marray(l12,l12)
    z1=0
    for i in range(0,rred):
        z2=0
        for j in range(0,rred):
            if i in i12set and j in i12set:
                if zeta[i][j]==1:
                    zetaneu[z1][z2]=1
                else:
                    zetaneu[z1][z2]=0
                z2+=1   
        if i in i12set:
            z1+=1

    #rmod2.matout(l12,l12,zetaneu)
    n=l12
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zetaneu)
    
    levmaxg=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmaxg:
            levmaxg=len(lobj[i])
            
    print "zzmax = ",zzmax
    print "levmaxg =",levmaxg
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zetaneu)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>50:
        lbhd2=Tkinter.Label(tpsub,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(tpsub,width=60, height=6)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(tpsub,text=orderchar)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmaxg,zzmax)
        
        
        cv=Tkinter.Canvas(tpsub,width=actwidth,height=actheight)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-circle,geomy[i][j]+circle,geomx[i][j]+circle,geomy[i][j]-circle,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objsub[lobj[i][j]])
        
#        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
#        cv.create_text(garrow1x+8,garrow1y-6,text="high")
#        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()


def msgwarning():
    tkMessageBox.showwarning("++No data matrix available ++"," you must select a file")

    
    
def about():
    "literatur information "
    hflit=Tkinter.Toplevel(hf)
    hflit.title("about")
    frlit=Tkinter.Frame(hflit,width=100, height=4)
    frlit.pack()
    txt="\n"
    txt+="Program developed by R.Bruggemann, June, 10th, 2008 \n"
    txt+="Mathematical background may be: interval order, see Trotter, Combinatorics and Partially Ordered Sets, John Hopkins, 1992 \n"
    txt+="see also Denoeux et al., Fuzzy Sets and Systems, 153, 1-28, 2005\n"
    txt+="\n"
    txt+="End member elimination, idea based on: Myers,W.L., Patil,G.P., Cai,Y., 2006 in Brueggemann & Carlsen (eds): "
    txt+="Partial Order in Environm. Sc. and Chemistry, page 309-325, Springer, Heidelberg, Germany"
    tlit=ScrolledText(frlit,width=60,height=4)
    tlit.pack()
    tlit.insert("end",txt)

  
    

def fileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    import tkFileDialog
    global fn,x,ob,pr,r,k,prop,obj,flagnorm, circle
    fn=tkFileDialog.askopenfilename()
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    #rmod2.matout(r,k,x)
    rmod2.matcopy(r,k,x,y)
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    lbnorm.config(bg="white")
    lbnorm["text"]=""
    flagnorm=0
    try:
        circle=int(ecircle.get())
    except:
        circle=10
    return 

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from simi3
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(y[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def matchar():
    """ characterizes the original dm """
    # brg 9.12.07
    hfchar=Tkinter.Toplevel(hf)
    hfchar.title(' characteristics of dm ')
    lbhfchar=Tkinter.Label(hfchar,text=' characteristics of the data matrix ')
    tchar=ScrolledText(hfchar, width=60, height=5)
    tchar.pack()
    
    a=rmod2.matrixchar(r,k,y)
    #rmod2.matout(4,k,a)
    txt="\n characteristics of the dm-properties \n"
    txt+="number of rows  "+str(r)+ "  number of columns "+str(k)+"\n"
    for j in range(0,k):
        txt+="\t"+prop[j]+"       "
    txt+="\n"
    txt+="max   :\t"
    for j in range(0,k):
        txt+=str(a[0][j])+"\t"
    txt+="\nmin   :\t"
    for j in range(0,k):
        txt+=str(a[1][j])+"\t"
    txt+="\nmean  :\t"
    for j in range(0,k):
        txt+=str(a[2][j])+"\t"
    txt+="\nstdev :\t"
    for j in range(0,k):
        txt+=str(a[3][j])+"\t"
    txt+="\n"
    tchar.insert("end",txt)

    
def matnorm(r,k,x):
    """ normalizes the columns of dm to 0,1 """
    # brg 9.12.07, 7.5.08, 10.6.08
    global yn,flagnorm              # wesentliche Aenderung!!
    yn=rmod2.matrixnorm(r,k,x)
    
    flagnorm=1
    butt6.config(state="active")
    butt7.config(state="active")
    return yn

def interval():
    """ from each row of the column-normalized dm
    the min and the max value will be determined """
    global ynprof,crucprop
    yn=matnorm(r,k,x)
    #rmod2.matout(r,k,yn)
    crucprop=rmod2.marray(r,2)
    ynprof=rmod2.marray(r,2)
        
    for i in range(0,r):
        ynmin=10**20
        for j in range(0,k):
            if yn[i][j]<=ynmin:
                ynmin=yn[i][j]
                crucprop[i][0]=j
        ynprof[i][0]=ynmin
    
    for i in range(0,r):
        ynmax=-10**20
        for j in range(0,k):
            if yn[i][j]>=ynmax:
                ynmax=yn[i][j]
                crucprop[i][1]=j
        ynprof[i][1]=ynmax
    lbnorm.config(bg="yellow")
    lbnorm["text"]="Normalization and min-max calc.is done"     

def interval_b():
    """ from each row the min and the max value will be determined
    - without the columnwise normalization """
    global ynprof,crucprop
    crucprop=rmod2.marray(r,2)
    ynprof=rmod2.marray(r,2)
        
    for i in range(0,r):
        ynmin=10**20
        for j in range(0,k):
            if x[i][j]<=ynmin:
                ynmin=x[i][j]
                crucprop[i][0]=j
        ynprof[i][0]=ynmin
    
    for i in range(0,r):
        ynmax=-10**20
        for j in range(0,k):
            if x[i][j]>=ynmax:
                ynmax=x[i][j]
                crucprop[i][1]=j
        ynprof[i][1]=ynmax
    lbnormb.config(bg="yellow")
    lbnormb["text"]=" min-max calc.is done"     



def showDMprof():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from simi3
    tp3=Tkinter.Toplevel(hf)
    tp3.title('show interval-DM')
    lbtp2=Tkinter.Label(tp3,text=" General information about the interval data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp3,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    
    txt3="\n interval data matrix  \n"
    txt3+="\t"
    txt3+="    min"+"\tmax"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,2):
            txt3+=str(round(ynprof[i][j],2))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt3
    tfile.insert("end",txt)    
            

def filecompprof(r,ynprof):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08 , 10.6.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global xprof,rprof,objprof
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    propprof=rmod2.vecgentext1(2)
    propprof[0]="min"
    propprof[1]="max"
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rprof,xprof,objprof,txtprof,neq=rmod2.equivcompactm(r,2,ynprof,obj)   #20.6.08, 16.9.08 
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rprof,xprof,objprof,propprof,txtprof           
                


def HDprof():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 200 then only the cover-matrix and the level-population
    #
    global zeta,zetaprof,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    rred,xred,objred,prop,txt=filecompprof(r,ynprof)
    n=rred
    txtn="Number of representants "+str(n)+"\n"
    txtn+=txt
    tpeqprof=Tkinter.Toplevel(hf)
    tpeqprof.title(' equivalence classes of the min-max DM ')
    teqprof=ScrolledText(tpeqprof,width=60,height=5)
    teqprof.pack()
    teqprof.insert("end",txtn)
    #
    zetahilf=rmod2.comp(n,2,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic=Tkinter.Toplevel(hf)
    tpbasic.title(' basic characteristics of the min-max Hasse diagram ')
    lbbasic=Tkinter.Label(tpbasic,text="number of level: \t\t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic.pack()
    
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zetaprof=rmod2.cover(n,tr,lext)
    if n>200:
        coverprof_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
##        print "actual width  ",actwidth
##        print "actual height ",actheight
##        print "factory       ",factory
##        print "factorx       ",factorx
##        print "garrow1x      ",garrow1x
        
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight, bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zetaprof[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-circle,geomy[i][j]+circle,geomx[i][j]+circle,geomy[i][j]-circle,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=coverprof_show)
        buttcover.pack()

def coverprof_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07, 22.6.16
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations of max-min based poset ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zetaprof[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
                        
def filecomporig(r,yn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,yn,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,txt   

def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07, 3.9.16
    # If the number of representants > 200 then only the cover-matrix and the level-population
    #
    global zeta,zeta2,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    rred,xred,objred,txt=filecomporig(r,x)
    n=rred
    tpeqorig=Tkinter.Toplevel(hf)
    tpeqorig.title(' equivalence classes of the original DM ')
    teqorig=ScrolledText(tpeqorig,width=60,height=5)
    teqorig.pack()
    teqorig.insert("end",txt)
    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic2=Tkinter.Toplevel(hf)
    tpbasic2.title(' basic characteristics of the orig HD ')
    lbbasic2=Tkinter.Label(tpbasic2,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>100:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
##        print "actual width  ",actwidth
##        print "actual height ",actheight
##        print "factory       ",factory
##        print "factorx       ",factorx
##        print "garrow1x      ",garrow1x
        
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-circle,geomy[i][j]+circle,geomx[i][j]+circle,geomy[i][j]-circle,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def HDinclus():
    # 11.5.09 , 22.5.2013 Brg
    global objredincl,cov

    n,dm,objredincl,prop,txt=filecompprof(r,ynprof)
    zeta=rmod2.marray(n,n)

    for i in range (0,n):
        for j in range(0,n):
            if dm[i][0]>=dm[j][0] and dm[i][1]<=dm[j][1]:
                zeta[i][j]=1


    #rmod2.matout(n,n,zeta)

    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
      
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       

    cov=rmod2.cover(n,tr,lext)

    #rmod2.matout(n,n,cov)

    tpinclus=Tkinter.Toplevel(hf)
    tpinclus.title(' Inclusion Order ')

    if n>100:
        coverincl_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(tpinclus,text=" Interval-Inclusion Hasse Diagram ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(tpinclus,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-circle,geomy[i][j]+circle,geomx[i][j]+circle,geomy[i][j]-circle,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredincl[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcovinclus=Tkinter.Button(tpinclus,text="cover-relations of inclusion order ",command=coverincl_show)
        buttcovinclus.pack()

def coverincl_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07, 22.5.2013
    #*28.12.07
    #akt 22.5.2013
    #note: -
    #source: -
    hfcoverincl=Tkinter.Toplevel(hf)
    hfcoverincl.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcoverincl,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objredincl[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objredincl[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcoverincl,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def RRRlike():
    #brg 14.7.10
    #this is not really an RRR, however
    #a similar presentation
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    yn=rmod2.matrixnorm(r,k,x)
    minq=rmod2.vecgen1(r)
    maxq=rmod2.vecgen1(r)
    delta=rmod2.vecgen1(r)
    for i in range(0,r):
        minq[i]=min(yn[i])
        maxq[i]=max(yn[i])
        delta[i]=maxq[i]-minq[i]
        
    mq=0
    for i in range(0,r):
        mq+=(minq[i]+maxq[i])/2.0
    mq=1.0*mq/r
    tpgesamt=Tkinter.Toplevel(hf)
    tpgesamt.title(' RRR-diagrams ')
    zlines=10
    zsubdiag=10
    if r<=zlines*zsubdiag:
        lbnormal=Tkinter.Label(tpgesamt,text="++extended representation ++",bg="yellow")
        lbnormal.pack()
        nodreal=int(math.ceil(1.0*r/zlines))
        flag=1
        db=20
        lw=12
        color="cyan"
    elif zlines*zsubdiag<r<500:
        lbreduced=Tkinter.Label(tpgesamt, text="+++only simplified representation +++",bg="yellow")
        lbreduced.pack()
        zlines=50
        nodreal=int(math.ceil(1.0*r/(1.0*zlines)))
        db=5
        lw=3
        flag=0
        color="black"
    else:
        lbsorry=Tkinter.Label(tpgesamt,text="++sorry no representation yet +++",bg="yellow")
        lbsorry.pack()
        flag=-1
    if flag!=-1:    
        tcl=rmod2.vecgen1(nodreal)
        for i in range(0,r):
            maxq[i]=minq[i]+delta[i]
        maxx=max(maxq)
        scale=200
        f1=scale*(1.0/maxx)
        f2=scale*1.0/(2.0*maxx)

        for diag in range(0,nodreal):
            tcl[diag]=Tkinter.Toplevel(tpgesamt)
            tcl[diag].title(str(diag+1) +" subdiagram")
            cv=Tkinter.Canvas(tcl[diag],width=400,height=400,bg="white")
            cv.pack()


            line1=cv.create_line(50,300,50,50,arrow="last")
            line2=cv.create_line(50,300,350,300)
            for i2 in range(0,300,5):
                linemq=cv.create_line(50+i2,(300-f1*mq),53+i2,(300-f1*mq))
            
            
            i=0
            for i1 in range(diag*zlines,(diag+1)*zlines):
                if i1>=r:
                    break
                line=cv.create_line(55+db*i,300-f1*(minq[i1]),55+db*i,300-f1*(minq[i1]+delta[i1]),fill=color,width=lw,tag="rrr")
                if flag!=0:
                    text=cv.create_text(55+db*i,300-f1*minq[i1]-f2*delta[i1],text=obj[i1],font=("arial",8))
                i+=1
    else:
        lbheul=Tkinter.Label(tpgesamt, text="++too many objects +++")
        lbheul.pack()



hf=Tkinter.Tk()
hf.title("    GUI:     min- max order                   ")
helpinterval=raioop2.brgabout(hf,"tp1","help_interval.txt",9,\
            "Sept., the 3rd, 2016"," help_interval ", "white", "t1",120,10,ScrolledText)
    
fr=Tkinter.Frame(hf,width=400,height=400)
fr.pack()

aboutinterval=raioop2.brgabout(fr,"tp1","about_interval.txt",9,\
            "Sept, the 3rd, 2016"," about_interval ", "white", "t1",80,5,ScrolledText)


labecircle=Tkinter.Label(fr,text="Enter a radius for the circles of the Hasse diagrams\
    \n(Default=10)")
labecircle.pack()
ecircle=Tkinter.Entry(fr, width=5)
ecircle.pack()
butt1=Tkinter.Button(fr,text="(1)select and open file ",width=50,bg="white",command=fileopen)
butt1.pack()   #10.6.08
lbopen1=Tkinter.Label(fr,text="")
lbopen1.pack()
frneu=Tkinter.Frame(fr,bd=3,relief="sunken")
frneu.pack()
buttshow=Tkinter.Button(frneu,text="show dm",bg="cyan",width=20,command=showDM)
buttshow.grid(row=0,column=0)
buttchar=Tkinter.Button(frneu,text="char. dm",width=20,bg="cyan",command=matchar)
buttchar.grid(row=0,column=1)


butt2a=Tkinter.Button(frneu,text="(2)min-max norm.",bg="cyan",width=20,command=interval)
butt2a.grid(row=1,column=0)

butt2b=Tkinter.Button(frneu,text="(2)min-max unnorm.",bg="cyan",width=20,command=interval_b)
butt2b.grid(row=1,column=1)


butt3=Tkinter.Button(frneu,text="show data matrix min- max",width=20,command=showDMprof)
butt3.grid(row=3,columnspan=2)
tpresults=Tkinter.Toplevel(hf)
lbnorm=Tkinter.Label(tpresults,text="",bg="cyan")
lbnorm.pack()
lbnormb=Tkinter.Label(tpresults,text="",bg="cyan")
lbnormb.pack()
lbgfm=Tkinter.Label(tpresults,text="")
lbgfm.pack()
butRRR=Tkinter.Button(fr,text="RRR-like-presentation",bg="cyan",width=50,command=RRRlike)
butRRR.pack()

butt4=Tkinter.Button(fr,text="(3)HD min-max",bg="cyan",width=50,command=HDprof)
butt4.pack(pady=5)
frleftright=Tkinter.Frame(fr,width=100,height=25)
frleftright.pack()
frleft=Tkinter.Frame(frleftright,width=50,height=25, bd=2,relief="groove")
frleft.pack(side="left")
labobj=Tkinter.Label(frleft,text="(unnormormalized) obj1, obj2: >>>")
labobj.pack(side="left")
eobj1=Tkinter.Entry(frleft,width=4)
eobj1.pack(side="left")
eobj2=Tkinter.Entry(frleft,width=4)
eobj2.pack(side="left")
buttobj=Tkinter.Button(frleft,text="object analysis",width=10,bg="cyan",height=2,command=showcruc)
buttobj.pack(side="bottom")
frright=Tkinter.Frame(frleftright,width=50,height=25,bd=2,relief="groove")
frright.pack(side="right")
labobj=Tkinter.Label(frright,text=" (normalized) obj1, obj2: >>>")
labobj.pack(side="left")
eobj1n=Tkinter.Entry(frright,width=4)
eobj1n.pack(side="left")
eobj2n=Tkinter.Entry(frright,width=4)
eobj2n.pack(side="left")
buttobjn=Tkinter.Button(frright,text="object analysis",width=10,bg="cyan",height=2,command=showcruc_b)
buttobjn.pack(side="bottom")

frinclus=Tkinter.Frame(fr,width=100,height=5)
frinclus.pack()
buttinclus=Tkinter.Button(frinclus,text="inclusion order",width=50,bg="cyan",height=1,command=HDinclus)
buttinclus.pack(pady=5)
# order ideals, -filters, -intervals
frfilter=Tkinter.Frame(fr,relief="sunken",bd=2,width=100)
frfilter.pack(fill="x",pady=5)
lbfilter=Tkinter.Label(frfilter,text=">>>enter filter-generating object >>>")
lbfilter.pack(side="left",fill="x")
o1=Tkinter.Entry(frfilter,width=10)
o1.pack(side="left")
buttfilter=Tkinter.Button(frfilter,text = "filter ",bg="cyan",width=15,command=rfilter)
buttfilter.pack()

frideal=Tkinter.Frame(fr,relief="sunken",bd=2,width=100)
frideal.pack(fill="x")
lbideal=Tkinter.Label(frideal,text=">>>enter ideal-generating object >>>")
lbideal.pack(side="left",fill="x")
o2=Tkinter.Entry(frideal,width=10)
o2.pack(side="left")
buttideal=Tkinter.Button(frideal,text = "ideal ",bg="cyan",width=15,command=rideal)
buttideal.pack()

frinterv=Tkinter.Frame(fr,relief="sunken",bd=2,width=100)
frinterv.pack()
lbinterv1=Tkinter.Label(frinterv,text=">enter generat.object (below)>>")
lbinterv1.pack(side="left")
o3=Tkinter.Entry(frinterv,width=10)
o3.pack(side="left")
lbinterv2=Tkinter.Label(frinterv,text=">enter generat.object (above)>>")
lbinterv2.pack(side="left")
o4=Tkinter.Entry(frinterv,width=10)
o4.pack(side="left")              
buttinterv=Tkinter.Button(frinterv,text = "interval ",bg="cyan",width=15,command=rinterv)
buttinterv.pack()

frorig=Tkinter.Frame(fr,width=100,height=10, relief="sunken",bd=3)
frorig.pack(pady=2)
butt5=Tkinter.Button(frorig,text="(4)HD orig DM",bg="cyan",width=50,command=HD)
butt5.pack(pady=2)
butt6=Tkinter.Button(frorig,text="end member elimination ",bg="cyan",width=50,command=emelim,state="disabled")
butt6.pack(pady=2)
frobj=Tkinter.Frame(hf)
frobj.pack(pady=2)
lbobj=Tkinter.Label(frobj,text=" End of member : which object >>> ")
lbobj.pack(side="left")
eobj=Tkinter.Entry(frobj,width=5)
eobj.pack(side="left")
frfinal=Tkinter.Frame(hf)
frfinal.pack(pady=5)
butt7=Tkinter.Button(frfinal,text=" end member elim: \nAnalysis of an individual object",bg="cyan",command=singleobjemel,state="disabled")
butt7.pack()
tpemelin=Tkinter.Toplevel(hf)
tpemelin.title('end member elimination ')
temelin=ScrolledText(tpemelin,width=80,height=10)
temelin.pack()
buttsf=Tkinter.Button(frfinal, text = "store changed (normalized)\n dm with min, max ",bd=5,width=25,bg="cyan",\
                      command=sf)
buttsf.pack(pady=2)
lbsuccess=Tkinter.Label(frfinal,text="")
lbsuccess.pack()
buttexit=Tkinter.Button(frfinal,text="  exit   ",font="bold",width=25,bd=4,bg="red",command=hf.destroy)
buttexit.pack(pady=5)
hf.mainloop()
