#############################################
# 17.8.2012 funktioniert !!!!               #
#############################################
# 4.2.2013 cosmetics
# 9.and 10. Sept.2013 cosmetics
# 4.11.2014 Correction: navigation: interval
# 10.11.2014 Heavy changes due to a bug in the representation of equivalence classes
#............Along all these changes some other corrections and adaptions are done


def graphHD(perturb,objred,navigset,posetch, graphch, oblist, cov, lobj, nameofTP,titleofTP,txtequiv):
        # brg 15.8.2012, 16.8.2012, 18.12.2012
        nameofTP=Tkinter.Toplevel(hf)
        nameofTP.title(titleofTP)
        lbequiv=Tkinter.Label(nameofTP,text=txtequiv)   #18.12.2012, 10.11.2014
        lbequiv.pack()
        rred=posetch[0]
        level=posetch[1]
        levmax=posetch[2]
        f=graphch[0]
        diameter=graphch[1]
        diamsp=graphch[2]
        fontobj=graphch[3]
        fontobjsp=graphch[4]
        obsp=oblist[0]         # marking an object in main HD
        ob1=oblist[1]          # one generating object
        ob2=oblist[2]          # another generating object for interval
        color="cyan"
        colorsp="yellow"
        fonttypesp="bold"
        fonttype=""
        
        try:
                iobsp=objred.index(obsp)
        except:
                iobsp=999999
        try:
                iob1=objred.index(ob1)
        except:
                iob1=999999
        try:
                iob2=objred.index(ob2)
        except:
                iob2=999999
        

        l=rmod2.vecgen1(level)
        for i in range(0,level):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(level)
        for i in range(0,level):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)
        actwidth,actheight,factorx,\
            factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD1(rred,levmax,level)
        cv=Tkinter.Canvas(nameofTP,width=actwidth*f,height=actheight*f,bg="white")
        cv.pack()
   
        for i in range(0,level):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(f*factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(f*factory/level)*i
            
        
        for i in range(0,level-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,level):
                    for j1 in range(0,l[i1]):
                        if objred[lobj[i1][j1]] in navigset and objred[lobj[i][j]] in navigset:
                            if cov[lobj[i1][j1]][lobj[i][j]]==1:
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])

        
        for i in range(0,level):
            for j in range(0,l[i]):
                    if objred[lobj[i][j]] in navigset: #general section condition
                            if iobsp==lobj[i][j]: #marking of one object
                                    cv.create_oval(geomx[i][j]-diamsp,geomy[i][j]+diamsp,geomx[i][j]+diamsp,geomy[i][j]-diamsp,\
                                           fill=colorsp,tags="object_"+str(objred[lobj[i][j]]))
                                    cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]],font=("arial",fontobjsp,fonttypesp))
                            elif iob1==lobj[i][j]:  #ob1 i.e. iob1 is a generating object 
                                    cv.create_oval(geomx[i][j]-diameter,geomy[i][j]+diameter,geomx[i][j]+diameter,geomy[i][j]-diameter,\
                                       fill=color,tags="object_"+str(objred[lobj[i][j]]))
                                    cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]], font=("arial",fontobj,fonttype))
                            elif iob2==lobj[i][j]: #ob2 e.e. iob2 is a generating object
                                    cv.create_oval(geomx[i][j]-diameter,geomy[i][j]+diameter,geomx[i][j]+diameter,geomy[i][j]-diameter,\
                                       fill=color,tags="object_"+str(objred[lobj[i][j]]))
                                    cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]], font=("arial",fontobj,fonttype))
                            else: #standard
                                    print "standard "
                                    cv.create_oval(geomx[i][j]-diameter,geomy[i][j]+diameter,geomx[i][j]+diameter,geomy[i][j]-diameter,\
                                       fill="white",tags="object_"+str(objred[lobj[i][j]]))
                                    cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]], font=("arial",fontobj,fonttype))
        return cv,garrow1x,garrow1y,garrow2y,actheight                           
        
 
            




class HD(object):
    import Tkinter
    import tkMessageBox
    def __init__(self,max_count_of_vertices,mouse):
        """based on objred (zeta-matrix) the Hasse diagram is generated and one of the linear extension)"""
        # Brg 20.12.07, 28.12.07, 16.8.2012, 19.8.2012
        # If the number of representants > 200 then only the cover-matrix and the level-population
        # Begin of a rearrangement of HD inbto a class: brg 12.8.2012
        # The parameters method, max_count_...,mouse are programming parameter
        # and are not accessible by the user
        #self.fn=fn              # name of File
        #self.method=method      # method = 1 then 'old' method,
                                # method = 0 then the new method (trred) which
                                # also can analyze very large dms.
        self.max_count_of_vertices=max_count_of_vertices   # A HD may be only useful with less than this number
                                #  if the number of vertices > max_count_of_vertices then only the cover-relations are shown
        
              
        self.mouse=mouse         # 1: mouse activity allowed , 0: mouse activity disabled
        
        

        
    def methodreadin(self,method):
        self.method = 1
        #print "method in 'methodreadin'",self.method
                
            
    def inread(self):                             
        #brg 12.8.2012, 14.8.2012
        #self.fn=fn
        self.fn=tkFileDialog.askopenfilename(title='data matrix (txt)')    
        self.dm,ob,pro,self.r,self.k=rmod2.EXCELreadin6(self.fn)
        self.obj=[]
        for i in range(0,self.r):
            self.obj.append(ob[i+1])
        self.prop=[]
        for j in range(0,self.k):
            self.prop.append(pro[j+1])

        #self.rred,self.xred,self.objred,self.txteq,self.neq=rmod2.equivcompactgr1(self.r,self.k,self.dm,self.obj)
        self.eqm = rmod2.equivcompactgr3(self.r,self.k, self.dm)
        self.eqlist,self.objred,self.rred=rmod2.deliver_readable_eqclasses(self.r,self.eqm,self.obj)
        self.xred=rmod2.calc_reduceddm(self.r,self.k,self.dm,self.obj,self.objred)
        
        
##        self.txteqvec=self.txteq.split("\n")
        
        tpinread=Tkinter.Toplevel(hf)
        tpinread.title(' Read in data/PyHasse format')
        labeq=Tkinter.Label(tpinread,text="file = "+str(self.fn)+":\n calc. is based on representants\n\
            Number of objects: "+str(self.r)+"\nnumber of vertices: "+str(self.rred)+"\nnumber of attributes: "+str(self.k))
        labeq.config(bg="yellow")
        labeq.pack()
        

    def inread_pdt(self):
        # brg 17.8.2012
        
        """ File selection of transformed data matrices (format pdt)
            through other PyHasse programs """
        #* 1.6.09
        # akt. 1.6.09, 17.8.2012
        # source: mainHD20_5
        #self.fn=fn
        self.fn=tkFileDialog.askopenfilename(title='data matrix (pdt)') 
        self.r,self.k, self.dm,self.obj,self.prop=rmod2.raireadin5(self.fn)
        self.eqm = rmod2.equivcompactgr3(self.r,self.k, self.dm)
        self.eqlist,self.objred,rred=rmod2.deliver_readable_eqclasses(self.r,self.eqm,self.obj)
        self.xred=rmod2.calc_reduceddm(self.r,self.k,self.dm,self.obj,self.objred)
        self.rred = rred
        
##        self.rred,self.xred,self.objred,self.txteq,self.neq=rmod2.equivcompactgr1(self.r,self.k\
##                ,self.dm,self.obj)
##        self.txteqvec=self.txteq.split("\n")
        tpinread=Tkinter.Toplevel(hf)
        tpinread.title( 'Read in pdt-format ')
        labeq=Tkinter.Label(tpinread,text="file = "+str(self.fn)+":\n calc. is based on representants\n\
            Number of objects: "+str(self.r)+"\nnumber of vertices: "+str(self.rred)+"\nnumber of attributes: "+str(self.k))
        labeq.config(bg="yellow")
        labeq.pack()
        
    
    def sto_cov(self):
        """ stores the cover matrix """
        # brg 17.8.2012 , taken from mainHD20_5               
        #rmod2.matout(rred,rred,cov)
        fnc=tkFileDialog.asksaveasfilename(title="Save cov_file ",\
                 defaultextension=".txt") #14.3.09
        rmod2.raiwritecov1(fnc,self.cov,self.objred,self.rred)   #14.3.09, 2.12.09
        import tkMessageBox
        tkMessageBox.showinfo(title="store cov",message="successfull!")

    def sto_zeta(self):
        """ stores the zeta matrix """
        # brg 17.8.2012                
        #rmod2.matout(rred,rred,cov)
        fnz=tkFileDialog.asksaveasfilename(title="Save zeta_file ",\
                 defaultextension=".txt") #14.3.09
        rmod2.raiwritecov1(fnz,self.zeta,self.objred,self.rred)   #14.3.09, 2.12.09
        import tkMessageBox
        tkMessageBox.showinfo(title="store zeta",message="successfull!")


    def sto_graphviz(self):
        """ stores the cover matrix in graphviz
            format """
        # brg 15.3.09, 17.8.2012. taken from mainHD20_5.py
        covgr=rmod2.marray(self.rred,self.rred)
        for i1 in range(0,self.rred):
                for i2 in range(0,self.rred):
                        if i1!=i2:
                                covgr[i1][i2]=self.cov[i1][i2]
        txtgr=rmod2.covtxt(covgr,self.objred,self.rred,"digraph_x") #central routine! 
        app1=raioop2.brgsavefile3(hf,'t','w',txtgr,self.rred,self.rred)
        txtfnfnp=app1.info_brgsavefile3()
        import tkMessageBox
        
        tkMessageBox.showinfo(title="store graphviz-interface",message="successfull!\n"+str(txtfnfnp))

    def sto_pdt(self):
        # brg 17.8.2012, taken from discretiz3.py
        #brg  31.5.09, 1.6.09
        fnpdt=tkFileDialog.asksaveasfilename(parent=hf,title="save dm as pdt-file")
        rmod2.raiwrite5(fnpdt,self.dm,self.obj,self.prop,self.r,self.k)
        import tkMessageBox
        tkMessageBox.showinfo(title="store pdt",message="successafull!")    


    def show(self):
        # brg 12.8.2012
        """  shows the data matrix """
        #Brg taken from combsimilarity3 13.1.08, 4.8.2012
        tpfile=Tkinter.Toplevel(hf)
        tpfile.title(" Show data matrix ")
        from ScrolledText import ScrolledText
        tfile=ScrolledText(tpfile,width=80,height=10)
        tfile.pack()
        txt1="\n"
        txt1+="\n objects\n"
        for i in range(0,self.r):
            txt1+=" "+self.obj[i]+",\t"
        txt1+="\n"
        txt2="\n properties  \n"
        for j in range(0,self.k):
            txt2+=" "+self.prop[j]+",\t"
        txt2+="\n"
        txt3="\n data matrix  \n"
        txt3+="\t"
        for j in range(0,self.k):
            txt3+=self.prop[j]+"\t"
        txt3+="\n"    
        for i in range(0,self.r):
            txt3+=self.obj[i]+"\t"
            for j in range(0,self.k):
                txt3+=str(self.dm[i][j])+"\t"
            txt3+="\n"
        txt3+="\n\n"
        txt=txt1+txt2+txt3
        tfile.insert("end",txt)
        
    def showequivclasses(self):
        # brg 14.8.2012, 10.11.2014
        def eqgr():
            # brg 14.8.2012, 10.11.2014
            import math
            tpgraph=Tkinter.Toplevel(hf)
            tpgraph.title(' Graph of equivalence classes ')
            posx=rmod2.vecgen1(self.r)
            posy=rmod2.vecgen1(self.r)
            cvgr=Tkinter.Canvas(tpgraph,width=400, height=400, bg="white")
            dmax=120
            rdgr=100

            for i in range(0,self.r):
                posx[i]=dmax*math.cos(i*6.28/self.r)
                posy[i]=dmax*math.sin(i*6.28/self.r)
                
                cvgr.create_oval(dmax+60+posx[i]-17,dmax+30+posy[i]+17,dmax+60+posx[i]+17,dmax+30+posy[i]-17,fill="white")       
                cvgr.create_text(dmax+62+posx[i],dmax+32+posy[i],text=str(self.obj[i]),font = "10")


            for i in range(0,self.r):
                posx[i]=rdgr*math.cos(i*6.28/self.r)
                posy[i]=rdgr*math.sin(i*6.28/self.r)
                for i1 in range(0,self.r):
                    posx[i1]=rdgr*math.cos(i1*6.28/self.r)
                    posy[i1]=rdgr*math.sin(i1*6.28/self.r)
                    if i!=i1:
                        if self.eqm[i][i1]==1:
                            cvgr.create_line(dmax+60+posx[i],dmax+30+posy[i],dmax+60+posx[i1],dmax+30+posy[i1])  #7.6.08
                            

                            
            cvgr.create_text(1.5*dmax,2.8*dmax,text=" Graph of Equiv.rel. ",font="16")
            cvgr.pack()


        #body of method
        tpequivclasses=Tkinter.Toplevel(hf)
        tpequivclasses.title(" Equivalence classes " )
        from ScrolledText import ScrolledText
        tequivclasses=ScrolledText(tpequivclasses, width=80, height=10)
        tequivclasses.pack()
        txt="Equivalence classes of "+self.fn+"\n"
        txt+="rred = "+str(self.rred)+"\n"
        txt+="Equivalence classes represented by : "+"\n"
        for i in range(0,self.rred):
                txt+=str(self.objred[i])+", "   #correction 241114
        txt+="\n"        
        txt+="Equivalence classes: "+"\n"
        for i1 in range(0, len(self.eqlist)):
                for i2 in range(0,len(self.eqlist[i1])):
                        txt+=str(self.eqlist[i1][i2])+"\t"
                txt+="\n"
        txt+="\n"
        tequivclasses.insert("end",txt)
        butteq=Tkinter.Button(tpequivclasses,text="graph of equivalences ",command=eqgr)
        butteq.pack()

    def showequivclassesshort(self):
        # brg 10.11.2014
        tpequivclasses2=Tkinter.Toplevel(hf)
        tpequivclasses2.title(" Equivalence classes " )
        from ScrolledText import ScrolledText
        tequivclasses2=ScrolledText(tpequivclasses2, width=80, height=10)
        tequivclasses2.pack()
        txt="Equivalence classes of "+self.fn+"\n"
        txt+="Condensed output (only the nontrivial eq.classes) "+"\n"
        txt+="rred = "+str(self.rred)+"\n"
        txt+="\n"        
        txt+="Nontrivial Equivalence classes: "+"\n"
        for i1 in range(0, len(self.eqlist)):
                if len(self.eqlist[i1])>1:
                        for i2 in range(0,len(self.eqlist[i1])):
                                txt+=str(self.eqlist[i1][i2])+", "
                        txt+="\n"
        txt+="\n"
        tequivclasses2.insert("end",txt)
        
                    
    def dmchar(self):
        # brg 24.10.2012
        import pstat
        import stats
        from ScrolledText import ScrolledText
        tpchar=Tkinter.Toplevel(hf)
        tpchar.title(' characteristics of data matrix ')
        tchar=ScrolledText(tpchar,width=80,height=20)
        tchar.pack()
        txt="Characteristics of the data matrix"+"\n"
        txt+=70*"="+"\n"
        txt+="a) max, min, mean, stdev of original dm "+"\n"
        achar=rmod2.matrixchar(self.r,self.k,self.dm)
        txt+="\t"
        for j in range(0,self.k):
                txt+=str(self.prop[j])+2*"\t"
        txt+="\n"
        txt+="max : "+"\t"
        for j in range(0,self.k):
                txt+=str(round(achar[0][j],2))+2*"\t"
        txt+="\n"
        txt+="min : "+"\t"
        for j in range(0,self.k):
                txt+=str(round(achar[1][j],2))+2*"\t"
        txt+="\n"
        txt+="mean : "+"\t"
        for j in range(0,self.k):
                txt+=str(round(achar[2][j],2))+2*"\t"
        txt+="\n"
        txt+="st.dev : "+"\t"
        for j in range(0,self.k):
                txt+=str(round(achar[3][j],2))+2*"\t"
        txt+="\n\n"
        txt+="\nb) distribution of attribute's differences in steps "+"\n"
        txt+="   0,0.1,  0.1,0.2,...,  0.9,1."+"\n"
        txt+="((0,1)-normalized dm)"+"\n"
        txt+="\t"
        for j in range(0,self.k):
                txt+=str(self.prop[j])+2*"\t"
        txt+="\n"
        
        adm=rmod2.matrixnorm(self.r,self.k,self.dm)
        
        ldiff=int(self.r*(self.r-1)/2.0)
        diff=rmod2.marray(ldiff,self.k)

        zahl=0
        for i in range(0,self.r):
            for i1 in range(i+1,self.r):
                for j in range(0,self.k):
                    diff[zahl][j]=abs(adm[i][j]-adm[i1][j])
                zahl+=1    

        
        print "zahl= ",zahl
        z=zahl
        grid=10
        h=rmod2.marray(grid,self.k)
        #rounded: third decimal position
        for j in range(0,self.k):
            for i2 in range(0,grid):
                for i3 in range(0,z):
                    if int(1000.0/grid)*i2<=int(1000*diff[i3][j]+5)<int(1000.0/grid)*(i2+1):
                        h[i2][j]+=1
                
            

        #print "class matrix"
        #rmod2.matout(grid,self.k,h)

        for i4 in range(0,grid):
                txt+=str((1.0/grid)*i4)+"..."+str((1.0/grid)*(i4+1))+":\t "
                for j in range(0,self.k):
                        txt+=str(h[i4][j])+2*"\t"
                txt+="\n"

        spearm=rmod2.marray(self.k,self.k)
        pspearm=rmod2.marray(self.k,self.k)
        for j in range(0,self.k):
            vec1=[]
            for i in range(0,self.r):
                vec1.append(adm[i][j])
       
            for j1 in range(0,self.k):
                vec2=[] 
                for i in range(0,self.r):
                    vec2.append(adm[i][j1])
        
                rspear,pspear=pstat.lspearmanr(vec1,vec2)
                spearm[j][j1]=rspear
                pspearm[j][j1]=pspear

        print "spearm-correl.matrix"        
        rmod2.matout(self.k,self.k,spearm)    
                                    

        txt+="\n\nc) Spearman correlation (normalized dm) "+"\n"
        txt+="\t"
        for j in range(0,self.k):
                txt+=str(self.prop[j])+"\t"
        txt+="\n"
        for j in range(0,self.k):
                txt+=str(self.prop[j])+":\t"
                for j1 in range(0,self.k):
                        txt+=str(round(spearm[j][j1],3))+"\t"
                txt+="\n"

       
        

        txt+="\n   -   -  -   e o f    -   -   -"
        tchar.insert("end",txt)
        





        hilf=rmod2.vecgen1(grid)
        bth=rmod2.vecgen1(grid)
        for i4 in range(0,grid):
            hilf[i4]=h[i4][1]
            bth[i4]=str(i4)




        
                        
        
    def calc(self):
        # brg 12.8.2012, 14.8.2012 II, 23.8.2012
        import math
        self.zetatransp=rmod2.comp(self.rred,self.k,self.xred)  #zeta matrix with col<row
##        print "zetatransp (row<col)"
##        rmod2.matout(self.rred,self.rred,self.zetatransp)
##        print " "
        self.zeta=rmod2.marray(self.rred,self.rred)
        for i in range(0,self.rred):  #however we need for the 'normal' presentation: row < col. Transposition
            for j in range(0,self.rred):
                self.zeta[i][j]=self.zetatransp[j][i] #zeta with col>row
        #
        self.lobj,self.lext,self.revlext,self.level=rmod2.levtopsort(self.rred,self.zeta)
        
        if self.method==1:
            print "old method"    
            #old method to get cov
            adjc=rmod2.adjacent(self.rred,self.lext,self.revlext,self.zeta)
            #Transitive reduced relations
            ts,tr=rmod2.trreduct(self.rred,adjc,self.lext)
            self.cov=rmod2.cover(self.rred,tr,self.lext) #self.cov main result
        else:
            print "new method"    
            #new method to get cov
            self.cov=rmod2.trred(self.rred,self.zeta)  #self.cov  main result

        #self.revlext: linear extension
        #self.level: number of levels 

        self.levmax=-10**20     #20.6.08   #determination of the number of elements in largest level
        for i in range(0,self.level):
            if len(self.lobj[i])>=self.levmax:
                self.levmax=len(self.lobj[i])
        

        self.u_set=rmod2.vecgen1(self.rred)
        self.utotal=0
        for i in range(0,self.rred):
            self.u_set[i]=set([])
            for i2 in range(0,self.rred):
                if self.zeta[i][i2]==0 and self.zeta[i2][i]==0 and i!=i2:
                    self.utotal+=0.5
                    self.u_set[i].add(self.objred[i2])

        
        self.comparabilities=0
        for i in range(0,self.rred):
            for i2 in range(0,self.rred):
                if self.zeta[i][i2]==1 and i!=i2:
                    self.comparabilities+=1
        

        self.maximal=set([])
        for i in range(0,self.rred):
            sumzeta=0    
            for i2 in range(0,self.rred):
                if i!=i2:    
                        sumzeta+=self.zeta[i][i2]
            if sumzeta==0:
                self.maximal.add(self.objred[i])
                
        self.minimal=set([])
        for i in range(0,self.rred):
            sumzeta=0    
            for i2 in range(0,self.rred):
                if i!=i2:    
                        sumzeta+=self.zeta[i2][i]
            if sumzeta==0:
                self.minimal.add(self.objred[i])            

        
        self.isol=self.maximal&self.minimal
        
        self.upset=rmod2.vecgen1(self.rred)
        for i in range(0,self.rred):
            self.upset[i]=set([])
            for i2 in range(0,self.rred):
                if self.zeta[i][i2]!=0:
                    self.upset[i].add(self.objred[i2])

        self.downset=rmod2.vecgen1(self.rred)
        for i in range(0,self.rred):
            self.downset[i]=set([])
            for i2 in range(0,self.rred):
                if self.zeta[i2][i]!=0:
                    self.downset[i].add(self.objred[i2])
                                  
        # preparation for FOU-plot
        self.FOU=rmod2.marray(self.rred,3)
        for i in range(0,self.rred):
            self.FOU[i][1]=len(self.downset[i])
            self.FOU[i][2]=len(self.upset[i])
            self.FOU[i][0]=len(self.u_set[i])

       
        
    def complexity(self):
        # Brg 24.10.2012
        import math
        from ScrolledText import ScrolledText
        def L2fct(x):
                # brg 24.10.2012
                if x==0:
                        fct=0
                else:
                        fct=x*math.log(x,2)
                return fct        
        # preparation for complexity
        self.Rcompl=self.rred*(self.rred-1)/2.0
        self.degreeComp=1.0*self.comparabilities/self.Rcompl
        self.degreeIncomp=1.0*self.utotal/self.Rcompl
        self.maxH=-0.5*math.log(0.5,2)-0.5*math.log(0.5,2)
        hilf1=L2fct(self.degreeComp)
        hilf2=L2fct(self.degreeIncomp)
        self.Hcomp=-hilf1-hilf2
        self.complexit=1.0*self.Hcomp/self.maxH
        tpcomplexity=Tkinter.Toplevel(hf)
        tpcomplexity.title("complexity after Restrepo ")
        tcomp=ScrolledText(tpcomplexity, width=80, height=5)
        tcomp.pack()
        txt=" Complexity after Restrepo, 2012 "+"\n"
        txt+=70*"="+"\n"
        txt+="degree of comparability: "+4*"\t"+str(round(self.degreeComp,3))+"\n"
        txt+="degree of incomparability: "+4*"\t"+str(round(self.degreeIncomp,3))+"\n"
        txt+="maxComplexity : "+4*"\t"+str(round(self.maxH,3))+"\n"
        txt+="complexity : "+4*"\t"+str(round(self.Hcomp,3))+"\n"
        txt+="degree of complexity : "+4*"\t"+str(round(self.complexit,3))+"\n"
        txt+="   - - - e o f - - -     "
        tcomp.insert("end",txt)
        
        
            





    def LPOM0(self):
        # brg 13.8.2012, 10.11.2014, 4.1.2015
        # Here only the zeroth approximation
        from ScrolledText import ScrolledText
        tplpom0=Tkinter.Toplevel(hf)
        tplpom0.title('LPOM zeroth approximation ')
        tlpom0=ScrolledText(tplpom0,width=80,height=10)
        tlpom0.pack()
        
        txt=" LPOM0 of "+self.fn+"\n"
        txt+=70*"=" +"\n"
        txt+="Objects representing the equivalent elements "+"\n"
        txt+="Object"+"\tRkav (LPOM0)"+"\t|downset|" +"\t|set of incomparables| "+"\n"
        self.rkav=[]
        for i in range(0,self.rred):
            self.rkav.append((1.0*self.rred+1.0)*(len(self.downset[i])/(-1.0*len(self.u_set[i])+1.0+self.rred)))
            txt+=str(self.objred[i])+"\t"+str(round(self.rkav[i],3))+2*"\t"+str(len(self.downset[i]))+"\t"+str(len(self.u_set[i]))+"\n"
        txt+=60*"-"+"\n"
        rkavext=rmod2.weak1(self.r, self.obj,self.objred,self.rkav,self.eqm)
        txt+=" Rkav-vaues of LPOM0 extended to all objects "+"\n"
        for i in range(0,self.r):
                txt+=str(self.obj[i])+"\t"+str(round(rkavext[i],3))+"\n"
        txt+="\n"
        txt+="Sorting for increasing values of rkav "+"\n"
        rbreak=int(self.r/3.0)
        dummy,rkavsort,nrkav = rmod2.raisort2(rkavext)
        for i in range(0,self.r):
                txt+=str(self.obj[nrkav[i]])+" "+str(round(rkavsort[i],3))+"  ,"
                if 1.0*i/rbreak ==int(1.0*i/rbreak):
                        txt+="\n"
                                                     
        txt+="\n"        
        txt+="- - -     e o f   - - -  "+"\n"
        tlpom0.insert("end",txt)    

    def showUSP(self):
        #brg 13.8.2012
        # shows Main characteristics of the poset
        # Level. one linear extension
        # u-set (U), downset (S),upset (P)
        # needed: method calc
        tpUSP=Tkinter.Toplevel(hf)
        tpUSP.title(' Basic characteristics of the poset ')
        from ScrolledText import ScrolledText
        tUSP=ScrolledText(tpUSP,width=80,height=10)
        tUSP.pack()
        txt="USP-characteristics of HD of "+self.fn+"\n"
        txt+=70*"="+"\n"
        txt+="Total incomparabilities: "+str(self.utotal)+"\n"
        txt+="Comparabilities: "+str(self.comparabilities)+"\n"
        txt+="Number of Levels: "+str(self.level)+"\n"

        for i in range(0,self.level):
            txt+="Level "+str(self.level-i)+" :"
            for j in range(0,len(self.lobj[i])):
                txt+= self.objred[self.lobj[i][j]]+" "
            txt+="\n"    
        txt+="\n\n  "        
        txt="\n One of the linear extensions \n\n"
        for i in range(0,self.rred):
            if i<self.rred-1:
                txt+=self.objred[self.revlext[i]]+" < "
            else:
                txt+=self.objred[self.revlext[i]]+"\n"
        txt+="\n"
        txt+="\n"

        txt+="Maximal elements"+"\n"
        for el in self.maximal:
            txt+=el+", "
        txt+="\n\n"
        txt+="Minimal elements"+"\n"
        for el in self.minimal:
            txt+=el+", "
        txt+="\n\n"
        txt+="Isolated elements "+"\n"
        for el in self.isol:
            txt+=el+", "
        txt+="\n"
        txt+="\n"
                
                
        txt+="Individual info: \nFirst the object, then in parentheses: count of, then the list of elements "+"\n"
       
        txt+="sets of incomparable elements "+"\n"
        for i in range(0,self.rred):
            txt+=str(self.objred[i])+" :( "+str(len(self.u_set[i]))+" ): "
            for elem in self.u_set[i]:
                txt+=elem+", "
            txt+="\n"    
        txt+="\n"
        txt+="down sets "+"\n"
        for i in range(0,self.rred):
            txt+=str(self.objred[i])+" :( "+str(len(self.downset[i]))+" ): "
            for elem in self.downset[i]:
                txt+=elem+", "
            txt+="\n"     
        txt+="\n"
        txt+="upsets "+"\n"
        for i in range(0,self.rred):
            txt+=str(self.objred[i])+" :( "+str(len(self.upset[i]))+" ): " 
            for elem in self.upset[i]:
                txt+=elem+", "
            txt+="\n"     
        txt+="\n"
        tUSP.insert("end",txt)


    def visual_zeta(self):
        # brg 17.8.2012
        app1=raioop2.brg_digraph(hf,self.zetatransp,self.rred,self.objred,"yellow",100,120)
        app1.calc()

    def visual(self,f,perturb,diameter,diamsp,fontobj,fontobjsp,obsp):
        # brg 12.8.2012
        from ScrolledText import ScrolledText

        def details(event):
            # brg 12.8.2012
            # here what is in mainHD20: infhd
            # brg 19.8.2011, 6.11.2011 taken from HDalter, 1.12.2011
            # info by mouse click for the Hasse diagram
            self.mouse=1   #1.12.2012
            if self.mouse==1:                    
                xmouse=int(self.cv.canvasx(event.x))
                ymouse=int(self.cv.canvasy(event.y))
                #print item2
                mouseflag=1  
                tu=self.cv.gettags(self.cv.find_closest(xmouse,ymouse))
                print "tu= ",tu
                lt=len(tu[0])
                tagn=tu[0][7:lt]
                print "tagn= ",tagn
                try:
                   iobact=self.objred.index(tagn)
                   mouseflag=1
                except:
                   mouseflag=0
                print "mouseflag ",mouseflag
                if mouseflag==1:    
                   tpdetails=Tkinter.Toplevel(hf)
                   tpdetails.title('Info for vertex '+str(tagn))
                   tdetails=ScrolledText(tpdetails,width=40,height=10)
                   tdetails.pack(expand="yes")
                   such=self.objred[iobact]
                   txt="Details: object "+str(tagn)+"\n"

                   ui=0
                   txthilf=""
                   for i1 in range(0,self.rred):
                        if self.zeta[iobact][i1]==0 and self.zeta[i1][iobact]==0:
                               ui+=1.0
                               txthilf+=str(self.objred[i1])+", "
                   txthilf+="\n"            
                   txt+="Incomparabilities: :( "+str(ui)+" ): "+txthilf


                   zup=0
                   txthilf=""
                   for i1 in range(0,self.rred):
                       if self.zeta[iobact][i1]==1 and i1!=iobact:
                           zup+=1
                           txthilf+=str(self.objred[i1])+", "
                   txthilf+="\n"
                   txt+="Upset :( "+str(zup)+" ): "+txthilf
                   txt+="\n"
                   
                   zdown=0
                   txthilf=""
                   for i1 in range(0,self.rred):
                       if self.zeta[i1][iobact]==1 and i1!=iobact:
                           zdown+=1
                           txthilf+=str(self.objred[i1])+", "
                   txthilf+="\n"
                   txt+="Downset :( "+str(zdown) +" ): "+txthilf
                   txt+="\n"

                   txt+=" Profile "+"\n"
                   txt+=60*"-"+"\n"
                   for j in range(0,self.k):
                       txt+=str(self.xred[iobact][j])+", "
                   txt+="\n"    
                   tdetails.insert("end",txt)
            return           
            #end of details   

        def cover_show(self):
            # brg 13.8.2012
            # as a subroutine for method 'visual'
            """Cover-matrix is displayed"""
            #brg 28.12.07
            #*28.12.07
            #akt28.12.07
            #note: -
            #source: -
            hfcover=Tkinter.Toplevel(hf)
            hfcover.title(' cover-matrix ')

            lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
            lbhd2.pack()
            txt3="\n cover-matrix  \n"
            for i in range(0,self.rred):
                txt3+="\n"+self.objred[i]+":\t"
                txt3+="is covered by "
                for j in range(0,self.rred):
                    if i!=j:
                        if self.cov[i][j]==1:
                            txt3+=" "+self.objred[j]+" ,"
                        else:
                            pass
                    else:
                        pass
                txt3+="\n"    
            txt3+="\n"
            txt3+=" -- end of list --"
            tcov=ScrolledText(hfcover,width=50, height=20)
            tcov.pack(expand=1,fill="both")
            tcov.insert("end",txt3)
            return
            
        def covered_show(self):
            """Cover-matrix is displayed"""
            # Brg 13.8.2012 as a method of 'visual'
            #brg 21.6.08
            #*28.12.07
            #akt21.06.08
            #note: from cover_show
            #source: -
            hfcovered=Tkinter.Toplevel(hf)
            hfcovered.title(' covered-matrix ')
            
            lbhd2=Tkinter.Label(hfcovered,text=" Cover-Relations ")
            lbhd2.pack()
            txt3="\n cover-matrix  \n"
            for i in range(0,self.rred):
                txt3+="\n"+self.objred[i]+":\t"
                txt3+="is covering "
                for j in range(0,self.rred):
                    if i!=j:
                        if self.cov[j][i]==1:
                            txt3+=" "+self.objred[j]+" ,"
                        else:
                            pass
                    else:
                        pass
                txt3+="\n"    
            txt3+="\n"
            txt3+=" -- end of list --"
            tcov=ScrolledText(hfcovered,width=50, height=20)
            tcov.pack(expand=1,fill="both")
            tcov.insert("end",txt3)
            return

        #main body of visual
        
        self.mouse=1   #1.12.2012
        mouse=1  #1.12.2012
        self.hfhd=Tkinter.Toplevel(hf)
        self.hfhd.title(' Hassediagram ')
        posetch=rmod2.vecgen1(3)
        graphch=rmod2.vecgen1(5)
        oblist=rmod2.vecgen1(3)
        
        posetch[0]=self.rred
        posetch[1]=self.level
        posetch[2]=self.levmax

        graphch[0]=f
        graphch[1]=diameter
        graphch[2]=diamsp
        graphch[3]=fontobj
        graphch[4]=fontobjsp

        oblist[0]=obsp
        oblist[1]=""
        oblist[2]=""
        if self.rred>self.max_count_of_vertices:
            cover_show(self)                  #20.1.08
        else:
            if self.mouse==1:
                txtlb=" Hasse Diagram of File "+self.fn+"\nAlt-left-mouse-button for further infos, method = "+str(self.method) 
            else:
                txtlb=" Hasse Diagram of File "+self.fn+"  method = "+str(self.method)

            lbhd3=Tkinter.Label(self.hfhd,text=txtlb,bg="green")
            lbhd3.pack()
                        

            self.cv,garrow1x,garrow1y,\
                                        garrow2y,actheight=graphHD(perturb,self.objred,\
                                        self.objred,posetch,graphch,oblist,self.cov,self.lobj,"self.hfhd","main_HD","file= "+self.fn)
            
            self.cv.create_line(garrow1x*f,garrow1y,garrow1x*f,garrow2y-12,arrow="first",width=3,fill="red")

            self.cv.create_text((garrow1x+8)*f,garrow1y-6,text="high")
            self.cv.create_text((garrow1x+8)*f,garrow2y-6,text="low")
            self.txtouteq=""

            taddinfo=ScrolledText(self.hfhd,width=80,height=10)
            taddinfo.pack()
            txt="Additional information concerning the main_HD "+"\n"
            txt+=70*"="+"\n"
            txt+="Total incomparabilities "+"\t"+str(self.utotal)+"\n"
            txt+="Total comparabilities "+"\t"+str(self.comparabilities)+"\n"
            txt+="- - - e o f - - - "                      
            taddinfo.insert("end",txt)
            self.cv.pack()
            self.cv.bind("<Alt-Button-1>",details)

    def methcover_show(self):
        # brg 13.8.2012 as a method of Hasse
        """Cover-matrix is displayed"""
        #brg 28.12.07
        #*28.12.07
        #akt28.12.07
        #note: -
        #source: -
        from ScrolledText import ScrolledText
        hfcover=Tkinter.Toplevel(hf)
        hfcover.title(' cover-matrix ')

        lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,self.rred):
            txt3+="\n"+self.objred[i]+":\t"
            txt3+="is covered by "
            for j in range(0,self.rred):
                if i!=j:
                    if self.cov[i][j]==1:
                        txt3+=" "+self.objred[j]+" ,"
                    else:
                        pass
                else:
                    pass
            txt3+="\n"    
        txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(hfcover,width=50, height=20)
        tcov.pack(expand=1,fill="both")
        tcov.insert("end",txt3)
            
    def methcovered_show(self):
        """Cover-matrix is displayed"""
        # Brg 13.8.2012 as a method of Hasse
        #brg 21.6.08
        #*28.12.07
        #akt21.06.08
        #note: from cover_show
        #source: -
        from ScrolledText import ScrolledText
        hfcovered=Tkinter.Toplevel(hf)
        hfcovered.title(' covered-matrix ')
        
        lbhd2=Tkinter.Label(hfcovered,text=" Cover-Relations ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,self.rred):
            txt3+="\n"+self.objred[i]+":\t"
            txt3+="is covering "
            for j in range(0,self.rred):
                if i!=j:
                    if self.cov[j][i]==1:
                        txt3+=" "+self.objred[j]+" ,"
                    else:
                        pass
                else:
                    pass
            txt3+="\n"    
        txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(hfcovered,width=50, height=20)
        tcov.pack(expand=1,fill="both")
        tcov.insert("end",txt3)        
                
    def components(self):
        # brg 14.8.2012
        """the components of the HD will be calculated by a dfs """
        #Brg 2.3.09
        from ScrolledText import ScrolledText
        # connectedness referred to the undirected graph
        undircov=rmod2.marray(self.rred,self.rred)
        for i in range(0,self.rred):
            for i1 in range(0,self.rred):
                undircov[i][i1]=self.cov[i][i1]+self.cov[i1][i]

        # connectedComponents is based on a routine taken from Internet
        adjlist=rmod2.covadjlist(undircov,self.rred)
        ac=rmod2.connectedComponents(adjlist)
        eqclassC,noC,CC,lbC=rmod2.countCC1(ac)
        lbc1=rmod2.vecgentext1(noC)
        for i in range(0,noC):
            lbc1[i]=self.objred[eqclassC[i]]
            
        txtc=" Analysis of components \n"
        txtc+=40*"="
        txtc+="\n Number of components: = "+str(noC)+"\n"
        txtchilf="Components' representants and number of equiv. elements \n"
        for i in range(0,noC):
            txtchilf+=self.objred[eqclassC[i]]+" with: "+str(CC[i])+"  elements \n"
        txtc+=txtchilf
        txtc+=40*"="
        txtc+="\n - - - end of file - - -"

        tpcomp=Tkinter.Toplevel(hf)
        tpcomp.title(' connection components of poset ')
        tcomp=ScrolledText(tpcomp,width=60,height=20)
        tcomp.pack(expand=1,fill="both")
        tcomp.insert("end",txtc)
        xnoc=rmod2.vecgentext1(noC)
        if noC>1:
            for i1 in range(0,noC):
                xnoc[i1]=str(i1)
            bdnoc=raioop2.brgbar3(hf,"tpbnoC",noC,CC,xnoc,50,'Connection Components\nof poset', 30,30,40)
            bdnoc.ausgabe()

    
    def levelincomp(self):
        """Display level related results """
        # Brg 7.2.09, 15.3.09, 14.8.2012
        from ScrolledText import ScrolledText       
        tplevel=Tkinter.Toplevel(hf)
        tplevel.title('show level related results ')
        tlevel=ScrolledText(tplevel,width=80,height=10)
        tlevel.pack()
        nl,ul,al=rmod2.levelincomp(self.zetatransp,self.rred,self.level)
        
                                             #this part is new 7.2.09
        txt2="\n level info2\n"
        txt2+=" #representants \t incomp \t\t incomp \n"
        txt2+=" ..per level    \t  ..per level \t ..per level\n"
        txt2+="\t\t\t\tper obj.pro level\n"
        txt2+=50*"="+"\n"
        for iz in range(0,self.level):
            txt2+="level"+str(self.level-iz)+": "+str(nl[iz])+"\t\t"+str(ul[iz])+"\t\t\t"+str(round(al[iz],2))+"\n"
        
        tlevel.insert("end",txt2)
        
        levtxt=rmod2.vecgentext1(self.level)
        for iz in range(0,self.level):
            levtxt[iz]="    "+str(self.level-iz)+" "
            
            
        bd1=raioop2.brgbar3(hf,"tpbd1",self.level,ul,levtxt,50,'Incomp per level', 30,30,40)
        bd1.ausgabe()
        bd2=raioop2.brgbar3(hf,"tpbd2",self.level,al,levtxt,50,'Av. Incomp per level', 30,30,40)
        bd2.ausgabe()
        bd3=raioop2.brgbar3(hf,"tpbd3",self.level,nl,levtxt,50,'Numb. of obj per level', 30,30,40)
        bd3.ausgabe()
        
    def fouplot(self):
        #11.11.09, 6.11.2011, 6.7.2012,7.7.2012, 14.8.2012
        # Note, the calculation of FOU is in method calc
        def detailsfou(event):
            # brg 14.8.2012
            #brg 19.8.2011, 6.11.2011 taken from HDalter
            # Info taken for the FOU-plot
            from ScrolledText import ScrolledText
            tpinfofou=Tkinter.Toplevel(hf)
            tpinfofou.title('Info for selcted vertex ')
            tinfo=ScrolledText(tpinfofou,width=40,height=10)
            tinfo.pack(expand="yes")
            buttchange=Tkinter.Button(tpinfofou,text="change colour of \n\
            the specific clicked point",command=chcol)
            buttchange.pack()                      
           
            x=int(cvfou.canvasx(event.x))
            y=int(cvfou.canvasy(event.y))
            #print item2
            
            tu=cvfou.gettags(cvfou.find_closest(x,y))
            print "tu= ",tu[0]
            lt=len(tu[0])
            tagn=tu[0][7:lt]
            print "tagn= ",tagn
            try:
               self.iobact=self.objred.index(tagn)   #clicked object
            except:
               self.iobact=999999
            txt="Detail information "+"\n"
            txt+=19*"="+"\n"
            txt+="Selected object: "+tagn+"\n"
            ui=0
            if self.iobact!=999999:
                for i1 in range(0,self.rred):
                    if self.zeta[self.iobact][i1]==0 and self.zeta[i1][self.iobact]==0:
                        ui+=1.0
                txt+="Incomparabilities of object "+tagn+" : "+str(ui)+"\n"

                zup=0
                txthilf=""
                for i1 in range(0,self.rred):
                    if self.zeta[self.iobact][i1]==1 and i1!=self.iobact:
                        zup+=1
                        txthilf+=str(self.objred[i1])+", "
                txt+="|upset| : ("+str(zup)+" ): "+txthilf+"\n"
               
                zdown=0
                txthilf=""
                for i1 in range(0,self.rred):
                    if self.zeta[i1][self.iobact]==1 and i1!=self.iobact:
                        zdown+=1
                        txthilf+=str(self.objred[i1])+", "
                txt+="|downset| : ("+str(zdown)+" ): "+txthilf+"\n"
                tinfo.insert("end",txt)

        def chcol():
            # brg 5.7.2012, 14.8.2012
            #cvfou=Tkinter.Canvas(frrkuplot,width=500,height=450,bg="white")
            xleft=50
            ybasis=410
            xbasis=400
            ybereich=400
            mitte=xleft+(1.0*xbasis)*0.5
            xright=xbasis+xleft
            #print "mitte= ",mitte,"   xright= ",xright
            ay=self.basiskdn[0]
            by=self.basiskdn[1]
            axright=self.basiskdn[2]
            bxleft=self.basiskdn[3]
            axleft=self.basiskdn[4]
            
            if self.scattplot[self.iobact][0]<=0:
                xg=axleft*self.scattplot[self.iobact][0]+bxleft
            else:
                xg=axright*self.scattplot[self.iobact][0]+bxleft
            yg=ay*self.scattplot[self.iobact][1]+by
            ci=cvfou.create_oval(xg-5,yg+5,xg+5,yg-5,fill="blue",tags="object_"+self.objred[self.iobact])
            #cvfou.pack()

            
            
        # main body of method fouplot
        tpfouplot=Tkinter.Toplevel(hf)
        tpfouplot.title('scatterplot O-F vs U ')
        
        self.basiskdn=rmod2.vecgen1(6) #5.7.2012
        lbfou=Tkinter.Label(tpfouplot,text="Alt-Mouse-button-1 for further information on points in FOU-plot ",bg="yellow")
        lbfou.pack()    
        self.scattplot=rmod2.marray(self.rred,2)
                    
        for i in range(0,self.rred):
            self.scattplot[i][0]=self.FOU[i][1]-self.FOU[i][2]     #O-F
            self.scattplot[i][1]=self.FOU[i][0] #U
        
        fr=Tkinter.Frame(tpfouplot,width=500,height=500)
        fr.pack()

        #graphic
        maxdmx=-9999
        mindmx=9999
        for i in range(0,self.rred):
            if self.scattplot[i][0]>=maxdmx:
                maxdmx=self.scattplot[i][0]
            if self.scattplot[i][0]<=mindmx:
                mindmx=self.scattplot[i][0]
                
        maxdmy=-9999
        for i in range(0,self.rred):
            if self.scattplot[i][1]>=maxdmy:
                maxdmy=self.scattplot[i][1]

        
        maxxaxis=max(maxdmx,abs(mindmx))
        dy=1
        zahl=0
        while maxdmy%10!=0:
            maxdmy+=dy
            if zahl>7:
                break
        dx=1
        zahl=0
        while maxxaxis%10!=0:
            maxxaxis+=dx
            if zahl>7:
                break


        #print "corrected maxdmy= ",maxdmy, "  corrected maxxaxis ",maxxaxis
        cvfou=Tkinter.Canvas(fr,width=500,height=450,bg="white")
        cvfou.pack()
        xleft=50
        ybasis=410
        xbasis=400
        ybereich=400
        mitte=xleft+(1.0*xbasis)*0.5
        xright=xbasis+xleft
        liy=cvfou.create_line(mitte,ybasis,mitte,10,arrow="last",width=2,fill="red")
        lix=cvfou.create_line(xleft,ybasis,xleft+xbasis+10,ybasis,arrow="last",width=2,fill="red")

        anzxg=int(1.0*(xright-mitte)/10.0)
        dx=int(1.0*xbasis/(2.0*anzxg))
        
        for i in range(0,anzxg+1):
            ligridx=cvfou.create_line(mitte-dx*i,ybasis,mitte-dx*i,20)

        for i in range(0,anzxg+1):
            ligridx=cvfou.create_line(mitte+dx*i,ybasis,mitte+dx*i,20)

        anzyg=int((1.0*ybereich)/40.0)
        for i in range(0,anzyg):
            ligridy=cvfou.create_line(xleft,ybasis-40*i,xleft+xbasis,ybasis-40*i)

        if maxxaxis!=0:        
                axleft=1.0*(mitte-xleft)/(1.0*maxxaxis)
        else:
                axleft=5
        bxleft=mitte # = bxright

        if maxxaxis!=0:
                axright=1.0*xbasis/(2.0*maxxaxis)
        else:
                axright=5

        if maxdmy!=0:
                ay=-1.0*ybereich/maxdmy
        else:
                ay=-5.0
        by=ybasis
        self.basiskdn[0]=ay
        self.basiskdn[1]=by
        self.basiskdn[2]=axright
        self.basiskdn[3]=bxleft
        self.basiskdn[4]=axleft
       
        for i in range(0,self.rred):
            if self.scattplot[i][0]<=0:
                xg=axleft*self.scattplot[i][0]+bxleft
            else:
                xg=axright*self.scattplot[i][0]+bxleft
            yg=ay*self.scattplot[i][1]+by
            ci=cvfou.create_oval(xg-3,yg+3,xg+3,yg-3,fill="red",tags="object_"+self.objred[i])
            
                
        xt1=xleft-10
        yt1=ybasis+10
        ctext1=cvfou.create_text(xt1,yt1,text="-"+str(maxxaxis))
        xt2=xright+10
        yt2=ybasis+10
        ctext2=cvfou.create_text(xt2,yt2,text="+"+str(maxxaxis))
        xt3=mitte
        yt3=7
        ctext3=cvfou.create_text(xt3,yt3,text=str(maxdmy))
        xt4=mitte+150
        yt4=ybasis+10
        ctext4=cvfou.create_text(xt4,yt4,text="|O(x)|-|F(x)|")
        xt5=mitte+20
        yt5=20
        ctext5=cvfou.create_text(xt5,yt5,text="|U(x)|")
        cvfou.bind("<Alt-Button-1>",detailsfou)

    def upsetHD(self,f,perturb,diameter,fontobj,o1):
        # brg 14.8.2012, 16.8.2012
        posetch=rmod2.vecgen1(3)
        graphch=rmod2.vecgen1(5)
        oblist=rmod2.vecgen1(3)

        posetch[0]=self.rred
        posetch[1]=self.level
        posetch[2]=self.levmax

        graphch[0]=f
        graphch[1]=diameter
        graphch[2]=20
        graphch[3]=fontobj
        graphch[4]=12

        oblist[0]=""
        oblist[1]=o1
        oblist[2]=""
        
        try:
            io1=self.objred.index(o1)
            cv=graphHD(perturb,self.objred,\
                       self.upset[io1],posetch,graphch,oblist,self.cov, self.lobj,"tpgraph1","upset"," ")
        except:
            io1=999999
            print "io1=",io1
                       
            
            
            
        
        
    def downsetHD(self,f,perturb,diameter,fontobj,o1):
        # brg 14.8.2012, 16.8.2012
        posetch=rmod2.vecgen1(3)
        graphch=rmod2.vecgen1(5)
        oblist=rmod2.vecgen1(3)

        posetch[0]=self.rred
        posetch[1]=self.level
        posetch[2]=self.levmax

        graphch[0]=f
        graphch[1]=diameter
        graphch[2]=20
        graphch[3]=fontobj
        graphch[4]=12

        oblist[0]=""
        oblist[1]=str(o1)
        oblist[2]=""


        try:
            io1=self.objred.index(o1)
            cv=graphHD(perturb,self.objred,self.downset[io1],\
                       posetch,graphch,oblist,self.cov,self.lobj,"tpgraph2","downset"," ")
        except:
            io1=999999
            print "io1=",io1

        
        

    def intervalHD(self,f,perturb,diameter,fontobj,o1,o2):
        #brg 14.8.2012, 16.8.2012

        posetch=rmod2.vecgen1(3)
        graphch=rmod2.vecgen1(5)
        oblist=rmod2.vecgen1(3)

        posetch[0]=self.rred
        posetch[1]=self.level
        posetch[2]=self.levmax

        graphch[0]=f
        graphch[1]=diameter
        graphch[2]=20
        graphch[3]=fontobj
        graphch[4]=12

        oblist[0]=""
        oblist[1]=o1
        oblist[2]=o2    
        try:
            io1=self.objred.index(o1)
        except:
            io1=999999
            print "io1=",io1

        try:
            io2=self.objred.index(o2)
        except:
            io2=999999

        if io1!=999999 and io2!=999999:
            if self.zeta[io1][io2] == 0 and self.zeta[io2][io1] == 0:
                    intervalset = "None"
            else:        
                    if self.zeta[io1][io2]==1:    #io1 < io2    
                        intervalset=self.downset[io2]&self.upset[io1]
                    elif self.zeta[io2][io1]==1:  #io2 < io1
                        intervalset=self.downset[io1]&self.upset[io2]
                    else:
                        intervalset="None"

            print "intervalset = ",intervalset
            if intervalset == "None":
                    tpinfo_interval = Tkinter.Toplevel(hf)
                    lbinfointerval=Tkinter.Label(tpinfo_interval, text="+++ No connection +++",bg="yellow")
                    lbinfointerval.pack()
            else:        
                    cv=graphHD(perturb,self.objred,intervalset,\
                       posetch,graphch,oblist,self.cov,self.lobj,"tpgraph3","Interval"," ")
            
            
    def localHD(self,f,perturb,diameter,fontobj,o1):
        #brg 15.8.2012, 16.8.2012
        posetch=rmod2.vecgen1(3)
        graphch=rmod2.vecgen1(5)
        oblist=rmod2.vecgen1(3)

        posetch[0]=self.rred
        posetch[1]=self.level
        posetch[2]=self.levmax

        graphch[0]=f
        graphch[1]=diameter
        graphch[2]=20
        graphch[3]=fontobj
        graphch[4]=12

        oblist[0]=""
        oblist[1]=o1
        oblist[2]=""    
        try:
            io1=self.objred.index(o1)
        except:
            io1=999999
            print "io1=",io1

        if io1!=999999:
            localset=self.downset[io1]|self.upset[io1]
            cv=graphHD(perturb,self.objred,localset,posetch,graphch,\
                       oblist,self.cov, self.lobj,"tpgraph1","localHD"," ")


         
                

import rmod2
import itertools
import random
import Tkinter
import Canvas
import tkFileDialog
import raioop2


# def __init__(self,....
# fn: filename
# color,for marking the special object
# method (0 new method trred, 1: old method)
# obsp : special object of interest
# max_count_of_vertices: if rred> this numnber, then only cover-matirx, 200
# perturb,: perturbing the HD to detect artificial overlapping of lines, 1...3
# zusatz spce for additional information (such as eq.classes etc. in the HD), 100
# diameter: circle diameter of the vertices, 17
# diamsp: circle diameter for the object of interest, 20
# scaling: HD can be a little bit scaled up and down, 1.2
# mouse, 0: mouse diaabled, 1: mouse active
# fontobj,: size of labels of the veritces 10
# fontobjsp): size of the label of the special object 15
# obj1:       object for which an upset or downset is constructed
# obj2:       together with obj1: interval-HD

#        """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
  
        
def HDvisual():
    #19.8.2012
    ob=eob.get()     
    try:
       fHD=float(efHD.get())
    except:
       fHD=1.3     
    try:
       diameter=int(ediameter.get())
    except:
       diameter=17
    try:
       diamsp=int(ediamsp.get())
    except:
       diamsp=20
    try:
       fontobj=int(efont.get())
    except:
       fontobj=10
    try:
       fontobjsp=int(efontsp.get())
    except:
       fontobjsp=12              
    try:
       perturb=float(eperturb.get())
    except:
       perturb=0     

    app.visual(fHD,perturb,diameter,diamsp,fontobj,fontobjsp,ob)

def prepar1():
    app.inread()
    app.calc()
        
def prepar2():
    app.inread_pdt()
    app.calc()

def navi():
    #brg 18.8.2012
    global eo1,eo2,eo3,eo4a,eo4b,eo5a,eo5b    
    tpnavi=Tkinter.Toplevel(hf)
    tpnavi.title(' navigation board ')
    lbnavi=Tkinter.Label(tpnavi,text="Left side: Entry fields for the generating objects, right side: Buttons to start with")
    lbnavi.pack()
    frnavi=Tkinter.Frame(tpnavi,relief="sunken",bg="white",bd=3)
    frnavi.pack()
    eo1=Tkinter.Entry(frnavi,width=10)
    eo1.grid(row=2,column=1)
    eo2=Tkinter.Entry(frnavi,width=10)
    eo2.grid(row=3,column=1)
    eo3=Tkinter.Entry(frnavi,width=10)
    eo3.grid(row=4,column=1)
    eo4a=Tkinter.Entry(frnavi,width=10)
    eo4a.grid(row=5,column=1)
    eo4b=Tkinter.Entry(frnavi,width=10)
    eo4b.grid(row=5,column=2)
    eo5a=Tkinter.Entry(frnavi,width=10)
    eo5a.grid(row=6,column=1)
    eo5b=Tkinter.Entry(frnavi,width=10)
    eo5b.grid(row=6,column=2)
    buttsucc=Tkinter.Button(frnavi,text="downset ",width=15,bg="cyan",command=ds)
    buttsucc.grid(row=2,column=3)
    buttpred=Tkinter.Button(frnavi,text="upset ",width=15,bg="cyan",command=us)
    buttpred.grid(row=3,column=3)
    buttloc=Tkinter.Button(frnavi,text="localHD ",width=15,bg="cyan",command=lh)
    buttloc.grid(row=4,column=3)
    buttinter=Tkinter.Button(frnavi,text="intervalHD ",width=15,bg="cyan",command=ih)
    buttinter.grid(row=5,column=3)
    

def ds():
    o1=eo1.get()
    try:
            fnavds=float(efnavds.get())
    except:
            fnavds=1.3

    try:
            diameter=int(ediameter.get())
    except:
            diameter=17
    try:
            fontobj=int(efont.get())
    except:        
            fontobj=10    

    try:
            perturb=float(eperturb.get())
    except:
            perturb=0
    app.downsetHD(fnavds,perturb,diameter,fontobj,o1)

def us():
    o2=eo2.get()
    try:
            fnavus=float(efnavus.get())
    except:
            fnavus=1.3
    
    try:
            diameter=int(ediameter.get())
    except:
            diameter=17
    try:
            fontobj=int(efont.get())
    except:        
            fontobj=10
    try:
            perturb=float(eperturb.get())
    except:
            perturb=0
    app.upsetHD(fnavus,perturb,diameter,fontobj,o2)

def lh():
    o3=eo3.get()
    try:
            fnavLHD=float(efnavLHD.get())
    except:
            fnavLHD=1.3
    
    try:
            diameter=int(ediameter.get())
    except:
            diameter=17
    try:
            fontobj=int(efont.get())
    except:        
            fontobj=10
    
    try:
            perturb=float(eperturb.get())
    except:
            perturb=0
    app.localHD(fnavLHD,perturb,diameter,fontobj,o3)


def ih():
    o4a=eo4a.get()
    o4b=eo4b.get()
    try:
            fnaviv=float(efnaviv.get())
    except:
            fnaviv=1.3
    
    try:
            diameter=int(ediameter.get())
    except:
            diameter=17
    try:
            fontobj=int(efont.get())
    except:        
            fontobj=10
    
    try:
            perturb=float(eperturb.get())
    except:
            perturb=0
    app.intervalHD(fnaviv,perturb,diameter,fontobj,o4a,o4b)


def ft():
    #brg 19.8.2012 up to now: not well defined    
    o5a=eo5a.get()    
    o5b=eo5b.get()
    f=1.5
    diameter=12
    fontobj=10
    app.graphbetween(f,diameter,fontobj,o5a,o5b)


def saveboard():
    tpsaveboard=Tkinter.Toplevel(hf)
    tpsaveboard.title(' save files board ')
    lbsb=Tkinter.Label(tpsaveboard,text="Left side: result to be saved, right side: Buttons to start with")
    lbsb.pack()
    frsb=Tkinter.Frame(tpsaveboard,relief="sunken",bg="white",bd=3)
    frsb.pack()
    lbsb1=Tkinter.Label(frsb,text="save      pdt-File ")
    lbsb1.grid(row=2,column=1)
    lbsb2=Tkinter.Label(frsb,text="save      cov-File ")
    lbsb2.grid(row=3,column=1)
    lbsb3=Tkinter.Label(frsb,text="save     zeta-File ")
    lbsb3.grid(row=4,column=1)
    lbsb4=Tkinter.Label(frsb,text="save graphviz-File ")
    lbsb4.grid(row=5,column=1)
    buttsb1=Tkinter.Button(frsb,text=" save...",width=15,bg="cyan",bd=4,command=app.sto_pdt)
    buttsb1.grid(row=2,column=3)
    buttsb2=Tkinter.Button(frsb,text=" save...",width=15,bg="cyan",bd=4,command=app.sto_cov)
    buttsb2.grid(row=3,column=3)
    buttsb3=Tkinter.Button(frsb,text=" save...",width=15,bg="cyan",bd=4,command=app.sto_zeta)
    buttsb3.grid(row=4,column=3)
    buttsb4=Tkinter.Button(frsb,text=" save...",width=15,bg="cyan",bd=4,command=app.sto_graphviz)
    buttsb4.grid(row=5,column=3)

    
def cboard():
    #brg 19.8.2012
    global efHD,efnavds,efnavus,efnaviv,efnavLHD,ediameter,efont,efontsp,eperturb    
    tpcboard=Tkinter.Toplevel(hf)
    tpcboard.title(' controlling paneel ')
    lbcb=Tkinter.Label(tpcboard,text="from left to right: parameter, (recommended), entry field")
    lbcb.pack()
    frcb=Tkinter.Frame(tpcboard,relief="sunken", bd=3,bg="white")
    frcb.pack()
    lbcb1=Tkinter.Label(frcb,text="scaling factor for HD",bg="white")
    lbcb1.grid(row=1,column=1)
    lbcb1a=Tkinter.Label(frcb,text="(1.3)",bg="white")
    lbcb1a.grid(row=1,column=2)
    efHD=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    efHD.grid(row=1,column=3)
    lbcb2=Tkinter.Label(frcb,text="scaling factor for downset",bg="white")
    lbcb2.grid(row=2,column=1)
    lbcb2a=Tkinter.Label(frcb,text="(1.3)",bg="white")
    lbcb2a.grid(row=2,column=2)
    efnavds=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    efnavds.grid(row=2,column=3)
    lbcb3=Tkinter.Label(frcb,text="scaling factor for upset",bg="white")
    lbcb3.grid(row=3,column=1)
    lbcb3a=Tkinter.Label(frcb,text="(1.3)",bg="white")
    lbcb3a.grid(row=3,column=2)
    efnavus=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    efnavus.grid(row=3,column=3)    
    lbcb4=Tkinter.Label(frcb,text="scaling factor for intervalHD",bg="white")
    lbcb4.grid(row=4,column=1)
    lbcb4a=Tkinter.Label(frcb,text="(1.3)",bg="white")
    lbcb4a.grid(row=4,column=2)                     
    efnaviv=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    efnaviv.grid(row=4,column=3)       
    lbcb5=Tkinter.Label(frcb,text="scaling factor for localHD",bg="white")
    lbcb5.grid(row=5,column=1)
    lbcb5a=Tkinter.Label(frcb,text="(1.3)",bg="white")
    lbcb5a.grid(row=5,column=2)                     
    efnavLHD=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    efnavLHD.grid(row=5,column=3)
    lbcb6=Tkinter.Label(frcb,text="diameter (all HDs)",bg="white")
    lbcb6.grid(row=6,column=1)
    lbcb6a=Tkinter.Label(frcb,text="(17)",bg="white")
    lbcb6a.grid(row=6,column=2)
    ediameter=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    ediameter.grid(row=6,column=3)
    lbcb7=Tkinter.Label(frcb,text="diam:special object (only HD)",bg="white")
    lbcb7.grid(row=7,column=1)
    lbcb7a=Tkinter.Label(frcb,text="(20)",bg="white")
    lbcb7a.grid(row=7,column=2)
    ediamsp=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    ediamsp.grid(row=7,column=3)
    lbcb8=Tkinter.Label(frcb,text="fonts (all HDs)",bg="white")
    lbcb8.grid(row=8,column=1)
    lbcb8a=Tkinter.Label(frcb,text="(10)",bg="white")
    lbcb8a.grid(row=8,column=2)
    efont=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    efont.grid(row=8,column=3)
    lbcb9=Tkinter.Label(frcb,text="fonts for special object in HD",bg="white")
    lbcb9.grid(row=9,column=1)
    lbcb9a=Tkinter.Label(frcb,text="(12)",bg="white")
    lbcb9a.grid(row=9,column=2)
    efontsp=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    efontsp.grid(row=9,column=3)
    lbcb10=Tkinter.Label(frcb,text="perturb the HD ",bg="white")
    lbcb10.grid(row=10,column=1)
    lbcb10a=Tkinter.Label(frcb,text="(0)",bg="white")
    lbcb10a.grid(row=10,column=2)
    eperturb=Tkinter.Entry(frcb,width=5,relief="raised",bd=4)
    eperturb.grid(row=10,column=3)


def meth_submit():
        #brg 19.8.2012, 10.11.2014
        try:
                method=int(emethod.get())
        except:        
                method=0
        
        app.methodreadin(method)
         
        
    

    
hf=Tkinter.Tk()
hf.title(' main program ')
# brg 4.2.2013
global mouse   #1.12.2012
hf.option_add("*font", ("Arial", 10, "bold"))
fr=Tkinter.Frame(hf,bg="white")
fr.pack()
lb=Tkinter.Label(fr,text=20*"  "+"welcome: mHDCl"+36*" ",bg="green",font=("arial",12,"bold"))
lb.pack()

aboutmHDCl1=raioop2.brgabout3(fr,"tp1","about_mHDCl.txt",5,"about ","19.8.2012")
helpmHDCl=raioop2.brgabout3(fr,"tp1","help_mHDCl.txt",5,"help ","19.8.2012")

mouse = 1  #1.12.2012
app=HD(300,mouse) #1.12.2012, 13.9.2013   !!!!!!!!!Here the limiting number for drawing a HD
meth_submit()
butt1=Tkinter.Button(fr,text="Select data file (Excelderived dm) ",width=40,bg="grey",command=prepar1)
butt1.pack()
butt2=Tkinter.Button(fr,text="Select data file (pdt-format) ",bg="grey",width=40,command=prepar2)
butt2.pack()
tpadd=Tkinter.Toplevel(hf)
tpadd.title(' additional information ')
lbadd = Tkinter.Label(tpadd,text="additional information")
lbadd.pack()
butt3=Tkinter.Button(tpadd,text="show dm",width=40,bg="cyan", command=app.show)
butt3.pack(pady=2)
butt3a=Tkinter.Button(tpadd,text="dm-characteristics", width=40,bg="cyan",command=app.dmchar)
butt3a.pack()
butt4=Tkinter.Button(tpadd,text="show equivalence classes",width=40,bg="cyan",command=app.showequivclasses)
butt4.pack(pady=2)
butt4a=Tkinter.Button(tpadd,text="show nontrivial equivalence classes ",width=40,bg="cyan",command=app.showequivclassesshort)
butt4a.pack(pady=2)
butt5=Tkinter.Button(tpadd,text=" digraph of zeta-matrix ",width=40,bg="cyan",command=app.visual_zeta)
butt5.pack(pady=2)
butt6=Tkinter.Button(fr,text=" structural info of the poset ",width=40,bg="cyan",command=app.showUSP)
butt6.pack()
butt7=Tkinter.Button(tpadd,text=" conn. components of the poset ",width=40,bg="cyan",command=app.components)
butt7.pack()
butt8=Tkinter.Button(tpadd,text=" details concerning levels ",width=40,bg="cyan",command=app.levelincomp)
butt8.pack()
buttcomplexity = Tkinter.Button(tpadd,text="Complexity", width=40,bg="cyan",command=app.complexity)
buttcomplexity.pack()
butt9=Tkinter.Button(fr,text=" cover-matrix ",width=40,bg="cyan",command=app.methcover_show)
butt9.pack()
butt10=Tkinter.Button(fr,text=" covered-matrix ",width=40,bg="cyan",command=app.methcovered_show)
butt10.pack()
frinput1=Tkinter.Frame(fr,relief="sunken",bd=3)
frinput1.pack()
lbinput1=Tkinter.Label(frinput1,text="You may select an object >>>")
lbinput1.grid(row=1,column=0)
eob=Tkinter.Entry(frinput1,width=10)
eob.grid(row=1,column=2)
buttHD=Tkinter.Button(frinput1,text="Hasse diagram ",width=20,bg="cyan",command=HDvisual)
buttHD.grid(row=1,column=3)
buttnavi=Tkinter.Button(fr,text=" Order-theoretical navigation ",bg="cyan",width=40,command=navi)
buttnavi.pack()
buttfou=Tkinter.Button(fr,text="FOU-plot ",width=40,bg="cyan",command=app.fouplot)
buttfou.pack()
buttLPOM=Tkinter.Button(fr,text="Rkav based on LPOM0",width=40,bg="cyan",command=app.LPOM0)
buttLPOM.pack()
buttsave=Tkinter.Button(fr,text=" Save the different results ",bg="grey",width=40,command=saveboard)
buttsave.pack(pady=2)
buttgraphicscontrol=Tkinter.Button(fr,text="Open the control board for graphics ",width=40,bg="white",command=cboard)
buttgraphicscontrol.pack()
buttexit=Tkinter.Button(fr,text="exit",bg="red",width=40, bd=4,command=hf.destroy)
buttexit.pack(pady=5)

hf.mainloop()
