#  LPOM und probm GUI  24.6.07 , 7.7.07  Brg
#  brg probm (x<y)  = Q(x)/(Q(x)+Q(y))
#  Q(x) = (Nu(x)+1)/(Nd(x)+1)  Nu: elements above x , Nd: elements below x
# 7.7.07, 8.7.07, 20.10.07 , 22.10.07, 7.11.07, 16.11.07, 19.2.08
#  Brg 19.2.08: about as command
#  Brg 19.2.08: exit button
#  Brg 19.2.08: Toplevels
#  Brg 13.10.08 help text no external, loading by an OOP function
#  brg 3.6.09 cosmetics
#  brg 16.10.09 bug eliminated (in context with help)

import Tkinter 
import math
import rmod2
import raioop2
from ScrolledText import *

    
def about():
    #19.2.08
    tpabout=Tkinter.Toplevel(hf1)
    tpabout.title('about')
    lbabout=Tkinter.Label(tpabout,text="Author: R.Bruggemann, 19. Febr. 08 \n Module of PyHasse\n based on Python 2.5")
    lbabout.pack()
    

def approx():
    eingabe1=e01.get()
    if eingabe1=="":
        obj1="Obj1"
    else:
        obj1=eingabe1
    obj1=eingabe1
    eingabe2=e1.get()
    p1=float(eingabe2)
    eingabe3=e2.get()
    s1=float(eingabe3)
    eingabe4=e3.get()
    flag1=1
    if eingabe4=="" or eingabe4==" " or eingabe4== "   ":
        u1=0
        flag1=0
    else:    
        u1=float(eingabe4)
    
    eingabe5=e02.get()
    if eingabe5=="":
        obj2="Obj2"
    else:    
        obj2=eingabe5
    eingabe6=e4.get()
    p2=float(eingabe6)
    eingabe7=e5.get()
    s2=float(eingabe7)
    eingabe8=e6.get()
    flag2=1
    if eingabe8=="" or eingabe8==" " or eingabe8=="   ":
        u2=0
        flag2=0
    else:    
        u2=float(eingabe8)

    
    rkav1=float(s1+1)*(p1+s1+u1+2)/float(p1+s1+2)
    rkav2=float(s2+1)*(p2+s2+u2+2)/float(p2+s2+2)
    Q1=float(p1+1)/float(s1+1)
    Q2=float(p2+1)/float(s2+1)
    prm=float(Q1)/float(Q1+Q2)
    lb4a.config(bg="yellow",relief="raised",bd=2)
    lb4b.config(bg="yellow",relief="raised",bd=2)
    lb4c.config(bg="yellow",relief="raised",bd=2)
    if flag1*flag2==0:
        
        lb4a["text"]="Result: Rkav("+str(obj1)+")  :  not well defined"
        lb4b["text"]="Result: Rkav("+str(obj2)+")  :  not well defined"
        lb4c["text"]="pm ("+str(obj1)+" < "+str(obj2)+"):= " +str(round(prm,2))
    else:
        lb4a["text"]="Result: Rkav("+str(obj1)+")  :=  "+str(round(rkav1,2))
        lb4b["text"]="Result: Rkav("+str(obj2)+")  :=  "+str(round(rkav2,2))
        lb4c["text"]="pm ("+str(obj1)+" < "+str(obj2)+"):= " +str(round(prm,2))


hf1=Tkinter.Tk()
hf1.title("mutprobavrk")
muthelp=raioop2.brgabout(hf1,"tp1","help_mut.txt",1,\
            "Febr.,19th,2008"," help_mutprobavrk ", "white", "t1",80,5,ScrolledText)
    

frabout=Tkinter.Frame(hf1,width=300, height=300)
frabout.pack()

buttabout=Tkinter.Button(frabout,text="About ",bg="green",command=about)
buttabout.pack()
lbproblem=Tkinter.Label(frabout,text=" Rkav(obj1), Rkav(obj2) and mutual probability (pm)  (obj1 < obj2) ")
lbproblem.pack()
lbgap=Tkinter.Label(frabout,text="  ")
lbgap.pack()
frfeld=Tkinter.Frame(hf1,relief="sunken")
frfeld.pack()
freingabe=Tkinter.Frame(frfeld,relief="sunken")
freingabe.pack(side="left")
lb01=Tkinter.Label(freingabe,text="First object  ")
lb01.pack()
lb11=Tkinter.Label(freingabe,text="predecessors1  ")
lb11.pack()
lb21=Tkinter.Label(freingabe,text="successors1    ")
lb21.pack()
lb31=Tkinter.Label(freingabe,text="incomparables1 ")
lb31.pack()
lb02=Tkinter.Label(freingabe,text="Second object  ")
lb02.pack()
lb12=Tkinter.Label(freingabe,text="predecessors2  ")
lb12.pack()
lb22=Tkinter.Label(freingabe,text="successors2    ")
lb22.pack()
lb32=Tkinter.Label(freingabe,text="incomparables2 ")
lb32.pack()
frdaten=Tkinter.Frame(frfeld,relief="sunken")
frdaten.pack(side="right")
e01=Tkinter.Entry(frdaten)   #object-identifier
e01.pack()
#
e1=Tkinter.Entry(frdaten)    #p1
e1.pack()
e2=Tkinter.Entry(frdaten)    #s1
e2.pack()
e3=Tkinter.Entry(frdaten)    #u1
e3.pack()
#
e02=Tkinter.Entry(frdaten)  #object identifier
e02.pack()
e4=Tkinter.Entry(frdaten)    #p2
e4.pack()
e5=Tkinter.Entry(frdaten)    #s2
e5.pack()
e6=Tkinter.Entry(frdaten)    #u2
e6.pack()
frplatz=Tkinter.Frame(hf1)
frplatz.pack()
lbplatz=Tkinter.Label(frplatz,text="    ")
lbplatz.pack()
frstart=Tkinter.Frame(hf1,relief="groove")
frstart.pack()
b1=Tkinter.Button(frstart,text = "start approx ",bg="cyan",command=approx)
b1.pack()

frausgabe=Tkinter.Frame(hf1,relief="sunken")
frausgabe.pack()

lb4a=Tkinter.Label(frausgabe,text="Result: Rkav(obj1)  ")
lb4a.pack(fill="x",pady=10)
lb4b=Tkinter.Label(frausgabe,text="Result: Rkav(obj2)  ")
lb4b.pack(fill="x",pady=1)
lb4c=Tkinter.Label(frausgabe,text="pm (obj1 < obj2):   ")
lb4c.pack(fill="x",pady=1)

buttexit=Tkinter.Button(hf1,text=" exit", bg="red", command=hf1.destroy)
buttexit.pack()
hf1.mainloop()
