import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 31.03.2017: mutprobsimpl


###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def interface_graphviz():
    # brg 9.9.2014
    #taken from mHDCl2
    covgr=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if i1!=i2:
                covgr[i1][i2]=cov[i1][i2]
    txtgr=rmod2.covtxt(covgr,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile3(fr,'t','w',txtgr,rred,rred) 
    import tkMessageBox
    tkMessageBox.showinfo(title="store graphviz-interface",message="successafull!")


    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####

def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the [0,1]-columnwise data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=40)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def HD():
    # brg 26.7.2013, 29.8.2013, 2.11.16
    
    global x,la,ls,cov, rred, objred
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    rmod2.matout(rred,rred,zeta)
    Utotal = rmod2.incompzeta(rred,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
           

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    
def succ_predec(xred,rred,k):
    #brg 14.11.2015, 16.11.2015, 31.03.17
    #rmod2.matout(rred,k,xred)
    
    u=[]
    succ = []
    predec = []
    for i1 in range(0, rred):
        succ.append(0)
        succ[i1]=[]
        predec.append(0)
        predec[i1]=[]
        for i2 in range(0, rred):
            s=0
            p=0
            count  = 0
            for j in range(0, k):
                if xred[i1][j] <= xred[i2][j]:
                    #print "i1=",i1,"  i2=",i2,"  j= ",j,"dm=:", xred[i1][j]," <? ",xred[i2][j]
                    count+=1
            if count == k:
                p+=1       #i1 has someone connected upwards
            count = 0
            for j in range(0, k):
                if xred[i1][j] >= xred[i2][j]:
                    count+=1
            if count == k:
                s+=1       #i1 has someone connected downwards
            
            if s>0:
                succ[i1].append(i2)
            if p>0:
                predec[i1].append(i2)
        u.append(rred-len(succ[i1])-len(predec[i1])+1)
    return succ, predec,u


def calc_zeta(xred,rred,k):
    # brg 31.03.17
    zeta=[]
    for i1 in range(0, rred):
        zeta.append(0)
        zeta[i1]=[]
        for i2 in range(0, rred):
            p=0
            count  = 0
            for j in range(0, k):
                if round(xred[i1][j],10) <= round(xred[i2][j],10):
                    count+=1
            if count == k:
                zeta[i1].append(1)
            else:
                zeta[i1].append(0)
    return zeta

def mutprobsimple(zetaloc,smaller,larger,rred):
    # brg 16.2.2013
    for i in range(0,len(larger)):
        larger[i]=larger[i]-1
        smaller[i]=smaller[i]-1
        #print "i= ",i,"  larger= ",larger[i],"   smaller= ",smaller[i]
    # Bruggemann approach, see NERI 2002    
    mutprob=rmod2.marray(rred,rred)
    for i in range(0,rred):
       for j in range(0,rred):
           if i==j:
               mutprob[i][j]=1
           elif zetaloc[i][j]==1 and zetaloc[j][i]==0:
               mutprob[i][j]=0
           elif zetaloc[i][j]==0 and zetaloc[j][i]==1:
               mutprob[i][j]=1
           else:
               nenner=1.0*(smaller[i]+1.0)*(larger[j]+1.0)+1.0*(larger[i]+1.0)*(smaller[j]+1.0) 
               mutprob[i][j]=1.0*(smaller[i]+1.0)*(larger[j]+1.0)/nenner
    #print "mutprob-matrix"
    return mutprob

def calc_mutprob(zetaloc,rred):
    #brg 7.11.2010, 15.2.2013, 16.2.2013, 31.03.2017
    #first step: counts of x: elements larger/ smaller than x
    larger=rmod2.matrixrowsum(zetaloc,rred,rred)
    smaller=rmod2.matrixcolsum(zetaloc,rred,rred)
    mutprob=mutprobsimple(zetaloc,smaller,larger,rred)
    return mutprob

def s_p_u():
    # brg 31.03.17
    succ,predec,u=succ_predec(xred,rred,k)
    tplocal=Tkinter.Toplevel(hf)
    tplocal.title(" local info ")
    tlocal=ScrolledText(tplocal,width=60,height=40)
    tlocal.pack()
    txt="Local information in terms of "+"\n"
    txt+="down sets, "+"\n"
    txt+="up sets and \n"
    txt+="count of incomparables of each repr. element "+"\n"
    txt+="down sets "+"\n"
    for i1 in range(0,rred):
        txt+=str(objred[i1])+":\t"
        for i2 in range(0, len(succ[i1])):
            txt+=str(objred[succ[i1][i2]])+"\t"
        txt+="\n"
    txt+="up sets " +"\n"   
    for i1 in range(0,rred):
        txt+=str(objred[i1])+":\t"
        for i2 in range(0, len(predec[i1])):
            txt+=str(objred[predec[i1][i2]])+"\t"
        txt+="\n"
    txt+="Count of incomparables "+"\n"
    for i1 in range(0,rred):
        txt+=str(objred[i1])+":\t"+str(u[i1])+"\n"
    txt+="\n"
    tlocal.insert("end",txt)

def mp():
    #brg 31.03.2017
    # a calculation without the need of generating the HD
    zetaloc=calc_zeta(xred,rred,k)
    rmod2.matout(rred,rred,zetaloc)
    mutprob=calc_mutprob(zetaloc,rred)
    tpmp=Tkinter.Toplevel(hf)
    tpmp.title(" mutprob ")
    tmp=ScrolledText(tpmp,width=60,height=10)
    tmp.pack()
    txt=" mutual probabilities  row-element >= col-element"+"\n"
    txt+="\n"+60*"="+"\n"
    txt+="\t"
    for i1 in range(0,rred):
        txt+=str(objred[i1])+"\t"
    txt+="\n"
    for i1 in range(0,rred):
        txt+=str(objred[i1])+":\t"
        for i2 in range(0,rred):
            txt+=str(round(mutprob[i1][i2],3))+"\t"
        txt+="\n"
    txt+="\n- - - - e o f - - - -"
    tmp.insert("end",txt)
    

## Tkinter 
hf = Tkinter.Tk()
hf.title(' mutprobsimpl ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_mutprobsimpl.txt",1,\
            "March, the 31th, 2017"," about mutprobsimpl ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_mutprobsimpl.txt",1,\
            "March, the 31th, 2017"," help_mutprobsimpl ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", width=50, command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",
                                     bg="cyan",width=50, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=50, bg="cyan", command=HD)
buttHD.pack(pady=5)
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
buttlocalinfo=Tkinter.Button(fr,text="Successors, Predecessors and count of incomparable elements ",
                             width=50,bg="cyan",command=s_p_u)
buttlocalinfo.pack()
buttmutprob=Tkinter.Button(fr,text="prob that row-det. object >= col-determining object ",
                           width=50,bg="cyan",command=mp)
buttmutprob.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=3)
hf.mainloop()
