import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
import math
import random

#Brg 26.8.09 aus sensi11 und towardowa5
# Brg 27.8.09
# Brg 1.9.09 bug-Suche
# Brg 2.9.09 version owa3.py
# brg 10.7.10



def about():
    """ About owa """
    # Brg 16.8.08
    aboutowa=raioop2.brgabout(hf,"tp2","about_owa.txt",4,\
            "September 2nd,2009"," about_owa ", "white", "t2",90,3,ScrolledText)
    

def raihelp():
    """ Help about owa """
    
    #  Use of OOP
    helpowa=raioop2.brgabout(hf,"tp1","help_owa.txt",4,\
            "September 2nd,2009"," help_owa ", "white", "t1",120,5,ScrolledText)

def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,ob,obj,pro,prop,r,k,fn
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #rmod2.matout(r,k,dm)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    return 

def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    


def minmaxnorm(r,k,dm):
    """ normalizes the columns of dm to 0,1 """
    # brg 9.12.07, 7.5.08, 10.6.08, taken from interval6.py 10.7.10
    # brg 22.1.2015
    global yn,flagnorm              # wesentliche Aenderung!!
    yn=rmod2.matrixnorm(r,k,dm)
    flagnorm=1
    return yn



def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08, 1.9.09
    global rred,xred,objred,prop    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]

    yn=minmaxnorm(r,k,dm)   #10.7.10 new   
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,yn,obj)    
    ###############################################################
                #1.9.09
    return rred,xred,objred,obj,prop,txt           

def HDorig():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 8.6.08 
    global zeta,zeta2,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn,prop
    
    rred,xred,objred,obj,prop,txt=filecomp(fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>60:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def dispersion(owa,begin,end):
    # Brg 25.8.09,1.9.09, 10.7.10
    Dsum=0
    n=end-begin
    #print "in dispersion n:",n
    for j in range(0,n):
        if owa[j]!=0:
            Dsum-=owa[j]*math.log(owa[j])
        else:
            Dsum-=0   #regel d'hopital
    return Dsum        


def or_ness(owa,begin,end):
    #brg 27.8.09,1.9.09
    nn=end-begin
    sumor1=0
    #print "nn in in or_ness ",nn
    for j in range(0,nn):
        sumor1+=j*owa[j]  #10.7.10: the attributes are ordered from smallest to largest, therefore the sum must be modified
    if nn!=1:
        sumor=(1.0/(1.0*nn-1.0))*sumor1
    else:
        sumor=1
    #print "owa = ",owa
    #print "orness =  ",sumor
    return sumor
    


def owa_act(orfactor,m):
    # brg 26.8.09. 10.7.2010
    owaact=rmod2.vecgen1(m)
    if orfactor==100:
        for j in range(0,m):
            if j<m-1:
                owaact[j]=0.0
            else:
                owaact[j]=1.0   #the largest value will be selected 
    elif orfactor==0:
        for j in range(0,m):
            if j==0:
                owaact[j]=1.0  #the smallest value will be selected
            else:
                owaact[j]=0.0
    else:
        sumor=0
        for j in range(0,m):
            if orfactor<50.0:
                owaact[j]=(m-j)**(1.0*(50.0-orfactor)/25.0)
            else:    
                owaact[j]=(j+1)**(1.0*(orfactor-50.0)/25.0)
            sumor+=owaact[j]
        for j in range(0,m):
            owaact[j]=1.0*owaact[j]/(1.0*sumor)
    print "orfactor in owa_act:  ",orfactor        
    
    print "in owa_act :",owaact
    return owaact


def sel_agg():
    # Brg 26.8.09 sel ect_agg regation
    global tpagg,anz,eatt
    tpagg=Tkinter.Toplevel(hf)
    tpagg.title(' definition of aggreg ')
    
    fragg=Tkinter.Frame(tpagg,bd=3)#fragg container for grid.....!!!!
    fragg.pack()
    anz=int(eanz.get())
    
    eatt=rmod2.marray(anz,k)
    for i in range(0,anz):
        lbagg=Tkinter.Label(fragg,text=str(i+1)+"te aggr.")
        lbagg.grid(row=1+i,column=0)
        for j in range(0,k):
            eatt[i][j]=Tkinter.Entry(fragg,width=2)
            eatt[i][j].grid(column=1+j,row=1+i)
    

def design():
    #brg 26.8.09, 1.9.09
    #pattern of aggregation
    global attrecord,att
    att=rmod2.marray(anz,k)
    attrecord=rmod2.vecgen1(anz)
##    print "k= ",k
##    print "anz = ",anz
    for i in range(0,anz):
        zahl=0
        for j in range(0,k):
            hilf=eatt[i][j].get()
            if hilf!="x":
                att[i][j]=0
            else:
                att[i][j]=1
                zahl+=1
        attrecord[i]=zahl        
    #rmod2.matout(anz,k,att)
    #print attrecord
    #attrecord[i]: how many attributes of the original matrix will...
    #....be aggregated by OWA-operator technique
    # anz times data matrices with attrecord[i] columns
    


def owa_orfactor():
    #brg 1.9.09
    tpagg2=Tkinter.Toplevel(hf)
    tpagg2.title(' owa-aggregation ')
    fragg2=Tkinter.Frame(tpagg2)
    fragg2.pack()
    global orfactor
    orfactor=rmod2.vecgen1(anz)
    for i1 in range(0,anz):
        orfactor[i1]=Tkinter.DoubleVar()
        xsch=Tkinter.Scale(fragg2,width=20,length=100,orient="horizontal",from_=0,to=100,\
                   label="   Orness %",variable=orfactor[i1])
        xsch.pack()
        

def owa_agg():
    #brg 1.9.09
    global qnew,orvec,dispvec,owadoc
    qnew=rmod2.marray(r,anz)
    owadoc=rmod2.marray(r,k)
    orness=rmod2.vecgen1(anz)
    disp=rmod2.vecgen1(anz)
    lbagg=rmod2.vecgen1(anz)
    orvec=rmod2.vecgen1(anz)
    dispvec=rmod2.vecgen1(anz)
    for i1 in range(0,anz):
        x=orfactor[i1].get()
        dmnew=rmod2.marray(r,attrecord[i1])  #attrecord[1]
        new=rmod2.vecgen1(attrecord[i1])
        #print "i1= ",i1,"   orfactor = ",x
        owaa=owa_act(x,attrecord[i1])  #owaa is a tuple
        for i in range(0,r):
            j1=0
            for j in range(0,k):
                if att[i1][j]==1:
                    new[j1]=dm[i][j]
                    j1+=1
            newsort,dummy=rmod2.raisort(j1,new)
            for j in range(0,attrecord[i1]):
                dmnew[i][j]=newsort[j]
                qnew[i][i1]+=owaa[j]*dmnew[i][j]    
    
        #rmod2.matout(r,attrecord[i1],dmnew)
        ornessact=or_ness(owaa,0,attrecord[i1])
        disp=dispersion(owaa,0,attrecord[i1])
        lbagg[i1]=Tkinter.Label(tpagg,text="Orness = "+str(round(ornessact,2))+"   Dispersion= "+\
                        str(round(disp,2)))
        lbagg[i1].pack()
        orvec[i1]=ornessact
        dispvec[i1]=disp
        for j in range(0,attrecord[i1]):
            owadoc[i1][j]=owaa[j]
    #rmod2.matout(r,anz,qnew)
    #print "dispersion ",dispvec
    print "orness  ",orvec
    #rmod2.matout(anz,k,owadoc)        
        
                    
def showagg():
    #brg 1.9.09
    tpdoc=Tkinter.Toplevel(hf)
    tpdoc.title(' documentation of OWA aggregation ')
    lbdoc=Tkinter.Label(tpdoc,text=str(anz)+" superindicators based on owa-combinations")
    lbdoc.pack()
    dm,ob,pro,r,kor=rmod2.EXCELreadin4(fn)
    for i in range(0,r):
        obj[i]=ob[i+1]
    tdoc=ScrolledText(tpdoc,width=80,height=20)
    tdoc.pack()
    txt=""
    txt+="\n owa-matrix (each row corresponds to an aggregation generating a super-indicator \n"
    txt+=60*"="+"\n"
    for i1 in range(0,anz):
        for j in range(0,attrecord[i1]):
            txt+=str(round(owadoc[i1][j],2))+"\t"
        txt+="\n"
    txt+="\n"
    txt+="Parameters of aggregation:"
    txthilf="\n"
    for i1 in range(0,anz):
        if attrecord[i1]>1:  #10.7.10
            txthilf+="aggregation no "+str(i1+1)+"  dispersion = "+str(round(dispvec[i1],2))+"  orness = "+str(round(orvec[i1],3))+"\n"
        else:  #10.7.10
            txthilf+="aggregation no "+str(i1+1)+"  dispersion = "+str(round(dispvec[i1],2))+"  orness = ++ not defined +++\n"

        
    txt+=txthilf
    txt+="\n"
    txt+="\n"
    txt+=" matrix of the super-indicators\n"
    for i in range(0,r):
        txt+=obj[i]+":\t"
        for j in range(0,anz):
            txt+=str(round(qnew[i][j],2))+"\t"
        txt+="\n"    
    txt+=25*"-"+"e o f "+25*"-"+"\n"
    tdoc.insert("end",txt)
    
        
    
def confirm():
    #Brg 10.7.10
    global pruef
    
    
def newdm_save():
    #brg  31.5.09, 1.6.09, 23.7.09 (taken from palg4), 2.9.09
    tpsdm=Tkinter.Toplevel(hf,width=60,height=5)
    tpsdm.title(' save new dm ')
    frsdt=Tkinter.Frame(tpsdm,relief="sunken",bd=2)
    frsdt.pack()
    lbstart=Tkinter.Label(frsdt,text=" select directory ",bg="yellow")
    lbstart.pack()
    fn=tkFileDialog.asksaveasfilename(parent=tpsdm)
    rmod2.raiwrite5(fn,qnewred,objredowa,propowa,r,anz)
    lbsuccess=Tkinter.Label(frsdt,text="matrix with \n"+str(r)+"  rows  and "+str(anz)+"\n  columns stored",bg="yellow")
    lbsuccess.pack()    

def HD():
    global zeta,zeta2,r,objred,qnewred,objredowa    
    global fn,pruef,propowa
    dm,ob,pro,ror,kor=rmod2.EXCELreadin4(fn)
    propowa=rmod2.vecgentext1(anz)
    obj=rmod2.vecgentext1(ror)     #8.5.08 changed to ...text1
    for i in range(0,anz):
        propowa[i]="owa["+str(i)
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    r,qnewred,objredowa,txt=rmod2.equivcompact(ror,anz,qnew,obj)    
    ###############################################################
    
    
    zetahilf=rmod2.comp(r,anz,qnewred)
    zeta=rmod2.marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            zeta[i][j]=zetahilf[j][i]
    #

    lobj,lext,revlext,zzmax=rmod2.levtopsort(r,zeta)
    #print "zzmax = ",zzmax
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Level population ')
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objredowa[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,r):
        if i<r-1:
            txt2+=objredowa[revlext[i]]+" < "
        else:
            txt2+=objredowa[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(tplev,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
        
    #Adj-Listen

    adjc=rmod2.adjacent(r,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(r,adjc,lext)
           
        
    zeta2=rmod2.cover(r,tr,lext)
    tphasse=Tkinter.Toplevel(hf)
    tphasse.title(' OWA-HD  ')
    lbhdowa=rmod2.vecgen1(anz)
    try:                          #distortion of the HD to avoid artificial coincidence of lines
        pruef=int(epruef.get())
    except:
        pruef=0

    for i2 in range(0,anz):
        lbhdowa[i2]=Tkinter.Label(tphasse,text="aggregation no "+str(i2+1)+"  orness = "+str(round(orvec[i2],2))+"   dispersion = "+str(round(dispvec[i2],2)))
        lbhdowa[i2].pack()
    if r>60:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(tphasse,text=" Hasse Diagram of File "+fn)
        lbhd3.pack(pady=5)
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(r,levmax,zzmax)
        cv=Tkinter.Canvas(tphasse,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(r,r)
        geomy=rmod2.marray(r,r)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)+pruef*random.randint(5,15)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i+pruef*random.randint(5,15)
            
            
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredowa[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        
    cv.pack()
    buttsave.config(state="active")

    
hf=Tkinter.Tk()
hf.title(' OWA-Analysis ')
about()
raihelp()
lbopen=Tkinter.Label(hf,text="")
lbopen.pack()
buttload=Tkinter.Button(hf,text="load dm ",width=25,bg="white",command=File_select)
buttload.pack(pady=5)
frorig=Tkinter.Frame(hf,relief="sunken",bd=2)
frorig.pack()
buttdmshow=Tkinter.Button(frorig,text="show dm ",width=25,command=showDM)
buttdmshow.pack()
buttHDorig=Tkinter.Button(frorig,text="show HD of orig. dm",width=25,command=HDorig)
buttHDorig.pack()
franz=Tkinter.Frame(hf)
franz.pack()
lbanz=Tkinter.Label(franz,text="(1) Select the number of super-indicators ")
lbanz.pack(side="left")
eanz=Tkinter.Entry(franz,width=2)
eanz.pack(side="left")
buttselagg=Tkinter.Button(hf,text="(2) Design of aggregation",bg="cyan",width=25,command=sel_agg)
buttselagg.pack()
buttagg=Tkinter.Button(hf,text="(3) Confirm your selection ",width=25,bg="cyan",\
                       bd=3,command=design)
buttagg.pack()
buttorfactor=Tkinter.Button(hf,text="(4) weights ",width=25,bg="cyan",command=owa_orfactor)
buttorfactor.pack()
buttowa_agg=Tkinter.Button(hf,text="(5) aggregation ",width=25,bg="cyan",command=owa_agg)
buttowa_agg.pack()
frshow=Tkinter.Frame(hf)
frshow.pack()
lbshow=Tkinter.Label(frshow,text="")
lbshow.pack()
buttaggshow=Tkinter.Button(hf,text="show aggregation details ",command=showagg)
buttaggshow.pack()
frpruef=Tkinter.Frame(hf)
frpruef.pack()
lbpruef=Tkinter.Label(frpruef,text="HD_Layout entry :0 undisturbed, >=1 disturbed")
lbpruef.pack(side="left")
epruef=Tkinter.Entry(frpruef,width=1)
epruef.pack(side="left")
##buttconfirm=Tkinter.Button(frpruef,text="layout_submit",bg="cyan",bd=4,command=confirm)
##buttconfirm.pack(side="left")
buttHD=Tkinter.Button(hf,text="(6) HD after aggregation",width=25,bg="cyan",command=HD)
buttHD.pack()
buttsave=Tkinter.Button(hf,text="save new dm ",width=25,state="disabled",command=newdm_save)
buttsave.pack()
buttexit=Tkinter.Button(hf,text=" exit",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()                          
    
        
