import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkMessageBox
import Canvas
import os
import random
import tkFileDialog


# palg2.py from mainHD7, Brg, the 1.July 08, 2.7.08, 11.10.08, 
# 18.11.08: Now the original HD can be examined (button showorigHD)
# 15.3.09 palg3.py: cosmetics
# 8.6.09 palg4.py changed data matrix saved
# 24.9.09 Modifications in HDrigid and SOCN
# 17.10.09 and 8.12.2010 cosmetics
# 13.3.2016 vs 4_3: cosmetics


def sf():
    #brg  31.5.09, 1.6.09
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
    for i in range(0,r):
        print obj[i]," ",
    print " "    
    rmod2.raiwrite5(fn,dmfinal,obj,prop,r,k)
    lbsuccess.config(text="matrix with \n"+str(r)+"  rows  and "+str(k)+"\n  columns stored",bg="yellow")

def fileselect():
    """ File selection, opening and by Tkinter-Standards"""
    #*13.1.08
    #akt: 1.7.08
    #note: 
    #source:-
    global fn,r,dm, ob, pro, k
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbfile.config(bg="yellow")
    lbfile["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    buttshow.config(state="active",bg="cyan")
    buttmain.config(state="active",bg="cyan")
    buttshowpalg.config(state='active',bg='cyan')
     

def sortout():
    """ a loop which calculates number of eq.rel. and incop. as
    a function of amount of outsorted objects of lower importances"""
    #Brg *: 1.7.08
    #Brg akt: 1.7.08
    global obj,prop  
    n1=en1.get()
    n2=en2.get()
    if n1=="":
        xn1=80
    else:
        xn1=int(n1)
    if n2=="":
        xn2=100
    else:
        xn2=int(n2)

    global info_sortout,info_incomp,info_eqtotal,info_nrobj,dmnorm, dmtrans
    dmnorm=rmod2.matrixnorm(r,k,dm)
    
    info_sortout=rmod2.vecgen1(xn2-xn1+1)
    info_incomp=rmod2.vecgen1(xn2-xn1+1)
    info_eqtotal=rmod2.vecgen1(xn2-xn1+1)
    info_nrobj=rmod2.vecgen1(xn2-xn1+1)
    dmtrans=rmod2.marray(r,k)
    zaehl=0
    for sort_out in range(xn1,xn2+1):
        for j in range(0,k):
            for i in range(0,r):   #heart of p-algorithm (slightly modified in comparison to WHASSE
                if dmnorm[i][j]<=0.01*sort_out:
                    dmtrans[i][j]=0.0
                else:
                    dmtrans[i][j]=dmnorm[i][j]
        #idea: values which are less than sortout are set to 0
        #then the standard procedure can be used
        #print "interim result "
        #rmod2.matout(r,k,dmtrans)
        zobj=0
        
        for i in range (0,r):
            test=0.0
            for j in range(0,k):
                test+=round(dmtrans[i][j],4)
            if test<0.0001:
                zobj+=1
                    
        info_nrobj[zaehl]=r-zobj        
        rred,xred,objred,obj,prop,txt,neq=filecomp(r,dmtrans,pro,ob,fn)
         
        zetahilf=rmod2.comp(rred,k,xred)
        incomp=0
        for i in range(0,rred-1):
            for j in range(i+1,rred):
                if zetahilf[i][j]==0 and zetahilf[j][i]==0:
                    incomp+=1
        eqtotal=0
        for i in range(0,r):
            eqtotal+=(neq[i]*(neq[i]-1))/2.0     #20.6.08
        info_sortout[zaehl]=eqtotal+incomp
        info_incomp[zaehl]=incomp
        info_eqtotal[zaehl]=eqtotal
        zaehl+=1

##    print "info_inc   ",info_incomp
##    print "info_eq    ",info_eqtotal
##    print "info_uncertainty ",info_sortout
##    print "info_surv. objects  ",info_nrobj
    tpcv1=Tkinter.Toplevel(hf,width=250,height=450)
    tpcv1.title(' incomp as function of sort_out ')
    
    cvinfo=Tkinter.Canvas(tpcv1,width=450,height=540)
    cvinfo.pack()

    ninfo_incomp,maxinc,mininc=rmod2.vectornorm(xn2+1-xn1,info_incomp)
    ninfo_eqtotal,maxeq,mineq=rmod2.vectornorm(xn2-xn1+1,info_eqtotal)
    nsortout,maxsort,minsort=rmod2.vectornorm(xn2-xn1+1,info_sortout)
    nnrobj,maxnr,minnr=rmod2.vectornorm(xn2-xn1+1,info_nrobj)
    linter=xn2-xn1+1

    # incomp as function of sortout
    line1=cvinfo.create_line(50,140,50,0,arrow="last")
    line2=cvinfo.create_line(50,140,240,140,arrow="last")
    xstart0=50
    xstart=50
    delta=int(170.0/linter)
    endpos = delta*linter
##    print "linter = ",linter
##    print "delta =",delta
##    print "end position ",endpos
    for i in range(0,linter-1):
        linev=cvinfo.create_line(xstart,140-ninfo_incomp[i]*135,xstart+delta,140-ninfo_incomp[i+1]*135,fill="red",width=3)
        xstart+=delta                         
    cvinfo.create_text(15,7,text="inc",font = ("Arial",10,"bold"))
    cvinfo.create_text(270,140,text="sortout", font = ("Arial",10,"bold"))
    cvinfo.create_text(xstart0,150,text=str(xn1))
    cvinfo.create_text(xstart0+endpos,150,text=str(xn2))
    cvinfo.create_text(300,7,text="max and min-values: "+str(maxinc)+", "+str(mininc))

    # eqtotal as a function of sortout
    xstart=50
    line1=cvinfo.create_line(50,310,50,170,arrow="last")
    line2=cvinfo.create_line(50,310,240,310,arrow="last")
    for i in range(0,linter-1):
        linev=cvinfo.create_line(xstart,310-ninfo_eqtotal[i]*135,xstart+delta,310-ninfo_eqtotal[i+1]*135,fill="red",width=3)
        xstart+=delta                         
    cvinfo.create_text(15,177,text="eq",font = ("Arial",10,"bold"))
    cvinfo.create_text(270,320,text="sortout", font = ("Arial",10,"bold"))
    cvinfo.create_text(xstart0,320,text=str(xn1))
    cvinfo.create_text(xstart0+endpos,320,text=str(xn2))
    cvinfo.create_text(300,177,text="max and min-values: "+str(maxeq)+", "+str(mineq))

    # uncertainty as a function of sortout
    xstart=50
    line1=cvinfo.create_line(50,480,50,340,arrow="last")
    line2=cvinfo.create_line(50,480,240,480,arrow="last")
        
    for i in range(0,linter-1):
        linev=cvinfo.create_line(xstart,480-nsortout[i]*135,xstart+delta,480-nsortout[i+1]*135,fill="red",width=3)
        xstart+=delta                         
    cvinfo.create_text(40,353,text="uncertainty",font = ("Arial",10,"bold"))
    cvinfo.create_text(270,490,text="sortout", font = ("Arial",10,"bold"))
    cvinfo.create_text(xstart0,490,text=str(xn1))
    cvinfo.create_text(xstart0+endpos,490,text=str(xn2))
    cvinfo.create_text(300,347,text="max and min-values: "+str(maxsort)+", "+str(minsort))

    #info_nrobj as a function of sortout
    tpnrobj=Tkinter.Toplevel(hf,width=500,height=300)
    tpnrobj.title(' number of surviving objects ')
    cvinfo2=Tkinter.Canvas(tpnrobj,width=450,height=400)
    cvinfo2.pack()
    xstart0=100
    xstart=100
    line1=cvinfo2.create_line(xstart0,200,xstart0,0,arrow="last")
    line2=cvinfo2.create_line(xstart0,200,280,200,arrow="last")
    
    delta=int(170.0/linter)
    
    for i in range(0,linter-1):
        linev=cvinfo2.create_line(xstart,200-nnrobj[i]*185,xstart+delta,200-nnrobj[i+1]*185,fill="red",width=3)
        xstart+=delta                         
    cvinfo2.create_text(50,10,text="surviving obj",font = ("Arial",10,"bold"))
    cvinfo2.create_text(300,230,text="sortout", font = ("Arial",10,"bold"))
    cvinfo2.create_text(xstart0,210,text=str(xn1))
    cvinfo2.create_text(xstart0+endpos,210,text=str(xn2))
    cvinfo2.create_text(280,15,text="max and min-values: "+str(maxnr)+",  "+str(minnr))
    
def showpalg1():
    """in dependence of a filter some information """
    global rred, dmfinal,xred, objred,neq,filt,infocontent
    tpalg1=Tkinter.Toplevel(hf,width=300,height=450)
    tpalg1.title('show palg')
    tfile0=ScrolledText(tpalg1,width=60,height=4)
    tfile0.pack()
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n original data matrix   \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(round(dm[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile0.insert("end",txt)
    tfile1=ScrolledText(tpalg1,width=60,height=4)
    tfile1.pack()
    dmnorm2=rmod2.matrixnorm(r,k,dm)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix normalized but not changed  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(round(dmnorm2[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile1.insert("end",txt)

    eesort=esort.get()
    if eesort=="":
        filt=90
    else:
        filt=int(eesort)
    dmfinal=rmod2.marray(r,k)
    for j in range(0,k):
            for i in range(0,r):
                if dmnorm2[i][j]<=0.01*filt:
                    dmfinal[i][j]=0.0
                else:
                    dmfinal[i][j]=1.0*dmnorm2[i][j]
                    
    rred,xred,objred,obj,prop,txt,neq=filecomp(r,dmfinal,pro,ob,fn)
##    print "objred ",objred
##    print "rred  = ",rred
    tpeq=Tkinter.Toplevel(hf,width=70,height=5)
    tpeq.title(' quotient set with limiting value : '+str(filt))
    teq=ScrolledText(tpeq,width=60, height=4)
    teq.pack()
    teq.insert("end",txt)
    txt=""
    
    zetahilf=rmod2.comp(rred,k,xred)
    incomp=0
    for i in range(0,rred-1):
        for j in range(i+1,rred):
            if zetahilf[i][j]==0 and zetahilf[j][i]==0:
                incomp+=1
    eqtotal=0
    for i in range(0,r):
        eqtotal+=(neq[i]*(neq[i]-1))/2.0     #20.6.08
    
    infocontent=eqtotal+incomp                

    tfile2=ScrolledText(tpalg1,width=60,height=4)
    tfile2.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix filtered with limiting value "+str(0.01*filt)+"\n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(round(dmfinal[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile2.insert("end",txt)

    tfile3=ScrolledText(tpalg1,width=60,height=4)
    tfile3.pack()
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,rred):
        txt1+=" "+objred[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix resulting representants limiting value "+str(0.01*filt)+"\n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,rred):
        txt3+=objred[i]+"\t"          #2.7.08
        for j in range(0,k):
            txt3+=str(round(xred[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile3.insert("end",txt)

    tfile4=ScrolledText(tpalg1,width=60,height=4)
    tfile4.pack()
    txt="\n Summary \n"
    txt+="\nsortout-level = \t\t"+str(filt)
    txt+="\n incomparabilities = \t\t"+str(incomp)
    txt+="\n equivalence relations = \t"+str(eqtotal)
    txt+="\nuncertainty (=eq.rel.+incomp.) = \t"+str(infocontent)
    tfile4.insert("end",txt)
    buttcalc.config(state='active',bg='cyan')
    

def SOCN():
    """ normalizes and reduces the data matrix """
    # Brg 4.8.08, 18.11.08
    global rred,y,objred,fn,k
    #select and open
   
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)    #8.5.08 changed: ...text1
    #prop and obj contain the proper names of attributes and objects, resp.
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    ################################################################
    rred,xred,objred,extratxt,eqtxt=rmod2.equivcompact3(r,k,dm,obj)    
    ################################################################
    hfeq2=Tkinter.Toplevel(hf)
    hfeq2.title('equiv. classes')
    lbeq1=Tkinter.Label(hfeq2,width=60,text="Structure: quotient set")
    lbeq1.pack()
    labeq=Tkinter.Label(hfeq2,width=60,text="representants and their\n equivalent objects")
    labeq.pack()
    txteq=ScrolledText(hfeq2,width=60,height=4)
    txteq.pack()
    txteq.insert("end",extratxt)
    y=rmod2.matrixnorm(rred,k,xred)
    return rred,k,y,objred,obj,prop,extratxt,eqtxt
    
    
def showorigHD():
    """shows the orig. HD due to the orig dm """
    # Brg 18.11.08, 24.9.09, 13.3.2016
    rred,k,y,objred,obj,prop,txtquot,eqtxt=SOCN()

    app1=raioop2.HDrigid(hf,"tphd",250,"dummy"," ",eqtxt,rred,k,y,objred,r,obj)   #50 replaced by 250
    app1.preHD()
    app1.HDdraw()



def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
        

    
def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #
    global zeta,zeta2,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    ## Bausrtelle xred --> dmfinal
    #
    zetahilf=rmod2.comp(rred,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    #print "zzmax = ",zzmax
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Level population ')
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,rred):
        if i<rred-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(tplev,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    zeta2=rmod2.cover(rred,tr,lext)
    if rred>250:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight, bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(int(actwidth/3.0),actheight-10,text="Limiting value = "+str(filt)+"  uncertainty : "+str(infocontent))
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()
       
                          

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07, 13.3.16
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def calc():
    "series of HD/LPOM calculations"
    #brg 7.11.07, 12.12.07, 21.3.08, 17.6.08, 19.6.08, 21.6.08
    
    print "objred = ",objred
    #         definitions of vectors
    p=[]      #successors of any obj
    u=[]      #incomparable elem. of any obj
    succ=[]   #predecessors of any obj, nmen leider vertauscht. 
    pr=[]     # number of  chains
    rkav=[]   #rkav after LPOM(0)model
    minx=[]
    maxx=[]
    isox=[]

    zmaxminiso=[]

    for i in range(0,rred):
        succ.append(0)
        u.append(0)
        p.append(0)
        rkav.append(0)
        pr.append(0)
        minx.append(-1)
        maxx.append(-1)
        isox.append(-1)
        zmaxminiso.append(0)

    # definiton of matrices
    global objx,redobjx,quobx   #17.6.08
    objx=rmod2.marray(rred,rred)   
    redobjx=rmod2.marray(rred,rred)
    quobx=rmod2.marray(rred,rred)
    prod=rmod2.marray(rred,rred)
    prod1=rmod2.marray(rred,rred)
    unit=rmod2.matunit(rred)


    # heart of the program begin
    
    #print "xred "
    #rmod2.matout(rred,k,xred)
    objx=rmod2.comp(rred,k,xred)
    #print "objx (nach heart of the program "
    #rmod2.matout(rred,rred,objx)
    #print " "
    rmod2.matadd(rred,1.0,objx,-1.0,unit,redobjx)
    
    level,pr=rmod2.chainlevel(rred,redobjx)

    ######## results window 2 ######################################################
    hfresults2=Tkinter.Toplevel(hf)
    hfresults2.title('  results 1: limiting value = '+str(filt))
    lbresultlevel=Tkinter.Label(hfresults2,text="maximal count of levels: "+str(level))
    lbresultlevel["font"]="Arial 16"
    tchainlength=ScrolledText(hfresults2,width=50,height=10)
    tchainlength.pack()
    txt="\n chain analysis \n"
    for i in range(0,rred):
        if pr[i]!=0:
            txt+="number of chains with length:  "+str(i)+" = :"+str(pr[i])+"\n"
    
    tchainlength.insert("end",txt)

    rmod2.qualcomp(rred,objx,quobx)
    #rmod2.matout(rred,rred,objx)  #7.11.07
    #rmod2.strmatout(rred,rred,quobx)  #7.11.07
    inco=rmod2.marray(rred,rred)    
    maxx,minx,isox=rmod2.maxminiso1(rred,quobx)

    inco=rmod2.rai_inc(rred,quobx)

    lbresult=Tkinter.Label(hfresults2,text="")
    lbresult.pack()
    lbresult["text"]="maximal,minimal and isolated elements (row-numbers) "
    lbmax=Tkinter.Label(hfresults2,text="")
    lbmax.pack()
    lbmax["text"]="maximal elements"
    tmaxel=ScrolledText(hfresults2,width=50,height=10)
    tmaxel.pack()
    txt=""
    z=0
    for i in range(0,rred):
        if maxx[i]!=-1:
            z+=1
            txt+=str(objred[maxx[i]])+" "                 #29.11.07
    #print "number of maximal elements: ",z
    txt+="\n count of max elements: "+str(z)+"\n"
    tmaxel.insert("end",txt)

    
    lbmin=Tkinter.Label(hfresults2,text="")
    lbmin.pack()
                        
    lbmin["text"]="minimal elements"
    tminel=ScrolledText(hfresults2,width=50,height=10)
    tminel.pack()
    txt=""
    z=0
    for i in range(0,rred):
        if minx[i]!=-1:
            z+=1    
            txt+=str(objred[minx[i]])+" "                   #29.11.07
    txt+="\n count of min elements: "+str(z)+"\n"
    tminel.insert("end",txt)

    lbiso=Tkinter.Label(hfresults2,text="Isolated elements")
    lbiso.pack()
    tisoel=ScrolledText(hfresults2,width=50,height=10)
    tisoel.pack()
    txt=""
    z=0
    for i in range(0,rred):
        if isox[i]!=-1:
            z+=1
            txt+=str(objred[isox[i]])+" "
    txt+="\n count of isolated elements: "+str(z)+"\n"
    tisoel.insert("end",txt)

    hfresults3=Tkinter.Toplevel(hf)   #26.5.08 
    hfresults3.title(' results 2: limiting value =  '+str(filt))
    labinc=Tkinter.Label(hfresults3,text="incomparable elements:")
    labinc.pack(pady=3)
    tincel=ScrolledText(hfresults3,width=50,height=10)
    tincel.pack()
    z=0
    txt=" "
    for i in range(0,rred):
        txt+="object "+str(objred[i])+":  "               #29.11.07
        for j in range(0,rred):
            if inco[i][j]!=-1:
                z+=1
                txt+=str(objred[inco[i][j]])+" "         #29.11.07
        txt+="\n"
    utotal=round(float(1.0*z/2.0),2)
    ntotal= 1.0*r*(r-1.0)/2.0
    #print "ntotal = ",ntotal
    eqtotal=0
    for i in range(0,r):
        eqtotal+=(neq[i]*(neq[i]-1))/2.0     #20.6.08
        
    if rred==0:
        pib=0
        txt+=" "
        msgwarning()
    else:    
        pib=round(2.0*utotal/(rred*(rred-1)),2)
        txt+="\n number of incomparable pairs "+str(utotal)+"  stability: "+str(pib) +"\n"   
    totobj=len(objred)   #26.5.08
    #txt+="\n nr. of representants "+str(totobj)
    comparabilities= (totobj*(totobj-1)/2.0)-utotal
    #txt+="\n nr of comparabilities "+str(comparabilities)
    tincel.insert("end",txt)    
    labov=Tkinter.Label(hfresults3,text="Relational information")
    labov.pack(pady=5)
    tstat=ScrolledText(hfresults3,width=50,height=4)
    tstat.pack()
    txtstat="Quotient set and some characteristics \n"
    txtstat+="\n number of incomparabilities\t"+str(utotal)
    txtstat+="\n number of comparabilties  \t"+str(comparabilities)
    txtstat+="\n number of representants   \t"+str(totobj)
    txtstat+="\n stability ('P(IB)'):  \t"+str(2.0*utotal/(1.0*totobj*(totobj-1)))
    txtstat+="\n - - - end of file - - - "
    tstat.insert("end",txtstat)
    
    lablevel=Tkinter.Label(hfresults3,text="Pop. of the levels")
    lablevel.pack(pady=5)
    
    levelpop=rmod2.marray(level,rred)
    levelpop=rmod2.railevel(rred,level,objx)

    tlevpop=ScrolledText(hfresults3,width=50,height=10)
    tlevpop.pack()
    
    txt="Level info\n"
    for iz in range(0,level):
        txt+="Level "+str(level-iz)+": "
        for j in range(0,rred):
            if levelpop[iz][j]!=-1:
                txt+=str(objred[levelpop[iz][j]])+" "          #29.11.07
        txt+="\n"        
    txt+="\n"
    tlevpop.insert("end",txt)   
    lbstruc=Tkinter.Label(hfresults3,text="structural details ")
    lbstruc.pack(pady=5)
    txtstruc=ScrolledText(hfresults3,width=50,height=10)
    txtstruc.pack()
    txtsuc="\n successors\n"
    for i in range(0,rred):
        txtsuc+="object "+objred[i]+": "
        for j in range(0,rred):
            if i!=j:
                if objx[i][j]==1:
                    txtsuc+=objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txtsuc+="\n"
    txtsuc+="\n predecessors  \n"
    for j in range(0,rred):
        txtsuc+="object "+objred[j]+": "
        for i in range(0,rred):
            if j!=i:
                if objx[i][j]==1:
                    txtsuc+=objred[i]+", "
                else:
                    pass
            else:
                pass
        txtsuc+="\n"    
    txtstruc.insert("end",txtsuc)
    buttHD.config(state="active",bg="cyan")
    
    
    
    
def filecomp(r,dm,pro,ob,fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08, 20.6.08, 2.7.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global rred
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,prop,txt,neq   #20.6.08        
                

def rai_about():
    """ About palg4.py """
    lbabout.config(text="Author: R.Bruggemann, June, 8th, 2009, version 4")
    lbabout2.config(text="In comparison to WHASSE: extended by more graph ")
    lbabout3.config(text="Main Literature: see Bruggemann,R. et al., \nChemosphere 38(10),2263-2279,1999\n\
        Other literature, see help-function ")
    
                    
                   
    

    
hf=Tkinter.Tk()
hf.title('--    p-algorithm   -- ')
lbtitle=Tkinter.Label(hf, text = ' p a l g   -   algorithm   ',width=60,font=("Arial", 14))
lbtitle.pack(pady=10)
helppalg=raioop2.brgabout(hf,"tp1","help_palg.txt",4,\
            "June, the 8th,2008"," help_palg ", "white", "t1",120,10,ScrolledText)
    
    

buttabout=Tkinter.Button(hf,bg="green",text="about",width=25,command=rai_about)
buttabout.pack()
lbabout=Tkinter.Label(hf,text="")
lbabout.pack()
lbabout2=Tkinter.Label(hf,text="")
lbabout2.pack()
lbabout3=Tkinter.Label(hf,text="")
lbabout3.pack()
buttfile=Tkinter.Button(hf,text="(1) Select and open file",bg="white",bd=4,width=25,command=fileselect)
buttfile.pack(pady=5)
lbfile=Tkinter.Label(hf,text="\n\n\n")
lbfile.pack()
buttshow=Tkinter.Button(hf,text="show data matrix ",width=25, state='disabled',command=showDM)
buttshow.pack()
buttHD0=Tkinter.Button(hf,text="original HD",width=25, command=showorigHD)
buttHD0.pack()
fr1=Tkinter.Frame(hf,relief="sunken",bd=2)
fr1.pack()
lben1=Tkinter.Label(fr1,text="start-value for cutting-level>>>")
lben1.pack(side="left")
en1=Tkinter.Entry(fr1,width=3)
en1.pack(side="left")
fr2=Tkinter.Frame(hf,relief="sunken",bd=2)
fr2.pack()
lben2=Tkinter.Label(fr2,text="end-value for cutting-level>>>")
lben2.pack(side="left")
en2=Tkinter.Entry(fr2,width=3)
en2.pack(side="left")
buttmain=Tkinter.Button(hf,text=" (2) Sortout-analysis ",state='disabled',bd=5,bg="cyan",width=25,command=sortout)
buttmain.pack(pady=3)
fr3=Tkinter.Frame(hf,relief="sunken",bd=2)
fr3.pack()
lbesort=Tkinter.Label(fr3,text="actual cutting level>>> ")
lbesort.pack(side="left")
esort=Tkinter.Entry(fr3,width=3)
esort.pack(side="left")
buttshowpalg=Tkinter.Button(hf,text="show palg-results ",state='disabled',bd=5,bg="cyan",width=25,command=showpalg1)
buttshowpalg.pack()
buttcalc=Tkinter.Button(hf,text="calculation ",state='disabled',bd=5,bg="cyan",width=25,command=calc)
buttcalc.pack()
buttHD=Tkinter.Button(hf,text=" (3) Hasse diagram, linExt ",bd=5,state='disabled',bg="cyan",width=25,command=HD)
buttHD.pack()
buttsf=Tkinter.Button(hf, text = "store changed dm ",bd=5,width=25,bg="cyan",\
                      command=sf)
buttsf.pack()
lbsuccess=Tkinter.Label(hf,text="")
lbsuccess.pack()

buttdestroy=Tkinter.Button(hf,text=" exit",bg="red",width=25,bd=5,command=hf.destroy)
buttdestroy.pack(pady=5)

hf.mainloop()
    

