import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 24.7.2016 Based on HDsimpl the new module Pathtable.py

###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def interface_graphviz():
    # brg 9.9.2014
    #taken from mHDCl2
    covgr=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if i1!=i2:
                covgr[i1][i2]=cov[i1][i2]
    txtgr=rmod2.covtxt(covgr,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile3(fr,'t','w',txtgr,rred,rred) 
    import tkMessageBox
    tkMessageBox.showinfo(title="store graphviz-interface",message="successafull!")


    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####


def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 24.7.16 taken from avrank5_2
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=80,height=20)
    tfile.pack()
   
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)



def HD():
    # brg 26.7.2013, 29.8.2013, 25.7.2016
    
    global x,la,ls,cov, rred, objred, zeta
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    
def SaPaUa():
    #Brg 30.9.09, 2.3,2012, 28.7.2012, 23.2.2013, from LPOMext: 25.7.16
    global Ua,Sa,Pa,countPa,countUa,countSa,rkav,hav 
    Sa=rmod2.marray1(rred,rred,-1)
    Pa=rmod2.marray1(rred,rred,-1)
    Ua=rmod2.marray1(rred,rred,-1)
    countSa=rmod2.vecgen1(rred)
    countPa=rmod2.vecgen1(rred)
    countUa=rmod2.vecgen1(rred)
    alpha=1  #parameters to be determined by statistical techniques
    beta=0  #parameters to be determined by statistical techniques

    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element label whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z

    for ob in objred:
        obi=objred.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z

    # relevanter Teil    
    for ob in objred:
        obi=objred.index(ob)
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rred):
            if zeta[i1][obi]==0 and zeta[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1   #if object with label i1 is incomparable with obi, then Ua[obi][i1] gets just the label i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
        countUa[obi]=z
        #print "ob= ",ob,"   count Ua= ",countUa[obi]
    #rmod2.matout(rred,rred,Ua)
    hav=rmod2.vecgen1(rred)    #LPOM0
    for ob in objred:    #28.7.2012
        obi=objred.index(ob)  #28.7.2012
        hav[obi]=1.0*countSa[obi]*(rred+1)/(1.0*(rred+1-countUa[obi]))
    return(hav)   
        
def heightext():
    # brg 8.11.2014, from LPOMext: 25.7.16
    global objsort
    rred,xred,objred,elist,eqm=rmod2.equivcompactgr(r,k,x,obj) 
    # hav (LPOM0)
    hav=SaPaUa()
    havextended=rmod2.weak1(r,obj,objred,hav,eqm)
    tpallobjects=Tkinter.Toplevel(hf)
    tpallobjects.title(" all objects ")
    tallobjects=ScrolledText(tpallobjects, width=60, height=10)
    tallobjects.pack()
    txt=" Extension of hav (LPOM0) and rkav (LPOMext) to all objects"+"\n"
    txt+="  (application or routine weak1 )"+"\n"
    txt+=50*"="+"\n"
    txt+="Objects"+"\t"+"LPOM0"+"\t"+"\n"
    for i in range(0,r):
        txt+=str(obj[i])+"\t"+str(round(havextended[i],3))+"\n"
    txt+="\n"
    txt+="- - - sorting - - -  "+"\n"
    tallobjects.insert("end",txt)
    havrev=[]
    for i in range(0,r):
        havrev.append(r+1-havextended[i])
    rsort,nsort=rmod2.raisort(r,havrev)
    txt="Rank Info "+"\n"
    txt+=50*"="+"\n"
    txt+="\n"
    txt+="Sorted "+"\n"
    txt+=60*"-"+"\n"
    txt+="objects "+2*"\t"+"hav rev"+"\n"
    txt+=60*"-"+"\n"
    objsort=[]
    ranksort=[]
    for i in range(0,r):
        objsort.append(obj[nsort[i]])
        ranksort.append(rsort[i])
        txt+=str(obj[nsort[i]])+2*"\t"+str(round(rsort[i],3))+"\n"
    txt+="\n"
    print objsort
    print ranksort
    tallobjects.insert("end",txt)
    
    
def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def calc_relat(r, k, x):
    #taken from rmod2 13.10.2014 and modified according to PyHasse_internet
    c= []
    flag=0    
    for i1 in range(0, r):
        c.append(0)
        c[i1] = []
        for i2 in range(0, r):
            flag=0
            for j in range(0, k):
                #print " kk =",kk," i=",i," j = ",j
                if x[i1][j] >= x[i2][j]:
                    flag += 1
            if flag == k:
                 c[i1].append(1)
            else:
                 c[i1].append(0)
            #print " "     
    return c

    

def save_relat():
    # Brg taken from Electresimpl 13.10.2014
    relat = calc_relat(r, k, x)
    fnrelat=tkFileDialog.asksaveasfilename(parent=hf,title="save relation-files in PyHasseformat")
    fcsv=open(fnrelat,"w")
    fcsv.write(str(r)+"\n")
    for i1 in range(0,r):
        for i2 in range(0,r):
            fcsv.write(str(relat[i1][i2])+"\t")
        fcsv.write("\n")
    fcsv.close()

def sort_attributes():
    # brg 24.7.16, 26.7.16
    # Give the sequence of attributes according
    # its importance (whatever the reason may be):
    # qi1>qi2>qi3>...>qim w.r.t. to that (user-defined) importance
    global seqlist, qsort, pattern
    tpsort=Tkinter.Toplevel(hf)
    tpsort.title("Sorting window")
    seq=eseq.get()
    if seq!="":
        seqlist=seq.split(",")
    else:
        print "leer"
        seqlist=[]
        for j in range(0,k):
            seqlist.append(prop[j])
    print k, seq, seqlist
    txt="Sorted according to 'impotance'"+"\n"
    qsort=[]
    for j in range(0,k):
        txt+=seqlist[j]+", "
        qsort.append(prop.index(seqlist[j]))
    txt+="\n"
    lbsort = Tkinter.Label(tpsort,text=txt)
    lbsort.pack()
    print qsort
    pattern=[]
    for x in range((2**k)-1,-1,-1):
        bx=rmod2.bitrep(k,x)
        print x,bx
        pattern.append(bx)
    print "pattern"
    print pattern
    print " "
   

def generate_pattern(x,obj1,obj2,qsort,pattern,j,m):
    # brg 24.7.16
    # x original dm
    # obj1 label of first object
    # obj2 label of second object
    # qsort (calculated in routine 'sort_attributes') indicates ---
    #... which attribute has which location in the bit pattern pattern[j]
    # for example [1,0,2,3] corresponding to [q2,q1,q3,q4]
    # (meaning importance q2>q1>q3>q4).
    # pattern[j]: for example [1,0,1,0]. For an object pair (obj1,obj2) to belong to pattern [j]
    #...it is required that x1[q2]>=x2[q2], x1[q1]<x2[q1], x1[q3]>=x2[q3] and finally x1[q4]<x2[q4]
    # return: matches. Corresponding to pattern[j], needs matches=m!!
    iob1=obj.index(obj1)
    iob2=obj.index(obj2)
    bx=[]
    for j2 in range(0,m):
        if x[iob1][qsort[j2]]>=x[iob2][qsort[j2]]:
            bx.append(1)
        else:
            bx.append(0)
    #print "bx= ",bx
    matches=0
    for j3 in range(0, m):
        if bx[j3]==pattern[j][j3]:
            matches+=1
        else:
            matches+=0
    return matches    
        
def calc_table():
    # brg 24.7.16, 26.7.16
    subsetobj=elistobj.get()
    if subsetobj=="all":
        objlist=[]
        for i in range(0, r):
            objlist.append(objsort[i])
    else:        
        objlist=subsetobj.split(",")
    n=len(objlist)
    #print "objlist= ",objlist
    objbelong_j=[]
    for j in range(0,(2**k)):
        hilf=[]
        for i1 in range(0, n):
            for i2 in range(i1+1,n):
                match=generate_pattern(x,objlist[i1],objlist[i2],qsort,pattern,j,k)
                if match==k:
                    hilf.append((objlist[i1],objlist[i2]))
                else:
                    pass
        objbelong_j.append((pattern[j],hilf))
        #print "pattern und hilf ",pattern[j],hilf
    countdpp=[]
    for j in range(0,(2**k)):
        countdpp.append((objbelong_j[j][0],len(objbelong_j[j][1])))
        print j,countdpp[j]
    tpresult=Tkinter.Toplevel(hf)
    tpresult.title(' Decision-paths and their object pairs ')
    tresult=ScrolledText(tpresult,width=120,height=10)
    tresult.pack()
    txt=""
    txt+="File = "+fn+"\n"
    txt+="Selected objects: "
    for ob in objlist:
        txt+=str(ob)+", "
    txt+="\n"
    txt+="Sorted attributes according their importance "+"\n"
    for j in range(0, k):
        txt+=str(prop[qsort[j]])+", "
    txt+="\n"
    txt+="Decision paths and their population (by object pairs) "+"\n"
    #print "objbelong= ",objbelong_j
    for j in range(0,(2**k)):
        txt+="("
        for j2 in range(0,k):
            txt+=str(countdpp[j][0][j2])+","
        txt+="): "    
        txt+=str(countdpp[j][1])+"\n"    
    txt+="\n"
    txt+="Details: "+"\n"
    for j in range (0,2**k):
        if objbelong_j[j][1]!=[]:
            ll=len(objbelong_j[j][1])
            txt+=str(objbelong_j[j][0])+", "
            for j2 in range(0, ll):
                txt+=str(objbelong_j[j][1][j2])+", "
            txt+="\n"
    txt+="- - - e o f  -  -  - "+"\n"        
    tresult.insert("end",txt)
    
## Tkinter 
hf = Tkinter.Tk()
hf.title(' path_table ')
aboutpathtable=raioop2.brgabout(hf,"tp1","about_path_table.txt",2,\
            "July, the 26th, 2016"," about path_table ", "white", "t1",80,5,ScrolledText)
helppathtable=raioop2.brgabout(hf,"tp1","help_path_table.txt",2,\
            "July, the 26th, 2016"," help path_table ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=40, bg="cyan", command=HD)
buttHD.pack(pady=5)
buttshowdm=Tkinter.Button(fr,text="Show data matrix ",bg="cyan",width=40,command=showDM)
buttshowdm.pack()
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
lbseq=Tkinter.Label(fr,text="Enter the attributes according to their importance")
lbseq.pack()
eseq=Tkinter.Entry(fr,width=20)
eseq.pack()
buttsort=Tkinter.Button(fr,text="Sort!",bg="cyan",width=40,command=sort_attributes)
buttsort.pack()
buttranksort=Tkinter.Button(fr,text="Sorting all objects according to LPOM0 ",bg="cyan",width=40,command=heightext)
buttranksort.pack()
lbselectobj=Tkinter.Label(fr,text="Read_in objects of interest \n\
                          ('all' if all objects are to be read in")
lbselectobj.pack()
elistobj=Tkinter.Entry(fr,width=40)
elistobj.pack()
butt_calctable=Tkinter.Button(fr,text="Calculate path_table ",width=40, bg="cyan",command=calc_table)
butt_calctable.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
