import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import random
import tkFileDialog
import tkSimpleDialog
import raioop2


#avs_vs1.py  (attribute value's sensitivity _ very simple)
# brg 16.3.09, 17.3.09, 18.3.09
# Brg 25.3.09 Histogram of resistances
# Brg: 25.3.09 renamed in pooc.py  perturbation on order characteristics from avs_vs1
# Brg 25.3.09 Rearrangement for a more flexible input
# brg 9.6.09 very unclear output
# Brg 8.11.09 general changes
# Brg 9.11.09 general changes
# Brg 18.7.2011 pooc6 simplified as a full analysis should be done with
#               sensitivity variance based, see Annoni et al., 2011 
# Brg 9.11.2012 cosmetics
# Brg 23.11.2012: bugs detected by Lars

def filecomp(r,dm,pro,fn,ob,k):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08, 20.6.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    #prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
##    for i in range(0,k):
##        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
       
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)    
    ###############################################################
    print "in filecomp ",obj
    global obj
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,txt,neq   #20.6.08        


def preview():
    app1=raioop2.brgfileselect(hf,"tppreview")
    #access to dimension of the matrix
    fn,r,k=app1.transfer_part1()
    #access to names
    ob,pro=app1.transfer_part2()
    #access to the dm itself
    dm0=app1.transfer_part3()
    app1.show()

def submit():
    app1=raioop2.brgfileselect(hf,"tp3")
    #access to dimension of the matrix
    fn,r,k=app1.transfer_part1()
    #access to names
    ob,pro=app1.transfer_part2()
    #access to the dm itself
    dm0=app1.transfer_part3()
    #
    app1.show()
    global fn
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)    #8.5.08 changed: ...text1
    #prop and obj contain the proper names of attributes and objects, resp.
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    
    global perturb,r,k,dm0,obj,ob,fn,prop
    standard_calc()    


def standard_calc():
    """ standard case is analyzed """
    # Brg 4.8.08, 16.3.09, 18.3.09, 9.6.09, 8.11.09, 9.11.09
    global standardpsu,prred,prop,n,objred,dm0,obj,standardtotal,rred
    
    #dq=tkSimpleDialog.askfloat(' avs_vs ','test-unit',parent=tpinput)
    tp=Tkinter.Toplevel(hf)
    tp.title(' Standard case ')
    # Normal state
    txt="\n Standard state\n"
    rred,xred,objred,obj,txt,neq=filecomp(r,dm0,prop,fn,ob,k)#identifies eq.classes
    n=rred
    
    standardpsu=rmod2.marray(r,4)
    standardtotal=rmod2.vecgen1(4)
    
    labeq=Tkinter.Label(tp,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    objx=rmod2.comp(r,k,dm0)#makes the zeta matrix
##    print "standard "
##    rmod2.matout(r,r,objx)
    qzeta=rmod2.qualcomp1(r,objx)
    #rmod2.strmatout(r,r,qzeta)
    
    #print "io= ",io    
    txt+="\n standard\n"
    txt+="\tequiv\tpredec\tsucc\tincomp\n"
    for i in range(0,r):
        for j in range(0,r):
            if i!=j:
                if qzeta[i][j]=="eg":
                    standardpsu[i][3]+=1
                elif qzeta[i][j]=="lt":
                    standardpsu[i][1]+=1
                elif qzeta[i][j]=="gt":
                    standardpsu[i][0]+=1
                elif qzeta[i][j]=="ic":
                    standardpsu[i][2]+=1
                else:
                    pass
        standardtotal[0]+=standardpsu[i][0]
        standardtotal[1]+=standardpsu[i][1]
        standardtotal[2]+=0.5*standardpsu[i][2]
        standardtotal[3]+=0.5*standardpsu[i][3]
        
    for i in range(0,r):
        txt+=obj[i]+" :\t"+str(standardpsu[i][3])+"\t"+str(standardpsu[i][1])+"\t"+str(standardpsu[i][0])+"\t"\
              +str(standardpsu[i][2])+"\n"
    txt+="\n total (standard)\n"
    
    txt+="\t"+str(int(standardtotal[3]))+"\t"+str(standardtotal[1])+"\t"+str(standardtotal[0])+"\t"+str(int(standardtotal[2]))
    tstandard=ScrolledText(tp,width=60,height=10)
    tstandard.pack()
    tstandard.insert("end",txt)
    ##########################################################


def HD():
    zetahilf=rmod2.comp(r,k,dm0)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Level population ')
    lbhd1=Tkinter.Label(tplev,text= "Level ")
    lbhd1.pack()
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    cov=rmod2.cover(n,tr,lext)

    if n>70:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(tplev,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(tplev,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        
##def showdetails():
##    tpdet=Tkinter.Toplevel(hf)
##    tpdet.title(' details of perturbation ')
##    tdet=ScrolledText(tpdet,width=80,height=10)
##    tdet.pack()
##    tdet.insert("end",txtp)

def perturb():    ###########################################################
    global txtp,dm,objaffected,attaffected,dq,objper
    perturbpsu=rmod2.marray(n*k,4)
    dq=float(eatt.get())
    objaffected=objaff.get()
    iaff=obj.index(objaffected)
    attaffected=attaff.get()
    jaff=prop.index(attaffected)
    dm=rmod2.matcopy1(r,k,dm0)
    dm[iaff][jaff]=dm0[iaff][jaff]+dq
    print "affected dm "
    rmod2.matout(r,k,dm)
    #changes in qzeta
    objx=rmod2.comp(r,k,dm) #perturbed dm at iaff and jaff
    qzeta=rmod2.qualcomp1(r,objx)# perturbation in object iaff and attribut jaff
    print "affected qzeta"
    rmod2.strmatout(r,r,qzeta)
    # perturbation: the cell iaff,jaff of dm will be affected
    tpperturb=Tkinter.Toplevel(hf,width=80,height=10)
    tpperturb.title(' perturbation ')
    tperturb=ScrolledText(tpperturb,width=120,height=10)
    tperturb.pack()
    
    txtp=" perturbation Analysis (objects)\n"
    txtp+=5*"\t "+"equiv\tpredec\tsucc\tincomp\n"
    zahl=0
    objper=rmod2.marray(r,4)
    for i2 in range(0,r):  #analysis of modified qzeta
        for i3 in range(0,r):
            if i2!=i3:
                if qzeta[i2][i3]=="eg":  #8.11.09 here analysis w.r.t. selected object
                    objper[i2][3]+=1      #18.7.2011 summation over all objects except i2
                elif qzeta[i2][i3]=="lt":
                    objper[i2][1]+=1
                elif qzeta[i2][i3]=="gt":
                    objper[i2][0]+=1
                elif qzeta[i2][i3]=="ic":
                    objper[i2][2]+=1
                else:
                    pass
            else:
                pass
        txtp+="cell perturbed ("+obj[iaff]+", "+prop[jaff]+"): "+"Object: "+\
                "'"+obj[i2]+"'"+3*"\t"+":  "+str(objper[i2][3])+3*"\t"+str(objper[i2][1])+"\t"+str(objper[i2][0])+"\t"+str(objper[i2][2])+"\n"
        txtp+="\n"
        
        txtp+=40*"-"+"\n"    
    tperturb.insert("end",txtp)        
    buttgr=Tkinter.Button(tpperturb,text="graphic",width=25,command=star)
    buttgr.pack()
    
def star():
    #brg 18.7.2011, 9.11.2012
    tpgr=Tkinter.Toplevel(hf)
    cvgr=Tkinter.Canvas(tpgr,width=400,height=450,bg="white")
    cvgr.pack()
    rgr=50
    rkl=8
    cir1=cvgr.create_oval(200-rgr,200+rgr,200+rgr,200-rgr,outline="black",fill="yellow")
    textcir1_1=cvgr.create_text(200,195,text="obj= "+objaffected+"  attr = "+attaffected)
    textcir1_2=cvgr.create_text(200,215,text="perturb = "+str(dq))
    cir2=cvgr.create_oval(20-rkl,200+rkl,20+rkl,200-rkl,outline="black")
    textcir2=cvgr.create_text(20,200,text="eq")
    cir3=cvgr.create_oval(380-rkl,200+rkl,380+rkl,200-rkl,outline="black")
    textcir3=cvgr.create_text(380,200,text="ic")
    cir4=cvgr.create_oval(200-rkl,20+rkl,200+rkl,20-rkl,outline="black")
    textcir4=cvgr.create_text(200,20,text="lt")
    cir5=cvgr.create_oval(200-rkl,380+rkl,200+rkl,380-rkl,outline="black")
    textcir5=cvgr.create_text(200,380,text="gt")
    iobjaff=obj.index(objaffected)
    xr=30
    ar1=cvgr.create_line(200,150,200,30,arrow="last",width=3,fill="red")
    ar2=cvgr.create_line(200,250,200,370,arrow="last",width=3,fill="red")
    ar3=cvgr.create_line(150,200,30,200,arrow="last",width=3,fill="red")
    ar4=cvgr.create_line(250,200,370,200,arrow="last",width=3,fill="red")
    rect1=cvgr.create_rectangle(200-xr,90+20,200+xr,90-20,fill="white")
    text_rect1_1=cvgr.create_text(200,85,text="original:   "+str(standardpsu[iobjaff][1]))
    text_rect1_2=cvgr.create_text(200,95,text="perturb: "+str(objper[iobjaff][1]))
    rect2=cvgr.create_rectangle(90-xr,200+20,90+xr,200-20,fill="white")
    text_rect2_1=cvgr.create_text(90,195,text="original:   "+str(standardpsu[iobjaff][3]))
    text_rect2_2=cvgr.create_text(90,205,text="perturb: "+str(objper[iobjaff][3]))
    rect3=cvgr.create_rectangle(310-xr,200+20,310+xr,200-20,fill="white")
    text_rect3_1=cvgr.create_text(310,195,text="original:   "+str(standardpsu[iobjaff][2]))
    text_rect3_2=cvgr.create_text(310,205,text="perturb: "+str(objper[iobjaff][2]))                            
    rect4=cvgr.create_rectangle(200-xr,310+20,200+xr,310-20,fill="white")
    text_rect4_1=cvgr.create_text(200,305,text="original:   "+str(standardpsu[iobjaff][0]))
    text_rect4_2=cvgr.create_text(200,315,text="perturb: "+str(objper[iobjaff][0]))
    controlsumorig=0
    controlsumperturbed=0
    for k in range(0,4):
        controlsumorig+=standardpsu[iobjaff][k]
        controlsumperturbed+=objper[iobjaff][k]

    text_control=cvgr.create_text(200,415,text="(Control-sum (orig): "+str(controlsumorig)+\
                                  " should be equal: Control-sum (perturbed): "+str(controlsumperturbed)+"\nshould be equal: "+str(r-1)+")")    
                   

def HDindiv():
    #brg 9.6.09,9.11.09
    global obj
    io=obj.index(objaffected)
    dq=float(eatt.get())
    iat=prop.index(attaffected)
    
    dm=rmod2.matcopy1(r,k,dm0)
    dm[io][iat]=dm0[io][iat]+dq       
            
    rred,xred,objred,obj,txt,neq=filecomp(r,dm,prop,fn,ob,k)#identifies eq.classes
    n=rred
    tpindiv=Tkinter.Toplevel(hf)
    tpindiv.title(' individ HD ')
    labeq=Tkinter.Label(tpindiv,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    lbhd1=Tkinter.Label(tpindiv,text= "Level ")
    lbhd1.pack()
    
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    cov=rmod2.cover(n,tr,lext)

    if n>70:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(tpindiv,text=" Perturbed HD "+prop[iat]+"("+str(obj[io])+")"\
                            +"  dq=  "+str(dq))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(tpindiv,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        

    
    
hf=Tkinter.Tk()
hf.title('--    pooc   -- ')
lb0=Tkinter.Label(hf,width=60)
lb0.pack()

aboutsensi=raioop2.brgabout(hf,"tp3","about_pooc.txt",6,\
        "July, 18th,2011"," about_pooc ", "white", "t2",60,3,ScrolledText)

helpHasse=raioop2.brgabout(hf,"tp4","help_pooc.txt",6,\
        "July, 18th,2011"," help_pooc ", "white", "t1",120,10,ScrolledText)

buttpreview=Tkinter.Button(hf,text="preview",width=25,command=preview)
buttpreview.pack()


                        
buttcalc=Tkinter.Button(hf,text="submit&select/open file  ",width=25,bg="cyan",command=submit)
buttcalc.pack(pady=10)
buttHD=Tkinter.Button(hf, text="HD standard case",width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
frperturb=Tkinter.Frame(hf,width=60,height=60,relief="sunken",bd=3)
frperturb.pack(pady=5)
lbentry2=Tkinter.Label(frperturb,text="Enter perturb.val.>>>")
lbentry2.grid(row=0,column=0)
eatt=Tkinter.Entry(frperturb,width=10)
eatt.grid(row=0,column=1)
lbentry3=Tkinter.Label(frperturb,text=" Enter which object is affected >>>")
lbentry3.grid(row=1,column=0)
objaff=Tkinter.Entry(frperturb,width=10)
objaff.grid(row=1,column=1)
lbentry4=Tkinter.Label(frperturb,text=" Enter which attribute (q1,q2 ... (name)> is affected  >>>")
lbentry4.grid(row=2,column=0)
attaff=Tkinter.Entry(frperturb,width=10)
attaff.grid(row=2,column=1)
                     
buttperturb=Tkinter.Button(hf,text="perturb analysis",width=25,bg="cyan",command=perturb)
buttperturb.pack()
lbwarning=Tkinter.Label(hf,text="")
lbwarning.pack()
lbwarn=Tkinter.Label(hf,text="")
lbwarn.pack()
fr=Tkinter.Frame(hf,relief="sunken",bd=2)
fr.pack(pady=10)
lbfr=Tkinter.Label(fr,text="  Individual analysis  ")
lbfr.grid(row=0,columnspan=3)
buttindiv=Tkinter.Button(hf,text="individual HD ",bg="cyan",width=25,command=HDindiv)
buttindiv.pack()
buttexit=Tkinter.Button(hf,text="  exit  ",width=25,bg="red",command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
    


