# -*- coding: cp1252 -*-
import itertools
import Tkinter
import rmod2
import raioop2
import Canvas
import tkFileDialog
from ScrolledText import *

#brg 20.10.18

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,objem,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    objem=[]
    for i in range(1,la):
        objem.append(a[i][0])

    print "objempirical = ",objem    

    countob=len(objem)

    print "Number of objects ",countob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,objem,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,objem,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    objem=[]
    for i in range(1,la):
        objem.append(a[i][0])

    print "objempirical = ",objem    

    countob=len(objem)

    print "Number of objects ",countob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,objem,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17
    global fn,r,k,x,prop,objem,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    objem=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        objem[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,objem,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,objem,rred,xred,objred,txteq
    
    r,k,x,objem,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,objem,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####


def prepare():
    global k,lp, steps, obj, prop, objdoc, tupelspace, schalt
    nind=int(enind.get())
    k = nind
    schalt=eschalt.get()
    print "schalt= ",schalt    
    print "nind= ",nind
    steps=estep.get().split(",")
    
    print "step = ",steps
    if len(steps)!=nind:
        lbwarning.config(text="+++There is an inconstency++++", bg="yellow")
    profile=[]
    for j in range(0,k):
        profile.append(0)
        profile[j]=[]
        for j1 in range(1,int(steps[j])+1):
            profile[j].append(j1-1)      #20.10.18

    print profile
    prop=[]
    if k==2:
        tupel = list(itertools.product(profile[0],profile[1]))
        list_of_pairs2 = [(item[0],item[1]) for item in tupel]
        lp = len(list_of_pairs2)
        tupelspace = []
        objdoc = []
        for i in range(0, lp):
            x1,x2=list_of_pairs2[i]
            x1s=str(x1)
            x2s=str(x2)
            objdoc.append((x1s,x2s))
            tupelspace.append([x1,x2])
        for i in range(0,k):
            indname="q"+str(i)
            prop.append(indname)
        obj=[]
        for i in range(0, lp):
            obj.append("o"+str(i))
            print obj[i],"\t",tupelspace[i][0],"\t",tupelspace[i][1]
    elif k==3:
        tupel = list(itertools.product(profile[0],profile[1],profile[2]))
        list_of_pairs2 = [(item[0],item[1], item[2]) for item in tupel]
        lp = len(list_of_pairs2)
        tupelspace = []
        objdoc = []
        for i in range(0, lp):
            x1,x2,x3=list_of_pairs2[i]
            x1s=str(x1)
            x2s=str(x2)
            x3s=str(x3)
            objdoc.append((x1s,x2s,x3s))
            tupelspace.append([x1,x2,x3])
        for i in range(0,k):
            indname="q"+str(i)
            prop.append(indname)    
        #print "merkmrm",2*"\t","q1","\t","q2","\t","q3"
        obj=[]
        for i in range(0, lp):
            obj.append("o"+str(i))
            print obj[i],"\t",tupelspace[i][0],"\t",tupelspace[i][1],"\t",tupelspace[i][2]
        
    elif k==4:
        tupel = list(itertools.product(profile[0],profile[1],profile[2],profile[3]))
        list_of_pairs2 = [(item[0],item[1], item[2],item[3]) for item in tupel]
        lp = len(list_of_pairs2)
        tupelspace = []
        objdoc = []
        for i in range(0, lp):
            x1,x2,x3,x4=list_of_pairs2[i]
            x1s=str(x1)
            x2s=str(x2)
            x3s=str(x3)
            x4s=str(x4)
            objdoc.append((x1s,x2s,x3s,x4s))
            tupelspace.append([x1,x2,x3,x4])
        for i in range(0,k):
            indname="q"+str(i)
            prop.append(indname)    
        #print "merkmrm",2*"\t","q1","\t","q2","\t","q3","\t","q4"
        obj=[]
        for i in range(0, lp):
            obj.append("o"+str(i))
            print obj[i],"\t",tupelspace[i][0],"\t",tupelspace[i][1],"\t",tupelspace[i][2],"\t",tupelspace[i][3]
    elif k==5:
        tupel = list(itertools.product(profile[0],profile[1],profile[2],profile[3],profile[4]))
        list_of_pairs2 = [(item[0],item[1], item[2],item[3],item[4]) for item in tupel]
        lp = len(list_of_pairs2)
        tupelspace = []
        objdoc = []
        for i in range(0, lp):
            x1,x2,x3,x4,x5=list_of_pairs2[i]
            x1s=str(x1)
            x2s=str(x2)
            x3s=str(x3)
            x4s=str(x4)
            x5s=str(x5)
            obj.append((x1s,x2s,x3s,x4s,x5s))
            tupelspace.append([x1,x2,x3,x4,x5])
        for i in range(0,k):
            indname="q"+str(i)
            prop.append(indname)    
        #print "merkmrm",2*"\t","q1","\t","q2","\t","q3","\t","q4","\t","q5"
        obj=[]
        for i in range(0, lp):
            obj.append("o"+str(i))
            print obj[i],"\t",tupelspace[i][0],"\t",tupelspace[i][1],"\t",tupelspace[i][2],"\t",tupelspace[i][3],"\t",tupelspace[i][4]
    elif k==6:
        tupel = list(itertools.product(profile[0],profile[1],profile[2],profile[3],profile[4],profile[5]))
        list_of_pairs2 = [(item[0],item[1], item[2],item[3],item[4],item[5]) for item in tupel]
        lp = len(list_of_pairs2)
        tupelspace = []
        objdoc = []
        for i in range(0, lp):
            x1,x2,x3,x4,x5,x6=list_of_pairs2[i]
            x1s=str(x1)
            x2s=str(x2)
            x3s=str(x3)
            x4s=str(x4)
            x5s=str(x5)
            x6s=str(x6)
            obj.append((x1s,x2s,x3s,x4s,x5s,x6s))
            tupelspace.append([x1,x2,x3,x4,x5,x6])
        for i in range(0,k):
            indname="q"+str(i)
            prop.append(indname)    
        #print "merkmrm",2*"\t","q1","\t","q2","\t","q3","\t","q4","\t","q5"
        obj=[]
        for i in range(0, lp):
            obj.append("o"+str(i))
            print obj[i],"\t",tupelspace[i][0],"\t",tupelspace[i][1],"\t",tupelspace[i][2],\
                  "\t",tupelspace[i][3],"\t",tupelspace[i][4],"\t",tupelspace[i][5]
    else:
        lbcalc.config(text="+++sorry "+str(k)+"  not implemented yet ++++",bg="yellow")    
        
def generate_mark():
    # brg 20.10.18, 22.10.18
    global mark
    if schalt=="n":
        lx=len(x)
    
        mark=[]
        for i in range(0,lp):
            flag=0
    
            for i1 in range(0,lx):
                if x[i1]==tupelspace[i]:
                    flag+=1
    
            mark.append(flag)
    
        print mark
    else:
        mark=[]
        for i in range(0, lp):
            mark.append(0)
    return mark 

            
    
def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015, 31.07.18
    #*: 13.1.08
    #akt: 31.07.18
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+objem[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=objem[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def HD(rred,k,obj,tupelspace,flag):
    # brg 26.7.2013, 29.8.2013, 2.11.16, 31.07.18, 1.8.18, 20.10.18
    if flag==1:
        mark=generate_mark()
        print "flag= ",flag
        print "mark = ",mark
    else:
        mark=rmod2.vecgen1(rred)
        print "flag= ",flag
        print "mark = ",mark
    
    global cov
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,tupelspace)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    if rred<20:        
        rmod2.matout(rred,rred,zeta)
    else:
        print "only the first twenty rows of the zeta matrix "
        for i1 in range(0,rred):
            for i2 in range(0,20):
                print zeta[i1][i2],
            print " "
    print " "        
    Utotal = rmod2.incompzeta(rred,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    print "lobj = "
    sumlevtotal = []
    countlevel=[]
    txtlevel="Level "+"\n"
    for j in range(0,len(lobj)):
        if sum(lobj[j])>=0:
            txtlevel+="Level "+str(j)+": "
            sumlevel=0
            count=0
            for j2 in range(0, len(lobj[j])):
                if lobj[j][j2]!=-1:
                    count+=1
                    txtlevel+=str(obj[lobj[j][j2]])+", "
                    for j3 in range(0,k):
                        sumlevel+=tupelspace[lobj[j][j2]][j3]
            sumlevtotal.append(sumlevel)
            countlevel.append(count)
            print " "
            txtlevel+="\n"
    print "sumlevtotal = ",sumlevtotal
    print "count of level = ",countlevel
    print "zzmax= ",zzmax
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])

        count=0
        d=14   #HD-vertex umfang
        for i in range(0,lz):
            for j in range(0,l[i]):
                #print "mark = ",mark[count]
                if mark[lobj[i][j]]==0:
                    cv.create_oval(geomx[i][j]-d,geomy[i][j]+d,geomx[i][j]+d,geomy[i][j]-d,fill="white")
                elif mark[lobj[i][j]]==1:
                    cv.create_oval(geomx[i][j]-d,geomy[i][j]+d,geomx[i][j]+d,geomy[i][j]-d,fill="grey")
                else:
                    cv.create_oval(geomx[i][j]-d,geomy[i][j]+d,geomx[i][j]+d,geomy[i][j]-d,fill="cyan")
                cv.create_text(geomx[i][j],geomy[i][j],text=obj[lobj[i][j]])
                count+=1
                
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    rred=lp
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    
def HDprop():
    # brg 20.10.18
    HD(lp,k,obj,tupelspace,1)

def HDemp():
    # brg 20.10.18
    HD(rred,k,objred,xred,0)

def showpropspace():
    #brg 20.10.18
    tpshow=Tkinter.Toplevel()
    tpshow.title(" details property space ")
    tshow=ScrolledText(tpshow,width=60,height=20)
    tshow.pack()
    txt="property space"+"\n"
    txt+="label in HD and value-combinations "+"\n"
    txt+="indicators "+"\n"
    for j in range(0,k):
        txt+=str(prop[j])+", "
    txt+="\n"
    txt+="steps: "+"\n"
    for j in range(0,k):
        txt+=str(steps[j])+", "
    txt+="\n"
    txt+=25*"- "+"\n"
    for i in range(0,lp):
        txt+="o"+str(i)+": "+str(objdoc[i])+"\n"
    txt+="\n"
    txt+="- - -  eof - - - "
    tshow.insert("end",txt)

def assign():
    #brg 22.10.18
    print "objem= ",obj
    txtass="Assignment "+"\n"
    for i in range(0,lp):
        for i1 in range(0, len(x)):
            if tupelspace[i]==x[i1]:
               
                txtass+="o"+str(i)+": "
                for j in range(0,k):
                    txtass+=str(tupelspace[i][j])+", "
                txtass+="---"+str(objem[i1])
                txtass+="\n"
    txtass+="\n"
    txtass+="- - -    e o f  - - -  "
    tpass=Tkinter.Toplevel(hf)
    tpass.title("assignment")
    tass=ScrolledText(tpass,width=60,height=20)
    tass.pack()
    tass.insert("end",txtass)
    
            
        

    
hf=Tkinter.Tk()
hf.title(' propspace ')
about=raioop2.brgabout(hf,"tp1","about_propspace.txt",3,\
            "October, the 22nd, 2018"," about propspace ", "white", "t1",80,5,ScrolledText)
help=raioop2.brgabout(hf,"tp1","help_propspace.txt",3,\
            "October, the 22nd, 2018"," help propspace ", "white", "t1",80,5,ScrolledText)

fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", width=35, command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=35, command=show_dm)
buttshow_datamatrix.pack()
buttHDemp=Tkinter.Button(hf,text="Show empirical HD ",bg="cyan",width=35,command=HDemp)
buttHDemp.pack()
lbschalter=Tkinter.Label(hf,text="Only the property space? (y,n)")
lbschalter.pack()
eschalt=Tkinter.Entry(hf,width=5)
eschalt.pack()
lb1=Tkinter.Label(hf, text="Program running...")
lb1.pack()
lbwarning=Tkinter.Label(hf,text="")
lbwarning.pack()
lbentry1=Tkinter.Label(hf,text="Enter number of indicators ")
lbentry1.pack()
enind=Tkinter.Entry(hf,width=5)
enind.pack()
lbentry2=Tkinter.Label(hf,text="Enter the number of steps\n each of the indicator has ")
lbentry2.pack()
estep=Tkinter.Entry(hf,width=10)
estep.pack()
buttprepare=Tkinter.Button(hf,text="prepare the space of properties ",width=35,bg="cyan",command=prepare)
buttprepare.pack()
buttHDmerkmal=Tkinter.Button(hf,text="HD of property space",bg="cyan",width=35,command=HDprop)
buttHDmerkmal.pack()
lbcalc=Tkinter.Label(hf,text="")
lbcalc.pack()
buttshowpropspace=Tkinter.Button(hf,text="show property space ",bg="cyan",width=35,command=showpropspace)
buttshowpropspace.pack()
buttassign = Tkinter.Button(hf, text="Assign empirical objectsto patterns ",bg="cyan",width=35, command=assign)
buttassign.pack()
buttexit=Tkinter.Button(hf,text="exit",width=10, bg="red",bd=4,command=hf.destroy)
buttexit.pack()
hf.mainloop()
