import rmod2
import raioop2
import Pycluster
import Tkinter
import tkFileDialog
from ScrolledText import ScrolledText


# brg 28.10.2012
def selopfile():
    # brg 28.10.2012
    global fn, obj, prop, r,k, xred,rred,objred
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lb1.config(text="opened "+fn+ "\nwith "+str(r)+"rows and "+str(k)+" columns" ,bg="yellow")
    

    prop=[]
    for j in range(0,k):
        prop.append(pro[j+1])
            
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,r):
        obj[i]=ob[i+1]

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)

def seloppdtfile():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3)
    # source: mainHD19
    global fn,r,k,dm,prop,obj,rred,xred,objred
    fn=tkFileDialog.askopenfilename()
    r,k,dm,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)
    
    

def showDM():
    # brg 28.10.2012, taken from antag2.py
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=10)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    
def showpdtdm():
    # 29.10.2012
    txt="show pdt-file "+"\n"
    txt+="objects: "
    for i in range(0,r):
        txt+=str(obj[i])+", "
    txt+="\n"    
    txt+="attributes "
    for j in range(0,k):
        txt+=str(prop[j])+", "
    txt+="\n"
    txt+="data matrix "+"\n"
    for i in range(0,r):
        for j in range(0,k):
            txt+=str(round(dm[i][j],3))+", "
        txt+="\n"
    txt+="\n"
    txt+="\n - - -  e o f - - -"
    tppdtshow=Tkinter.Toplevel(hf)
    tppdtshow.title(' pdt file ')
    tpdtshow=ScrolledText(tppdtshow,width=80, height=10)
    tpdtshow.pack()
    tpdtshow.insert("end",txt)
    
            
    
def HD():
    # brg 28.10.2012 from HDsimpl1.py
    #
    freq=Tkinter.Toplevel(hf)
    freq.title(' HD full matrix ')
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


def cluster():
    # brg 28.10.2012
    global clobj,dmcluster,ncl
    try:
        ncl=int(ecl.get())
    except:
        ncl=2

    try:
        dimeth=emeth.get()
    except:
        dimeth="e"

    try:
        clumeth=eclu.get()
    except:
        clumeth="a"

    try:
        npstepact=int(enstep.get())
    except:
        npstepact=1

    print dimeth, clumeth, npstepact    
    tpcluster=Tkinter.Toplevel(hf)
    tpcluster.title(' Cluster-info ')
    tcluster=ScrolledText(tpcluster,width=80,height=10)
    tcluster.pack()
    txt="cluster information "+"\n"
    txt+=70*"="+"\n"
    txt+="Method: Kmeans"+"\n"
    txt+="Number of clusters "+str(ncl)+"\n"
    txt+="Iterations "+str(npstepact)+"\n"
    
    txt+="distance-method"+"\t"
    if dimeth=="c":
        txt+=" correlation"
    elif dimeth=="s":
        txt+=" Spearmans rank correlation"
    elif dimeth=="e":
        txt+="Average of squared Euclidian "
    else:
        txt+="City block distance "
    txt+="\n"
    txt+=" Cluster method (Kmeans)"+"\n"
    if clumeth=="a":
        txt+="arithmetic mean"
    else:
        txt+="median "
    txt+="\n"
    
    
    clusteract,error,nfound=Pycluster.kcluster(xred,nclusters=ncl,mask=None,weight=None,transpose=0,npass=npstepact,\
                                method=clumeth,dist=dimeth,initialid=None)
    clobj=[]
    for i in range(0,ncl):
        clobj.append("cl_"+str(i))

    txt+="Results "+"\n"
    txt+="Error "+str(round(error,4))
    for i in range(0,r):
        txt+=str(clusteract[i])
    txt+="\n"    
    txt+="clusternames and assignments"+"\n"
    txt+=70*"-"+"\n"
    for i in range(0,ncl):
        txt+=str(clobj[i])+": "+"\t"
        for j in range(0,r):
            if clusteract[j]==i:
                txt+=str(obj[j])+", "
        txt+="\n"
    txt+="\n"
     
        
    cd,cm=Pycluster.clustercentroids(xred,mask=None,clusterid=clusteract,method=clumeth,transpose=0)

    
    
    dmcluster=rmod2.marray(ncl,k)
    for i in range(0,ncl):
        for j in range(0,k):
            dmcluster[i][j]=cd[i][j]
            

    rmod2.matout(ncl,k,dmcluster)

    txt+="Centers of the "+str(ncl)+"  clusters "+"\n"
    txt+=70*"-"+"\n"
    for i in range(0,ncl):
        txt+=str(clobj[i])+"\t"
        for j in range(0,k):
            txt+=str(round(dmcluster[i][j],3))+", "
            
        txt+="\n"
    txt+="\n"
    txt+="    - - -  e o f - - - "+"\n"
    tcluster.insert("end",txt)



    
def HDcluster():
    # brg 29.10.2012
    try:
        ncl=int(ecl.get())
    except:
        ncl=2
    freqc=Tkinter.Toplevel(hf)
    freqc.title(' HD cluster matrix ')
    rredc,xredc,objredc,txtc,neqc=rmod2.equivcompactm(ncl,k,dmcluster,clobj)  
    zetahilfc=rmod2.comp(rredc,k,xredc)  #zeta matrix with col<row
    zetac=rmod2.marray(rredc,rredc)
    for i in range(0,rredc):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rredc):
            zetac[i][j]=zetahilfc[j][i]
    #
    #One linear extension (based on levels)
    
    lobjc,lextc,revlextc,zzmaxc=rmod2.levtopsort(rredc,zetac)
       
    levmaxc=-10**20     #20.6.08
    for i in range(0,zzmaxc):
        if len(lobjc[i])>=levmaxc:
            levmaxc=len(lobjc[i])
       
    #Adj-Listen

    adjcc=rmod2.adjacent(rredc,lextc,revlextc,zetac)
        
    #Transitive reduced relations
    tsc,trc=rmod2.trreduct(rredc,adjcc,lextc)
       
    
    covc=rmod2.cover(rredc,trc,lextc)

    if rredc>70:
        lbhd3c=Tkinter.Label(freqc,text=" +++too many objects ++++  ",bg="yellow")
        lbhdc3.pack()                  
    else:
        lbhd3c=Tkinter.Label(freqc,text=" Hasse Diagram  ")
        lbhd3c.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rredc,levmaxc,zzmaxc)
        cv=Tkinter.Canvas(freqc,width=actwidth,height=actheight,bg="white")
        
        lz=zzmaxc
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobjc[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rredc,rredc)
        geomy=rmod2.marray(rredc,rredc)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covc[lobjc[i1][j1]][lobjc[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-12,geomy[i][j]+12,geomx[i][j]+12,geomy[i][j]-12,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredc[lobjc[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()



def sto_pdt():
    # brg 17.8.2012, taken from discretiz3.py
    #brg  31.5.09, 1.6.09, 30.10.2012
    fnpdt=tkFileDialog.asksaveasfilename(parent=hf,title="save dm as pdt-file")
    rmod2.raiwrite5(fnpdt,dmcluster,clobj,prop,ncl,k)
    import tkMessageBox
    tkMessageBox.showinfo(title="store pdt",message="successafull!")    



hf=Tkinter.Tk()
lbcluster=Tkinter.Label(hf,text=" Clusteranalysis (needed Pycluster!!) ",width=50)
lbcluster.pack(pady=5)
helppycluster=raioop2.brgabout(hf,"tp1","help_pycluster.txt",1,\
            "October, the 29th,2012"," help_pycluster ", "white", "t1",80,5,ScrolledText)
    
aboutpycluster=raioop2.brgabout(hf,"tp1","about_pycluster.txt",1,\
            "October, the 29th,2012"," about_pycluster ", "white", "t1",80,5,ScrolledText)    

wb=30
lb1=Tkinter.Label(hf,text=" ")
lb1.pack()
lbpdtopen=Tkinter.Label(hf,text=" ")
lbpdtopen.pack()
fropen=Tkinter.Frame(hf,bd=2,relief="sunken")
fropen.pack()
buttselop=Tkinter.Button(fropen,text="select and open file ",bg="cyan",width=wb, command=selopfile)
buttselop.pack(side="left")
buttselppdtop=Tkinter.Button(fropen, text="select and open pdt-file",bg="cyan",width=wb, command=seloppdtfile)
buttselppdtop.pack(side="right")
frshow=Tkinter.Frame(hf,bd=2,relief="sunken")
frshow.pack()
buttshowdm=Tkinter.Button(frshow,text="show data matrix ",bg="cyan",width=wb,command=showDM)
buttshowdm.pack(side="left")
buttshowpdt=Tkinter.Button(frshow, text="Show pdt-File ",bg="cyan",width=wb,command=showpdtdm)
buttshowpdt.pack(side="right")
buttHD=Tkinter.Button(hf,text="HD full dm ",bg="cyan",width=wb,command=HD)
buttHD.pack()
frmeth=Tkinter.Frame(hf,bd=2,relief="sunken")
frmeth.pack()
lb2=Tkinter.Label(frmeth,text="read in: number of clusters (default=1)",bg="white")
lb2.grid(row=0,column=0)
ecl=Tkinter.Entry(frmeth,width=5)
ecl.grid(row=0,column=3)
lb3=Tkinter.Label(frmeth,text="     readin distance method(c,s,e,b)    ",bg="white")
lb3.grid(row=1,column=0)
emeth=Tkinter.Entry(frmeth,width=1)
emeth.grid(row=1,column=3)
lb4=Tkinter.Label(frmeth,text="     Kmeans clustering method (a,m)    ",bg="white")
lb4.grid(row=2,column=0)
eclu=Tkinter.Entry(frmeth,width=1)
eclu.grid(row=2,column=3)
lb4=Tkinter.Label(frmeth,text="   number iteration steps (default=1, variation recommended  ",bg="white")
lb4.grid(row=3,column=0)
enstep=Tkinter.Entry(frmeth,width=5)
enstep.grid(row=3,column=3)
buttcluster=Tkinter.Button(hf,text="cluster ",bg="cyan",width=wb,command=cluster)
buttcluster.pack()
buttHDcluster=Tkinter.Button(hf,text="cluster-HD ",bg="cyan",width=wb,command=HDcluster)
buttHDcluster.pack()
buttsto_pdt=Tkinter.Button(hf,text="save cluster-matrix as pdt-file",bg="cyan",width=wb,command=sto_pdt)
buttsto_pdt.pack()
buttexit=Tkinter.Button(hf,text=" exit ",bg="red",width=wb, command=hf.destroy)
buttexit.pack()



hf.mainloop()    
