# -*- coding: cp1252 -*-
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
#import pylab

#Brg 17.1.08 sensi3.py with graphics, 4.2.08
#Brg 19.2.08: daughter-windows with titles
#Brg 19.2.08: try..except..routine in single object analysis
#Brg 8.6.08: If the object doesn't exist the procedure 'object specific analysis'
#            is jumping to its end
#Brg 8.6.08: The modules 'HD' and 'filecomp' are included. So a HD can be displayed
# Brg 26.7.08: New result-presentation for attribute's sensitivity
# Brg 16.8.08: The cases and their HD
# Brg 16.8.08 : Help and about text by OOP-class
# Brg 18.9.08 (PSU) Implementation: Ranking Precision Graph (RPG) and other types
#              of graphs
# Brg 19.9.08: to be done: a) help and about texts
#                          b) HD only on request
#                          c) HDs of cases on request
#                          d) Graphic buttons, like to get RPG only one at a time
# brg 4.10.08 Sensitivity of attributes as weights to get a data driven ranking
# Brg 15.10.08 Bar diagram of sensitivities
# Brg 20.10.08 sensi10: Objectspecific analysis an own window
# Brg 19.11.08 porgraph-procedure reworked
# Brg 15.3.09 pylab eliminated and replaced by a bar-diagram from raioop2
# Brg  3.4.09 The combination IC EQ eliminated
# Brg 17.2.10 better descriptions in local analysis
# Brg 24.2.10 HD background: white
# Brg 26.3.10 sensi13: Cases only on request, new: diagrams of canonical sequence
# Brg 13.6.10 brgbar2 gegen brgbar6 ausgetauscht.
# Brg 23.6.10 MRG now directly selectable
# Brg 11.7.10 Now PyHasse-formatted files can be read
# Brg 6.8.10 Version 16: IB decomposition , sorted dm according to W(q) is available
#             as PyHasse-formatted file
# Brg 3.9.10 Version 17, some changes (store decomposition, U1/U2)
# Brg 6.12.2010 outcomment of cover_show in case of decomposition
# Brg 8.12.2010 better fit to laptop formats: sensi18_2
# Brg 14.4.2011: New name sensitivity18_2.py (identical with sensi18_2.py)
# Brg 18.8.2011 sensitivity18_3.py: Ticker in MRG- and other graphs. severe bug MRG was wrong. Now corrected
# Brg 1.12.2012: Equivalence classes and better description of case selection and attribute set selection
# Brg 9.6.2013 changes in extract (objec now dynamically generated
# Brg 9.6.2013  and around line 558: n replaced by ncase where the zeta-matrix is calculated from zeta1
# Brg 26.1.2014 bug in HDscan eliminated, now the complete functionality is available for pdt too
# brg 4.2.2014 Behavior of CAM-graph. A rounding problem?
# brg 8.11.2014 sensitivitybased CI for representative and then for all elements of object set
# brg 13.3.2016: Version 22: Comparison based on incomparabilities and cosmetics
# brg 6.6.16: Equivalence classes in a separate window
# brg 24.03.18: Am-curves according to user - defined sequences
# brg 26-03.18: about - and help improved

def sf(fn,dmn,obj,prop,r,k):
    #brg  31.5.09, 1.6.09
    # 4.8.10: Fuer die geplante Ausgabe der nach Wichtigkeit geordneten dmn
    # 6.8.10 modification: Ausgabe des Filenamens
    # 3.9.2010: Umbau zu procedure with parameterlist
    # brg  30.5.09
    for i in range(0,r):
        print obj[i]," ",
    print " "
    flag=0
    try:
        rmod2.raiwrite5(fn,dmn,obj,prop,r,k)
        flag=1
    except:
        flag=0
    return flag

def sf2():
    #brg  31.5.09, 1.6.09
    # 4.8.10: Fuer die geplante Ausgabe der nach Wichtigkeit geordneten dmn
    # 6.8.10 modification: Ausgabe des Filenamens
    # 3.9.10 Korrektur fn1 --> fn2
    fn1=tkFileDialog.asksaveasfilename(parent=hf,title="save file1")
    fl1=sf(fn1,dm1,obj,prop1,r,k1)
    fn2=tkFileDialog.asksaveasfilename(parent=hf,title="save file2")
    fl2=sf(fn2,dm2,obj,prop2,r,k2)
    fl=fl1*fl2
    if fl>0:
        txtstore="matrices with \n"+str(r)+"  rows  and "+str(k1)+" columns \n stored in file1: \n"+fn1
        txtstore+="\n  and "+str(r)+"  rows and "+str(k2)+" columns \n stored in file2: \n"+fn2
    else:
        txtstore="+++ unfortunately not successful +++ "
    lbsuccess.config(text=txtstore,bg="yellow")



def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,ob,obj,pro,prop,r,k,fn,rred,xred,objred,txt,n,flagpdtorExcel
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin6(fn)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    rred,xred,objred,obj,prop,txt=filecomp(r,dm,pro,fn)
    flagpdtorExcel="Excel"
    n=rred
    return 

def fileselect_PyHasse():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    #* 1.6.09
    # akt. 11.7.10 (taken from mainHD19 and modified
    # source: mainHD19
    global fn,r,k,dm,pro0,prop, on,ob,obj,xred,rred,objred,txt,n, flagpdtorExcel
    fn=tkFileDialog.askopenfilename()
    r,k,dm,obj,prop=rmod2.raireadin5(fn)
    print "control in fileselect_PyHasse"
    print "obj = ",obj
    print "prop = ",prop
    print "r= ",r
    print "k= ",k
    pro0=rmod2.vecgentext1(k)
    pro0[0]="prop"              #this 3 lines construction needed because attsel needs pro0
    for j in range(1,k):
        pro0[j]=prop[j-1]
    #print "in mainHD = : r= ",r,"  k= ",k0
    ob=rmod2.vecgentext1(r+1) #this 3 lines construction needed because filecomp needs ob
    ob[0]="dummy"
    for i in range(1,r+1):
        ob[i]=obj[i-1]
    
    lbopen.config(bg="yellow")
    lbopen["text"]="selected file (PyHasse format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)
    print "rred= ",rred
    n=rred
    flagpdtorExcel="pdt"
    return 



def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def filecomp(r,dm,pro,fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08, 13.3.2016
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global U0,xred
    dm,ob,pro,r,k=rmod2.EXCELreadin6(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    zetah0=rmod2.comp(r,k,dm)
    U0 = rmod2.vecgen1(r)
    for i1 in range(0,r):
        for i2 in range(0,r):
            if zetah0[i1][i2]==0 and zetah0[i2][i1]==0:
                U0[i1]+=1
    print "U0 = ",U0            
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    print txt
    return rred,xred,objred,obj,prop,txt           


def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 8.6.08, 13.3.16 
    global zeta,zeta2,rred,n,r,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=600,height=600)
    freq.pack()
    global fn
    
    
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(rred,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    U=0
    for i in range(0,rred):
        for j in range(0,rred):
            if zeta[i][j]==0 and zeta[j][i]==0:
                U+=0.5

    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>100:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=600,height=600,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(320.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(320.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=580
        garrow1y=20
        garrow2y=580
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cvt=cv.create_text(295,590,text="U = "+str(U))
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def cover_showcase(i,n,cov12,objred):  #1.12.2012 zeta2 replaced by cov12, new in parameterlist: n
    """Cover-matrix is displayed"""
    #brg 28.12.07, 16.8.08, 1.12.2012
    #*28.12.07
    #akt 16.8.08, 1.12.2012
    #note: -
    #source: cover_show
    tpHDcasecover=Tkinter.Toplevel(hf)  #1.12.2012
    tpHDcasecover.title(' cover-matrix ')
    lbhd2=Tkinter.Label(tpHDcasecover,text=" Cover-Relations  case:" + str(i))
    lbhd2.pack()
    print "cov12 in cover_showcase"
    print "n= ",n
    print "i (selection of case ):",i
    rmod2.matout(n,n,cov12)
    txt3="\n cover-matrix  \n"
    for ix in range(0,n):
        txt3+="\n"+objred[ix]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if ix!=j:
                if cov12[ix][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(tpHDcasecover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
        
def extract2(r,zetah,i,tpcase,flcase):
    """extracts from the crisp matrix the order relations"""
    #brg 30.11.07, 11.4.08, 16.8.08 taken from fuzzyHD10, 4.10.08
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    ec=rmod2.dmcompress(r,r,zetah)             #30.11. from cq the equivalent relations
    eqtext=""
    eqtext+=rmod2.eqcguiout1(r,ec,obj)        #30.11. matrix output
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    #print "======================================="
    #print " Control in extract (ex) "
    #print "======================================="
    ltxt=len(txt)
    #print "ex1: ec : ",ec
    #print "ex1: txt , ltxt",txt," ",ltxt
    
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    if b=="true":
        texteq="No equivalent objects in case "+str(i)
    else:
        texteq="Case "+str(i)+": Equivalent objects"
    if flcase!=0:
        lbhfeq=Tkinter.Label(tpcase[i-1],text=texteq)
        lbhfeq.pack()
        if b!="true":
            teq=ScrolledText(tpcase[i-1],width=60,height=3)
            teq.pack()
            teq.insert("end",eqtext)
        
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,zetah) # columns eliminated
    zeta,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
        #print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        #print "ex5: rs = ",rs
    return zeta,objec,rs


def extractcase(r,zetah):
    """extracts from the crisp matrix the order relations"""
    #brg 30.11.07, 11.4.08, 16.8.08 taken from fuzzyHD10, 4.10.08
    # modified from extract: 4.10.08
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    ec=rmod2.dmcompress(r,r,zetah)             #30.11. from cq the equivalent relations
    eqtext=""
    eqtext+=rmod2.eqcguiout1(r,ec,obj)        #30.11. matrix output
    #print "r  = ",r
    print "eqtext = ",eqtext
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    print "======================================="
    print " Control in extract (ex) "
    print "======================================="
    ltxt=len(txt)
    print "ex1: ec : ",ec
    print "ex1: txt , ltxt",txt," ",ltxt
    
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    
        
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,zetah) # columns eliminated
    zeta,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        print "conobj = ",conobj    
        
        objec=[]   #9.6.2013
        for ob in obj:    #9.6.2013
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if ob not in conobj:
                objec.append(ob)     #9.6.2013
        rs=len(objec)               #9.6.2013      
        print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        print "ex5: rs = ",rs
    return zeta,objec,rs,eqtext

def HDcase():
    #Brg 4.10.08, 13.3.2016, 6.6.16, 24.03.18
    #The execution of this commands needs that one step before
    #the sensitivity analysis was performed (Brg 26.3.2010)
    #Ucase will be calculated and made available
    global Ucase, caseact, eqtextact, caseactual
    caseactual=ecase.get()
    caseact=int(caseactual)
    
        
    tpHDcase=Tkinter.Toplevel(hf)
    tpHDcase.title(' case specific HDs ')
    txtcase="attribute numbers: "
    txtwarn=""
    
    lbwarn=Tkinter.Label(tpHDcase,text=txtwarn)
    lbwarn.pack()
    print "prop= ",prop
    if caseact>k or caseact==0:
        txtwarn="++Please select a number <= "+str(k)+"  and >0"
        lbwarn.config(text=txtwarn,bg="yellow")
    else:
        txtwarn="case is ok"
        lbwarn.config(text=txtwarn,bg="white")
        for i1 in range(0,k):
            if case[caseact][i1]!=-1:
                txtcase+=str(prop[i1])+" "
        lbcase=Tkinter.Label(tpHDcase,text=txtcase,bg="yellow",width=60)
        zetah=rmod2.comp3(r,k,case,caseact,dm)
        Ucase=rmod2.vecgen1(r)
        for i1 in range(0,r):
            for i2 in range(0,r):
                if zetah[i1][i2]==0 and zetah[i2][i1]==0:
                    Ucase[i1]+=1      #3.5.16
        print "Ucase= ",Ucase
        print "zetah "
        rmod2.matout(r,r,zetah)
        zeta1case,objredcase,ncase,eqtextact=extractcase(r,zetah)#1.12.2012 objred replaced by objredcase, n replaced by ncase
        print "In HDcase:  objredcase ",objredcase
        print "In HDcase ncase: ",ncase
        print " eqtextact  ",eqtextact
        print "  "
        print "zeta1 "
        rmod2.matout(ncase,ncase,zeta1case)
        print " "
        zetacase=rmod2.marray(ncase,ncase)    #9.6.2013 n replaced by ncase, zeta replaced
        # by zetacase
        for i2 in range(0,ncase):
            for i3 in range(0,ncase):
                zetacase[i2][i3]=zeta1case[i3][i2]
                
        lobj,lext,revlext,zzmax=rmod2.levtopsort(ncase,zetacase)
            
        #Adj-Listen

        adjc=rmod2.adjacent(ncase,lext,revlext,zetacase)
            
        #Transitive reduced relations
        ts,tr=rmod2.trreduct(ncase,adjc,lext)
           
        
        zeta2case=rmod2.cover(ncase,tr,lext) #1.12.202 zeta2case
        print "zeta2case in HDcase "
        Ucase_spec=rmod2.incompzeta(ncase,zetacase)
        print "Ucase nach incompzeta ", Ucase_spec
        rmod2.matout(ncase,ncase,zeta2case)
        if ncase>300:
            cover_show()                  #20.1.08
        else:
            lbhd3=Tkinter.Label(tpHDcase,text=" Hasse Diagram case "+txtcase+" Incomp: "+str(Ucase_spec))
            lbhd3.pack()
            cv=Tkinter.Canvas(tpHDcase,width=600,height=600,bg="white")
            lz=zzmax
            l=rmod2.vecgen1(lz)
            for i8 in range(0,lz):
                l[i8]=len(lobj[i8])

            pos=rmod2.vecgen1(lz)
            for i9 in range(0,lz):
                pos[i9]=l[i9]
            
            geomx=rmod2.marray(ncase,ncase)
            geomy=rmod2.marray(ncase,ncase)

            geom0x=10
            geom0y=20
            for i4 in range(0,lz):
                for j in range(0,l[i4]):
                    geomx[i4][j]=geom0x+(320.0/(pos[i4]+1.0))*(j+1)
                    geomy[i4][j]=geom0y+(320.0/lz)*i4
                

            for i4 in range(0,lz-1):
                for j in range(0,l[i4]):
                    for i1 in range(i4+1,lz):
                        for j1 in range(0,l[i1]):
                            if zeta2case[lobj[i1][j1]][lobj[i4][j]]==1:  #1.12.2012 zeta2case
                                cv.create_line(geomx[i4][j],geomy[i4][j],geomx[i1][j1],geomy[i1][j1])


            for i5 in range(0,lz):
                for j in range(0,l[i5]):
                    cv.create_oval(geomx[i5][j]-10,geomy[i5][j]+10,geomx[i5][j]+10,geomy[i5][j]-10,fill="white")
                    cv.create_text(geomx[i5][j],geomy[i5][j],text=objredcase[lobj[i5][j]])
            garrow1x=580
            garrow1y=20
            garrow2y=580
            cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
            cv.create_text(garrow1x+8,garrow1y-6,text="high")
            cv.create_text(garrow1x+8,garrow2y+6,text="low")
            cv.create_text(200,520,text="Equivalence classes ")
            cv.create_text(200,540,text=eqtextact)   #1.12.2012
            cv.pack()
            cover_showcase(caseact,ncase,zeta2case,objredcase)  #1.12.2012 objred--> objredcase, ncase as parameter
            show_eqclasses()

def show_eqclasses():
    # brg 6.6.16
    tpeqcase=Tkinter.Toplevel(hf)
    tpeqcase.title(' Equivalence classes ')
    teqcase=ScrolledText(tpeqcase,width=80, height=10)
    teqcase.pack()
    txt="Equivalence classes of case "+str(caseactual)+"\n"
    txt+=eqtextact+"\n"
    teqcase.insert("end",txt)
    
def show_single_ranking(j):
    # brg 19.07.2017
    print "indicator ",prop[j],"   selected"
    indic=[]
    for i in range(0,rred):
        indic.append(xred[i][j])
    print "indicator ",prop[j],"  vector"
    indicsort,ysort,nsort=rmod2.brgsort(indic)
    txt="increasing sequence due to indicator "+str(prop[j])+"\n"
    for i in range(0,rred):
        if i<rred-1:
            txt+=objred[nsort[i]]+"< "
        else:
            txt+=objred[nsort[i]]+" "
    txt+="\n"
    tpsortsingle=Tkinter.Toplevel(hf)
    tsortsingle=ScrolledText(tpsortsingle,width=80,height=20)
    tsortsingle.pack()
    tsortsingle.insert("end",txt)
    
    

def HDcanseq():
    #Brg 4.10.2008
    #Brg 26.3.2010
    # Brg 1.12.2012
    # brg 6.2.2014
    # brg 6.6.16
    # brg 19.7.17
    global k, attrib,txteq,zeta2, objredcs,rredcs
    attlisttest=[]
    for j in range(0,k):
        attlisttest.append(str(j))
        
    attribtxt=eattrib.get().split(",")
    print "selected attributes ",attribtxt
    print "only one attribute ",attribtxt[0]
    #  routine to check the correct selection 
    flagcheck=0
    for jtest in attribtxt:
        if jtest not in attlisttest:
            flagcheck=1
            break
        else:
            flagcheck=0
       
            
    if flagcheck==1:
        lbpropsel.config(text=" +++ wrong selection, please check your input +++",bg="yellow")
    else:
        lbpropsel.config(text=" correct selection ")

    flagcheck=0
    # end of the check-routine
    kact=len(attribtxt)
    print "kact = ",kact
    attrib=rmod2.vecgen1(kact)
    for i in range(0,kact):
        attrib[i]=int(attribtxt[i])
    print "attributes ",attrib    
    rred,xred,objred,txt=rmod2.equivcompact(r,k,dm,obj)
    print "rred= ",rred

    txtcs,dmnewcs=rmod2.newmatrix(r,k,dm,attrib)
    print "textcs ",txtcs
    print "Matrix corrsponding the attribute combin. selected "
    rmod2.matout(r,kact,dmnewcs)
    txtuser=""
    for i in range(0,kact):
        txtuser+=str(attrib[i])+", "

    rredcs,xredcs,objredcs,txt1,txt2=rmod2.equivcompact3(r,kact,dmnewcs,obj)
    #print "r eingelesen ",r,"  rredcs = ",rredcs
    txteq=rmod2.eqclassesread2(r,obj,txt2)
    #print txteq
    #print "equivcompact extralist  ",txt1
    #print "equivcompact3 eqlist ",txt2
    zeta1=rmod2.comp(rredcs,kact,xredcs)
    #rmod2.matout(rredcs,rredcs,zeta1)
    n=rredcs
    zeta=rmod2.marray(n,n)
    for i2 in range(0,n):
        for i3 in range(0,n):
            zeta[i2][i3]=zeta1[i3][i2]

    ucanseq=0
    for i in range(0,n):
        for i1 in range(0,n):
            if zeta[i][i1]==0 and zeta[i1][i]==0:
                ucanseq+=0.5
            
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
        
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>300:
        show_coverattlist()                  #20.1.08, 6.6.16
    else:
        tpcs=Tkinter.Toplevel(hf,width=300,height=300)
        lbhd3=Tkinter.Label(tpcs,text=" Hasse Diagram user selection "+txtuser)
        lbhd3.pack()
        cv=Tkinter.Canvas(tpcs,width=600,height=600,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i8 in range(0,lz):
            l[i8]=len(lobj[i8])

        pos=rmod2.vecgen1(lz)
        for i9 in range(0,lz):
            pos[i9]=l[i9]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i4 in range(0,lz):
            for j in range(0,l[i4]):
                geomx[i4][j]=geom0x+(320.0/(pos[i4]+1.0))*(j+1)
                geomy[i4][j]=geom0y+(320.0/lz)*i4
            

        for i4 in range(0,lz-1):
            for j in range(0,l[i4]):
                for i1 in range(i4+1,lz):
                    for j1 in range(0,l[i1]):
                        if zeta2[lobj[i1][j1]][lobj[i4][j]]==1:
                            cv.create_line(geomx[i4][j],geomy[i4][j],geomx[i1][j1],geomy[i1][j1])


        for i5 in range(0,lz):
            for j in range(0,l[i5]):
                cv.create_oval(geomx[i5][j]-10,geomy[i5][j]+10,geomx[i5][j]+10,geomy[i5][j]-10,fill="white")
                cv.create_text(geomx[i5][j],geomy[i5][j],text=objredcs[lobj[i5][j]])
        garrow1x=580
        garrow1y=20
        garrow2y=560
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.create_text(geom0x+200,garrow2y+10,text="equiv. cl.: "+txteq,font=("Arial",8))
        cv.create_text(geom0x+200,garrow2y,text="U= "+str(ucanseq))   #Baustelle 06022014
        cv.pack()
        show_eqclassesattlist()
        show_coverattlist()
        if kact==1:
            show_single_ranking(int(attribtxt[0]))

def show_eqclassesattlist():
    #brg 6.6.16
    tpeq2classes=Tkinter.Toplevel(hf)
    tpeq2classes.title('Equivalenceclasses \n according to attribute-selection ')
    teq2classes=ScrolledText(tpeq2classes,height=10,width=80)
    teq2classes.pack()
    txt="Equivalenceclasses according to the selected attributelist"+"\n"
    for j in attrib:
        txt+=str(prop[j])+"\t"
    txt+="\n"
    txt+=txteq
    teq2classes.insert("end",txt)
    
def show_coverattlist():
    #brg 6.6.16
    tpcoverattlist=Tkinter.Toplevel(hf)
    tpcoverattlist.title(' cover-matrix according to your list of attributes ')
    tcoverattlist=ScrolledText(tpcoverattlist,height=10, width=80)
    tcoverattlist.pack()
    txt3="\n cover-matrix  \n"
    txt3+="according to your selection of attributes "+"\n"
    for j in attrib:
        txt3+=str(prop[j])+"\t"
    txt3+="\n"    
    for i1 in range(0,rredcs):
        txt3+="\n"+objredcs[i1]+":\t"
        txt3+="is covered by "
        for i2 in range(0,rredcs):
            if i1!=i2:
                if zeta2[i1][i2]==1:
                    txt3+=" "+objredcs[i2]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcoverattlist.insert("end",txt3)
    
    
        
def infocase():
    # brg 1.12.2012
    tpinfocase=Tkinter.Toplevel(hf)
    tpinfocase.title(' Info Cases ')
    tinfocase=ScrolledText(tpinfocase,width=80,height=10,bg="yellow")
    tinfocase.pack()
    txtic=" Info about cases "+"\n"
    txtic+=60*"="+"\n"
    for j in range(0,k+1):
        txtic+="case No "+str(j)+": "
        for j1 in range(0,k):
            if case[j][j1]!=-1:
                txtic+=str(prop[j1])+", "
        txtic+="\n"
    txtic+="\n"
    txtic+=" - - -  e o f - - - "
    tinfocase.insert("end",txtic)


def prophelp():
    # brg 1.12.2012
    tpprop=Tkinter.Toplevel(hf)
    tprop=ScrolledText(tpprop,width=80,height=10,bg="yellow")
    tprop.pack()
    txtph="Correspondence list attribute's name vs column number "+"\n"
    txtph+=60*"="+"\n"
    for j in range(0,k):
        txtph+=str(prop[j])+"  corresponds with "+str(j)+"\n"
    tprop.insert("end",txtph)    
    
def calc():
    """calculates sensitivity """
    #Brg 17.1.08, 16.8.08, 24.03.18
    #*17.1.08
    #akt: 16.8.08, 13.3.16, 5.8.16, 24.03.18
    #note: 
    #source:    main body taken from sensi1.py
    flcase=0

    global di,disort,prot,newcase,inco,utot,pib,n,case
    case=rmod2.preparcases(k)
    print "case = ",case, "   prop= ",prop
    di=rmod2.vecgen1(k+1)
    disort=rmod2.vecgen1(k+1)
    di[0]=0
    #di is the distance vector based on zeta-matrix-comparisons
    zeta0=rmod2.comp(r,k,dm)
    tpcase=rmod2.vecgen1(k)   #16.8.08
    
    for i in range(1,k+1):
        zetah=rmod2.comp3(r,k,case,i,dm)  #zetah may contain equivalent rows/columns
        if flcase!=0:
            tpcase[i-1]=Tkinter.Toplevel(hf)
            tpcase[i-1].title(' case = '+str(i))
            txtcase="attribute numbers: "
        
            for i1 in range(0,k):
                if case[i][i1]!=-1:
                    txtcase+=str(prop[i1+1])+" "
                
            lbcase=Tkinter.Label(tpcase[i-1],text=txtcase)
            lbcase.pack()
        zeta1,objred,n=extract2(r,zetah,i,tpcase,flcase)  #important step, modified procedure: 4.10.08
        zeta=rmod2.marray(n,n)
        for i2 in range(0,n):
            for i3 in range(0,n):
                zeta[i2][i3]=zeta1[i3][i2]
                
        lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
        if flcase!=0:
            tlev=ScrolledText(tpcase[i-1],width=60,height=4)
            tlev.pack()
            txt1="\n"
            for i7 in range(0,zzmax):
                txt1+="Level "+str(zzmax-i7)+" :"
                for j in range(0,len(lobj[i7])):
                    txt1+= objred[lobj[i7][j]]+" "
                txt1+="\n"    
            txt1+="\n\n  -- end --"        
            tlev.insert("end",txt1)

            txt2="\n One linear extension \n\n"
            for i7 in range(0,n):
                if i7<n-1:
                    txt2+=objred[revlext[i7]]+" < "
                else:
                    txt2+=objred[revlext[i7]]+"\n"
            txt2+="\n"
            txt2+="\n -- end of list -- "
            tlinext=ScrolledText(tpcase[i-1],width=60, height=2)
            tlinext.pack()
            tlinext.insert("end",txt2)
        di[i]=rmod2.posetdistanz(r,zeta0,zetah)
              
    print "Distances: ",di   ## muss als Ergebnis dargestellt werden 
    
    # Outside of i-loop
    # 15.10.08
    #print "k = ",k,"   di = ",di
    dibar=rmod2.vecgen1(k)
    for i in range(1,k+1):
        dibar[i-1]=di[i]
    #print "dibar = ",dibar
    prop1=rmod2.vecgen1(k)
    for j in range(0,k):
        prop1[j]=prop[j]  #necessary because in brgbar8 prop will be overwritten
    
    gr=raioop2.brgbar8(hf,dibar,prop1,"sensitivity")
    
    gr.ausgabe()
    ##################################################################################################
    disort,prot=rmod2.raisort(k+1,di)

    #new cases according to the importance
    utot=rmod2.vecgen1(k)
    pib=rmod2.vecgen1(k)
    newcase=rmod2.marray(k,k)
    for i7 in range(0,k):
        for j in range(0,k):
            newcase[i7][j]=-1


    for i7 in range(0,k):
        zaehl=0
        for j in range(i7+1,k+1):
            newcase[i7][zaehl]=prot[j]
            zaehl+=1
    
    # newcase: first line all attributes sorted according to increasing importance
    #          second line the least important arribute removed
    #          third line: the next less important attribute removed etc
    #          ...
    #          last line: the most important attribut
    #          note the corresponding indexes
    #print newcase
    for i7 in range(0,k):
        objx=rmod2.comp4(r,k,newcase,i7,dm) 
        redobjx=rmod2.marray(r,r)
        quobx=rmod2.marray(r,r)
        unit=rmod2.matunit(r)
        
        rmod2.matadd(r,1.0,objx,-1.0,unit,redobjx)

        rmod2.qualcomp(r,objx,quobx)
        inco=rmod2.marray(r,r)    
        inco=rmod2.rai_inc(r,quobx)
        z=0
        zsel=0
        for i1 in range(0,r):
            for j in range(0,r):
                if inco[i1][j]!=-1:
                    z+=1
                    
                      
        utot[i7]=1.0*z/2.0
        pib[i7]=2.0*utot[i7]/(1.0*r*(r-1))  #1.0*...
        pib[i7]=round(pib[i7],5) #5 decimals instead of 2
        print "i7= ",i7,"C",i7+1,"  utot= ",utot[i7],"   pib= ",pib[i7]
        print "newcase ",newcase[0][i7]

    # 4.10.08
    
    disum=0
    #print "di  = ", di
    dmnorm=rmod2.marray(r,k)
    dmnorm=rmod2.matrixnorm(r,k,dm)
    rred,xred,objred,extralist,eqm=rmod2.equivcompactgr(r,k,dmnorm,obj)
    din=rmod2.marray(k,1)
    ddranking=rmod2.vecgen1(r)
    ddrankingcopy=rmod2.vecgen1(r)
    ddrankingrred=rmod2.vecgen1(rred)
    ddrankingcopyrred=rmod2.vecgen1(rred)
    for i in range(1,k+1):
        disum+=di[i]
    #print "disum = ",disum
    
    for i in range(0,k):
        din[i][0]=1.0*di[i+1]/(1.0*disum)
    # din is a matrix with k rows and one column of data driven weights.
    #print "din = ",din
    
    # sensitivity driven CI for representative elements
    
    ddrankingrred=rmod2.matmult1(rred,k,xred,k,1,din)  #ldi sollte = k sein
    for i in range(0,rred):
        ddrankingcopyrred[i]=ddrankingrred[i][0]
    ddsortrred,nsortred=rmod2.raisort(rred,ddrankingcopyrred)
    ## 5.8.16
    
        # now all elements
    ddranking=rmod2.matmult1(r,k,dmnorm,k,1,din)  #ldi sollte = k sein
    for i in range(0,r):
        ddrankingcopy[i]=ddranking[i][0]
    ddsort,nsort=rmod2.raisort(r,ddrankingcopy)
    
    tp1=Tkinter.Toplevel(hf)
    tp1.title(' CAM, CI  ')
    lbtp1=Tkinter.Label(tp1,text=" object independent results ")
    lbtp1.pack()
    t_tp1=ScrolledText(tp1,width=60, height=10)
    t_tp1.pack()
    txt1="\n sensitivity \n"
    txt1="\n\tproperty\tsensitivity\n"
    for j in range(1,k+1):
        txt1+="\t"+prop[prot[j]-1]+"\t\t"+str(di[j])+"\n"
    txt1+="\n\n"
    txt1+="\n\n CAM (cumul. ambiguity maximum) \n"
    txt1+="subsequent inclusion of attributes from right to the left \n"
    for j in range(0,k):
        txt1+=str(pib[j])+"\t"
    txt1+="\n"    
    global pibr,pibrmax
    pibr=rmod2.vecgen1(k)
    for j in range(0,k):  #18.8.2011 i replaced by j: i should as far as possible count objects, j attributes
        pibr[j]=pib[k-1-j]
    pibrmax=max(pibr) #CAM
    geomx=rmod2.vecgen1(k)
    geomy=rmod2.vecgen1(k)
    cv=Tkinter.Canvas(tp1,width=200,height=250)
    #rec=cv.create_rectangle(0,0,198,248)
    for j in range(0,k):
        geomx[j]=20+(160.0/(1.0*k))*j
        geomy[j]=180-(160.0/(1.0*pibrmax))*pibr[j]
    for j in range(0,k-1):
        pibline=cv.create_line(geomx[j],geomy[j],geomx[j+1],geomy[j+1],fill="red",width=2)
    cir0=cv.create_oval(20-2,180+2,20+2,180-2,fill="white",outline="red")
    for j in range(0,k):
        cir=cv.create_oval(geomx[j]-2,geomy[j]+2,geomx[j]+2,geomy[j]-2,fill="white", outline="red")
    #print geomx
    #print geomy
    abscisse=cv.create_line(geomx[0],geomy[0],geomx[k-1],geomy[0],arrow="last")
    ordinate=cv.create_line(geomx[0],geomy[0],geomx[0],20,arrow="last")
    declar1=cv.create_text(70,210,text=" inclus. of attr. ")
    declar2=cv.create_text(70,230,text="CAM=f(cases)\n(object set)") #4.2.08
    for j in range(0,k):
        cv.create_line(geomx[j],186,geomx[j],180)
    for j in range(0,10,2):
        cv.create_line(16,180-16*j,20,180-16*j)
    cv.create_text(150,7,text="CAM = "+str(round(pibrmax,3)))  #4.2.08
    cv.pack()
    # decompositon
    global dmn, propn
    #rmod2.matout(r,k,dm)
    dmn,propn,fl=rmod2.msort(newcase,dm,prop,k,r)
    print prop
    txt1+="\nsorted after decreasing importance..."
    txt1+="Attributes: \n"
    for j in range(0, k):
        txt1+=str(propn[j])+"\t"
    txt1+="\n"    
    txt1+="Relative U-values (pib-values): \n"
    for j in range(0, k):
        txt1+=str(round(pib[k-j-1],3))+"\t"
    txt1+="\n"    
    txtdd="Sensitivities as weights to calculate a CI "+"\n"
    txtdd+="\n\ndata driven height for representative elements \n"
    txtdd+=50*"="+"\n"
    for i in range(0,rred):
        txtdd+=objred[nsortred[i]]+": data driven height: "+str(ddsortrred[i])+"\n"
    txtdd+="\n"
    txtdd+="\n\ndata driven height  for a l l  objects \n"
    for i in range(0,r):
        txtdd+=obj[nsort[i]]+": data driven height: "+str(ddsort[i])+"\n"
    txtdd+="\n"    
    txt1+=txtdd   ## Baustelle 05082016
    txt1+="\n"
    t_tp1.insert("end",txt1)
    print propn
    print "col. sorted increasing with W(qi)"
    rmod2.matout(r,k,dmn)
    buttHDcase.config(state="active")
    
def amTP():
    #brg 24.03.18, 25.3.18
    global eamseq,fram
    Tpam=Tkinter.Toplevel(hf)
    fram=Tkinter.Frame(Tpam)
    fram.pack()
    lbam1=Tkinter.Label(fram,text="How many sequences ? ")
    lbam1.pack()
    eamseq=Tkinter.Entry(fram,width=10)
    eamseq.pack()
    buttsubmit_seq=Tkinter.Button(fram,text="submit the sequences ",bg="cyan", width=25, command=submit_amseq)
    buttsubmit_seq.pack()
    fram2=Tkinter.Button(Tpam)
    fram2.pack()
    buttfill_am=Tkinter.Button(fram2,text="Results ",bg="cyan",width=25,command=fill_am)
    buttfill_am.pack()
    buttshowamotherresults=Tkinter.Button(fram2,text=" Equivalence classes ",width=25, bg="white",command=showothers)
    buttshowamotherresults.pack()
    
def submit_amseq():
    # brg 24.03.18
    global eseq, namseq
    
    namseq=int(eamseq.get())
    print "namseq= ",namseq
    lbam2=Tkinter.Label(fram,text="Insert the different sequences of indicators\n all with the same length: "+str(k) )
    lbam2.pack()
    eseq=rmod2.vecgen1(namseq)
    for i in range(0, namseq):
        eseq[i]=Tkinter.Entry(fram, width=20)
        eseq[i].pack()
        
    
def fill_am():
    # brg 24.03.18
    # k number of indicators
    global txt1                    
    hilfseq=rmod2.vecgen1(namseq)
    seq_am=rmod2.vecgen1(namseq)
    
    for i in range(0,namseq):
        hilfseq[i]=eseq[i].get()
        seq_am[i]=hilfseq[i].split(",")
    #print "seq_am[0] ", seq_am[0]
    #print "seq_am[1]: ",seq_am[1]
    set_ind=rmod2.vecgen1(namseq)
    Useq = rmod2.marray(namseq,k)
    txt1=" Am-sequences "+"\n"
    txt1+="Equivalence classes: "+"\n"
    for i in range(0,namseq):
        set_ind[i]=set([ ])
        attrib = []
        for j in range(0,k):
            set_ind[i].add(int(seq_am[i][j]))
            for indic in set_ind[i]:
                attrib.append(indic)
            #1) data matrix xx corresponding to attrib
            xx=rmod2.marray(r,len(set_ind[i]))    
            for i1 in range(0,r):
                zaehl=0
                for j1 in range(0,k):
                    if j1 in attrib:
                        xx[i1][zaehl]=dm[i1][j1]
                        zaehl+=1
            #print i,"  xx= "
            rmod2.matout(r,len(set_ind[i]),xx)
            #2) xxred (elimination of eq.classes )
            rredact,xxred,objredact,txtact=rmod2.equivcompact(r,len(set_ind[i]),xx,obj)
            txt1+="sequence no: "+str(i)+"  natt = "+str(j)+"\n"
            txt1+=txtact+"\n"
            #3) zeta matrix
            zetahilf=rmod2.comp(rredact,len(set_ind[i]),xxred)
            #4) U corresponding to i and j
            hilfU = 0
            for i2 in range(0, rredact):
                for i3 in range(0, rredact):
                    if zetahilf[i2][i3]==0 and zetahilf[i3][i2]==0:
                        hilfU+=0.5
            Useq[i][j]=hilfU
    txt2=" Am as a function of natt for "+str(namseq)+" indicator sequences" +"\n"       
    txt2+="\n"+"U as function of the sequences: U=f(natt)"+"\n"
    txt2+="natt  \t"
    for i in range(0, k):
        txt2+="natt="+str(i)+"\t"
    txt2+="\n"    
    for i in range(0, namseq):
        txt2+="Seq. "+str(i)+"\t "
        for j in range(0, k):
            txt2+=str(int(Useq[i][j]))+"\t"
        txt2+="\n"
    tam=ScrolledText(fram,width=120, height=20)
    tam.pack()
    tam.insert("end",txt2)
    print "Useq= "        
    rmod2.matout(namseq,k,Useq)
            # Baustelle  24.03.18: jetzt zeta-matrix zu jedem einzenlen set #
            
            
def showothers():
    #brg 25.03.18
    global txt1
    Tpothers=Tkinter.Toplevel(hf)
    tothers=ScrolledText(Tpothers,width=60,height=30)
    tothers.pack()
    tothers.insert("end",txt1)
    
def objan():
    """ Daughter window for the object specific analysis (osa)"""

    def objectrelated_analysis():
        """results of calc are now applied on selected objects"""
        #Brg 17.1.08, 19.2.08, 18.9.08, 19.9.08, 20.10.08
        #*: 17.1.08
        #akt: 20.10.08
        global itot
        itot=rmod2.vecgen1(k)
        objnr=enr.get()
        # what relations are to be analyzed:  brg 18.9.08
        txt1=rel1.get()
        txt2="eg"
        try:
            txt2t=rel2.get()
        except:
            txt2t="eg"
        if txt2t=="eq":   # necessary because the central quobx-matrix has erroneously a 'eg' as
            txt2="eg"    #...as code for equality
        elif txt2t=="eg":
            txt2="eg"
        else:
            txt2="none"

        if txt1=="MRG":
            txt1="lt"
            txt2="eg"
        
        if txt1=="gt" and txt2=="eg":
            txtgraph="PEG"    #predecessor evolution graph
        elif txt1=="ic":
            txtgraph="LAG"      #local ambiguity graph
        elif txt1=="ic" and txt2=="eg":
            txtgraph="WSG"   #weight sensitivity graph
            txt2=""
        elif txt1=="lt" and txt2=="eg":
            txtgraph="MRG"    #minimum rank graph)
        else:
            txtgraph=txt1
        #print "object = ",objnr,"  relation1 = ",txt1,"   relation2 = ",txt2
        #check whether objectname is in list
        obtest=1                        #8.6.08
        try:
            iob=obj.index(objnr)
            warnlb.config(bg="white")
            warnlb["text"]=""
        except:
            warnlb.config(bg="yellow")
            warnlb["text"]="+++ object correct??+++"
            obtest=0                     #8.6.08
            
        
    ##        print "case ",newcase[i]
    ##        print "incomparables of data matrix x"
    ##        print " Objects incomparable to..."
        if obtest!=0:                                   #8.6.08 
            for i in range(0,k):
                objx=rmod2.comp4(r,k,newcase,i,dm)  ## here is a crucial step!
                redobjx=rmod2.marray(r,r)
                quobx=rmod2.marray(r,r)
                unit=rmod2.matunit(r)
                rmod2.matadd(r,1.0,objx,-1.0,unit,redobjx)
                rmod2.qualcomp(r,objx,quobx)
                #print "case ",newcase[i]
                #print "quobx"
                #rmod2.strmatout(r,r,quobx)
                
                c1,txt1,txt2=rmod2.porgraph(r,quobx,txt1,txt2)
                #print "c1"
                #rmod2.strmatout(r,r,c1)
                zsel=0
                #print "Object = ",objnr," Object number ",iob
                for j in range(0,r):
                    if c1[iob][j]!=-1:
                        zsel+=1
                        #print inco[iob][j]," ",
                        
                itot[i]=zsel   #itot is an object specific information
            #print "relation = ",txtgraph," object = ", objnr," itot = ",itot
            itotrev=rmod2.reverselist(k,itot)
            itotn,maxi,mini=rmod2.vectornorm(k,itotrev)
            if txtgraph=="MRG":
                txtg="S("+objnr+")"
            elif txtgraph=="LAG":
                txtg="U("+objnr+")"
            elif txtgraph=="HEG":
                txtg="P("+objnr+")"
            else:
                txtg="#"+txt1+","+txt2+"("+objnr+")"
                
            names=["can.seq",txtg,"rel.of "+objnr+": "+txtgraph,"maximum= "+str(maxi)\
                   +" minimum= "+str(mini),txtg]
            graph=raioop2.brggraph(tpobjan,names,30,40,"red",2,itotn,1.0,k)
            
            
            lbtp2=Tkinter.Label(tpobjan,text=" object specific results  ")
            lbtp2.pack()
            t_tp2=ScrolledText(tpobjan,width=60,height=4)
            t_tp2.pack()
            txt2="\n "+txtgraph+": "+objnr+" as a function of attribut-aggregations"
            txt2+="\nsubseq. inclusion from left to right\n"
            for i in range(k,0,-1):
                txt2+="\t"+prop[prot[i]-1]
            txt2+="\n\t"
            for i in range(k-1,-1,-1): #correct ?? 23.6.09 Note if ties then the user should define a sequence
                txt2+=str(itot[i])+"\t"
            txt2+="\n"    
            t_tp2.insert("end",txt2)

    tpobjan=Tkinter.Toplevel(hf)
    tpobjan.title(' Osa ')
    lbobjan=Tkinter.Label(tpobjan,text="Object specific analysis (osa)",width=60)
    lbobjan.pack()
    lbobject=Tkinter.Label(tpobjan,text="Object-related analysis",font = ("arial",10,"bold"))
    lbobject.pack(pady=5)
    lbobject1=Tkinter.Label(tpobjan,text="(1) minimum rank graph (MRG) selected obj >= ....(lt,eq)")
    lbobject1.pack()
    lbobject2=Tkinter.Label(tpobjan,text="(2) local ambiguity graph (LAG): relation 'ic'        ")
    lbobject2.pack()
    lbobject3=Tkinter.Label(tpobjan,text="(3) height evolution graph (HEG)selected obj <=....(gt,eq)" )
    lbobject3.pack()
    frobject=Tkinter.Frame(tpobjan,width=60,height=10)
    frobject.pack()
    frinput=Tkinter.Frame(frobject)
    frinput.pack()
    lbinput=Tkinter.Label(frinput,text=">>> (2) object identifier >>>")
    lbinput.pack(side="left")
    enr=Tkinter.Entry(frinput,width=10)
    enr.pack(side="left")
    frinput2=Tkinter.Frame(frobject)
    frinput2.pack()
    lbMRG=Tkinter.Label(frinput2,text="minimum rank graph? press: MRG")
    lbMRG.pack()
    lbinput2=Tkinter.Label(frinput2,text=">>> (3) which relation (lt,gt,ic) >>>")
    lbinput2.pack()
    rel1=Tkinter.Entry(frinput2,width=10)
    rel1.pack()
    lbinput3=Tkinter.Label(frinput2,text=">>> (4) include equality? Insert 'eq' >>>")
    lbinput3.pack()
    rel2=Tkinter.Entry(frinput2,width=10)
    rel2.pack()
    buttcalc2=Tkinter.Button(tpobjan,text=" (5) object related analysis ",bg="cyan",command=objectrelated_analysis)
    buttcalc2.pack()
    warnlb=Tkinter.Label(tpobjan,bg="white")
    warnlb.pack()


def natteval():
    # Brg August 2010, 3.9.10
    global objred1,objred2,rred1,rred2,dm1,dm2,k1,k2,prop1,prop2,r
    nattc1=int(nattc.get())
    lbnatt.config(text="Decomposition: "+str(nattc1)+" indics. : IB1 and \n"+ str(k-nattc1)+" indic1 : IB2",bg="yellow")
    nattcline=cv3.create_line(geomx[nattc1-1],geomy[0],geomx[nattc1-1],20,fill="blue")
    
    dm1=rmod2.marray(r,nattc1)
    dm2=rmod2.marray(r,k-nattc1)
    
    ttest="orig:\t"
    for j in range(0,k):
       ttest+=str(dmn[0][j])+"\t"
    ttest+="\n"+"dm1:\t"    
    k1=nattc1
    k2=k-nattc1
    print "k1= ",k1
    print "k2= ",k2
    prop1=rmod2.vecgen1(k1)
    prop2=rmod2.vecgen1(k2)
    for i in range(0,r):
       z1=0
       for j in range(0,k1):
           dm1[i][z1]=dmn[i][j]
           z1+=1
    for i in range(0,r):
       z2=0
       for j in range(nattc1,k):
           dm2[i][z2]=dmn[i][j]
           z2+=1
    
    for j in range(0,k1):
        prop1[j]=propn[j]
    z1=0
    for j in range(nattc1,k):
        prop2[z1]=propn[j]
        z1+=1
        
    # documentation
    for j in range(0,nattc1):
        ttest+=str(dm1[0][j])+"\t"
    ttest+="\n"+"dm2:\t"               
    for j in range(0,z2):
        ttest+=str(dm2[0][j])+"\t"
    ttest+="\n"               
    rred1,xred1,objred1,txt1=rmod2.equivcompact(r,nattc1,dm1,obj)
    rred2,xred2,objred2,txt2=rmod2.equivcompact(r,k-nattc1,dm2,obj)
    print "objred1 = ",objred1
    print "objred2 = ",objred2
    print "rred1 = ",rred1
    print "rred2 = ",rred2
    print "The new matrices "
    rmod2.matout(r,k1,dm1)
    print " "
    rmod2.matout(r,k2,dm2)
    zetahilf1=rmod2.comp(rred1,k1,xred1)
    zeta1=rmod2.marray(rred1,rred1)
    for i in range(0,rred1):
        for j in range(0,rred1):
            zeta1[i][j]=zetahilf1[j][i]
    #
    U1=0
    for i in range(0,rred1):
        for j in range(0,rred1):
            if zeta1[i][j]==0 and zeta1[j][i]==0:
                U1+=0.5

    zetahilf2=rmod2.comp(rred2,k2,xred2)
    zeta2=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):
        for j in range(0,rred2):
            zeta2[i][j]=zetahilf2[j][i]
    #
    U2=0
    for i in range(0,rred2):
        for j in range(0,rred2):
            if zeta2[i][j]==0 and zeta2[j][i]==0:
                U2+=0.5
    if U2!=0:
        urelat=str(round(1.0*U1/U2,2))
    else:
        urelat="infinity"
           
    tpdecomp=Tkinter.Toplevel(hf)
    tpdecomp.title(' decomposition ')
    lbinfo=Tkinter.Label(tpdecomp,text=ttest+"  U1/U2 = "+urelat)
    lbinfo.pack()
    Storedecompbutt=Tkinter.Button(tpdecomp,text="store both decomp. matrices",command=sf2)
    Storedecompbutt.pack()
    fr1=Tkinter.Frame(tpdecomp,relief="sunken",bd=4)
    fr1.pack(side="left")
    fr2=Tkinter.Frame(tpdecomp,relief="sunken",bd=4)
    fr2.pack(side="left")
    
    HDvar(fr1,rred1,k1,xred1,objred1)
    HDvar(fr2,rred2,k2,xred2,objred2)
    
    

def nattcruc():
    #brg 6.8.10
    global tpagg3,fragg3,cv3,geomx,geomy
    tpagg3=Tkinter.Toplevel(hf)
    tpagg3.title(' nattcruc-aggregation ')
    fragg3=Tkinter.Frame(tpagg3)
    fragg3.pack()
    global nattc
    nattf=k
    nattc=Tkinter.DoubleVar()
    xsch=Tkinter.Scale(fragg3,width=10,length=180,orient="horizontal",from_=0,to=nattf-1,\
                   label="   natt",variable=nattc)
    xsch.pack()
    
    geomx=rmod2.vecgen1(k)
    geomy=rmod2.vecgen1(k)
    cv3=Tkinter.Canvas(fragg3,width=200,height=250)
    cv3.pack()
    #rec=cv.create_rectangle(0,0,198,248)
    for i in range(0,k):
        geomx[i]=20+(160.0/(1.0*k))*i
        geomy[i]=180-(160.0/(1.0*pibrmax))*pibr[i]
    for i in range(0,k-1):
        pibline=cv3.create_line(geomx[i],geomy[i],geomx[i+1],geomy[i+1],fill="red",width=2)
    #print geomx
    #print geomy
    abscisse=cv3.create_line(geomx[0],geomy[0],geomx[k-1],geomy[0],arrow="last")
    ordinate=cv3.create_line(geomx[0],geomy[0],geomx[0],0,arrow="last")
    
    camline=cv3.create_line(geomx[0],20,geomx[k-1],20)
    camtext=cv3.create_text(185,20,text="CAM")
    declar1=cv3.create_text(70,210,text=" inclus. of attr. ")
    global buttdecomp
    buttdecomp=Tkinter.Button(tpagg3,text="perform decomp.",width=25,bg="cyan",command=natteval)
    buttdecomp.pack()
    global lbnatt
    lbnatt=Tkinter.Label(tpagg3,text="")
    lbnatt.pack()
    
            
def HDvar(master,rxx,kx,x,objred):
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 200 then only the cover-matrix and the level-population
    # This module I took from mainHD5
    # 6.8.10

##    def showcover():
##    #Brg 6.12.2010
##        cover_decomp_show(rxx,objred)

    global zeta,zeta2,fn   
    print "rxx= ",rxx   
    #
    zetahilf=rmod2.comp(rxx,kx,x)
    zeta=rmod2.marray(rxx,rxx)
    for i in range(0,rxx):
        for j in range(0,rxx):
            zeta[i][j]=zetahilf[j][i]
    #
    U=0
    for i in range(0,rxx):
        for j in range(0,rxx):
            if zeta[i][j]==0 and zeta[j][i]==0:
                U+=0.5
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rxx,zeta)
    #print "zzmax = ",zzmax
    
    
    #Adj-Listen

    adjc=rmod2.adjacent(rxx,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rxx,adjc,lext)
       
    
    zeta2=rmod2.cover(rxx,tr,lext)
    if rxx>200:                         #6.12.2010
       lbdecomp.config(text="dm too large, store the dms and use mainHD ",bg="yellow",font=("arial",14,bold)) 
    else:
        
        cv=Tkinter.Canvas(master,width=400,height=400,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rxx,rxx)
        geomy=rmod2.marray(rxx,rxx)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(180.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(180.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        cvt=cv.create_text(100,390,text="U = "+str(U))
        cv.pack(expand="yes",fill="both")
        buttdecomp.config(state="disabled")
##        buttcover=Tkinter.Button(master,text="show cover relation",command=showcover)
##        buttcover.pack()


    


def cover_decomp_show(r,objred):
    # brg 06.12.2010
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt06.12.2010
    #note: -
    #source: -
    hfcoverdecomp=Tkinter.Toplevel(hf)
    hfcoverdecomp.title(' cover-matrix (decomposition) ')
    
    lbhd2=Tkinter.Label(hfcoverdecomp,text=" Cover-Relations (decomposition) ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,r):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,r):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcoverdecomp,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def uucomp():
    # brg 13.3.16, 24.03.2018
    # comparison of U0 and Ucase
    txtuu="Comparison based on incomparability vectors"+"\n"
    txtuu+="Based on the object set"+"\n"
    txtuu+="Considered case: "+str(caseact)+"\n"
    print "caseact = ", caseact
    for i1 in range(0,k):
            if case[caseact][i1]!=-1:
                txtuu+=str(prop[i1])+" "
    txtuu+="\n"
    txtuu+="delta U rel = deltaU/U0 "+"\n"
    print txtuu
    deltau=rmod2.vecgen1(r)
    deltaurel=rmod2.vecgen1(r)
    Ucasesum = sum(Ucase)
    txtuu+="Object"+"\t"+"U0"+"\t"+"Ucase"+"\t"+"delta U"+"\t"+"delta U rel"+"\n"
    for i in range(0,r):
        deltau[i]=U0[i]-Ucase[i]
        if U0[i]!=0:
            deltaurel[i]=1.0*deltau[i]/U0[i]
        else:
            deltaurel[i]=0
        txtuu+=str(obj[i])+":\t"+str(U0[i])+"\t"+str(Ucase[i])+"\t"+str(deltau[i])+"\t"+str(round(deltaurel[i],3))+"\n"
    deltaUsum = sum(deltau)
    deltaUsumav= 1.0*deltaUsum/r
    txtuu+="\n"
    txtuu+="sum of Ucase over all objects "+"\t"+str(Ucasesum)+"\n"
    txtuu+="Utotalcase = "+"\t"+str(1.0*Ucasesum/2.0)+"\n"
    txtuu+="Average of Ucase: "+"\t"+str(1.0*Ucasesum/r)+"\n"
    txtuu+="\n"
    txtuu+="sum of deltaU-values: "+"\t"+str(deltaUsum)+"\n"
    txtuu+="average of deltaU-values "+"\t"+str(deltaUsumav)+"\n"
    maxuu=-99999
    for i in range(0,r):
        if deltau[i]>=maxuu:
            maxuu=deltau[i]
            imax=i
    minuu=99999
    for i in range(0,r):
        if deltau[i]<=minuu:
            minuu=deltau[i]
            imin=i
    maxuurel=-99999
    for i in range(0,r):
        if deltaurel[i]>=maxuurel:
            maxuurel=deltaurel[i]
            imaxrel=i
    minuurel=99999
    for i in range(0,r):
        if deltaurel[i]<=minuurel:
            minuurel=deltaurel[i]
            iminrel=i
    # extrmal cases                    
    objmax=[]
    objmin=[]
    objmaxrel=[]
    objminrel=[]
    for i in range(0,r):
        if deltau[i]==maxuu:
            objmax.append(obj[i])
        if deltau[i]==minuu:
            objmin.append(obj[i])
        if deltaurel[i]==maxuurel:
            objmaxrel.append(obj[i])
        if deltaurel[i]==minuurel:
            objminrel.append(obj[i])
    txtuu+="\n"        
    txtuu+="Extremal cases "+"\n"
    txtuu+="Maximal with respect to delta U "+"\n"
    txtuu+="delta U max = "+str(maxuu)+"\n"
    for ob in objmax:
        txtuu+=ob+"\t"
    txtuu+=2*"\n"
    txtuu+="Minimal with respect to delta U "+"\n"
    txtuu+="delta U min = "+str(minuu)+"\n"
    for ob in objmin:
        txtuu+=ob+"\t"
    txtuu+=2*"\n"
    txtuu+="Maximal with respect to delta U rel "+"\n"
    txtuu+="delta U rel max = "+str(maxuurel)+"\n"
    for ob in objmaxrel:
        txtuu+=ob+"\t"
    txtuu+=2*"\n"
    txtuu+="Minimal with respect to delta U rel"+"\n"
    txtuu+="delta U rel min = "+str(minuurel)+"\n"
    for ob in objminrel:
        txtuu+=ob+"\t"
    txtuu+="\n"
    txtuu+="- - -  e o f  - - - "+"\n"
    tpuu=Tkinter.Toplevel(hf)
    tpuu.title(' UU-comparison ')
    tuu=ScrolledText(tpuu,height=10, width=80)
    tuu.pack()
    tuu.insert("end",txtuu)
    



hf=Tkinter.Tk()
hf.title('sensitivity')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_sensi.txt",24,\
            "March, the 26th, 2018"," about sensitivity ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_sensi.txt",24,\
            "March, the 26th, 2018"," help_sensi ", "white", "t1",80,5,ScrolledText)
    


lbhallo=Tkinter.Label(hf,text="",width=60)
lbhallo.pack()
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen=Tkinter.Label(fropen,text="")
lbopen.pack()
lbfileselect=Tkinter.Label(fropen,text=">>>sel.& open file >>>")
lbfileselect.pack(side="left",pady=10)
buttfileselect=Tkinter.Button(fropen,text="sel. & open file (EXCEL-related)",width=25, bg="white",command=File_select)
buttfileselect.pack(side="left",pady=5)
buttfileselect2=Tkinter.Button(fropen,text="sel. & open file (PyHasse format, (pdt))",width=25,bg="white",command=fileselect_PyHasse)
buttfileselect2.pack(side="left",pady=5)
frshow=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshow.pack(fill="x")
buttshow=Tkinter.Button(frshow,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=5)
buttHD=Tkinter.Button(frshow,text="show  HD ",width=25,command=HD)
buttHD.pack(pady=5)
frcalc=Tkinter.Frame(hf,relief="sunken",bd=2)
frcalc.pack()
lbcalc=Tkinter.Label(frcalc, text="Global calculation (for all objects) ")
lbcalc.pack()
frindic=Tkinter.Frame(frcalc)
frindic.pack()

##lbindic=Tkinter.Label(frindic,text="0: no additional info; 1: detailed info comcerning the cases ")  #changed: 1.12.2012
##lbindic.pack(side="left")
##eflcases=Tkinter.Entry(frindic,width=1)
##eflcases.pack()

buttcalc=Tkinter.Button(frcalc,text="(1) global calculate",bg="cyan",width=25,command=calc)
buttcalc.pack(pady=10)
buttic=Tkinter.Button(hf,text=" Info about cases wanted?",bg="green",width=25,command=infocase)
buttic.pack()
froptional=Tkinter.Frame(hf,relief="sunken",bd=2)
froptional.pack(pady=5)
lboptional=Tkinter.Label(froptional,text="select a case >>>")
lboptional.grid(column=0,row=0)
ecase=Tkinter.Entry(froptional,width=3)
ecase.grid(column=1,row=0)
buttHDcase=Tkinter.Button(froptional,text="case specific HD ",width=25,command=HDcase,state="disabled")
buttHDcase.grid(column=1,row=1)
frcanseq=Tkinter.Frame(hf,relief="sunken",bd=2)
frcanseq.pack()
buttproplist=Tkinter.Button(frcanseq, text="help: column number  vs attribute's name ",bg="green",width=25,command=prophelp)
buttproplist.pack()
lbcanseq=Tkinter.Label(frcanseq,text="Enter the attributes (columnnumber) of your specific interest (see available list)")
lbcanseq.pack()
eattrib=Tkinter.Entry(frcanseq,width=50)
eattrib.pack()
lbpropsel=Tkinter.Label(frcanseq,text=" ")
lbpropsel.pack()
buttHDcanseq=Tkinter.Button(frcanseq,text="HD of your attrib. selection ",width=25,command=HDcanseq)
buttHDcanseq.pack()
buttam=Tkinter.Button(frcanseq,text="Open GUI for Am-analysis ", width=25, bg="cyan", command=amTP)
buttam.pack()
buttuu=Tkinter.Button(frcanseq, text="Comparison, based on U-vectors",width=25,bg="cyan",command=uucomp)
buttuu.pack(pady=2)
tplocal=Tkinter.Toplevel(hf)
tplocal.title('local analysis')
frobject=Tkinter.Frame(tplocal,relief="sunken",bd=2)
frobject.pack(pady=5)
lbobject=Tkinter.Label(frobject,text="Local calculation (for single objects) ")
lbobject.pack()
buttobjrel_Analyse=Tkinter.Button(frobject,text="(2) local calculate", \
                                  width=25,bg="cyan",command=objan)
buttobjrel_Analyse.pack()
frdecomp=Tkinter.Frame(tplocal,bd=3,relief="sunken")
frdecomp.pack(pady=2)
buttnatt=Tkinter.Button(frdecomp,text="nattc-selection for \ndecomposition of IB",width=25,bg="cyan",command=nattcruc)
buttnatt.pack()
lbdecomp=Tkinter.Label(frdecomp)
lbdecomp.pack()
buttsave=Tkinter.Button(tplocal, text=" Save the two W(q)-sorted\n matrix in pdt - format",command=sf2) #brg 29.09.2010
buttsave.pack(pady=2)
lbsuccess=Tkinter.Label(tplocal,text="")
lbsuccess.pack()
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=5)
hf.mainloop()
