import rmod2
import raioop2
import Tkinter
import Canvas
from ScrolledText import ScrolledText
import tkFileDialog


# brg 24.9.2014 derived from simstudy
def fileselect():
    """ File selection, opening and by Tkinter-Standards"""
    #*13.1.08
    #akt: 10.10.14
    #note: 
    #source: palg4_2.py
    global fndm, obj
    fndm = tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fndm)
    obj = []
    for i in range(0, r):
        obj.append(ob[i+1])
    print "obj = ",obj    
   

def inread1():
    # brg 24.9.2014
    global fn1,r,relat1, sumrelat1
    fn1=tkFileDialog.askopenfilename()
    print "fn1 ",fn1
    Tpopener1=Tkinter.Toplevel(hf)
    Tpopener1.title(' Opening file ')
    Topen1=ScrolledText(Tpopener1,height=5, width=80)
    Topen1.pack()
    f=open(fn1,'r')
    r=int(f.readline())
    xx=[]
    relat1=rmod2.marray(r,r)
    for i in range(0,r):
        xx.append(f.readline().split('\t'))
        lx=len(xx[i])
        print "lx= ",lx
        for i2 in range(0, lx-1):
            print xx[i][i2],
        print " "    
    sumrelat1 = 0    
    for i1 in range(0,r):
        for i2 in range(0,lx-1):
            relat1[i1][i2]=int(float(xx[i1][i2]))
            if (relat1[i1][i2] == 1 and relat1[i2][i1] ==0) or\
               (relat1[i1][i2] == 0 and relat1[i2][i1] == 1):
                sumrelat1 += relat1[i1][i2]
    rmod2.matout(r,r,relat1)
    txt="Open file"+str(fn1)+"\n"
    txt+="number of rows/columns = "+str(r)+"\n"
    for i in range(0,r):
        for i2 in range(0,r):
            txt+=str(relat1[i][i2])+"\t"
        txt+="\n"
    txt+="\n"    
    Topen1.insert("end",txt)
    return relat1,r                      

def inread2():
    # brg 24.9.2014
    global fn2,relat2, relat2test, Topen2, sumrelat2
    fn2=tkFileDialog.askopenfilename()
    print "fn2 ",fn2
    Tpopener2=Tkinter.Toplevel(hf)
    Tpopener2.title(' Opening file ')
    Topen2=ScrolledText(Tpopener2,height=5, width=80)
    Topen2.pack()
    f2=open(fn2,'r')
    r=int(f2.readline())
    xx=[]
    relat2test=rmod2.marray(r,r)
    relat2 = rmod2.marray(r, r)
    for i in range(0,r):
        xx.append(f2.readline().split('\t'))
        lx=len(xx[i])
        print "lx= ",lx
        for i2 in range(0, lx-1):
            print xx[i][i2],
        print " "    
    sumrelat2 = 0    
    for i1 in range(0,r):
        for i2 in range(0,lx-1):
            relat2[i1][i2]=int(float(xx[i1][i2]))
            if (relat2[i1][i2] == 1 and relat2[i2][i1] ==0) or\
               (relat2[i1][i2] == 0 and relat2[i2][i1] == 1):
                sumrelat2 += relat2[i1][i2]
            
    rmod2.matout(r,r,relat2)
    txt="Open file"+str(fn2)+"\n"
    txt+="number of rows/columns = "+str(r)+"\n"
    for i in range(0,r):
        for i2 in range(0,r):
            txt+=str(relat2[i][i2])+"\t"
        txt+="\n"
    txt+="\n"
    Topen2.insert("end",txt)
    return relat2

def transpose1():
    # brg 23.1.2015
    global relat1
    txttr="Transpose first matrix"+"\n"
    hilf = []
    for i1 in range(0, r):
        hilf.append(0)
        hilf[i1] = []
        for i2 in range(0, r):
            hilf[i1].append(relat1[i2][i1])
    for i1 in range(0, r):
        for i2 in range(0, r):
            relat1[i1][i2] = hilf[i1][i2]
    txttr+="\nTransposed matrix: number of rows/columns = "+str(r)+"\n"
    for i1 in range(0,r):
        for i2 in range(0,r):
            txttr+=str(relat1[i1][i2])+"\t"
        txttr+="\n"
    txttr+="\n"            
    Topen2.insert("end",txttr)                            
    return relat1,r                               
    
def transpose2():
    # brg 23.1.2015
    global relat2
    txttr="Transpose second matrix"+"\n"
    hilf = []
    for i1 in range(0, r):
        hilf.append(0)
        hilf[i1] = []
        for i2 in range(0, r):
            hilf[i1].append(relat2[i2][i1])
    for i1 in range(0, r):
        for i2 in range(0, r):
            relat2[i1][i2] = hilf[i1][i2]
    txttr+="\nTransposed matrix: number of rows/columns = "+str(r)+"\n"
    for i1 in range(0,r):
        for i2 in range(0,r):
            txttr+=str(relat2[i1][i2])+"\t"
        txttr+="\n"
    txttr+="\n"            
    Topen2.insert("end",txttr)                            
    return relat2,r                                         
               
            
           

def calc_simmatrix(relat,r):
    # brg 24.9.2014, 10.10.2014
    matrix = []
    for i1 in range(0,r):
        matrix.append(0)
        matrix[i1] = []
        for i2 in range(0,r):
            if i1!=i2:
                if (relat[i1][i2]==0 and relat[i2][i1]==0):
                    matrix[i1].append("||")
                if (relat[i1][i2]==1 and relat[i2][i1]!=1):
                    matrix[i1].append("<")
                if (relat[i2][i1]==1 and relat[i1][i2]!=1):
                    matrix[i1].append(">")    
                if relat[i1][i2]==1 and relat[i2][i1]==1:
                    matrix[i1].append("=")
            else:
                matrix[i1].append("*")
    print "matrix"
    rmod2.strmatout(r,r,matrix)
    print " "
    return matrix

def calculation1():
    # brg 24.9.2014, 10.10.2014
    global matrix1, matrix2
    matrix1 = calc_simmatrix(relat1, r)
    matrix2 = calc_simmatrix(relat2, r)
    simmatrix = []
    for i1 in range(0, r):
        simmatrix.append(0)
        simmatrix[i1] = []
        for i2 in range(0, r):
            simmatrix[i1].append((matrix1[i1][i2], matrix2[i1][i2]))
    return simmatrix
            
def final_calculation():
    # brg 10.10.2014
    global isotone, antitone, weakisotone, indifferent, equiv, relsum, tau1, sim_act
    sim_act = calculation1()
    rmod2.strmatout(r,r,sim_act)
    isotone = 0
    antitone = 0
    weakisotone = 0
    indifferent = 0
    equiv = 0
    for i1 in range(0, r):
        for i2 in range(i1+1,r):
            if sim_act[i1][i2] == ("<","<") or sim_act[i1][i2] == (">",">"):
                isotone += 1
            elif sim_act[i1][i2] == (">","<") or sim_act[i1][i2] == ("<",">"):
                antitone += 1
            elif sim_act[i1][i2] == ("=","<") or sim_act[i1][i2] == ("=",">")\
               or sim_act[i1][i2] == ("<","=") or sim_act[i1][i2] == (">","="):
                weakisotone += 1
            elif sim_act[i1][i2] == ("=","="):
                equiv += 1
            else:
                indifferent += 1
    relsum = isotone+antitone+weakisotone+indifferent+equiv
    tau1 = 2.0*(isotone+weakisotone+equiv)/(r*(r - 1))
    lbresults.config(text="fraction of relations not contradicting similarity "\
                     +str(round(tau1,3)),bg="yellow",font=("arial",14,"bold"))
    

def show_final_results():
    # brg 24.9.2014
    tpresults = Tkinter.Toplevel()
    tpresults.title('results of similarity studies')
    tresults=ScrolledText(tpresults, width=60,height=10,bg="white")
    tresults.pack()
    txt="Details of similarity study "+"\n"
    txt+="Number of > or < relations (excluding equiv.) in matrix relat1: "+str(sumrelat1)+"\n"
    txt+="Number of > or < relations (excluding equiv.) in matrix relat2: "+str(sumrelat2)+"\n"
    txt+=50*"=" + "\n"
    txt+="Number of objects = "+str(r)+"\n"
    txt+="Isotone = "+str(isotone)+"\n"
    txt+="Antitone= "+str(antitone)+"\n"
    txt+="Weakisotone = "+str(weakisotone)+"\n"
    txt+="Equivalent = "+str(equiv)+"\n"
    txt+="Indifferent = "+str(indifferent)+"\n"
    txt+="Not contradicting similarity "+str(isotone+weakisotone+equiv)+"\n"
    txt+="Contradicting similarity "+str(antitone)+"\n"
    txt+="Fraction pro Similarity (tau1) "+str(round(tau1,3))+"\n"
    if tau1>=0.5:
        txt+="More or equal than the half of all relations not contradicting similarity"+"\n"
    else:
        txt+="Less than half of all relations are pro similarity "+"\n"
    txt+="- - -   e o f  - - -  "
    tresults.insert("end",txt)

def show_interim_results():
    # brg 10.10.2014
    tpinterim=Tkinter.Toplevel(hf)
    tpinterim.title(" Interim results ")
    tinterim = ScrolledText(tpinterim,height = 20, width=60)
    tinterim.pack()
    txt="Interim results "+"\n"
    txt+=50*"="+"\n"
    sel=esel.get()
    txt+="File1 = "+str(fn1) + "\n"
    txt+="File2 = "+str(fn2) + "\n"
    txt+="Selection = "+str(sel)+"\n"
    txt+="objects sequence: "+"\n"
    for i in range(0, r):
        txt+=str(obj[i])+", "
    txt+="\n"    
    if sel == "1":
        for i1 in range(0, r):
            for i2 in range(i1+1, r):
                txt+=str(matrix1[i1][i2])+", "
            txt+="\n"
        txt+="\n"    
    elif sel == "2":
        for i1 in range(0, r):
            for i2 in range(i1 + 1, r):
                txt+=str(matrix2[i1][i2])+", "
            txt+="\n"
        txt+="\n"    
    elif sel == "both":
        for i1 in range(0, r):
            txt+=str(obj[i1])+": "
            for i2 in range(i1 + 1, r):
                txt+=str(sim_act[i1][i2])+", "
            txt+="\n"
        txt+="\n"   
    else:
        txt+="No (valid) selection"+"\n"
    tinterim.insert("end",txt)    

def checkobj():
    # brg 10.10.2014
    # to get the correct object labels open the file, containing the dm
    tpcheckobject=Tkinter.Toplevel(hf)
    tpcheckobject.title('objects check')
    tcheckobj = ScrolledText(tpcheckobject,height=10, width=60)
    tcheckobj.pack()
    obj1=eobj1.get()
    obj2=eobj2.get()
    txt=" Check, using the file "+str(fndm)+ "\n...to get the correct object labels"+"\n"
    if obj1 in obj and obj2 in obj:
        txt += "Selected objects: "+str(obj1)+"  "+str(obj2)+"\n"
        iob1 = obj.index(obj1)
        iob2 = obj.index(obj2)
        txt+="Relation1 corresponding to "+str(fn1)+"\n"
        txt+="Relation2 corresponding to "+str(fn2)+"\n"
        txt+="Relation1: " + str(obj1)+" "+str(matrix1[iob1][iob2])+" "+str(obj2) + "\n"
        txt+="Relation2: " + str(obj1)+" "+str(matrix2[iob1][iob2])+" "+str(obj2) + "\n"
        txt+="Contribution: "+str(obj1)+", "+str(obj2)+": "+str(sim_act[iob1][iob2])+"\n"
    else:
        txt+="+ + + wrong labels + + + " +"\n"
    tcheckobj.insert("end",txt)
    
def search_antitone_pairs():
    # brg 11.10.2014
    tpantitone=Tkinter.Toplevel(hf)
    tpantitone.title(' antitone_seach ')
    tantitone=ScrolledText(tpantitone,height=10,width=60)
    tantitone.pack()
    txt="Search: antitone: object pairs "+"\n"
    zahl=0
    for i1 in range(0,r):
        for i2 in range(i1+1,r):
            if sim_act[i1][i2]==("<",">") or sim_act[i1][i2] ==(">","<"):
                zahl+=1
                txt+="("+str(obj[i1])+", "+str(obj[i2])+")"+"\n"
    txt+="\n"
    if zahl>0:
        txt+=50*"=" +"\n"
    else:
        txt+="+ + + no pairs being in an antitone relation + + +"
    tantitone.insert("end",txt)
    
                
    

hf=Tkinter.Tk()
aboutsimzeta=raioop2.brgabout(hf,"tpabout","about_simzeta.txt",2,\
            "January, the 23rd, 2015"," about simzeta ", "white", "t1",80,5,ScrolledText)
helpsimstudy=raioop2.brgabout(hf,"tpabout","help_simzeta.txt",2,\
            "January, the 23rd, 2015"," help_simzeta ", "white", "t1",80,5,ScrolledText)
fr=Tkinter.Frame(hf)
fr.pack()
buttfileselect = Tkinter.Button(fr, text = "Data matrix read in \n (in order to perform an objectwise study)",width=40, command=fileselect)
buttfileselect.pack()
butt1=Tkinter.Button(fr,text="inread1",bg="cyan",width=40,command=inread1)
butt1.pack()
butt4a = Tkinter.Button(fr,text="transpose the 1st relational matrix", bg="cyan",width=40,command=transpose1)
butt4a.pack()
butt3=Tkinter.Button(fr,text="inread2",bg="cyan",width=40,command=inread2)
butt3.pack()
butt4b = Tkinter.Button(fr,text="transpose the 2nd relational matrix", bg="cyan",width=40,command=transpose2)
butt4b.pack()
frgui3=Tkinter.Frame(fr,relief="sunken",bd=3)
frgui3.pack(pady=5)
lbresults = Tkinter.Label(fr,text="")
lbresults.pack()
buttcalc=Tkinter.Button(frgui3,text="Evaluation ",width=40, bg="cyan",command=final_calculation)
buttcalc.pack()
buttshow=Tkinter.Button(frgui3,text="Show details ",bg="cyan",width=40,command=show_final_results)
buttshow.pack()
labsel=Tkinter.Label(fr,text="select: 1 (relations1), 2 (relations 2)\n or both for interim results")
labsel.pack()
esel = Tkinter.Entry(fr, width=5)
esel.pack()
buttshowinterimresults = Tkinter.Button(fr,text="show interim results ",width=40, command=show_interim_results)
buttshowinterimresults.pack()
frobjcheck=Tkinter.Frame(fr,relief="sunken",bd=3)
frobjcheck.pack()
lbobjcheck=Tkinter.Label(frobjcheck,text="Enter for an object-wise check two object labels of interest ")
lbobjcheck.pack()
eobj1=Tkinter.Entry(frobjcheck, width=5)
eobj1.pack(side="left")
eobj2=Tkinter.Entry(frobjcheck, width=5)
eobj2.pack(side="left")
buttobjwisecheck=Tkinter.Button(frobjcheck,text="calculate info for the selected two objects ",width=40, command=checkobj)
buttobjwisecheck.pack()
buttsearchantitone=Tkinter.Button(fr,text="Search for antitone-realizations  ",\
                                  width=40, command=search_antitone_pairs)
buttsearchantitone.pack()
buttexit=Tkinter.Button(fr,text="exit",bg="red",width=20,bd=4,command=hf.destroy)
buttexit.pack()
hf.mainloop()
               
               
    
                              
                              
            
            
                             
        
