import rmod2
import raioop2
import Tkinter
from ScrolledText import ScrolledText

# brg 31.8.2013

def io():
    #brg 30.8.2013
    import Tkinter
    from ScrolledText import ScrolledText
    import tkFileDialog
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)
    

def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,obj,prop,xred,rred,objred,dm
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))
    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)
    
    

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)
 

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)




def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,x,k,r,obj,prop,rred,objred,xred

    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    
    print "original matrix "
    rmod2.matout(r,k,x)
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)   #6.8.2013

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)    

##### end ofg editenster ### 29.8.2013 ####

def trafo():
    #brg 31.8.2013
    global e_ind,xnew,r,k
    tpselect=Tkinter.Toplevel(hf)
    frselect=Tkinter.Frame(tpselect)
    frselect.pack()
    # grid
    lb00=Tkinter.Label(frselect,text="No transformation ")
    lb00.grid(row=0,column=1)
    lb01=Tkinter.Label(frselect,text="multiplication with -1 ")
    lb01.grid(row=1,column=1)
    lb02=Tkinter.Label(frselect,text="reciprocal values  ")
    lb02.grid(row=2,column=1)
    lb03=Tkinter.Label(frselect, text="max(x) - x  ")
    lb03.grid(row=3,column=1)
    butt00=Tkinter.Button(frselect,text="Do nothing ",width=20,bg="cyan",command=go_on0)
    butt00.grid(row=0,column=2)
    butt01=Tkinter.Button(frselect,text="Go on ",width=20,bg="cyan",command=go_on1)
    butt01.grid(row=1,column=2)
    butt02=Tkinter.Button(frselect,text="Go on (! x/0 ???) ",width=20,bg="cyan",command=go_on2)
    butt02.grid(row=2,column=2)
    butt03=Tkinter.Button(frselect,text="Go on ",width=20,bg="cyan",command=go_on3)
    butt03.grid(row=3,column=2)
    frindicator=Tkinter.Frame(tpselect)
    frindicator.pack()
    lbind1=Tkinter.Label(frindicator,text="select indicator (0 first data column, 1, second...")
    lbind1.pack()
    
    xnew=rmod2.matcopy1(r,k,x)
    print "in Trafo"
    rmod2.matout(r,k,xnew)
    e_ind=Tkinter.Entry(frindicator,width=3)
    e_ind.pack()
    
    
def go_on0():
    # brg 31.8.2013
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    indsel=0
    
    for i in range(0,r):
        xnew[i][indsel]=x[i][indsel]
        print xnew[i][indsel]
    return xnew
    
def go_on1():
    # brg 31.8.2013
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    indsel=int(e_ind.get())
    
    for i in range(0,r):
        xnew[i][indsel]=-x[i][indsel]
        print xnew[i][indsel]
    return xnew

def go_on2():
    # brg 31.8.2013
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    indsel=int(e_ind.get())
    
    for i in range(0,r):
        if x[i][indsel]!=0:
            xnew[i][indsel]=1.0/x[i][indsel]
        else:
            xnew[i][indsel]=999999.99
        print xnew[i][indsel]
        
    return xnew

def go_on3():
    #brg 31.8.2013
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    indsel=int(e_ind.get())
    hilf=[]
    for i in range(0,r):
        hilf.append(x[i][indsel])
    maxindsel=max(hilf)
    print maxindsel              
    for i in range(0,r):
        xnew[i][indsel]=maxindsel-x[i][indsel]
        print "i= ",xnew[i][indsel]    
    return xnew
    
    
    
    
    

def calc():
    #brg 30.08.2013
    #Modell fuer die Vorgehensweise die Wassermann vorschlaegt
    print "modified matrix "
    rmod2.matout(r,k,xnew)
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,xnew,obj)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(rred,k,xred)
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)
    lz=zzmax
    l=rmod2.vecgen1(lz)
    for i in range(0,lz):
        l[i]=len(lobj[i])

    pos=rmod2.vecgen1(lz)
    for i in range(0,lz):
        pos[i]=l[i]

    
    if rred>400:
        flagHD=0
        transfer0=[flagHD,0,0,0,0,0,0,0,lz,lobj,objred,rred,cov,l]
        return transfer0
    else:
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

   
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i

        
        
        flagHD=1
        transfer0=[flagHD,actwidth,actheight,geomx,geomy,garrow1x,garrow1y,garrow2y,lz,lobj,objred,rred,cov,l]
        return transfer0



def plot():
    # brg 30.8.2013,31.8.2013
    import Tkinter
    import Canvas
    tpdraw=Tkinter.Toplevel(hf)
    tpdraw.title(' Hassediagram ')
    freq=Tkinter.Frame(tpdraw,width=200,height=300)
    freq.pack()

    transfer=calc()
    
    actwidth=transfer[1]
    actheight=transfer[2]
    geomx=transfer[3]
    geomy=transfer[4]
    garrow1x=transfer[5]
    garrow1y=transfer[6]
    garrow2y=transfer[7]
    lz=transfer[8]
    lobj=transfer[9]
    objred=transfer[10]
    rred=transfer[11]
    cov=transfer[12]
    l=transfer[13]
    
    if transfer[0]==0:
        print "sorry not implemented yet!"
        print l
        print lobj
    else:
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        cv.pack()
        
        
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        
    

def bio():
    io()
    
def bplot():
    plot()
    
hf=Tkinter.Tk()
hf.title(" trafo ")

app1=raioop2.brgabout(hf,"tp1","help_trafo.txt",1,\
            "August, the 31th,2013"," help_trafo", "white", "t1",120,10,ScrolledText)
    
app2=raioop2.brgabout(hf,"tp2","about_trafo.txt",13,\
            "August, the 31th,2013"," about_trafo ", "white", "t1",120,5,ScrolledText)
    

butt1=Tkinter.Button(hf,text="Read in-procedure ",width=30,bg="cyan",command=bio)
butt1.pack()
butt2=Tkinter.Button(hf,text="Transformation of a column",bg="cyan",width=30,command=trafo)
butt2.pack()
butt4=Tkinter.Button(hf,text="Draw HD ",width=30,bg="cyan",command=plot)
butt4.pack()
butt10=Tkinter.Button(hf,text="  Exit   ",bg="red",bd=4,command=hf.destroy)
butt10.pack(pady=3)
hf.mainloop()



    
         
    
