import Tkinter
import rmod2
import raioop2
import random
from ScrolledText import *
import tkFileDialog
import Canvas
import os
from math import *

# u_partitioning programmed on the basis of dds12
# 2.3.16
# variabler input


global fn

def HD1():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
        
    global zeta,cov,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,k1,xred,objred,obj,txteq,eqm_act=filecomp(fn)
    n=rred
    k=k1
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    sumeq=0
    for i in range(0,r):
        for j in range(0,r):
            sumeq+=eqm_act[i][j]
    sumeq=sumeq-r
    if sumeq!=0:
        txteq_act=txteq
    else:
        txteq_act="no nontrivial eq.classes"
    
    labeq2=Tkinter.Label(freq,text="equivalence classes: \n"+txteq_act,bg="white",relief="groove",bd=3)
    labeq2.pack()
    #
    zetahilf=rmod2.comp(n,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    comparabilities=0
    utotal=0
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]

    for i in range(0,rred): #calculation of comparabilities
        for j in range(0,rred):
            if i!=j:
                comparabilities+=zeta[i][j]

    for i in range(0,rred): #calculation of utotal
        for j in range(0,rred):

            if zeta[i][j]==0  and zeta[j][i]==0:
                utotal+=1
    utotal=0.5*utotal            
#
    #One linear extension (based on levels)
    

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Level population ')
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    cov=rmod2.cover(n,tr,lext)

    if n>200:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(int(1.0*actwidth/2.0),actheight-5,text="compar.:  "+str(comparabilities)+\
                       ",   incomp. "+str(utotal))
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack(side="left",padx=5)
        buttcoverstore=Tkinter.Button(freq,text="store covermatrix ",command=stocov)
        buttcoverstore.pack(side="left",padx=5)
        buttgraphviz=Tkinter.Button(freq,text="store in graphviz format ",command=stogv)
        buttgraphviz.pack(side="left",padx=5)
        
def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08
    #note: There may be conflicts with other moduls
    #source:-
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    global fn
    fn=tkFileDialog.askopenfilename()
    
    
def stocov():
    """ stores the cover matrix """
   
    #rmod2.matout(rred,rred,cov)
    fnc=tkFileDialog.asksaveasfilename(title="Save file ",\
                                      defaultextension=".txt") #14.3.09
    #print "fnc = ",fnc,"    rred= ",rred
    rmod2.raiwritecov1(fnc,cov,objred,rred)   #14.3.09, 2.12.09

def stogv():
    """ stores the cover matrix in graphviz
        format """
    # brg 15.3.09
    # File-name is a request within 'brgsavefile1'
    txtgr=rmod2.covtxt(cov,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile1(hf,'yellow','t','w',txtgr,r,r)    
    
         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    

def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 14.1.08, 8.5.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
        #recoding ob to obj and pro to prop
    ## +++ Baustelle 4.4.2011 ++ hier muss equivcompactgr hinein und eqm
    ## zugaenglich gemacht werden +++
    global dm,ob,obj,pro,prop,k,k1,r,rred,xred,objred,txteq
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k1)+" columns"
    

    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k1)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k1):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txteq,eqmact=rmod2.equivcompactgr(r,k1,dm,obj)    
    ###############################################################
    return rred,k1,xred,objred,obj,txteq,eqmact
    

def inforep():
    """ informs about representants """
    # Brg 14.1.08 
    rred,k1,xred,objred,obj,txteq,eqm_act=filecomp(fn)
    hfinfo=Tkinter.Toplevel(hf)
    hfinfo.title(' equivalence classes ')
    lbhfinfo=Tkinter.Label(hfinfo, text=' information ')
    lbhfinfo.pack()
    tinfo=ScrolledText(hfinfo,width=60,height=4)
    tinfo.pack()
    txtrep="\n representants: \n"
    txtrep+=50*"="
    txtrep+="\n\n"
    for i in range(0,rred):
        txtrep+=objred[i]+", "
    txtrep+="\n\n ---   end of file   \n"
    tinfo.insert("end",txtrep)

    

def how_many():
    """how many entries are to be open"""
    #brg 26.12.07
    global e,hfs
    hfs=int(es.get())
    #print hfs
    e=rmod2.vecgen1(hfs)
    for i in range(0,hfs):
        e[i]=Tkinter.Entry(fr2,width=30)
        e[i].grid(columnspan=2,row=7+i)
    
    return hfs

def confirm():
    """ hfs entries are opened to read in hfs strings """
    #brg 26.12.07
    global ra
    #print "in confirm hfs=",hfs," ra = "
    ra=rmod2.vecgentext1(hfs)
    for i in range(0,hfs):
        ra[i]=e[i].get()
        #print ra[i]
    return ra



def rai_x(hfs,rai,objred):
    """ transformation of sequence (rai) into a vectorial quantity (x)"""
    #brg 26.12.07, 31.12.07
    #brg 14.1.08: renamed: calc --> rai_x, because there is no calculation 
    
    x=rmod2.vecgentext1(hfs)
    y=rmod2.vecgen1(hfs)
    lx=rmod2.vecgen1(hfs)
    #print "in rai_x"
##    for i in range(0,hfs):
##        print rai[i]
    for i in range(0,hfs):
        x[i]=rai[i].split(",")
    for i in range(0,hfs):
        lx[i]=len(x[i])
        y[i]=[]
        #print "i= ",i,"  lx = ",lx[i],"  x= ",x[i]
    lob=len(objred)
    
    for i in range(0,hfs):
        for j in range(0,lx[i]):
            for k in range(0,lob):
                if x[i][j] ==objred[k]:
                    y[i].append(k)

        
    txt="\n  subset selection \n"
    for i in range(0,hfs):
        txt+="\n Input was "+str(i+1)+": \n"
        for j in range(0,lx[i]):
            txt+=x[i][j]+"\t"
        txt+="\n"
    txt+="\n"
    hfsubset=Tkinter.Toplevel(hf)
    hfsubset.title('dds-subsets')
    lbhfsubset=Tkinter.Label(hfsubset,text=' subsets ')
    lbhfsubset.pack()
    t=ScrolledText(hfsubset,width=40,height=3)
    t.pack()
    t.insert("end",txt)
    return y,x,lx
        
def analysis():
    """the core of u_partitioning
    based on object subsets the
    characteristics of incomps are calculated"""
    #Brg  31.12.07, 14.1.08, 02.03.16
    # objx is the central zeta-matrix
    #Open the file
    # Excelreadin3 built in
    # Brg 29.11.07, 12.12.07
    global rai
    rred,k,xred,objred,obj,txt,eqm_act=filecomp(fn)  #filecomp reads the file fn
                                                  #which was selected in fileselect

    # here we have now objred, prop and xred
    dim_inter=hfs*hfs
    objx=rmod2.marray(rred,rred)
    Uinter=rmod2.marray(dim_inter,dim_inter)
    ninter=rmod2.marray(dim_inter,dim_inter)
    finter=rmod2.marray(dim_inter,dim_inter)
    udensity_inter=rmod2.marray(dim_inter,dim_inter)
    uRdensity=rmod2.marray(dim_inter,dim_inter)
    X=rmod2.marray(dim_inter,dim_inter)
    for i1 in range(0,hfs):
        for i2 in range(0, hfs):
            if i1==i2:
                X[i1][i2]="X("+str(i1+1)+"]"
            else:
                X[i1][i2]="X("+str(i1+1)+","+str(i2+1)+")"

    zeta=rmod2.comp(rred,k,xred)
    ra=confirm()          ####!!!26.7.08
    rai,x,lrai=rai_x(hfs,ra,objred)  #27.5.08
    print "rai"
    for i2 in range(0,hfs):
        print "rai i2 ",rai[i2]
        for i1 in range(0,len(rai[i2])):
            print rai[i2][i1],"***",
        print" "    
    #######################################
    # 02032016 core
    
    Utot=0
    for i1 in range(0, hfs):
        for i2 in range(0, hfs):
            Uinter[i1][i2]=0
            for iob1 in rai[i1]:
                for iob2 in rai[i2]:
                    if zeta[iob1][iob2]==0 and zeta[iob2][iob1]==0:
                        if i1==i2:
                            Uinter[i1][i2]+=0.5   #diagonal
                        else:
                            Uinter[i1][i2]+=1     #Only the upper triangle is of interest
    for i1 in range(0,hfs):
        for i2 in range(i1,hfs):
            Utot+=Uinter[i1][i2]
    print "Utot= ",Utot       
    print "U_inter "
    rmod2.matout(hfs,hfs,Uinter)
    for i1 in range(0, hfs):
        ni1=len(rai[i1])
        for i2 in range(0, hfs):
            ni2=len(rai[i2])
            if i1==i2:
                ninter[i1][i2]=(ni1*(ni1-1)/2.0)
            else:
                ninter[i1][i2]=ni1*ni2
    print "ninter= "
    ng=int(rred*(rred-1.0)/2.0)
    print "ng= ",ng
    URtot = 1.0*Utot/ng
    print "Utotdensity= ",URtot
    rmod2.matout(hfs,hfs,ninter)
    for i1 in range(0, hfs):
        ni1=len(rai[i1])
        print i1,"ni1= ",ni1
        for i2 in range(0, hfs):
            ni2=len(rai[i2])
            print i2,"ni2= ",ni2
            if i1==i2:
                finter[i1][i2]=(ni1*(ni1-1)/2.0)/ng
            else:
                finter[i1][i2]=1.0*ni1*ni2/ng
    print "finter= "
    rmod2.matout(hfs,hfs,finter)            
    controlsum = 0
    for i1 in range(0, hfs):
        for i2 in range(i1,hfs):
            controlsum+=finter[i1][i2]
    print "controlsum= ",round(controlsum,4)       
    for i1 in range(0,hfs):
        for i2 in range(0,hfs):
            udensity_inter[i1][i2]=1.0*Uinter[i1][i2]/ninter[i1][i2]
            print i1,i2,"  udensity_inter= ",udensity_inter[i1][i2]
    print "udensity-matrix "
    rmod2.matout(hfs,hfs, udensity_inter)
    ucontrol=0
    for i1 in range(0,hfs):
        for i2 in range(0, hfs):
            uRdensity[i1][i2]=1.0*finter[i1][i2]*udensity_inter[i1][i2]
            print i1,i2, uRdensity[i1][i2]
    print "uRdensity"
    rmod2.matout(hfs,hfs,uRdensity)
    ucontrol2=0
    for i1 in range(0,hfs):
        for i2 in range(i1,hfs):
            ucontrol2+=uRdensity[i1][i2]
    print "ucontrol= ",ucontrol2," sollte gleich UT/ng sein: ", URtot
    tpresult= Tkinter.Toplevel(hf)
    #tpresult.title("U-Partitioning")
    tresult=ScrolledText(tpresult, height=20,width=80)
    tresult.pack()
    txt="Partitioning of Incomparabilities"+"\n"
    txt+=60*"="+"\n"
    txt+= "U-matrix"+"\n"
    for i1 in range(0, hfs):
        for i2 in range(i1,hfs):
            txt+="U["+str(X[i1][i2])+"]:= "+"\t"+str(round(Uinter[i1][i2],3))+"\n"
    txt+="\n"
    txt+="U total "+str(Utot)+"\n"
    txt+="ninter-matrix"+"\n"
    for i1 in range(0, hfs):
        for i2 in range(i1,hfs):
            txt+="ninter["+str(X[i1][i2])+"]:= "+str(round(ninter[i1][i2],3))+"\n"
    txt+="\n"
    txt+="finter-matrix"+"\n"
    for i1 in range(0, hfs):
        for i2 in range(i1,hfs):
            txt+="finter["+str(X[i1][i2])+"]:= "+"\t"+str(round(finter[i1][i2],3))+"\n"
    txt+="\n"
    txt+="Udensity-matrix =(U(i,j)/ninter(i,j) "+"\n"
    for i1 in range(0, hfs):
        for i2 in range(i1,hfs):
            txt+="Udensity["+str(X[i1][i2])+"]:= "+"\t"+str(round(udensity_inter[i1][i2],3))+"\n"
    txt+="\n"
    txt+="Urelatdensity-matrix = Udensity(i,j)*finter(i,j) "+"\n"
    for i1 in range(0, hfs):
        for i2 in range(i1,hfs):
            txt+="Urelatdensitx["+str(X[i1][i2])+"]:= "+"\t"+str(round(uRdensity[i1][i2],3))+"\n"
    txt+="\n"
    txt+="U total_density = "+str(URtot)+"\n"
    txt+="\n"
    txt+="-   -   -   eof   -   -  -"+"\n"
    tresult.insert("end",txt)
    
            

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)
    


hf=Tkinter.Tk()
hf.title(' u_partitioning ')
lbdds8=Tkinter.Label(hf,text=" U_Partitioning ",width=50)
lbdds8.pack(pady=5)
helpdds=raioop2.brgabout(hf,"tp1","help_u_part.txt",1,\
            "March, the 2nd,2016"," help_u_part ", "white", "t1",120,5,ScrolledText)
    
aboutdds=raioop2.brgabout(hf,"tp1","about_u_part.txt",1,\
                          "March, the 2nd, 2016"," about u_part ","white","t1",120,5,ScrolledText)




fr2=Tkinter.Frame(hf,width=60,height=50,relief="sunken",bd=4)
fr2.pack(pady=5)
#In fr2 exclusively grid - geometry manager  (26.7.08)
buttsubmit=Tkinter.Button(fr2,text="(1) select and open file",width=25,bg="white",command=fileselect)
buttsubmit.grid(columnspan=2,row=1)
lbopen1=Tkinter.Label(fr2,text="")
lbopen1.grid(columnspan=2,row=2)
buttinfo=Tkinter.Button(fr2,text="(2a) show the representants ",width=25,command=inforep)
buttinfo.grid(columnspan=3,row=3)
buttshow=Tkinter.Button(fr2,text="(2b) show data matrix",width=25, command=showDM)
buttshow.grid(columnspan=3,row=4)
lbsubset=Tkinter.Label(fr2,text="")
lbsubset.grid(columnspan=3,row=5)
lb2=Tkinter.Label(fr2,text=">>> How many subsets? >>>>")
lb2.grid(column=0,row=5)
es=Tkinter.Entry(fr2,width=3)
es.grid(column=1,row=5)
butt1=Tkinter.Button(fr2,text="(3) confirm the number of subsets",command=how_many)
butt1.grid(columnspan=3,row=6)
fr3=Tkinter.Frame(hf,relief="sunken",bd=2)
fr3.pack(pady=5)
mainprog=Tkinter.Button(fr3,text="(5) analysis",bg="cyan",width=25,command=analysis)
mainprog.pack(pady=3)
frperturb=Tkinter.Frame(hf)   #next lines new 3.4.2011
frperturb.pack()
lbperturb=Tkinter.Label(frperturb,text="0 for no perturb., 1,... for perturbed HD ")
lbperturb.pack(side="left",pady=10)
eperturb=Tkinter.Entry(frperturb,width=2)
eperturb.pack(side="left")
buttHD=Tkinter.Button(hf,text=" (2c) HD ",bg="cyan",width=25,command=HD1)
buttHD.pack()
buttexit=Tkinter.Button(hf,text=" Exit ",width=25,bd=4,bg="red",command=hf.destroy)
buttexit.pack(pady=20)
hf.mainloop()
