import rmod2
import os
import sys
from glob import *
from time import *
import Tkinter
from ScrolledText import ScrolledText
import raioop2

# brg 17.7.2012
# brg 30.10.2012 cosmetics
# brg 15.06.2014 Modules written/changed sorted after years
# brg 04.08.18

def pathfind():
    # brg 17.7.2012, 30.10.2012, 15.6.2014, 04.08.18
    year0=2007
    yearend=eyearend.get()
    path="F:\\Pythonprogramme\PyHasse\RainerHasse"
    year=rmod2.vecgen1(20)
    lp=len(path)
    xall=glob(path+"\*.py")
    #print xall
    txt="PyHasse-Modules\n"
    txt+="2007 "+" "+str(yearend)+"\n"
    txt+=50*"="+"\n"
    for y in range(2007,int(yearend)+1):
        zahly=0
        for x in xall:
            lx=len(x)
            info=os.stat(x)
            ty=info[8]
            ltx=localtime(ty)
            timeact=int(ltx[0])
            if timeact==y:
                zahly+=1
        txt+=str(y)+"\t"+str(zahly)+"\n"
    txt+="- - - -   e o f - - - - "
    tputility=Tkinter.Toplevel(hf)
    tputility.title("PyHasse programs 2007-"+str(yearend))
    t=ScrolledText(tputility,width=60,height=15)
    t.pack()
    t.insert("end",txt)
    


hf=Tkinter.Tk()
hf.title(' How many modules in the years 2007 - ... ')
about_ut_1=raioop2.brgabout(hf,"tp1","about_utilityyears.txt",1,\
            "August, the 04th, 2018"," about utility_year ", "white", "t1",80,5,ScrolledText)
help_ut_1=raioop2.brgabout(hf,"tp1","help_utilityyears.txt",1,\
            "August, the 04th,2018"," help_utility_year ", "white", "t1",80,5,ScrolledText)
lbet=Tkinter.Label(hf,text="Insert start: actual year (e.g. 2014) ")
lbet.pack()
eyearend=Tkinter.Entry(hf,width=4)
eyearend.pack()
butt1=Tkinter.Button(hf,text="Info: PyHasse year's count: GO! ",width=40,bg="cyan",command=pathfind)
butt1.pack()
fr=Tkinter.Frame(hf,bd=2,relief="sunken")
fr.pack()
buttexit=Tkinter.Button(hf,text=" exit ",bg="red",width=30,command=hf.destroy)
buttexit.pack()

hf.mainloop()
           
