import Tkinter
from ScrolledText import *

def geninst():
    #Brg 12.11.2010
    tp1=Tkinter.Toplevel(hf)
    tp1.title(' Overview ')
    t1=ScrolledText(tp1,width=120,height=25)
    t1.pack()
    txt1=" General instructions "+"\n"
    txt1+=55*"="+"\n"
    txt1+="The CD of PyHasse consists of"+"\n"
    txt1+="install0.txt, which you already may have read"+"\n"
    txt1+="Folder: PyHasse"+"\n"
    txt1+="     with subfolders: "+"\n"
    txt1+="     (1) cov_files:         storage of cover matrices"+"\n"
    txt1+="     (2) graphviz_files:    storage of files provided for graphviz"+"\n"
    txt1+="     (3) modifdm:           storage of data matrices in pdt-format for internal exchange"+"\n"
    txt1+="     (4) modules:           Very important: Here are four libraries: "+"\n"
    txt1+="                             rmod2: basic routines written by Bruggemann"+"\n"
    txt1+="                             raioop2: classes (graphics, design, etc) also written by Bruggemann "+"\n"
    txt1+="                             pstat and stat with basic statistical routines, downloaded freely from Internet"+"\n"
    txt1+="     (5) PyHassedatafiles:  My own data files. You may erase them to store there your own data files"+"\n"
    txt1+="     (6) RainerHasse:       Very important: The core of PyHasse:"+"\n"
    txt1+="                              about- and help-texts "+"\n"
    txt1+="                              The single programs, all with extension .py"+"\n"
    txt1+="     (7) sets:              Some of the PyHasse-programs need as input sets or deliver sets. They are stored here."+"\n"
    txt1+="     (8) testdm             data matrices randomly generated "+"\n"
    txt1+="     (9) tutorial           Many (hopefully!) instructive texts to install and run PyHasse"+"\n"
    t1.insert("end",txt1)    
    
    
def how_to_run():
    #brg 12.11.2010
    tp2=Tkinter.Toplevel(hf)
    tp2.title('details how to run ')
    t2=ScrolledText(tp2,width=120,height=25)
    t2.pack()
    txt2=" Details: How to run PyHasse"+"\n"
    txt2+=55*"="+"\n"
    txt2+="When you read these lines you already know how to run PyHasse!!"+"\n"
    txt2+="However, for running PyHasse-programs, stored in 'RainerHasse' you need some preparatory steps"+"\n"
    txt2+="The libraries, which are stored in 'modules' ...."+"\n"
    txt2+=".... within the folder 'PyHasse' of your CD must be put into your folder, where Python2.6 was installed"+"\n"
    txt2+="The best is to copy the four libraries 'rmod2', 'raioop2' , 'pstat' and 'stats' ..."+"\n"
    txt2+=".... and then to paste them directly under Python2.6 "+"\n"
    txt2+="You may generate an own new folder for your data, instead of my own huge PyHassedatafile" +"\n"
    txt2+="It is then recommended to add the new folder to your PyHasse...."+"\n"
    txt2+="...in order to avoid long search-paths"+"\n"
    txt2+="\n"
    txt2+="Steps to run programs of PyHasse: "+"\n"
    txt2+="a) you know already the name of the program which you would like to work with (see tutorial)"+"\n"
    txt2+="    IDLE, double click"+"\n"
    txt2+="    Select the program "+"\n"
    txt2+="          either by 'open' "+"\n"
    txt2+="          or by 'recent files ' "+"\n"
    txt2+="    You see the source code " +"\n"
    txt2+="    Select 'Run'"+"\n"
    txt2+="    Select 'Run Module (F5)'"+"\n"
    txt2+="    The user interface is opening and then you can follow what the help-texts are advising you"+"\n"
    txt2+="b) you don't know the name of the program which you would like to run "+"\n"
    txt2+="    Select pyhassemenue8.py (8 is the version number and may change )"+"\n"
    txt2+="    pyhassemenue offers many information about PyHasse and also allows you to see which program ..."+"\n"
    txt2+="    .... of PyHasse may be suitable for your purposes "+"\n"
    txt2+="    Follow the menuebar of pyhassemenue "+"\n"
    t2.insert("end",txt2)
    
def useful():
    #Brg 12.11.2010
    tp3=Tkinter.Toplevel(hf)
    tp3.title('some useful information ')
    t3=ScrolledText(tp3,width=120,height=25)
    t3.pack()
    txt3=" Some useful information about PyHasse"+"\n"
    txt3+=55*"="+"\n"
    txt3+="Structure of the user interface"+"\n"
    txt3+="a) In most cases there is one main window awaiting your actions"+"\n"
    txt3+="   At the top you will find buttons 'about' and 'help' (in green color)"+"\n"
    txt3+="   Then the sequence of commands is (most often) vertically arranged "+"\n"
    txt3+="   Select and Open data matrix, show data matrix, specific commands "+"\n"
    txt3+="   Grey buttons: optionally "+"\n"
    txt3+="   In cyan color: the important ones "+"\n"
    txt3+="   In some important programs buttons are deactivated as long needed calculations are not performed "+"\n"
    txt3+="   When the mouse is touching them and the color changes to cyan then the buttons are ready for the next steps "+"\n"
    txt3+="b) In some few cases , like in pyhassemenue the program is menue-oriented"+"\n"
    txt3+="    "+"\n"
    txt3+="About and help-texts "+"\n"
    txt3+=" 'about' gives a brief information and encourages you to ask the programmer in case of difficulties...."+"\n"
    txt3+="  'help' has the structure:  "+"\n"
    txt3+="   a) Aim, b) Prerequisites c) steps or usage d) (in complicated programs: results ) e) difficulties f) References " +"\n"
    txt3+="    "+"\n"
    txt3+="Most important programs  "+"\n"
    txt3+="mainHD version 9_3_3: Hasse diagrams , upsets, downsets, intervals, Bubley Dyer, Local Partial Order Model"+"\n"
    txt3+="dds version 8: Partition the object set into subsets: What is the dominance relation amog the subsets "+"\n"
    txt3+="sensi (version 17): sensitivity analysis globally and locally"+"\n"
    txt3+="simi (version 5): proximity analysis of two posets "+"\n"
    txt3+="pyhassemenue (version 8) : Access to all PyHasse programs (menue-governed) "+"\n"
    txt3+="avrank (version 4): lattice theoretical method to get exact ranks ..."+"\n"
    txt3+=".....(only if number of incomparability*number of objects is not too large) "+"\n"
    txt3+="hdgt (version 5): Beside some graph theoretical information: extended local partial order model ..."+"\n"
    txt3+="...after Bruggemann and Carlsen "+"\n"
    txt3+="Many more programs are available, see overview in pyhassemenue "+"\n"
    t3.insert("end",txt3)




hf=Tkinter.Tk()
butt1=Tkinter.Button(hf,text="General instructions ",width=40,bg="cyan",command=geninst)
butt1.pack(pady=5)
butt2=Tkinter.Button(hf,text="Details for running PyHasse ",width=40,bg="cyan",command=how_to_run)
butt2.pack(pady=5)
butt3=Tkinter.Button(hf,text="Some useful information about PyHasse ",bg="cyan",width=40,command=useful)
butt3.pack(pady=5)






buttexit=Tkinter.Button(hf,text="  exit ",bg="red",width=40,command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()
