import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import math

import Canvas
import os
import pstat
import stats
import csv
from string import replace



# 25.11.2013: ACsimple1.py derived from antichain20_4.py
# 20.8.2014 bug mit lbpdtopen


def xselectfile():
    # brg 6.8.2013, 25.11.2013 (taken from fuzzysimpl
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)




def xfileopen():
    """Informs about the file-operations"""
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    #rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)   #6.8.2013

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # corrections 22.8.2014
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)    

##### end ofg editenster ### 29.8.2013 ####




def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def HD():
    # brg 26.7.2013, 29.8.2013, 25.11.2013
    global x,la,ls,xred,cov,n,txteq
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()

        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

    n=rred
    teqorig=ScrolledText(freq,width=60,height=5)
    teqorig.pack()
    txteq2="Equivalence classes of \n"+str(fn)+"\n"
    txteq2+="\n"+txteq+"\n"
    teqorig.insert("end",txteq2)
    #
    
def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    tpcover=Tkinter.Toplevel(hf)
    tpcover.title(' cover-matrix ')
    lbhd2=Tkinter.Label(tpcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    n=rred
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(tpcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y            
         

def inread():
    #brg 13.8.10, 25.4.2011
    x1=set(ex1.get().split(","))
    
    if len(x1)<=1:
        lbwarning.config(text="++Note: Wrong input++++ ",bg="yellow")
    else:
        lbwarning.config(text="Antichain has more than one element ")
        
    lx1=len(x1)
    print x1," len x1",lx1
    return x1,lx1

def ac_statistics():
    # brg 22.9.2010, 21.3.2012,26.3.2012, 31.3.2012,9.4.2012
    global eattr,emino,emaxo,emina,emaxa, propmatrix,tpanti,k
    global densobjdisc,objdisc,densattdisc,maxd2,d1,d2,listobjpair,attmatrix
    #Note: pstat seems to render a pretty crude approximation brg 26.3.2012
    x1,xd1=inread()  #4.11.2010
    #print "xd1= ",xd1
    tpanti=Tkinter.Toplevel(hf)
    tpanti.title(' antichain-analysis ')
    tant=ScrolledText(tpanti,width=60, height=10)
    tant.pack()
    
    d1=int(1.0*xd1*(xd1-1.0)/2.0)
    d2=int(1.0*k*(k-1)/2.0)
    
    propmatrix=rmod2.marray(d1,d2)
    listobjpair=rmod2.vecgen1(d1)
    listattrpair=rmod2.vecgen1(d2)
    densobjdisc=rmod2.vecgen1(d2)
    densobjdisc=rmod2.vecgen1(d1)
    
    attmatrix=rmod2.marray(k,k)   #26.3.2012
    for k1 in range(0,k):
        for k2 in range(k1+1,k):
            for ob1 in x1:
                for ob2 in x1:
                    bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                    bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                    bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                    bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                    if (bool1 and bool2) or (bool3 and bool4):
                        attmatrix[k1][k2]+=0.5
                  
    deltax1=set([])
    txtatt=""
    z1=0
    for ob1 in x1:
        deltax1.add(ob1)
        for ob2 in x1:
            if ob2 not in deltax1:
                txtatt+="\n\n"+ob1+","+ob2+": "
                z2=0
                
                for k1 in range(0,k):
                    for k2 in range(k1+1,k):
                        bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                        bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                        bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                        bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                        if (bool1 and bool2) or (bool3 and bool4):
                            txtatt+="("+str(prop[k1])+", "+str(prop[k2])+"), "
                            propmatrix[z1][z2]+=1
                        listattrpair[z2]=[prop[k1],prop[k2]]    
                        z2+=1
                        
                listobjpair[z1]=[ob1,ob2]
                z1+=1

           
    txt="Antichain-analysis "+"\n"
    objdisc=rmod2.matrixrowsum(propmatrix,d1,d2)
    attdisc=rmod2.matrixcolsum(propmatrix,d1,d2)
    hilfd21=k*k
    maxd2=math.floor(1.0*hilfd21/4.0) #Turan s theorem
    txt+="Objectpairs' analysis \n"
    txt+="d1 = "+str(d1)+"\t"+"=maximum possible object pairs from AC "+"\n"
    densattdisc=rmod2.vecgen1(d2)
    for i in range(0,d1):
        densobjdisc[i]=1.0*objdisc[i]/(1.0*maxd2)
        txt+=str(listobjpair[i])+":\t"+str(objdisc[i])+"\t density (/maxd2):\t"+str(round(densobjdisc[i],2))+"\n"  #4.11.2010 d1->d2
    txt+="\n\n"
    
    # attmatrix normalizing
    txt+="attributepairs analysis "+"\n"
    txt+="d2= "+str(d2)+"\t"+"max. possible: maxd2="+str(maxd2)+" of attribute pairs \n"
    for i1 in range(0,k):
        for j1 in range(i1+1,k):
            attmatrix[i1][j1]=1.0*attmatrix[i1][j1]/(1.0*d1)
   
    
    for i in range(0,d2):
        densattdisc[i]=1.0*attdisc[i]/(1.0*d1)
        txt+=str(listattrpair[i])+":\t"+str(attdisc[i])+"\t density (/d1):\t"+str(round(densattdisc[i],2))+"\n" #4.11.2010: d2-> d1
    txt+="\n"
    txt+="Frequence how often an attribute is contributing to incomparability "+"\n"
    txt+="of the objects in the selected AC "+"\n"
    lp=len(listattrpair)
    for proname in prop:
        #print "proame= ",proname
        z3=0
        txt+=proname+": \t"
        for j in range(0,lp):
            if proname == listattrpair[j][0] or proname == listattrpair[j][1]:
                z3+=attdisc[j]
        txt+=str(z3)+"\n"
        
    txt+="\n\n"        
    txt+="\n Individual analysis: object pairs  \n"
    txt+=txtatt
    txt2att="Individual analysis: attribute pairs \n"
    
    #z4=0
    for k1 in range(0,k):
        for k2 in range(k1+1,k):  #24.4.2011
            #indatt[z4]=set([])
            #z4+=1
            txt2att+="\n"+str(prop[k1])+" "+str(prop[k2])+": "
            delta2x1=set([])
            for ob1 in x1:
                delta2x1.add(ob1)
                for ob2 in x1:
                    if ob2 not in delta2x1:
                        bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                        bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                        bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                        bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                        if (bool1 and bool2) or (bool3 and bool4):
                            #print k1," ",k2," ",ob1," ",ob2
                            txt2att+="("+ob1+", "+ob2+"), "
                            #indatt[z4].add("("+ob1+","+ob2+")")
                        
    
    
    txt2att+="\n - - - e o f - - - "
    txt+=txt2att
    tant.insert("end",txt)
    
    


def acmatrix():
    # brg 25.4.2010
    global eattr,tpac,propmatrix,listobjpair,listattrpair,k
    x1,xd1=inread()  #4.11.2010
    #print "xd1= ",xd1
    d1=int(1.0*xd1*(xd1-1.0)/2.0)
    d2=int(1.0*k*(k-1)/2.0)
    propmatrix=rmod2.marray(d1,d2)
    listobjpair=rmod2.vecgen1(d1)
    listattrpair=rmod2.vecgen1(d2)
    deltax1=set([])
    
    txtatt=""
    z1=0
    for ob1 in x1:
        deltax1.add(ob1)
        for ob2 in x1:
            if ob2 not in deltax1:
                txtatt+="\n\n"+ob1+","+ob2+": "
                z2=0
                
                for k1 in range(0,k):
                    for k2 in range(k1+1,k):
                        bool1=xred[objred.index(ob1)][k1]>xred[objred.index(ob2)][k1]
                        bool2=xred[objred.index(ob1)][k2]<xred[objred.index(ob2)][k2]
                        bool3=xred[objred.index(ob1)][k1]<xred[objred.index(ob2)][k1]
                        bool4=xred[objred.index(ob1)][k2]>xred[objred.index(ob2)][k2]
                        if (bool1 and bool2) or (bool3 and bool4):
                            txtatt+=str(prop[k1])+" "+str(prop[k2])+", "
                            propmatrix[z1][z2]+=1
                        listattrpair[z2]=[prop[k1],prop[k2]]    
                        z2+=1
                        
                listobjpair[z1]=[ob1,ob2]
                z1+=1

    tpac=Tkinter.Toplevel(hf)
    tpac.title(' AC-matrix ')
    tac=ScrolledText(tpac,width=180,height=20)
    tac.pack()
    txt=" Matrix AC "+"\n"
    txt+=100*"="+"\n\t"
    for i in range(0,len(listattrpair)):
        txt+=str(listattrpair[i])+"\t"
    txt+="\n"
    for i in range(0,len(listobjpair)):
        txt+=str(listobjpair[i])+":\t"
        for j in range(0,len(listattrpair)):
            txt+=str(propmatrix[i][j])+"\t"
        txt+="\n"
    txt+="\n"
    txt+="- - - e o f - - - "
    tac.insert("end",txt)
    tac.configure(font=("arial",7))
    
    

     
def tripartite_graph():
    #  brg 19.1.2012
    # Only the set of buttons for complete, objectpair or selected attribute
    global eob1,eob2,eatt1,tptrip0
    tptrip0=Tkinter.Toplevel(hf)
    tptrip0.title(' tripartite graph of AC ')
    
    frtg=Tkinter.Frame(tptrip0, bd=4, relief="sunken")
    frtg.pack()
    butt1=Tkinter.Button(frtg,text=" All vertices of the tripartite graph ",width=40,bg="cyan",command=atp)
    butt1.pack()
    frtg1=Tkinter.Frame(frtg)
    frtg1.pack()
    eob1=Tkinter.Entry(frtg1,width=4)
    eob1.pack(side="left")
    eob2=Tkinter.Entry(frtg1,width=4)
    eob2.pack(side="left")
    butt2=Tkinter.Button(frtg1,text=" One objectpair  ",width=40,bg="cyan",command=atp7b)
    butt2.pack(side="left",fill="x")
    frtg2=Tkinter.Frame(frtg)
    frtg2.pack()
    eatt1=Tkinter.Entry(frtg2,width=4)
    eatt1.pack(side="left")
    butt3=Tkinter.Button(frtg2,text=" One attribute (0,1,..,"+str(k-1)+ " )",width=40,bg="cyan",command=atp7c)
    butt3.pack(side="left",fill="x")
    
def atp():
    # brg taken and modified from sepanal16 , 19.1.2012
    global tptrip,k
    tptrip=Tkinter.Toplevel(hf)
    tptrip.title(' complete tripartite graph of AC ')
    
    x1,xd1=inread()
    nlist =int(1.0*xd1*(xd1-1.0)/2.0)
    objlist=rmod2.vecgen1(xd1)
    zahl=0
    for ob in x1:
        iob=objred.index(ob)
        objlist[zahl]=iob
        zahl+=1
    listpaar=[]
    for i1 in range(0,xd1):
        for i2 in range(i1+1,xd1):
            listpaar.append([objlist[i1],objlist[i2]])
    
    cv=Tkinter.Canvas(tptrip,width=400,height=400,bg="white")
    cv.config(scrollregion=(0,0,1000,1000)) 
    cv.config(highlightthickness=1)
    t="0123456789"
    tt=7*t
    lb1=Tkinter.Label(cv,text=tt,bg="yellow")
    lb1.pack()


    sbary=Tkinter.Scrollbar(cv,orient="vertical")
    sbary.config(command=cv.yview) 
    cv.config(yscrollcommand=sbary.set) 
    sbary.pack(side="right", fill="y")
    cv.pack(side="left",expand="yes",fill="both")
    pos1=rmod2.marray(k,2)
    pos2=rmod2.marray(nlist,2)
    pos3=rmod2.marray(k,2)
    ct01=cv.create_text(130,40,text=" x > y ")
    ct012=cv.create_text(200,40,text=" (x,y) ")
    ct02=cv.create_text(270,40,text=" x < y ") 
    for j in range(0,k):
        pos1[j][0]=75
        pos3[j][0]=325
        pos1[j][1]=60+20*j
        pos3[j][1]=60+20*j

    for i in range(0,nlist):
        pos2[i][0]=200
        pos2[i][1]=60+20*i

    for j in range(0,k):
        xx=pos1[j][0]
        yy=pos1[j][1]
        ct1=cv.create_text(xx,yy,text=prop[j])

        xx2=pos3[j][0]
        yy2=pos3[j][1]
        ct2=cv.create_text(xx2,yy2,text=prop[j])

    for i in range(0,nlist):
        xx1=pos2[i][0]
        yy1=pos2[i][1]
        ctp=cv.create_text(xx1,yy1,text="("+str(objred[listpaar[i][0]])+","+str(objred[listpaar[i][1]])+")")

    for j in range(0,k):
        for i in range(0,nlist):
            io1=listpaar[i][0]
            io2=listpaar[i][1]
            if xred[io1][j]>xred[io2][j]:
                o1o2q=1
                
            if xred[io1][j]==xred[io2][j]:
                o1o2q=0
               
            if xred[io1][j]<xred[io2][j]:
                o1o2q=-1
            if o1o2q==1:
                line1=cv.create_line(pos1[j][0]+15,pos1[j][1],pos2[i][0]-20,pos2[i][1],fill="red")
            if o1o2q==-1:
                line2=cv.create_line(pos3[j][0]-15,pos3[j][1],pos2[i][0]+20,pos2[i][1],fill="blue")


def atp7b():
    #brg 22.8.10  individual analysis
    # 19.1.2012 taken from sepanal16, co7 there
    global eob1,eob2,tpco7,k
    tpco7=Tkinter.Toplevel(hf)
    tpco7.title(' individual analysis ')
    th="0123456789"
    tt=7*th
    x1,xd1=inread()
    nlist =int(1.0*xd1*(xd1-1.0)/2.0)
    objlist=rmod2.vecgen1(xd1)
    zahl=0
    for ob in x1:
        iob=objred.index(ob)
        objlist[zahl]=iob
        zahl+=1
    listpaar=[]
    for i1 in range(0,xd1):
        for i2 in range(i1+1,xd1):
            listpaar.append([objlist[i1],objlist[i2]])
    

    
    ob1=eob1.get()
    iob1=objred.index(ob1)
    ob2=eob2.get()
    iob2=objred.index(ob2)
    
    cv2=Tkinter.Canvas(tpco7,width=400,height=400,bg="white")
    lb2=Tkinter.Label(tpco7,text=tt,bg="yellow")
    lb2.pack()
    cv2.pack(expand="yes",fill="both")
    pos12=rmod2.marray(k,2)
    pos32=rmod2.marray(k,2)
    ct01=cv2.create_text(130,40,text=" x  > y ")
    ct012=cv2.create_text(200,40,text=" (x,y) ")
    ct02=cv2.create_text(270,40,text=" x  < y ") 
    for j in range(0,k):
        pos12[j][0]=75
        pos32[j][0]=325
        pos12[j][1]=60+20*j
        pos32[j][1]=60+20*j


    for j in range(0,k):
        xx1=pos12[j][0]
        yy1=pos12[j][1]
        ct1=cv2.create_text(xx1,yy1,text=prop[j])

        x3=pos32[j][0]
        y3=pos32[j][1]
        ct2=cv2.create_text(x3,y3,text=prop[j])


    xx2=200
    yy2=60+k*10
    ctp=cv2.create_text(xx2,yy2,text="("+ob1+","+ob2+")")

    for j in range(0,k):
        if xred[iob1][j]>xred[iob2][j]:
                o1o2q=1
                
        if xred[iob1][j]==xred[iob2][j]:
            o1o2q=0
           
        if xred[iob1][j]<xred[iob2][j]:
            o1o2q=-1

        if o1o2q==1:
            line1=cv2.create_line(pos12[j][0]+15,pos12[j][1],xx2-15,yy2,fill="red",width=2)
        if o1o2q==-1:
            line2=cv2.create_line(pos32[j][0]-15,pos32[j][1],xx2+15,yy2,fill="blue",width=2)



def atp7c():
    #brg 4.9.10
    #brg 22.8.10  individual analysis
    # brg 19.1.2012 taken from sepanal16
    global eatt1,tpco7b
    tpco7b=Tkinter.Toplevel(hf)
    tpco7b.title(' individual analysis /attr. ')
    th="0123456789"
    tt=7*th
    x1,xd1=inread()
    nlist =int(1.0*xd1*(xd1-1.0)/2.0)
    objlist=rmod2.vecgen1(xd1)
    zahl=0
    for ob in x1:
        iob=objred.index(ob)
        objlist[zahl]=iob
        zahl+=1
    listpaar=[]
    for i1 in range(0,xd1):
        for i2 in range(i1+1,xd1):
            listpaar.append([objlist[i1],objlist[i2]])
    
    
    iatt=int(eatt1.get())
    
    
    cv2=Tkinter.Canvas(tpco7b,width=400,height=400,bg="white")
    lb2=Tkinter.Label(tpco7b,text=tt,bg="yellow")
    lb2.pack()
    cv2.pack(expand="yes",fill="both")
    pos12=rmod2.marray(1,2)
    pos32=rmod2.marray(1,2)
    ct01=cv2.create_text(130,40,text=" x  > y ")
    ct012=cv2.create_text(200,40,text="(x,y)")
    ct02=cv2.create_text(270,40,text=" x  < y ") 
    
    
    pos12[0][0]=75
    pos32[0][0]=325
    pos12[0][1]=120
    pos32[0][1]=120


    ct1=cv2.create_text(pos12[0][0],pos12[0][1],text=prop[iatt])
    ct2=cv2.create_text(pos32[0][0],pos32[0][1],text=prop[iatt])

    for i in range(0,nlist):
        ctp=cv2.create_text(200,60+15*i,text="("+str(objred[listpaar[i][0]])+","+str(objred[listpaar[i][1]])+")")

    for i in range(0,nlist):
        iob1=listpaar[i][0]
        iob2=listpaar[i][1]
        if xred[iob1][iatt]>xred[iob2][iatt]:
                o1o2q=1
                
        if xred[iob1][iatt]==xred[iob2][iatt]:
            o1o2q=0
           
        if xred[iob1][iatt]<xred[iob2][iatt]:
            o1o2q=-1

        if o1o2q==1:
            line1=cv2.create_line(pos12[0][0]+15,pos12[0][1],200-15,60+15*i,fill="red",width=2)
        if o1o2q==-1:
            line2=cv2.create_line(pos32[0][0]-15,pos32[0][1],200+15,60+15*i,fill="blue",width=2)
    


hf=Tkinter.Tk()
hf.title('--   GUI ACsimple   -- ')

aboutmainHD=raioop2.brgabout(hf,"tp1","about_ACsimpl.txt",1,\
            "Nov., the 25th, 2013"," about ACsimpl ", "white", "t1",120,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_ACsimpl.txt",1,\
            "Nov., the 25th, 2013"," help_ACsimpl ", "white", "t1",120,10,ScrolledText)
    
fr1=Tkinter.Frame(hf,width=60)   #about, help, fn, lbopen1
fr1.pack()
fr11=Tkinter.Frame(fr1,width=60)
fr11.pack()
Buttfn=Tkinter.Button(fr11,text="select&open-file",width=30,bg="cyan",command=xselectfile)
Buttfn.pack()
lbopen1=Tkinter.Label(fr1,text="",width=60)
lbopen1.pack()
lbpdtopen = Tkinter.Label(fr1, text="",width = 60)
lbpdtopen.pack()
fr12=Tkinter.Frame(fr1,width=60)
fr12.pack()
Buttshow=Tkinter.Button(fr12,text="show data matrix from txt-file",bg="cyan",width=30,command=showDM)
Buttshow.pack()
ButtHD=Tkinter.Button(fr12,text="Hassediagram ",width=30,bg="cyan",command=HD)
ButtHD.pack()
fr13=Tkinter.Frame(fr12,bd=4,relief="sunken")
fr13.pack()
labex1=Tkinter.Label(fr13,text="Select the objects of an antichain >>>")
labex1.pack(side="left")
ex1=Tkinter.Entry(fr13,width=30)
ex1.pack(side="left")
lbwarning=Tkinter.Label(fr12,text="")
lbwarning.pack()
Butt2=Tkinter.Button(fr12,text="AC-statistics ",bg="cyan",width=40,command=ac_statistics)
Butt2.pack()
Butt3=Tkinter.Button(fr12,text=" AC-matrix ",bg="cyan",width=40,command=acmatrix)
Butt3.pack()
Butt5=Tkinter.Button(fr12,text="tripartite graphs ",bg="cyan",width=40,command=tripartite_graph)
Butt5.pack()
buttexit=Tkinter.Button(hf,text=" Exit  ",bg="red", width=30,command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()


