import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import math

import Canvas
import os
import pstat
import stats
import csv
from string import replace
import random



# 29.11.2013: Enrich1 derived from ACsimpl1.py
# 30.11.2013
# Because of transitivity the ul,ol,mw taken from all pairs which fulfill the delta condition for a certain qi
# After many trials (see toward_enrich18...py  now the needed cluster analysis
# 8.12.2013,
# 9.12.2013
# 21.08.18: cosmetics
# 28.08.18: Dramatic changes: Iteration no more depending on U but on diff of matrices


def xselectfile():
    # brg 6.8.2013, 25.11.2013 (taken from fuzzysimpl
    global fn
    fn=tkFileDialog.askopenfilename()
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,x,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print ("Number of objects ",lob)

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,x,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)




def xfileopen():
    """Informs about the file-operations"""
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    #rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)   #6.8.2013

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm(r,k,x,obj)    

##### end of editenster ### 29.8.2013 ####
    
def setequal(aset1,aset2):
    #brg 8.12.2013
    """ if aset1 equal aset2 result is "yes" """
    
    
    result=""
    if aset1 <= aset2 and aset2 <= aset1:
        result="yes"
    else:
        result= "no"
    return result

def clustersets(delta,lds):
    #Brg  8.12.2013
    """ delta is a vector of pairs (i,j) for which with respect to a certain indicator
    the abs diff of data entries is less  delt.
    From these pairs clusters are formed, due to any common element in any pair (i1,j1), (i2,j2).
    First step: Formation of sets dset
    Second step: Find out which dset[i], dset[i1] has common elements
    Third step: If common elements: union of the corresp. pair
    Fourth step: Reduction due to equality of sets
    Series toward_enrich18, ...18a,..,18d.py shows how clustersets is to be used """
    global dsetnew, zahlcl, ldscorr
    # Step 1: dset-formation
    dset=rmod2.vecgen1(lds)

    for i in range(0,lds):
        dset[i]=set([])
        dset[i].add(delta[i][0])
        dset[i].add(delta[i][1])


    # Step2,3 : Common elements and union.
    for i in range(0,lds):
        for i1 in range(0,lds):
            if len(dset[i]&dset[i1])!=0:
                dset[i]=dset[i]|dset[i1]  #union
                #print "i= ",i,"   dsetneu= ",dset[i]
            
    # Step 4: purification
    # the larger set of dset[i] and dset[i1], resp., will retained
    ldscorr=len(dset)
    #print "ldscorr= ",ldscorr
##    for i in range(0,ldscorr):
##        print dset[i]

    for i in range(0,ldscorr):
        for i1 in range(i+1,ldscorr):
            if dset[i] <= dset[i1]:
                dset[i].clear()
            if dset[i1]<= dset[i]:
                dset[i1].clear()
        
    dsetnew=rmod2.vecgen1(ldscorr)
    zahlcl=0        
    for i in range(ldscorr):
        if len(dset[i])!=0:
            dsetnew[zahlcl]=dset[i].copy()
            zahlcl+=1
            

    print "Number of clusters = ",zahlcl
    return dsetnew,zahlcl,ldscorr





def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    # brg 21.08.18
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def showDMn1():
    """shows the DM [0,1]-columnwise normalized"""
    # taken from fuzzyHD7
    # 21.08.18, 28.08.18
    dmn1=rmod2.matrixnorm(r,k,x)  #sik
    tp2b=Tkinter.Toplevel(hf)
    tp2b.title(' show normalized DM (before the enrich-procedure) ')
    lbtp2=Tkinter.Label(tp2b,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2b,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n normalized data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(dmn1[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n"
    txt4="Maximal and minimal objects "+"\n"
    maximal=[]
    for i in range(0, r):
        for j in range(0, k):
            if dmn1[i][j]==1:
                maximal.append((j,i))
        
    minimal=[]
    for i in range(0, r):
        for j in range(0, k):
            if dmn1[i][j]==0:
                minimal.append((j,i))
    txt4+="Maximal elements " +"\n"           
    for j1 in range(0,len(maximal)):
        txt4+= "object "+str(obj[maximal[j1][1]])+" indicator: "+str(prop[maximal[j1][0]])+"\n"
    txt4+="Minimal elements "+"\n"
    for j1 in range(0,len(minimal)):
        txt4+= "object "+str(obj[minimal[j1][1]])+" indicator: "+str(prop[minimal[j1][0]])+"\n"
    txt4+="\n"
    txt=txt1+txt2+txt3+txt4
    tfile.insert("end",txt)    



def HD():
    # brg 26.7.2013, 29.8.2013, 25.11.2013, 9.12.2013
    global x,la,ls,xred,cov,n,txteq,Uorig
    try:
        perturb=float(eperturb.get())
    except:
        perturb=1.0
    objx=rmod2.comp(r,k,x)
    #rmod2.matout(r,r,objx)
    quobx=rmod2.qualcomp1(r,objx)
    #rmod2.strmatout(r,r,quobx)
    Uorig=0
    for i1 in range(0,r):
        for i2 in range(0,r):
            if quobx[i1][i2]=="ic":
                Uorig+=0.5
    print "U= ",Uorig
    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                if perturb!=1.0:
                    pt=1+perturb*random.random()
                else:
                    pt=1
                geomx[i][j]=geom0x+pt*(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(garrow1x-130,garrow2y-6,text="Incomp(objectset based) = "+str(Uorig))
        cv.pack()

        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

    n=rred
    teqorig=ScrolledText(freq,width=60,height=5)
    teqorig.pack()
    txteq2="Equivalence classes of \n"+str(fn)+"\n"
    txteq2+="\n"+txteq+"\n"
    teqorig.insert("end",txteq2)
    Buttcalc.config(state="active")
    #
    
def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    tpcover=Tkinter.Toplevel(hf)
    tpcover.title(' cover-matrix ')
    lbhd2=Tkinter.Label(tpcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    n=rred
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(tpcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y            


def matrixdiff(dm1,dm2, r, k):
    #brg 28.08.18
    diff=[]
    for i in range(0, r):
        for j in range(0, k):
            diff.append(abs(dm1[i][j]-dm2[i][j]))
    maxdiff=max(diff)
    return maxdiff

def calc():
    # brg 29.11.2013, 30.11.2013, 8.12.2013, 28.08.18
    global dmn2,Uneu,Uorig,deltalist
    try:
        delta=float(edelta.get())
    except:
        delta=0.1
    # Govering parameter
    try:
        h=eh.get()
    except:
        h="mw"
        
    dm=rmod2.matcopy1(r,k,x)
    dmn2=rmod2.matrixnorm(r,k,dm)
    dmn1=rmod2.matrixnorm(r,k,dm)
    dmnold=rmod2.matcopy1(r,k,dmn1)
    objx=rmod2.comp(r,k,dmn2)
    #rmod2.matout(r,r,objx)
    quobx=rmod2.qualcomp1(r,objx)
    U=0
    for i1 in range(0,r):
        for i2 in range(0,r):
            if quobx[i1][i2]=="ic":
                U+=0.5
    #print "U= ",U
    

    Ualt=U
    deltaU=999999
    zahl=0
    deltalist=[]
    
    Utuple=[]
    for i1 in range(0,r):
        for i2 in range(i1+1,r):
            if quobx[i1][i2]=="ic":
                Utuple.append([i1,i2])
    #print "Utuple = ",Utuple
    lut=len(Utuple)
    maxdiff=99999
    while maxdiff>0.1:
        for k1 in range(0,k):
            deltas=[]
            for ob in Utuple:
                #print "ob= ",ob,"  dmn ic-pairs ",dmn2[ob[0]][k1],dmn2[ob[1]][k1]
                if abs(dmn2[ob[0]][k1]-dmn2[ob[1]][k1])<delta:
                        deltas.append((ob[0],ob[1]))
            lds=len(deltas)
            #print "k1= ",k1,"   lds= ",lds
            #print "deltas= ",deltas
            #print "delta= ",delta
            dset_act,z_act,ld=clustersets(deltas,lds)   #clusters for each single indicator
            deltalist.append((k1,dset_act))   #only documentation, not a calc-step
            for i3 in range(0,z_act):
                hilf=[]
                for i4 in dset_act[i3]:
                    hilf.append(dmn2[i4][k1])  #list of the k1-th indicator valuesof objects in actual set
                if h=="ul":
                    qnew=min(hilf)
                    #print "qul= ",qnew
                elif h=="ol":
                    qnew=max(hilf)
                    #print "qol= ",qnew
                elif h=="mw":
                    qmw=sum(hilf)
                    qnew=1.0*qmw/(1.0*len(hilf))
                    #print "qmw= ",qnew
                else:
                    print "+++wrong input (only ul, ol or mw ++++ "
                    
                for i4 in dset_act[i3]:  #generating the new modified data matrix
                    dmn2[i4][k1]=qnew

        maxdiff=matrixdiff(dmnold, dmn2,r,k)
        dmnold=rmod2.matcopy1(r,k,dmn2)
        zahl+=1
        if zahl > 1000:
            zahl=99999
            break
    print "while loop finalized: "
    if zahl ==99999:
        print "Iteration interrupted! "
    else:    
        print "Iterations ",zahl    
    objx=rmod2.comp(r,k,dmn2)
    quobx=rmod2.qualcomp1(r,objx)
    Uneu=0
    for i1 in range(0,r):
        for i2 in range(0,r):
            if quobx[i1][i2]=="ic":
                Uneu+=0.5
    print "Uneu= ",Uneu
        
            
                    
   
    #print "Modified dmn2 "
    #rmod2.matout(r,k,dmn2)
    tpcalc=Tkinter.Toplevel(hf)
    tpcalc.title(' Details about the enrichment procedure ')
    tcalc=ScrolledText(tpcalc,width=60,height=10)
    tcalc.pack()
    txtc=" Background information concerning the enrichment procedure "+"\n"
    txtc+=50*"="+"\n"
    txtc+="Incomparabilities (based on object set) originally: "+2*"\t"+str(Uorig)+"\n"
    txtc+="Parameters of the procedure: delta:  "+2*"\t"+str(delta)+"\n"
    txtc+="Parameters of the procedure: method: "+2*"\t"+h+"\n"
    txtc+="Number of iterations: "+2*"\t"+str(zahl)+"\n"
    txtc+=" Incomparabilities of the enriched partial order: "+2*"\t" +str(Uneu)
    txtc+="\n"
    txtc+="- - -    e o f - - - "
    tcalc.insert("end",txtc)

def interimresults():
    #brg 28.08.18
    tpinterim=Tkinter.Toplevel(hf)
    tpinterim.title("Interim results 2")
    tinterim=ScrolledText(tpinterim,width=80, height=20)
    tinterim.pack()
    #print deltalist
    txt="Interim results of Enrich - procedure "+"\n"
    txt+="Accoring to the iterations "+"\n"
    
    for i in range(0, len(deltalist)):
        txt+=str(prop[deltalist[i][0]])+" :"
        for i2 in range(0,len(deltalist[i][1])):
            if deltalist[i][1][i2]!=0:
                 txt+=str(deltalist[i][1][i2])+", "
        txt+="\n"         
    txt+="\n"
    tinterim.insert("end",txt)
    
        
    

def showDMn2():
    """shows the DM after the enrichment process"""
    # taken from fuzzyHD7
    # 21.08.18, 28.08.18
    tp2b=Tkinter.Toplevel(hf)
    tp2b.title(' show normalized DM (after the enrich-procedure) ')
    
    tfile=ScrolledText(tp2b,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n normalized data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(round(dmn2[i][j],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    


    
            
def HDenriched():
    # brg 29.11.2013
    global Uneu,cov3,rred3,objred3
    try:
        perturb=float(eperturb.get())
    except:
        perturb=1.0
    Ufinal=Uneu
    rred3,xred3,objred3,txteq3,neq3=rmod2.equivcompactm(r,k,dmn2,obj)   #6.8.2013
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred3,k,xred3)  #zeta matrix with col<row
    zeta=rmod2.marray(rred3,rred3)
    for i in range(0,rred3):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred3):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred3,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred3,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred3,adjc,lext)
       
    
    cov3=rmod2.cover(rred3,tr,lext)

    if rred3>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred3,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred3,rred3)
        geomy=rmod2.marray(rred3,rred3)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                if perturb!=1.0:
                    pt=1+perturb*random.random()
                else:
                    pt=1
                geomx[i][j]=geom0x+pt*(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov3[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred3[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(garrow1x-130,garrow2y-6,text="Incomp(final,objectset based)= "+str(Ufinal))
        cv.pack()

        buttcover5=Tkinter.Button(freq,text="show cover relation of HD enriched ",command=cover_show3)
        buttcover5.pack()

    
    teqorig=ScrolledText(freq,width=60,height=5)
    teqorig.pack()
    txteq4="Equivalence classes of \n"+str(fn)+"\n"
    txteq4+="\n"+txteq3+"\n"
    teqorig.insert("end",txteq4)

def cover_show3():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    tpcover3=Tkinter.Toplevel(hf)
    tpcover3.title(' cover-matrix ')
    lbhd2=Tkinter.Label(tpcover3,text=" Cover-Relations ")
    lbhd2.pack()
    txt5="\n cover-matrix  \n"
    n=rred3
    for i in range(0,n):
        txt5+="\n"+objred3[i]+":\t"
        txt5+="is covered by "
        for j in range(0,n):
            if i!=j:
                if cov3[i][j]==1:
                    txt5+=" "+objred3[j]+" ,"
                else:
                    pass
            else:
                pass
        txt5+="\n"    
    txt5+="\n"
    txt5+=" -- end of list --"
    tcov=ScrolledText(tpcover3,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt5)

hf=Tkinter.Tk()
hf.title('--   GUI Enrich   -- ')

aboutmainHD=raioop2.brgabout(hf,"tp1","about_Enrich.txt",3,\
            "August, the 21s, 2018"," about Enrich ", "white", "t1",120,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_Enrich.txt",3,\
            "August, the 21s, 2018"," help Enrich ", "white", "t1",120,10,ScrolledText)
    
fr1=Tkinter.Frame(hf,width=60)   #about, help, fn, lbopen1
fr1.pack()
fr11=Tkinter.Frame(fr1,width=60)
fr11.pack()
Buttfn=Tkinter.Button(fr11,text="select&open-file",width=30,bg="cyan",command=xselectfile)
Buttfn.pack()
lbopen1=Tkinter.Label(fr1,text="",width=60)
lbopen1.pack()
fr12=Tkinter.Frame(fr1,width=60)
fr12.pack()
Buttshow=Tkinter.Button(fr12,text="show data matrix from txt-file",bg="cyan",width=30,command=showDM)
Buttshow.pack()
Buttshowdmn1 = Tkinter.Button(fr1, text="Show normalized dm (before the enrichment)",width=30,
                         bg="cyan",command=showDMn1)
Buttshowdmn1.pack()
lbperturb=Tkinter.Label(fr12,text=" perturb the Hassediagram (default=1)")
lbperturb.pack()
eperturb=Tkinter.Entry(fr12,width=2)
eperturb.pack()
ButtHD=Tkinter.Button(fr12,text="Hassediagram ",width=30,bg="cyan",command=HD)
ButtHD.pack()
fr13=Tkinter.Frame(fr1,relief="sunken",bd=4)
fr13.pack()
lb13=Tkinter.Label(fr13,text="Needed: delta and method parameter (ul,mw,ol)")
lb13.pack()
lb131=Tkinter.Label(fr13,text="Enter delta (0.1 or 0.2 or...)")
lb131.pack(side="left")
edelta=Tkinter.Entry(fr13,width=4)
edelta.pack(side="left")
lb132 = Tkinter.Label(fr13, text=" Enter the method ")
lb132.pack(side="left")
eh = Tkinter.Entry(fr13, width=3)
eh.pack(side="left")
Buttcalc = Tkinter.Button(fr1, text="Enrichment ", width=30,
                          bg="cyan", state="disabled", command=calc)
Buttcalc.pack()
Buttinterimresults2 = Tkinter.Button(fr1, text="Show further interim results ",
                         width=30, command=interimresults)
Buttinterimresults2.pack()
Buttshowdmn2 = Tkinter.Button(fr1, text="Show modified dm ",width=30,
                         bg="cyan",command=showDMn2)
Buttshowdmn2.pack()
ButtHDenriched = Tkinter.Button(fr1, text="Hasse diagram enriched ",
                                width=30, bg="cyan", command=HDenriched)
ButtHDenriched.pack()

buttexit = Tkinter.Button(hf, text=" Exit  ",
                          bg="red", width=30, command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()
