
import Tkinter
import rmod2
from ScrolledText import *
import tkMessageBox
import Canvas
import os
import random
import tkFileDialog
import raioop2


# brg 3.10.2009

class Excelreadin(object):
    def __init__ (self,fn):
        self.fn=fn
        return

    def clread(self):
        import win32com.client
        x1App=win32com.client.Dispatch("Excel.Application")
        x1App.Workbooks.Add()


        simple=x1App.Workbooks.Open(self.fn)

        #Objekte
        self.obj=[]
        i=2
        j=1
        zahl=0
        while simple.ActiveSheet.Cells(i,j).Value!=None:
            self.obj.append(simple.ActiveSheet.Cells(i,j).Value)
            i+=1
            zahl+=1
            if zahl>2000:
                break
        self.n=len(self.obj)

        self.prop=[]
        j=2
        i=1
        zahl=0
        while simple.ActiveSheet.Cells(i,j).Value!=None:
            self.prop.append(simple.ActiveSheet.Cells(i,j).Value)
            j+=1
            zahl+=1
            if zahl>2000:
                break
        self.m=len(self.prop)

        self.dm=rmod2.marray(self.n,self.m)    
        for i in range(0,self.n):
            for j in range(0,self.m):
                self.dm[i][j]=simple.ActiveSheet.Cells(i+2,j+2).Value
                

        return self.fn,self.n,self.m,self.obj,self.prop,self.dm




#main program

def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    fn=tkFileDialog.askopenfilename()


    app1=Excelreadin(fn)
    fn_act,n,k,obj_act,prop_act,dm_act=app1.clread()

    

    
    lb1.config(text="opened "+fn,bg="yellow")
    

   

    rred,xred,objred,txt2,neq=rmod2.equivcompactm(n,k,dm_act,obj_act)  
    
    #
    tpdocum=Tkinter.Toplevel(hf)
    tpdocum.title(' background info ')
    tdocum=ScrolledText(tpdocum,width=80,height=10)
    tdocum.pack()
    txt=""
    txt+="Selected file = "+fn_act
    txt+="\n"+"Objects"

    txthilf=""
    for i in range(0,n):
        txthilf+=str(obj_act[i])+" "
    txt+="\n"+txthilf

    txt+="\n"+"Attributes "        
    txthilf=""
    for j in range(0,k):
        txthilf+=str(prop_act[j])+" "
    txt+="\n"+txthilf


    txt+="\n"+"Data matrix"    
    txthilf=""   
    for i in range(0,n):
        for j in range(0,k):
            txthilf+=str(dm_act[i][j])+"\t"
        txthilf+="\n"
    txt+="\n"+txthilf
    txt+="Info equivalence classes "
    txt+=txt2
    txt+="\n\n"+"- - -  E O F - - - "
    
    tdocum.insert("end",txt)
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.create_text(50,garrow2y+10,text="Attributes: ")
        for j in range(0,k):
            cv.create_text(100+20*j,garrow2y+10,text=prop_act[j]+"  ")
        cv.pack()

    



hf = Tkinter.Tk()
hf.title(' ExcelHD ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_ExcelHD.txt",1,\
            "May, 23rd,2011"," about ExcelHD ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_ExcelHD.txt",1,\
            "May, 23rd,2011"," help_ExcelHD ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=60)
fr.pack()
buttHD = Tkinter.Button(fr, text='select, open and HD',width=25,bg="cyan",command=HD)
buttHD.pack(pady=5)
lb1=Tkinter.Label(fr,text=" ",width=50)
lb1.pack()
buttexit = Tkinter.Button(fr, text = 'exit', bg = 'red', width=25,command = hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()

       
