import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import math
import stats
import pstat
#from string import replace

# brg 07.05.2015
# Derived from hdsimpl03
# CSV-readin using professional routines of csv-library
# MCnoiseproblem: new approach
# Detail info concerning defuzzification 26.7.2015
# Restructuring 24.1.2016
# cosmetics 14.08.18


###### editfenster ### 29.8.2013 #####
def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    
    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    la=len(a)
    ls=len(a[0])
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    
    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####
    ######################################
    ######################################


def SaPaUa():
    #Brg 30.9.09, 2.3,2012, 28.7.2012, 23.2.2013, 24.1.2016
    global Ua,Sa,Pa,countPa,countUa,countSa,rkavmc,havmc 
    Sa=rmod2.marray1(rs,rs,-1)
    Pa=rmod2.marray1(rs,rs,-1)
    Ua=rmod2.marray1(rs,rs,-1)
    countSa=rmod2.vecgen1(rs)
    countPa=rmod2.vecgen1(rs)
    countUa=rmod2.vecgen1(rs)
    alpha=1  #parameters to be determined by statistical techniques
    beta=0  #parameters to be determined by statistical techniques

    for ob in objredmc:
        obi=objredmc.index(ob)
        
        #obi the selected element label whose rkav will be deternmined
        z=0
        for i1 in range(0,rs):
            if order[i1][obi]==1:
                z+=1
                Sa[obi][i1]=i1
        #print "ob = ",ob,"  its order ideal:  ",Sa[obi]
        countSa[obi]=z

    for ob in objredmc:
        obi=objredmc.index(ob)
        
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rs):
            if order[obi][i1]==1:
                z+=1
                Pa[obi][i1]=i1
        #print "ob = ",ob,"  its order filter:  ",Pa[obi]
        countPa[obi]=z

    #print "objred = ",objred
    #print "zeta matrix"
    #rmod2.matout(rred,rred,zeta)
    for ob in objredmc:
        obi=objredmc.index(ob)
        print "ob= ",ob,"obi= ",obi
        #obi the selected element whose rkav will be deternmined
        z=0
        for i1 in range(0,rs):
            if order[i1][obi]==0 and order[obi][i1]==0:
                z+=1
                Ua[obi][i1]=i1   #if object with label i1 is incomparable with obi, then Ua[obi][i1] gets just the label i1
        #print "ob = ",ob,"  its incomparables  ",Ua[obi]
        countUa[obi]=z
        #print "ob= ",ob,"   count Ua= ",countUa[obi]
    #rmod2.matout(rred,rred,Ua)
    havmc=rmod2.vecgen1(rs)    #LPOM0
    for ob in objredmc:    #28.7.2012
        obi=objredmc.index(ob)  #28.7.2012
        havmc[obi]=1.0*countSa[obi]*(rred+1)/(1.0*(rs+1-countUa[obi]))
        
    
    rkavmc=rmod2.vecgen1(rs) #LPOMext
    for i2 in range(0,rs):
        rkavmc[i2]=countSa[i2]  #note Sa includes the interesting element a too
    for ob in objredmc:
        obi=objredmc.index(ob)
        increment=0
        hilf=rmod2.vecgen1(rs)
        for i in range(0,rs):   #28.7.2012
            hilf[i]=Ua[obi][i]  #28.7.2012
        print "ob = ",ob
        print "hilf= ",hilf
        for y in hilf:
##            if y!=-1:
##                #print "ob= ",ob, " y ncrloop: ",y," nme= ",objred[y]," ",
            Uy=[]
            Pdown=0
            Pup=0
            
            if y!=-1:
                for i1 in range(0,rs):
                    if order[i1][y]==0 and order[y][i1]==0:
                        Uy.append(i1)
                        
                
                for x in Uy:
                    if x in Sa[obi]:
                        Pdown+=1
                            
                for x in Uy:
                    if x in Pa[obi]:
                        Pup+=1
                
                dinc=1.0*Pdown/(1.0*Pdown+1.0*Pup)
                
                
                
                increment+=dinc
                #print "obi = ",obi,"  y= ",y,"  Pdown= ",Pdown,"   Pup = ",Pup
        rkavmc[obi]+=alpha*increment+beta
    tplpom=Tkinter.Toplevel(hf)
    tplpom.title('LPOM0 and LPOMext ')
    tlpom=ScrolledText(tplpom,width=60, height=20)
    tlpom.pack()
    txt="average heights, corresponding to alpha-cut "+str(acut)+"  and MC-runs "+str(mcrun)+"\n"
    txt+="model used: "+str(distsel)+"\n"
    txt+=50*"-"+"\n"
    txt+="Object: "+"\t"+"height (LPOM0)"+"\t"+"height(LPOMext"+"\n"
    for ob in objredmc:
        obi=objredmc.index(ob)
        txt+=str(objredmc[obi])+"\t"+str(round(havmc[obi],2))+2*"\t"+str(round(rkavmc[obi],2))+"\n"
    txt+="\n"
    tlpom.insert("end",txt)
        



def HD():
    # brg 26.7.2013, 29.8.2013
    
    global x,la,ls,cov, rred, objred, zeta, U, C
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    U = 0.0
    C = 0.0
    for i1 in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rred):
            zeta[i1][i2]=zetahilf[i2][i1]
    for i1 in range(0, rred):
        for i2 in range(0, rred):
            if i1!=i2:
                #print "i1= ",i1,"  i2= ",i2,"  zetai1i2= ",zeta[i1][i2],"    zetai2i1= ",zeta[i2][i1]," ",
                if zeta[i1][i2]+zeta[i2][i1] == 0:
                    U+=0.5
                    #print "U = ",U
                if zeta[i1][i2]+zeta[i2][i1] == 1:
                    C+=0.5
       
    print "zeta "
    rmod2.matout(rred, rred, zeta)
    print " "
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  "+"  U= "+str(U)+"   C= "+str(C))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttnc.config(state="active")
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def calc_relat(r, k, x):
    #taken from rmod2 13.10.2014 and modified according to PyHasse_internet
    c= []
    flag=0    
    for i1 in range(0, r):
        c.append(0)
        c[i1] = []
        for i2 in range(0, r):
            flag=0
            for j in range(0, k):
                #print " kk =",kk," i=",i," j = ",j
                if x[i1][j] >= x[i2][j]:
                    flag += 1
            if flag == k:
                 c[i1].append(1)
            else:
                 c[i1].append(0)
            #print " "     
    return c

    

def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 7.5.2015, 14.08.18
    #note: taken from interval9
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="File: "+str(fn)+"\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    txt4 = "Mutual distances "+"\n"
    for j in range(0, k):
        txt4+=str(prop[j])+"\n"
        for i1 in range(0, r):
            for i2 in range(i1+1,r):
                txt4+=str(obj[i1])+"--"+str(obj[i2])+": "+str(abs(x[i1][j]-x[i2][j]))+"\n"
                
    txt4+="\n"
    txt5 = "max distance regarding all indicators "+"\n"
    for i1 in range(0,r):
        for i2 in range(i1+1,r):
            hilf = []
            for j in range(0, k):
                hilf.append(abs(x[i1][j]-x[i2][j]))
            txt5+=str(obj[i1])+"--"+str(obj[i2])+": "+str(max(hilf))+"\n"  
            
    txt+=txt4+txt5                                        
    tfile.insert("end",txt)        



    
def MCsubmit():
    # brg 7.5.2015, 30.5.2015
    global k,MCrunentry,MCentry, MCseedentry, MCstdentry, MCselectentry
    tpMC = Tkinter.Toplevel(hf)
    tpMC.title(" MC-specifications")
    for j in range(0,k):
        lbMC=Tkinter.Label(tpMC,text=str(prop[j]))
        lbMC.grid(row=1, column=j+1)
    lbMC2=Tkinter.Label(tpMC,text="%p")
    lbMC2.grid(row=2,column = 0)
    MCentry = rmod2.vecgen1(k)
    for j in range(0,k):
        MCentry[j]=Tkinter.Entry(tpMC,width=5)
        MCentry[j].grid(row = 2,column=j+1)
    lbMC3=Tkinter.Label(tpMC,text="#MC-runs" )
    lbMC3.grid(row=4,column=0)
    MCrunentry=Tkinter.Entry(tpMC,width=10)
    MCrunentry.grid(row=4, column  = 1)
    lbMC4=Tkinter.Label(tpMC, text="select a seed if wanted")
    lbMC4.grid(row=5,column=0)
    MCseedentry = Tkinter.Entry(tpMC,width=10)
    MCseedentry.grid(row=5,column = 1)
    lbMC5=Tkinter.Label(tpMC,text="Select distribution: uniform : 0, Gauss: 1 ")
    lbMC5.grid(row = 6, column = 0)
    MCselectentry = Tkinter.Entry(tpMC, width=10)
    MCselectentry.grid(row=6,column = 1)
    lbMC6=Tkinter.Label(tpMC,text = "select standard deviation for each indicator ")
    lbMC6.grid(row=7,column = 0)
    MCstdentry = rmod2.vecgen1(k)
    for j in range(0, k):
        lbMC7 = Tkinter.Label(tpMC, text = str(prop[j]))
        lbMC7.grid(row=8,column=j+1)
    lbMC8 = Tkinter.Label(tpMC, text = "std")
    lbMC8.grid(row=9,column=0)
    for j in range(0, k):
        MCstdentry[j] = Tkinter.Entry(tpMC,width=5)
        MCstdentry[j].grid(row=9, column=j+1)
    
def calc_nc():
    # brg 21.08.2015
    dim_cols = k
    dim_rows = int(dim_cols*(rred*(rred - 1.0)/2.0))
    
    nc = []
    for i1 in range(0,rred):
        for i2 in range(i1+1,rred):
            for j in range(0, k):
                if xred[i1][j]+xred[i2][j]>0:
                    hilf = 1.0*abs(xred[i1][j]-xred[i2][j])/(xred[i1][j]+xred[i2][j])
                else:
                    hilf = 0
                nc.append((hilf,objred[i1],objred[i2],prop[j],zeta[i1][i2],zeta[i2][i1]))
    tpnc = Tkinter.Toplevel(hf)
    tpnc.title(' nc ')
    tnc = ScrolledText(tpnc, width=120,height = 20)
    tnc.pack()
    txt=" nc"+"\t"+"object1"+"\t"+"object2"+"\t"+"prop"+"\t"+"zeta-values "+"\n"
    for i in range(0, dim_rows):
        txt+=str(round(nc[i][0],3))+"\t"+str(nc[i][1])+"\t"+str(nc[i][2])+"\t"+str(nc[i][3])+"\t"+str(nc[i][4])+"\t"+str(nc[i][5])+"\n"
    tnc.insert("end",txt)    
    
def MCperform():
    # brg 7.5.2015, 30.5.2015, 27.11.2015, 12.1.2016
    global k, MCrunentry, MCentry, zetaMC, \
           zetaMChilf, xav, overlap, mcrun, \
           pprop,mcseed,distsel,std, zetaav_vector
    import random
    pprop=rmod2.vecgen1(k)
    std = rmod2.vecgen1(k)
    #readin
    # control of MC
    try:
        mcrun=int(MCrunentry.get())
    except:
        mcrun=5000
    try:
        mcseed = int(MCseedentry.get())
    except:
        mcseed = None    
    try:
        distsel = int(MCselectentry.get())
    except:
        distsel = 0
    #print "distsel = ",distsel
    sumpprop = 0
    sumstd = 0
    if distsel == 0:    
        sumpprop = 0
        for j in range(0,k):
            try:
                pprop[j]=float(MCentry[j].get())
            except:
                pprop[j] = 0.0
            sumpprop += pprop[j]
    
    elif distsel == 1:
        sumstd = 0
        for j in range(0, k):
            try:
                std[j] = float(MCstdentry[j].get())
            except:
                std[j] = 0.0
        sumstd += std[j]        
        #print "std = ", std        
    else:
        pass
    # perturbations
    xmc = rmod2.marray(r,k)
    xav = rmod2.marray(r,k)
    zetaMC = rmod2.marray(r,r)
    if distsel ==1:
        print "std= ",std
    if distsel == 0:
        print "propp = ",pprop 
    random.seed(mcseed)
    xtest = []
    if distsel == 0 and sumpprop < 0.0001: 
        mcrun = 1           #overwriting mcrun in case of certainty
    if distsel == 1 and sumstd < 0.00001:
        mcrun = 1
    for mc in range(0, mcrun):
        for i in range(0,r):
            for j in range(0,k):
                if distsel == 0:
                    lowlimit = x[i][j] - x[i][j]*pprop[j]/100.0
                    uplimit = x[i][j] + x[i][j]*pprop[j]/100.0
                    if mcrun == 1:
                        xmc[i][j] = x[i][j]
                    else:    
                        xmc[i][j] = random.uniform(lowlimit,uplimit)
                    xtest.append(xmc[0][0])
                elif distsel == 1:
                    if mcrun == 1:
                        xmc[i][j] = x[i][j]
                    else:    
                        xmc[i][j] = random.gauss(x[i][j], std[j])
                    xtest.append(xmc[0][0])
                elif distsel == 2:
                    pass
                else:
                    pass
                xav[i][j] += xmc[i][j]
        zetaMChilf = rmod2.comp(r,k,xmc)       
        for i1 in range(0,r):
            for i2 in range(0,r):
                zetaMC[i1][i2]+=zetaMChilf[i2][i1]
    
    for i in range (0, r):
        for j in range(0,k):
            xav[i][j] = 1.0*xav[i][j]/mcrun

    zetaav_vector = []
    for i1 in range(0,r):
        for i2 in range(0,r):
            if i1 == i2:
                zetaMC[i1][i2] = 1
            else:    
                zetaMC[i1][i2] = 1.0*zetaMC[i1][i2]/(1.0*mcrun)
                zetaav_vector.append(zetaMC[i1][i2])
    
    

def fuzzyproduct(zetaMC):
    "see DeBaets,DeMeyer in Inf Sci 152, 2003, 167-179"
    #brg 14.11.07
    
    flag=0
    eps=0.01
    zaehl=0
   
    
    q=rmod2.matcopy1(r,r,zetaMC)
    
    while flag==0:
        q1=rmod2.fuzzymatmult(r,q,q)
        flag=rmod2.comparematrices(r,r,eps,q1,q)
        q=rmod2.matcopy1(r,r,q1)
        zaehl+=1
        if zaehl>100:
            break
        else:
            pass
    
    print "flag=",flag   
    txt=""
    hilf1=rmod2.vecgen1(r*r)
    hilf2=rmod2.vecgen1(r*r)
    hilf3=rmod2.vecgen1(r*r)
    alpha=rmod2.vecgen1(r*r)
    nn=rmod2.vecgen1(r*r)
    zaehl=0
    for i in range(0,r):
        for j in range(0,r):
            hilf1[zaehl]=round(q[i][j],3)
            zaehl+=1
    
    hilf2,nn=rmod2.raisort(r*r,hilf1)
    for i in range(0,r*r):
        hilf3[i]=hilf2[i]
        
    for i in range(0,r*r):
        z=hilf2[i]
        for i1 in range(i+1,r*r):
            if z==hilf2[i1]:
                hilf3[i1]="*"
    nr_of_cuts=0
    for i in range(0,r*r):
        if hilf3[i]!="*":
            alpha[nr_of_cuts]=float(hilf3[i])
            nr_of_cuts+=1
    txt1="Number of cuts = "+str(nr_of_cuts)+"\n"
    lbalpha.config(bg="yellow")
    lbalpha["text"]=txt1
    nhisto=5         #graphics  neu 20.2.08
    nal=nr_of_cuts   #graphics
    balpha=rmod2.vecgen1(nhisto)
    for j in range(0,nhisto):
        for i in range(0,nal):
            if j<nhisto-1 and j<=nhisto*alpha[i]<j+1:
                balpha[j]+=1
            if j==nhisto-1 and j<=nhisto*alpha[i]<=j+1:
                balpha[j]+=1
    histo=Tkinter.Toplevel(hf)
    histo.title(' alpha-values  ')
    talfa=ScrolledText(histo,width=60,height=5)
    talfa.pack(expand="yes",fill="both")
    txt2="alpha-values\n "  #16.3.09
    for i in range(0,nal):
        if i>0 and i%20==0:                        #18.2.08
            txt2+=str(alpha[i])+" \n"
        else:
            txt2+=str(alpha[i])+"   "
    #txt+="\n"
    txt2+="\n"+"  - - -   eof  - - - "        
    talfa.insert("end",txt2)
    return q

def crispq(q,r,acuser):
    "depending on alpha: crisp matrices"
    # brg 14.11.07, 26.7.2015
    global ior, nior   
    lbextract.config(bg="white")
    lbextract["text"]=""
    cq=rmod2.marray(r,r)
    ior = []
    nior = []
    for i1 in range(0,r):
        for i2 in range(0,r):
            if q[i1][i2]>=acuser:
                cq[i1][i2]=1
            else:
                cq[i1][i2]=0
                 
    lbc.config(bg="yellow")
    lbc["text"]=" crisp matrix "
    return cq,acuser,ior,nior


    
def extract(cq,r,acut):
    """extracts from the crisp matrix the order relations"""
    global eqtext
    lbextract.config(bg="yellow")
    lbextract["text"]="Extraction performed: Selected alpha-cut: "+str(acut)
    #brg 30.11.07, 11.4.08
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    eqtext="\n"
    #eqtext+="alphacut : "+str(acut)+":  \n"
    try:
        seed = int(MCseedentry.get())
    except:
        seed = None
    eqtext += "Seed = "+str(seed)+"\n"
    if distsel == 0:
        eqtext+="Uniform distribution"+"\n"
        eqtext+="Noise: "
        for j in range(0, k):
            eqtext += str(pprop[j])+" "
        eqtext+="\n"    
    elif distsel == 1:
        eqtext+="Normal (Gauss) distribution, mean: orig datamatrix"+"\n"
        eqtext+="standard deviations: "
        for j in range(0, k):
            eqtext += str(std[j])+" "
        eqtext+="\n"
    else:
        pass
    eqtext += "\nMC runs: "+str(mcrun)+"\n"
    
    
    ec=rmod2.dmcompress(r,r,cq)             #30.11. from cq the equivalent relations
    eqtxt,Ksum_act=rmod2.eqcguiout2(r,ec,obj)        #30.11. matrix output 16.7.2013: eqc... version 2
    print "eqtxt = ",eqtxt
    eqtext+="Equivalence classes"+"\n"
    eqtext+=eqtxt
    eqtext+="\n"
    eqtext+="K = "+str(Ksum_act)+"\n"
    
    
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    #print "======================================="
    #print " Control in extract (ex) "
    #print "======================================="
    ltxt=len(txt)
    #print "ex1: ec : ",ec
    #print "ex1: txt , ltxt",txt," ",ltxt
    
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    
        
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,cq) # columns eliminated
    order,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
   
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
        #print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        #print "ex5: rs = ",rs
    return order,objec,rs

def infowindow():
    #brg 6.6.2015, 27.11.2015
    hfeq=Tkinter.Toplevel(hf)
    hfeq.title(' Basic infos concerning the MC-study' )
    nav,mmav,mav,sdav,kav,kurtav = pstat.ldescribe(zetaav_vector)                                 
    txt = ' alpha-cut= '+str(acut)+"\n"
    txt += "noise parameters "+"\n"
    for j in range(0,k):
        txt+=str(prop[j])+"p% = "+str(pprop[j])+"\n"
    txt += "\n"    
    txt += "zetaav - matrix (statistics of nondiagonal elements" +"\n" 
    txt += "no of nondiagonal elements of zetaav: "+str(nav)+"\n"
    txt += "minimal value of nondiagonal entries "+str(mmav[0])+"\n"
    txt += "maximal value of nondiagonal entries "+str(mmav[1])+"\n"
    txt += "mean of zetaav(i,j), i ne j          "+str(round(mav,4))+"\n"
    txt += "standard deviation of zetaav(i,j) i ne j "+str(round(sdav,4))+"\n"
    txt += "\n"
    txt+= "zetath-statistic (nondiagonal terms) "+"\n"
    zetath_vector = []
    for i1 in range(0, rred):
        for i2 in range(0, rred):
            if i1!=i2:
                zetath_vector.append(qmc[i1][i2])
    qmcnav,qmcmm, qmcmav,qmcsdav,qmckav, qmckurtav = pstat.ldescribe(zetath_vector)
    txt+="min =  "+str(qmcmm[0])+"\n"
    txt+="max =  "+str(qmcmm[1])+"\n"
    txt+="mean = "+str(round(qmcmav,4)) +"\n"
    txt+="std  = "+str(round(qmcsdav,4))+"\n"
    txt+="\n"                   
    txt+= ' file: '+str(fn)
    txt+="\n" +20*"- "+"\n" 
    txt+=eqtext+"\n"
    txt+="Incomparabilities    "+str(utotal)+"\n"
    txt+="Comparabilities      "+str(comptot)+"\n"
    txt+="No of levels         "+str(zzmaxmc)+"\n"
    txt+= "- - -    e o f  - - -  "+"\n"
    teq=ScrolledText(hfeq,width=70,height=10)
    teq.pack(expand="yes",fill="both")
    teq.insert("end",txt)
    return
    

def HDMC(order,rs,r,objec,acut):
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #

    global covmc,n,objredmc, utotal, comptot,zzmaxmc  
    try:
        modus=int(emodus.get())
    except:
        modus=1
        
        
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
    #print "test 7.5.08 rs  = ",rs    
    n=rs  #14.4.08 
    objredmc=rmod2.vecgentext1(rs)  #changed to ..text1: 7.5.08
    
    for i in range(0,rs):
        objredmc[i]=objec[i]  #control 15.1.08
         
    hfhd1=Tkinter.Toplevel(hf)
    hfhd1.title(' Hasse diagram / cover matrix ')
    try:
        seed = int(MCseedentry.get())
    except:
        seed = None
    txt = "Selected seed (if any) "+str(seed)+"\n"
    if distsel == 0:
        txt+= "uniform distribution"+"\n"
        txt+="noise: "
        for j in range(0,k):
            txt+=str(pprop[j])+" "
        txt+="\n"    
    elif distsel == 1:
        txt += "Normal (Gauss) distribution; mean: orig datamatrix"+"\n"
        txt +="Std: "
        for j in range(0,k):
            txt+=str(std[j])+" "
        txt+="\n"    
    else:
        pass
    txt+="\n"+"MC runs: "+str(mcrun)+" alpha-cut = "+str(acut)+"\n"    
    lbhfhd1=Tkinter.Label(hfhd1,text='Hasse diagram or cover matrix , Parameters: '+txt)
    lbhfhd1.pack()
    freq=Tkinter.Frame(hfhd1,width=400,height=480)
    freq.pack()
    
   
    
    zetamcmc=rmod2.marray(rs,rs)
    for i in range(0,rs):
        for j in range(0,rs):
            zetamcmc[i][j]=order[i][j]   #15.1.08 evtl. diese Manipul weglassen
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()
    utotal=rmod2.incompzeta(rs,zetamcmc)   #9.2.2008
    #print "rs= ",rs      #16.7.2013
    comptot=rs*(rs-1.0)/2.0 - utotal
    #rmod2.matout(n,n,zeta)
    lobjmc,lextmc,revlextmc,zzmaxmc=rmod2.levtopsort(rs,zetamcmc)
    
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack(expand="yes",fill="both")
    txt1="\n"
    for i in range(0,zzmaxmc):
        txt1+="Level "+str(zzmaxmc-i)+" :"
        for j in range(0,len(lobjmc[i])):
            txt1+= objredmc[lobjmc[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    lbequiv=Tkinter.Label(freq,text="Nontrivial Equivalence classes")
    lbequiv.pack()
    txt2="\n equivalence classes \n\n"
    txt2+=eqtext
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack(expand="yes",fill="both")
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lextmc,revlextmc,zetamcmc)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lextmc)
       
    
    covmc=rmod2.cover(n,tr,lextmc)
    if n>100:
        cover_show2()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram, parameters:  "+txt)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=400,height=480,bg="white")  #5.3.09
        lz=zzmaxmc
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobjmc[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):  #random positions 22.11.2010, 5.1.2011
            for j in range(0,l[i]):
                if modus==1:
                    ff=320.0
                else:
                    ff=random.randint(320-modus*5.0,320+modus*5.0)
                geomx[i][j]=geom0x+(ff/(pos[i]+1.0))*(j+1)  #22.11.2010    
                geomy[i][j]=geom0y+(320.0/lz)*i

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if covmc[lobjmc[i1][j1]][lobjmc[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredmc[lobjmc[i][j]])
        garrow1x=380
        garrow1y=20
        garrow2y=230
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show2)
        buttcover.pack()
        infowindow()
        
def cover_show2():
    hfcover2 = Tkinter.Toplevel(hf)
    hfcover2.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover2,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, len(covmc)):
        txt3 += "\n" + objredmc[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, len(covmc)):
            if i!=j:
                if covmc[i][j] == 1:
                    txt3 += " " + objredmc[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover2,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def showavdm():
    #brg 8.5.2015
    """ New routine : shows the av, data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 8.5.2015
    #note: taken from interval9
    tp2dmav=Tkinter.Toplevel(hf)
    tp2dmav.title('show average DM')
    lbtp2=Tkinter.Label(tp2dmav,text=" General information about the average data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2dmav,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n av. data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(xav[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)        
    
def showavrelat():
    #brg 8.5.2015
    """ New routine : shows the av, data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 8.5.2015
    #note: taken from interval9
    tp2zav=Tkinter.Toplevel(hf)
    tp2zav.title('show average relat. matrix')
    lbtp2=Tkinter.Label(tp2zav,text=" General information about the average relational matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2zav,width=80,height=10)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt3="\n av. relational matrix  \n"
    txt3+="\t"
    for i in range(0,r):
        txt3+=obj[i]+"\t"
    txt3+="\n"    
    for i1 in range(0,r):
        txt3+=obj[i1]+"\t"
        for i2 in range(0,r):
            txt3+=str(round(zetaMC[i1][i2],5))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt3
    tfile.insert("end",txt)

def showavrelattransp():
    #brg 8.5.2015, 26.5.2015, 29.5.2015 
    """ New routine : shows the matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 8.5.2015, 26.5.2015
    #note: taken from interval9
    tp2zav=Tkinter.Toplevel(hf)
    tp2zav.title('show average transponed relat. matrix')
    lbtp2=Tkinter.Label(tp2zav,text=" General information about the average relational matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2zav,width=80,height=10)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt3="\n av. transponed relational matrix  \n"
    txt3+="\t"
    for i in range(0,r):
        txt3+=obj[i]+"\t"
    txt3+="\n"    
    for i1 in range(0,r):
        txt3+=obj[i1]+"\t"
        for i2 in range(0,r):
            txt3+=str(round(zetaMC[i2][i1],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt3
    tfile.insert("end",txt)

def Trhull():
    # brg 8.8.2013, 29.8.2013, 7.5.2015, 9.5.2015
    # acut read in
    # normalization
    # Tr.closure by matrix method
    # crisp matrix
    # extract order
    global qmc
    qmc=fuzzyproduct(zetaMC)
    tp2qmc=Tkinter.Toplevel(hf)
    tp2qmc.title('show tr. corrected relat. matrix')
    lbtp2=Tkinter.Label(tp2qmc,text=" General information about the tr.corr. relational matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2qmc,width=80,height=10)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt3="\n av. trhull  \n"
    txt3+="\t"
    for i in range(0,r):
        txt3+=obj[i]+"\t"
    txt3+="\n"    
    for i1 in range(0,r):
        txt3+=obj[i1]+"\t"
        for i2 in range(0,r):
            txt3+=str(round(qmc[i1][i2],3))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt3
    txt4=2*"\n"
    txt4+="\n objects\n"
    for i in range(0,r):
        txt4+=" "+obj[i]+",\t"
    txt4+="\n"
    txt5="\n av. transponed trhull  \n"
    txt5+="\t"
    for i in range(0,r):
        txt5+=obj[i]+"\t"
    txt5+="\n"    
    for i1 in range(0,r):
        txt5+=obj[i1]+"\t"
        for i2 in range(0,r):
            txt5+=str(round(qmc[i2][i1],3))+"\t"
        txt5+="\n"
    txt5+="\n\n"
    txt+=txt4+txt5
    tfile.insert("end",txt)

   

def towardsmcHD():
    #brg 7.5.2015
    global cq, acut, ior, nior, order, rs
    try:
        acut = float(eacut.get())
    except:    
        acut = 0.5
    print "acut = ",acut
    
    cq,acut,ior,nior=crispq(qmc,r,acut)
    order,objec_act,rs=extract(cq,r,acut)
    HDMC(order,rs,r,objec_act,acut)

def detailsdefuzz():
    # brg 26.7.2015
    MCrunentry,MCentry, MCseedentry, MCstdentry, MCselectentry
    tpdetails=Tkinter.Toplevel(hf)
    tpdetails.title('details defuzzification ')
    tdetails = ScrolledText(tpdetails,width=120, height=30)
    tdetails.pack()
    txt="Details of defuzzification"+"\n"
    txt+=100*"="+"\n"
    txt+="Basis-Infor"+"\n"
    txt+="file = "+str(fn)+"\n"
    txt+="parameters of MC-simulation: "+str(mcrun)+"\n"
    txt+="seed "+str(mcseed)+"\n"
    txt+="alpha-cut: "+str(acut)+"\n"
    txt+="Selection: "+str(distsel)+"\n"
    if distsel==1:
        for j in range(0, len(std)):
            txt+=str(std[j])+"\t"
    else:
        for j in range(0,len(pprop)):
            txt+=str(pprop[j])+"\t"
    txt+="\n"
    
    txt+=100*"-"+"\n"
    lior=len(ior)
    lnior=len(nior)
    txt+="Ordered object pairs "+"\n"
    for i in range(0,lior):
        for i2 in range(0,3):
            txt+=str(ior[i][i2])+"\t"
        txt+="\n"    
    txt+="\n"
    txt+="not ordered object pairs "+"\n"
    for i in range(0,lnior):
        for i2 in range(0,3):
            txt+=str(nior[i][i2])+"\t"
        txt+="\n"
    txt+="\n"    
    txt+="statistics"+"\n"
    meanior=0
    inlistior=[]
    for i in range(0,lior):
        inlistior.append(ior[i][2])
        meanior+=ior[i][2]
    meanior=1.0*meanior/(1.0*lior)
    meannior=0
    inlistnior = []                     
    for i in range(0,lnior):
        inlistnior.append(nior[i][2])
        meannior+=nior[i][2]
    meannior=1.0*meannior/(1.0*lnior)
    nactior,nmior,mior,sdior,skior,kurtior=pstat.ldescribe(inlistior)
    nactnior, nmnior, mnior, sdnior, sknior, kurtnior = pstat.ldescribe(inlistnior)
    txt+="mean of maxmutdist of ordered pairs:                "+str(round(meanior,3))+"\n"
    txt+="standard deviation of maxmutdist of ordered pairs:  "+str(sdior)+"\n"
    txt+="length of ordered pairs-list                        "+str(len(inlistior))+"\n"
    txt+="\n"                                                                
    txt+="mean of maxmutdist of unordered pairs:                  "+str(round(meannior,3))+"\n"
    txt+="standard deviation of maxmutdist of non ordered pairs:  "+str(sdnior)+"\n"
    txt+="length of unordered pairs-list                            "+str(len(inlistnior))+"\n"
    tdetails.insert("end",txt)                                                   
    
    
def defuzzifyMCzeta():
    # brg 7.5.2015
    global zetadefuzz
    try:
        acut = float(eacut.get())
    except:    
        acut = 0.5
    zetadefuzz=rmod2.marray(r,r)
    for i1 in range(0,r):
        for i2 in range(0,r):
            if zetaMC[i1][i2]>=acut:
                zetadefuzz[i1][i2]=1
            else:
                zetadefuzz[i1][i2]=0
    print "Direct deffuzzification"
    rmod2.matout(r,r,zetadefuzz)
     

def graph(matrix):
    """relational graph """
    # matrix either defuzzified "DeBaetsDeMeyer" (transitive hull) relational matrix
    # or directly defuzzified
    #brg 1.1.08, 8.5.2015 adapted for MC_basedHD
    hfgraph=Tkinter.Toplevel(hf)
    hfgraph.title(' filtered matrix ')
    lbhfgraph=Tkinter.Label(hfgraph,text=' filtered matrix ')
    lbhfgraph.pack()
    frgr=Tkinter.Frame(hfgraph,width=400,height=400,relief="raised",bd=3)
    frgr.pack()
    
    posx=rmod2.vecgen1(r)
    posy=rmod2.vecgen1(r)
    cvgr=Tkinter.Canvas(frgr,width=400, height=400)
    
    
    for i in range(0,r):
        posx[i]=100.0*math.cos(i*6.28/r)
        posy[i]=100.0*math.sin(i*6.28/r)
        
        cvgr.create_oval(160+posx[i]-20,130+posy[i]+20,160+posx[i]+20,130+posy[i]-20,fill="yellow")       
        cvgr.create_text(162+posx[i],132+posy[i],text=str(obj[i]),font = "15")

    rdgr=80
    for i1 in range(0,r):
        posx[i1]=rdgr*math.cos(i1*6.28/r)
        posy[i1]=rdgr*math.sin(i1*6.28/r)
        for i2 in range(0,r):
            posx[i2]=rdgr*math.cos(i2*6.28/r)
            posy[i2]=rdgr*math.sin(i2*6.28/r)
            if i1!=i2:
                if matrix[i1][i2]==1:
                    cvgr.create_line(160+posx[i1],130+posy[i1],160+posx[i2],130+posy[i2],arrow="last")  #7.6.08
                    

                    
    cvgr.create_text(140,380,text=" digraph ",font="16")
    
    cvgr.pack()
    
def graphTH():
    # brg 8.5.2015
    graph(cq)

def graphdir():
    # brg 8.5.2015
    graph(zetadefuzz)

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' MC_basedHD ')
aboutHD = raioop2.brgabout(hf,"tp1","about_MC_basedHD.txt",11,\
            "Jan., the 24th, 2016"," about MC_basedHD ", "white", "t1",80,5,ScrolledText)
helpHD = raioop2.brgabout(hf,"tp1","help_MC_basedHD.txt",11,\
            "Jan., the 24th, 2016"," help_MC_basedHD ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
# open procedure
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", width=40, command=xselectfile)
butt1.pack()
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
buttshow=Tkinter.Button(fr,text="Show data matrix",width=40,command = showDM)
buttshow.pack()
# Draw HD of "frozen" data
buttHD = Tkinter.Button(fr, text='Draw HD', width=40, bg="cyan", command=HD)
buttHD.pack(pady=5)
fr2 = Tkinter.Frame(hf,width=100,height=10)
fr2.pack()
buttnc = Tkinter.Button(fr2,text="values of nc ",width=40,bg="cyan",state="disabled",command=calc_nc)
buttnc.pack()
buttsubmit = Tkinter.Button(fr2,text="Open sheet to specify MC-calculations",\
                            bg="cyan",width=40,command=MCsubmit)
buttsubmit.pack()

# perform the MC-calculations
buttperform = Tkinter.Button(fr2,text="Calc. an average relational matrix ",\
                             bg="cyan",width=40,command=MCperform)
buttperform.pack()
buttshowxav=Tkinter.Button(fr2,text="Show average of data matrix",width=40,command=showavdm)
buttshowxav.pack()
froutput = Tkinter.Frame(fr2,relief = "sunken", bd=3)
froutput.pack()
buttshowrelat=Tkinter.Button(froutput,text="Show av of rel matrix",width=40,command=showavrelat)
buttshowrelat.pack(side="left")
buttshowrelattransp=Tkinter.Button(froutput,text="Show transp. av of rel matrix",width=40,\
                                   command=showavrelattransp)
buttshowrelattransp.pack(side="right")
lbalpha=Tkinter.Label(fr2,text="")
lbalpha.pack()
lbextract=Tkinter.Label(fr2,text="")
lbextract.pack()
lbc=Tkinter.Label(fr2,text="")
lbc.pack()
butttransitivehull=Tkinter.Button(fr2,text="calculate the transitive hull of the relational matrix",\
                                  bg="cyan", width=40, command=Trhull)
butttransitivehull.pack(pady=5)

lbacut=Tkinter.Label(fr2,text="Enter alpha-cut for defuzzification ")
lbacut.pack()
eacut=Tkinter.Entry(fr2,width=5)
eacut.pack()
lb1 = Tkinter.Label(fr2,text="Transitive hull after matrixmethod of DeBaets,DeMeyer, 2003")
lb1.pack()
buttmcHD=Tkinter.Button(fr2,text="defuzzify,extract and construct HD",bg="cyan",width=40,command=towardsmcHD)
buttmcHD.pack()
buttlpom = Tkinter.Button(fr2, text ="LPOM0 and LPOMext ",width = 40, command=SaPaUa)
buttlpom.pack()
buttexit = Tkinter.Button(hf, text='exit', bg='red',
                          width=40, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
