import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 29.1.2017: Basis for the new module mod_spec4: Analysis of a three-attribute-system
# 30.1.2017: Continuing... 

###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()

def interface_graphviz():
    # brg 9.9.2014
    #taken from mHDCl2
    covgr=rmod2.marray(rred,rred)
    for i1 in range(0,rred):
        for i2 in range(0,rred):
            if i1!=i2:
                covgr[i1][i2]=cov[i1][i2]
    txtgr=rmod2.covtxt(covgr,objred,rred,"digraph_x") #central routine! 
    app1=raioop2.brgsavefile3(fr,'t','w',txtgr,rred,rred) 
    import tkMessageBox
    tkMessageBox.showinfo(title="store graphviz-interface",message="successafull!")


    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq
    print "r= ",r
    print "k = ",k


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editfenster ### 29.8.2013 ####

def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the [0,1]-columnwise data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def HD():
    # brg 26.7.2013, 29.8.2013, 2.11.16
    
    global x,la,ls,cov, rred, objred, Utotal
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    rmod2.matout(rred,rred,zeta)
    Utotal = rmod2.incompzeta(rred,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def calc_zeta():
    #taken from rmod2 13.10.2014 and modified according to PyHasse_internet
    c= []
    flag=0    
    for i1 in range(0, r):
        c.append(0)
        c[i1] = []
        for i2 in range(0, r):
            flag=0
            for j in range(0, k):
                #print " kk =",kk," i=",i," j = ",j
                if x[i1][j] >= x[i2][j]:
                    flag += 1
            if flag == k:
                 c[i1].append(1)
            else:
                 c[i1].append(0)
            #print " "     
    return c

def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global prop, obj
   
    xn=rmod2.matrixnorm(r,k,x)
    #recoding ob to obj and pro to prop
    
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('warning')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,k,xn,obj)    
    ###############################################################
    return rred,k,xred,objred,obj,prop,txt           
    
##### end of standard routines ############################################

def gcruc():
     """ calculates the g-spectrum  """
     # Brg 14.12.07, 18.1.17, 22.1.17, 28.1.2017
     # for 3 attributes
     global fn,x,xn,y,r,rred,obj,objred,prop, k, LiL,gc   #21.1.08, 21.1.11
   
     rred, k, xred, objred, obj,prop, txt = filecomp(fn)
     zetahilf=rmod2.comp(rred,k,xred)
     incomplist=set([])
     incomplistcalc=[]
     for i1 in range(0,rred):
         for i2 in range(i1+1,rred):
             if zetahilf[i1][i2]==0 and zetahilf[i2][i1]==0:
                 incomplist.add((objred[i1],objred[i2]))
                 incomplistcalc.append((i1,i2))
     LiL=len(incomplist)
     np=3*LiL    #all crucial values (w.r.t. all 3 attributes
     gcrucsum = rmod2.vecgen1(3)
     gcruc=rmod2.marray(LiL,3)
     gcrucprod=rmod2.marray(LiL,3)
     tpcruc=Tkinter.Toplevel(hf)
     tcruc=ScrolledText(tpcruc, width=120,height=20)
     tcruc.pack()
     txt="Crucial average weights for the m=3 - system"+"\n"
     txt+="Note: First and second indicator are selected to solve the equation system"+"\n"
     txt+="Set of pairs of objects, incomparable w.r.t. IB "+"\n"
     for i in incomplist:
         txt+=str(i)+"\t"
     txt+="\n"
     txt+="Number of incomparabilities = "+str(LiL)+"\n"
     for i in range(0,LiL):
         iob1=incomplistcalc[i][0]
         iob2=incomplistcalc[i][1]
         delta0 = xred[iob1][0]-xred[iob2][0]
         delta1 = xred[iob1][1]-xred[iob2][1]
         delta2 = xred[iob1][2]-xred[iob2][2]
         ddelta12=delta0-delta1
         ddelta31=delta2-delta0
         ddelta23=delta1-delta2
         sumg=rmod2.vecgen1(3)
         
         
         zahl=0
         nrt=1000
         
         for t1 in range(0,nrt):
             t=(1.0/nrt)*t1
             g1=(1.0/(1.0*ddelta12))*(-1.0*delta1+ddelta23*t)
             g2=(1.0/(1.0*ddelta12))*(delta0+ddelta31*t)
             g3=(1.0/(1.0*ddelta12))*ddelta12*t
             if 1>=g1>=0 and 1>=g2>=0 and 1>=g3>=0:
                 sumxy=g1+g2+g3
                 if 0.97 <= sumxy <= 1.03: #renormalization
                     g1=1.0*g1/sumxy
                     g2=1.0*g2/sumxy
                     g3=1.0*g3/sumxy
                 sumg[0]+=g1
                 sumg[1]+=g2
                 sumg[2]+=g3
                 
                 
                 zahl+=1
        
                        
         for j in range(0,3):
             if zahl!=0:
                 gcruc[i][j]=1.0*sumg[j]/(1.0*zahl)
             else:
                 gcruc[i][j]=0
                 
         txt+=str(objred[incomplistcalc[i][0]])+", "+str(objred[incomplistcalc[i][1]])+": "+"Accessibility: "+\
                                             str(100.0*zahl/nrt)+", crucial weights:   "+\
                                             str(round(gcruc[i][0],2))+", "+\
                                             str(round(gcruc[i][1],2))+", "+\
                                             str(round(gcruc[i][2],2))+"\n"         
     tcruc.insert("end",txt)   
     gc=[]      
     for i in range(0,LiL):
         gc.append(0)
         gc[i]=[]
         for j in range(0,3):
             gc[i].append(gcruc[i][j])   #
         print " "    


def scone():
    #brg 22.1.2017
    global txtspectrum,txtmax
    startw = epd.get().split(",")
    startweights=[]
    for j in range(0,3):
        startweights.append(float(startw[j]))
    so=rmod2.marray(LiL,3)
    su=rmod2.marray(LiL,3)
    smax=rmod2.vecgen1(LiL)
    txtspectrum="Formal crossing points of crucial weights with the cones "+"\n"
    txtspectrum+= "no"+"\t"+"so1"+"\t"+"so2"+"\t"+"so3"+"\t"+"su1"+"\t"+"su2"+"\t"+"su3"+"\t"+"smax"+"\n"
    txtmax=""
    for i in range(0,LiL):
        for j in range(0,3):
            # analyisis for each x||y, denoted by i
            shilf=[]
            so[i][0]=1.0*(gc[i][j]-startweights[0])/(1.0-1.0*startweights[0])
            so[i][1]=1.0*(gc[i][j]-startweights[1])/(1.0-1.0*startweights[1])
            so[i][2]=1.0*(gc[i][j]-startweights[2])/(1.0-1.0*startweights[2])
            su[i][0]=1.0*(startweights[0]-gc[i][j])/(1.0*startweights[0])
            su[i][1]=1.0*(startweights[1]-gc[i][j])/(1.0*startweights[1])
            su[i][2]=1.0*(startweights[2]-gc[i][j])/(1.0*startweights[2])
            if so[i][0]>0:
                shilf.append(so[i][0])
            if so[i][1]>0:
                shilf.append(so[i][1])
            if so[i][2] > 0:
                shilf.append(so[i][2])
            if su[i][0]>0:
                shilf.append(su[i][0])
            if su[i][1]>0:
                shilf.append(su[i][1])
            if su[i][2]>0:
                shilf.append(su[i][2])
        smax[i]=max(shilf) ###30-01-2017 testweise: min 
        txtspectrum+=str(i)+": "+str(round(so[i][0],2))+", "+str(round(so[i][1],2))+", "+str(round(so[i][2],2))+", "+\
                      str(round(su[i][0],2))+", "+str(round(su[i][1],2))+", "+", "+str(round(su[i][2],2))+",   "\
                      +str(round(smax[i],2))+"\n"
        txtmax+=str(round(smax[i],2))+"\n"
    
    
    dummy,smaxord,dummy2=rmod2.raisort2(smax)
    
    Uaccum=[]
    Us=[]
    for s in range(0,11):
        countU=0
        Us.append(Utotal*0.1*s)
        for i in range(0,LiL):
            if smaxord[i]<0.1*s:
                countU+=1   #
                
        Uaccum.append(countU)
    lu=len(Uaccum)
    txtU ="s"+"\t"+"Uaccum"+"\t"+"Us"+"\n"
    for i in range(0,11):
        txtU+=str(i)+"\t"+str(Uaccum[i])+"\t"+str(Us[i])+"\n"
    txtU+="\n"
    tpUaccum=Tkinter.Toplevel(hf)
    tUaccum=ScrolledText(tpUaccum,width=60, height=10)
    tUaccum.pack()
    tUaccum.insert("end",txtU)
    
def binfo():
    #brg 22.1.2017, 29.1.17
    tpspectrum=Tkinter.Toplevel(hf)
    tpspectrum.title("Distribution of s-cone-values ")
    tspectrum=ScrolledText(tpspectrum,width=120, height=20)
    tspectrum.pack()
    tspectrum.insert("end",txtspectrum)
    tpmax=Tkinter.Toplevel(hf)
    tmaxt=ScrolledText(tpmax,width=10, height=20)
    tmaxt.pack()
    tmaxt.insert("end",txtmax)

    

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' mod_spec4_2 ')
aboutmod_spec4=raioop2.brgabout(hf,"tp1","about_mod_spec4.txt",2,\
            "January, the 309th, 2017"," about U_Us_for m=3 ", "white", "t1",80,5,ScrolledText)
helpmod4_spec4=raioop2.brgabout(hf,"tp1","help_mod_spec4.txt",2,\
            "January, the 30th, 2017"," help_mod_spec4 ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", width=40,command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=40, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=40, bg="cyan", command=HD)
buttHD.pack(pady=5)
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
buttcalcgruc=Tkinter.Button(fr,text="Calculate average crucial weights (m=3 only)" \
                    ,width=40, bg="cyan",command=gcruc)
buttcalcgruc.pack()
lb2=Tkinter.Label(fr,text="Enter weights specifically for the three attributes ")
lb2.pack(pady=5)
epd=Tkinter.Entry(fr,width=20)
epd.pack()
buttscone=Tkinter.Button(fr,text="Calculate the crossing points due to the s-cones ",bg="cyan",width=40, command=scone)
buttscone.pack()
buttbackgroundinfo=Tkinter.Button(fr,text="Background info to crossing points within the s-cone ",bg="cyan",width=40,command=binfo)
buttbackgroundinfo.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=10)
hf.mainloop()
