import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import Canvas
import random
import tkFileDialog
import stats
import pstat


# Brg 14.9.08 in PSU aus mainHD7
# separately the working program developed: towardscap2: 15.9.08
# Brg 16.9.08 inclusion of graphics and reordering the daughter windows
# Brg 17.9.08: slope above average slope (aasl)
# Brg 20.11.08 during aggreg.steps: u+v = const. Hoever the last aggr.step: u+v=const+1
# Brg 20.11.08 This bug is still not identified. Routine uv
# Brg 25.11.08 txt is not defined
# Brg 25.11.08 cap2 : buttons level, cover and quotient eliminated. This does
#              not work correctly.
# Brg 26.11.08 cap3
# Brg 27.11.08 Towards cap5
# Brg 2.12.08  test with atest0212
# Brg 14.2.09 real calculation : problems with cover_show: txt_in_cov = txtloop+" "+txtadd as argument in cover_show
#             solved that problem
# Brg 16.10.09 Minor cosmetics
# Brg 10.11.09 CAP7
# brg 1.12.11 Cosmetics

def aasl2(v):
    """ determines the average slope in v
    and calculate the aggreg. steps in v:
    less or larger than the average slope"""
    #Brg 17.9.08, 27.11.08
    #v is the tuple of comparabilities
    # v(i) =< v(i+1) for any i
    # therefore v(0) is the least, v(k) is the maximum of comparabilities
    # and v(k) is the greatest value
    vleast=v[0]
    
    
    lv=len(v)
    print "length of v ",lv
    vgreatest=v[lv-1]
    print "vleast ",vleast,"  vgreatest   ",vgreatest
    avslope=(1.0*vgreatest-1.0*vleast)/(1.0*k-1.0)
    print "average slope ",avslope
    histv=rmod2.vecgen1(len(v))
    histv[0]=0  #by definition
    for i in range(1,k):
        histv[i]=v[i]-v[i-1]-avslope
    print "histogram "
    for i in range(0,k):
        print histv[i]," ",
    print " "    
    return histv        
    
       
def how_many_attributes():
    """read in how many weights """
    # taken from Disco.py
    # the number of attributes is decisive for the number of weights and strategy
    global k,flecon
    k = int(ek.get())
    global egew,estr
    egew=rmod2.vecgen1(k)
    estr=rmod2.vecgen1(k)
    lbgew.config(text=str(k)+"  attributes")
    
    try:
        flecon=int(econ.get())
    except:
        flecon=1
    if flecon==0:
        lbstrat.config(text=" weights and sequence of aggregation  "+str(k)+"  attributes")
        lbinfo1.config(text="wghts:")
        
        for j in range(0,k):
            egew[j]=Tkinter.Entry(fr2grid,width=4)
            egew[j].grid(row=3,column=j+1)
         
    else:
        lbstrat.config(text= "seq. of aggr. "+str(k)+" attr. (numbers out of {0,1,2...})")
    lbinfo2.config(text="strat:")
    
    for j in range(0,k):
        estr[j]=Tkinter.Entry(fr2grid,width=4) #26.11.08
        estr[j].grid(row=4,column=j+1)
            
def weights_strategy():
    """ Independently how the analysis afterwards
    is carried out the weights and the strategy are
    to be fixed up """
    # Brg 27.11.08
    global g,strategy,dm1,txtstrat
    g=rmod2.vecgen1(k)
    strategy=rmod2.vecgen1(k)
    gsum=0
    txtw=""
    if flecon==0:
        for j in range(0,k):
            g[j]=float(egew[j].get())
            gsum+=g[j]
        if gsum!=1.0 and gsum!=0:
            for j in range(0,k):
                g[j]=g[j]/gsum
            txtw="Renormalization! "    
        elif gsum>0.9999 and gsum<1.0001:
            txtw="...successful  "    
        else:
            txtw="+++please control the weights +++"
        lbgw2.config(text="read_in: weights/strategy",width=30)    
    else:
        for j in range(0,k):
            g[j]=1.0/(1.0*k)
        txtw="equal "
        lbgw2.config(text="read_in: strategy",width=30)
    #brg 22.3.08 , 23.3.08
    # taken from Disco.py, modified, 15.9.08
    strategy=rmod2.vecgen1(k)
    
    for j in range(0,k):
        strategy[j]=int(estr[j].get())
        
    lbconf1.config(text=txtw+"weights and strategy read in",bg="yellow")
    

def weights_optim():
    """ In order to perform an autom_cap the weights
    have to be fixed"""
    # Brg 27.11.08, 30.11.08
    global g,strategy,dm1,txtstrat
    try:
        hilfecon=econ.get()
        flecon=int(hilfecon)
    except:
        flecon=1
    g=rmod2.vecgen1(k)
    gsum=0
    if flecon==0:
        for j in range(0,k):
            g[j]=float(egew[j].get())
            gsum+=g[j]
        if gsum!=1.0 and gsum!=0:
            for j in range(0,k):
                g[j]=g[j]/gsum
    else:
        for j in range(0,k):
            g[j]=1.0/(1.0*k)
    return g        
        
def calc_Complete():
    """read in weights and performs the calculation, many most unnecessary
    details  """
    #brg 22.3.08 , 23.3.08, 10.11.09
    # taken from Disco.py, 15.9.08
    # this is the main core of cap2
    
    dm0=rmod2.matrixnorm(r,k,dm00)
    global vtuple, utuple
    vtuple=rmod2.vecgen1(k)
    utuple=rmod2.vecgen1(k)
    corrtuple=rmod2.vecgen1(k)  #25.11.08
    

    dm=rmod2.marray(r,k)
    for i in range(0,r):
        for j in range(0,k):
            dm[i][j]=dm0[i][strategy[j]]

    #dm: rearranged matrix
    txtstrat=""
    for i in range(0,k):
        txtstrat+=str(strategy[i])+"  "
    looporig=0
    txtgorig="weights irrelevant"
    txtadditional=" original "
    HD(r,k,dm,txtstrat,txtadditional, looporig,g,txtgorig)
    grearr=rmod2.marray(k,1)
    for i in range(0,k):
        grearr[i][0]=g[strategy[i]]

    # rearranged g : grearr
    
    # now the loops starts 

    vtuple[0],utuple[0],corrtuple[0]=uv(r,k,dm)  #25.11.08
    tploop=Tkinter.Toplevel(hf)
    tploop.title(" Complete List of Comparab & Incomp ")
    tloop=ScrolledText(tploop,width=60,height=5)
    tloop.pack()
    txtg="weights: "   #26.11.08
    for j in range(0,k):
        txtg+=str(round(g[j],2))+" "
    txtg+="\n"    
    txtloop="aggreg.sequence: "+txtstrat+"\n"
    txtloop+=txtg+"\n"
    txtloop+="\naggreg.step\t\tComp\tIncomp\tequivalence relations"  #1.12.2011
    txtloop+="\n"+50*"-"
    txtloop+="\n - \t\t"+str(vtuple[0])+"\t"+str(utuple[0])
    for loop in range(2,k+1):
        c=rmod2.marray(r,1)
        for i in range(0,r):
            msum=0.0
            for j in range(0,loop):
                msum+=1.0*dm[i][j]*grearr[j][0]
            c[i][0]=1.0*msum
    
        dm1=rmod2.marray(r,k+1-loop)
        for i in range(0,r):
            dm1[i][0]=c[i][0]

        if loop<k:
            for i in range(0,r):
                j1=1
                for j in range(loop,k):
                    #print "j1= ",j1,"  j = ",j,"   loop = ",loop,"  dim = ",k+1-loop
                    dm1[i][j1]=dm[i][j]
                    j1+=1
        else:
            pass #final aggregation to one superindicator, already in dm1[i][0]
        txtadd=" aggreg.no "+str(loop)
##        HD(r,k+1-loop,dm1,txtstrat,txtadd,loop,g,txtg)
##        #rmod2.matout(n,n,zeta2)
        vtuple[loop-1],utuple[loop-1],corrtuple[loop-1]=uv(r,k+1-loop,dm1)
        txtloop+="\n"+str(loop)+"\t\t"+str(vtuple[loop-1])+"\t"+str(utuple[loop-1])+"\t"+str(corrtuple[loop-1])
    tloop.insert("end",txtloop)    
    # graphics
    names=rmod2.vecgen1(5)
    lenvtuple=len(vtuple)
    normv=rmod2.vecgen1(lenvtuple)
    names[0]="steps "
    names[1]="V"
    names[2]="graphics window: strategy "+txtstrat+"\n"+txtg
    names[3]="max= "+str(r*(r-1.0)/2.0)
    names[4]="C A P  "+txtstrat
    normv,vmin,vmax=rmod2.vectornorm(lenvtuple,vtuple)
    #self,supmaster,names,space1,space2,col,w,h,start,stop
    gr1=raioop2.brggraph(hf,names,30,60,"red",2,normv,0,k)
    devtuple=aasl2(vtuple)
    lendevtuple=len(devtuple)
    devn,devmax,devmin,devnull=rmod2.vectornorm2(lendevtuple,devtuple)
    gr2=raioop2.brghisto3(hf,"tpdevtuple",k,devn,devnull,devmax,devmin,"red","white","differential_CAP: "+txtstrat)
    gr2.ausgabe()
    
def calc_CAP_profile():
    """ Like calc_Complete, however only the line-
    graph the histogram (differential cap and the Table comp-incomp-equiv. """
    #Brg 27.11.08
    # taken from calc_Complete
    # this is the main core of cap4
    dm0=rmod2.matrixnorm(r,k,dm00)
    global vtuple, utuple
    vtuple=rmod2.vecgen1(k)
    utuple=rmod2.vecgen1(k)
    corrtuple=rmod2.vecgen1(k)  #25.11.08
    

    dm=rmod2.marray(r,k)
    for i in range(0,r):
        for j in range(0,k):
            dm[i][j]=dm0[i][strategy[j]]

    #dm: rearranged matrix
    txtstrat=""
    for i in range(0,k):
        txtstrat+=str(strategy[i])+"  "
    
    grearr=rmod2.marray(k,1)
    for i in range(0,k):
        grearr[i][0]=g[strategy[i]]

    # rearranged g : grearr
    
    # now the loops starts 

    vtuple[0],utuple[0],corrtuple[0]=uv(r,k,dm)  #25.11.08
    tploop=Tkinter.Toplevel(hf)
    tploop.title(" Comparab & Incomp ")
    tloop=ScrolledText(tploop,width=60,height=5)
    tloop.pack()
    txtg="weights: "   #26.11.08
    for j in range(0,k):
        txtg+=str(round(g[j],2))+" "
    txtg+="\n"    
    txtloop="aggreg.sequence: "+txtstrat+"\n"
    txtloop+=txtg+"\n"
    txtloop+="\naggreg.step\tComp\tIncomp\tequivalence relations"
    txtloop+="\n"+50*"-"
    txtloop+="\n - \t\t"+str(vtuple[0])+"\t"+str(utuple[0])
    for loop in range(2,k+1):
        c=rmod2.marray(r,1)
        for i in range(0,r):
            msum=0.0
            for j in range(0,loop):
                msum+=1.0*dm[i][j]*grearr[j][0]
            c[i][0]=1.0*msum
    
        dm1=rmod2.marray(r,k+1-loop)
        for i in range(0,r):
            dm1[i][0]=c[i][0]

        if loop<k:
            for i in range(0,r):
                j1=1
                for j in range(loop,k):
                    #print "j1= ",j1,"  j = ",j,"   loop = ",loop,"  dim = ",k+1-loop
                    dm1[i][j1]=dm[i][j]
                    j1+=1
        else:
            pass #final aggregation to one superindicator, already in dm1[i][0]
        
        vtuple[loop-1],utuple[loop-1],corrtuple[loop-1]=uv(r,k+1-loop,dm1)
        txtloop+="\n"+str(loop)+"\t\t"+str(vtuple[loop-1])+"\t"+str(utuple[loop-1])+"\t"+str(corrtuple[loop-1])
    tloop.insert("end",txtloop)    
    # graphics
    names=rmod2.vecgen1(5)
    lenvtuple=len(vtuple)
    normv=rmod2.vecgen1(lenvtuple)
    names[0]="steps "
    names[1]="V"
    names[2]="graphics window: strategy "+txtstrat+"\n"+txtg
    names[3]="max= "+str(r*(r-1.0)/2.0)
    names[4]="C A P  "+txtstrat
    maxvtuple=max(vtuple)
    minvtuple=min(vtuple)
    normv,vmin,vmax=rmod2.vectornorm(lenvtuple,vtuple)
    #self,supmaster,names,space1,space2,col,w,h,start,stop
    gr1=raioop2.brggraph(hf,names,30,60,"red",2,normv,0,k)
    devtuple=aasl2(vtuple)
    lendevtuple=len(devtuple)
    devn,devmax,devmin,devnull=rmod2.vectornorm2(lendevtuple,devtuple)
    gr2=raioop2.brghisto3(hf,"tpdevtuple",k,devn,devnull,devmax,devmin,"red","white","differential_CAP: "+txtstrat)
    gr2.ausgabe()

def show_selected_step():
    icon=int(e_icon.get())
    if icon<0 or icon>k:
        lbwarnung.config(bg="yellow",text="+++ wrong step +++\
                \nOnly between 0 (original) and "+str(k))
    else:
        dm0=rmod2.matrixnorm(r,k,dm00)
        global vtuple, utuple
        vtuple=rmod2.vecgen1(k)
        utuple=rmod2.vecgen1(k)
        corrtuple=rmod2.vecgen1(k)  #25.11.08
        dm=rmod2.marray(r,k)
        for i in range(0,r):
            for j in range(0,k):
                dm[i][j]=dm0[i][strategy[j]]

        #dm: rearranged matrix
        txtstrat=""
        for i in range(0,k):
            txtstrat+=str(strategy[i])+"  "
        if icon==0:    
            looporig=0
            txtgorig="weights irrelevant"
            txtadd=" original "
            HD(r,k,dm,txtstrat,txtadd,looporig,g,txtgorig)

        grearr=rmod2.marray(k,1)
        for i in range(0,k):
            grearr[i][0]=g[strategy[i]]

        # rearranged g : grearr
        
        # now the loops starts 

        vtuple[0],utuple[0],corrtuple[0]=uv(r,k,dm)  #25.11.08
        tploop=Tkinter.Toplevel(hf)
        tploop.title(" Comparab & Incomp ")
        tloop=ScrolledText(tploop,width=60,height=5)
        tloop.pack()
        txtg="weights: "   #26.11.08
        for j in range(0,k):
            txtg+=str(round(g[j],2))+" "
        txtg+="\n"    
        txtloop="aggreg.sequence: "+txtstrat+"\n"
        txtloop+=txtg+"\n"
        txtloop+="\naggreg.step\tComp\tIncomp\tequivalence relations"
        txtloop+="\n"+50*"-"
        txtloop+="\n - \t\t"+str(vtuple[0])+"\t"+str(utuple[0])
        for loop in range(2,k+1):
            c=rmod2.marray(r,1)
            for i in range(0,r):
                msum=0.0
                for j in range(0,loop):
                    msum+=1.0*dm[i][j]*grearr[j][0]
                c[i][0]=1.0*msum
        
            dm1=rmod2.marray(r,k+1-loop)
            for i in range(0,r):
                dm1[i][0]=c[i][0]

            if loop<k:
                for i in range(0,r):
                    j1=1
                    for j in range(loop,k):
                        #print "j1= ",j1,"  j = ",j,"   loop = ",loop,"  dim = ",k+1-loop
                        dm1[i][j1]=dm[i][j]
                        j1+=1
            else:
                pass #final aggregation to one superindicator, already in dm1[i][0]
            if loop==icon:
                txtadd=" aggreg.no "+str(loop)
                HD(r,k+1-loop,dm1,txtstrat,txtadd,loop,g,txtg)
            
            vtuple[loop-1],utuple[loop-1],corrtuple[loop-1]=uv(r,k+1-loop,dm1)
            txtloop+="\n"+str(loop)+"\t\t"+str(vtuple[loop-1])+"\t"+str(utuple[loop-1])+"\t"+str(corrtuple[loop-1])
        tloop.insert("end",txtloop)    
        
def replaceattr(n,m,iopt,jopt,phi,dm,prop):
    """dm will replaced by phi
    if say the 2. and 4. column are to be replaced by phi, then
    first step: both columns get the value phi
    second step (in dmneu): the first of these columns will be skipped
    third step: the second of these columns (here column no 4) filled with phi
    will maintained.
    In summa the new matrix dimension has only m-1 columns """
    # Brg *: 29.11.08
    # Brg akt: 29.11.08
    dmneu=rmod2.marray(n,m-1)
    propneu=rmod2.vecgen1(m-1)
    for i in range(0,n):
        dm[i][iopt]=phi[i]
        dm[i][jopt]=phi[i]
    #prop[iopt]=str(prop[jopt])+str(prop[iopt])+"| "
    prop[jopt]=str(prop[iopt])+str(prop[jopt])+"| "
    delcol=min(iopt,jopt)
    #print "delcol = ",delcol
    for i in range(0,n):
        for j in range(0,delcol):
            dmneu[i][j]=dm[i][j]
    for j in range(0,delcol):
        propneu[j]=prop[j]
    #rmod2.matout(n,m-1,dmneu)
    for i in range(0,n):
        for j in range(delcol,m-1):
            dmneu[i][j]=dm[i][j+1]
    for j in range(delcol,m-1):
        propneu[j]=prop[j+1]
    
    return dmneu,propneu

    
def genphi(n,g,iopt,jopt,phi,dm):
    """generation of phi in the frame of o-METEOR """
    #Brg *: 29.11.08
    #Brg akt: 29.11.08
    for i in range(0,n):
        phi[i]=g[iopt]*dm[i][iopt]+g[jopt]*dm[i][jopt]
        phi[i]=round(phi[i],4)   #rounding problems! normalization will be problematic
    return phi    


def automcap():
    """  dm --> spearman correl __> elim attr. i and j and replace
    one of the columns by phi --> new dm """
    # Brg * : 27.11.08
    # Brg akt: 10.11.09
    # Brg : 27.11.08,28.11.08,29.11.08,30.11.08, 10.11.09
    global vtuple, utuple
    
    ##rmod2.matout(n,m,dm)
    n=r  #adaptation
    m=k  #adaptation
    phi=rmod2.vecgen1(n)
    
    vtuple=rmod2.vecgen1(k)
    utuple=rmod2.vecgen1(k)
    corrtuple=rmod2.vecgen1(k)  #25.11.08
    g=weights_optim()
    dmoptim=rmod2.matcopy1(r,m,dm00)
    dmoptim=rmod2.matrixnorm(n,m,dmoptim)
    propoptim=rmod2.veccopy(m,prop)
    protattr="protokoll aggregierung \n"
    
    # g is taken from the body of the program
    ##print "loop"
    ##print "================================================="
    vtuple[0],utuple[0],corrtuple[0]=uv(r,k,dmoptim)  
    tploop2=Tkinter.Toplevel(hf)
    tploop2.title(" List of Comparab. & Incomp: automcap")
    tloop2=ScrolledText(tploop2,width=60,height=5)
    tloop2.pack()
    txtg="weights: "   #26.11.08
    for j in range(0,k):
        txtg+=str(round(g[j],2))+" "
    txtg+="\n"
    txtloop=txtg+"\n"
    txtloop+="\naggreg.step\tComp\tIncomp\tequivalence relations"
    txtloop+="\n"+50*"-"
    txtloop+="\n - \t\t"+str(vtuple[0])+"\t"+str(utuple[0])+"\t"+str(corrtuple[0])
    HD(r,m,dmoptim," ","original",str(m),g,txtg)
    #print "m = ",m
    txtp="original+\n"
    for i in range(0,k):
        txtp+=prop[i]
    txtp+="\n"
    while m>=2:
        corrm,iopt,jopt,copt=rmod2.optimattr(n,m,dmoptim)
        protattr+=str(m)+": "+str(iopt)+", "+str(jopt)+"\n "
        phi=genphi(n,g,iopt,jopt,phi,dmoptim)
        dmneu,propneu=replaceattr(n,m,iopt,jopt,phi,dmoptim,propoptim)  # this line and...

        m-=1                                                             #..this line shouldnt separated
        
        dmoptim=rmod2.matcopy1(n,m,dmneu)
        dmoptim=rmod2.matrixnorm(n,m,dmoptim)
        vtuple[k-m],utuple[k-m],corrtuple[k-m]=uv(r,m,dmoptim)  #25.11.08
        txtloop+="\n"+str(m)+" \t\t"+str(vtuple[k-m])+"\t"+str(utuple[k-m])+"\t"+str(corrtuple[k-m])
        
        #print propneu
        propoptim=rmod2.veccopy(m,propneu)
        for i in range(0,m):
            txtp+="\n"+str(m)+":"+propoptim[i]
        #HD(r,m,dmoptim," ",str(m),str(m),g,txtg)
    
    txtloop+="\n autom. aggregation sequence "
    txtloop+="\n"
    txtloop+=txtp+"\n"
    tloop2.insert("end",txtloop)
    # graphics
    names=rmod2.vecgen1(5)
    lenvtuple=len(vtuple)
    normv=rmod2.vecgen1(lenvtuple)
    names[0]="steps "
    names[1]="V"
    names[2]="graphics window: autom strategy \n"+txtg
    names[3]="max= "+str(r*(r-1.0)/2.0)+"  min = "+str(vtuple[0])
    names[4]="Autom C A P  "
    normv,vmin,vmax=rmod2.vectornorm(lenvtuple,vtuple)
    #self,supmaster,names,space1,space2,col,w,h,start,stop
    gr1=raioop2.brggraph(hf,names,30,60,"red",2,normv,0,k)
    devtuple=aasl2(vtuple)
    lendevtuple=len(devtuple)
    devn,devmax,devmin,devnull=rmod2.vectornorm2(lendevtuple,devtuple)
    gr2=raioop2.brghisto3(hf,"tpdevtuple",k,devn,devnull,devmax,devmin,"red","white","differential_autom CAP: ")
    gr2.ausgabe()
    
def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 21.6.08
    # brg 10.6.08, 21.6.08
    awidth=zv*40
    aheight=zv*40
    if awidth<400:
        awidth=400
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y


#################  new  13.01.08   #################################################
def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 14.9.08
    #note: There may be conflicts with other moduls
    #note: fileselect does now partially the job of filecomp: the
    #      correct obj and prop will be generated 
    #source:-
    
    global fn,r,k,obj,prop,dm00
    fn=tkFileDialog.askopenfilename()
    
    dm00,ob,pro,r,k=rmod2.EXCELreadin4(fn)

    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    
    lbfile.config(bg="yellow")
    lbfile["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    buttshow.config(state="active")
    
         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title('showDM')
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm0,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm00[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def quotient_set(txtstrat,obj,objred,txtequiv,neq,loop,txtg):
    """informs about quotient sets"""
    # Brg 16.9.08, 25.11.08
    hfeq=Tkinter.Toplevel(hf)
    hfeq.title(' equivalent elements ')
    lbeq1=Tkinter.Label(hfeq,text="Structure: quotient set\n aggregation "+txtstrat\
                        +"\n"+"step: "+str(loop)+"\n"+txtg) #21.6.08 many changes
    lbeq1.pack()
    labeq=Tkinter.Label(hfeq,text="")
    labeq.pack()
    txteq=ScrolledText(hfeq,width=60,height=10)
    txteq.pack()
    txtq=""
    l1=len(obj)
    l2=len(objred)
    if l1!=l2:
        labeq.config(text="quotient set is unequal the object set ")
        
        txtq=txtequiv+"\n"    #25.11.08
        txtq+="\n\n distribution of equivalent elements \n"
        for i in range(0,r):
            if neq[i]>1:
                txtq+=str(neq[i])+"\n"
        
       
    else:
        labeq.config(text="quotient set = object set ",bg="yellow")
        txtq+="\nThe equivalence elements are singletons "
        txtq+="\n see the data matrix for the objects "
    txteq.insert("end",txtq)    
    #



def cover_show(zeta2,loop,txtstrat,txtg,objred):
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    txt3+="aggregation step No "+str(loop)+"\n"
    txt3+=txtstrat+"\n"
    txt3+=txtg+"\n\n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def level_show(txtloop,zzmax,objred,lobj,revlext,loop,txtg):
    """shows the levels of the HD"""
    #brg 16.9.08, 25.11.08
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' aggreg.No '+str(loop))
    
    txtlev=' Level population: aggregation step = '+str(loop)
     #One linear extension (based on levels)
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1=txtlev+"\n"
    txt1+=txtloop+"\n"
    txt1+=txtg+"\n\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(tplev,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
        
def HD(r,kact,y,txtloop,txtadd,loop,g,txtg):
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension"
    # Brg 20.12.07, 28.12.07, 15.9.08
    # If the number of representants > 60 then only the cover-matrix and the level-population
    #
    global rred,n,objred,obj    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    rred,xred,objred,txtequiv,neq=rmod2.equivcompactm(r,kact,y,obj)
    txt=txtequiv   #25.11.08 There may be some relations to txt. However only txtequiv is global
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    labg=Tkinter.Label(freq,text=txtg)
    labg.pack()
    zetahilf=rmod2.comp(n,kact,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
   
    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
        
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>60:
        txt_in_cov=txtloop+" "+txtadd                        #14.2.09
        cover_show(zeta2,loop,txt_in_cov,txtg,objred)                  #20.1.08, 14.2.09
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn+" \n strategy: "+txtloop+" "+txtadd+"\n"+txtg)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight)
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        level_show(txtloop,zzmax,objred,lobj,revlext,loop,txtg)
        cover_show(zeta2,loop,txtloop,txtg,objred)
        quotient_set(txtloop,obj,objred,txtequiv,neq,loop,txtg)
        return zeta, zeta2,txtequiv,neq,zzmax,revlext,lobj,objred


def uv(r,k,dm):
    #14.9.08, 15.9.08
    # calculates incomparabilities and comparabilities on the basis of
    # object set.
    # dm is the dm varying from one column to two, etc
    # col is the actual number of columns considered
    zeta=rmod2.comp(r,k,dm)  #dm will be first all columns, then the first two columns aggregated
                                 # until a weighted sum of all attrib. is obteined
    
    # v is the actual value of comparabilities
    # u is the actual value of incomparabilities
    # v[0] = comp. of orig. dm is considered
    # v[1] is the number of comp. after first aggregation
                                 
    summ=0
    corrt=0
    for i in range(0,r):
        for j in range(0,r):
            if zeta[i][j]==zeta[j][i] and zeta[i][j]!=0:
                corrt+=1
            summ+=zeta[i][j]
    v=summ-r                      #diagonal elements are not counted
    corr=1.0*(corrt-r)/2.0                   # diagonal elements not counted. >= and <= corresponds to  o n e  equiv. relat.
    summ=0
    for i in range(0,r):
        for j in range(0,r):
            if zeta[i][j]==0 and zeta[j][i]==0:
                summ+=1
    u=1.0*summ/2.0            
    return v,u,corr        
    
    
hf=Tkinter.Tk()
hf.title('--    Cap analysis   -- ')

lab0=Tkinter.Label(hf,text="",width=50)
lab0.pack()
#  Use of OOP
aboutcap=raioop2.brgabout(hf,"tp2","about_cap.txt",7,\
    "Nov. 10th,2009"," about_cap ", "white", "t2",80,5,ScrolledText)
helpcap=raioop2.brgabout(hf,"tp1","help_cap.txt",7,\
    "Nov. 10th,2009"," help_cap ", "white", "t1",80,10,ScrolledText)
    


buttfile=Tkinter.Button(hf,text="(1) Select and open file",bg="white",bd=4,width=25,command=fileselect)
buttfile.pack(pady=5)
lbfile=Tkinter.Label(hf,text="\n\n\n")
lbfile.pack()
buttshow=Tkinter.Button(hf,text="show data matrix ",width=25,state="disabled", command=showDM)
buttshow.pack(pady=5)
frinput2=Tkinter.Frame(hf, relief="sunken",bd=3)
frinput2.pack(pady=5)
fr1=Tkinter.Frame(frinput2)
fr1.pack()
lb_how_many_weights=Tkinter.Label(fr1,text=" how many attributes ")
lb_how_many_weights.pack(side="left")
ek=Tkinter.Entry(fr1,width=3)
ek.pack(side="left")
lbexpl=Tkinter.Label(fr1,text="eq.weights: 1, else: 0")  #26.11.08 and next 3 rows
lbexpl.pack(side="left")
econ=Tkinter.Entry(fr1,width=1)
econ.pack(side="left")
lbgew=Tkinter.Label(fr1,text="")
lbgew.pack()
fr2=Tkinter.Frame(frinput2)
fr2.pack()
butt1=Tkinter.Button(fr2,bg="cyan",text="(2) confirm",width=25,command=how_many_attributes)
butt1.pack()
lbgw2=Tkinter.Label(fr2,text="")
lbgw2.pack()
lbstrat=Tkinter.Label(fr2,text="")
lbstrat.pack()
fr2grid=Tkinter.Frame(fr2)
fr2grid.pack()
lbinfo1=Tkinter.Label(fr2grid,text="")
lbinfo1.grid(row=3,column=0)
lbinfo2=Tkinter.Label(fr2grid,text="")
lbinfo2.grid(row=4,column=0)
buttacc=Tkinter.Button(fr2,text="(2.1) accept strategy and weights",bg="cyan",width=25,command=weights_strategy)
buttacc.pack()
lbconf1=Tkinter.Label(fr2)
lbconf1.pack()
butt2b=Tkinter.Button(fr2,text="(2.2) calc_CAP_profile",bg="cyan",width=25,command=calc_CAP_profile)
butt2b.pack()
butt2a=Tkinter.Button(fr2,text=" details of (2.2)",width=25,command=calc_Complete)
butt2a.pack()

lb4=Tkinter.Label(fr2,text="select aggr. step ")
lb4.pack(side="left")
e_icon=Tkinter.Entry(fr2,width=3)
e_icon.pack(side="left")
fr3=Tkinter.Frame(frinput2)
fr3.pack()
buttshowstep=Tkinter.Button(fr3,text="(2.3) show_selected_step",bg="cyan",width=25,command=show_selected_step)
buttshowstep.pack()
fr4=Tkinter.Frame(hf)
fr4.pack()
buttoptim=Tkinter.Button(fr4,text="(3) autom._CAP (instead of (2) ",bg="cyan",width=25,command=automcap)
buttoptim.pack(pady=5)
buttdestroy=Tkinter.Button(hf,text=" exit",bg="red",width=10,bd=4,command=hf.destroy)
buttdestroy.pack(pady=10)

hf.mainloop()
    

