import rmod2
import Tkinter
import raioop2
import tkSimpleDialog
import tkFileDialog
from ScrolledText import *
import raioop2
from math import *


# brg 13.3.09, 14.3.09
# simuliert cov matrix speicherung und Objectnamenuebergabe
# 7.9.09 Fehler in raiwritecov1
# 28.12.2011: no error
# brg 25.7.2012
# brg 26.4.2013 cosmetic change

def nrofobjects():
    global r,cov,obj
    r=tkSimpleDialog.askinteger('Entry','how many objects ', minvalue=1,maxvalue=200)
    cov=rmod2.marray(r,r)
    obj=rmod2.vecgentext1(r)
    
    
def nameofobjects():
    global obj
    for i in range(0,r):
        obj[i]=tkSimpleDialog.askstring(' Object entries','name of object '+str(i)+" = ")

def coverdialog():
    # brg , extended: 25.7.2012
    
    cvc=Tkinter.Canvas(hf,width=400,height=400,bg="white")
    cvc.pack()
    lbcov.config(text="1 for a covered-relation, else:0")
    posx=rmod2.vecgen1(r)
    posy=rmod2.vecgen1(r)
    for i in range(0,r):
        posx[i]=100*cos(i*6.28/r)
        posy[i]=100*sin(i*6.28/r)
        
        cvc.create_oval(160+posx[i]-20,130+posy[i]+20,160+posx[i]+20,130+posy[i]-20,fill="yellow")       
        cvc.create_text(162+posx[i],132+posy[i],text=str(obj[i]),font = "15")

    rdgr=80
    for i in range(0,r):
        posx[i]=rdgr*cos(i*6.28/r)
        posy[i]=rdgr*sin(i*6.28/r)
        for j in range(0,r):
            posx[j]=rdgr*cos(j*6.28/r)
            posy[j]=rdgr*sin(j*6.28/r)
            if i!=j and cov[i][j]==0 and cov[j][i]==0:
                c=tkSimpleDialog.askinteger(' Cov-entries',obj[i]+" covered by... "+obj[j]+"?",\
                                            minvalue=0,maxvalue=1)
                cov[i][j]=c
                if c==1:
                    cvc.create_line(160+posx[j],130+posy[j],160+posx[i],130+posy[i],arrow="last")  #7.6.08
    global cov            
    
def HD():
    "based on cover-matrix the Hasse diagram is generated and one linear extension)"
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #

    global zeta2,n,obj  
   
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
    #print "test 7.5.08 rs  = ",rs    
    n=r
    rs=r     #14.4.08 
   
    
    hfhd1=Tkinter.Toplevel(hf)
    hfhd1.title(' Hasse diagram / cover matrix ')
    lbhfhd1=Tkinter.Label(hfhd1,text='Hasse diagram or cover matrix ')
    lbhfhd1.pack()
    freq=Tkinter.Frame(hfhd1,width=400,height=480)
    freq.pack()
    
   
    
    zeta=rmod2.marray(rs,rs)
    for i in range(0,rs):
        for j in range(0,rs):
            zeta[i][j]=cov[i][j]
    for i in range(0,rs):
        if zeta[i][i]==0:
            zeta[i][i]=1
            
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()
    
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rs,zeta)
    
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= obj[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=obj[revlext[i]]+" < "
        else:
            txt2+=obj[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    if n>50:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram ")
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=400,height=480,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(320.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(320.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=obj[lobj[i][j]])
        garrow1x=380
        garrow1y=20
        garrow2y=230
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        
        cv.pack()



def savecov():
    fn=tkFileDialog.asksaveasfilename(title="Save file ",defaultextension=".txt")
    rmod2.raiwritecov1(fn,cov,obj,r)
    

hf=Tkinter.Tk()
hf.title('--    interactive dialog for covermatrix  -- ')


abouti_cover=raioop2.brgabout(hf,"tp1","about_cov_interactive.txt",3,\
            "July,the 25th, 2012"," about cover interactive ", "white", "t1",120,5,ScrolledText)
helpi_cover=raioop2.brgabout(hf,"tp1","help_cov_interactive.txt",3,\
            "July, the 25th, 2012"," help_cov_interactive ", "white", "t1",80,5,ScrolledText)
    
butt1=Tkinter.Button(hf,text="how many objects",bg="cyan",width=30,command=nrofobjects)
butt1.pack(pady=2)
butt2=Tkinter.Button(hf,text="names of objects ",bg="cyan",width=30,command=nameofobjects)
butt2.pack(pady=2)
lbcov=Tkinter.Label(hf,text="")
lbcov.pack()
butt3=Tkinter.Button(hf,text="cover-matrix dialog ",bg="cyan",width=30,command=coverdialog)
butt3.pack(pady=2)
buttHD=Tkinter.Button(hf,text="Hasse diagram ",bg="cyan",width=30,command=HD)
buttHD.pack()
butt4=Tkinter.Button(hf,text="save cover-matrix dialog",bg="cyan",width=30,command=savecov)
butt4.pack(pady=5)
buttexit=Tkinter.Button(hf,text='exit',bg="red",command=hf.destroy)
buttexit.pack(pady=10)
    
hf.mainloop()
