import rmod2
import raioop2
import Tkinter
import tkFileDialog
from ScrolledText import *
import pstat
import stats


# Brg  13.7.09, 23.7.09, 24.7.09
def ov():
    tpov=Tkinter.Toplevel(hf)
    tpov.title('    overview    ')
    lbbasic=Tkinter.Label(tpov,text=" menue-governed program, calc. weights\n after AHP-method ",bg="white")
    lbbasic.pack(pady=5)
    

def about_dahp():
    tpabout=Tkinter.Toplevel(hf)
    aboutdahp=raioop2.brgabout(tpabout,"tpabout","about_dahp.txt",4,\
            "July, 24th,2009"," about dahp ", "white", "t1",80,5,ScrolledText)

def help_dahp():
    tphelp=Tkinter.Toplevel(hf)
    helpmdahp=raioop2.brgabout(tphelp,"tpabout","help_dahp.txt",4,\
            "July, 24th,2009"," help_dahp ", "white", "t1",80,5,ScrolledText)


def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 23.7.09
    #source: dds8.py
    
    global fn,obj,prop,r,m,dm

    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,m=rmod2.EXCELreadin4(fn)
    
    obj=rmod2.vecgentext1(r)
    prop=rmod2.vecgentext1(m)
    for i in range(0,r):
        obj[i]=ob[i+1]
    for j in range(0,m):
        prop[j]=pro[j+1]
    
    
    return 

def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 14.1.08, 8.5.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    # taken from dds8
    dm,ob,pro,r,m=rmod2.EXCELreadin4(fn)
    
    prop=rmod2.vecgentext1(m)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,m):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt=rmod2.equivcompact(r,m,dm,obj)    
    ###############################################################
    
    return rred,m,xred,objred,obj,prop,txt           


def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 13.7.09
    #source: dds8.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,m=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,m):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,m):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,m):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    
def normDM():
    global dmn
    dmn=rmod2.matrixnorm(r,m,dm)
    tpnorm=Tkinter.Toplevel(hf)
    tpnorm.title(' data matrix normalized ')
    lbnorm=Tkinter.Label(tpnorm,text="dm with "+str(r)+"  rows \n"+str(m)+"  columns normalized")
    buttshowdm=Tkinter.Button(tpnorm,text="show norm. dm ",command=showdmn)
    buttshowdm.pack()
    
                         
   
def showdmn():
    tpsdmnorm=Tkinter.Toplevel(hf)
    tpsdmnorm.title(' show normalized dm ')
    
    tfile2=ScrolledText(tpsdmnorm,width=60,height=4)
    tfile2.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,m):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n normalized data matrix  \n"
    txt3+="\t"
    for j in range(0,m):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,m):
            txt3+=str(round(dmn[i][j],2))+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile2.insert("end",txt)
    
    

def newDM():
    #Brg 13.7.09, 13.6.2013
    def confirmdim():
        def confirm():
            global dm
            #print "r=  ",r
            #print "m = ",m
            dm=rmod2.marray(r,m)
            for i in range(0,r):
                for j in range(0,m):
                    dm[i][j]=float(e[i][j].get())
            tpshow=Tkinter.Toplevel(hf)
            tpshow.title(' show/edit new dm ')
            frshow=Tkinter.Frame(tpshow,width=60,height=100)
            frshow.pack()
            tfile=ScrolledText(frshow,width=60,height=4)
            tfile.pack()
            txt1="\n"
            txt1+="\n objects\n"
            for i in range(0,r):
                txt1+=" "+obj[i]+",\t"
            txt1+="\n"
            txt2="\n properties  \n"
            for j in range(0,m):
                txt2+=" "+prop[j]+",\t"
            txt2+="\n"
            txt3="\n data matrix  \n"
            txt3+="\t"
            for j in range(0,m):
                txt3+=prop[j]+"\t"
            txt3+="\n"    
            for i in range(0,r):
                txt3+=obj[i]+"\t"
                for j in range(0,m):
                    txt3+=str(dm[i][j])+"\t"
                txt3+="\n"
            txt3+="\n\n"
            txt=txt1+txt2+txt3
            tfile.insert("end",txt)    

        global r,m,fn,obj,prop
        r=int(en.get())
        m=int(em.get())
        fn="dummy.txt"
        obj=[]
        for i in range(0,r):
            obj.append(str(i))
        prop=[]
        for j in range(0,m):
            prop.append("q"+str(j+1))
        #print "obj = ",obj
        #print "prop= ",prop
        e=rmod2.marray(r,m)
        frmatrix=Tkinter.Frame(tpnew,bd=2,width=r*5,relief="sunken")  #13.6.2013
        frmatrix.pack()
        for i in range(0,r):
            for j in range(0,m):
                e[i][j]=Tkinter.Entry(frmatrix,width=5)
                e[i][j].grid(row=1+i,column=j)  #13.6.2013
        buttconfirm=Tkinter.Button(frmatrix,text="confirm",bg="cyan",command=confirm)
        buttconfirm.grid(row=r+6,columnspan=m)


    tpnew=Tkinter.Toplevel(hf)
    tpnew.title('new data matrix ')
    frnew=Tkinter.Frame(tpnew)
    frnew.pack()
    lben=Tkinter.Label(frnew,text="no of objects ")
    lben.grid(row=0,column=0)
    en=Tkinter.Entry(frnew,width=3)
    en.grid(row=0,column=1)
    lbem=Tkinter.Label(frnew,text="no of attributes ")
    lbem.grid(row=1,column=0)
    em=Tkinter.Entry(frnew,width=3)
    em.grid(row=1,column=1)
    buttconfirmdim=Tkinter.Button(frnew,text="confirm dim ",bg="cyan",command=confirmdim)
    buttconfirmdim.grid(row=2,column=1)
    
def newdm_save():
    #brg  31.5.09, 1.6.09, 23.7.09 (taken from palg4)
    global m
    tpsdm=Tkinter.Toplevel(hf,width=60,height=5)
    tpsdm.title(' save new dm ')
    frsdt=Tkinter.Frame(tpsdm,relief="sunken",bd=2)
    frsdt.pack()
    lbstart=Tkinter.Label(frsdt,text=" select directory ",bg="yellow")
    lbstart.pack()
    fn=tkFileDialog.asksaveasfilename(parent=tpsdm)
    rmod2.raiwrite5(fn,dm,obj,prop,r,m)
    lbsuccess=Tkinter.Label(frsdt,text="matrix with \n"+str(r)+"  rows  and "+str(m)+"\n  columns stored",bg="yellow")
    lbsuccess.pack()
    
def fileselect_PyHasse():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    #* 1.6.09
    # akt. 24.7.09
    # source: from mainHD16
    global fn,r,m,dm,obj,prop
    fn=tkFileDialog.askopenfilename()
    r,m,dm,obj,prop=rmod2.raireadin5(fn)
    tp3=Tkinter.Toplevel(hf)
    tp3.title(' read_in PyHasse-file ')
    lbtp3=Tkinter.Label(tp3,text=" General information about the read-in data matrix:\n\
            no of rows: "+str(r)+"\n   no of columns:  "+str(m),bg="yellow")
    lbtp3.pack()
    buttshowpdt=Tkinter.Button(tp3,text="show pdt-file ",width=25,command=show_pdtfile)
    buttshowpdt.pack()
    
    return 

def show_pdtfile():
    """ pdt-Files are files generated within PyHasse"""
    # Brg 24.7.09
    tp4=Tkinter.Toplevel(hf)
    tp4.title(' show PyHasse-file ')
    tfile3=ScrolledText(tp4,width=60,height=4)
    tfile3.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,m):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,m):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,m):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile3.insert("end",txt)


def critmat():
    tpcrit=Tkinter.Toplevel(hf,width=60)
    tpcrit.title(' pairwise criteria preference ')
    lbcrit=Tkinter.Label(tpcrit, text="criteria preferences, please use\n1,3,5,... and their reciprocals",bg="white")
    lbcrit.pack()
    frcrit=Tkinter.Frame(tpcrit,width=60)
    frcrit.pack(pady=5)
          
    global crit  
    lbc=rmod2.vecgen1(m)
    lbexpla1=Tkinter.Label(frcrit,text="    criterion 1 preferred to criterion 2 :",bg="white")
    lbexpla1.grid(row=1,columnspan=2)
    mk=int(m*(m-1)*0.5)
    zaehl=0
    crit=rmod2.vecgen1(mk)
    for i in range(0,m):
        for j in range(i+1,m):
            lbc[i]=Tkinter.Label(frcrit,text="crit."+str(i))
            lbc[i].grid(row=2+zaehl,column=0)
            lbdp=Tkinter.Label(frcrit,text="  :  ",bg="white")
            lbdp.grid(row=2+zaehl,column=1)
            lbc[j]=Tkinter.Label(frcrit,text="crit."+str(j))
            lbc[j].grid(row=2+zaehl,column=2)
            crit[zaehl]=Tkinter.Entry(frcrit,width=3)
            crit[zaehl].grid(row=2+zaehl,column=3)
            zaehl+=1
    
    buttcrit=Tkinter.Button(tpcrit,text="submit your preferences",width=25,bg="cyan",command=submit)
    buttcrit.pack()    
    
def submit():
    global c,m,xcrit,txtcrit,wcrit,sumcol,sumrow
    wcrit=rmod2.marray(m,m)
    wcritn=rmod2.marray(m,m)
    mk=int(m*(m-1)*0.5)
    xcrit=rmod2.vecgen1(mk)
    txtcrit=""
    for i in range(0,mk):
        xcrit[i]=float(crit[i].get())
        txtcrit+=str(xcrit[i])+"\t"
    #print xcrit
    zaehl=0
    for i in range(0,m):
        for j in range(i+1,m):
            #print "zaehl = ",zaehl,"  xcrit= ",xcrit[zaehl]
            wcrit[i][j]=1.0*xcrit[zaehl]
            zaehl+=1
    for i in range(0,m):
        wcrit[i][i]=1
    for j in range(0,m):
        for i in range(j+1,m):
            if wcrit[i][j]==0:
                wcrit[i][j]=1.0/(1.0*wcrit[j][i])
    rmod2.matout(m,m,wcrit)
    # sum of the columns
    sumcol=rmod2.vecgen1(m)
    for j in range(0,m):
        for i in range(0,m):
            sumcol[j]+=wcrit[i][j]
    #print sumcol

    #scaling
    for i in range(0,m):
        for j in range(0,m):
            wcritn[i][j]=1.0*wcrit[i][j]/sumcol[j]
            
    #print "skaliert wcrit"
    #rmod2.matout(m,m,wcrit)

    #sum of rows
    sumrow=rmod2.vecgen1(m)
    for i in range(0,m):
        for j in range(0,m):
            sumrow[i]+=1.0*wcritn[i][j]/(1.0*m)

    #print sumrow        
    ssumrow=sum(sumrow)
    #print "sum of sumrow ",ssumrow
    c=rmod2.matvecmult(r,m,dmn,sumrow)
    tpahpbased=Tkinter.Toplevel(hf,width=60)
    tpahpbased.title(' ranking due to AHP weights')
    tahp=ScrolledText(tpahpbased,width=60,height=10)
    tahp.pack()
    txt1=" Ranking due to AHP-weights "
    txt1+="\n"+60*"="+"\n"
    for i in range(0,r):
        txt1+=obj[i]+"\t :"+str(round(c[i],3))+"\n"
    txt1+="\n"
    txt1+="\n"+60*"="
    txt1+="  - - - e o f  - - - "
    tahp.insert("end",txt1)
    buttinterim=Tkinter.Button(tpahpbased,text=" Display the steps to get the result ",command=display)
    buttinterim.pack()

def display():
    # brg 13.6.2013
    global m
    tpdisplay=Tkinter.Toplevel(hf)
    tpdisplay.title('  steps to the final result ')
    tdisplay=ScrolledText(tpdisplay,width=60, height=10)
    tdisplay.pack()
    txt=" Calculation steps in detail  "+"\n"
    txt+=60*"="+"\n"
    txt+="complete criterion-matrix wcrit "+"\n"
    txt+="\t"
    for j in range(0,m):
        txt+="crit("+str(j+1)+")"+"\t"
    txt+="\n"
    for j in range(0,m):
        txt+="crit("+str(j+1)+"):"
        for j1 in range(0,m):
            txt+=str(round(wcrit[j][j1],2))+2*"\t"
        txt+="\n"    
    
    txt+="\n"
    txt+="Column sums (needed to normalize )"+"\n"
    for j in range(0,m):
        txt+="col "+str(j)+": "+str(round(sumcol[j],3))+"\n"
    txt+="\n"
    txt+="crit-preference = (Rowsum of wcrit)/m "+"\n"
    for j in range(0,m):
        txt+="row "+str(j)+": "+str(round(sumrow[j],3))+"\n"
    txt+="\n"
    txt+="Ranking due to AHP: dmn*crit-preference "+"\n"
    for i in range(0,r):
        txt+="obj("+str(i)+")= "+str(round(c[i],3))+"\n"
    txt+=" - - -    e o f  - - - "
    tdisplay.insert("end",txt)
    

def level():
    global zeta2,obj,r,m,fn  
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Level')
    freq2=Tkinter.Frame(hfhd3,width=200,height=300)
    freq2.pack()
    lfn=len(fn)
    part_fn=fn[lfn-3:lfn]
    if part_fn=="txt" and fn!="dummy.txt":  #supposed all readin files with txt are EXCELfiles 
        rred,m,xred,objred,obj,prop,txt=filecomp(fn)
    elif fn=="dummy.txt":  # internal file 
        m=len(dm[0])
        obj=rmod2.vecgentext1(r)
        for i in range(0,r):
            obj[i]=str(i)
        rred,xred,objred,txt=rmod2.equivcompact(r,m,dm,obj)  
    elif part_fn=="pdt":   #PyHasse internal dm-files
        m=len(dm[0])
        obj1=rmod2.vecgentext1(r)
        for i in range(0,r):
            obj1[i]=obj[i]
        
        rred,xred,objred,txt=rmod2.equivcompact(r,m,dm,obj1)
    else:
        lbwarn=Tkinter.Label(freq,text="+++ no known data format +++",bg="yellow")
        lbwarn.pack()
    
    labeq=Tkinter.Label(freq2,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(rred,m,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq2,text= "Level ")
    lbhd1.pack()

    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    tlev=ScrolledText(freq2,width=60,height=4)
    tlev.pack()
    txt1="\n"
    txt1+=" Number of Levels: "+str(zzmax)+"\n"
    h=rmod2.vecgen1(zzmax)
    bh=rmod2.vecgentext1(zzmax)
    for i in range(0,zzmax):
        bh[i]="lv"+str(zzmax-i)
        
    for i in range(0,zzmax):
        h[i]=len(lobj[i])
        
    for i in range(0,zzmax):
        txt1+="Population in level \t"+str(zzmax-i)+"\t: "+str(len(lobj[i]))+"\n"
    txt1+="\n\n Individual objects per level: \n"    
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= "\t"+objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)
    app1=raioop2.brgbar6(hfhd3,h,bh," ","Lev_pop",10)
    app1.ausgabe()



def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension"
    # Brg 20.12.07, 28.12.07, 14.1.08 taken from mainHD3
    # If the number of representants > 30 then only the cover-matrix and the level-population
    #
    global zeta2,objred,obj,r,m,fn    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram or cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    lfn=len(fn)
    part_fn=fn[lfn-3:lfn]
    if part_fn=="txt" and fn!="dummy.txt":  #supposed all readin files with txt are EXCELfiles 
        rred,m,xred,objred,obj,prop,txt=filecomp(fn)
    elif fn=="dummy.txt":  # internal file 
        m=len(dm[0])
        obj=rmod2.vecgentext1(r)
        for i in range(0,r):
            obj[i]=str(i)
        rred,xred,objred,txt=rmod2.equivcompact(r,m,dm,obj)  
    elif part_fn=="pdt":   #PyHasse internal dm-files
        m=len(dm[0])
        obj1=rmod2.vecgentext1(r)
        for i in range(0,r):
            obj1[i]=obj[i]
        
        rred,xred,objred,txt=rmod2.equivcompact(r,m,dm,obj1)
    else:
        lbwarn=Tkinter.Label(freq,text="+++ no known data format +++",bg="yellow")
        lbwarn.pack()
        
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(rred,m,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
                
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    zeta2=rmod2.cover(rred,tr,lext)
    if rred>50:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,rred):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,rred):
            txt3+=objred[i]+" :"
            for j in range(0,rred):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,rred):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)
    
def LPOM():
    """Local partial order model """
    #brg 17.6.08
    # taken from mainHD16
    # 21.6.08 end of the changed part
    global rkav,obj,r,m,fn
    #         definitions of vectors
    p=[]      #successors of any obj
    u=[]      #incomparable elem. of any obj
    succ=[]   #predecessors of any obj, nmen leider vertauscht. 
    pr=[]     # number of  chains
    rkav=[]   #rkav after LPOM(0)model
    
    lfn=len(fn)
    part_fn=fn[lfn-3:lfn]
    if part_fn=="txt" and fn!="dummy.txt":  #supposed all readin files with txt are EXCELfiles 
        rred,m,xred,objred,obj,prop,txt=filecomp(fn)
    elif fn=="dummy.txt":  # internal file 
        m=len(dm[0])
        obj=rmod2.vecgentext1(r)
        for i in range(0,r):
            obj[i]=str(i)
        rred,xred,objred,txt=rmod2.equivcompact(r,m,dm,obj)  
    elif part_fn=="pdt":   #PyHasse internal dm-files
        m=len(dm[0])
        obj1=rmod2.vecgentext1(r)
        for i in range(0,r):
            obj1[i]=obj[i]
        
        rred,xred,objred,txt=rmod2.equivcompact(r,m,dm,obj1)
    else:
        lbwarn=Tkinter.Label(freq,text="+++ no known data format +++",bg="yellow")
        lbwarn.pack()
       
    for i in range(0,rred):
        succ.append(0)
        u.append(0)
        p.append(0)
        rkav.append(0)
        pr.append(0)
        

    # definiton of matrices
    
    objx=rmod2.marray(rred,rred)   
    redobjx=rmod2.marray(rred,rred)
    quobx=rmod2.marray(rred,rred)
    prod=rmod2.marray(rred,rred)
    prod1=rmod2.marray(rred,rred)
    unit=rmod2.matunit(rred)


    # heart of the program begin
    objx=rmod2.comp(rred,m,xred)
    rmod2.matadd(rred,1.0,objx,-1.0,unit,redobjx)
    rmod2.qualcomp(rred,objx,quobx)
    
    tplpom1=Tkinter.Toplevel(hf)
    tplpom1.title(" LPOM calculation's results 1")           
    succ,p,u,eq=rmod2.sucpredinc(rred,quobx)
    lbavrk1=Tkinter.Label(tplpom1,text="Results of LPOM-calculation ")
    lbavrk1.pack()

    tstruct=ScrolledText(tplpom1,width=60,height=5)
    tstruct.pack()
    

    
    txt1="results of LPOM1: structuralinformation \n"
    txt1+="\nobject\tsucc\tpredec\tincom\n"
    for i in range(0,rred):
        txt1+=str(objred[i])+":\t"+str(succ[i])+"\t"+str(p[i])+"\t"+str(u[i])+"\t "
        txt1+="\n"
    
    tstruct.insert("end",txt1)    

    rkav,pro,p,succ,u,eq=rmod2.lpom0(rred,quobx)
    trkav=ScrolledText(tplpom1,width=60,height=6)
    trkav.pack()
    txt2="results of LPOM2: averaged ranks and probabilities \n"
    txt2+="\n\t\tNo\tRkav\tpr<\tpr>\n"
    
    for i in range(0,rred):
        #test=round(pro[i][0]+pro[i][1],3)
        p1=round(pro[i][0],3)
        p2=round(pro[i][1],3)
        avr=round(rkav[i],3)
        txt2+="\t\t "+str(objred[i])+" :\t"
        txt2+=str(avr)+"\t"+str(p1)+"\t"+str(p2)+"\n"      
    txt2+="\n"
    trkav.insert("end",txt2)
    # new 21.3.08


def regr():
    tpregr=Tkinter.Toplevel(hf,width=60)
    tpregr.title('regression analysis ')
    lbmsg=Tkinter.Label(tpregr,text="")
    lbmsg.pack()
    if rkav==None or c==None:
        lbmsg.config(text="+++sorry, LPOM and AHP-weights needed+++",bg="yellow")
    else:    
        slope,interc,pears,probab,ster=pstat.llinregress(rkav,c)
        lbmsg.config(text="Successful analysis ",bg="green")
        rsp,psp=pstat.spearmanr(rkav,c)


        lbregr=Tkinter.Label(tpregr,text="Pearson correlation coeff (squared) \n\n"+str(round(pears*pears,3))+"\n\
                \nSpearman corr.coeff (squared): "+str(round(rsp*rsp,3))+"\n\n \
                AHP-preference vector: "+txtcrit+"\n")


        lbregr.pack()
    
                 

hf=Tkinter.Tk()
hf.title(' DAHP-program ')

c=None
rkav=None
fr=Tkinter.Frame(hf,height=100, width=200,bd=4)
fr.pack()


mBar=Tkinter.Menu(hf)


mFile=Tkinter.Menu(mBar,bg="cyan")   #first group

mFile.add_command(label="New", command=newDM)
mFile.add_command(label="Open", command=fileselect)
mFile.add_command(label="Open PyHasse files ",command=fileselect_PyHasse)
mFile.add_command(label="Save",command=newdm_save)
mFile.add_command(label="Show", command=showDM)
mFile.add_separator()
mFile.add_command(label="exit", command=hf.destroy)

mBar.add_cascade(label="Files", menu=mFile)



mCalc=Tkinter.Menu(mBar, bg="cyan")    #second group
mCalc.add_command(label="Normalize dm",command=normDM)
mCalc.add_command(label="Hasse diagram            ", command=HD)
mCalc.add_command(label="Level and population     ", command=level)
mCalc.add_command(label="Local Partial Order Model",command=LPOM)
mCalc.add_command(label="AHP-derived weights      ",command=critmat)
mCalc.add_command(label="Corr.coeff:AHP vs LPOM   ",command=regr)

mBar.add_cascade(label="Calculate", menu=mCalc)


mInfo=Tkinter.Menu(mBar,bg="green")    #third group

mInfo.add_command(label="Overview",command=ov)
mInfo.add_command(label="About",command=about_dahp)
mInfo.add_command(label="Help",command=help_dahp)

mBar.add_cascade(label="Information",menu=mInfo)


hf["menu"]=mBar


hf.mainloop()
