# -*- coding: cp1252 -*-
import math
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
import random
import stats
import pstat

# Brg outrkhd1.py (derived from condor7.py)  4.7.10
# 29.9.10: The HD is not in a good format. 
# 10.4.2011 Adaption to the screen of laptops
# 12.4.2011 change to outrkhd6 (outrkhd5 can be thrown away).
# 13.4.2011new module genoutrk1.py derived from outrk6.py
#          after ideas of Paola Annoni and Michaela Saisana
# 15.4.2011

def about():
    """ About genoutrk1 """
    # Brg 17.6.10, 13.4.11
    aboutsensi=raioop2.brgabout(hf,"tp2","about_genoutrk.txt",7,\
            "April, the 16st ,2011"," about_genoutrk ", "white", "t2",120,5,ScrolledText)
    

def raihelp():
    """ Help about genoutrk """
    #  brg 13.4.2011
    #  Use of OOP
    helpsensi=raioop2.brgabout(hf,"tp1","help_genoutrk.txt",7,\
            "April, the 16, 2011"," help_genoutrk ", "white", "t1",120,10,ScrolledText)

def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,ob,obj,pro,prop,r,k,fn,rred,xred,objred,txtred,tpsub
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbopen.config(bg="yellow",width=120)
    txtfile=120*"="+"\n"+"File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen["text"]=txtfile
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    
   
    rred,xred,objred,txtred=rmod2.equivcompact(r,k,dm,obj)
       
    return        
    

def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    


def interimresults():
    # Brg  17.6.10, 17.8.10, 13.4.2011,15.4.2011
    # calc the generalized outranking matrix
                   
    app1=raioop2.brgmatrixoutput2(hf,outrk1,"tpoutrk","outrk-matrices1 ","cut= "+str(100*cut)+": only counted >",r,r,obj,obj,"results_outranking")
    app1.ausgabe()
    app2=raioop2.brgmatrixoutput2(hf,outrk2,"tpoutrk","outrk-matrices2 ","cut= "+str(100*cut)+": counted > and =",r,r,obj,obj,"results_outranking")
    app2.ausgabe()
    app3=raioop2.brgmatrixoutput2(hf,outrk3,"tpoutrk","outrk-matrices2 ","cut= "+str(100*cut)+": counted > and 0.5=",r,r,obj,obj,"results_outranking")
    app3.ausgabe()
    app4=raioop2.brgmatrixoutput2(hf,probrk,"tpprob","rank probabilities ",\
                                  "cut= "+str(100*cut)+"  Number of MC: "+str(MCsim)+"   averaged retained info "+str(round(mwstat,3))\
                                  ,r,r,obj,rank,"results_outranking")
    app4.ausgabe()
    tprki=Tkinter.Toplevel(hf)
    tprki.title("outranking: rankintervals ")
    trki=ScrolledText(tprki,width=120,height=10)
    trki.pack()
    txt="Rank intervals\n"
    txt+="\t"
    for i in range(0,r):
        txt+=str(rank[i])+"\t"
    txt+="\n"
    txt+=r*"------------"+"\n"
    for i in range(0,r):
        txt+=str(obj[i])+":\t"
        for j in range(0,r):
            txt+=str(rcmtxt[i][j])+"\t"
        txt+="\n"
    txt+="\n"
    txt+="\n"+" List of min and max rank"
    txt+="\n"+"\t"+"minimum\tmaximum rank\n"
    for i in range(0,r):
        txt+=str(obj[i])+":\t"+str(minmaxrk[i][0])+"\t"+str(minmaxrk[i][1])+"\n"

    txt+="\n\n- - -   e o f -  -  -"
    trki.insert("end",txt)
    


def rankdistr():
    #brg 13.4.2011
    global minmaxrk,outrk1,outrk2,outrk3,\
           rkm,rcmtxt,cut,k,dm,r,probrk,rank,mwstat,MCsim
    outrk=rmod2.genoutrk(r,k,dm)
    outrk1=rmod2.marray(r,r)
    outrk2=rmod2.marray(r,r)
    outrk3=rmod2.marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            outrk1[i][j]=outrk[i][j][0]
    for i in range(0,r):
        for j in range(0,r):
            outrk2[i][j]=outrk[i][j][1]        
    for i in range(0,r):
        for j in range(0,r):
            outrk3[i][j]=outrk[i][j][2]   

    try:
        cut=float(ecut.get())
    except:
        cut=75   #Default

    cut=1.0*cut/100.0
    rkmact=rmod2.rkinterval(r,cut,outrk3)#rkintervals to be based on generalized outk(including equal attribute values)

    minmaxrk=rmod2.marray(r,2)
    for i in range(0,r):
            #object i
            for l in range(0,r):
                if rkmact[i][l]!=-1:
                    minmaxrk[i][0]=rkmact[i][l]
                    break
                else:
                    pass
            for l in range(r-1,0,-1):
                if rkmact[i][l]!=-1:
                    minmaxrk[i][1]=rkmact[i][l]
                    break
                else:
                    pass
            #note this procedure assumes that the range of accessible ranks is always topologically connected

    #readibility:
    rank=[]
    for i in range(0,r):
        rank.append(i+1)
    
    rcmtxt=rmod2.marray(r,r)
    for i in range(0,r):
        for j in range(0,r):
            if rkmact[i][j]==-1:
                rcmtxt[i][j]="***"
            else:
                rcmtxt[i][j]=rkmact[i][j]
    
    try:
        MCsim=int(emcsim.get())
    except:
        MCsim=10
    
    caserk=rmod2.marray(MCsim,r)
    
    
    for mc in range(0,MCsim):
        for i in range(0,r):
            rkrd=random.randint(minmaxrk[i][0],minmaxrk[i][1])
            caserk[mc][i]=rkrd

                          
    for mc in range(0,MCsim):
        for i in range(0,r):
            for j in range(i+1,r):
                if caserk[mc][i]==caserk[mc][j]:
                    rdx=random.randint(1,10)
                    if rdx>5:
                        for j1 in range(0,r):
                            caserk[mc][j1]="*"
                    else:
                        for i1 in range(0,r):
                            caserk[mc][i1]="*"



    mcs=[]
    for mc1 in range(0,MCsim):
        for mc2 in range(mc1+1,MCsim):
            if caserk[mc1]==caserk[mc2]:
                    mcs.append(mc2)
                
        


    #print mcs
    for i in range(0,r):
        zahl=0
        for k in mcs:
            caserk[k][i]="*"
            
            
    freq=rmod2.marray(r,r)
    stat=rmod2.vecgen1(r)
    for i in range(0,r):
        stat[i]=0
        for mc in range(0,MCsim):
            if caserk[mc][i]!="*":
                stat[i]+=1
            else:
                pass

    #print "Existence statistics : ",stat
    lstat=len(stat)
    mwstat=0
    for i in range(0,lstat):
        mwstat+=stat[i]
    mwstat=1.0*mwstat/(1.0*lstat*r)  #not count through all objects  

    for rk in range(0,r):
        rkreal=rk+1
        for i in range(0,r):
            for mc in range(0,MCsim):
                if caserk[mc][i]==rkreal:
                    freq[rk][i]+=1
                    
    
   
    #probability
    probrk=rmod2.marray(r,r)
    for rk in range(0,r):  #rank loop
        for i in range(0,r): #object loop
            probrk[rk][i]=1.0*freq[rk][i]/(1.0*stat[i])
            
    rkav=rmod2.vecgen1(r)
    for i in range(0,r):
        for rk in range(0,r):
            rkav[i]+=probrk[rk][i]*(rk+1)
            
    rkmed=rmod2.saisanamedrk(r,r,probrk)        
            
    tpmain=Tkinter.Toplevel(hf)
    tpmain.title(' main result: av ranks, med. ranks ')
    tmain=ScrolledText(tpmain,height=20,width=120)
    tmain.pack()
    txt="Averaged rank and median ranks of gen.outrk-procedure"+"\n"
    txt+=60*"="+"\n"
    
    for i in range(0,r):
        txt+=str(round(rkav[i],2))+"\t"+str(round(rkmed[i],2))+"\n"
            
    txt+="\n"
    txt+=" - - -  e o f - - - "
    tmain.insert("end",txt)
                       
    buttinterim.config(state="active")

def indanalysis():
    global probrk
    objsel=eobj.get()
    isel=obj.index(objsel)
    hisel=rmod2.vecgen1(r)
    rkisel=rmod2.vecgen1(r)
    rkiselnz=[]
    for rk in range(0,r):
        hisel[rk]=probrk[rk][isel]
        rkisel[rk]=(rk+1.0)*probrk[rk][isel]
        if probrk[rk][isel]!=0:
            rkiselnz.append((rk+1.0)*probrk[rk][isel])

    txt="Object = "+objsel+"\n  cut= "+str(cut*100)+"  MCsim = "+str(MCsim)+" retained info (av.) "+str(round(mwstat,3)),"rank distr."

    
    estimav=0
    for rk in range(0,r):
        estimav+=(rk+1)*hisel[rk]

    
    tpindan=Tkinter.Toplevel(hf)
    tpindan.title('object = '+objsel)
    tindan=ScrolledText(tpindan,width=60,height=10)
    tindan.pack()
    txt2="Object = "+objsel+"\n"
    txt2+="cut   = "+str(100*cut)+"\n"
    txt2+="MCsim = "+str(MCsim)+"\n"
    txt2+="Retained information in % :"+str(round(100.0*mwstat/(1.0*MCsim),2))
    txt2+="\n"
    txt2+="estimated average: "+str(round(estimav,2))+"\n"
##    txt2+="median           : "+str(round(objmedian1,2))+"\n"
##    txt2+="median (probrk>0): "+str(round(objmedian2,2))+"\n"
    txt2+="\n"+"\t"+"minimum\tmaximum rank\n"
    txt2+=str(objsel)+":\t"+str(minmaxrk[isel][0])+"\t"+str(minmaxrk[isel][1])+"\n"
    txt2+="\n"
    txt2+="----------------\n"
    tindan.insert("end",txt2)
    app4=raioop2.brgbar9(hf,hisel,rank,objsel+": rank probability",15)
    app4.ausgabe()


def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07
    # If the number of representants > 20 then only the cover-matrix and the level-population
    #
    try:
        perturb=int(eperturb.get())
    except:
        perturb=0
        
    global zeta,cov,rred,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    global fn
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    rred,xred,objred,obj,txteq0,neq=filecomp(r,dm,prop,fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()
    tp00=Tkinter.Toplevel(hf)
    t00=ScrolledText(tp00,width=120,height=5)
    t00.pack()
    txt="Equivalence classes of the ordinary data matrix "+"\n"
    txt+=60*"="+"\n"
    txt+=txteq0
    txt+="\n"
    txt+=" -  -  - e o f -  -  -  "+"\n"
    txt+="\n"
    t00.insert("end",txt)
    #
    zetahilf=rmod2.comp(n,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #Local U
    uloc=rmod2.vecgen1(rred)
    for i in range(0,rred):
        uloc[i]=0
        for j in range(0,rred):
            if zeta[i][j]==0 and zeta[j][i]==0:
                uloc[i]+=1
        
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tplev=Tkinter.Toplevel(hf)
    tplev.title(' Level population ')
    tlev=ScrolledText(tplev,width=60,height=4)  
    tlev.pack()
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(tplev,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    cov=rmod2.cover(n,tr,lext)

    if n>200:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=(perturb*random.randint(1,5)+1)*geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-17,geomy[i][j]+17,geomx[i][j]+17,geomy[i][j]-17,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]]+": "+str(uloc[lobj[i][j]]),font=1)
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack(side="left",padx=5)


def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)

def filecomp(r,dm,pro,fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 8.5.08, 20.6.08
    #r,k,dm,ob,pro,fn are globals and should be available after open
    
    #dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title(' ++warning++ ')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    #prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #8.5.08 changed to ...text1
##    for i in range(0,k):
##        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,dm,obj)    
    ###############################################################
    #print objred
    #print "reduzierte matrix"
    #rmod2.matout(rred,k,xred)
    return rred,xred,objred,obj,txt,neq   #20.6.08        

def sf():
    #brg 29.9.2010
    # taken from interval7.py
    zetout2=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            if i!=j:
                zetout2[i][j]=zetout1[j][i]
            else:
                zetout2[i][j]=0
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    rmod2.raiwrite5(fn,zetout2,objred,objred,rred,rred)
    lbsuccess.config(text="matrix with \n"+str(rred)+"  rows  and "+str(rred)+"\n  columns stored",bg="yellow")




hf=Tkinter.Tk()
hf.title(' Generalized Outranking/Cut analysis')
about()
raihelp()
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen=Tkinter.Label(fropen,width=120)
lbopen.pack()
buttfileselect=Tkinter.Button(fropen,text="select and open file",width=25, bg="white",command=File_select)
buttfileselect.pack(pady=2)
buttshow=Tkinter.Button(fropen,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=2)
fr2=Tkinter.Frame(hf)
fr2.pack()
lbperturb=Tkinter.Label(fr2,text="perturb HD (values>1)>>>>")
lbperturb.pack(side="left")
eperturb=Tkinter.Entry(fr2,width=2)
eperturb.pack(side="left")
buttHD=Tkinter.Button(fr2,text="show  HD ",width=25,command=HD)
buttHD.pack(pady=2)
froutrk=Tkinter.Frame(hf,relief="sunken",bd=4)
froutrk.pack(pady=5)
frcut=Tkinter.Frame(froutrk)
frcut.pack()
lbcut=Tkinter.Label(frcut,text="cut-level in % >>")
lbcut.pack(side="left",expand=True)
ecut=Tkinter.Entry(frcut,width=10)
ecut.pack(side="left")
frcut2=Tkinter.Frame(froutrk)
frcut2.pack()
lbec=Tkinter.Label(frcut2,text="How many MC runs? >>")
lbec.pack(side="left",expand=True)
emcsim=Tkinter.Entry(frcut2,width=10)
emcsim.pack()
frcut3=Tkinter.Frame(froutrk)
frcut3.pack()
buttdist=Tkinter.Button(frcut3,text="calculate frequency matrix ",bg="cyan",width=25,command=rankdistr)
buttdist.pack()
frresults=Tkinter.Frame(froutrk)
frresults.pack()
fr1=Tkinter.Frame(froutrk)
fr1.pack()
lbresults=Tkinter.Label(fr1,text="Rank distribution of objects")
lbresults.pack(side="left")
eobj=Tkinter.Entry(fr1,width=5)
eobj.pack(side="left")
frcut4=Tkinter.Frame(froutrk)
frcut4.pack()
buttindiv=Tkinter.Button(frcut4,text="Individual rk-distrib. ",bg="cyan",width=25,command=indanalysis)
buttindiv.pack()
frcut5=Tkinter.Frame(froutrk)
frcut5.pack(pady=5)
buttinterim=Tkinter.Button(frcut5,text="additional interim-results ",width=25,state="disabled",command=interimresults)
buttinterim.pack()

buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=2)



hf.mainloop()
