import rmod2
import raioop2
import Tkinter
import Canvas
from ScrolledText import ScrolledText
from time import *
import random

# brg 17.5.09, 20.5.09, 21.5.09

def readin():
    #brg 19.5.09, 31.1.2013
    # linear extensions
    global ealeft,hleft, eobj, r,n
    
    r=int(e_r.get())
    n=int(e_n.get())
    
    hleft=rmod2.vecgen1(r)
    ealeft=rmod2.vecgen1(r)
    
    
    for i in range(0,r):
        ealeft[i]=Tkinter.Entry(fr2,width=25)
        ealeft[i].pack()
    
def order(n,a,c):
    #brg 18.5.09
    l=[]
    for i in range(0,n):
        for j in range(i+1,n):
            l.append("("+str(c.index(a[i]))+","+str(c.index(a[j]))+")")
    return l


def linextreadcalc():
    #brg 19.5.09
    # reads the linear extensions
    # per input by user
    la=rmod2.vecgen1(r)
    laset=rmod2.vecgen1(r)
    objred=eobj.get().split(",")
    flag=0
    for i in range(0,r):
        hleft[i]=ealeft[i].get().split(",")
        for j in range(0,n):
            if hleft[i][j] not in objred:
                flag=1
                #print "not in objred "
                break
        if flag==1:
            break
        la[i]=order(n,hleft[i],objred)
        laset[i]=set(la[i])
    if flag==0:    
        intersec=lin_intersection(r,n,laset)
        zeta=rmod2.marray(n,n)
        for i in range(0,n):
            for j in range(0,n):
                x="("+str(i)+","+str(j)+")"
                if x in intersec:
                    zeta[i][j]=1 

        for i in range(0,n):
            zeta[i][i]=1

        #rmod2.matout(n,n,zeta)

        lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
        levmax=-10**20     #20.6.08
        for i in range(0,zzmax):
            if len(lobj[i])>=levmax:
                levmax=len(lobj[i])
          
        #Adj-Listen

        adjc=rmod2.adjacent(n,lext,revlext,zeta)
            
        #Transitive reduced relations
        ts,tr=rmod2.trreduct(n,adjc,lext)
           

        cov=rmod2.cover(n,tr,lext)
        tptext=Tkinter.Toplevel(hf)
        ts1=ScrolledText(tptext,width=60,height=10)
        ts1.pack()
        txt="Intersection of lin.ext \n"
        txt+="number linext ="+str(r)+"\n"
        txt+="number objects="+str(n)+"\n"
        txt+="Input: \n"
        txthilf=""
        for i in range(0,r):
            for j in range(0,n):
                txthilf+=hleft[i][j]
            txthilf+="\n"
        txt+=txthilf
        
        lt=localtime()
        stunde,minute,sekunde=lt[3:6]
        identifier=stunde+minute+sekunde
        txt+="\nidentifier "+str(identifier)
        txt+="\n\n  e   o  f   "
        ts1.insert("end",txt)    
        
        
        
        if n>60:
            cover_show()                  #20.1.08
        else:
            tpgraph=Tkinter.Toplevel(hf)
            lbhd3=Tkinter.Label(tpgraph,text=" intersect. of lin. ext Hasse Diagram ")
            lbhd3.pack()
            txtlb1="number of objects= "+str(n)+\
                          "\n number of lin.ext = "+str(r)+\
                          "\n identifier = "+str(identifier)
            lb1=Tkinter.Label(tpgraph,text=txtlb1)
            lb1.pack()
            actwidth,actheight,factorx,\
                    factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(n,levmax,zzmax)
            cv=Tkinter.Canvas(tpgraph,width=actwidth,height=actheight,bg="white")
            
            lz=zzmax
            l=rmod2.vecgen1(lz)
            for i in range(0,lz):
                l[i]=len(lobj[i])

            pos=rmod2.vecgen1(lz)
            for i in range(0,lz):
                pos[i]=l[i]

            geomx=rmod2.marray(n,n)
            geomy=rmod2.marray(n,n)

            distort=edistort.get() #9 lines new
            try:
                prr=int(distort)
            except:
                prr=0
              
           
            for i in range(0,lz):
                for j in range(0,l[i]):
                    geomx[i][j]=geom0x+(1.0+1.0*random.randint(0,prr)/5.0)*(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480, 16.10.09 disto
                    geomy[i][j]=geom0y+(factory/lz)*i
                
            
            for i in range(0,lz-1):
                for j in range(0,l[i]):
                    for i1 in range(i+1,lz):
                        for j1 in range(0,l[i1]):
                            if cov[lobj[i1][j1]][lobj[i][j]]==1:
                                cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


            for i in range(0,lz):
                for j in range(0,l[i]):
                    cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                    cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
            
            cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")

            cv.create_text(garrow1x+8,garrow1y-6,text="high")
            cv.create_text(garrow1x+8,garrow2y-6,text="low")
            cv.pack()
    else:
        tpmess=Tkinter.Toplevel(hf)
        tpmess.title('+++ warning ++++')
        lbmess=Tkinter.Label(tpmess,text='+++please check the \
            object identifiers+++ ',width=60,bg='yellow')
        lbmess.pack()
        

def lin_intersection(r,n,laset):
    #brg 20.5.09, 31.1.2013
    global iset
    iset=laset[0]
    for i in range(1,r):
        helpset=laset[i]
        iset=iset&helpset
    
    #print iset
    return iset
    

hf=Tkinter.Tk()
lblinext=Tkinter.Label(hf,text=" Linear Extensions ",width=60)
lblinext.pack(pady=2)

    
aboutlinext=raioop2.brgabout(hf,"tp1","about_linext.txt",2,\
            "May, 21th,2009"," about_linext", "white", "t1",80,5,ScrolledText)    
helplinext=raioop2.brgabout(hf,"tp1","help_linext.txt",2,\
            "May, 21th,2009"," help_linext ", "white", "t1",80,5,ScrolledText)

fr=Tkinter.Frame(hf)
fr.pack()
lab1=Tkinter.Label(fr,text="enter number of lin.ext. >>>")
lab1.grid(column=0,row=0)
e_r=Tkinter.Entry(fr,width=3)
e_r.grid(column=1,row=0)
lab2=Tkinter.Label(fr,text="enter number of objects >>>")
lab2.grid(column=0,row=1)
e_n=Tkinter.Entry(fr,width=3)
e_n.grid(column=1,row=1)
buttreadin=Tkinter.Button(hf, text=" confirm ",width=25,bg="cyan",command=readin)
buttreadin.pack()
frobj=Tkinter.Frame(hf,bd=2,bg="yellow",relief="sunken")
frobj.pack(pady=2)  #######################grid###########
labobj=Tkinter.Label(frobj,text="list of objects>>",bg="yellow")
labobj.grid(row=0,column=0)
eobj=Tkinter.Entry(frobj,width=25)
eobj.grid(row=0,column=1)
fr2=Tkinter.Frame(hf,bd=2,relief="groove")
fr2.pack()
fr3=Tkinter.Frame(hf,relief="sunken",bd=3)
fr3.pack(pady=5)
lbdistort=Tkinter.Label(fr3,text="distort. f Hasse (0: no distortion (default),...,5: high distortion>>>")
lbdistort.pack(side="left")
edistort=Tkinter.Entry(fr3,width=2)
edistort.pack(side="left")
buttlinextreadin=Tkinter.Button(fr3, text=" confirm linext and calc",\
                                width=25,bg="cyan",command=linextreadcalc)
buttlinextreadin.pack(pady=10)

buttexit=Tkinter.Button(hf,text=" Exit ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=10)

               
hf.mainloop()
                  
