import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import random
#from string import replace

# brg 14.11.2015
rred = 10

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq
    print "objred= ",objred


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####

def lpom(xred,rred,k,plimit=0.3333*rred, slimit=0.3333*rred):
    #brg 14.11.2015, 16.11.2015
    rmod2.matout(rred,k,xred)
    n = rred+1
    hav = []
    iso = []
    maxim = []
    minim = []
    connect = []
    chain = []
    succ = []
    predec = []
    for i1 in range(0, rred):
        p=0
        s=0
        for i2 in range(0, rred):
            if i2 != i1:
                flag  = 0
                for j in range(0, k):
                    if xred[i1][j] <= xred[i2][j]:
                        #print "i1=",i1,"  i2=",i2,"  j= ",j,"dm=:", xred[i1][j]," <? ",xred[i2][j]
                        flag+=1
                if flag == k:
                    p+=1
                flag = 0
                for j in range(0, k):
                    if xred[i1][j] >= xred[i2][j]:
                        flag+=1
                if flag == k:
                    s+=1
        if s == 0 and p == 0:
            iso.append(i1)
        if s==0 and p>0:
            minim.append(i1)
        if s>0 and p==0:
            maxim.append(i1)
        if s>0 and p>0:
            connect.append(i1)
        if s>slimit and p>plimit:
            chain.append(i1)
        if s>slimit:
            succ.append(i1)
        if p>plimit:
            predec.append(i1)
        u=rred-1.0-s-p
        
        hav.append((1.0*s+1.0)*n/(1.0*n-1.0*u))
    return hav,maxim,minim,iso,connect,chain,succ, predec


def calc():
    #brg 14.11.2015, 16.11.2015
    global hav0,maxim,minim,iso,succ,predec,chain
    global readinlimit_p,readinlimit_s
    try:
        readinlimit_s=float(eslimit.get())
    except:
        readinlimit_s=0.3333*rred
    try:
        readinlimit_p=float(eplimit.get())
    except:
        readinlimit_p=0.3333*rred
##    print "dm in calc"
##    rmod2.matout(rred,k,xred)
##    print " "
    hav0,maxim,minim,iso,connect,chain,succ,predec = lpom(xred,rred,k,plimit=readinlimit_p,slimit=readinlimit_s)
    
    nomax=len(maxim)
    nomin=len(minim)
    noiso=len(iso)
    noconnect=len(connect)
    nochain=len(chain)
    nosuc=len(succ)
    nopredec=len(predec)
    tpresult = Tkinter.Toplevel(hf)
    tpresult.title("lpom_results")
    tresult=ScrolledText(tpresult,width=80,height=20)
    tresult.pack()
    txt="basis info: dm "+"\n"
    txt+="number of representative elements "+"\t"+": "+str(rred)+"\n"
    txt+="number of indicators              "+"\t"+": "+str(k)+"\n"
    txt+="Basis info: partial order "+"\n"
    txt+="number of isolated elements "+"\t"+": "+str(noiso)+"\n"
    txt+="number of minimal elements  "+"\t"+": "+str(nomin)+"\n"
    txt+="number of maximal elements  "+"\t"+": "+str(nomax)+"\n"
    txt+="number of connected elements else"+"\t"+": "+str(noconnect)+"\n"
    txt+="number of elements having more successors than   "+str(readinlimit_s)+": "+str(nosuc)+"\n"
    txt+="number of elements having more predecessors than "+str(readinlimit_p)+": "+str(nopredec)+"\n" 
    txt+="number of conn. elements in long chains "+"\t"+": "+str(nochain)+"\n"
    txt+="\n"
    tresult.insert("end",txt)

def show_details():
    #brg 16.11.2015
    import pstat, stats
    tpdetails=Tkinter.Toplevel(hf)
    tdetails=ScrolledText(tpdetails,width=60,height=20)
    tdetails.pack()
    txtd="Details concerning datamining and LPOM "+"\n"
    txtd+="+++note, this table can be extremely long "+"\n"
    txtd+="elements where the number of successors > "+str(readinlimit_s)+":\n"
    for isuc in succ:
        txtd+=str(isuc)+"\t"
    txtd+="\n"
    txtd+="elements where the number of predecessors > "+str(readinlimit_p)+":\n"
    for ipredec in predec:
        txtd+=str(ipredec)+"\t"
    txtd+="\n"
    txtd+="Maximal elements"+"\n"
    for imax in maxim:
        txtd+=str(imax)+"\t"
    txtd+="\n"
    txtd+="Minimal elements"+"\n"
    for imin in minim:
        txtd+=str(imin)+"\t"
    txtd+="\n"
    txtd+="Isolated elements "+"\n"
    for iiso in iso:
        txtd+=str(iiso)+"\t"
    txtd+="\n"
    txtd+="Elements being member of long chains "+"\n"
    for ichain in chain:
        txtd+=str(ichain)+"\t"
    txtd+="\n"    
    nr,rangehav0, mean,std,skew,kurt=pstat.ldescribe(hav0)
    txtd+="Some basic statistics of hav0"+"\n"
    txtd+=50*"="+"\n"
    txtd+="Rangeof hav0               \t:"+str(round(rangehav0[0],3))+" - " + str(round(rangehav0[1],3))+"\n"
    txtd+="mean of hav0               \t:"+str(round(mean,3))+"\n"
    txtd+="standard deviation of hav0 \t:"+str(round(std,3))+"\n"
    txtd+="skewness of hav0           \t:"+str(round(skew,3))+"\n"
    txtd+="kurtosis of hav0           \t:"+str(round(kurt,3))+"\n"
    txtd+="hav according to LPOM0 "+"\n"
    for i in range(0,rred):
        txtd+=str(i)+"\t"+": "+str(round(hav0[i],3))+"\n"
    txtd+="\n"    
    tdetails.insert("end",txtd)

def save_hav0():
    # Brg taken from Electresimpl 13.10.2014, 14.11.2015
    fnhav0=tkFileDialog.asksaveasfilename(parent=hf,title="save hav0-values in file: \
                                            select filename")
    fcsv=open(fnhav0,"w")
    fcsv.write(str(rred)+"\n")
    for i1 in range(0,rred):
        fcsv.write(str(i1)+"\t"+str(round(hav0[i1],5))+"\n")
    fcsv.close()    

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' lpomdatamining ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_lpomdatamining.txt",1,\
            "Nov., the 16th, 2015"," about lpom_datamining ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_lpomdatamining.txt",1,\
            "Nov, the 16th, 2015"," help_lpom_datamining ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", width=40, command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
fr2=Tkinter.Frame(hf)
fr2.pack()
lb2=Tkinter.Label(fr2, text="select limit for successors\n (actual number of successor has to be larger than your limit)\n: \
                            Default = number of repr. elem. * 0.3333 ")
lb2.pack(side="left")
eslimit=Tkinter.Entry(fr2,width=5)
eslimit.pack(side="right")
fr3=Tkinter.Frame(hf)
fr3.pack()
lb3=Tkinter.Label(fr3, text="select limit for predecessors\n(actual number of predecessors has to be larger than your limit)\n\
                            Default = number of repr. elem. * 0.3333 ")
lb3.pack(side="left")
eplimit=Tkinter.Entry(fr3,width=5)
eplimit.pack(side="right")

fr4=Tkinter.Frame(hf)
fr4.pack()
buttcalc=Tkinter.Button(fr4,text="Run LPOM0 ",bg="cyan",width=40,command=calc)
buttcalc.pack()
buttdetails=Tkinter.Button(fr4,text="Show details", bg="cyan",width=40,command=show_details)
buttdetails.pack()
buttsave_hav0 = Tkinter.Button(fr4, text = "Save the hav0-values ",width=40, command=save_hav0)
buttsave_hav0.pack()
buttexit = Tkinter.Button(fr4, text='exit', bg='red',
                          width=40, command=hf.destroy)
buttexit.pack(pady=5)

hf.mainloop()
