import rmod2
import math
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import raioop2
import tkSimpleDialog

# brg 10.6.2014
# brg 15.6.2014

def Ireadin():
    #brg 15.6.2014
    global dmI,objI,propI,r,m,fn
    fn=tkFileDialog.askopenfilename()
    dmI,ob,pro,r,m=rmod2.EXCELreadin4(fn)
    lbopen1.config(bg="yellow")
    lbopen1["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
        +str(m) +" columns"
    lbopen1.pack()
    objI=rmod2.vecgentext1(r)                        #29.11.07
    propI=rmod2.vecgentext1(m)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        objI[i]=ob[i+1]
    for i in range(0,m):
        propI[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    
    
    

def Freadin():
    # brg 15.6.2014
    global dmF,objF,propF,rF,mF,fnF
    fnF=tkFileDialog.askopenfilename()
    dmF,ob,pro,rF,mF=rmod2.EXCELreadin4(fnF)
    lbopen2.config(bg="yellow")
    lbopen2["text"]="File with profiles "+fn+"\n opened with "+str(rF)+" rows \n and "\
                         +str(mF) +" columns"
    lbopen2.pack()

    objF=rmod2.vecgentext1(rF)                        #29.11.07
    propF=rmod2.vecgentext1(mF)
    for i in range(0,rF):  #recoding, because ob[0] is a dummy string 
        objF[i]=ob[i+1]
    for i in range(0,mF):
        propF[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    

def M_matrixdialog():
    # brg taken from covi_interactive3.py: 15.6.2014
    global M
    M=rmod2.marray(m,mF)
    for j1 in range(0,m):
        for j2 in range(0,mF):
            M[j1][j2]=tkSimpleDialog.askinteger(' M-entries',"I-"+propI[j1]+" fits well (1)/ not well (0) with ...F- "+propF[j2]+"?",\
                                            minvalue=0,maxvalue=1)
    tpM=Tkinter.Toplevel(hf,width=60,height=60)
    tpM.title(' M-Matrix   ')
    tm=ScrolledText(tpM,width=60,height=60)
    tm.pack()
    txt=" M-matrix "+"\n"
    txt+="\t"
    for i in range(0,mF):
        txt+=str(propF[i])+"\t"
    txt+="\n"
    for i2 in range(0,m):
        txt+=str(propI[i2])+"\t"
        for i3 in range(0,mF):
            txt+=str(M[i2][i3])+"\t"
        txt+="\n"
    txt+="\n"
    tm.insert("end",txt)
                
def copeland(xred,r,k):
    # brg 7.7.10, 2.2.2011, 3.2.2011, 12.6.2014
    # objred list of representative objects
    # weights  list of k weights, will be overwritten (2.2.2011)
    # xred dm of quotient set , representatives of eq.cl.
    # k: number of columns of xred (number of attributes)
    
    
    outrk=rmod2.marray(r,r)
    for i in range(0,r):
        for i1 in range(0,r):
            if i!=i1:
                for j in range(0,k):
                    if xred[i][j]>xred[i1][j]:
                        outrk[i][i1]+=1
                    elif xred[i][j]==xred[i1][j]:
                        outrk[i][i1]+=0
                    else:
                        outrk[i][i1]-=1
    return outrk

# brg  12.6.2014
def examplecalc():
    # brg 12.6.2014
    global objred,copelsum,dm_r,dm_m
    objred=[]
    for i1 in range(0, r):
        for i2 in range(0, rF):
            objred.append((objI[i1], objF[i2]))
    
    print objred
    dm_r = r * rF
    dm_m = 2 * m * mF
                          
    dm=rmod2.marray(dm_r,dm_m)
    z=0
    for selecti in range(0,r):
        for selectf in range(0,rF):
            y=0
            for i in range(0,m):
                for j in range(0,mF):
                    if M[i][j]==0:
                        dm[z][y]=0
                        dm[z][y+1]=0
                    else:
                        dm[z][y]=dmI[selecti][i]
                        dm[z][y+1]=dmF[selectf][j]
                    y+=2    
            z+=1        

    rmod2.matout(dm_r,dm_m,dm)
    
    outact=copeland(dm,dm_r,dm_m)
    print "outact= ",outact
    copelsum=rmod2.vecgen1(dm_r)
    for i in range(0,dm_r):
        copelsum[i]=0
        for i1 in range(0,dm_r):
            copelsum[i]+=outact[i][i1]
    print copelsum        
    txtcopel=" Weak order due to Copeland rule "
    txtcopel+="\n"+60*"="+"\n"
    for i in range(0,dm_r):
        txtcopel+=str(objred[i])+"\t:"+str(copelsum[i])+"\n"
    txtcopel+="- - - e o f - - - "
    tpcopeland=Tkinter.Toplevel(hf)
    tpcopeland.title(" -- Copeland - results --- ")
    tcopeland=ScrolledText(tpcopeland,width=60, height=20)
    tcopeland.pack()
    tcopeland.insert("end",txtcopel)
    
def copelsumsort():
    # brg 15.6.2014
    tpcopelsort=Tkinter.Toplevel(hf, width=60)
    tpcopelsort.title(' Sorted according the copeland-index ')
    tcopelsort=ScrolledText(tpcopelsort,width=60,height=10)
    tcopelsort.pack()
    objsort,hilf,nobj=rmod2.raisort2(copelsum)
    txt="Sorted according to increasing values of copeland-index "+"\n"
    txt+=60*"=="+"\n"
    for i in range(0,dm_r):
        txt+=str(objred[nobj[i]])+"< "
    txt+=" "+"\n"
    tcopelsort.insert("end",txt)
    
    txt+="- - - - -  e o f - - - - "
    
    



hf=Tkinter.Tk()
hf.title(' matching ')
aboutmatch=raioop2.brgabout(hf,"tp1","about_matching.txt",3,\
            "July, the 3rd, 2014"," about matching ", "white", "t1",80,5,ScrolledText)
helpmatch=raioop2.brgabout(hf,"tp1","help_matching.txt",3,\
            "July, the 3rd, 2014"," help matching ", "white", "t1",80,5,ScrolledText)
    
frin=Tkinter.Frame(hf,relief="sunken",bd=2)
frin.pack()
buttreadin1=Tkinter.Button(frin,text="Readin Indicatorprofiles ",width=30,bg="cyan",command=Ireadin)
buttreadin1.pack()
lbopen1=Tkinter.Label(frin,text=" ")
lbopen1.pack()
buttreadin2=Tkinter.Button(frin,text="Readin Fprofiles ",width=30,bg="cyan",command=Freadin)
buttreadin2.pack()
lbopen2=Tkinter.Label(frin,text=" ")
lbopen2.pack()
buttreadin3=Tkinter.Button(frin,text="  Dialog to determine the matrix M ",width=30,bg="cyan",command=M_matrixdialog)
buttreadin3.pack()
frcalc=Tkinter.Frame(hf, relief="groove",bd=3)
frcalc.pack()
buttcalc1=Tkinter.Button(frcalc,text="  calculate   ",bg="cyan",width=30,command=examplecalc)
buttcalc1.pack()
buttcalc2=Tkinter.Button(frcalc, text="Sorting (increasing values) ",bg="cyan",width=30,command=copelsumsort)
buttcalc2.pack()
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=30)
hf.mainloop()


