import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import random
import os
import Canvas
import tkFileDialog

#Brg 9.12.07, 16.12.07,2.1.08, 8.1.08, 12.1.08, 15.1.08, 3.2.08, 4.2.08
# Brg 19.2.08: daughter windows with titles
# Brg 19.2.08: help modified
# Brg  8.5.08: adaptations because of changes in rmod2
# Brg  28.5.08 aus simi3: optimsim1. It is assumed that one dm (dm1) is only a column
#              consisting of the target values
#              The second datamatrix may contain maximally 20 descriptors.
#              Which subset of attr. of the dm2 maximizes the quotient Q
#              Q = (g1*isotone+g2*weakisotone+g3*equiv)/(g4*antitone+g5*indiff +1)
#              g1 = 1, g2 = 0.2, g3 = 0.1 , g4 = 1, g5 = 0.2
# Brg 29.5.08 tests....
# Brg 30.5.08 tests...
# Brg 30.5.08 Introduction of variable weights (Qselect)
# Brg 30.5.08 histogram, more infos
# Brg 1.6.08  In HD2: nach equivcompact: r durch n2 ersetzt, n1 durch n2
# Brg 1.6.08: Great changes: In Hd the original dm will f i r s t be reduced
#             due to optimal (sub) set of attributes
#             Then the equivcompact - routine is applied
# Brg 2.6.08: Introduction of Q2 and the new objective function QS=h1*Q+h2*Q2
# Brg: 13.10.08: help external, loading by an OOP-function
# Brg  15.3.09 help-function changed. Changes planned in the near future
# brg 11.12.2011: New Quality function, parameterfree
# brg 12.12.2011: Option to exclude AC
# brg 2.2.2012 : Completely rebuilt: optisim1 based on optimsim7.py
# brg 3.2.2012: Changing the search strategy: Maximizing isotone fraction and accepting a
#               certain degree of antitone
# Brg 12.12.2013: Back into the PyHasse package. Some corrections.
#.................(Obviously in February 2012 not finalized)

tech=rmod2.vecgen1(20)
x=rmod2.marray(200,200)
y=rmod2.marray(200,200)

    
def simi_fileselect():
    """ file open 1, file open 2"""
    # Brg 15.1.08, 29.5.08
    #*:15.1.08
    #akt: 29.5.08
    #note: a variant of fileselect, used in other HD programs
    #source:-
    import tkFileDialog
    global y1,y2,obj1,obj2,prop1,prop2,r1,r2,r,k1,k2,fn1,fn2
    fn1=tkFileDialog.askopenfilename()
    fn2=tkFileDialog.askopenfilename()

    
    y1,obj1,prop1,r1,k1=rmod2.EXCELreadin4(fn1)
    y2,obj2,prop2,r2,k2=rmod2.EXCELreadin4(fn2)
    print "obj1 in simi_fileselect ",obj1
    print "  "
    print "obj2 in simi_fileselect ",obj2
    # it may be that there are the same objects but in different order in the two different files
    tp1=Tkinter.Toplevel(hf)
    tp1.title('open/select')
    lbfileselect=Tkinter.Label(tp1, bg="yellow",text = "opened file1 with "+str(r1)+" rows and "+str(k1)+" columns\n\
and file2 with "+str(r2)+" rows and "+str(k2)+"  columns")
    lbfileselect.pack()
    if r1!=r2:
        lberror=Tkinter.Label(tp1,bg="yellow",text="++++ error : unequal number of objects +++"\
                              ,font=14 )
        lberror.pack()
        buttexit=Tkinter.Button(tp1,text=" quit ",command=hf.destroy)
        buttexit.pack()
    else:
        r=r1
                                
    return

def showDM1():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from dds7.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM1 ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj1[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k1):
        txt2+=" "+prop1[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k1):
        txt3+=prop1[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj1[i+1]+"\t"
        for j in range(0,k1):
            txt3+=str(y1[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

def showDM2():
    """ New routine : shows the data matrix """
    #Brg 13.1.08, 15.1.08
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from dds7.py
    tp3=Tkinter.Toplevel(hf)
    tp3.title('show DM2 ')
    lbtp2=Tkinter.Label(tp3,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp3,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj2[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k2):
        txt2+=" "+prop2[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k2):
        txt3+=prop2[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj2[i+1]+"\t"
        for j in range(0,k2):
            txt3+=str(y2[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)

##
                                 
def simopt2():
    # brg 11.12.2011
    # the quality function is based just on minimizing  Q=(1-fraction antitone)/(1+fraction antitone)
    # By this, weights are not needed , however this strategy favours linear models
    global eactatt
    print "r=  ",r
    tpsim=Tkinter.Toplevel(hf)
    tpsim.title(' similarity')
    lbhfsim=Tkinter.Label(tpsim, text=' Search protocol ')
    lbhfsim.pack()
    tsim=ScrolledText(tpsim, width=60, height=4)
    tsim.pack()

    txtsim1=""
    
    
    txtsim1+="\n Filename:"+fn2+"   Version 1"
    txtsim1+="\n-----------------------------\n"
    global Qmax
    Qmax=float(eQmax.get())
    indifflimit=float(e_indiff.get())
    txtsim1+="Any isotonedegree > "+str(round(Qmax,3))+" will be reported"
    txtsim1+="..and only if indiff fraction < "+str(indifflimit)+"\n"
    flagAC="n"
        
    #Q  value to be optimized
    jmax=0  # which attribute comb. makes the best job
    olimit=2**k2
    nrsim=0
    for j in range(0,olimit):#generation of cases taken from the model-dm
        
        x=j
        x1=j
        bx=[]
        bx=rmod2.bitrep(k2,x)
        if sum(bx)==0:            #30.5.08 Avoiding the empty bx
            continue
        k2akt=0
        for i in range(0,k2):
            k2akt+=bx[i]
        pakt=rmod2.vecgen1(k2akt)
        
        pakti=0
        for i in range(0,k2):  #actual list of model attributes
            if bx[i]==1:
                pakt[pakti]= prop2[i+1]
                pakti+=1
        
        
        yakt=rmod2.marray(r,k2akt)
        iattakt=0
        #print "in simopt"
        for iob in range(0,r):
            iattakt=0
            for iatt in range(0,k2):  #actual data matrix
                #print "iattakt = ",iattakt
                if bx[iatt]==1:
                    yakt[iob][iattakt]=y2[iob][iatt]
                    iattakt+=1
                
            
    
        # start with analysis: derivation of quobx
        objx1=rmod2.marray(r,r)
        quobx1=rmod2.marray(r,r)
        objx1=rmod2.comp(r,k1,y1)
        rmod2.qualcomp(r,objx1,quobx1)
        
        #start with analysis: derivation of quoby
        objx2=rmod2.marray(r,r)
        quobx2=rmod2.marray(r,r)
        objx2=rmod2.comp(r,k2akt,yakt)
        rmod2.qualcomp(r,objx2,quobx2)
        
         #heart of similarity analysis:
        # Based on quobx and quoby the sim-matrix will be prepared
        global simi
        
        
        sim=rmod2.similarity1(r,quobx1,quobx2)
       
        #sim0: isotone, sim1: antitone, sim2: weak isotone, sim3: indiff (||,...)
        #sim4 equiv,
        Q=sim[6]#  Q=1 : optimal vslue
        

        if Q>=Qmax:
            
            jmax=j
            optbx=rmod2.vecgen1(k2)
            
            k2opt=k2akt
            optpakt=rmod2.vecgen1(k2opt)
            for i1 in range(0,k2):
                optbx[i1]=bx[i1]
                

            yaktopt=rmod2.marray(r,k2akt)
            for iob in range(0,r):
                iattakt1=0
                for iatt in range(0,k2):  #actual data matrix
                    print "iattakt = ",iattakt
                    if optbx[iatt]==1:
                        yaktopt[iob][iattakt1]=y2[iob][iatt]
                        iattakt1+=1

            i3=0
            for iatt in range(0,k2):
                if optbx[iatt]==1:
                    optpakt[i3]=pakt[i3]
                    i3+=1
            objx2opt=rmod2.marray(r,r)
            quobx2opt=rmod2.marray(r,r)
            objx2opt=rmod2.comp(r,k2akt,yaktopt)
            rmod2.qualcomp(r,objx2opt,quobx2opt)
        

        
            # Based on quobx and quoby the sim-matrix will be prepared
            global simiopt
        
            
            prop2c=[]
            for j in range(0,k2):
                prop2c.append(prop2[j+1])
            simiopt=rmod2.similarity1(r,quobx1,quobx2opt)
            print "simopt = ",simiopt[9], "   indifflimit= ",indifflimit
            if simiopt[9]<indifflimit:
                nrsim+=1
                print "simiopt[6] ",simiopt[6],"  isotonelimit= ",Qmax, "   Q=  ",round(Q,3)
                txtsim1+="\nSimulation no : "+str(nrsim)
                txtsim1+="\nValue of Quality function : "+str(round(Q,3))+"\n"
                txtsim1+="No of descriptors: "+str(k2akt)+" of in total "+str(k2) +" descriptors" +"\n"
                txtsim1+="Actually selected descriptors: "
                txthilf=""
                lp=len(pakt)
                for i2 in range(0,lp):
                    txthilf+=str(pakt[i2])+", "
                txthilf+="\n"
                txthilf+="Numbers of the descriptors (for subseq. getting the HD)"+"\n"
                for i2 in range(0,lp):
                    txthilf+=str(prop2c.index(pakt[i2]))+", "
                txtsim1+= txthilf
                txtsim1+="\n: "
                txtsim1+="S i m i l a r i t y "+"\n"
                txtsim1+="fraction isotone (>>): "+"\t"+str(round(simiopt[6],3))+"\n"
                txtsim1+="fraction antitone (><): "+"\t"+str(round(simiopt[7],3))+"\n"
                txtsim1+="fraction weak iso (>=): "+"\t"+str(round(simiopt[8],3))+"\n"
                txtsim1+="fraction indiff (||...): "+"\t"+str(round(simiopt[9],3))+"\n"
                txtsim1+="fraction equiv (=,=): "+"\t"+str(round(simiopt[10],3))+"\n"
            


                    
    tsim.insert("end",txtsim1)
    lbattact=Tkinter.Label(tpsim,text="selected attributes such as 0,1,.. or 2,3,5..")
    lbattact.pack()
    eactatt=Tkinter.Entry(tpsim,width=10)
    eactatt.pack()
    buttHDopt=Tkinter.Button(tpsim,text=" HDs of orig dm and \nof selected descriptors",width=25,command=HD2vs)
    buttHDopt.pack()
    
def HD2vs():
    # brg 11.12.2011, taken from HDsimpl  11.12.2011
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09
    # If the number of representants > 70 then only the cover-matrix and the level-population
    #
    global covds,objred2c,k2act,objred2c,xred2,rred2,attact2
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    obj1corr=rmod2.vecgen1(r)
    for i in range(0,r):
        obj1corr[i]=obj2[i+1]
    print "obj1corr = ",obj1corr
    rred1,xred1,objred1c,txt1,neq1=rmod2.equivcompactm(r1,k1,y1,obj1corr)
    
    print "in HD2vs txt1 of equivcompactm ",txt1
    print "objred1c ",objred1c
    #
    zetahilf1=rmod2.comp(rred1,k1,xred1)  #zeta matrix with col<row
    zeta1=rmod2.marray(rred1,rred1)
    for i in range(0,rred1):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred1):
            zeta1[i][j]=zetahilf1[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred1,zeta1)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred1,lext,revlext,zeta1)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred1,adjc,lext)
       
    
    cov=rmod2.cover(rred1,tr,lext)

    if rred1>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram 1 (orig dm) ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred1,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred1,rred1)
        geomy=rmod2.marray(rred1,rred1)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred1c[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()

    # now dm with selected descriptors
    attact=[]
    hilf=eactatt.get()
    attact=hilf.split(",")
    k2act=len(attact)
    print "r2= ",r2,"  k2= ",k2,"  attact= ",attact
    #rmod2.matout(r2,k2,y2)
    attact2=[]
    for j in range(0,k2act):
        attact2.append(int(attact[j]))
    txt,y2act=rmod2.newmatrix(r2,k2,y2,attact2)
    print attact2  

    #
    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title(' HD of selected descriptors ')
    freq=Tkinter.Frame(hfhd3,width=200,height=300)
    freq.pack()
    
    rred2,xred2,objred2c,txt2,neq2=rmod2.equivcompactm(r2,k2act,y2act,obj1corr)
##    print "r2 = ",r2
##    print "objred2c = ",objred2c
##    print "rred2= ",rred2
##    print "txt2 = ",txt2
    #
    zetahilf2=rmod2.comp(rred2,k2act,xred2)  #zeta matrix with col<row
    zeta2=rmod2.marray(rred2,rred2)
    for i in range(0,rred2):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred2):
            zeta2[i][j]=zetahilf2[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred2,zeta2)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred2,lext,revlext,zeta2)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred2,adjc,lext)
       
    
    covds=rmod2.cover(rred2,tr,lext)

    if rred2>70:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram 2 (model dm) ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred2,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred2,rred2)
        geomy=rmod2.marray(rred2,rred2)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covds[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2c[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(hfhd3,text="cover relation ",bg="cyan",width=25,command=coverds)
        buttcov.pack()
    

def coverds():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: taken from mainHD20-
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,rred2):
        txt3+="\n"+objred2c[i]+":\t"
        txt3+="is covered by "
        for j in range(0,rred2):
            if i!=j:
                if covds[i][j]==1:
                    txt3+=" "+objred2c[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack(expand=1,fill="both")
    tcov.insert("end",txt3)    

def sfds():
    #brg  31.5.09, 1.6.09, 2.2.2012
    fnds=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    # brg  30.5.09
    print "k2 = ",k2
    print "k2act = ",k2act
    print "prop2 = ",prop2
    print "attact2 = ",attact2
    prop2act=[]
    for j in range(0,k2act):
        prop2act.append(prop2[int(attact2[j]+1)])
   
    print prop2act
    rmod2.raiwrite5(fnds,xred2,objred2c,prop2act,rred2,k2act)
    lbsuccess.config(text="matrix with \n"+str(rred2)+"  rows  and "+str(k2act)+"\n  columns stored",bg="yellow")

    
    
hf=Tkinter.Tk()
hf.title("optimizing similarity by subset search")
#  Use of OOP
helpoptimsim=raioop2.brgabout(hf,"tp1","help_optimsim.txt",1,\
            "Febr. 2nd,2012"," help_optisim ", "white", "t1",80,6,ScrolledText)
    

fr=Tkinter.Frame(hf,width=400,height=400)
fr.pack()
lbinfo=Tkinter.Label(fr,text="         Author: R.Bruggemann, vs 6 of 2.2.12                  ")
lbinfo.pack(pady=25)

lbopenfile=Tkinter.Label(fr,text="select the files")
lbopenfile.pack()

butt1=Tkinter.Button(fr,text="(1)select and open the files",bg="white",width=25, command=simi_fileselect)
butt1.pack(pady=10)
butt2a=Tkinter.Button(fr,text="(2a) show data matrix 1",width=25,command=showDM1)
butt2a.pack()
butt2b=Tkinter.Button(fr,text="(2b) show data matrix 2",width=25,command=showDM2)
butt2b.pack(pady=5)

frvs2=Tkinter.Frame(fr,bd=3,relief="groove")
frvs2.pack()
lbvs2=Tkinter.Label(frvs2,text="Optimal value =1. Lower limit for accepting\nQ as approx. \n\
    (0.9,0.8,... recommended) >>")
lbvs2.pack(side="left")
eQmax=Tkinter.Entry(frvs2,width=5)
eQmax.pack(side="left")
frvs2_2=Tkinter.Frame(fr,bd=3,relief="groove")
frvs2_2.pack()
frvs3=Tkinter.Frame(fr,bd=3,relief="groove")
frvs3.pack()
lbvs3=Tkinter.Label(frvs3,text="Only results with an isotone fraction > ... \n\
    (recommended to start with low fractions, 0.5,0.6,...) ")
lbvs3.pack(side="left")
e_iso=Tkinter.Entry(frvs3,width=3)
e_iso.pack(side="left")
frvs4=Tkinter.Frame(fr,bd=3,relief="groove")
frvs4.pack(pady=2)
lbvs4=Tkinter.Label(frvs4,text="...and where the indiff-relations are less than...\n\
    (enter a value <=1) (1 recommended")
lbvs4.pack(side="left")
e_indiff=Tkinter.Entry(frvs4,width=4)
e_indiff.pack(side="left")
                    
butt42=Tkinter.Button(fr,text="(4_2) optsim vs 2",bg="cyan",bd=4,width=25, command=simopt2)
butt42.pack()
lbsuccess=Tkinter.Label(fr,text="")
lbsuccess.pack()
buttstore=Tkinter.Button(fr,text="store the selected dm ",bg="cyan",bd=4,width=25,command=sfds)
buttstore.pack()
buttexit=Tkinter.Button(fr,text = " Exit ", bg="red",width=25,command=hf.destroy)
buttexit.pack(pady=25)


hf.mainloop()
