import rmod2
import raioop2
import Tkinter
from ScrolledText import *
import tkFileDialog
import Canvas
import os
from math import *

# Orientation1.py 25.10.2012



def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08
    #note: There may be conflicts with other moduls
    #source:-
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    global fn,dm,r,k,obj,prop
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    obj=rmod2.vecgen1(r)
    prop=rmod2.vecgen1(k)
    for i in range(0,r):
        obj[i]=ob[i+1]
    for j in range(0,k):
        prop[j]=pro[j+1]
    

         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)


def calc():
    # brg 25.10.2012
    nq=k
    
    def reverse(dm,r,k,nq,obj):
    # brg 25.10.2012
        maxz=2**k
        Ugrande=rmod2.marray(maxz,3)
        for j in range(0,maxz):
            bxact=rmod2.bitrep(k,j)
            dmact=rmod2.marray(r,k)
            #print "actual bitpattern ",bxact
            for j1 in range(0,k):
                if bxact[j1]==1:
                    hilf1=[]
                    hilf2=[]
                    for i in range(0,r):
                        hilf1.append(dm[i][j1])
                    maxhilf=max(hilf1)
                    for i in range(0,r):
                        hilf2.append(maxhilf-hilf1[i])
                    for i in range(0,r):
                        dmact[i][j1]=hilf2[i]
                else:
                    for i in range(0,r):
                        dmact[i][j1]=dm[i][j1]
                                 
            rred,xred,objred,txteq,neq2=rmod2.equivcompactm(r,k,dmact,obj)
            zetahilf=rmod2.comp(rred,k,xred)
            zahl_U=0
            for i in range(0,rred):
                for i2 in range(0,rred):
                    if zetahilf[i][i2]==0 and zetahilf[i2][i]==0:
                        zahl_U+=0.5
            #print "bitpattern ",bxact,"  zahl_U ",zahl_U
            Ugrande[j][0]=j
            Ugrande[j][1]=bxact
            Ugrande[j][2]=zahl_U
    
            #print "j= ",j,"  Ugrande ",Ugrande[j]    
        return maxz,Ugrande  


    def elim(dm,r,k):
        # brg 25.10.2012
        Ulittle=rmod2.marray(k,3)
        for j in range(0,k):
            dmact=rmod2.marray(r,k)
            
            for i in range(0,r):
                for j1 in range(0,k):
                    if j1==j:
                        dmact[i][j1]=0
                    else:
                        dmact[i][j1]=dm[i][j1]
            print "j= ",j
            rmod2.matout(r,k,dmact)
            rred,xred,objred,txteq,neq2=rmod2.equivcompactm(r,k,dmact,obj)
            zetahilf=rmod2.comp(rred,k,xred)
            print j,"  rred= ",rred
            zahl_U=0
            for i in range(0,rred):
                for i2 in range(0,rred):
                    if zetahilf[i][i2]==0 and zetahilf[i2][i]==0:
                        zahl_U+=0.5
            print "j= ",j,"   Ulittle= ",zahl_U
            Ulittle[j][0]=j
            Ulittle[j][1]=0
            Ulittle[j][2]=zahl_U
            print "Final Ulittle",j,Ulittle[j][0],Ulittle[j][2]
        
        return Ulittle

    # main indicators Ugr and Uli
    # Ugr: all combinations of reverting columns of dm
    # Uli: one column left out
    global Ugr,Uli
    dummy,Ugr=reverse(dm,r,k,nq,obj)    
    Uli=elim(dm,r,k)                
##    print Ugr
##    print " "
##    print Uli

def basicinfoUgr():
    # brg 25.10.2012
    maxz=2**k
    
    minUgr=999999
    for j1 in range(0,maxz):
        if Ugr[j1][2]<=minUgr:
            minUgr=Ugr[j1][2]
            bitpmin=Ugr[j1][1]
            nrbitpmin=j1

    sampleminUgr=[]
    for j1 in range(0,maxz):
        if Ugr[j1][2]==minUgr:
            sampleminUgr.append(j1)

    maxUgr=-999999
    for j1 in range(0,maxz):
        if Ugr[j1][2]>=maxUgr:
            maxUgr=Ugr[j1][2]
            bitpmax=Ugr[j1][1]
            nrbitpmax=j1
            
        
    hilf=[]
    for j1 in range(0,maxz):
        hilf.append(Ugr[j1][2])

    meanUgr=1.0*sum(hilf)/maxz

    tpbugr=Tkinter.Toplevel(hf)
    tpbugr.title(' basic info concerning Ugr ')
    tbugr=ScrolledText(tpbugr,width=80,height=10)
    tbugr.pack()
    tpar=3
    txt=" Basic info to total number of incomparabilities (Ugr) "+"\n"
    txt+="of different oriented datamatrices"+"\n"
    txt+="Number of matrices "+tpar*"\t"+str(maxz)+2*"\n"
    txt+="Minimal value of Ugr"+tpar*"\t"+str(minUgr)+"\n"
    txt+="orientation pattern: "+tpar*"\t"+str(bitpmin)+"\n"
    txt+="reference number (min): "+tpar*"\t"+str(nrbitpmin)+2*"\n"
    txt+="Maximal value of Ugr"+tpar*"\t"+str(maxUgr)+"\n"
    txt+="orientation pattern: "+tpar*"\t"+str(bitpmax)+"\n"
    txt+="reference number (max): "+tpar*"\t"+str(nrbitpmax)+2*"\n"
    txt+="Mean value of Ugr"+tpar*"\t"+str(meanUgr)+"\n"
    txt+="  "+"\n"
    txt+="reference numbers of minimal values of Ugr "+"\n"
    lsampleUgr=len(sampleminUgr)
    for j1 in range(0,lsampleUgr):
        txt+=str(sampleminUgr[j1])+"\t"
    txt+=" "+"\n"
    tbugr.insert("end",txt)

    
def basicinfoUli():
    # brg 25.10.2012
    tpuli=Tkinter.Toplevel(hf)
    tpuli.title('basic info: Uli ')
    tuli=ScrolledText(tpuli, width=80,height=20)
    tuli.pack()
    txt2="Basic info to total incomparabilities (Uli) "+"\n"
    for j in range(0,k):
        txt2+="attrbute \t"+str(j)+"\tnot considered: Uli= \t"+str(Uli[j][2])+"\n"
    tuli.insert("end",txt2)


def HDUgr():
    # brg 25.10.2012
    global dmact
    tpHDUgr=Tkinter.Toplevel(hf)
    tpHDUgr.title(' HD of reference (Ugr) ')
    refnrUgr=int(erefUgr.get())
    bxact=rmod2.bitrep(k,refnrUgr)
    dmact=rmod2.marray(r,k)
    print "actual bitpattern ",bxact
    for j1 in range(0,k):
        if bxact[j1]==1:
            hilf1=[]
            hilf2=[]
            for i in range(0,r):
                hilf1.append(dm[i][j1])
            maxhilf=max(hilf1)
            for i in range(0,r):
                hilf2.append(maxhilf-hilf1[i])
            for i in range(0,r):
                dmact[i][j1]=hilf2[i]
        else:
            for i in range(0,r):
                dmact[i][j1]=dm[i][j1]
                             
                
    rmod2.matout(r,k,dmact)
    print " "
    print "-----------"
    rred,xred,objred,txteq,neq2=rmod2.equivcompactm(r,k,dmact,obj)
    zetahilf=rmod2.comp(rred,k,xred)
    zahl_U=0
    for i in range(0,rred):
        for i2 in range(0,rred):
            if zetahilf[i][i2]==0 and zetahilf[i2][i]==0:
                zahl_U+=0.5
    print "bitpattern ",bxact,"  zahl_U ",zahl_U
    
    zeta=rmod2.marray(rred,rred)
    
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)
    
    if rred>200:
        print "too many objects "                
    else:
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(tpHDUgr,width=actwidth,height=actheight,bg="white")
        cv.pack()
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(1*factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(1*factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                iob=obj.index(objred[lobj[i][j]]) #lobj is based on representative elements, whereas ci is based on all objects
                #print "i=",i,"  j= ",j,"  lobj = ",lobj[i][j],objred[lobj[i][j]],iob,obj[iob]
                
                cv.create_oval(geomx[i][j]-15,geomy[i][j]+15,geomx[i][j]+15,geomy[i][j]-15,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        cvtxt=cv.create_text(100,actheight-10,text="bitpattern: "+str(bxact)+"  total incomp: "+str(zahl_U))
        buttonstore=Tkinter.Button(tpHDUgr,text="store the data matrix",width=25,command=storedmUgr)
        buttonstore.pack()


def storedmUgr():
    # brg 26.10.2012
    # taken from interval8.py
    fndmact=tkFileDialog.asksaveasfilename(parent=hf,title="save dmact of Ugr as file ")
    # brg  30.5.09
    for i in range(0,r):
        print obj[i]," ",
    print " "    
    rmod2.raiwrite5(fndmact,dmact,obj,prop,r,k)
    lbsuccess.config(text="matrix with \n"+str(r)+"  rows  and "+str(k)+"\n  columns stored",bg="yellow")




        
def HDUli():
    #brg 25.10.2012
    tpUliHD=Tkinter.Toplevel(hf)
    tpUliHD.title(' HD of reference (Uli) ')
    refnrUli=int(erefUli.get())
    
    dmact=rmod2.marray(r,k)
    for i in range(0,r):  #26.10.2012
        for j1 in range(0,k):
            if j1==refnrUli:
                dmact[i][j1]=0
            else:
                dmact[i][j1]=dm[i][j1]
    print "refnrUli= ",refnrUli
    rmod2.matout(r,k,dmact)
    rred2,xred2,objred2,txteq2,neq2=rmod2.equivcompactm(r,k,dmact,obj)
    zetahilf2=rmod2.comp(rred2,k,xred2)
            
    zahl_U=0
    for i in range(0,rred2):
        for i2 in range(0,rred2):
            if zetahilf2[i][i2]==0 and zetahilf2[i2][i]==0:
                zahl_U+=0.5
    
    zeta2=rmod2.marray(rred2,rred2)
    
    for i in range(0,rred2):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred2):
            zeta2[i][j]=zetahilf2[j][i]
    #
    #One linear extension (based on levels)
    
    lobj2,lext2,revlext2,zzmax2=rmod2.levtopsort(rred2,zeta2)
       
    levmax2=-10**20     #20.6.08
    for i in range(0,zzmax2):
        if len(lobj2[i])>=levmax2:
            levmax2=len(lobj2[i])
       
    #Adj-Listen

    adjc2=rmod2.adjacent(rred2,lext2,revlext2,zeta2)
        
    #Transitive reduced relations
    ts2,tr2=rmod2.trreduct(rred2,adjc2,lext2)
       
    
    cov2=rmod2.cover(rred2,tr2,lext2)
    
    if rred2>200:
        print "too many objects "                
    else:
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred2,levmax2,zzmax2)
        cv=Tkinter.Canvas(tpUliHD,width=actwidth,height=actheight,bg="white")
        cv.pack()
        
        lz=zzmax2
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj2[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred2,rred2)
        geomy=rmod2.marray(rred2,rred2)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(1*factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(1*factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov2[lobj2[i1][j1]][lobj2[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                iob=obj.index(objred2[lobj2[i][j]]) #lobj is based on representative elements, whereas ci is based on all objects
                #print "i=",i,"  j= ",j,"  lobj = ",lobj[i][j],objred[lobj[i][j]],iob,obj[iob]
                
                cv.create_oval(geomx[i][j]-15,geomy[i][j]+15,geomx[i][j]+15,geomy[i][j]-15,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred2[lobj2[i][j]])
     

                    

hf=Tkinter.Tk()
hf.title(' orientation ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_orientation.txt",1,\
            "October, 25th,2012"," about orientation ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_orientation.txt",1,\
            "October, 25th,2012"," help_orientation ", "white", "t1",80,5,ScrolledText)
    
fr=Tkinter.Frame(hf,width=80)
fr.pack()
wb=30
cl="cyan"
button1=Tkinter.Button(fr,text="Select and open a file",width=wb,bg=cl,command=fileselect)
button1.pack()
lbopen1=Tkinter.Label(fr,text=3*"\n ")
lbopen1.pack()
button4=Tkinter.Button(fr,text="Show dm  ",width=wb, bg=cl, command=showDM)
button4.pack()
button8=Tkinter.Button(fr,text="Calculations ",width=wb,bg=cl,command=calc)
button8.pack()
button12=Tkinter.Button(fr,text="Show Ugr-results ",width=wb,bg=cl,command=basicinfoUgr)
button12.pack()
button16=Tkinter.Button(fr,text="Show Uli-results ",width=wb,bg=cl,command=basicinfoUli)
button16.pack()
fr2=Tkinter.Frame(fr)
fr2.pack()
lb1=Tkinter.Label(fr2,text="refnr (Ugr) ")
lb1.grid(row=0,column=0)
erefUgr=Tkinter.Entry(fr2,width=5)
erefUgr.grid(row=0,column=2)

lb2=Tkinter.Label(fr2,text="refnr (Uli) ")
lb2.grid(row=1,column=0)
erefUli=Tkinter.Entry(fr2,width=5)
erefUli.grid(row=1,column=2)

button22=Tkinter.Button(fr,text=" HD based on speficic reference (Ugr)",width=wb,bg=cl,command=HDUgr)
button22.pack()
button26=Tkinter.Button(fr, text=" HD based on specific reference (Uli) ",width=wb,bg=cl,command=HDUli)
button26.pack()
button30=Tkinter.Button(fr,text=" exit",bg="red",width=10,command=hf.destroy)
button30.pack(pady=5)


hf.mainloop()









hf.mainloop()
    
    
