import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import polib
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# palg_simple (derived from HDsimpl)
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 19.12.17 Control prints
# 24.10.18: palg_simple1_1


###### editfenster ### 29.8.2013 #####

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####
##########################################
    

    
def show_dm_orig():
    # brg 24.10.2018
    
    polib.show_DM(hf, fn, x, prop, obj)

def HD_orig():
    # brg 24.10.2018
    global cov_orig
    print "objred= ",objred
    cov_orig=polib.HD(hf,fn, xred, rred, k, objred, 12)
    
def show_covorig():
    # brg 24.10.2018
    polib.cover_show(hf,cov_orig, objred)
    
def calc():
    # brg 24.10.2018
    global limit, span, xtrafo, mindata, maxdata, count
    limit=float(e_limit.get())
    print "limit= ",limit
    limitreal=limit/100.0
    lowerlimit=-9999
    mindata=[]
    for j in range(0, k):
        hilf=[]
        for i in range(0,rred):
            hilf.append(xred[i][j])
        mindata.append(min(hilf))
    maxdata=[]
    for j in range(0,k):
        hilf=[]
        for i in range(0,rred):
            hilf.append(xred[i][j])
        maxdata.append(max(hilf))
    rmod2.matout(rred,k,xred)
    print mindata
    print maxdata
    span=[]
    for j in range(0,k):
        span.append(maxdata[j]-mindata[j])
    xtrafo=[]
    count=0
    for i in range(0,rred):
        xtrafo.append(0)
        xtrafo[i]=[]
        flag=0
        for j in range(0,k):
            if xred[i][j]>=mindata[j]+limitreal*span[j]:
                xtrafo[i].append(xred[i][j])
            else:
                xtrafo[i].append(-9999)
                flag+=1
        if flag==k:
            count+=1

def details():
    # brg 24.10.2018
    tpdetails=Tkinter.Toplevel(hf)
    tpdetails.title(" details of transformation ")
    tdetails=ScrolledText(tpdetails,width=60,height=20)
    tdetails.pack()
    txt="File = "+str(fn)+"\n"
    txt+="user given limit "+str(limit)+"\n"
    txt+="minimal values: "+"\n"
    for j in range(0,k):
        txt+=str(round(mindata[j],3))+", "
    txt+="\n"
    txt+="maximal values: "+"\n"
    for j in range(0,k):
        txt+=str(round(maxdata[j],3))+", "
    txt+="\n"
    txt+="Span "
    for j in range(0,k):
        txt+=str(round(span[j],3))+", "
    txt+="\n"    
    txt+="limits: "+"\n"
    for j in range(0,k):
        txt+=str(round(mindata[j]+(1.0*limit/100.0)*span[j],3))+", "
    txt+="\n"
    txt+="Complete replacement of data by -9999 for.. "+str(count) +".. objects"+"\n"
    txt+=" of "+str(rred)+" representative objects"+"\n"
    txt+="- - - e o f - - -"
    
    tdetails.insert("end",txt)
    
def show_dm_trafo():
    # brg 24.10.2018
    polib.show_DM(hf,fn,xtrafo,prop,objred)

def HDtrafo():
    #brg 24.10.2018
    global txteq2, cov_trafo, objred2
    rred2,xred2,objred2,txteq2,neq2=rmod2.equivcompactm2(rred,k,xtrafo,objred,10)
    cov_trafo=polib.HD(hf,fn,xred2,rred2,k,objred2,12)

def eqtrafo():
    # brg 24.10.2018
    polib.show_equivalencies(hf,fn,txteq2)

def show_cov_trafo():
    polib.cover_show(hf,cov_trafo,objred2)

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' palg_simple ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_palg_simple.txt",1,\
            "October, 24th, 2018"," about palg_simple ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_palg_simple.txt",1,\
            "October, the 24th, 2018"," help_palg_simple", "white", "t1",80,5,ScrolledText)
wpalg=35    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", width=wpalg, command=xselectfile)
butt1.pack()
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="Show data matrix (dm)",bg="cyan",width=wpalg, command=show_dm_orig)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=wpalg, bg="cyan", command=HD_orig)
buttHD.pack(pady=5)
buttcovorig=Tkinter.Button(fr, text="show cover matrix ",width=wpalg, bg="white", command=show_covorig)
buttcovorig.pack()
txtlimit="Enter the percentage e.g. 90%\n"
txtlimit+="then all data larger than 90% of the whole span\n"
txtlimit+="keep their values, whereas values less tahn 90% get a value -9999"
lblimit=Tkinter.Label(fr,text=txtlimit)
lblimit.pack()
e_limit=Tkinter.Entry(fr,width=5)
e_limit.pack()
buttcalc=Tkinter.Button(fr,text="palg-transformation ",width=wpalg,bg="cyan",command=calc)
buttcalc.pack()
buttshowdetails=Tkinter.Button(fr,text="Details of transformation ",width=wpalg,bg="white",command=details)
buttshowdetails.pack()
buttshowtrafodm=Tkinter.Button(fr,text="show transformed matrix",width=wpalg,bg="cyan",command=show_dm_trafo)
buttshowtrafodm.pack()
buttHDtrafodm=Tkinter.Button(fr,text="show HD of transformed matrix",width=wpalg,bg="cyan",command=HDtrafo)
buttHDtrafodm.pack()
buttequivtrafo=Tkinter.Button(fr, text="Show equivalence classes of transformed matrix ",width=wpalg, bg="cyan",command=eqtrafo)
buttequivtrafo.pack()
buttshowcovtrafo=Tkinter.Button(fr,text="show cover matrix of transformed system ",bg="white",width=wpalg, command=show_cov_trafo)
buttshowcovtrafo.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width=10, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
