import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
#from string import replace

# brg 26.7.2013
# CSV-readin using professional routines of csv-library
# HDsimpl specifically for CSV-files (CSV-separated by ";")
# 28.7.2013: "," in numbers in "." in numbers
# 29.7.2013 cosmetics
# 29.8.2013 enabling to read data files stored in different formats
# 22.3.2014 cover-relation
# 8.9.2014 precision when checking the equivalence classes (equivcompactm2)
# 8.9.2014: output equivalence classes
# 9.9.2014 interface: graphviz
# 19.9.15 probobjpair1.py  
# 20.9.2015 Fortsetzung der Arbeiten
# 27.9.2015 Direct entering data
# Problems concerning manual entering data
# 3.10.2015 Prob x || y file related

    

def xselectfile():
    # brg 6.8.2013, 27.9.15
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    buttprobcalc.config(state="active")
    buttprobcalc2.config(state="active")
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)
    


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####





def HD():
    # brg 26.7.2013, 29.8.2013
    
    global x,la,ls,cov, rred, objred, zeta, dmn
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
      #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        buttcov=Tkinter.Button(freq, text = "cover - relation ",width = 20, command = cover)
        buttcov.pack()
        buttequiv = Tkinter.Button(freq,text="show equivalence classes", width = 30,command = showeq)
        buttequiv.pack()
        

def cover():
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i in range(0, rred):
        txt3 += "\n" + objred[i] + ":\t"
        txt3 += "is covered by "
        for j in range(0, rred):
            if i!=j:
                if cov[i][j] == 1:
                    txt3 += " " + objred[j] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def showeq():
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

def show_file():
    # br 2.7.2013
    global dmn
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    
    

def calc_relat(r, k, x):
    #taken from rmod2 13.10.2014 and modified according to PyHasse_internet
    c= []
    flag=0    
    for i1 in range(0, r):
        c.append(0)
        c[i1] = []
        for i2 in range(0, r):
            flag=0
            for j in range(0, k):
                #print " kk =",kk," i=",i," j = ",j
                if x[i1][j] >= x[i2][j]:
                    flag += 1
            if flag == k:
                 c[i1].append(1)
            else:
                 c[i1].append(0)
            #print " "     
    return c


#########################################################################
def submitek():
    #brg 27.09.15
    global kd, eobj1,eobj2
    try:
        kd=int(ek.get())
    except:
        kd = 2
    tpdirect=Tkinter.Toplevel(hf)
    tpdirect.title(' Direct in-read ')
    lbd1=Tkinter.Label(tpdirect,text="Read in "+str(kd)+" attribute values for two objects")
    lbd1.pack()
    lbd2=Tkinter.Label(tpdirect,text="First object, then the second one")
    lbd2.pack()
    lbd3=Tkinter.Label(tpdirect,text="Prob(first object < second object) will be determined")
    lbd3.pack()
    frd4=Tkinter.Frame(tpdirect)
    frd4.pack()
    eobj1=rmod2.vecgen1(kd)
    eobj2=rmod2.vecgen1(kd)
    lbd5=Tkinter.Label(frd4,text="1st obj")
    lbd5.grid(row=0,column=0)
    for j in range(0,kd):
        eobj1[j]=Tkinter.Entry(frd4,width=4)
        eobj1[j].grid(row=0, column=1+j)
           
    lbd6=Tkinter.Label(frd4,text="2nd obj")
    lbd6.grid(row=1,column=0)    
    for j in range(0,kd):
        eobj2[j]=Tkinter.Entry(frd4,width=4)
        eobj2[j].grid(row=1, column=1+j)
    butttakevalues2.config(state="active")
    butttakevalues3.config(state="active")
    butttakevalues3.config(state="active")
    
def takevalues2():
    # brg 27.9.15, 29.9.15
    global xm, ym
    xm = rmod2.vecgen1(kd) #xm,ym: manually entered data
    ym = rmod2.vecgen1(kd) 
    minob=rmod2.vecgen1(kd)
    maxob=rmod2.vecgen1(kd)
    for j in range(0,kd):
        xm[j]=float(eobj1[j].get())
        ym[j]=float(eobj2[j].get())
        if xm[j]<ym[j]:
            minob[j]=xm[j]
            maxob[j]=ym[j]
        else:
            minob[j]=ym[j]
            maxob[j]=xm[j]
    calc_prob2(minob,maxob,kd)

def takevalues3():
    # brg 27.9.15, 29.9.15
    global xm, ym
    xm = rmod2.vecgen1(kd) #xm,ym: manually entered data
    ym = rmod2.vecgen1(kd) 
    minob=rmod2.vecgen1(kd)
    maxob=rmod2.vecgen1(kd)
    for j in range(0,kd):
        xm[j]=float(eobj1[j].get())
        ym[j]=float(eobj2[j].get())
        if xm[j]<ym[j]:
            minob[j]=xm[j]
            maxob[j]=ym[j]
        else:
            minob[j]=ym[j]
            maxob[j]=xm[j]
    calc_prob3(minob,maxob,kd)

def calc_prob():
    # brg 18.09.15, 19.9.15
    try:
        nstart = float(enstart.get())
    except:
        nstart = 0
    try:
        nstep = float(enstep.get())
    except:
        nstep = 0.1
    try:
        nend = float(enend.get())
    except:
        nend = 0.5
        
    txt= "Start probability:   "+"\n"
    txt+=60*"="+"\n"
    ob1 = eob1.get()  #first object
    ob2 = eob2.get()    #second object
    iob1 = objred.index(ob1)
    iob2 = objred.index(ob2)
    minob = rmod2.vecgen1(k)
    maxob = rmod2.vecgen1(k)
    txt += "File = "+str(fn)+"\n"    
    txt += "First object =   "+str(ob1)+"\n"
    for j in range(0, k):
        txt+=str(round(xred[iob1][j],3))+"\t"
    txt+="\n"    
    txt += "Second object =  "+str(ob2)+"\n"
    for j in range(0, k):
        txt+=str(round(xred[iob2][j],3))+"\t"
    txt+="\n"  
    txt += "noise - setting "+"\n"
    txt += "start: "+str(nstart)+"\n"
    txt += "Step: "+str(nstep)+"\n"
    txt += "End: "+str(nend)+"\n"
    #noise independent specifications and calculations
    nc = []
    H = []
    for j in range(0, k):
        if xred[iob1][j] < xred[iob2][j]:
            H.append(1)
            minob[j] = xred[iob1][j]
            maxob[j] = xred[iob2][j]
        else:
            H.append(0)  #equality will arbitrarily  set H=0
            minob[j] = xred[iob2][j]
            maxob[j] = xred[iob1][j]
        nc.append(1.0*(maxob[j]-minob[j])/(1.0*maxob[j] + 1.0*minob[j]))
    txt+="Char. parameter:"+"\n"
    txt+="crucial noise"+"\n" 
    for j in range(0,k):
        txt+=str(prop[j])+"\t"
    txt+="\n"
    for j in range(0, k):
        txt+=str(round(nc[j],3))+"\t"
    txt+="\n"    
    txt+=" H (=1 if x <(j) y  else =0) "+"\n"
    for j in range(0, k):
        txt+=str(H[j])+"\t"
    txt+="\n"    
    txt+=" Main result "+"\n"
    txt+=60*"-"+"\n"
    # probability that first object < second object, taken all k attributes
    # ...simultaneously and regarding the noise-value        
    probdata = []
    zahl=0
    noise = nstart
    txt += "noise "+"\t"+"  Prob( "+str(ob1)+"  < "+str(ob2)+")" + "\n"
    while noise < nend:
        probhilf = rmod2.vecgen1(k)
        Z = rmod2.vecgen1(k)
        pov = rmod2.vecgen1(k)
        Probtotal = 1
        
        
        for j in range(0, k):
            if (1+noise)*minob[j] < (1-noise)*maxob[j]:
                probhilf[j] = H[j]
            else:
                Z[j] = minob[j]-maxob[j] + noise*(minob[j] + maxob[j])
                if noise*minob[j]*maxob[j] != 0:
                    pov[j] = 1.0*Z[j]*Z[j]/(4.0*noise*noise*minob[j]*maxob[j])
                else:
                    pov[j] = 0
                probhilf[j] = H[j]*(1.0-pov[j])+0.5*pov[j]
            Probtotal = Probtotal*probhilf[j]
        txt += str(noise) +"\t"+str(round(Probtotal,4))+"\n"
        probdata.append(Probtotal)
        noise += nstep
        zahl+=1
        if zahl > 100:  #internal safety
            break
    names=["noise","prob","prob("+str(ob1)+" < "+str(ob2)+")"]
    app1 = raioop2.brggraph5(hf,names,"red",3,probdata,nstart,nend)
    app1.ausgabe()
    
        
    tpresult = Tkinter.Toplevel(hf)
    tpresult.title(' McNoise ')
    tresult = ScrolledText(tpresult, height=20, width=60)
    tresult.pack()
    tresult.insert("end",txt)

def calc_probic():
    # brg 18.09.15, 19.9.15, 3.10.15
    try:
        nstart = float(enstart.get())
    except:
        nstart = 0
    try:
        nstep = float(enstep.get())
    except:
        nstep = 0.1
    try:
        nend = float(enend.get())
    except:
        nend = 0.5
        
    txt= "Start probability:   "+"\n"
    txt+=60*"="+"\n"
    ob1 = eob1.get()  #first object
    ob2 = eob2.get()    #second object
    iob1 = objred.index(ob1)
    iob2 = objred.index(ob2)
    minob = rmod2.vecgen1(k)
    maxob = rmod2.vecgen1(k)
    txt += "File = "+str(fn)+"\n"    
    txt += "First object =   "+str(ob1)+"\n"
    for j in range(0, k):
        txt+=str(round(xred[iob1][j],3))+"\t"
    txt+="\n"    
    txt += "Second object =  "+str(ob2)+"\n"
    for j in range(0, k):
        txt+=str(round(xred[iob2][j],3))+"\t"
    txt+="\n"  
    txt += "noise - setting "+"\n"
    txt += "start: "+str(nstart)+"\n"
    txt += "Step: "+str(nstep)+"\n"
    txt += "End: "+str(nend)+"\n"
    #noise independent specifications and calculations
    nc = []
    J1 = []
    J2 = []
    for j in range(0, k):
        if xred[iob1][j] < xred[iob2][j]:
            J1.append(j)
            minob[j] = xred[iob1][j]
            maxob[j] = xred[iob2][j]
        else:
            J2.append(j)  #equality will arbitrarily  set H=0
            minob[j] = xred[iob2][j]
            maxob[j] = xred[iob1][j]
        nc.append(1.0*(maxob[j]-minob[j])/(1.0*maxob[j] + 1.0*minob[j]))
    txt+="Char. parameter:"+"\n"
    txt+="crucial noise"+"\n" 
    for j in range(0,k):
        txt+=str(prop[j])+"\t"
    txt+="\n"
    for j in range(0, k):
        txt+=str(round(nc[j],3))+"\t"
    txt+=2*"\n"    
    txt+=" J1 "+"\n"
    for j in J1:
        txt+=str(prop[j])+"\t"
    txt+="\n"
    txt+=" J2 "+"\n"
    for j in J2:
        txt+=str(prop[j])+"\t"
    txt+="\n"
    txt+=" Main result "+"\n"
    txt+=60*"-"+"\n"
    # probability that first object < second object, taken all k attributes
    # ...simultaneously and regarding the noise-value        
    probdata = []
    zahl=0
    noise = nstart
    txt += "noise "+"\t"+"  Prob( "+str(ob1)+"  || "+str(ob2)+")" + "\n"
    while noise < nend:
        probhilf1 = rmod2.vecgen1(k)
        probhilf2 = rmod2.vecgen1(k)
        probhilf3 = rmod2.vecgen1(k)
        probhilf4 = rmod2.vecgen1(k)
        Z = rmod2.vecgen1(k)
        pov = rmod2.vecgen1(k)
        ProbLTJ1 = 1
        ProbGTJ1 = 1
        for j in J1:
            if (1+noise)*minob[j] < (1-noise)*maxob[j]:
                probhilf1[j] = 1
                probhilf2[j] = 0
            else:
                Z[j] = minob[j]-maxob[j] + noise*(minob[j] + maxob[j])
                if noise*minob[j]*maxob[j] != 0:
                    pov[j] = 1.0*Z[j]*Z[j]/(4.0*noise*noise*minob[j]*maxob[j])
                else:
                    pov[j] = 0
                probhilf1[j] = (1.0-0.5*pov[j])
                probhilf2[j] = 0.5*pov[j]
            ProbLTJ1 = ProbLTJ1*probhilf1[j]
            ProbGTJ1 = ProbGTJ1*probhilf2[j]

        probhilf3 = rmod2.vecgen1(k)
        probhilf4 = rmod2.vecgen1(k)
        Z = rmod2.vecgen1(k)
        pov = rmod2.vecgen1(k)
        ProbLTJ2 = 1
        ProbGTJ2 = 1
        for j in J2:
            if (1+noise)*minob[j] < (1-noise)*maxob[j]:
                probhilf3[j] = 1
                probhilf4[j] = 0
            else:
                Z[j] = minob[j]-maxob[j] + noise*(minob[j] + maxob[j])
                if noise*minob[j]*maxob[j] != 0:
                    pov[j] = 1.0*Z[j]*Z[j]/(4.0*noise*noise*minob[j]*maxob[j])
                else:
                    pov[j] = 0
                probhilf3[j] = (1.0-0.5*pov[j])
                probhilf4[j] = 0.5*pov[j]
            ProbLTJ2 = ProbLTJ2*probhilf4[j]
            ProbGTJ2 = ProbGTJ2*probhilf3[j]
        Probtotal = 1 - ProbLTJ1*ProbLTJ2 - ProbGTJ1*ProbGTJ2
        txt += str(noise) +"\t"+str(round(Probtotal,4))+"\n"
        probdata.append(Probtotal)
        noise += nstep
        zahl+=1
        if zahl > 1000:  #internal safety
            break
    names=["noise","prob","prob("+str(ob1)+" || "+str(ob2)+")"]
    appic = raioop2.brggraph5(hf,names,"red",3,probdata,nstart,nend)
    appic.ausgabe()
    
        
    tpresultfic = Tkinter.Toplevel(hf)
    tpresultfic.title(' prob incomp ')
    tresultfic = ScrolledText(tpresultfic, height=20, width=60)
    tresultfic.pack()
    tresultfic.insert("end",txt)

def listnc():
    # brg 28.9.2015, 29.9.2015
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    minobnc=rmod2.vecgen1(k)
    maxobnc=rmod2.vecgen1(k)
    minnc = []
    for i1 in range(0, rred):
        for i2 in range(i1+1, rred):
            nc = []
            if zeta[i1][i2]==1:
                for j in range(0, k):
                    maxobnc[j] = xred[i1][j]
                    minobnc[j] = xred[i2][j]
                    nc.append(1.0*(abs(maxobnc[j]-minobnc[j]))/(1.0*maxobnc[j] + 1.0*minobnc[j]))
                minnc.append(min(nc))
    print minnc        
    tpminnc = Tkinter.Toplevel(hf)
    tpminnc.title('list of min nc')
    tminnc=ScrolledText(tpminnc,width=80,height=20)
    tminnc.pack()
    txt="Object1\tobject2\tmin value of nc"+"\n"
    zahl = 0
    for i1 in range(0, rred):
        for i2 in range(i1+1, rred):
            if zeta[i1][i2] ==1:
                txt+=str(objred[i1])+"\t"+str(objred[i2])+"\t"+str(round(minnc[zahl],3))+"\n"
                zahl+=1
    try:
        limitnc=float(enc.get())
    except:
        limitnc=0.1
    txt+="\n"    
    txt+=" limit value for nc: "+str(limitnc)+"\n"
    txt+="Only those object pairs are shown, whose nc is below the limit-value "+"\n"
    zahl = 0
    for i1 in range(0, rred):
        for i2 in range(i1+1, rred):
            if zeta[i1][i2] ==1:
                if minnc[zahl]<=limitnc:
                    txt+=str(objred[i1])+"\t"+str(objred[i2])+"\t"+str(round(minnc[zahl],3))+"\n"
                zahl+=1    
    tminnc.insert("end",txt)        
            
                         
                         
    
def calc_prob2(minob,maxob,kd):
    # brg 18.09.15, 19.9.15, 27.9.15, 29.9.15
    # prob(first object < 2nd object)
    global ProbtotalLT
    print "minobj = ",minob
    print "maxobj = ",maxob
    print "kd = ",kd
    try:
        nstart = float(enstart.get())
    except:
        nstart = 0
    try:
        nstep = float(enstep.get())
    except:
        nstep = 0.1
    try:
        nend = float(enend.get())
    except:
        nend = 0.5
    print "noise= ",nstart, nstep,nend
    txt = "Input data "+"\n"
    txt+="First object:\t"
    for j in range(0, kd):
        txt+=str(round(xm[j],3))+"\t"
    txt+="\n"
    txt+="Second object:\t"
    for j in range(0,kd):
        txt+=str(round(ym[j],3))+"\t"
    txt+="\n"    
    txt+=50*"="+"\n"
    txt+= "Start probability:   "+"\n"
    txt+=60*"="+"\n"
    txt += "noise - setting "+"\n"
    txt += "start: "+str(nstart)+"\n"
    txt += "Step: "+str(nstep)+"\n"
    txt += "End: "+str(nend)+"\n"
    #noise independent specifications and calculations
    nc = []
    J1 = []
    J2 = []
    for j in range(0, kd):
        if xm[j]<ym[j]:  #xm is considered as first, ym as second element
            J1.append(j)
        else:
            J2.append(j)
    for j in range(0, kd):
        nc.append(1.0*(maxob[j]-minob[j])/(1.0*maxob[j] + 1.0*minob[j]))
    txt+="Char. parameter:"+"\n"
    txt+="crucial noise"+"\n" 
    for j in range(0, kd):
        txt+="attr"+str(j+1)+"\t"
    txt+="\n"
    for j in range(0, kd):
        txt+=str(round(nc[j],3))+"\t"
    txt+="\n"    
    txt+=" J1 "+"\n"
    for el in J1:
        txt+=str(el)+"\t"
    txt+="  J2  "+"\n"
    for el in J2:
        txt+=str(el)+"\t"
    txt+=" Main result "+"\n"
    txt+=60*"-"+"\n"
    # probability that first object < second object, taken all k attributes
    # ...simultaneously and regarding the noise-value        
    probdata = []
    zahl=0
    noise = nstart
    txt += "noise "+"\t"+"  Prob( first object  < second object)" + "\n"
    txt+="\n"
    ProbtotalLT =[]
    while noise < nend:
        probhilf = rmod2.vecgen1(kd)
        Z = rmod2.vecgen1(kd)
        pov = rmod2.vecgen1(kd)
        Probtotal1 = 1
        Probtotal2 = 1
        Probtotal = 1
        for j in range(0, kd):
            if (1+noise)*minob[j] < (1-noise)*maxob[j]:
                pov[j] = 0
            else:
                Z[j] = minob[j]-maxob[j] + noise*(minob[j] + maxob[j])
                if noise*minob[j]*maxob[j]!=0:
                    pov[j] = 1.0*Z[j]*Z[j]/(4.0*noise*noise*minob[j]*maxob[j])
                else:
                    pov[j] = 0
            if j in J1:      
                Probtotal1 = Probtotal1*(1-0.5*pov[j])
            else:
                Probtotal2 = Probtotal2*0.5*pov[j]
            
        Probtotal = Probtotal1*Probtotal2
        ProbtotalLT.append(Probtotal)
        txt += str(noise) +"\t"+str(round(Probtotal,4))+"\n"
        probdata.append(Probtotal)
        noise += nstep
        zahl+=1
        if zahl > 100:  #internal safety
            break
    names=["noise","prob","prob(first object < second object)+1"]
    app1 = raioop2.brggraph5(hf,names,"red",3,probdata,nstart,nend)
    app1.ausgabe()
    
        
    tpresult2 = Tkinter.Toplevel(hf)
    tpresult2.title(' McNoise ')
    tresult2 = ScrolledText(tpresult2, height=20, width=60)
    tresult2.pack()
    tresult2.insert("end",txt)
    
def calc_prob3(minob,maxob,kd):
    # brg 18.09.15, 19.9.15, 27.9.15, 29.9.15
    # prob(first object > 2nd object)
    global ProbtotalGT
    print "minobj = ",minob
    print "maxobj = ",maxob
    print "kd = ",kd
    try:
        nstart = float(enstart.get())
    except:
        nstart = 0
    try:
        nstep = float(enstep.get())
    except:
        nstep = 0.1
    try:
        nend = float(enend.get())
    except:
        nend = 0.5
    print "noise= ",nstart, nstep,nend
    txt = "Input data "+"\n"
    txt+="First object:\t"
    for j in range(0, kd):
        txt+=str(round(xm[j],3))+"\t"
    txt+="\n"
    txt+="Second object:\t"
    for j in range(0,kd):
        txt+=str(round(ym[j],3))+"\t"
    txt+="\n"    
    txt+=50*"="+"\n"
    txt+= "Start probability:   "+"\n"
    txt+=60*"="+"\n"
    txt += "noise - setting "+"\n"
    txt += "start: "+str(nstart)+"\n"
    txt += "Step: "+str(nstep)+"\n"
    txt += "End: "+str(nend)+"\n"
    #noise independent specifications and calculations
    nc = []
    J1 = []
    J2 = []
    for j in range(0, kd):
        if xm[j]<ym[j]:  #xm is considered as first, ym as second element
            J1.append(j)
        else:
            J2.append(j)
    for j in range(0, kd):
        nc.append(1.0*(maxob[j]-minob[j])/(1.0*maxob[j] + 1.0*minob[j]))
    txt+="Char. parameter:"+"\n"
    txt+="crucial noise"+"\n" 
    for j in range(0, kd):
        txt+="attr"+str(j+1)+"\t"
    txt+="\n"
    for j in range(0, kd):
        txt+=str(round(nc[j],3))+"\t"
    txt+="\n"    
    txt+=" J1 "+"\n"
    for el in J1:
        txt+=str(el)+"\t"
    txt+="  J2  "+"\n"
    for el in J2:
        txt+=str(el)+"\t"
    txt+=" Main result "+"\n"
    txt+=60*"-"+"\n"
    # probability that first object < second object, taken all k attributes
    # ...simultaneously and regarding the noise-value        
    probdata = []
    zahl=0
    noise = nstart
    txt += "noise "+"\t"+"  Prob( first object  > second object)" + "\n"
    txt+="\n"
    ProbtotalGT = []
    while noise < nend:
        probhilf = rmod2.vecgen1(kd)
        Z = rmod2.vecgen1(kd)
        pov = rmod2.vecgen1(kd)
        Probtotal1 = 1
        Probtotal2 = 1
        Probtotal = 1
        
        for j in range(0, kd):
            if (1+noise)*minob[j] < (1-noise)*maxob[j]:
                pov[j] = 0
            else:
                Z[j] = minob[j]-maxob[j] + noise*(minob[j] + maxob[j])
                if noise*minob[j]*maxob[j]!=0:
                    pov[j] = 1.0*Z[j]*Z[j]/(4.0*noise*noise*minob[j]*maxob[j])
                else:
                    pov[j] = 0
            if j in J2:      
                Probtotal2 = Probtotal2*(1-0.5*pov[j])
            else:
                Probtotal1 = Probtotal1*0.5*pov[j]
            
        Probtotal = Probtotal1*Probtotal2
        ProbtotalGT.append(Probtotal)
        txt += str(noise) +"\t"+str(round(Probtotal,4))+"\n"
        probdata.append(Probtotal)
        noise += nstep
        zahl+=1
        if zahl > 100:  #internal safety
            break
    names=["noise","prob","prob(first object > second object)"]
    app1 = raioop2.brggraph5(hf,names,"red",3,probdata,nstart,nend)
    app1.ausgabe()
    
        
    tpresult2 = Tkinter.Toplevel(hf)
    tpresult2.title(' McNoise ')
    tresult2 = ScrolledText(tpresult2, height=20, width=60)
    tresult2.pack()
    tresult2.insert("end",txt)
    
def Probincomp():
    # brg 29.9.2015
    try:
        nstart = float(enstart.get())
    except:
        nstart = 0
    try:
        nstep = float(enstep.get())
    except:
        nstep = 0.1
    try:
        nend = float(enend.get())
    except:
        nend = 0.5
    print "noise= ",nstart, nstep,nend
    txt = "Input data "+"\n"
    txt+="First object:\t"
    for j in range(0, kd):
        txt+=str(round(xm[j],3))+"\t"
    txt+="\n"
    txt+="Second object:\t"
    for j in range(0,kd):
        txt+=str(round(ym[j],3))+"\t"
    txt+="\n"    
    txt+=50*"="+"\n"
    txt+= "Start probability:   "+"\n"
    txt+=60*"="+"\n"
    txt += "noise - setting "+"\n"
    txt += "start: "+str(nstart)+"\n"
    txt += "Step: "+str(nstep)+"\n"
    txt += "End: "+str(nend)+"\n"
    print "length LT ",len(ProbtotalLT)
    print "length GT ",len(ProbtotalGT)
    if len(ProbtotalLT) == len(ProbtotalGT):
        txt+="noise"+"\t"+"Prob(first object || second object)"+"\n"
        noise = nstart
        zahl = 0
        Probic = []
        while noise<nend:
            Probic.append(1.0 - ProbtotalLT[zahl] - ProbtotalGT[zahl])
            txt+=str(round(noise,4))+"\t"+str(round(Probic[zahl],4))+"\n"
            zahl += 1
            noise += nstep
        txt+="\n"
        
    else:
        txt+="+++ different lengths of the two probabilities "+"\n"
    tpresultic = Tkinter.Toplevel(hf)
    tpresultic.title(' Prob x|| y')
    tresultic=ScrolledText(tpresultic,width=60,height=10)
    tresultic.pack()
    tresultic.insert("end",txt)
    names=["noise","prob","prob(first object || second object)"]
    app1 = raioop2.brggraph5(hf,names,"red",3,Probic,nstart,nend)
    app1.ausgabe()     
            

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' probobjpair ')
aboutMCnoise = raioop2.brgabout(hf,"tp1","about_probobjpair.txt",4,\
            "Oct., the 03rd, 2015"," about probobjpair ", "white", "t1",80,5,ScrolledText)
aboutMCnoise = raioop2.brgabout(hf,"tp1","help_probobjpair.txt",4,\
            "Oct., the 03rd, 2015"," help_probobjpair ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshowdm = Tkinter.Button(fr, text = "Show dm ",bg="white", width = 40, command = show_file)
buttshowdm.pack()
buttHD = Tkinter.Button(fr, text='Draw HD', width=40, command=HD)
buttHD.pack(pady=5)
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
frhilf = Tkinter.Frame(fr)
frhilf.pack()
lbenc=Tkinter.Label(frhilf, text="Enter a limiting value for nc-min-values (default: 0.1)")
lbenc.pack(side="left")
enc = Tkinter.Entry(frhilf,width=5)
enc.pack(side="right")
buttlistofnc=Tkinter.Button(fr,text="List of all minimal nc-values", bg="cyan",width=40,command=listnc)
buttlistofnc.pack()
frinput = Tkinter.Frame(fr,bd=3, relief="sunken")
frinput.pack()
lb2 = Tkinter.Label(frinput, text="first object:  ")
lb2.pack(side="left")
eob1 = Tkinter.Entry(frinput,width=10)
eob1.pack(side="left")
lb3 = Tkinter.Label(frinput, text="second object:  ")
lb3.pack(side="left")
eob2 = Tkinter.Entry(frinput, width=10)
eob2.pack(side="left")
frdirect = Tkinter.Frame(fr, relief="sunken",bd=3)
frdirect.pack()
lbdirect1=Tkinter.Label(frdirect,text="How many attributes ")
lbdirect1.pack(side="left")
ek = Tkinter.Entry(frdirect,width=10)
ek.pack(side="left")
buttsubmitek=Tkinter.Button(frdirect,text="submit the number of attributes ",bg="cyan",width=40, command = submitek)
buttsubmitek.pack(side="left")
lb4 = Tkinter.Label(fr, text = "Enter noise in fractions (0...1)")
lb4.pack()
frnoise = Tkinter.Frame(fr, bd=3,relief="sunken")
frnoise.pack()
lb5 = Tkinter.Label(frnoise,text="Enter noise-start, ..-step, ..-end")
lb5.pack(side="left",pady=5)
enstart=Tkinter.Entry(frnoise, width=5)
enstart.pack(side="left")
enstep=Tkinter.Entry(frnoise, width=5)
enstep.pack(side="left")
enend=Tkinter.Entry(frnoise, width=5)
enend.pack(side="left")
butttakevalues2=Tkinter.Button(fr, text="Read in: prob(first object < second object ",bg="cyan",width=40,state="disabled",command=takevalues2)
butttakevalues2.pack()
butttakevalues3=Tkinter.Button(fr, text="Read in: prob(first object > second object ",bg="cyan",width=40,state="disabled",command=takevalues3)
butttakevalues3.pack()
butttakevalues4=Tkinter.Button(fr, text="Read in: prob(first object || second object ",bg="cyan",width=40,state="disabled", command=Probincomp)
butttakevalues4.pack()
buttprobcalc = Tkinter.Button(fr, text = "probability calculation (file-related)", width = 40, bg="cyan", state ="disabled", command = calc_prob)
buttprobcalc.pack()
buttprobcalc2 = Tkinter.Button(fr, text = "Prob(first obj || second obj) (file related)", width = 40, bg = "cyan", state="disabled", command = calc_probic)
buttprobcalc2.pack()
lbresult = Tkinter.Label(fr, text ="")
lbresult.pack()
buttexit = Tkinter.Button(fr, text='exit', bg='red',
                          width= 40, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
