# -*- coding: cp1252 -*-
import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2
import csv
from string import replace
import copy

#Brg 17.1.08 sensi3.py with graphics, 4.2.08
# Brg 9.9.2013 from sensitivity19_1 a simple and heavily reduced version is
#              derived.
# 25.11.2013
# 26.1.2014 cosmetics
# 26.3.2014 improvement of rendering the results
# 19.10.16 Discrepancy to the results with sensitivity23_1.py !!!!
# Used matrix: material100_10b.txt (of Akter, TU Berlin)

def about():
    """ About sensi """
    # Brg 16.8.08
    aboutsensi=raioop2.brgabout(hf,"tp2","about_sensisimpl.txt",1,\
            "Nov. , the 25th,2013"," about_sensisimple ", "white", "t2",120,3,ScrolledText)
    

def raihelp():
    """ Help about sensi """
    
    #  Use of OOP
    helpsensi=raioop2.brgabout(hf,"tp1","help_sensisimpl.txt",1,\
            "Nov., the 25th,2013"," help_sensisimple ", "white", "t1",120,10,ScrolledText)




###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
def xsave_in_PyHasseformat_n():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    xn=rmod2.matrixnorm(r,k,x)

    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=xn[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save normalized dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global fn, r,k,obj,prop,x,xred,rred,objred,dm
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)
    #print "rred ",rred
    #print "Matrix "
    #rmod2.matout(r,k,xred)

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)




def xfileopen():
    "Informs about the file-operations"
    # Excelreadin6 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08
    global fn,r,k,x,prop,obj,rred,xred,objred
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   #recoding, because pr[0] is a dummy string
    #rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)   #6.8.2013

    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred
    
    r,k,dm,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txt,neq=rmod2.equivcompactm(r,k,x,obj)    

##### end of editenster ### 29.8.2013 ####




def showDM():
    """shows the DM"""
    # taken from fuzzyHD7
    tp2a=Tkinter.Toplevel(hf)
    tp2a.title(' show DM ')
    lbtp2=Tkinter.Label(tp2a,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2a,width=60,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def HD():
    # brg 26.7.2013, 29.8.2013
    
    global x,la,ls,zeta
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()

        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,r):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is covered by "
        for j in range(0,r):
            if i!=j:
                if zeta[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)


def extract3(r,zetah,i):
    """extracts from the crisp matrix the order relations"""
    #brg 30.11.07, 11.4.08, 16.8.08 taken from fuzzyHD10, 4.10.08, 18.3.2014
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    ec=rmod2.dmcompress(r,r,zetah)             #30.11. from cq the equivalent relations
    eqtext=""
    eqtext+=rmod2.eqcguiout1(r,ec,obj)        #30.11. matrix output
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    #print "======================================="
    #print " Control in extract (ex) "
    #print "======================================="
    ltxt=len(txt)
    #print "ex1: ec : ",ec
    #print "ex1: txt , ltxt",txt," ",ltxt
    
    b=rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    if b=="true":
        texteq="No equivalent objects in case "+str(i)
    else:
        texteq="Case "+str(i)+": Equivalent objects"
    
        
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,zetah) # columns eliminated
    zeta,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
        #print "ex4: Reduz. Liste der Objekte (objec in modul extract) ",objec
        #print "ex5: rs = ",rs
    return zeta,objec,rs
    

def calc():
    """calculates sensitivity """
    #Brg 17.1.08, 16.8.08
    #*17.1.08
    #akt: 16.8.08, 18.3.2014
    #note: 
    #source:    main body taken from sensi1.py
    

    global di,disort,prot,newcase,inco,utot,pib,n,case
    case=rmod2.preparcases(k)
    #print "case = ",case
    di=rmod2.vecgen1(k+1)
    disort=rmod2.vecgen1(k+1)
    di[0]=0
    #di is the distance vector based on zeta-matrix-comparisons
    zeta0=rmod2.comp(r,k,x)
    n0=len(zeta0)
    #print "Dim of zeta0 = ",n0
    tpcase=rmod2.vecgen1(k)   #16.8.08
    nvec = []
    for j in range(1, k+1):
        zetah=rmod2.comp3(r, k, case, j, x)  #zetah may contain equivalent rows/columns
        nh=len(zetah)
        #print "i= ",j,"   Dim of zetah ",nh
        #print "zetah= "
        #rmod2.matout(r,r,zetah)
        #print " "
        zeta1,objred,n=extract3(r,zetah,j)  #important step, modified procedure: 4.10.08
        nvec.append(n)
        zeta=rmod2.marray(n,n)
        for i2 in range(0,n):
            for i3 in range(0,n):
                zeta[i2][i3]=zeta1[i3][i2]
                
        
        

        # Note: Distances are based on object set (equivalent elements will be counted too)    
        di[j]=rmod2.posetdistanz(r,zeta0,zetah)
    dicopy = copy.deepcopy(di)          
    #print "Distances: ",di   ## muss als Ergebnis dargestellt werden
    #print "Dim of the zeta matrices: ",nvec 
    
    
    dibar=rmod2.vecgen1(k)
    for i in range(1,k+1):
        dibar[i-1]=di[i]
    #print "dibar = ",dibar
    prop1=rmod2.vecgen1(k)
    for j in range(0,k):
        prop1[j]=prop[j]  #necessary because in brgbar8 prop will be overwritten
    
    gr=raioop2.brgbar8(hf,dibar,prop1,"sensitivity1")
    gr.ausgabe()
    ##################################################################################################
    disort,prot=rmod2.raisort(k+1,di)

    #new cases according to the importance
    utot=rmod2.vecgen1(k)
    pib=rmod2.vecgen1(k)
    newcase=rmod2.marray(k,k)
    for i7 in range(0,k):
        for j in range(0,k):
            newcase[i7][j]=-1


    for i7 in range(0,k):
        zaehl=0
        for j in range(i7+1,k+1):
            newcase[i7][zaehl]=prot[j]
            zaehl+=1
    
    # newcase: first line all attributes sorted according to increasing importance
    #          second line the least important arribute removed
    #          third line: the next less important attribute removed etc
    #          ...
    #          last line: the most important attribut
    #          note the corresponding indexes
    #print newcase
    for i7 in range(0,k):
        objx=rmod2.comp4(r,k,newcase,i7,x) 
        redobjx=rmod2.marray(r,r)
        quobx=rmod2.marray(r,r)
        unit=rmod2.matunit(r)
        
        rmod2.matadd(r,1.0,objx,-1.0,unit,redobjx)

        rmod2.qualcomp(r,objx,quobx)
        inco=rmod2.marray(r,r)    
        inco=rmod2.rai_inc(r,quobx)
        z=0
        zsel=0
        for i1 in range(0,r):
            for j in range(0,r):
                if inco[i1][j]!=-1:
                    z+=1
                    
                      
        utot[i7]=1.0*z/2.0
        pib[i7]=2.0*utot[i7]/(r*(r-1))
        pib[i7]=round(pib[i7],2)
    #Results in a textbox
    tpsensi = Tkinter.Toplevel(hf)
    tpsensi.title(" Results of sensitivity1 ")
    tsensi = ScrolledText(tpsensi,width=80, height=5)
    tsensi.pack()
    txt = "Sensitivity analysis "+"\n"
    txt += "File = "+fn +"\n"
    txt += 60*"=" + "\n"
    for j in range(0, k):
        txt += str(prop[j])+"\t"+":"+str(dicopy[j+1])+"\n"
    txt += "\n"
    txt += "Fraction of incomparability "+"\n"
    txt += 60*"=" + "\n"
    for j in range(0, k):
        txt += "fr(incomp) = "+"\t" + str(round(pib[j],3)) + "\n"
    txt += " -- - -  e o f  - - - "
    tsensi.insert("end",txt)
                    
def calc2():
    #brg 3.2.2017
    zeta0=rmod2.comp(r,k,x)
    # transpoosition zo get the <= relation
    zeta=rmod2.marray(r,r)
    for i1 in range(0,r):
        for i2 in range(0,r):
            zeta[i1][i2]=zeta0[i2][i1]
    #        
    print "zeta = "
    rmod2.matout(r,r,zeta)
    di2=rmod2.vecgen1(k)
    txt="Sensitivity study "+"\n"
    txt+=50*"="+"\n"
    for j in range(0,k):
        print "j = ",j, "   corresponding zeta: "
        zetaattr=[]
        for i1 in range(0,r):
            zetaattr.append(0)
            zetaattr[i1]=[]
            for i2 in range(0,r):
                if x[i1][j]<=x[i2][j]:
                    zetaattr[i1].append(1)
                else:
                    zetaattr[i1].append(0)
        rmod2.matout(r,r,zetaattr)
        print " "
        txt+=str(prop[j])+"\t"
        di2[j]=rmod2.posetdistanz(r,zeta,zetaattr)        
        txt+=" Distance2 = " +str(di2[j])+"\n"
        txt+="\n"
    tpdistance2=Tkinter.Toplevel(hf)
    tpdistance2.title("single indicator compared\nwith complete set ")
    tdistance2=ScrolledText(tpdistance2,width=60,height=10)
    tdistance2.pack()
    tdistance2.insert("end",txt)
    
hf=Tkinter.Tk()
hf.title('sensitivitysimpl')
about()
raihelp()
lbhallo=Tkinter.Label(hf,text="",width=60)
lbhallo.pack()
fropen=Tkinter.Frame(hf,width=60,height=40,relief="sunken",bd=2)
fropen.pack()
lbopen1=Tkinter.Label(fropen,text="")
lbopen1.pack()
buttfileselect=Tkinter.Button(fropen,text="select & open file ",width=25, bg="white",command=xselectfile)
buttfileselect.pack()
frshow=Tkinter.Frame(hf,width=60,height=4,relief="sunken",bd=2)
frshow.pack(fill="x")
buttshow=Tkinter.Button(frshow,text="show data matrix ",width=25,command=showDM)
buttshow.pack(pady=5)
buttHD=Tkinter.Button(frshow,text="show  HD ",width=25,command=HD)
buttHD.pack(pady=5)
frcalc=Tkinter.Frame(hf,relief="sunken",bd=2)
frcalc.pack()
lbcalc1=Tkinter.Label(frcalc, text=" Global calculation (for all objects) \nEach indicator within the context of m-1 other indicators")
lbcalc1.pack()
##frindic=Tkinter.Frame(frcalc)
##frindic.pack()

buttcalc=Tkinter.Button(frcalc,text=" Global calculate1",bg="cyan",width=35,command=calc)
buttcalc.pack(pady=10)
lbcalc2=Tkinter.Label(frcalc, text=" Global calculation (for all objects) \nEach indicator compared with the totality of all m indicators")
lbcalc2.pack()
buttcalc2=Tkinter.Button(frcalc,text=" Global calculate2",bg="cyan",width=35,command=calc2)
buttcalc2.pack(pady=10)
buttsave=Tkinter.Button(frcalc,text="Save the original matrix in PyHasse format ",bg="cyan",width=35,command=xsave_in_PyHasseformat)
buttsave.pack()
buttsaven=Tkinter.Button(frcalc,text="Save normalized matrix in PyHasse format ",bg="cyan",width=35,command=xsave_in_PyHasseformat_n)
buttsaven.pack()
buttexit=Tkinter.Button(hf,text="  Exit  ",bg="red",width=35,command=hf.destroy)
buttexit.pack(pady=5)
hf.mainloop()
