import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import math
import time
import Canvas
import os


#  brg  6.6.09
# es fehlt noch eine gute Ergebnisdarstellung 6.6.09, 21.30
#  brg 7.6.09 now a results textbox is available
# 17.10.09 several slight changes
# 10.1.2010 new: exploration
# 7.3.2010 more details about separation
# 8.3.2010 Cosmetics
# 10.3.2010 Extension: A bipartite graph is obtained and from this a minimal number of attr. pairs
#           is selected, which explain the separation
# 10.3.2010 HD of objects of sep sets
#           reduced matching diagram
# 13.3.2010 scatterplot of one optimal attribute pair and objects of sep sets.
# 16.6.10 rename into sepanal1.py
# Juli: sepanal2.py with tripartite graph
# 7.8.10: Individual Analysis of tripartite graph
# 8.8.10: Reduction of tripartite graph
# 10.8.10: Partitioning
# 12.8.10: sepanal8.py major changes
# 22.8.10: Complete reorganisation based on the series seppairs<i>.py:   sepanal12
# 4.9.10: new: brgbar8 as histogram. Major revision to sepanal14
# 18.9.2010: Equivelence classesof reduced tripartite graph: sepanal15.py
# 28.9.2010 corrections in co6
# 5.10.2010 A deep bug was eliminated: sepanal15_2
# 25.10.2010: Some confusing texts eliminated
# 23.11.2010 All scrolled text fields now with extended functionality
# 15.01.18 Table of tripartite graph

def submit():
    global x1,x2
    x1,x2=inread()
    txtresult=""
    for ob1 in x1:
        for ob2 in x2:
            txtresult+="("+ob1+","+ob2+") "
    lbresult.config(text=txtresult)        
            

def storeset(i,x):
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save set "+str(i))
    fl=storeprocess(fn,x,i)

    if fl>0:
        txtstore="set stored in file: \n"+fn
        
    else:
        txtstore="+++ unfortunately not successful +++ " 
    lbstore.config(text=txtstore,bg="yellow")

def store1():
    i=1
    storeset(i,x1)

def store2():
    i=2
    storeset(i,x2)

def store3():
    i=2
    storeset(i,x2)


def storeprocess(fn,x,i):
    #Brg 4.9.10
    flag=0
    y,m,d,h=time.localtime()[0:4]
    try:
        f=open(fn,'w')
        f.write(fn+":   "+str(i)+"  data: "+str(y)+" "+str(m)+" "+str(d)+" "+str(h)+"\n")
        for ob in x:
            f.write(ob+",")
        f.close()
        flag=1
    except:
        flag=0
    return flag

def set_inprocess(fn):
    #Brg 4.9.10
    #global x1,x2
    f=open(fn,'r')
    s=f.readline()
    
    s2=f.readline()
    
    return s,s2

def set_in1():
    # brg 4.9.10
    global x1
    fn=tkFileDialog.askopenfilename(parent=hf,title="open ")
    sact,sact2=set_inprocess(fn)
    print "sact = ",sact
    print "sact2 = ",sact2
    hilf=sact2.split(',')
    x1=set([])
    for ob in hilf:
        if ob=="" or ob==" " or ob==",":
            pass
        else:
            x1.add(ob)
    print x1    
    

def set_in2():
    global x2
    fn=tkFileDialog.askopenfilename(parent=hf,title="open ")
    sact,sact2=set_inprocess(fn)
    print "sact = ",sact
    print "sact2 = ",sact2
    hilf=sact2.split(",")
    x2=set([])
    for ob in hilf:
        if ob=="" or ob==" " or ob==",":
            pass
        else:
            x2.add(ob)
    print x2    
    


def show_sets():
    #brg 4.9.10
    txtresult=""
    for ob1 in x1:
        for ob2 in x2:
            txtresult+="("+ob1+","+ob2+") "
    lbshow.config(text=txtresult)     


def file_issues():
    #brg 4.9.10
    global lbopen1
    tpfile=Tkinter.Toplevel(hf)
    tpfile.title(' open/save ')
    lbopen1=Tkinter.Label(tpfile,text="")
    lbopen1.pack()
    fr1=Tkinter.Frame(tpfile)
    fr1.pack()
    buttf1=Tkinter.Button(fr1,text="select & open file & HD ",width=30,bg="cyan",command=fileselect)
    buttf1.pack()
    Buttshow=Tkinter.Button(fr1,text="show data matrix",width=30,command=showDM)
    Buttshow.pack(pady=5)
    buttexit=Tkinter.Button(tpfile,text=" Exit  ",bg="red", width=30,command=hf.destroy)
    buttexit.pack(pady=10)
    
    Buttset.config(state="active")

def setoperat():
    global ex1,ex2,ex3,lbresult,lbshow,lbstore
    tpset=Tkinter.Toplevel(hf)
    tpset.title(' sets new, load, store ')
    fr2a=Tkinter.Frame(tpset)
    fr2a.pack(pady=5)
    fr2b=Tkinter.Frame(tpset)
    fr2b.pack(pady=5)
    fr2c=Tkinter.Frame(tpset)
    fr2c.pack(pady=10)
    fr3a=Tkinter.Frame(tpset)
    fr3a.pack()
    fr1=Tkinter.Frame(tpset,relief="sunken",bd=2)
    fr1.pack()
    frselect=Tkinter.Frame(fr1)
    frselect.pack()
    labex1=Tkinter.Label(frselect,text="Select the objects of set 1 >>>")
    labex1.pack(side="left")
    ex1=Tkinter.Entry(frselect,width=30)
    ex1.pack(side="left")
    buttstore1=Tkinter.Button(frselect,text="save set1",command=store1)
    buttstore1.pack(side="left")
    fr2=Tkinter.Frame(fr1,relief="sunken",bd=3)
    fr2.pack()
    labex2=Tkinter.Label(fr2,text="Select the objects of set 2 >>>")
    labex2.pack(side="left")
    ex2=Tkinter.Entry(fr2,width=30)
    ex2.pack(side="left")
    buttstore2=Tkinter.Button(fr2,text="save set2",command=store2)
    buttstore2.pack(side="left")
    fr3=Tkinter.Frame(fr1,relief="sunken",bd=2)
    fr3.pack()
    labex3=Tkinter.Label(fr3,text="set 2: All objects except.... >>>")
    labex3.pack(side="left")
    ex3=Tkinter.Entry(fr3,width=30)
    ex3.pack(side="left")
    buttstore3=Tkinter.Button(fr3,text="save set2",command=store3)
    buttstore3.pack(side="left")
    butt2=Tkinter.Button(tpset,text="submit your selection ",bg="cyan",command=submit)
    butt2.pack()
    lbresult=Tkinter.Label(tpset,text="")
    lbresult.pack()
    lbstore=Tkinter.Label(tpset,text="")
    lbstore.pack()
    fropen=Tkinter.Frame(tpset,relief="groove",bd=4)
    fropen.pack()
    buttopen1=Tkinter.Button(fropen,text = "open set 1 ",command=set_in1)
    buttopen1.pack()
    buttopen2=Tkinter.Button(fropen,text = "open set 2 ",command=set_in2)
    buttopen2.pack()
    buttshow=Tkinter.Button(fropen,text=" show the pairs ",command=show_sets)
    buttshow.pack()
    lbshow=Tkinter.Label(fropen,text="")
    lbshow.pack()

    buttexit=Tkinter.Button(tpset,text=" Exit  ",bg="red", width=30,command=hf.destroy)
    buttexit.pack(pady=10)
    Buttsep.config(state="active")




def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08, 28.5.09
    #note: Taken from antag
    #source:-
    
    global fn,k0,r,dm,pro,ob,prop,obj,xred,objred,rred
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k0=rmod2.EXCELreadin4(fn)
    lbopen1.config(bg="yellow")
    lbopen1["text"]="sel. file : "+fn+"\n"+str(r)+" rows\n"+str(k0)+" columns"
    prop=rmod2.vecgentext1(k0)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k0):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################this part is of 21.12.07 #########
    rred,xred,objred,txt=rmod2.equivcompact(r,k0,dm,obj)    
    ###############################################################
    global ex1,ex2,ex3,echar
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    
    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    n=rred
    tpeqorig=Tkinter.Toplevel(hf)
    tpeqorig.title(' equivalence classes of the original DM ')
    teqorig=ScrolledText(tpeqorig,width=60,height=5)
    teqorig.pack(expand="yes",fill="both")
    teqorig.insert("end",txt)
    #
    zetahilf=rmod2.comp(n,k0,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
            
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack(expand="yes",fill="both")
    txt1="\n"
    levmax=-10**20
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
    tpbasic2=Tkinter.Toplevel(hf)
    tpbasic2.title(' basic characteristics of the orig HD ')
    lbbasic2=Tkinter.Label(tpbasic2,text="number of level: \t\t\t"+str(zzmax)+"\n\
number of representants in the largest level:\t "+str(levmax),bd=3,bg="yellow",width=60)
    lbbasic2.pack()
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt2="\n One linear extension \n\n"
    for i in range(0,n):
        if i<n-1:
            txt2+=objred[revlext[i]]+" < "
        else:
            txt2+=objred[revlext[i]]+"\n"
    txt2+="\n"
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    global zeta2
    zeta2=rmod2.cover(n,tr,lext)
    
    if n>100:
        cover_show()                  #20.1.08
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(n,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        
        
        
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(factory/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    n=rred
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack(expand="yes",fill="both")
    tcov.insert("end",txt3)


def geomHD(zv, levm,zlev):
    """ from zv the graphical control for HDs is derived """
    #zv is the number of vertices
    # levm is the number of vertices in the maximal level (determines the x coord
    # zlev is the number of levels, determines the y coord
    # * Brg 10.6.08
    # akt: 29.5.09
    # brg 10.6.08, 29.5.09
    # taken from interval4.py
    awidth=zv*40
    aheight=zv*40
    if awidth<120:
        awidth=120
    if awidth>600:
        awidth=600
    if aheight<120:
        aheight=120
    if aheight>600:
        aheight=600
    
    #aheight and awidth: extent of canvas
    fx = int((awidth-40))
    fy = int((aheight-40))
    g0x=5   #Start of the HD-area x
    g0y=20   #Start of the HD-area y
    garr1x=fx +10.0  #location of the arrow
    garr1y=20
    garr2y=fy+10.0
    return awidth,aheight,fx,fy,g0x,g0y,garr1x,garr1y,garr2y            
         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack(expand="yes",fill="both")
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
   

def inread():
    #brg 13.8.10
    x1=set(ex1.get().split(","))
    #print "x1= ",x1
    xhilf=set(ex3.get().split(","))
    #print "xhilf= ",xhilf
    if xhilf!=set(['']):
        x2=set([])
        for ob in objred:
            x2.add(ob)
        x2=x2-xhilf
    else:
        x2=set(ex2.get().split(","))
    #print "xhilf = ",xhilf    
    #print "x2= ",x2    
    return x1,x2

def separation():
    # brg 6.6.09, 22.8.10 (completely new),4.9.10
    global eattr,mixing,mixmax,nopaths,nopathspercent,rowsum1,rowsum2,rowsum3,listprop
    global eob1,eob2,listpaar,xmatrixtotal,matrix1,matrix2,x1,x2,eatt1,eobx,esetpos,lenx1x2
##    x1,x2=inread()
    # basic material: matrix1,matrix2, adjmat
##    print "In Separation "
##    print "x1= ",x1
##    print "x2 = ",x2
##    print "objred= ",objred
    lenx1x2,k0,listpaar,matrix1,xmatrix1=rmod2.matrixfirstgreatersecond(x1,x2,rred,xred,objred,prop)

    print "xmatrix1 "
    rmod2.matout(k0,lenx1x2,xmatrix1)
    
    rowsum1=rmod2.matrixrowsum(matrix1,k0,lenx1x2)
    for i in range(0,k0):
        rowsum1[i]=100.0*rowsum1[i]/lenx1x2
    
    lenx1x2,k0,listpaar,matrix2,xmatrix2=rmod2.matrixfirstlesssecond(x1,x2,rred,xred,objred,prop)

    print "xmatrix2 "
    rmod2.matout(k0,lenx1x2,xmatrix2)
    
    rowsum2=rmod2.matrixrowsum(matrix2,k0,lenx1x2)
    for i in range(0,k0):
        rowsum2[i]=100.0*rowsum2[i]/lenx1x2


    lenx1x2,k0,listpaar,matrix3=rmod2.matrixfirstequalsecond(x1,x2,xred,objred,prop)
    rowsum3=rmod2.matrixrowsum(matrix3,k0,lenx1x2)
    for i in range(0,k0):
        rowsum3[i]=100.0*rowsum3[i]/lenx1x2
    #print " "

    lprop,listprop=rmod2.make_listpaars_except_diag(prop)
##    for i in range(0,int(lprop)):
##        print "i= ",i,"  ",listprop[i][1],",",listprop[i][2]

    matrix2t=rmod2.marray(lenx1x2,k0)
    for k in range(0,k0):
        for i in range(0,lenx1x2):
            matrix2t[i][k]=matrix2[k][i]

    adjmat=rmod2.matmult1(k0,lenx1x2,matrix1,lenx1x2,k0,matrix2t)
    #rmod2.matout(k0,k0,adjmat)

    # number of paths from qi inducing x > y   to qj inducing x < y
    
    nopaths=[]
    z=0
    for k1 in range(0,k0):
        for k2 in range(0,k0):
            if k1!=k2:
                nopaths.append(adjmat[k1][k2])
                z+=1

    lnopaths=len(nopaths)
    maxnopaths=max(nopaths)
    nopathspercent=[]
    for i in range(0,lnopaths):
        nopathspercent.append(100.0*nopaths[i]/(1.0*lenx1x2))
        
    lprop2,matrixtotal=rmod2.matrixsep(matrix1,matrix2,lenx1x2,k0)
##    print lprop2
##    print "matrix total "
##    rmod2.matout(int(lprop2),lenx1x2,matrixtotal)
    lprop2,xmatrixtotal=rmod2.xmatrixsep(xmatrix1,xmatrix2,lenx1x2,k0)
    #rmod2.matout(int(lprop2),lenx1x2,xmatrixtotal)

    # mixing character 28.6.2015 single contributions depend
    # on the order, by which the elements are given.
    leftprop=[]
    rightprop=[]
    for k in range(0,k0):
        hilf1=0
        hilf2=0
        for i in range(0,lenx1x2):
            hilf1+=matrix1[k][i]
            hilf2+=matrix2[k][i]
        leftprop.append(hilf1)
        rightprop.append(hilf2)
        
        
   
    mixing=[]
    mixmax=math.floor(k0*k0/4.0)
    print " "
    print "adjmatrix1"
    rmod2.matout(k0,lenx1x2,matrix1)
    print "adjmatrix2"
    rmod2.matout(k0,lenx1x2,matrix2)
    print "xmatrixtotal "
    lkprop=k0*(k0-1)
    rmod2.matout(lkprop,lenx1x2,xmatrixtotal)
    print "leftprop = ", leftprop
    print "rightprop= ", rightprop 
    for k in range(0,k0):
        mixing.append(leftprop[k]*rightprop[k]/(1.0*mixmax))
        
            
    # Result nopaths, mixing , rowsum1, rowsum2,rowsum3                
    # Main result: Tripartite graph
    tptrip=Tkinter.Toplevel(hf,bg="white")
    tptrip.title(' tripartite graph  ')
    tpdetails=Tkinter.Toplevel(hf)
    tpdetails.title('    details - paneel ')
    lbdetails=Tkinter.Label(tpdetails,text="Results beyond tripartite graph: ",width=60)
    lbdetails.pack()
    butt1=Tkinter.Button(tpdetails,text="x>y-statistics ",width=30,bg="cyan",command=co1)
    butt1.pack()
    butt2=Tkinter.Button(tpdetails,text="x<y-statistics ",width=30,bg="cyan",command=co2)
    butt2.pack()
    butt3=Tkinter.Button(tpdetails,text="x=y-statistics ",width=30,bg="cyan",command=co3)
    butt3.pack()
    butt4=Tkinter.Button(tpdetails,text="mixing ",width=30,bg="cyan",command=co4)
    butt4.pack()
    butt5=Tkinter.Button(tpdetails,text="count of paths ",width=30,bg="cyan",command=co5)
    butt5.pack()
    butt6=Tkinter.Button(tpdetails,text="reduction of tripartite graph ",width=30,bg="cyan",bd=4,command=co6)
    butt6.pack()
    frind=Tkinter.Frame(tpdetails,width=80,relief="sunken",bd=4)
    frind.pack(fill="x")
    
    labind=Tkinter.Label(frind, text="first object, second object >>>")
    labind.pack(side="left")
    eob1=Tkinter.Entry(frind,width=4)
    eob1.pack(side="left")
    eob2=Tkinter.Entry(frind,width=4)
    eob2.pack(side="left")
    butt7a=Tkinter.Button(frind,text="indiv analysis/objects ",bg="cyan",command=co7)
    butt7a.pack(side="right",fill="x")
    frind2=Tkinter.Frame(tpdetails,relief="sunken",bd=4)
    frind2.pack(pady=5,fill="x")
    labind2=Tkinter.Label(frind2, text="actual attribute >>>")
    labind2.pack(side="left")
    eatt1=Tkinter.Entry(frind2,width=6)
    eatt1.pack(side="left")
    butt7b=Tkinter.Button(frind2,text="indiv analysis/attr. ",bg="cyan",command=co7b)
    butt7b.pack(side="right",fill="x")
    frind3=Tkinter.Frame(tpdetails,width=80,relief="sunken",bd=4)
    frind3.pack(fill="x")
    labind3=Tkinter.Label(frind3, text="object, of first or second set >>>")
    labind3.pack(side="left")
    eobx=Tkinter.Entry(frind3,width=4)
    eobx.pack(side="left")
    
    butt7c=Tkinter.Button(frind3,text="indiv analysis/objects ",bg="cyan",command=co7c)
    butt7c.pack(side="right",fill="x")
##    butt8=Tkinter.Button(tpdetails,text="scatterplots ",width=30,command=scatter)
##    butt8.pack()
    butt9=Tkinter.Button(tpdetails,text="HD of sepsets (control) ",width=30,bg="cyan",command=HDsep)
    butt9.pack()
    butt10=Tkinter.Button(tpdetails,text="x>y,x<y statistics\n excluding ordered pairs ",width=30,bg="cyan",command=sepstat)
    butt10.pack()
    buttexit=Tkinter.Button(tpdetails,text="  Exit ",bg="red",width=10,bd=4,command=hf.destroy)
    buttexit.pack(pady=10)
    cv=Tkinter.Canvas(tptrip,width=400,height=400,bg="white")
    cv.config(scrollregion=(0,0,1000,1000)) 
    cv.config(highlightthickness=1)
    t="0123456789"
    tt=7*t
    lb1=Tkinter.Label(cv,text=tt,bg="yellow")
    lb1.pack()


    sbary=Tkinter.Scrollbar(cv,orient="vertical")
    sbary.config(command=cv.yview) 
    cv.config(yscrollcommand=sbary.set) 
    sbary.pack(side="right", fill="y")
    cv.pack(side="left",expand="yes",fill="both")
    pos1=rmod2.marray(k0,2)
    pos2=rmod2.marray(lenx1x2,2)
    pos3=rmod2.marray(k0,2)
    ct01=cv.create_text(130,40,text=" x > y ")
    ct02=cv.create_text(270,40,text=" x < y ") 
    for k in range(0,k0):
        pos1[k][0]=75
        pos3[k][0]=325
        pos1[k][1]=60+20*k
        pos3[k][1]=60+20*k
    for i in range(0,lenx1x2):
        pos2[i][0]=200
        pos2[i][1]=60+20*i

    for j in range(0,k0):
        xx=pos1[j][0]
        yy=pos1[j][1]
        ct1=cv.create_text(xx,yy,text=prop[j])

        xx2=pos3[j][0]
        yy2=pos3[j][1]
        ct2=cv.create_text(xx2,yy2,text=prop[j])

    for i in range(0,lenx1x2):
        xx1=pos2[i][0]
        yy1=pos2[i][1]
        ctp=cv.create_text(xx1,yy1,text="("+str(listpaar[i][1])+","+str(listpaar[i][2])+")")

    for k in range(0,k0):
        for i in range(0,lenx1x2):
            if matrix1[k][i]==1:
                line1=cv.create_line(pos1[k][0]+15,pos1[k][1],pos2[i][0]-20,pos2[i][1],fill="red")
            if matrix2[k][i]==1:
                line2=cv.create_line(pos3[k][0]-15,pos3[k][1],pos2[i][0]+20,pos2[i][1],fill="blue")



def co1():
    #brg 22.8.10
    # set1 > set2
    tpco1=Tkinter.Toplevel(hf)
    tpco1.title(' x of set1    >    y of set2  ')
    tco1=ScrolledText(tpco1,width=80,height=5)
    tco1.pack(expand="yes",fill="both")
    txtco1="x of set1 > y of set2"+"\n"
    txtco1+=60*"="+"\n"
    txtco1+="\t"
    for k in range(0,k0):
        txtco1+=prop[k]+"\t"
    txtco1+="\n"
    txtco1+="x>y: \t"
    for k in range(0,k0):
        txtco1+=str(round(rowsum1[k],2))+"\t"
    txtco1+="\n     - e  o  f  - - -"
    tco1.insert("end",txtco1)
    prop1=rmod2.veccopy(k0,prop)
    app1=raioop2.brgbar8(tpco1,rowsum1,prop1," x (set1) > y (set2) ")
    app1.ausgabe()

def co2():
    #brg 22.8.10, 4.9.10
    # set1 < set2
    tpco2=Tkinter.Toplevel(hf)
    tpco2.title(' x of set1    <    y of set2  ')
    tco2=ScrolledText(tpco2,width=80,height=5)
    tco2.pack(expand="yes",fill="both")
    txtco2="x of set1 < y of set2"+"\n"
    txtco2+=60*"="+"\n"
    txtco2+="\t"
    for k in range(0,k0):
        txtco2+=prop[k]+"\t"
    txtco2+="\n"
    txtco2+="x<y: \t"
    for k in range(0,k0):
        txtco2+=str(round(rowsum2[k]))+"\t"
    txtco2+="\n     - e  o  f  - - -"
    tco2.insert("end",txtco2)
    prop1=rmod2.veccopy(k0,prop)
    app2=raioop2.brgbar8(tpco2,rowsum2,prop1," x < y  ")
    app2.ausgabe()

def co3():
    #brg 22.8.10, 4.9.10
    # set1 = set2
    tpco3=Tkinter.Toplevel(hf)
    tpco3.title(' x of set1    =    y of set2  ')
    tco3=ScrolledText(tpco3,width=80,height=5)
    tco3.pack(expand="yes",fill="both")
    txtco3="x of set1 = y of set2"+"\n"
    txtco3+=60*"="+"\n"
    txtco3+="\t"
    for k in range(0,k0):
        txtco3+=prop[k]+"\t"
    txtco3+="\n"
    txtco3+="x=y: \t"
    for k in range(0,k0):
        txtco3+=str(round(rowsum3[k],2))+"\t"
    txtco3+="\n     - e  o  f  - - -"
    tco3.insert("end",txtco3)
    prop1=rmod2.veccopy(k0,prop)
    app3=raioop2.brgbar8(tpco3,rowsum3,prop1," x (set1) = y (set2) ")
    app3.ausgabe()


def co4():
    #brg 22.8.10 mixing, mixingpercent  (100% = number of objpairs)
    tpco4=Tkinter.Toplevel(hf)
    tpco4.title('  mixing degree   ')
    tco4=ScrolledText(tpco4,width=80,height=5)
    tco4.pack(expand="yes",fill="both")
    txtco4=" mixing degree \n(maximal mixing (Turan theorem) within set1 and set2 = "+str(mixmax)+")\n"
    txtco4+=60*"="+"\n"
    txtco4+="\t"
    for k in range(0,k0):
        txtco4+=prop[k]+"\t"
    txtco4+="\n"
    txtco4+="mix: \t"
    for k in range(0,k0):
        txtco4+=str(round(mixing[k],3))+"\t"
    txtco4+="\n"
    
    txtco4+="\n     - e  o  f  - - -"
    tco4.insert("end",txtco4)
    prop1=rmod2.veccopy(k0,prop)
    app4=raioop2.brgbar8(tpco4,mixing,prop1," mixing degree in % ")
    app4.ausgabe()

def co5():
    #brg 22.8.10 no of paths left vertices right vertices
    #brg 15.01.18  How often causes qi: x>y snd how often x<y
    tpco5=Tkinter.Toplevel(hf)
    tpco5.title('  path analysis   ')
    tco5=ScrolledText(tpco5,width=80,height=5)
    tco5.pack(expand="yes",fill="both")
    txtco5=" number of paths LHS-RHS of tripartite graph: \n\
    Intensity of separation (ios)"+"\n"
    txtco5+=60*"="+"\n"
    txtco5+="\t"
    for k in range(0,len(listprop)):
        txtco5+="("+str(listprop[k][1])+","+str(listprop[k][2])+"}"+"\t"
    txtco5+="\n"
    txtco5+="ios: \t"
    for k in range(0,len(listprop)):
        txtco5+=str(nopaths[k])+"\t"
    txtco5+="\n"
    txtco5+="ios% \t"
    for k in range(0,len(listprop)):
        txtco5+=str(nopathspercent[k])+"\t"
    txtco5+="\n     - e  o  f  - - -"
    tco5.insert("end",txtco5)
    liprop=[]
    for k in range(0,len(listprop)):
        txthilf="("+str(listprop[k][1])+","+str(listprop[k][2])+")"
        liprop.append(txthilf)
    
    app5=raioop2.brgbar8(tpco5,nopathspercent,liprop," intensity of sep (%) ")
    app5.ausgabe()
    tpco5a=Tkinter.Toplevel(hf)
    tpco5a.title(' table of tripartite graph ')
    tco5a=ScrolledText(tpco5a, width=120, height=20)
    tco5a.pack()
    txtco5a="Tables of tripartite graphs "+"\n"
    txtco5a+=50*" -"+"\n"
    txthilf1="adjacence matrix: indicators causing x>y "+"\n"
    txthilf1+="each row: one of the indicators "+"\n"
    txthilf1+="each entry (referring to an objectpair (x,y))"+"\n"
    txthilf1+=" 1 if the indicator causes x > y, ..."+"\n"
    txthilf1+=" 0 otherwise...."+"\n"
    ncol=len(matrix1[0])
    nrow=len(matrix1)
    summatrix1vec=[]
    for i1 in range(0, nrow):
        summatrix1=0
        for i2 in range(0,ncol):
            txthilf1+=str(round(matrix1[i1][i2],1))+"\t"
            summatrix1+=matrix1[i1][i2]
        summatrix1vec.append(summatrix1)    
        txthilf1+="\n"
    txthilf1+="\n"
    txthilf2="adjacence matrix: indicators causing x<y "+"\n"
    txthilf2+="each row: one of the indicators "+"\n"
    txthilf2+="each entry (referring to an objectpair (x,y))"+"\n"
    txthilf2+=" 1 if the indicator causes x < y, ..."+"\n"
    txthilf2+=" 0 otherwise...."+"\n"
    ncol=len(matrix2[0])
    nrow=len(matrix2)
    summatrix2vec=[]
    for i1 in range(0, nrow):
        summatrix2=0
        for i2 in range(0,ncol):
            txthilf2+=str(round(matrix2[i1][i2],1))+"\t"
            summatrix2+=matrix2[i1][i2]
        summatrix2vec.append(summatrix2)    
        txthilf2+="\n"
    txthilf2+="\n"
    txthilf3=""
    lsummatrix=len(summatrix1vec)
    for i3 in range(0,lsummatrix):
        txthilf3+=str(prop[i3])+"  causes "+str(summatrix1vec[i3])+"  x>y and "+str(summatrix2vec[i3])+"  x<y relations"+"\n"
    txthilf3+="\n"
    txtco5a+=txthilf1
    txtco5a+=txthilf2
    txtco5a+=txthilf3
    txtco5a+="\n"
    tco5a.insert("end",txtco5a)

def co6():
    # brg 22.8.10 reduction
    # brg 5.9.10, 3.10.2010
    #test_reduktionsalg2.py
    nrows=len(listprop)
    ncols=len(listpaar)
    srs=999999

    z=0
    listresult=[]
    while srs>0:
        rs=rmod2.matrixrowsum(xmatrixtotal,nrows,ncols)  #rs tuple of rowsums
        rowmax,rowsumvalue=rmod2.findmax(rs,nrows)    #the first ppossible maximal rowsum (rowsumvalue) and its row
        #print "z= ",z," rowmax= ",rowmax,"  rowsumvalue = ",rowsumvalue
        z2=0
        for k in range(0,ncols):
            if xmatrixtotal[rowmax][k]!=0:
                listresult.append([rowmax,k])    #listresult: pairs of max rowsum and the corresp. objpair-number
                #print "z= ",z," rowsmax = ",rowmax,"  k= ",k, "listpaar = ",listpaar[k][1],listpaar[k][2]
                z2+=1
        for i in range(0,nrows):            #xmatrixtotal all entries, which are already in listresult will be set 0
            for k in range(0,ncols):
                if i!=rowmax:
                    if xmatrixtotal[rowmax][k]!=0:
                        xmatrixtotal[i][k]=0
                        
        srs=sum(rs)
        for k in range(0,ncols):       #now the row with the original max contribution will be set to 0 to find the next maximal
            xmatrixtotal[rowmax][k]=0
        z+=1
        if z>1000:                #safety to avoid endless loops
            break


    
##    print "after the reduction process "
##    print "listresult ",listresult    

    llistresult=len(listresult)

    mnew1=rmod2.marray(llistresult,k0)
    mnew2=rmod2.marray(llistresult,k0)
    for j in range(0,llistresult):
        for k in range(0,k0):
            #print "j= ",j,"   prop= ",prop[k],"  listprop> ",listprop[listresult[j][0]][1]
            if listprop[listresult[j][0]][1]==prop[k]:
                mnew1[j][k]=1
            

    for j in range(0,llistresult):
        for k in range(0,k0):
            #print "j= ",j,"   prop = ",prop[k],"   listprop< ",listprop[listresult[j][0]][2]
            if listprop[listresult[j][0]][2]==prop[k]:
                mnew2[j][k]=1

##    print "  important ....."       
##    print "reduced matrices "           
##    print "mnew1 = "
##    rmod2.matout(llistresult,k0,mnew1)
##
##    print "mnew2 = "
##    rmod2.matout(llistresult,k0,mnew2)

    # mnewtotal mnew1 first columns  then the columns of mnew2
    mnewtotal=rmod2.marray(llistresult,2*k0)
    for i in range(0,llistresult):
        z=0
        for j in range(0,2*k0):
            if j<k0:
                mnewtotal[i][j]=mnew1[i][j]
            else:
                mnewtotal[i][j]=mnew2[i][z]
                z+=1

                
##    print "mnewtotal "
##    rmod2.matout(llistresult,2*k0,mnewtotal)
        
    objpairlist=rmod2.vecgen1(llistresult)
    for i in range(0,llistresult):
        objpairlist[i]=str(listresult[i][1])

    reduc,dmreduc,listreduc,equivlist=rmod2.equivcompact(llistresult,2*k0,mnewtotal,objpairlist)
##    print "reduc= ",reduc
##    print "reduced adjacency matrix "
##    rmod2.matout(reduc,2*k0,dmreduc)
##    print"listreduc ",listreduc
##    print "equivlist ",equivlist

    txtreduc="\n Equivalence classes of the reduced Tripartite Graph \n"
    txtreduc+=60*"="+"\n"
    txtreduc+="Count of elements of the quotient set\n due to 'equality of incidences': "+str(reduc)+"\n"
    txtreduc+="Representatives "+"\n"
    txthilf=""
    for i in range(0,reduc):
        txthilf+=str(listreduc[i])+": ("+str(listpaar[int(listreduc[i])][1])+","+str(listpaar[int(listreduc[i])][2])+"}\n"
    txtreduc+=txthilf+"\n"
    txtreduc+="Equivalent: "+"\n"
    txthilf=""
    txthilf+=str(equivlist)+"\n"
    txtreduc+=txthilf+"\n"    
    
    propnew1=set([])
    propnew2=set([])
    for j in range(0,llistresult):
        for k in range(0,k0):
            if mnew1[j][k]==1:
                propnew1.add(prop[k])

    for j in range(0,llistresult):
        for k in range(0,k0):
            if mnew2[j][k]==1:
                propnew2.add(prop[k])
                

##    print "propnew1 = ",propnew1
##    print "propnew2 = ",propnew2
    propis=propnew1&propnew2
    propun=propnew1.union(propnew2)
    lpropis=len(propis)
    lpropun=len(propun)
    lpropnew1=len(propnew1)
    lpropnew2=len(propnew2)
    
    lipur=rmod2.marray(nrows,2)
    #print "llistresult = ",llistresult
    for z in range(0,nrows):
        hilf=[]
        for i in range(0,llistresult):
            if listresult[i][0]==z:
                hilf.append(listresult[i][1])
                #print "attrpaar ",z, "objpairs: ",listresult[i][1]," ",
        lipur[z][0]=z
        lipur[z][1]=hilf
        print " "  
    nolipur=[]
    zahl=0
##    print "lipur  "
##    for z in range(0,nrows):
##        if lipur[z][1]!=[]:
##            nolipur.append(len(lipur[z][1]))
##            print listprop[z][1],",",listprop[z][2],"  : ",len(lipur[z][1])," ",lipur[z][1]
##            zahl+=1
        
    print "end of lipur generation"
    # hier kommt ScrolledText
    tpred=Tkinter.Toplevel(hf)
    tpred.title('   reduction   ')
    tred=ScrolledText(tpred,width=80,height=10)
    tred.pack(expand="yes",fill="both")
    txt=" R e d u c t i o n "+"\n"
    txt+=60*"="+"\n"
   
    for z in range(0,nrows):
        if lipur[z][1]!=[]:
            hm=len(lipur[z][1])
            for j1 in range(0,hm):
                txt+=str(listprop[z][1])+"-- ("+str(listpaar[lipur[z][1][j1]][1])+","+str(listpaar[lipur[z][1][j1]][2])+")--"+str(listprop[z][2])+"\n"
                
    txt+="\n\n"
    txt+="(1) Minimal needed attributes for separation = "+str(propun)+"\n"
    txt+="(2) Needed minimal dimension of attrib.space = "+str(lpropun)+"\n"
    txt+="(3) Attributes in the intersection (contributing to mixing):\n "+str(propis)+"\n"
    txt+="(4) Equivalence relations "
    txt+=txtreduc
    txt+="  - - - e o f - - - "
    tred.insert("end",txt)        

    tpgraph=Tkinter.Toplevel(hf)       #23.8.10 Baustelle
    tpgraph.title(' reduced tripartite graph ')
    posr1=rmod2.marray(lpropnew1,2)
    posr2=rmod2.marray(len(listpaar),2)
    posr3=rmod2.marray(lpropnew2,2)
    cv3=Tkinter.Canvas(tpgraph,height=500,width=500,bg="white")
    cv3.pack(expand="y",fill="both")
    ct01=cv3.create_text(120,40,text="reduced: x  > y ")
    ct02=cv3.create_text(260,40,text="reduced: x  < y ") 
    for k in range(0,lpropnew1):
        posr1[k][0]=75
        posr1[k][1]=60+k*20

    for k in range(0,lpropnew2):
        posr3[k][0]=325
        posr3[k][1]=60+k*20

    for i in range(0,len(listpaar)):
        posr2[i][0]=200
        posr2[i][1]=60+i*20
        
    z=0
    for k in propnew1:
            xx=posr1[z][0]
            yy=posr1[z][1]
            ct1=cv3.create_text(xx,yy,text=k)
            z+=1
    z=0
    for k in propnew2:
            xx2=posr3[z][0]
            yy2=posr3[z][1]
            ct2=cv3.create_text(xx2,yy2,text=k)
            z+=1

    for i in range(0,len(listresult)):  #28.9.10 statt (len(listpaar))
        xx1=posr2[i][0]
        yy1=posr2[i][1]
        ctp=cv3.create_text(xx1,yy1,text="("+str(listresult[i][1])+")")
    posvertical=posr2[len(listpaar)-1][1]
    
    z=0
    for k in propnew1:
        kz=prop.index(k)
        for i in range(0,len(listresult)):#28.9.10 s.o.
            if mnew1[i][kz]==1:
                line1=cv3.create_line(posr1[z][0]+15,posr1[z][1],posr2[i][0]-15,posr2[i][1],fill="red")
        z+=1
    z=0
    for k in propnew2:
        kz=prop.index(k)
        for i in range(0,len(listresult)): #28.9.10 s.o.
            if mnew2[i][kz]==1:
                line2=cv3.create_line(posr3[z][0]-15,posr3[z][1],posr2[i][0]+15,posr2[i][1],fill="blue")
        z+=1
    z=0
    
    ii=0       #3.10.2010
##    print "len listresults ",len(listresult)
##    print "listpaar = ",listpaar
##    for i in range(0,len(listpaar)):
##        for j in range(0,3):
##            print listpaar[i][j]," ",
##        print " "
##        
##                   
##    print "listresult ", listresult
##    print " "
##    print "lipur "
##    for i1 in range(0,nrows):
##        for j1 in range(0,len(lipur[i1][1])):
##            print "z= ",z,"   j1= ",j1,"   lipur = ",lipur[i1][1][j1]," ",
##        print " "                
    i=0
    ii=0
    for i2 in range(0,nrows): #28.9.10, 5.10.2010
        if lipur[i2][1]!=[]:
            hm=len(lipur[i2][1])
            #print "i2= ",i2,"   hm = ",hm
            for j1 in range(0,hm):
                ctpair=cv3.create_text(50+100*ii,posvertical+20+z,text=str(lipur[i2][1][j1])+": ("+str(listpaar[lipur[i2][1][j1]][1])+","+str(listpaar[lipur[i2][1][j1]][2])+"), ")
                if (1.0*i/4.0)-i/4==0:   #3.10.2010
                    z+=15
                    ii=0                   
                else:
                    ii+=1
                i+=1


        
def co7():
    #brg 22.8.10  individual analysis
    tpco7=Tkinter.Toplevel(hf)
    tpco7.title(' individual analysis ')
    th="0123456789"
    tt=7*th
    lenx1x2=len(listpaar)
    ob1=eob1.get()
    ob2=eob2.get()
    ispez=rmod2.find_no_inlistpaar(listpaar,ob1,ob2,lenx1x2)
    cv2=Tkinter.Canvas(tpco7,width=400,height=400,bg="white")
    lb2=Tkinter.Label(tpco7,text=tt,bg="yellow")
    lb2.pack()
    cv2.pack(expand="yes",fill="both")
    pos12=rmod2.marray(k0,2)
    pos32=rmod2.marray(k0,2)
    ct01=cv2.create_text(130,40,text=" x  > y ")
    ct02=cv2.create_text(270,40,text=" x  < y ") 
    for k in range(0,k0):
        pos12[k][0]=75
        pos32[k][0]=325
        pos12[k][1]=60+20*k
        pos32[k][1]=60+20*k


    for j in range(0,k0):
        xx1=pos12[j][0]
        yy1=pos12[j][1]
        ct1=cv2.create_text(xx1,yy1,text=prop[j])

        x3=pos32[j][0]
        y3=pos32[j][1]
        ct2=cv2.create_text(x3,y3,text=prop[j])


    xx2=200
    yy2=60+k0*10
    ctp=cv2.create_text(xx2,yy2,text="("+str(listpaar[ispez][1])+","+str(listpaar[ispez][2])+")")

    for k in range(0,k0):
        if matrix1[k][ispez]==1:
            line1=cv2.create_line(pos12[k][0]+15,pos12[k][1],xx2-15,yy2,fill="red",width=2)
        if matrix2[k][ispez]==1:
            line2=cv2.create_line(pos32[k][0]-15,pos32[k][1],xx2+15,yy2,fill="blue",width=2)



def co7b():
    #brg 4.9.10
    #brg 22.8.10  individual analysis
    global x1,x2
    tpco7b=Tkinter.Toplevel(hf)
    tpco7b.title(' individual analysis /attr. ')
    th="0123456789"
    tt=7*th
    lenx1x2=len(listpaar)
    att1=eatt1.get()
    
    
    cv2=Tkinter.Canvas(tpco7b,width=400,height=400,bg="white")
    lb2=Tkinter.Label(tpco7b,text=tt,bg="yellow")
    lb2.pack()
    cv2.pack(expand="yes",fill="both")
    pos12=rmod2.marray(1,2)
    pos32=rmod2.marray(1,2)
    ct01=cv2.create_text(130,40,text=" x  > y ")
    ct02=cv2.create_text(270,40,text=" x  < y ") 
    iatt=prop.index(att1)
    
    pos12[0][0]=75
    pos32[0][0]=325
    pos12[0][1]=120
    pos32[0][1]=120


    ct1=cv2.create_text(pos12[0][0],pos12[0][1],text=prop[iatt])
    ct2=cv2.create_text(pos32[0][0],pos32[0][1],text=prop[iatt])

    for i in range(0,lenx1x2):
        ctp=cv2.create_text(200,60+15*i,text="("+str(listpaar[i][1])+","+str(listpaar[i][2])+")")

    for i in range(0,lenx1x2):
        if matrix1[iatt][i]==1:
            line1=cv2.create_line(pos12[0][0]+15,pos12[0][1],200-15,60+15*i,fill="red",width=2)
        if matrix2[iatt][i]==1:
            line2=cv2.create_line(pos32[0][0]-15,pos32[0][1],200+15,60+15*i,fill="blue",width=2)
    

def co7c():
    tptrip2=Tkinter.Toplevel(hf)
    tptrip2.title('  analysis of a single object ')
    cv=Tkinter.Canvas(tptrip2,width=400,height=400,bg="white")
    cv.config(scrollregion=(0,0,1000,1000)) 
    cv.config(highlightthickness=1)
    t="0123456789"
    tt=7*t
    lb1=Tkinter.Label(cv,text=tt,bg="yellow")
    lb1.pack()
    # special selection of an object either of set1 or set2
    obspez=eobx.get()
    lspez1,listspez1=rmod2.listpaar_no_identifier_orient(listpaar,obspez,lenx1x2,1)
    if lspez1==0:
         lspez1,listspez1=rmod2.listpaar_no_identifier_orient(listpaar,obspez,lenx1x2,2)
    print "listspez = ",listspez1
    #
    sbary=Tkinter.Scrollbar(cv,orient="vertical")
    sbary.config(command=cv.yview) 
    cv.config(yscrollcommand=sbary.set) 
    sbary.pack(side="right", fill="y")
    cv.pack(side="left",expand="yes",fill="both")
    pos1=rmod2.marray(k0,2)
    pos2=rmod2.marray(lenx1x2,2)
    pos3=rmod2.marray(k0,2)
    ct01=cv.create_text(130,40,text=" x  > y ")
    ct02=cv.create_text(270,40,text=" x  < y ") 

    for k in range(0,k0):
        pos1[k][0]=75
        pos3[k][0]=325
        pos1[k][1]=60+20*k
        pos3[k][1]=60+20*k

    for i in range(0,lenx1x2):
        pos2[i][0]=200
        pos2[i][1]=60+20*i

    for j in range(0,k0):
        xx=pos1[j][0]
        yy=pos1[j][1]
        ct1=cv.create_text(xx,yy,text=prop[j])

        xx2=pos3[j][0]
        yy2=pos3[j][1]
        ct2=cv.create_text(xx2,yy2,text=prop[j])

    for i in range(0,lenx1x2):
        xx1=pos2[i][0]
        yy1=pos2[i][1]
        if i in listspez1:
            ctp=cv.create_text(xx1,yy1,text="("+str(listpaar[i][1])+","+str(listpaar[i][2])+")")

    for k in range(0,k0):
        for i in range(0,lenx1x2):
            if i in listspez1:
                if matrix1[k][i]==1:
                    line1=cv.create_line(pos1[k][0]+15,pos1[k][1],pos2[i][0]-20,pos2[i][1],fill="red")
                if matrix2[k][i]==1:
                    line2=cv.create_line(pos3[k][0]-15,pos3[k][1],pos2[i][0]+20,pos2[i][1],fill="blue")



def HDsep():
    #brg 10.3.2010
    global x1,x2
    print "in HDsep: x1,x2 ",x1,"  ",x2
    tphdsep=Tkinter.Toplevel(hf)
    tphdsep.title(' HD of union of sep.sets ')
    freq=Tkinter.Frame(tphdsep,width=400,height=400)
    freq.pack()
    
    txte=""
    txte+="user defined sets \n"
    txte+="set1 = "
    lx1=len(x1)
    lx2=len(x2)
    for i in x1:
        txte+=i+", "
    txte+="\nset2 = "
    for i in x2:
        txte+=i+", "

    
        
    txte+="\n"
    txte+=30*"=="+"\n\n"
    rsep=len(x1)+len(x2)
    
    dm,ob,pro,r,k0=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k0)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k0):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################this part is of 21.12.07 #########
    rred,xred,objred,txt=rmod2.equivcompact(r,k0,dm,obj)    
    ###############################################################
    dmsep=rmod2.marray(rsep,k0)   
    
    objsep=[]
    zahl=0
    for i in range(0,rred):
        if objred[i] in x1 or objred[i] in x2:
            objsep.append(objred[i])
            for j in range(0,k0):        
                dmsep[zahl][j]=xred[i][j]
            zahl+=1

    zetahilfsep=rmod2.comp(rsep,k0,dmsep)
    zetasep=rmod2.marray(rsep,rsep)
    for i in range(0,rsep):
        for j in range(0,rsep):
            zetasep[i][j]=zetahilfsep[j][i]
            

    lobjsep,lextsep,revlextsep,zzmaxsep=rmod2.levtopsort(rsep,zetasep)
    #print "zzmaxsep = ",zzmaxsep
    #print "lobjsep = ",lobjsep
   
    levmaxsep=-10**20
    for i in range(0,zzmaxsep):
       if len(lobjsep[i])>=levmaxsep:
           levmaxsep=len(lobjsep[i])
    
      
    #Adj-Listen

    adjcsep=rmod2.adjacent(rsep,lextsep,revlextsep,zetasep)
        
    #Transitive reduced relations
    tssep,trsep=rmod2.trreduct(rsep,adjcsep,lextsep)
       
    global zeta2sep
    zeta2sep=rmod2.cover(rsep,trsep,lextsep)
    
    if rsep>60:
        cover_show()                  #20.1.08
    else:
       lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of sep sets ")
       lbhd3.pack()
       actwidth,actheight,factorx,factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=geomHD(rsep,levmaxsep,zzmaxsep)
       cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
       lz=zzmaxsep
       l=rmod2.vecgen1(lz)
       for i in range(0,lz):
           l[i]=len(lobjsep[i])

       pos=rmod2.vecgen1(lz)
       for i in range(0,lz):
           pos[i]=l[i]
        
       geomx=rmod2.marray(rsep,rsep)
       geomy=rmod2.marray(rsep,rsep)

       for i in range(0,lz):
           for j in range(0,l[i]):
               geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)
               geomy[i][j]=geom0y+(factory/lz)*i
            

       for i in range(0,lz-1):
           for j in range(0,l[i]):
               #print obj[lobj[i][j]]
               for i1 in range(i+1,lz):
                   for j1 in range(0,l[i1]):
                       #print obj[lobj[i1][j1]]
                       if zeta2sep[lobjsep[i1][j1]][lobjsep[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


       for i in range(0,lz):
           for j in range(0,l[i]):
               cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
               cv.create_text(geomx[i][j],geomy[i][j],text=objsep[lobjsep[i][j]])
        
       cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
       cv.create_text(garrow1x+8,garrow1y-6,text="high")
       cv.create_text(garrow1x+8,garrow2y+6,text="low")
       cv.pack()

    



    
def scatter():
    #Brg 13.3.2020  still a test version
    x1,x2=inread()
    
    #print finfin
    #print attfin
    lx1=len(x1)
    lx2=len(x2)
    xnew=x1|x2
    objassign=[]
    objspec=[]
    
    iatt=attfin[0]
    
    #print prop[iprot[iatt][0]]," ",prop[iprot[iatt][1]]
    rows=lx1+lx2
    dmspec=rmod2.marray(rows,2)
    #propspec=[]
    zahl=0
    
    for i in range(0,rred):
        if objred[i] in x1 or objred[i] in x2:
            #print objred[i]," ",
            objspec.append(objred[i])     #16.3.2010
            if objred[i] in x1:
                objassign.append(0)
            elif objred[i] in x2:
                objassign.append(1)
            for j in range(0,k0):
                if j==iprot[iatt][0]:
                    dmspec[zahl][0]=xred[i][j]
                    #propspec.append(prop[j])
                    #print dmspec[zahl][0]," ",
                elif j==iprot[iatt][1]:
                    dmspec[zahl][1]=xred[i][j]
                    #propspec.append(prop[j])
                    #print dmspec[zahl][1]
                else:
                    pass
            zahl+=1
            #print " "
    propspec=[prop[iprot[iatt][0]],prop[iprot[iatt][1]]]
    reff,xreff,objreff,txtequ=rmod2.equivcompact(rows,2,dmspec,objspec)
    #print "Equivalent ",txtequ
    app0=raioop2.brgmatrixoutput(hf,dmspec,"tpscdat","scatter-dm ",txtequ,rows,2,propspec,objspec,"sc.plt")
    app0.ausgabe()
   
    txt1=prop[iprot[iatt][0]]
    txt2=prop[iprot[iatt][1]]
    app1=raioop2.brgscatterplot1(hf,"tpsc1",objspec,objassign,dmspec,txt1,txt2,rows,0)
    app1.anzeige()
    app2=raioop2.brgscatterplot1(hf,"tpsc2",objspec,objassign,dmspec,txt1,txt2,rows,1)
    app2.anzeige()
    #rmod2.matout(rows,2,dmspec)
            

def sepstat():
    #brg 23.8.10
    lenx1x2=len(listpaar)
    rowsumred1=[]
    for k in range(0,k0):
        sumk=0
        for j in range(0,lenx1x2):
            T=0
            for k1 in range(0,k0):
                T+=matrix2[k1][j]
            #print "k= ",k,"  j= ",j,"   T= ",T    
            if matrix1[k][j]==1 and T!=0:
                sumk+=1
            else:
                sumk+=0
        rowsumred1.append(sumk)

    rowsumred2=[]
    for k in range(0,k0):
        sumk=0
        for j in range(0,lenx1x2):
            T=0
            for k1 in range(0,k0):
                T+=matrix1[k1][j]
            #print "k= ",k,"  j= ",j,"   T= ",T    
            if matrix2[k][j]==1 and T!=0:
                sumk+=1
            else:
                sumk+=0
        rowsumred2.append(sumk)
    # normalization by setting 100% = lenx1x2 (=len(listpaar))    
    for i in range(0,k0):
        rowsumred1[i]=100.0*rowsumred1[i]/(1.0*len(listpaar))
        rowsumred2[i]=100.0*rowsumred2[i]/(1.0*len(listpaar))
                   
    tpsepstat=Tkinter.Toplevel(hf)
    tpsepstat.title(' x>(qi)y, x<(qi)y count in x||y ')
    tsepstat=ScrolledText(tpsepstat,width=60,height=10)
    tsepstat.pack(expand="yes",fill="both")
    txt=" x > (q(i)) y, x < (q(i)) y in x ||y "+"\n"
    txt+=60*"="+"\n"
    txt+="\t"
    for k in range(0,k0):
        txt+=str(prop[k])+"\t"
    txt+="\n"
    txt+="x>y:\t "
    for k in range(0,k0):
        txt+=str(round(rowsumred1[k],2))+"\t"
    txt+="\n"
    txt+="x<y:\t "
    for k in range(0,k0):
        txt+=str(round(rowsumred2[k],2))+"\t"
    txt+="\n"
    txt+=" - - - e o f  - - - "
    tsepstat.insert("end",txt)
    prop1=rmod2.veccopy(k0,prop)
    app6=raioop2.brgbar8(tpsepstat,rowsumred1,prop1," x  > y \n reduced ")
    app6.ausgabe()
    app7=raioop2.brgbar8(tpsepstat,rowsumred2,prop1," x  < y \n reduced ")
    app7.ausgabe()


hf=Tkinter.Tk()
hf.title('--   Main GUI sepanal   -- ')

aboutmainHD=raioop2.brgabout(hf,"tp1","about_sep.txt",16,\
            "Sept. 4th, 2010"," about sep ", "white", "t1",120,5,ScrolledText)
helpmainHD=raioop2.brgabout(hf,"tp1","help_sepanal.txt",16,\
            "Sept. 4th, 2010"," help_sep ", "white", "t1",120,10,ScrolledText)
    

fr1=Tkinter.Frame(hf,width=60,relief="sunken",bd=3,bg="white")   
fr1.pack()
##lb0=Tkinter.Label(fr1,text=80*"-")
##lb0.pack()
Buttfn=Tkinter.Button(fr1,text="data file-operations",width=40,bg="cyan",command=file_issues)
Buttfn.pack(pady=5)

Buttset=Tkinter.Button(fr1,text=" selection &\norganisation of disjoint object subsets",state="disabled",width=40,bg="cyan",command=setoperat)
Buttset.pack(pady=5)


frm=Tkinter.Frame(fr1,width=60,height=10)
frm.pack(pady=10)
Buttsep=Tkinter.Button(frm,text="Calculate separation ",width=40,bg="cyan",state="disabled",command=separation)
Buttsep.pack()
##lb01=Tkinter.Label(fr1,text=80*"-")
##lb01.pack()
buttexit=Tkinter.Button(hf,text=" Exit  ",bg="red", width=30,command=hf.destroy)
buttexit.pack(pady=20)


hf.mainloop()


