import Tkinter
import rmod2
import raioop2
from ScrolledText import *
import tkFileDialog
import Canvas
import os
from math import *
import webbrowser

# antag1.py derived from dds8 4.2.09
# antag2.py 6.2.09, 8.10.09, 16.10.09
# antag3.py 20.12.2012
# antag2scattplot.py : brg 26.2.2012
# 27.12.2012,3.7.2013
# 27.12.2014 Rename and some modifications



global fn

def fileselect():
    """ File selection and opening by Tkinter-Standards"""
    #*13.1.08
    #akt: 13.1.08
    #note: There may be conflicts with other moduls
    #source:-
    #tp=Tkinter.Toplevel(hf)   #18.2.08
    global fn
    fn=tkFileDialog.askopenfilename()
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    maxatt=[]
    txthilf="Max values of attributes:\n"
    for j in range(0,k):
        hilf=[]
        for i in range(0,r):
            hilf.append(dm[i][j])
        maxatt.append(max(hilf))
        txthilf+=str(pro[j+1])+": "+str(maxatt[j])+", "
    txthilf+="\n"                  
    
    lbopen1.config(bg="yellow")
    lbopen1["text"]="selected file : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"
    lbopen2.config(text=txthilf)
    
    return r,k,dm,ob,pro,fn

         
def showDM():
    """ New routine : shows the data matrix """
    #Brg 13.1.08
    tp2=Tkinter.Toplevel(hf)
    tp2.title(' show DM ')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+ob[i+1]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+pro[j+1]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=pro[j+1]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=ob[i+1]+"\t"
        for j in range(0,k):
            txt3+=str(dm[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)
    

def filecomp(fn):
    """ reduces a dm with equiv objects to a dm of a quotient set """
    # Brg 12.12.07, 13.1.08, 14.1.08, 8.5.08
    # von mainHD3 uebernommen und geringfuegig angepasst
    #r,k,dm,ob,pro,fn are globals and should be available after open
    global r,dm,txteq,prop
    dm,ob,pro,r,k1=rmod2.EXCELreadin4(fn)
    #recoding ob to obj and pro to prop
    if r==0:
        hfwarning=Tkinter.Toplevel(hf)
        hfwarning.title('++warning++')
        frwarning=Tkinter.Frame(hfwarning,width=10,height=3)
        frwarning.pack()
        bwarning=Tkinter.Button(frwarning,text="++warning ++",command=msgwarning)
        bwarning.pack()
        
    prop=rmod2.vecgentext1(k1)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k1):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    #############################dieser Teil ist neu 21.12.07
    rred,xred,objred,txteq=rmod2.equivcompact(r,k1,dm,obj)    
    ###############################################################
    print txteq
    return rred,k1,xred,objred,obj,prop,txteq           
     

def confirm():
    """ hfs entries are opened to read in hfs strings """
    #brg 26.12.07
    global ra
    #print "in confirm hfs=",hfs," ra = "
    ra=rmod2.vecgentext1(2)
    for i in range(0,2):
        ra[i]=e[i].get()
    return ra


def analysis():
    # Brg 4.2.09,5.2.09,6.2.09
    # 
    global relsep, sep
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    # available now:
    # dm original
    # obj original
    # prop original

    zeta=rmod2.comp(r,k,dm)

    # Note this zeta matrix may also describe equivalenve relations 
           
    ra=confirm()        
    rai,x,lrai=rmod2.rai_x(ra,obj)  
    print "rai= ",rai
    print "x = ",x
    print "lrai = ",lrai
    #that is the central part: based on rai the separability degree
    sep=0
    
    for i2 in range(0,lrai[0]):
        for i4 in range(0,lrai[1]):
                if zeta[rai[0][i2]][rai[1][i4]]==0 and zeta[rai[1][i4]][rai[0][i2]]==0:
                    sep+=1        
    
    #print "separability standard ",sep

    anz=1.0*k*(k-1)/2.0
    cases=int(anz)
    relsep=rmod2.vecgen1(cases)
    t=rmod2.vecgen1(2)   #column's selector
    
    zaehl=0
    for i in range(0,k-1):
        for j in range(i+1,k):
            t[0]=i
            t[1]=j
            txth,xx=rmod2.newmatrix(r,k,dm,t)
            zetah=rmod2.comp(r,2,xx)
            dummy=rmod2.partialseparability1(r,rai,lrai,zetah)  
            relsep[zaehl]=dummy
            zaehl+=1
    print "relsep = ",relsep
    lrelsep=len(relsep)
    txt="\tSelected subsets \n"
    zaehl=1
    
    for i in range(0,2):
        txt+="\t("+str(i+1)+"): "
        for j in range(0,lrai[i]):
            txt+="\t"+obj[rai[i][j]]+"\t"
            zaehl+=1
        txt+="\n"
    
    txt+="\tSeparability based on original data matrix = "+str(sep)+"\n"
    txtcomb=rmod2.vecgentext(lrelsep+1)
    txt+="\tSeparabilities due to "+str(cases) +"   attribute pairs\n"
    zaehl=0
    for i in range(0,k-1):
        for j in range(i+1,k):
            txtcomb[zaehl]=prop[i]+","+prop[j]
            zaehl+=1
    txthilf=""
    for i in range(0,lrelsep):
        txthilf+="\t"+txtcomb[i]+"\t\t"+str(relsep[i])+"\n"
    txt+=txthilf
    txt+=50*"="

    # Results in ScrolledText    
    sct1=raioop2.brgscrolltext(fr3,txt,'Results of separability ', \
                               'Details see results','cyan','tpsct1',60,anz+16,'results 1')
    
    bd1=raioop2.brgbar3(hf,'tpbd1',lrelsep,relsep,txtcomb,\
                        20,' sep due to '+str(cases)+' att.pairs',30,15,20)
    bd1.ausgabe()

def HDattpairs():
    """ for selected attribute pairs the HD is shown """
    # Brg 6.2.09
    def cover_show1():
        """Cover-matrix is displayed"""
        #brg 28.12.07
        #*28.12.07
        #akt28.12.07
        #note: -
        #source: -
        hfcover=Tkinter.Toplevel(hf)
        hfcover.title(' cover-matrix ')
        
        lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\n"+objred[i]+":\t"
            txt3+="is cover_less than "
            for j in range(0,n):
                if i!=j:
                    if zeta2[i][j]==1:
                        txt3+=" "+objred[j]+" ,"
                    else:
                        pass
                else:
                    pass
            txt3+="\n"    
        txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(hfcover,width=50, height=4)
        tcov.pack()
        tcov.insert("end",txt3)

    hfhd3=Tkinter.Toplevel(hf)
    hfhd3.title('Hasse diagram or cover matrix ')
    freq=Tkinter.Frame(hfhd3,width=200,height=400)
    freq.pack()
    
    att1=int(eat1.get())
    att2=int(eat2.get())
    
    t=rmod2.vecgen1(2)
    t[0]=att1
    t[1]=att2
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    
    txth,xx=rmod2.newmatrix(r,k,dm,t)
    print txth
    rred,xred,objred,txt=rmod2.equivcompact(r,2,xx,obj)  
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,2,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    txt="\n Equivalence classes \n"
    txt2+=60*"="+"\n"
    txt2+=txt
    txt2+="\n -- end of list -- "
    tlinext=ScrolledText(freq,width=60, height=2)
    tlinext.pack()
    tlinext.insert("end",txt2)
    
    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    tpHDatt=Tkinter.Toplevel(hf)
    tpHDatt.title(' HD of selected attributes ')
    lbHDatt=Tkinter.Label(tpHDatt,text= "HD of selected attributes "+str(prop[att1])+", "+str(prop[att2]))
    lbHDatt.pack()
    if n>100:
        lbhd2=Tkinter.Label(tpHDatt,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(tpHDatt,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        cv=Tkinter.Canvas(tpHDatt,width=300,height=500)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=160
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show1)
        buttcover.pack()

    
        
def HD():
    "based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension"
    # Brg 20.12.07, 28.12.07, 14.1.08 taken from mainHD3
    # If the number of representants > 30 then only the cover-matrix and the level-population
    #
    global zeta2,n,objred    
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram or cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
    rred,k,xred,objred,obj,prop,txt=filecomp(fn)
    n=rred
    labeq=Tkinter.Label(freq,text="file = "+fn+": calc. is based on representants ")
    labeq.config(bg="yellow")
    labeq.pack()

    #
    zetahilf=rmod2.comp(n,k,xred)
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    lbhd1=Tkinter.Label(freq,text= "Level ")
    lbhd1.pack()

    #rmod2.matout(n,n,zeta)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(n,zeta)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
    txt1="\n"
    for i in range(0,zzmax):
        txt1+="Level "+str(zzmax-i)+" :"
        for j in range(0,len(lobj[i])):
            txt1+= objred[lobj[i][j]]+" "
        txt1+="\n"    
    txt1+="\n\n  -- end --"        
    tlev.insert("end",txt1)

    #Adj-Listen

    adjc=rmod2.adjacent(n,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(n,adjc,lext)
       
    
    zeta2=rmod2.cover(n,tr,lext)
    if n>100:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,n):
            txt3+="\t"+objred[i]+"\t"
        txt3+="\n"
        for i in range(0,n):
            txt3+=objred[i]+" :"
            for j in range(0,n):
                txt3+=str(zeta2[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta2[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
##        cv.create_line(garrow1x-4,garrow2y-4,garrow1x,garrow2y)
##        cv.create_line(garrow1x+4,garrow2y-4,garrow1x,garrow2y)
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover=Tkinter.Button(freq,text="show cover relation",command=cover_show)
        buttcover.pack()

def cover_show():
    """Cover-matrix is displayed"""
    #brg 28.12.07
    #*28.12.07
    #akt28.12.07
    #note: -
    #source: -
    hfcover=Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    
    lbhd2=Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbhd2.pack()
    txt3="\n cover-matrix  \n"
    for i in range(0,n):
        txt3+="\n"+objred[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,n):
            if i!=j:
                if zeta2[i][j]==1:
                    txt3+=" "+objred[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)
    
def showeq():
    #brg 20.12.2012
    tpEquivalences=Tkinter.Toplevel(hf)
    tpEquivalences.title("Equiv. conc. orig dm ")
    lbequivw=Tkinter.Label(tpEquivalences,text="Equivalence classes "+"\n"+txteq)
    lbequivw.pack()

def scattplot():
    #Brg 20.12.2012
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for j in range(0,k):
        prop[j]=pro[j+1]
    for i in range(0,r):
        obj[i]=ob[i+1]

    att1=int(eat1.get())
    att2=int(eat2.get())
    t=rmod2.vecgen1(2)
    t[0]=att1
    t[1]=att2
    lbinfosc.config(text="First coordinate (abscissa): "+str(prop[att1])\
                    +"\n  second coordinate (ordinate): "+str(prop[att2]))



    maxhilf0=-9999999
    for i in range(0,r):
        if dm[i][t[0]]>maxhilf0:
            maxhilf0=dm[i][t[0]]

    maxhilf1=-9999999
    for i in range(0,r):
        if dm[i][t[1]]>maxhilf1:
            maxhilf1=dm[i][t[1]]


    
    try:
        max0=float(e0.get())
    except:
        max0=maxhilf0
    try:    
        max1=float(e1.get())
    except:
        max1=maxhilf1

    
    print "max0,max1  ",max0,max1    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for i in range(0,k):
        prop[i]=pro[i+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    txth,xx=rmod2.newmatrix(r,k,dm,t)
    #print txth
    ra=confirm()        
    rai,x,lrai=rmod2.rai_x(ra,obj)  

    objassign=rmod2.vecgen1(r)
    for i in range(0,r):
        if obj[i] in x[0]:
            objassign[i]=1
        elif obj[i] in x[1]:
            objassign[i]=2
        else:
            objassign[i]=3

    app=raioop2.brgscatterplot5(hf,"tpscatertplot",obj,objassign,xx,dm,str(prop[t[0]]),str(prop[t[1]]),r,k,max0,max1,1)
    app.anzeige()

def HD5():
    # brg 20.12.2012
    global zeta3,objred3,rred3
    att1=int(eat1.get())
    att2=int(eat2.get())
    t=rmod2.vecgen1(2)
    t[0]=att1
    t[1]=att2
    
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    prop=rmod2.vecgentext1(k)
    obj=rmod2.vecgentext1(r)     #changed to ...text1: 8.5.08
    for j in range(0,k):
        prop[j]=pro[j+1]
    for i in range(0,r):
        obj[i]=ob[i+1]
    txth,xx=rmod2.newmatrix(r,k,dm,t)
    
    reducedobj=e51.get().split(",")
    print "reduced objects ",reducedobj
    dmred=rmod2.marray(len(reducedobj),2)
    zahl=0
    objcorr=[]
    for i in range(0,r):
        if obj[i] in reducedobj:
            dmred[zahl][0]=dm[i][t[0]]
            dmred[zahl][1]=dm[i][t[1]]
            objcorr.append(obj[i])
            zahl+=1
    r3=zahl
    rmod2.matout(len(reducedobj),2,dmred)
    hfhdred=Tkinter.Toplevel(hf)
    hfhdred.title('Hasse diagram , selected objects ')
    freq=Tkinter.Frame(hfhdred,width=200,height=300)
    freq.pack()
    
    rred3,xred3,objred3,txteq3,neq3=rmod2.equivcompactm(r3,2,dmred,objcorr)  
    print "neq_act ", neq3
    print "txteq_act ",txteq3
    
    zetahilf=rmod2.comp(rred3,2,xred3)
    zetared=rmod2.marray(rred3,rred3)
    for i in range(0,rred3):
        for j in range(0,rred3):
            zetared[i][j]=zetahilf[j][i]
    #
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred3,zetared)
    #print "zzmax = ",zzmax
    tlev=ScrolledText(freq,width=60,height=4)
    tlev.pack()
   
    
    #Adj-Listen

    adjc=rmod2.adjacent(rred3,lext,revlext,zetared)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred3,adjc,lext)
       
    
    zeta3=rmod2.cover(rred3,tr,lext)
    if rred3>100:
        lbhd2=Tkinter.Label(freq,text=" graphical presentation not meaningful, see levels and cover-matrix ")
        lbhd2.pack()
        txt3="\n cover-matrix  \n"
        for i in range(0,rred3):
            txt3+="\t"+objred3[i]+"\t"
        txt3+="\n"
        for i in range(0,rred3):
            txt3+=objred3[i]+" :"
            for j in range(0,rred3):
                txt3+=str(zeta3[i][j])+"\t"
            txt3+="\n"
        txt3+=" -- end of list --"
        tcov=ScrolledText(freq,width=60, height=4)
        tcov.pack()
        tcov.insert("end",txt3)
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram of File "+fn)
        lbhd3.pack()
        cv=Tkinter.Canvas(freq,width=300,height=200)
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]
        
        geomx=rmod2.marray(n,n)
        geomy=rmod2.marray(n,n)

        geom0x=10
        geom0y=20
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(160.0/(pos[i]+1.0))*(j+1)
                geomy[i][j]=geom0y+(160.0/lz)*i
            

        for i in range(0,lz-1):
            for j in range(0,l[i]):
                #print obj[lobj[i][j]]
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        #print obj[lobj[i1][j1]]
                        if zeta3[lobj[i1][j1]][lobj[i][j]]==1:
                            #print obj[lobj[i][j]],"-",obj[lobj[i1][j1]]
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred3[lobj[i][j]])
        garrow1x=210
        garrow1y=20
        garrow2y=190
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y+6,text="low")
        cv.pack()
        buttcover3=Tkinter.Button(freq,text="show cover relation",command=cover_show3)
        buttcover3.pack()

def cover_show3():
    # brg 20.12.2012
    """Cover-matrix is displayed"""
    #brg 20.12.12
    #*28.12.07
    #akt20.12.12
    #note: -
    #source: -
    global rred3
    hfcover3=Tkinter.Toplevel(hf)
    hfcover3.title(' cover-matrix3 ')
    
    lbhd2=Tkinter.Label(hfcover3,text=" Cover-Relations3 ")
    lbhd2.pack()
    txt3="\n cover-matrix3  \n"
    for i in range(0,rred3):
        txt3+="\n"+objred3[i]+":\t"
        txt3+="is cover_less than "
        for j in range(0,rred3):
            if i!=j:
                if zeta3[i][j]==1:
                    txt3+=" "+objred3[j]+" ,"
                else:
                    pass
            else:
                pass
        txt3+="\n"    
    txt3+="\n"
    txt3+=" -- end of list --"
    tcov=ScrolledText(hfcover3,width=50, height=4)
    tcov.pack()
    tcov.insert("end",txt3)
    

def helptxt():
    # Koppatz, Brg  21.12.2012
    webbrowser.open_new(HELPTEXT)

hf=Tkinter.Tk()
hf.title(' GUI sepanalscatterplot ')
lbantag=Tkinter.Label(hf,text=" Separability pairwise ",width=50)
lbantag.pack(pady=5)

helpantag=raioop2.brgabout(hf,"tp1","help_sepanalscattplot.txt",1,\
            "Dec., 27th,2014"," help_sepanalscatterplot ", "white", "t1",80,5,ScrolledText)
    
aboutantag=raioop2.brgabout(hf,"tp1","about_sepanalscattplot.txt",1,\
            "Dec., 27th,2014"," about_sepanalscatterplot ", "white", "t1",80,5,ScrolledText)    

fr1=Tkinter.Frame(hf,relief="sunken")
fr1.pack()
buttsubmit=Tkinter.Button(fr1,text="(1) select and open file",width=25,bg="white",command=fileselect)
buttsubmit.pack()
lbopen1=Tkinter.Label(fr1,text="")
lbopen1.pack()
lbopen2=Tkinter.Label(fr1,text="")
lbopen2.pack()


fr2=Tkinter.Frame(hf,width=60,height=50,relief="sunken",bd=4)
fr2.pack(pady=5)
#In fr2 exclusively grid - geometry manager  (26.7.08)
buttshow=Tkinter.Button(fr2,text="(2) show data matrix",width=25, command=showDM)
buttshow.grid(columnspan=3,row=4)
buttHD=Tkinter.Button(fr2,text=" (3) HD ",bg="cyan",width=25,command=HD)
buttHD.grid(columnspan=3,row=5)
butteq=Tkinter.Button(fr2,text="(4) Show equivalence classes ",width=25,command=showeq)
butteq.grid(columnspan=3,row=6)
lbsubset=Tkinter.Label(fr2,text="(5) Define the subsets")
lbsubset.grid(columnspan=3,row=7)
lb1=Tkinter.Label(fr2,text=" subset 1: ")
lb1.grid(column=0,row=8)
lb2=Tkinter.Label(fr2,text=" subset 2: ")
lb2.grid(column=0,row=9)
e=rmod2.vecgen1(2)
e[0]=Tkinter.Entry(fr2,width=15)
e[0].grid(row=8,column=1)
e[1]=Tkinter.Entry(fr2,width=15)
e[1].grid(row=9,column=1)


# in fr3 : pack() domain
fr3=Tkinter.Frame(hf,relief="sunken",bd=2)
fr3.pack()

mainprog=Tkinter.Button(fr3,text=" (6) analysis",bg="cyan",width=25,command=analysis)
mainprog.pack(pady=5)

fr4=Tkinter.Frame(hf, relief="sunken",bd=2)
fr4.pack()
# in fr4  grid domain "
lb34=Tkinter.Label(fr4,text=" (7) Select of attr. f spec HDs ")
lb34.grid(row=0,columnspan=4)
lb3=Tkinter.Label(fr4,text="Select first attribute (abscissa in scatterplot) (0,..,)")
lb3.grid(row=1,column=0)
lb4=Tkinter.Label(fr4,text="Select second attribute ordinate in scatterplot) (0,..,)")
lb4.grid(row=2,column=0)
eat1=Tkinter.Entry(fr4,width=2)
eat1.grid(row=1,column=2)
eat2=Tkinter.Entry(fr4,width=2)
eat2.grid(row=2,column=2)
lbinfosc=Tkinter.Label(fr4,text="")
lbinfosc.grid(row=3,columnspan=3)
buttHDspec=Tkinter.Button(fr4,text="(8) spec HD ",bg="cyan",command=HDattpairs)
buttHDspec.grid(row=4,columnspan=4)
lbmax0=Tkinter.Label(fr4,text="(9a) Maximum for first attribute?")
lbmax0.grid(row=5,columnspan=4)
lbmax1=Tkinter.Label(fr4,text="(9b) Maximum for second attribute?")
lbmax1.grid(row=6,columnspan=4)
e0=Tkinter.Entry(fr4,width=5)
e0.grid(row=5,column=5)
e1=Tkinter.Entry(fr4,width=5)
e1.grid(row=6,column=5)
buttscattplot=Tkinter.Button(fr4,text="(10) Scatterplot ",bg="cyan",command=scattplot)
buttscattplot.grid(row=7,columnspan=4)
fr5=Tkinter.Frame(hf)
fr5.pack()
lb51=Tkinter.Label(fr5,text=" (11) Select a list of objects ")
lb51.pack()
e51=Tkinter.Entry(fr5,width=10)
e51.pack()
butt51=Tkinter.Button(fr5,text="HD of sel.objects and sel. att. ",width=25,bg="cyan",command=HD5)
butt51.pack()

buttexit=Tkinter.Button(hf,text=" Exit ",width=25,bd=4,bg="red",command=hf.destroy)
buttexit.pack(pady=5)

hf.mainloop()
