import rmod2
import raioop2
from ScrolledText import *
import Canvas
import os
import tkMessageBox
import tkFileDialog
import stats
import pstat
import random
import Tkinter



# Brg 14.12.07, 17.12.07, 13.1.08, 4.2.08
# g-stability fields
# Brg 19.2.08: Toplevel: titles
# May 08: Brg adaptations because of changes in rmod2
# 7.6.08: Important step: How to avoid the case where no incomp. pair is found
# Brg 10.10.08 Help text now as external file. Loading by an OOP-function
# HD of a weight-interval
# Brg 20.6.2012 cosmetics
# Brg 21.6.2012 rearrangements to stability6.py
# Brg 24.6.2012 further steps toward stability8
# Brg 25.6.2012 stability9 (once again a change in ideas)
# Brg 23.4.2013;: about: extended
# Brg 03.06.18: stabilitysimpl
# Brg inputs and basics form HDsimpl03_2.py


###### editfenster ### 29.8.2013 #####
def xsave_in_PyHasseformat():
    # brg 26.7.2013
    # 6.8.2013: taken from csvHDsimpl1.py, 27.8.2013
    global r,k,x
    la=r+1
    ls=k+1
    
    xext=rmod2.marray(la,ls)
    for i in range(0,la):
        for j in range(0,ls):
            if i==0 and j==0:
                xext[i][j]="dummy"
            elif j==0 and i>0:
                xext[i][j]=obj[i-1]
            elif j>0 and i==0:
                xext[i][j]=prop[j-1]
            else:
                xext[i][j]=x[i-1][j-1]


    print " xext-matrix "
    for i in range(0,la):
        for j in range(0,ls):
            print xext[i][j]," ",
        print " "
    print "  "    
    fnnew=tkFileDialog.asksaveasfilename(parent=hf,title="save orig dm in PyHasseformat")
    fcsv=open(fnnew,"w")
    for i in range(0,la):
        for j in range(0,ls):
            fcsv.write(str(xext[i][j])+"\t")
        fcsv.write("\n")
    fcsv.close()
   
    

def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq





def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


    

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of editenster ### 29.8.2013 ####

def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 15.1.08
    #note: modified from the routine, taken from interval9.py
    # brg 3.6.18
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the [0,1]-columnwise data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=80,height=20)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

def HD(datamatrix, rows, columns, objectlist ):
    # brg 26.7.2013, 29.8.2013, 2.11.16
    # from HDsimpl03
    # changed to a parametric procedure: 3.6.18
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
        #
    zetahilf=rmod2.comp(rows,columns,datamatrix)  #zeta matrix with col<row
    zeta=rmod2.marray(rows,rows)
    for i1 in range(0,rows):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rows):
            zeta[i1][i2]=zetahilf[i2][i1]
    #rmod2.matout(rred,rred,zeta)
    Utotal = rmod2.incompzeta(rows,zeta)
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rows,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rows,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rows,adjc,lext)
       
    
    cov=rmod2.cover(rows,tr,lext)

    if rows>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rows,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rows,rows)
        geomy=rmod2.marray(rows,rows)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objectlist[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        return zeta, cov, Utotal

def cover(covmatrix, rows, objectlist):
    # from HDsimpl03
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations ")
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i1 in range(0, rows):
        txt3 += "\n" + objectlist[i1] + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, rows):
            if i1!=i2:
                if covmatrix[i1][i2] == 1:
                    txt3 += " " + objectlist[i2] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def show_eq(txteq):
    # brg from HDsimpl03
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes"+"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)


def show_indicators():
    # brg 03.06.18
    # optimization taken from weightsweights6
    tpshowind=Tkinter.Toplevel(hf)
    tshowind=ScrolledText(tpshowind,width=80,height=20)
    tshowind.pack()
    # Which pair of indicators maximizes U
    xredn = rmod2.matrixnorm(r,k,xred)
    Utotalmax=-99999
    for jother1 in range(0,k-1):
        for jother2 in range(jother1+1,k):
            #for jother1 and jother2: zeta
            zeta12=[]
            for i1 in range(0,rred):
                zeta12.append(0)
                zeta12[i1]=[]
                for i2 in range(0,rred):
                    flag=0
                    for j in (jother1,jother2):
                        if round(xredn[i1][j],5)<=round(xredn[i2][j],5):
                            flag+=1
                        else:
                            flag+=0
                    if flag==2:
                        zeta12[i1].append(1)
                    else:    
                        zeta12[i1].append(0)
            
                        
    
            Utot12 = rmod2.incompzeta(rred,zeta12)
            if Utot12>=Utotalmax:
                Utotalmax=Utot12
                jopt1=jother1
                jopt2=jother2
                #
    txtopt="Suggestion for the optimizing pair of indicators "+"\n"            
    txtopt+="Final optimization "+str(prop[jopt1])+", "+str(prop[jopt2]) +"\n"
    txtopt+="  Umax based on two indicators: = "+str(Utotalmax)+"\n"
    
    txt="  Indicators "+"\n"
    txt+="  int. no    shortname (to be used in this module)"+"\n"
    txt+="  "
    for j in range(0,k):
        txt+=str(j)+":\t     "+str(prop[j])+"\n  "
    txt+="\n"
    txt+=txtopt
    txt+="- - - -    e o f  - - -  "
    tshowind.insert("end",txt)
    

def calc():
    # brg 3.6.18
    # note: needed [0,1 normed data matrices
    tpcalc=Tkinter.Toplevel(hf)
    tpcalc.title(" details of calculation ")
    tcalc=ScrolledText(tpcalc,width=80,height=20)
    tcalc.pack()
    global dm2,rred2, xred2, objred2,txteq2
    sel_ind=eselect.get()
    #print "sel_ind ",sel_ind
    txtcalc=" Calculations "+"\n"
    txtcalc+="filename = "+str(fn)+"\n"
    txtcalc+=60*"_"+"\n"
    txtcalc+="original system with " +str(k)+"   indicators"+"\n"
    for j in range(0, k):
        txtcalc+=str(prop[j])+", "
    txtcalc+="\n"    
    sel_indic=sel_ind.split(",")
    txtcalc+="first selected indicator   " + str(sel_indic[0])+"\n"
    txtcalc+="secnd selected indicator  " + str(sel_indic[1]) + "\n"
    if sel_indic[0] not in prop:
        print "wrong 1 st indicator name ! "
    if sel_indic[1] not in prop:
        print "wrong 2 nd indicator name ! "
    iatt1=prop.index(sel_indic[0])
    iatt2=prop.index(sel_indic[1])
    #print "iatt1 = ",iatt1,"  iatt2 = ",iatt2
    dm2 = []
    for i in range(0, r):
        dm2.append(0)
        dm2[i] = []
        dm2[i].append(x[i][iatt1])
        dm2[i].append(x[i][iatt2])
    #print "dm2= "
    #rmod2.matout(r,2,dm2)
    dm2norm = rmod2.matrixnorm(r,2,dm2)
    rred2,xred2,objred2,txteq2,neq2=rmod2.equivcompactm2(r,2,dm2norm,obj,10)
    txtcalc+="Number of regarded representative elements "+str(rred2)+"\n"
    print "neq= ",neq2
    print "txteq = ",txteq2
    zetahilf2=rmod2.comp(rred2,2,xred2)  #zeta matrix with col<row
    zeta2=rmod2.marray(rred2,rred2)
    for i1 in range(0,rred2):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rred2):
            zeta2[i1][i2]=zetahilf2[i2][i1]
    #print "zeta2"        
    #rmod2.matout(rred2,rred2,zeta2)
    Utotal2 = rmod2.incompzeta(rred2,zeta2)
    
    txtcalc+="Utotal2=  "+str(Utotal2)+"\n"
    # gc
    gc = []
    freqgc = 0
    zahl=0
    zahlgesamt=0
    for i1 in range(0, rred2-1):
        for i2 in range(i1+1, rred2):
            if zeta2[i1][i2]==0 and zeta2[i2][i1]==0:
                #print objred2[i1]," || ",objred[i2]
                delta1=(xred2[i2][0]-xred2[i1][0])
                delta2=(xred2[i2][1]-xred2[i1][1])
                ddelta = delta2 - delta1
                #print "delta1= ",delta1,"  delta2= ",delta2,"  ddelta= ",ddelta
                gc.append(1.0*delta2/(1.0*ddelta))   #note in m=2 -system it suffices to calc. gc for the first indic
                if gc[zahlgesamt]>=0.4 and gc[zahlgesamt]<=0.6:
                    zahl+=1
                zahlgesamt+=1    
    print "the first ten gc-values for the first indicator (control)"
    iz=0
    for zahl2 in range(0, len(gc)):
        if iz<10:
            print round(gc[zahl2],2),
        iz+=1    
    txtcalc+= " Main results "+"\n"
    txtcalc+= " (a) Incomp(2-system)/Incomp("+str(k)+"-system) = "+"\t"+str(round(Utotal2/(1.0*Utotal0),3))+"\n"
    txtcalc+= " (b) freq. of crucial values                    = "+str(zahlgesamt)+"\n"
    txtcalc+= " (c) freq. of gc in [0.4,0.6]                   = "+str(zahl)+"\n"
    txtcalc+= " (d) probability for a weighting problem        = "+str(round(1.0*zahl/(1.0*zahlgesamt),3))+"\n"
    #histogram for crucialweight1
    hrangew=20
    #print "hrangew= ",hrangew
    hw = rmod2.vecgen1(hrangew)
    
    for i in range(0,hrangew):
        for w1 in gc:
            #print 0.1*i," ",fr," ",0.1*(i+1)
            if 0.05*i <= w1 < 0.05*(i+1):
                hw[i]+=1
            
    print "hw= ",hw
    tcalc.insert("end",txtcalc)

    app2=raioop2.brghisto4(hf,"tgc",hrangew,hw,"blue","white","freq(crucial weight1)",ScrolledText)
    app2.bardiagram()
    app2.data_scroll()
    app2.data_label()
            
def HDdm():
    #brg 3.6.18
    global zeta0, cov0, Utotal0
    zeta0,cov0,Utotal0=HD(xred,rred,k,objred)
    
def HDdm2():
    #Brg 3.6.18
    global zeta2,cov2,Utotal2
    zeta2,cov2,Utotal2=HD(xred2,rred2,2,objred2)

def covdm():
    #brg 3.6.18
    cover(cov0,rred,objred)

def covdm2():
    #brg 3.6.18
    cover(cov2, rred2,objred2)

def showeq0():
    #brg 3.6.18
    show_eq(txteq)

def showeq2():
    show_eq(txteq2)
    


hf = Tkinter.Tk()
hf.title(' stabilitysimpl ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_stabilitysimpl.txt",1,\
            "June, the 3rd, 2018"," about stabilitysimpl ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_stabilitysimpl.txt",1,\
            "June, the 3rd, 2018"," help stabilitysimpl ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="(1) Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="(2) Show data matrix (dm)",bg="white",width=35, command=show_dm)
buttshow_datamatrix.pack()
buttshow_indicators = Tkinter.Button(fr,text="(3) Show indicators ",bg="cyan",width=35,command=show_indicators)
buttshow_indicators.pack()
buttHD = Tkinter.Button(fr, text='(4) Draw HD of orig dm', width=35, bg="cyan", command=HDdm)
buttHD.pack(pady=5)
buttcov0 = Tkinter.Button(fr, text="(5) show cover relation of orig. poset",bg="white",width=35,command = covdm)
buttcov0.pack()
butteq0= Tkinter.Button(fr, text="(6) Show equivalence relations (orig dm)",bg="white",width=35,command=showeq0)
butteq0.pack()

lbselect=Tkinter.Label(fr, text="Select two indicators (for example Pb,Cd) ")
lbselect.pack()
eselect = Tkinter.Entry(fr, width=10)
eselect.pack()
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
buttcalc=Tkinter.Button(fr,text="(7) Calculations (with reduced dm) ",bg="cyan",width=35,command = calc)
buttcalc.pack()
buttHDdm2 = Tkinter.Button(fr, text="(8) HD of two indicators ",bg="cyan",width=35, command=HDdm2)
buttHDdm2.pack()
buttcov2 = Tkinter.Button(fr, text="(9) show cover relation of reduced poset",bg="white",width=35,command = covdm2)
buttcov2.pack()
butteq2= Tkinter.Button(fr, text="(10) Show equivalence relations (reduced dm)",bg="white",width=35,command=showeq2)
butteq2.pack()

buttexit=Tkinter.Button(fr,text="exit ", bd=4,bg="red", width=10, command=hf.destroy)
buttexit.pack(pady=5)
hf.mainloop()
