import Tkinter
import tkFileDialog
from ScrolledText import *
import Canvas
import rmod2
import raioop2


# brg Interface: txt-file (EXCEL-derived) ---> pdt-file
# brg 3.9.10



    
def sf(fn,dmn,obj,prop,r,k):
    #brg  31.5.09, 1.6.09
    # 4.8.10: Fuer die geplante Ausgabe der nach Wichtigkeit geordneten dmn
    # 6.8.10 modification: Ausgabe des Filenamens
    # 3.9.2010: Umbau zu procedure with parameterlist
    # brg  30.5.09
    for i in range(0,r):
        print obj[i]," ",
    print " "
    flag=0
    try:
        rmod2.raiwrite5(fn,dmn,obj,prop,r,k)
        flag=1
    except:
        flag=0
    return flag

def store_pdt():
    #brg 3.9.10
    fn=tkFileDialog.asksaveasfilename(parent=hf,title="save file")
    fl1=sf(fn,dm,obj,prop,r,k)
    
    if fl1>0:
        txtstore="matrices with \n"+str(r)+"  rows  and "+str(k)+" columns \n stored in file: \n"+fn
        
    else:
        txtstore="+++ unfortunately not successful +++ "
    lbsuccess.config(text=txtstore,bg="yellow")

def File_select():
    """select a file and open it """
    #Brg 17.1.08
    #*:17.1.08
    #akt: 17.1.08
    global dm,obj,prop,r,k,fn,rred,xred,objred,txt,n
    fn=tkFileDialog.askopenfilename()
    dm,ob,pro,r,k=rmod2.EXCELreadin4(fn)
    lbopen.config(bg="yellow")
    lbopen["text"]="File "+fn+"\n opened with "+str(r)+" rows \n and "\
                         +str(k) +" columns"
    lbopen.pack()

    obj=rmod2.vecgentext1(r)                        #29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  #recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pro[i+1]   #recoding, because pro[0] is a dummy string
    rred,xred,objred,txtred,neq=rmod2.equivcompactm(r,k,dm,obj)  
    n=rred
    return 
    
def HD():
    """based on objred (zeta-matrix) the Hasse diagram is generated and one linear extension)"""
    # Brg 20.12.07, 28.12.07, 2.10.,3.10.09, 13.6.10
    # If the number of representants > 200 then only the cover-matrix and the level-population
    #
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    
        #
    zetahilf=rmod2.comp(rred,k,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for j in range(0,rred):
            zeta[i][j]=zetahilf[j][i]
    #
    #One linear extension (based on levels)
    
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
       
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    global cov   #13.6.10
    cov=rmod2.cover(rred,tr,lext)

    if rred>200:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram  ")
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


hf=Tkinter.Tk()
hf.title('   Interface: txt-File (EXCEL-derived) ---> PyHasse-dm (...pdt) ')
abouttxtpdt=raioop2.brgabout(hf,"tp2","about_txtpdt.txt",1,\
            "Sept. 3rd,2010"," about_txtpdt ", "white", "t2",120,3,ScrolledText)
helptxtpdt=raioop2.brgabout(hf,"tp1","help_txtpdt.txt",1,\
            "Sept. 3rd,2010"," help_txtpdt ", "white", "t1",120,10,ScrolledText)

buttfile=Tkinter.Button(hf,text=" select txt-file ",width=30,bg="cyan",command=File_select)
buttfile.pack()
lbopen=Tkinter.Label(hf,text="",width=60)
lbopen.pack()
buttconversion=Tkinter.Button(hf,text=" txt ---> pdt ", width=30,bg="cyan",command=store_pdt)
buttconversion.pack()
lbsuccess=Tkinter.Label(hf,text="",width=60)
lbsuccess.pack()
buttHD=Tkinter.Button(hf,text=" Hasse diagram ",width=30,command=HD)
buttHD.pack()
buttexit=Tkinter.Button(hf,text= "exit",width=10,bg="red",command=hf.destroy)
buttexit.pack(pady=10)


hf.mainloop()
