import csv
import tkFileDialog
import Tkinter
import rmod2
from ScrolledText import *
import Canvas
import raioop2
import random

# brg 26.7.2013 HDsimpl
# brg 11.01.18 weight1weight2-analysis
# brg 30.05.18 
# brg 04.06.18 weight2evolution  based on weightsweights6
# brg 05.06.18 vs3



###### openfenster ### 11.01.18 #####
def xselectfile():
    # brg 6.8.2013
    global fn
    fn=tkFileDialog.askopenfilename()
    print "fn ",fn
    Tpopener=Tkinter.Toplevel(hf)
    Tpopener.title(' Opening window: different formats ')
    fropen2=Tkinter.Frame(Tpopener,bd=3,bg="white")
    fropen2.pack()
    # +++ Grid-Geometry manager +++
    lb0=Tkinter.Label(fropen2,text=" Select the appropriate format: ",bg="yellow",font=("arial",12,"bold"))
    lb0.grid(row=0,column=0)
    lb1=Tkinter.Label(fropen2,text="(1a) Open files, txt, tab (or blank) as delimiter (PyHasse-standard) :                ",bg="white")
    lb1.grid(row=1,column=0)
    lb2=Tkinter.Label(fropen2,text="(1b) Open files, csv, ';' as delimiter (csv with ';') :                               ",bg="white")
    lb2.grid(row=2,column=0)
    lb3=Tkinter.Label(fropen2,text="(1c) Open files, csv, ',' as delimiter (csv with ',') :                               ",bg="white")
    lb3.grid(row=3,column=0)
    lb6=Tkinter.Label(fropen2,text="(1f) Open files, pdt, internal PyHasse-format to exchange interim-results:            ",bg="white") 
    lb6.grid(row=6,column=0)
    butt1=Tkinter.Button(fropen2,text="(1a) Open txt-file       ",bg="cyan",bd=4,command=xfileopen)
    butt1.grid(row=1,column=1)
    butt2=Tkinter.Button(fropen2,text="(1b) Open csv-file (';') ",bg="cyan",bd=4,command=xcsvopenS)
    butt2.grid(row=2,column=1)
    butt3=Tkinter.Button(fropen2,text="(1c) Open csv-file (',') ",bg="cyan",bd=4,command=xcsvopenK)
    butt3.grid(row=3,column=1)
    butt6=Tkinter.Button(fropen2,text="(1f) Open pdt-file       ",bg="cyan",bd=4,command=xopenfilepdt)
    butt6.grid(row=6,column=1)


def xcsvopenS():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,obj,prop,x,xred,rred,objred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=';', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)
    print "rred ",rred
    print "Matrix "
    rmod2.matout(r,k,xred)
    print "neq= ",neq
    print "txteq = ", txteq

    

def xcsvopenK():
    # brg 6.8.2013, taken from csvHDsimpl1 (there: a part of HD-routine)
    global r,k,x,fn,obj,prop,xred,objred,rred,dm,txteq
    DataReader = csv.reader(open(fn), delimiter=',', quotechar='|')
    a=[]
    for row in DataReader:
        a.append(row)

    print a
    print a[0]
    la=len(a)
    print "number or rows of a    ",la
    ls=len(a[0])
    print "number of columns of a  ",ls
    prop=[]
    for j in range(1,ls):
        prop.append(a[0][j])

    print "prop = ",prop    


    obj=[]
    for i in range(1,la):
        obj.append(a[i][0])

    print "obj = ",obj    

    lob=len(obj)

    print "Number of objects ",lob

    dm=[]
    for i in range(0,la):
        dm.append(0)
        dm[i]=[]
    for i in range(0,la):
        for j in range(0,ls):
           dm[i].append(a[i][j])


    x=rmod2.marray(la-1,ls-1)
    for i in range(0,la-1):
        for j in range(0,ls-1):
            x[i][j]=float(dm[i+1][j+1].replace(',','.'))


    r=la-1
    k=ls-1
    rmod2.matout(r,k,x)


    
    lbopen1.config(text="opened with "+str(r)+"  objects \n\
        and  "+str(k)+" indicators: \n\
        File "+str(fn),bg="yellow")

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq


def xfileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 19.12.17
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    x,ob,pr,r,k=rmod2.EXCELreadin6(fn)
    print "fn= ",fn, "r = ",r,"   k = ",k
    obj=rmod2.vecgentext1(r)                        # 29.11.07
    prop=rmod2.vecgentext1(k)
    for i in range(0,r):  # recoding, because ob[0] is a dummy string 
        obj[i]=ob[i+1]
    for i in range(0,k):
        prop[i]=pr[i+1]   # recoding, because pr[0] is a dummy string
    # rmod2.matout(r,k,x)
    
    lbopen1.config(bg="yellow")    # 18.2.08
    lbopen1["text"]="File "+fn+" was opened with "+str(r)+" rows and "+str(k)+"  columns"
    
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   # 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

  

def xopenfilepdt():
    """ File selection of transformed data matrices
    through other PyHasse programs """
    # brg 29.10.2012 taken from sensitivity18_3
    #* 1.6.09
    # akt. 29.10.2012 (taken from sensitivity18_3), 6.8.2013
    # source: mainHD19
    global fn,r,k,x,prop,obj,rred,xred,objred,txteq
    
    r,k,x,obj,prop=rmod2.raireadin5(fn)
    lbpdtopen.config(bg="yellow")
    lbpdtopen["text"]="selected file (PyHasse (pdt) format) : "+fn+"  with \n"+str(r)+" rows\n"+str(k)+" columns"

    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)  # new 8.9.2014
    print "neq= ",neq
    print "txteq = ",txteq

##### end of open-window ### 11.01.2018 ####

def show_dm():
    #brg taken from HDweightMC8_7
    #Brg 13.1.08, 15.1.08, 11.1.2015
    #*: 13.1.08
    #akt: 04.06.18
    #note: modified from the routine, taken from interval9.py
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=20)
    tfile.pack()
    
    txt1="data matrix of file "+str(fn)+"\n"
    txt1+="\n objects\n"
    for i in range(0,r):
        txt1+=" "+obj[i]+",\t"
    txt1+="\n"
    txt2="\n properties  \n"
    for j in range(0,k):
        txt2+=" "+prop[j]+",\t"
    txt2+="\n"
    txt3="\n data matrix  \n"
    txt3+="\t"
    for j in range(0,k):
        txt3+=prop[j]+"\t"
    txt3+="\n"    
    for i in range(0,r):
        txt3+=obj[i]+"\t"
        for j in range(0,k):
            txt3+=str(x[i][j])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    

       
            
def calcHD():
    #brg 11.01.18, 13.01.2018, 04.06.18, 05.06.18
    global xred,cov,Utotal   
    cov0,objred,rred,Utotal,nameHDorig=HD(x,r,k,obj," HDorig")
    show_cover(cov0,objred,rred,nameHDorig)
    show_eq(Utotal,nameHDorig)
    

def calcHD2():
    # brg 04.06.18, 05.06.18
    cov2,objred2,rred2,Utot12,nameHD2=HD(x2,r,2,obj," 2-system")
    show_cover(cov2, objred2,rred2, nameHD2)
    show_eq(Utot12,nameHD2)
    
def HD(datamatrix, rows, columns, objectlist,nameHD):
    # brg 26.7.2013, 29.8.2013, 2.11.16, 11.01.2018, 13.01.2018
    # brg 04.06.18, 05.06.18
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(rows,columns,datamatrix,objectlist,10)
    zetahilf=rmod2.comp(rred,columns,xred)  #zeta matrix with col<row
    zeta=rmod2.marray(rred,rred)
    for i1 in range(0,rred):  #however we need for the 'normal' presentation: row < col. Transposition
        for i2 in range(0,rred):
            zeta[i1][i2]=zetahilf[i2][i1]                         #to calcHD
    print "txteq = ",txteq
    print "neq = ",neq
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    Utotal = rmod2.incompzeta(rred,zeta)
    #One linear extension (based on levels)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rred,zeta)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rred,lext,revlext,zeta)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rred,adjc,lext)
       
    
    cov=rmod2.cover(rred,tr,lext)

    if rred>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objred[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        return cov, objred, rred, Utotal, nameHD

def HDzeta(zeta_act, rows, objlist,nameHD):
    # brg 26.7.2013, 29.8.2013, 2.11.16, 11.01.2018, 13.01.2018
    # brg 04.06.18, 05.06.18
                       
    hfhd2=Tkinter.Toplevel(hf)
    hfhd2.title('Hasse diagram / cover matrix ')
    freq=Tkinter.Frame(hfhd2,width=200,height=300)
    freq.pack()
    Utotal = rmod2.incompzeta(rows,zeta_act)
    #One linear extension (based on levels)
    lobj,lext,revlext,zzmax=rmod2.levtopsort(rows,zeta_act)
    levmax=-10**20     #20.6.08
    for i in range(0,zzmax):
        if len(lobj[i])>=levmax:
            levmax=len(lobj[i])
       
    #Adj-Listen

    adjc=rmod2.adjacent(rows,lext,revlext,zeta_act)
        
    #Transitive reduced relations
    ts,tr=rmod2.trreduct(rows,adjc,lext)
       
    
    cov=rmod2.cover(rows,tr,lext)

    if rows>400:
        lbhd3=Tkinter.Label(freq,text=" +++too many objects ++++  ",bg="yellow")
        lbhd3.pack()                  
    else:
        lbhd3=Tkinter.Label(freq,text=" Hasse Diagram , Utotal =  "+str(Utotal))
        lbhd3.pack()
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rows,levmax,zzmax)
        cv=Tkinter.Canvas(freq,width=actwidth,height=actheight,bg="white")
        
        lz=zzmax
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobj[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i]

        geomx=rmod2.marray(rows,rows)
        geomy=rmod2.marray(rows,rows)

       
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
            
        
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if cov[lobj[i1][j1]][lobj[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])


        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objlist[lobj[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()
        return Utotal, nameHD
    

def show_cover(cov, objlist,rows, nameHD):
    #brg 05.06.18
    hfcover = Tkinter.Toplevel(hf)
    hfcover.title(' cover-matrix ')
    lbcov = Tkinter.Label(hfcover,text=" Cover-Relations of "+str(nameHD))
    lbcov.pack()
    txt3 = "\n cover-matrix  \n"
    for i1 in range(0, rows):
        txt3 += "\n" + objlist[i1] + ":\t"
        txt3 += "is covered by "
        for i2 in range(0, rows):
            if i1!=i2:
                if cov[i1][i2] == 1:
                    txt3 += " " + objlist[i2] + " ,"
                else:
                    pass
            else:
                pass
        txt3 += "\n"    
    txt3 += "\n"
    txt3 += " -- end of list --"
    tcov=ScrolledText(hfcover,width=50, height=20)
    tcov.pack()
    tcov.insert("end",txt3)
    

def show_eq(incomp, nameHD):
    # brg 05.06.18
    # Rearrangement because now HD is embedded in a procedure
    tpequiv = Tkinter.Toplevel(hf)
    tpequiv.title(" equivalence classes ")
    tequiv=ScrolledText(tpequiv,width=60, height=10)
    tequiv.pack()
    txteq2="Equivalence classes... "+"\n"
    txteq2+="...of the actually opened "+str(nameHD)+"\n"
    txteq2+="Actual incomparabilities = "+str(incomp) +"\n"
    txteq2+=50*"="+"\n"
    txteq2+="File: "+str(fn) +"\n"
    txteq2+="equivalence classes: "+txteq
    txteq2+="\n"
    txteq2+="- - - e o f - - -"
    tequiv.insert("end",txteq2)

        
def calc2():
    #brg 11.01.2018, 13.01.18, 31.05.18
    #the two most important indicators and their analysis
    global x2, crucweights, objred2, rred2
    x2 = rmod2.marray(r,2)
    txt="weight-evolution "+"\n"
    txt+=50*"= "+"\n"
    txt+="Basics"+"\n"
    txt+="File: "+str(fn)+"\n"
    txt+=str(r)+"  objects"+"   "+str(k)+"  indicators "+"\n"
    txt+="Indicators are: "+"\n"
    for j in range(0,k):
        txt+=str(prop[j])+", "
    txt+="\n"
    rred,xred,objred,txteq,neq=rmod2.equivcompactm2(r,k,x,obj,10)   #05.06.18
    txt+=str(rred)+"   representative elements "+"\n"
    txt+="Results: "+"\n"
    global Utotmax12, zetamax12, jopt1,jopt2, Utotal,crucweights
    
    xredn=rmod2.matrixnorm(rred,k,xred)  #k: number of indicators
    
    #1) zeta12   maximizing U
    Utotalmax=-99999
    for jother1 in range(0,k-1):
        for jother2 in range(jother1+1,k):
            #for jother1 and jother2: zeta
            zeta12=[]
            for i1 in range(0,rred):
                zeta12.append(0)
                zeta12[i1]=[]
                for i2 in range(0,rred):
                    flag=0
                    for j in (jother1,jother2):
                        if round(xred[i1][j],5)<=round(xred[i2][j],5):
                            flag+=1
                        else:
                            flag+=0
                    if flag==2:
                        zeta12[i1].append(1)
                    else:    
                        zeta12[i1].append(0)
            
                        
    #4)Utot12
            Utot12 = rmod2.incompzeta(rred,zeta12)
            #print "not optimized:  jother1 = ",prop[jother1],"  jother2= ",prop[jother2],"  Utot12= ", Utot12
            if Utot12>=Utotalmax:
                Utotalmax=Utot12
                jopt1=jother1
                jopt2=jother2
                #print "interim:   jopt1= ",prop[jopt1],"   jopt2= ",prop[jopt2],"  Utot12 = ", Utot12
    #5) the relevant reduced dm
    
    print "txteq ",txteq
    print "objred ", objred
    print len(objred)            
    for i1 in range(0, rred):
        x2[i1][0]=xred[i1][jopt1]
        x2[i1][1]=xred[i1][jopt2]

    rred2,xred2,objred2,txteq2_system,neq2_system=rmod2.equivcompactm2(rred,2,x2,objred,10)   #05.06.18
    xredn2=rmod2.matrixnorm(rred2,2,xred2)  
    
    print "txteq2_system ",txteq2_system
    print "objred2 ", objred2
    print len(objred2)
    txt+="Final optimization "+str(prop[jopt1])+", "+str(prop[jopt2]) +"\n"
    txt+="  Umax based on two indicators: = "+str(Utotalmax)+"\n"
    #6) U12:=list of incomparable pairs for maxj1
    zetamax12=[]
    for i1 in range(0,rred2):
        #print objred[i1]," ",
        zetamax12.append(0)
        zetamax12[i1]=[]
        for i2 in range(0,rred2):
            #print objred[i2]
            flag=0
            for j in (0,1):
                #print "j= ",prop[j],"  ",round(xredn[i1][j],5),"  ",round(xredn[i2][j],5)
                if round(xredn2[i1][j],10)<=round(xredn2[i2][j],10):
                    flag+=1
                else:
                    flag+=0
            if flag==2:
                zetamax12[i1].append(1)
            else:
                zetamax12[i1].append(0)
                
    #Utest,cov12=HD(zetamax12)
    for i1 in range(0,rred2):
        i2 = i1
        zetamax12[i1][i2]=1
    #rmod2.matout(rred,rred,zetamax12)
    
    
   
    Utotmax12 = rmod2.incompzeta(rred2,zetamax12)
    #print "jopt1= ",prop[jopt1],"  jopt2= ",prop[jopt2],"  Utotmax12= ",Utotmax12
    Ulist=[]
    countU=0
    for i1 in range(0,rred2-1):
        for i2 in range(i1+1,rred2):
            if zetamax12[i1][i2]==0 and zetamax12[i2][i1]==0:
                Ulist.append((i1,i2))
                countU+=1
    print "countU= ",countU

    freqquot=[]
    crucweights=[]
    cu=0
    delta2_vec=[]
    ddelta_vec=[]
    invdd_vec=[]         #1/ddelta
    for paar in Ulist:
        #print objred[paar[0]], objred[paar[1]]
        delta2=(1.0*(xredn2[paar[0]][1]-xredn2[paar[1]][1]))
        delta1=(1.0*(xredn2[paar[0]][0]-xredn2[paar[1]][0]))
        delta2_vec.append(delta2)
        ddelta=1.0*delta1-1.0*delta2
        ddelta_vec.append(ddelta)
        if ddelta!=0:
            invdd_vec.append(1.0/ddelta)
            gc1=-1.0*delta2/ddelta
            gc2=1.0*delta1/ddelta
            crucweights.append((gc1,gc2))
        
    
    txt+="Umax "+str(Utot12)+"   explains "+str(round(100.0*Utot12/(1.0*Utotal),3))+"  of incomparabilities"+"\n"
    txt+="Number of crucial weights "+str(countU)+"\n"
    #print "crucweights ",crucweights
    
    #histogram for crucialweight1
    hrangew=20
    #print "hrangew= ",hrangew
    hw=rmod2.vecgen1(hrangew)
    for i in range(0,hrangew):
        for w1 in crucweights:
            if 0.05*i <= w1[0] < 0.05*(i+1):
                hw[i]+=1	

    app2=raioop2.brghisto4(hf,"tgc",hrangew,hw,"blue","white","freq(crucial weight1)",ScrolledText)
    app2.bardiagram()
    app2.data_scroll()

    
    # MC
    # gev1 is the start value, gev2 = 1 - gev1
    try:
        gev1=float(egev1.get())
    except:
        gev1=0.5
    gev2=1.0-gev1
    try:
        MCrun=int(eMC.get())
    except:
        MCrun = 100
    try:    
        eps=float(eeps.get())
    except:
        eps=0.1
    try:
        scone_interval=float(escone.get())
    except:
        scone_interval=0.2
    # gev1-pairs (intervals within the MC-calculation is to be performed)
    print "Parameter of one run: "
    print "gev1 start           ",gev1
    print "steps                ",eps
    print "number of MC-runs    ",MCrun
    gev1u=gev1
    gev1o=gev1
    gevintervals=[]  #(lower limit, upper limit)
    gevintervals.append((gev1u,gev1o))    # just a point: here UMCrun = 0
    zahl_intervalle= int(1.0/(1.0*eps))
    print "zahl der Intervalle= ",zahl_intervalle
    for i in range(0,zahl_intervalle+1):
        gev1u-=eps
        gev1o+=eps
        gevintervals.append([round(gev1u,4),round(gev1o,4)])
        print i,gevintervals[i][0],gevintervals[i][1]

    UMC_vec = []
    scone=[]
    freqgc = []
    print "len cucweights ",len(crucweights)
    for i in range(0,zahl_intervalle+1):
        if gevintervals[i][0]<=0:
            gevintervals[i][0]=0
        if gevintervals[i][1]>=1:
            gevintervals[i][1]=1
        print "(",round(gevintervals[i][0],3),",",round(gevintervals[i][1],3),")"
        g1u=gevintervals[i][0]
        g1o=gevintervals[i][1]
        freqgcinterval = 0
        for zgc in range(0,len(crucweights)):
            if g1o<1:
                if g1u<=round(crucweights[zgc][0],3)<g1o:
                    freqgcinterval+=1
            else:
                if g1u<=round(crucweights[zgc][0],3)<=g1o:
                    freqgcinterval+=1
                
        freqgc.append(freqgcinterval)                 
        g1intu=int(1000.0*g1u)
        g1into=int(1000.0*g1o)
        if g1u==g1o:
            scone.append(0)
        else:
            scone.append(g1o-g1u)
        dmg=rmod2.marray(rred2,MCrun)
        for run in range(0,MCrun):
            if g1u==g1o:
                gMC1=g1u
                gMC2=1.0-gMC1
                UMCrun=0
            else:
                gMC1 = 1.0*random.randint(g1intu,g1into)/(1000.0)
                gMC2 = 1.0 - gMC1
                for i2 in range(0,rred2):
                    Gammax=gMC1*xredn2[i2][0]+gMC2*xredn2[i2][1]
                    dmg[i2][run]=Gammax
        zetaMC0=rmod2.comp(rred2,MCrun,dmg)      #11.06.18 zetaMC, UMCrun after all MC calculations
        zetaMC=rmod2.marray(rred2,rred2)
        for i1 in range(0, rred2):
            for i2 in range(0, rred2):
                zetaMC[i1][i2]=zetaMC0[i2][i1]
        UMCrun = rmod2.incompzeta(rred2,zetaMC)
        UMC_vec.append(UMCrun)
        if scone[i]-0.1*eps<scone_interval<scone[i]+0.1*eps:
            UtotalMC,HDnameMC=HDzeta(zetaMC,rred2,objred2,"HDuncertainty")
            print "scone_interval= ",scone_interval
            print "name HD ",HDnameMC
        if scone[i] == 1:
            istop=i
            break
        
    #Total output
    print "freqgc= ",freqgc
    txt+="Main table "+"\n"
    txt+="File "+str(fn)+"\n"
    txt+="m=2-system with indicators "+str(prop[jopt1])+", "+str(prop[jopt2])+"\n"
    txt+="Incomp for the m=2-system: "+str(Utotmax12)+"\n"
    txt+="Parameters of the run: "+"\n"
    txt+="start-value for the weight of "+str(prop[jopt1])+" : "+str(round(gev1,3))+"\n"
    txt+="Steps of the evolution "+str(round(eps,3))+"\n"
    txt+="Monte Carlo runs "+str(MCrun)+"\n"
    txt+=25*"- "+"\n"
    txt+="s_cone"+"\t"+"U_st"+"\t"+"UMC"+"\t"+" freq(crucweights)"+"\n"
    txt+=25*"_ "+"\n"
    for i in range(0, istop+1):
        U_standard=scone[i]*Utotmax12
        txt+=str(scone[i])+"\t"+str(round(U_standard,3))+"\t"+str(int(UMC_vec[i]))+"\t"+str(freqgc[i])+"\n"
    txt+="\n"
    tpresults=Tkinter.Toplevel(hf)
    tpresults.title("weight_evolution")
    tresults=ScrolledText(tpresults,width=120, height=60)
    tresults.pack()
    tresults.insert("end",txt)

def show_cruc():
    # brg 5.6.18
    tpcw=Tkinter.Toplevel(hf)
    tpcw.title("cruc weights")
    tcw=ScrolledText(tpcw,width=60,height=20)
    tcw.pack()
    txt="Detailled list of all crucial weights of "+str(prop[jopt1])+"\n"
    txt+="(the crucial weight of "+str(prop[jopt2])+" just the complement to 1) "+"\n"
    txt+="Number of crucial weights "+str(len(crucweights))+"\n"
    txt+="crucial weights "+"\n"
    txthilfc=""
    i11=0
    for i1 in range(0,len(crucweights)):
        if i1==15*int(i1/15):
            txthilfc+="\n"
        txthilfc+=str(round(crucweights[i1][0],2))+", "
        
    txthilfc+="\n"
    txt+=txthilfc
    tcw.insert("end",txt)
    

## Tkinter Plot
hf = Tkinter.Tk()
hf.title(' weight2evolution ')
aboutHDsimpl=raioop2.brgabout(hf,"tp1","about_weight2evolution.txt",6,\
            "June, the 4th, 2018"," about weight2evolution ", "white", "t1",80,5,ScrolledText)
helpHDsimpl=raioop2.brgabout(hf,"tp1","help_weight2evolution.txt",6,\
            "June, the 4th, 2018"," help weight2evolution ", "white", "t1",80,5,ScrolledText)
    
fr = Tkinter.Frame(hf, width=60)
fr.pack()
frinput1 = Tkinter.Frame(fr, width=100, height=10)
frinput1.pack()
text = "Select first the file, then decide in which format to be opened "
lbinput1 = Tkinter.Label(frinput1,
                         text=text)
lbinput1.pack()
butt1 = Tkinter.Button(frinput1, text="(1) Select filename  ",
                       bg="white", command=xselectfile)
butt1.pack()
                      
lbopen1 = Tkinter.Label(fr, text="")
lbopen1.pack()
buttshow_datamatrix = Tkinter.Button(fr,text="(2) Show data matrix (dm)",bg="cyan",width=25, command=show_dm)
buttshow_datamatrix.pack()
buttHD = Tkinter.Button(fr, text='(3) Draw HD', width=25, bg="cyan", command=calcHD)
buttHD.pack()
lb1 = Tkinter.Label(fr,text=" ", width=50)
lb1.pack()
frMC=Tkinter.Frame(fr,bd=4,relief="sunken", bg="yellow")
frMC.pack()
lbMC1=Tkinter.Label(frMC,text="start-value of weight1",bg="yellow")
lbMC1.grid(row=0,column=1)
lbMC2=Tkinter.Label(frMC,text="Steps of the evolution",bg="yellow")
lbMC2.grid(row=0,column=10)
lbMC3=Tkinter.Label(frMC,text="How many MCruns ",bg="yellow")
lbMC3.grid(row=0,column=20)
egev1=Tkinter.Entry(frMC,width=10)
egev1.grid(row=2, column=1)
eeps=Tkinter.Entry(frMC,width=10)
eeps.grid(row=2,column=10)
eMC=Tkinter.Entry(frMC,width=10)
eMC.grid(row=2,column=20)
lbuncertainty=Tkinter.Label(fr,text=" Length of uncertainty interval ")
lbuncertainty.pack()
escone=Tkinter.Entry(fr,width=5)
escone.pack()
buttcalc2=Tkinter.Button(fr,text="(4) weight-evolution ",width=25, bg="cyan",command=calc2)
buttcalc2.pack()

buttHD2 = Tkinter.Button(fr,text="(5) Draw HD of 2-system ",width=25, bg="cyan", command=calcHD2)
buttHD2.pack()
buttshowcrucweights=Tkinter.Button(fr,text="(6) show crucial weights ",width=25, bg="white", command=show_cruc)
buttshowcrucweights.pack()
frend=Tkinter.Frame(hf)
frend.pack(pady=5)
buttexit = Tkinter.Button(frend, text='(7) exit', bg='red',
                          width=25, command=hf.destroy)
buttexit.pack(pady=10)

hf.mainloop()
