import rmod2
import Tkinter
import Canvas
import tkFileDialog
import raioop2
from ScrolledText import ScrolledText

# brg 11.6.2014
# brg 20.12.2015

def fileopen():
    "Informs about the file-operations"
    # Excelreadin4 built in
    # Brg 29.11.07, 30.11.07, 15.1.08,18.2.08, 3.7.2013, 19.12.2015
    import tkFileDialog
    global fn,zetaMC,zetaav_vector,r, obj
    fn = tkFileDialog.askopenfilename()
    lfn=len(fn)
    if lfn>30:
        txt="<truncated>..."+fn[lfn-30:lfn]
    else:
        txt=fn
    zetaMC,ob,pr,r,k=rmod2.EXCELreadin4(fn)
    obj = []
    for i in range(0, r):
        obj.append(ob[i+1])
    zetaav_vector = []
    for i1 in range(0,r):
        for i2 in range(0,r):
            if i1 != i2:    
                zetaav_vector.append(zetaMC[i1][i2])                      #29.11.07
    lbopen1.config(bg="yellow")    #18.2.08
    lbopen1["text"]="File "+txt+"\n"+" was opened with "+"\n"+str(r)+" rows and "+str(k)+"  columns"
    return 

def tranzet():
    # brg 19.12.2015
    global zetaMC
    hilf=rmod2.marray(r,r)
    for i1 in range(0, r):
        for i2 in range(0, r):
            hilf[i1][i2] = zetaMC[i2][i1]
    for i1 in range(0, r):
        for i2 in range(0, r):
            zetaMC[i1][i2] = hilf[i1][i2]


def extract(cq,r):
    """extracts from the crisp matrix the order relations"""
    global eqtext
    #brg 30.11.07, 11.4.08
    # the matrix order corresponds to objec
    
    # order is the matrix rs*rs which results after extract
    # rs is the number of rows/ columns of the square matrix order
    eqtext="\n"
    ec=rmod2.dmcompress(r,r,cq)             #30.11. from cq the equivalent relations
    eqtxt,Ksum_act=rmod2.eqcguiout2(r,ec,obj)        #30.11. matrix output 16.7.2013: eqc... version 2
    print "eqtxt = ",eqtxt
    eqtext+="Equivalence classes"+"\n"
    eqtext+=eqtxt
    eqtext+="\n"
    eqtext+="K = "+str(Ksum_act)+"\n"
    
    
    #print "r  = ",r
    txt=rmod2.irc_elim(r,ec)    #7.5.08 identifycolrows replaced by icr_elim
                                #in txt are the rows (and columns)
                                #...which can be eliminated
    
    ltxt=len(txt)
    b = rmod2.recogempty(txt,ltxt)
    # Not only the matrix cq is to be contracted but also the object vector obj
    # txt is a code of row numbers and as such ok for the matrixeliminations
    # however, to perform a new object list, txt must
    # be transformed in the corresponding object names
    an1,ldel1=rmod2.matrixcoldel(txt,r,r,cq) # columns eliminated
    order,ldel2=rmod2.matrixrowdel(txt,r,r-ldel1,an1)
    rs=r-ldel1
    
   
    if b=="true":
        #there is nothing to be reduced hence
        objec=rmod2.vecgentext1(r)
        for i in range(0,r):
            objec[i]=obj[i]
    else:        
        conobj=rmod2.vecgentext1(ltxt)
        for i in range(0,ltxt):
            conobj[i]=obj[int(txt[i])]
        #print "conobj = ",conobj    
        objec=rmod2.vecgentext1(rs)
        zaehl=0
        for i in range(0,r):
            #print "obj i  ",obj[i],"  in conobj  ",conobj
            if obj[i]not in conobj:
                objec[zaehl]=obj[i]
                zaehl+=1
    return order,objec,rs
            

def show_zeta():
    """ New routine : shows the zeta matrix """
    #Brg 13.1.08, 15.1.08, 19.12.2015
    #*: 13.1.08
    #akt: 19.12.15
    #note: modified from the routine, taken from simi3
    tp2=Tkinter.Toplevel(hf)
    tp2.title('show DM')
    lbtp2=Tkinter.Label(tp2,text=" General information about the read-in data matrix ")
    lbtp2.pack()
    tfile=ScrolledText(tp2,width=60,height=4)
    tfile.pack()
    
    txt1="\n"
    txt1+="\n objects\n"
    for i1 in range(0,r):
        txt1+=" "+obj[i1]+",\t"
    txt1+="\n"
    txt2="\n objects  \n"
    for i2 in range(0,r):
        txt2+=" "+obj[i2]+",\t"
    txt2+="\n"
    txt3="\n zeta matrix  \n"
    txt3+="\t"
    for i in range(0,r):
        txt3+=obj[i]+"\t"
    txt3+="\n"    
    for i1 in range(0,r):
        txt3+=obj[i1]+"\t"
        for i2 in range(0, r):
            txt3+=str(zetaMC[i1][i2])+"\t"
        txt3+="\n"
    txt3+="\n\n"
    txt=txt1+txt2+txt3
    tfile.insert("end",txt)    



def HDzeta():
    # brg 20.12.2015
    # here starts the calculation for drawing a HD
    zetaact, objredact, rred = extract(zetaMC,r)
    lobjact,lextact,revlextact,zzmaxact=rmod2.levtopsort(rred,zetaact)
    # lobjact: a 2Dfield : Identifiers for objects in different levels.
    # Note levels may have different lengths
    # lextact: a linear extension
    # revlextact, dual of lextact
    # zzmaxact: Number of objects in the maximum level
    print "lobjact= ",lobjact
    print "lextact = ",lextact
    print "zzmaxact = ",zzmaxact

    # levmaxact: Number of levels a HD has. Needs lobjact   
    levmaxact=-10**20     #20.6.08
    for i in range(0,zzmaxact):
        if len(lobjact[i])>=levmaxact:
            levmaxact=len(lobjact[i])
    # covact: Whichg object is to be connected with which other, regarding the transitive
    # ... reductiion, induced be levtopsort
    covact=rmod2.trred(rred,zetaact)  
    print "covact = ",covact

    freqact=Tkinter.Frame(hf)
    freqact.pack()
    if rred>400:
        lbhd3act=Tkinter.Label(freqact,text=" +++too many objects ++++ (study=) "+str(idnr),bg="yellow")
        lbhd3act.pack()                  
    else:
        lbhd3act=Tkinter.Label(freqact,text=" Hasse Diagram")
        lbhd3act.pack()
        # actual grid and dimension of the drawing plane
        actwidth,actheight,factorx,\
                factory,geom0x,geom0y,garrow1x,garrow1y,garrow2y=rmod2.geomHD(rred,levmaxact,zzmaxact)
        print "geom0x= ",geom0x,"   geom0y= ",geom0y
        print "factorx= ",factorx,"    factory= ",factory
        print "actwidth= ",actwidth,"   actheight= ",actheight
        cv=Tkinter.Canvas(freqact,width=actwidth,height=actheight,bg="white")
        
        lz=zzmaxact
        l=rmod2.vecgen1(lz)
        for i in range(0,lz):
            l[i]=len(lobjact[i])

        pos=rmod2.vecgen1(lz)
        for i in range(0,lz):
            pos[i]=l[i] # nothing else than the length of each level

        geomx=rmod2.marray(rred,rred)
        geomy=rmod2.marray(rred,rred)

        # actual assignment of the grids
        for i in range(0,lz):
            for j in range(0,l[i]):
                geomx[i][j]=geom0x+(factorx/(pos[i]+1.0))*(j+1)  #10.6.08 160-480
                geomy[i][j]=geom0y+(factory/lz)*i
        print "geomx= ",geomx
        print "geomy= ",geomy
        # which lines between the different levels:...
        for i in range(0,lz-1):
            for j in range(0,l[i]):
                for i1 in range(i+1,lz):
                    for j1 in range(0,l[i1]):
                        if covact[lobjact[i1][j1]][lobjact[i][j]]==1:
                            cv.create_line(geomx[i][j],geomy[i][j],geomx[i1][j1],geomy[i1][j1])

        # circles and object labels at the realized grid points
        # circles at the ith level in the jth position within the actual level
        for i in range(0,lz):
            for j in range(0,l[i]):
                cv.create_oval(geomx[i][j]-10,geomy[i][j]+10,geomx[i][j]+10,geomy[i][j]-10,fill="white")
                cv.create_text(geomx[i][j],geomy[i][j],text=objredact[lobjact[i][j]])
        
        cv.create_line(garrow1x,garrow1y,garrow1x,garrow2y-12,arrow="first",width=3,fill="red")
        cv.create_text(garrow1x+8,garrow1y-6,text="high")
        cv.create_text(garrow1x+8,garrow2y-6,text="low")
        cv.pack()


hf=Tkinter.Tk()
hf.title("      zeta --> HD: vs Dec. 2015         ")
aboutzetareader2=raioop2.brgabout(hf,"tp1","about_zeta_readin.txt",1,\
            "Dec., 20th, 2015"," about_zeta_readin ", "white", "t1",80,5,ScrolledText)
helppyhassemenue=raioop2.brgabout(hf,"tp1","help_zeta_readin.txt",1,\
            "Dec., the 20th,2015"," help_zeta_readin ", "white", "t1",80,5,ScrolledText)

fr=Tkinter.Frame(hf,width=400,height=400)
fr.pack()

frinput1=Tkinter.Frame(fr,width=100,height=10)
frinput1.pack()

butt1=Tkinter.Button(fr,text="select and open zeta-file\n\
    equipped with labels of the objects",bg="white",width=30,command=fileopen)
butt1.pack()
lbopen1=Tkinter.Label(fr,text="")
lbopen1.pack()
buttshow=Tkinter.Button(fr,text="show zeta matrix",bg="white",width=30,command=show_zeta)
buttshow.pack()
butttranspose=Tkinter.Button(fr,text=" Eventually transpose the zeta-matrix ",bg ="white", width=30, command = tranzet)
butttranspose.pack()
butt6=Tkinter.Button(fr,text=" Generate HD",bg="cyan",width=30,command=HDzeta)
butt6.pack()
buttexit=Tkinter.Button(hf,text=" exit ",bg="red", bd=4, width=25,command=hf.destroy)
buttexit.pack(pady=20)
hf.mainloop()
